/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Z=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/platform","vs/base/common/path","vs/base/common/async","vs/platform/environment/common/environment","vs/platform/files/common/files","vs/base/common/errors","vs/nls","vs/nls!vs/code/electron-browser/sharedProcess/sharedProcessMain","vs/base/common/resources","vs/base/common/types","vs/base/common/network","vs/base/node/pfs","vs/platform/log/common/log","vs/base/common/arrays","vs/platform/storage/common/storage","vs/platform/userDataSync/common/userDataSync","vs/base/common/strings","vs/platform/configuration/common/configuration","vs/platform/telemetry/common/telemetry","vs/base/common/buffer","vs/base/common/objects","vs/platform/product/common/productService","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/cancellation","vs/base/common/uuid","vs/platform/registry/common/platform","vs/base/common/json","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/process","os","vs/base/parts/ipc/common/ipc","vs/platform/configuration/common/configurationRegistry","vs/base/common/map","vs/platform/request/common/request","vs/base/common/jsonEdit","vs/base/common/extpath","fs","child_process","vs/base/common/errorMessage","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/userDataSync/common/abstractSynchronizer","vs/base/common/jsonFormatter","vs/base/common/stream","vs/base/parts/ipc/node/ipc.cp","vs/platform/instantiation/common/descriptors","vs/platform/product/common/product","vs/platform/userDataSync/common/content","vs/base/common/iterator","vs/base/common/codicons","vs/base/common/date","vs/platform/localizations/common/localizations","vs/base/common/semver/semver","vs/platform/native/electron-sandbox/native","vs/platform/telemetry/common/telemetryUtils","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/node/zip","vs/base/common/collections","vs/base/common/decorators","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/node/decoder","vs/base/parts/storage/common/storage","vs/platform/extensions/common/extensionValidator","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionRecommendations/common/extensionRecommendations","vs/platform/extensions/common/extensions","vs/platform/files/node/watcher/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/log/common/logIpc","vs/platform/files/common/io","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryService","vs/platform/terminal/common/terminal","vs/platform/userDataSync/common/extensionsStorageSync","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/userDataSync/common/userDataAutoSyncService","vs/base/common/assert","vs/base/common/stopwatch","vs/base/common/console","vs/base/common/marshalling","vs/base/common/glob","vs/base/common/uriIpc","vs/base/node/macAddress","vs/base/node/id","vs/base/node/extpath","vs/base/node/powershell","vs/base/node/ps","vs/base/node/watcher","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-browser/ipc.mp","electron","vs/base/parts/request/browser/request","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/processes","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/configRemotes","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionRecommendations/electron-sandbox/extensionRecommendationsIpc","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/unix/watcherService","vs/platform/files/node/watcher/win32/csharpWatcherService","vs/platform/files/node/watcher/win32/watcherService","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/contextkey/common/contextkey","vs/code/electron-browser/sharedProcess/contrib/logsDataCleaner","vs/code/electron-browser/sharedProcess/contrib/storageDataCleaner","vs/code/electron-browser/sharedProcess/contrib/deprecatedExtensionsCleaner","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/checksum/node/checksumService","crypto","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/ipc/electron-browser/mainProcessService","vs/platform/ipc/electron-sandbox/services","vs/code/electron-browser/sharedProcess/contrib/localizationsUpdater","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/localizations/node/localizations","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/code/electron-browser/sharedProcess/contrib/languagePackCachedDataCleaner","vs/code/electron-browser/sharedProcess/contrib/nodeCachedDataCleaner","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/request/browser/requestService","vs/platform/download/common/downloadService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/storage/common/storageIpc","vs/platform/storage/electron-sandbox/storageService","vs/platform/telemetry/common/commonProperties","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/electron-sandbox/terminal","vs/platform/terminal/node/terminalEnvironment","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/userDataSyncBackupStoreService","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/userDataSync/common/userDataSyncResourceEnablementService","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/electron-sandbox/userDataAutoSyncService","vs/platform/windows/node/windowTracker","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","vs/platform/extensionManagement/node/extensionManagementService","string_decoder","util","path","yauzl","yazl","vs/code/electron-browser/sharedProcess/sharedProcessMain","graceful-fs"],ee=function(G){for(var e=[],y=0,P=G.length;y<P;y++)e[y]=Z[G[y]];return e};define(Z[86],ee([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function y(P,L){if(!P)throw new Error(L?`Assertion failed (${L})`:"Assertion Failed")}e.ok=y}),define(Z[63],ee([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const y=Object.prototype.hasOwnProperty;function P(n){const f=[];for(let m in n)y.call(n,m)&&f.push(n[m]);return f}e.values=P;function L(n,f){for(let m in n)if(y.call(n,m)&&f({key:m,value:n[m]},function(){delete n[m]})===!1)return}e.forEach=L;function k(n,f){const m=Object.create(null);for(const C of n){const h=f(C);let E=m[h];E||(E=m[h]=[]),E.push(C)}return m}e.groupBy=k;function A(n){const f=Object.create(null);return n&&n.forEach((m,C)=>{f[C]=m}),f}e.fromMap=A;function R(n,f){const m=[],C=[];for(let h of n)f.has(h)||m.push(h);for(let h of f)n.has(h)||C.push(h);return{removed:m,added:C}}e.diffSets=R;function p(n,f){const m=[],C=[];for(let[h,E]of n)f.has(h)||m.push(E);for(let[h,E]of f)n.has(h)||C.push(E);return{removed:m,added:C}}e.diffMaps=p;class S{constructor(){this.map=new Map}add(f,m){let C=this.map.get(f);C||(C=new Set,this.map.set(f,C)),C.add(m)}delete(f,m){const C=this.map.get(f);!C||(C.delete(m),C.size===0&&this.map.delete(f))}forEach(f,m){const C=this.map.get(f);!C||C.forEach(m)}}e.SetMap=S}),define(Z[64],ee([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function y(A){return(R,p,S)=>{let n=null,f=null;if(typeof S.value=="function"?(n="value",f=S.value):typeof S.get=="function"&&(n="get",f=S.get),!f)throw new Error("not supported");S[n]=A(f,p)}}e.createDecorator=y;function P(A,R,p){let S=null,n=null;if(typeof p.value=="function"?(S="value",n=p.value,n.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof p.get=="function"&&(S="get",n=p.get),!n)throw new Error("not supported");const f=`$memoize$${R}`;p[S]=function(...m){return this.hasOwnProperty(f)||Object.defineProperty(this,f,{configurable:!1,enumerable:!1,writable:!1,value:n.apply(this,m)}),this[f]}}e.memoize=P;function L(A,R,p){return y((S,n)=>{const f=`$debounce$${n}`,m=`$debounce$result$${n}`;return function(...C){this[m]||(this[m]=p?p():void 0),clearTimeout(this[f]),R&&(this[m]=R(this[m],...C),C=[this[m]]),this[f]=setTimeout(()=>{S.apply(this,C),this[m]=p?p():void 0},A)}})}e.debounce=L;function k(A,R,p){return y((S,n)=>{const f=`$throttle$timer$${n}`,m=`$throttle$result$${n}`,C=`$throttle$lastRun$${n}`,h=`$throttle$pending$${n}`;return function(...E){if(this[m]||(this[m]=p?p():void 0),(this[C]===null||this[C]===void 0)&&(this[C]=-Number.MAX_VALUE),R&&(this[m]=R(this[m],...E)),this[h])return;const D=this[C]+A;D<=Date.now()?(this[C]=Date.now(),S.apply(this,[this[m]]),this[m]=p?p():void 0):(this[h]=!0,this[f]=setTimeout(()=>{this[h]=!1,this[C]=Date.now(),S.apply(this,[this[m]]),this[m]=p?p():void 0},D-Date.now()))}})}e.throttle=k}),define(Z[11],ee([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class y{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(r=>{r(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=y,e.errorHandler=new y;function P(s){e.errorHandler.setUnexpectedErrorHandler(s)}e.setUnexpectedErrorHandler=P;function L(s){p(s)||e.errorHandler.onUnexpectedError(s)}e.onUnexpectedError=L;function k(s){p(s)||e.errorHandler.onUnexpectedExternalError(s)}e.onUnexpectedExternalError=k;function A(s){if(s instanceof Error){let{name:t,message:r}=s;const i=s.stacktrace||s.stack;return{$isError:!0,name:t,message:r,stack:i}}return s}e.transformErrorForSerialization=A;const R="Canceled";function p(s){return s instanceof Error&&s.name===R&&s.message===R}e.isPromiseCanceledError=p;class S extends Error{constructor(){super(R);this.name=this.message}}e.CancellationError=S;function n(){const s=new Error(R);return s.name=s.message,s}e.canceled=n;function f(s){return s?new Error(`Illegal argument: ${s}`):new Error("Illegal argument")}e.illegalArgument=f;function m(s){return s?new Error(`Illegal state: ${s}`):new Error("Illegal state")}e.illegalState=m;function C(s){return s?new Error(`readonly property '${s} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=C;function h(s){const t=new Error(`${s} has been disposed`);return t.name="DISPOSED",t}e.disposed=h;function E(s){return s?s.message?s.message:s.stack?s.stack.split(`
`)[0]:String(s):"Error"}e.getErrorMessage=E;class D extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=D;class b extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=b;class I extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=I;function g(s){const t=s;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=g;function a(s,t=Object.create(null)){const r=new Error(s);return t.actions&&(r.actions=t.actions),r}e.createErrorWithActions=a}),define(Z[19],ee([0,1,11]),function(G,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function P(q,$=0){return q[q.length-(1+$)]}e.tail=P;function L(q){if(q.length===0)throw new Error("Invalid tail call");return[q.slice(0,q.length-1),q[q.length-1]]}e.tail2=L;function k(q,$,M=(U,O)=>U===O){if(q===$)return!0;if(!q||!$||q.length!==$.length)return!1;for(let U=0,O=q.length;U<O;U++)if(!M(q[U],$[U]))return!1;return!0}e.equals=k;function A(q,$,M){let U=0,O=q.length-1;for(;U<=O;){const _=(U+O)/2|0,N=M(q[_],$);if(N<0)U=_+1;else if(N>0)O=_-1;else return _}return-(U+1)}e.binarySearch=A;function R(q,$){let M=0,U=q.length;if(U===0)return 0;for(;M<U;){const O=Math.floor((M+U)/2);$(q[O])?U=O:M=O+1}return M}e.findFirstInSorted=R;function p(q,$,M){if(q=q|0,q>=$.length)throw new TypeError("invalid index");let U=$[Math.floor($.length*Math.random())],O=[],_=[],N=[];for(let W of $){const V=M(W,U);V<0?O.push(W):V>0?_.push(W):N.push(W)}return q<O.length?p(q,O,M):q<O.length+N.length?N[0]:p(q-(O.length+N.length),_,M)}e.quickSelect=p;function S(q,$){const M=[];let U;for(const O of q.slice(0).sort($))!U||$(U[0],O)!==0?(U=[O],M.push(U)):U.push(O);return M}e.groupBy=S;function n(q,$,M){const U=[];function O(W,V,Q){if(V===0&&Q.length===0)return;const X=U[U.length-1];X&&X.start+X.deleteCount===W?(X.deleteCount+=V,X.toInsert.push(...Q)):U.push({start:W,deleteCount:V,toInsert:Q})}let _=0,N=0;for(;;){if(_===q.length){O(_,0,$.slice(N));break}if(N===$.length){O(_,q.length-_,[]);break}const W=q[_],V=$[N],Q=M(W,V);Q===0?(_+=1,N+=1):Q<0?(O(_,1,[]),_+=1):Q>0&&(O(_,0,[V]),N+=1)}return U}e.sortedDiff=n;function f(q,$,M){const U=n(q,$,M),O=[],_=[];for(const N of U)O.push(...q.slice(N.start,N.start+N.deleteCount)),_.push(...N.toInsert);return{removed:O,added:_}}e.delta=f;function m(q,$,M){if(M===0)return[];const U=q.slice(0,M).sort($);return h(q,$,U,M,q.length),U}e.top=m;function C(q,$,M,U,O){return M===0?Promise.resolve([]):new Promise((_,N)=>{(async()=>{const W=q.length,V=q.slice(0,M).sort($);for(let Q=M,X=Math.min(M+U,W);Q<W;Q=X,X=Math.min(X+U,W)){if(Q>M&&await new Promise(ie=>setTimeout(ie)),O&&O.isCancellationRequested)throw(0,y.canceled)();h(q,$,V,Q,X)}return V})().then(_,N)})}e.topAsync=C;function h(q,$,M,U,O){for(const _=M.length;U<O;U++){const N=q[U];if($(N,M[_-1])<0){M.pop();const W=R(M,V=>$(N,V)<0);M.splice(W,0,N)}}}function E(q){return q.filter($=>!!$)}e.coalesce=E;function D(q){let $=0;for(let M=0;M<q.length;M++)q[M]&&(q[$]=q[M],$+=1);q.length=$}e.coalesceInPlace=D;function b(q,$,M){q.splice(M,0,q.splice($,1)[0])}e.move=b;function I(q){return!Array.isArray(q)||q.length===0}e.isFalsyOrEmpty=I;function g(q){return Array.isArray(q)&&q.length>0}e.isNonEmptyArray=g;function a(q,$){if(!$)return q.filter((U,O)=>q.indexOf(U)===O);const M=Object.create(null);return q.filter(U=>{const O=$(U);return M[O]?!1:(M[O]=!0,!0)})}e.distinct=a;function s(q){const $=new Set;return q.filter(M=>$.has(M)?!1:($.add(M),!0))}e.distinctES6=s;function t(q){const $=Object.create(null);return M=>{const U=q(M);return $[U]?!1:($[U]=!0,!0)}}e.uniqueFilter=t;function r(q,$){for(let M=q.length-1;M>=0;M--){const U=q[M];if($(U))return M}return-1}e.lastIndex=r;function i(q,$){return q.length>0?q[0]:$}e.firstOrDefault=i;function o(q,$,M=(U,O)=>U===O){let U=0;for(let O=0,_=Math.min(q.length,$.length);O<_&&M(q[O],$[O]);O++)U++;return U}e.commonPrefixLength=o;function c(q){return[].concat(...q)}e.flatten=c;function l(q,$){let M=typeof $=="number"?q:0;typeof $=="number"?M=q:(M=0,$=q);const U=[];if(M<=$)for(let O=M;O<$;O++)U.push(O);else for(let O=M;O>$;O--)U.push(O);return U}e.range=l;function u(q,$,M){return q.reduce((U,O)=>(U[$(O)]=M?M(O):O,U),Object.create(null))}e.index=u;function v(q,$){return q.push($),()=>w(q,$)}e.insert=v;function w(q,$){const M=q.indexOf($);if(M>-1)return q.splice(M,1),$}e.remove=w;function d(q,$,M){const U=q.slice(0,$),O=q.slice($);return U.concat(M,O)}e.arrayInsert=d;function T(q,$){let M;if(typeof $=="number"){let U=$;M=()=>{const O=Math.sin(U++)*179426549;return O-Math.floor(O)}}else M=Math.random;for(let U=q.length-1;U>0;U-=1){const O=Math.floor(M()*(U+1)),_=q[U];q[U]=q[O],q[O]=_}}e.shuffle=T;function F(q,$){const M=q.indexOf($);M>-1&&(q.splice(M,1),q.unshift($))}e.pushToStart=F;function z(q,$){const M=q.indexOf($);M>-1&&(q.splice(M,1),q.push($))}e.pushToEnd=z;function B(q,$){return Array.isArray(q)?q.map($):$(q)}e.mapArrayOrNot=B;function K(q){return Array.isArray(q)?q:[q]}e.asArray=K;function j(q){return q[Math.floor(Math.random()*q.length)]}e.getRandomElement=j;function H(q,$){for(const M of q){const U=$(M);if(U!==void 0)return U}}e.mapFind=H}),define(Z[65],ee([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function y(P){const L=this;let k=!1,A;return function(){return k||(k=!0,A=P.apply(L,arguments)),A}}e.once=y}),define(Z[53],ee([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var y;(function(P){function L(s){return s&&typeof s=="object"&&typeof s[Symbol.iterator]=="function"}P.is=L;const k=Object.freeze([]);function A(){return k}P.empty=A;function*R(s){yield s}P.single=R;function p(s){return s||k}P.from=p;function S(s){return!s||s[Symbol.iterator]().next().done===!0}P.isEmpty=S;function n(s){return s[Symbol.iterator]().next().value}P.first=n;function f(s,t){for(const r of s)if(t(r))return!0;return!1}P.some=f;function m(s,t){for(const r of s)if(t(r))return r}P.find=m;function*C(s,t){for(const r of s)t(r)&&(yield r)}P.filter=C;function*h(s,t){for(const r of s)yield t(r)}P.map=h;function*E(...s){for(const t of s)for(const r of t)yield r}P.concat=E;function*D(s){for(const t of s)for(const r of t)yield r}P.concatNested=D;function b(s,t,r){let i=r;for(const o of s)i=t(i,o);return i}P.reduce=b;function*I(s,t,r=s.length){for(t<0&&(t+=s.length),r<0?r+=s.length:r>s.length&&(r=s.length);t<r;t++)yield s[t]}P.slice=I;function g(s,t=Number.POSITIVE_INFINITY){const r=[];if(t===0)return[r,s];const i=s[Symbol.iterator]();for(let o=0;o<t;o++){const c=i.next();if(c.done)return[r,P.empty()];r.push(c.value)}return[r,{[Symbol.iterator](){return i}}]}P.consume=g;function a(s,t,r=(i,o)=>i===o){const i=s[Symbol.iterator](),o=t[Symbol.iterator]();for(;;){const c=i.next(),l=o.next();if(c.done!==l.done)return!1;if(c.done)return!0;if(!r(c.value,l.value))return!1}}P.equals=a})(y=e.Iterable||(e.Iterable={}))}),define(Z[32],ee([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var y;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(y=e.ScanError||(e.ScanError={}));var P;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(P=e.SyntaxKind||(e.SyntaxKind={}));var L;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(L=e.ParseErrorCode||(e.ParseErrorCode={}));var k;(function(t){t.DEFAULT={allowTrailingComma:!0}})(k=e.ParseOptions||(e.ParseOptions={}));function A(t,r=!1){let i=0,o=t.length,c="",l=0,u=16,v=0;function w(j){let H=0,q=0;for(;H<j;){const $=t.charCodeAt(i);if($>=48&&$<=57)q=q*16+$-48;else if($>=65&&$<=70)q=q*16+$-65+10;else if($>=97&&$<=102)q=q*16+$-97+10;else break;i++,H++}return H<j&&(q=-1),q}function d(j){i=j,c="",l=0,u=16,v=0}function T(){const j=i;if(t.charCodeAt(i)===48)i++;else for(i++;i<t.length&&S(t.charCodeAt(i));)i++;if(i<t.length&&t.charCodeAt(i)===46)if(i++,i<t.length&&S(t.charCodeAt(i)))for(i++;i<t.length&&S(t.charCodeAt(i));)i++;else return v=3,t.substring(j,i);let H=i;if(i<t.length&&(t.charCodeAt(i)===69||t.charCodeAt(i)===101))if(i++,(i<t.length&&t.charCodeAt(i)===43||t.charCodeAt(i)===45)&&i++,i<t.length&&S(t.charCodeAt(i))){for(i++;i<t.length&&S(t.charCodeAt(i));)i++;H=i}else v=3;return t.substring(j,H)}function F(){let j="",H=i;for(;;){if(i>=o){j+=t.substring(H,i),v=2;break}const q=t.charCodeAt(i);if(q===34){j+=t.substring(H,i),i++;break}if(q===92){if(j+=t.substring(H,i),i++,i>=o){v=2;break}switch(t.charCodeAt(i++)){case 34:j+='"';break;case 92:j+="\\";break;case 47:j+="/";break;case 98:j+="\b";break;case 102:j+="\f";break;case 110:j+=`
`;break;case 114:j+="\r";break;case 116:j+="	";break;case 117:const M=w(4);M>=0?j+=String.fromCharCode(M):v=4;break;default:v=5}H=i;continue}if(q>=0&&q<=31)if(p(q)){j+=t.substring(H,i),v=2;break}else v=6;i++}return j}function z(){if(c="",v=0,l=i,i>=o)return l=o,u=17;let j=t.charCodeAt(i);if(R(j)){do i++,c+=String.fromCharCode(j),j=t.charCodeAt(i);while(R(j));return u=15}if(p(j))return i++,c+=String.fromCharCode(j),j===13&&t.charCodeAt(i)===10&&(i++,c+=`
`),u=14;switch(j){case 123:return i++,u=1;case 125:return i++,u=2;case 91:return i++,u=3;case 93:return i++,u=4;case 58:return i++,u=6;case 44:return i++,u=5;case 34:return i++,c=F(),u=10;case 47:const H=i-1;if(t.charCodeAt(i+1)===47){for(i+=2;i<o&&!p(t.charCodeAt(i));)i++;return c=t.substring(H,i),u=12}if(t.charCodeAt(i+1)===42){i+=2;const q=o-1;let $=!1;for(;i<q;){if(t.charCodeAt(i)===42&&t.charCodeAt(i+1)===47){i+=2,$=!0;break}i++}return $||(i++,v=1),c=t.substring(H,i),u=13}return c+=String.fromCharCode(j),i++,u=16;case 45:if(c+=String.fromCharCode(j),i++,i===o||!S(t.charCodeAt(i)))return u=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return c+=T(),u=11;default:for(;i<o&&B(j);)i++,j=t.charCodeAt(i);if(l!==i){switch(c=t.substring(l,i),c){case"true":return u=8;case"false":return u=9;case"null":return u=7}return u=16}return c+=String.fromCharCode(j),i++,u=16}}function B(j){if(R(j)||p(j))return!1;switch(j){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function K(){let j;do j=z();while(j>=12&&j<=15);return j}return{setPosition:d,getPosition:()=>i,scan:r?K:z,getToken:()=>u,getTokenValue:()=>c,getTokenOffset:()=>l,getTokenLength:()=>i-l,getTokenError:()=>v}}e.createScanner=A;function R(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function p(t){return t===10||t===13||t===8232||t===8233}function S(t){return t>=48&&t<=57}var n;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(n||(n={}));function f(t,r){const i=[],o=new Object;let c;const l={value:{},offset:0,length:0,type:"object",parent:void 0};let u=!1;function v(w,d,T,F){l.value=w,l.offset=d,l.length=T,l.type=F,l.colonOffset=void 0,c=l}try{g(t,{onObjectBegin:(w,d)=>{if(r<=w)throw o;c=void 0,u=r>w,i.push("")},onObjectProperty:(w,d,T)=>{if(r<d||(v(w,d,T,"property"),i[i.length-1]=w,r<=d+T))throw o},onObjectEnd:(w,d)=>{if(r<=w)throw o;c=void 0,i.pop()},onArrayBegin:(w,d)=>{if(r<=w)throw o;c=void 0,i.push(0)},onArrayEnd:(w,d)=>{if(r<=w)throw o;c=void 0,i.pop()},onLiteralValue:(w,d,T)=>{if(r<d||(v(w,d,T,s(w)),r<=d+T))throw o},onSeparator:(w,d,T)=>{if(r<=d)throw o;if(w===":"&&c&&c.type==="property")c.colonOffset=d,u=!1,c=void 0;else if(w===","){const F=i[i.length-1];typeof F=="number"?i[i.length-1]=F+1:(u=!0,i[i.length-1]=""),c=void 0}}})}catch(w){if(w!==o)throw w}return{path:i,previousNode:c,isAtPropertyKey:u,matches:w=>{let d=0;for(let T=0;d<w.length&&T<i.length;T++)if(w[d]===i[T]||w[d]==="*")d++;else if(w[d]!=="**")return!1;return d===w.length}}}e.getLocation=f;function m(t,r=[],i=k.DEFAULT){let o=null,c=[];const l=[];function u(w){Array.isArray(c)?c.push(w):o!==null&&(c[o]=w)}return g(t,{onObjectBegin:()=>{const w={};u(w),l.push(c),c=w,o=null},onObjectProperty:w=>{o=w},onObjectEnd:()=>{c=l.pop()},onArrayBegin:()=>{const w=[];u(w),l.push(c),c=w,o=null},onArrayEnd:()=>{c=l.pop()},onLiteralValue:u,onError:(w,d,T)=>{r.push({error:w,offset:d,length:T})}},i),c[0]}e.parse=m;function C(t,r=[],i=k.DEFAULT){let o={type:"array",offset:-1,length:-1,children:[],parent:void 0};function c(w){o.type==="property"&&(o.length=w-o.offset,o=o.parent)}function l(w){return o.children.push(w),w}g(t,{onObjectBegin:w=>{o=l({type:"object",offset:w,length:-1,parent:o,children:[]})},onObjectProperty:(w,d,T)=>{o=l({type:"property",offset:d,length:-1,parent:o,children:[]}),o.children.push({type:"string",value:w,offset:d,length:T,parent:o})},onObjectEnd:(w,d)=>{o.length=w+d-o.offset,o=o.parent,c(w+d)},onArrayBegin:(w,d)=>{o=l({type:"array",offset:w,length:-1,parent:o,children:[]})},onArrayEnd:(w,d)=>{o.length=w+d-o.offset,o=o.parent,c(w+d)},onLiteralValue:(w,d,T)=>{l({type:s(w),offset:d,length:T,parent:o,value:w}),c(d+T)},onSeparator:(w,d,T)=>{o.type==="property"&&(w===":"?o.colonOffset=d:w===","&&c(d))},onError:(w,d,T)=>{r.push({error:w,offset:d,length:T})}},i);const v=o.children[0];return v&&delete v.parent,v}e.parseTree=C;function h(t,r){if(!t)return;let i=t;for(let o of r)if(typeof o=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let c=!1;for(const l of i.children)if(Array.isArray(l.children)&&l.children[0].value===o){i=l.children[1],c=!0;break}if(!c)return}else{const c=o;if(i.type!=="array"||c<0||!Array.isArray(i.children)||c>=i.children.length)return;i=i.children[c]}return i}e.findNodeAtLocation=h;function E(t){if(!t.parent||!t.parent.children)return[];const r=E(t.parent);if(t.parent.type==="property"){const i=t.parent.children[0].value;r.push(i)}else if(t.parent.type==="array"){const i=t.parent.children.indexOf(t);i!==-1&&r.push(i)}return r}e.getNodePath=E;function D(t){switch(t.type){case"array":return t.children.map(D);case"object":const r=Object.create(null);for(let i of t.children){const o=i.children[1];o&&(r[i.children[0].value]=D(o))}return r;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=D;function b(t,r,i=!1){return r>=t.offset&&r<t.offset+t.length||i&&r===t.offset+t.length}e.contains=b;function I(t,r,i=!1){if(b(t,r,i)){const o=t.children;if(Array.isArray(o))for(let c=0;c<o.length&&o[c].offset<=r;c++){const l=I(o[c],r,i);if(l)return l}return t}}e.findNodeAtOffset=I;function g(t,r,i=k.DEFAULT){const o=A(t,!1);function c(V){return V?()=>V(o.getTokenOffset(),o.getTokenLength()):()=>!0}function l(V){return V?Q=>V(Q,o.getTokenOffset(),o.getTokenLength()):()=>!0}const u=c(r.onObjectBegin),v=l(r.onObjectProperty),w=c(r.onObjectEnd),d=c(r.onArrayBegin),T=c(r.onArrayEnd),F=l(r.onLiteralValue),z=l(r.onSeparator),B=c(r.onComment),K=l(r.onError),j=i&&i.disallowComments,H=i&&i.allowTrailingComma;function q(){for(;;){const V=o.scan();switch(o.getTokenError()){case 4:$(14);break;case 5:$(15);break;case 3:$(13);break;case 1:j||$(11);break;case 2:$(12);break;case 6:$(16);break}switch(V){case 12:case 13:j?$(10):B();break;case 16:$(1);break;case 15:case 14:break;default:return V}}}function $(V,Q=[],X=[]){if(K(V),Q.length+X.length>0){let ie=o.getToken();for(;ie!==17;){if(Q.indexOf(ie)!==-1){q();break}else if(X.indexOf(ie)!==-1)break;ie=q()}}}function M(V){const Q=o.getTokenValue();return V?F(Q):v(Q),q(),!0}function U(){switch(o.getToken()){case 11:let V=0;try{V=JSON.parse(o.getTokenValue()),typeof V!="number"&&($(2),V=0)}catch(Q){$(2)}F(V);break;case 7:F(null);break;case 8:F(!0);break;case 9:F(!1);break;default:return!1}return q(),!0}function O(){return o.getToken()!==10?($(3,[],[2,5]),!1):(M(!1),o.getToken()===6?(z(":"),q(),W()||$(4,[],[2,5])):$(5,[],[2,5]),!0)}function _(){u(),q();let V=!1;for(;o.getToken()!==2&&o.getToken()!==17;){if(o.getToken()===5){if(V||$(4,[],[]),z(","),q(),o.getToken()===2&&H)break}else V&&$(6,[],[]);O()||$(4,[],[2,5]),V=!0}return w(),o.getToken()!==2?$(7,[2],[]):q(),!0}function N(){d(),q();let V=!1;for(;o.getToken()!==4&&o.getToken()!==17;){if(o.getToken()===5){if(V||$(4,[],[]),z(","),q(),o.getToken()===4&&H)break}else V&&$(6,[],[]);W()||$(4,[],[4,5]),V=!0}return T(),o.getToken()!==4?$(8,[4],[]):q(),!0}function W(){switch(o.getToken()){case 3:return N();case 1:return _();case 10:return M(!0);default:return U()}}return q(),o.getToken()===17?i.allowEmptyContent?!0:($(4,[],[]),!1):W()?(o.getToken()!==17&&$(9,[],[]),!0):($(4,[],[]),!1)}e.visit=g;function a(t,r){let i=A(t),o=[],c,l=0,u;do switch(u=i.getPosition(),c=i.scan(),c){case 12:case 13:case 17:l!==u&&o.push(t.substring(l,u)),r!==void 0&&o.push(i.getTokenValue().replace(/[^\r\n]/g,r)),l=i.getPosition();break}while(c!==17);return o.join("")}e.stripComments=a;function s(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=s}),define(Z[47],ee([0,1,32]),function(G,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function P(p,S,n){let f,m,C,h,E;if(S){for(h=S.offset,E=h+S.length,C=h;C>0&&!R(p,C-1);)C--;let l=E;for(;l<p.length&&!R(p,l);)l++;m=p.substring(C,l),f=k(m,n)}else m=p,f=0,C=0,h=0,E=p.length;const D=A(n,p);let b=!1,I=0,g;n.insertSpaces?g=L(" ",n.tabSize||4):g="	";const a=(0,y.createScanner)(m,!1);let s=!1;function t(){return D+L(g,f+I)}function r(){let l=a.scan();for(b=!1;l===15||l===14;)b=b||l===14,l=a.scan();return s=l===16||a.getTokenError()!==0,l}const i=[];function o(l,u,v){!s&&u<E&&v>h&&p.substring(u,v)!==l&&i.push({offset:u,length:v-u,content:l})}let c=r();if(c!==17){const l=a.getTokenOffset()+C,u=L(g,f);o(u,C,l)}for(;c!==17;){let l=a.getTokenOffset()+a.getTokenLength()+C,u=r(),v="";for(;!b&&(u===12||u===13);){const d=a.getTokenOffset()+C;o(" ",l,d),l=a.getTokenOffset()+a.getTokenLength()+C,v=u===12?t():"",u=r()}if(u===2)c!==1&&(I--,v=t());else if(u===4)c!==3&&(I--,v=t());else{switch(c){case 3:case 1:I++,v=t();break;case 5:case 12:v=t();break;case 13:b?v=t():v=" ";break;case 6:v=" ";break;case 10:if(u===6){v="";break}case 7:case 8:case 9:case 11:case 2:case 4:u===12||u===13?v=" ":u!==5&&u!==17&&(s=!0);break;case 16:s=!0;break}b&&(u===12||u===13)&&(v=t())}const w=a.getTokenOffset()+C;o(v,l,w),c=u}return i}e.format=P;function L(p,S){let n="";for(let f=0;f<S;f++)n+=p;return n}function k(p,S){let n=0,f=0;const m=S.tabSize||4;for(;n<p.length;){const C=p.charAt(n);if(C===" ")f++;else if(C==="	")f+=m;else break;n++}return Math.floor(f/m)}function A(p,S){for(let n=0;n<S.length;n++){const f=S.charAt(n);if(f==="\r")return n+1<S.length&&S.charAt(n+1)===`
`?`\r
`:"\r";if(f===`
`)return`
`}return p&&p.eol||`
`}e.getEOL=A;function R(p,S){return`\r
`.indexOf(p.charAt(S))!==-1}e.isEOL=R}),define(Z[40],ee([0,1,32,47]),function(G,e,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function L(S,n,f){return k(S,n,void 0,f)}e.removeProperty=L;function k(S,n,f,m,C){const h=n.slice(),E=[],D=(0,y.parseTree)(S,E);let b,I;for(;h.length>0&&(I=h.pop(),b=(0,y.findNodeAtLocation)(D,h),b===void 0&&f!==void 0);)typeof I=="string"?f={[I]:f}:f=[f];if(b)if(b.type==="object"&&typeof I=="string"&&Array.isArray(b.children)){const g=(0,y.findNodeAtLocation)(b,[I]);if(g!==void 0)if(f===void 0){if(!g.parent)throw new Error("Malformed AST");const a=b.children.indexOf(g.parent);let s,t=g.parent.offset+g.parent.length;if(a>0){const r=b.children[a-1];s=r.offset+r.length}else s=b.offset+1,b.children.length>1&&(t=b.children[1].offset);return A(S,{offset:s,length:t-s,content:""},m)}else return A(S,{offset:g.offset,length:g.length,content:JSON.stringify(f)},m);else{if(f===void 0)return[];const a=`${JSON.stringify(I)}: ${JSON.stringify(f)}`,s=C?C(b.children.map(r=>r.children[0].value)):b.children.length;let t;if(s>0){const r=b.children[s-1];t={offset:r.offset+r.length,length:0,content:","+a}}else b.children.length===0?t={offset:b.offset+1,length:0,content:a}:t={offset:b.offset+1,length:0,content:a+","};return A(S,t,m)}}else if(b.type==="array"&&typeof I=="number"&&Array.isArray(b.children))if(f!==void 0){const g=`${JSON.stringify(f)}`;let a;if(b.children.length===0||I===0)a={offset:b.offset+1,length:0,content:b.children.length===0?g:g+","};else{const s=I===-1||I>b.children.length?b.children.length:I,t=b.children[s-1];a={offset:t.offset+t.length,length:0,content:","+g}}return A(S,a,m)}else{const g=I,a=b.children[g];let s;if(b.children.length===1)s={offset:b.offset+1,length:b.length-2,content:""};else if(b.children.length-1===g){const t=b.children[g-1],r=t.offset+t.length,i=b.offset+b.length;s={offset:r,length:i-2-r,content:""}}else s={offset:a.offset,length:b.children[g+1].offset-a.offset,content:""};return A(S,s,m)}else throw new Error(`Can not add ${typeof I!="number"?"index":"property"} to parent of type ${b.type}`);else{if(f===void 0)throw new Error("Can not delete in empty document");return A(S,{offset:D?D.offset:0,length:D?D.length:0,content:JSON.stringify(f)},m)}}e.setProperty=k;function A(S,n,f){let m=R(S,n),C=n.offset,h=n.offset+n.content.length;if(n.length===0||n.content.length===0){for(;C>0&&!(0,P.isEOL)(m,C-1);)C--;for(;h<m.length&&!(0,P.isEOL)(m,h);)h++}const E=(0,P.format)(m,{offset:C,length:h-C},f);for(let b=E.length-1;b>=0;b--){const I=E[b];m=R(m,I),C=Math.min(C,I.offset),h=Math.max(h,I.offset+I.length),h+=I.content.length-I.length}const D=S.length-(m.length-h)-C;return[{offset:C,length:D,content:m.substring(C,h)}]}e.withFormatting=A;function R(S,n){return S.substring(0,n.offset)+n.content+S.substring(n.offset+n.length)}e.applyEdit=R;function p(S,n){let f=n.slice(0).sort((C,h)=>{const E=C.offset-h.offset;return E===0?C.length-h.length:E}),m=S.length;for(let C=f.length-1;C>=0;C--){let h=f[C];if(h.offset+h.length<=m)S=R(S,h);else throw new Error("Overlapping edit");m=h.offset}return S}e.applyEdits=p}),define(Z[2],ee([0,1,65,53]),function(G,e,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.ReferenceCollection=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.trackDisposable=e.setDisposableTracker=void 0;const L=!1;let k=null;function A(g){k=g}if(e.setDisposableTracker=A,L){const g="__is_disposable_tracked__";k=new class{trackDisposable(a){const s=new Error("Potentially leaked disposable").stack;setTimeout(()=>{a[g]||console.log(s)},3e3)}markTracked(a){if(a&&a!==E.None)try{a[g]=!0}catch(s){}}}}function R(g){!k||k.markTracked(g)}function p(g){return k&&k.trackDisposable(g),g}e.trackDisposable=p;class S extends Error{constructor(a){super(`Encountered errors while disposing of store. Errors: [${a.join(", ")}]`);this.errors=a}}e.MultiDisposeError=S;function n(g){return typeof g.dispose=="function"&&g.dispose.length===0}e.isDisposable=n;function f(g){if(P.Iterable.is(g)){let a=[];for(const s of g)if(s){R(s);try{s.dispose()}catch(t){a.push(t)}}if(a.length===1)throw a[0];if(a.length>1)throw new S(a);return Array.isArray(g)?[]:g}else if(g)return R(g),g.dispose(),g}e.dispose=f;function m(...g){return g.forEach(R),C(()=>f(g))}e.combinedDisposable=m;function C(g){const a=p({dispose:()=>{R(a),g()}});return a}e.toDisposable=C;class h{constructor(){this._toDispose=new Set,this._isDisposed=!1}dispose(){this._isDisposed||(R(this),this._isDisposed=!0,this.clear())}clear(){try{f(this._toDispose.values())}finally{this._toDispose.clear()}}add(a){if(!a)return a;if(a===this)throw new Error("Cannot register a disposable on itself!");return R(a),this._isDisposed?h.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(a),a}}e.DisposableStore=h,h.DISABLE_DISPOSED_WARNING=!1;class E{constructor(){this._store=new h,p(this)}dispose(){R(this),this._store.dispose()}_register(a){if(a===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(a)}}e.Disposable=E,E.None=Object.freeze({dispose(){}});class D{constructor(){this._isDisposed=!1,p(this)}get value(){return this._isDisposed?void 0:this._value}set value(a){var s;this._isDisposed||a===this._value||((s=this._value)===null||s===void 0||s.dispose(),a&&R(a),this._value=a)}clear(){this.value=void 0}dispose(){var a;this._isDisposed=!0,R(this),(a=this._value)===null||a===void 0||a.dispose(),this._value=void 0}}e.MutableDisposable=D;class b{constructor(){this.references=new Map}acquire(a,...s){let t=this.references.get(a);t||(t={counter:0,object:this.createReferencedObject(a,...s)},this.references.set(a,t));const{object:r}=t,i=(0,y.once)(()=>{--t.counter==0&&(this.destroyReferencedObject(a,t.object),this.references.delete(a))});return t.counter++,{object:r,dispose:i}}}e.ReferenceCollection=b;class I{constructor(a){this.object=a}dispose(){}}e.ImmortalReference=I}),define(Z[66],ee([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class y{constructor(k){this.element=k,this.next=y.Undefined,this.prev=y.Undefined}}y.Undefined=new y(void 0);class P{constructor(){this._first=y.Undefined,this._last=y.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===y.Undefined}clear(){let k=this._first;for(;k!==y.Undefined;){const A=k.next;k.prev=y.Undefined,k.next=y.Undefined,k=A}this._first=y.Undefined,this._last=y.Undefined,this._size=0}unshift(k){return this._insert(k,!1)}push(k){return this._insert(k,!0)}_insert(k,A){const R=new y(k);if(this._first===y.Undefined)this._first=R,this._last=R;else if(A){const S=this._last;this._last=R,R.prev=S,S.next=R}else{const S=this._first;this._first=R,R.next=S,S.prev=R}this._size+=1;let p=!1;return()=>{p||(p=!0,this._remove(R))}}shift(){if(this._first!==y.Undefined){const k=this._first.element;return this._remove(this._first),k}}pop(){if(this._last!==y.Undefined){const k=this._last.element;return this._remove(this._last),k}}_remove(k){if(k.prev!==y.Undefined&&k.next!==y.Undefined){const A=k.prev;A.next=k.next,k.next.prev=A}else k.prev===y.Undefined&&k.next===y.Undefined?(this._first=y.Undefined,this._last=y.Undefined):k.next===y.Undefined?(this._last=this._last.prev,this._last.next=y.Undefined):k.prev===y.Undefined&&(this._first=this._first.next,this._first.prev=y.Undefined);this._size-=1}*[Symbol.iterator](){let k=this._first;for(;k!==y.Undefined;)yield k.element,k=k.next}}e.LinkedList=P}),function(){function G(L){const k=[];typeof L=="number"&&k.push("code/timeOrigin",L);function A(p){k.push(p,Date.now())}function R(){const p=[];for(let S=0;S<k.length;S+=2)p.push({name:k[S],startTime:k[S+1]});return p}return{mark:A,getMarks:R}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?G():{mark(L){performance.mark(L)},getMarks(){let L=performance.timeOrigin;typeof L!="number"&&(L=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const k=[{name:"code/timeOrigin",startTime:Math.round(L)}];for(const A of performance.getEntriesByType("mark"))k.push({name:A.name,startTime:Math.round(L+A.startTime)});return k}};if(typeof process=="object"){const L=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return G(L)}else return console.trace("perf-util loaded in UNKNOWN environment"),G()}function y(L){return L.MonacoPerformanceMarks||(L.MonacoPerformanceMarks=e()),L.MonacoPerformanceMarks}var P;typeof global=="object"?P=global:typeof self=="object"?P=self:P={},typeof define=="function"?define("vs/base/common/performance",[],function(){return y(P)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=y(P):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),P.perf=y(P))}(),define(Z[6],ee([0,1]),function(G,e){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isPreferringBrowserCodeLoad=e.browserCodeLoadingCacheStrategy=e.isElectronSandboxed=e.globals=void 0;const P="en";let L=!1,k=!1,A=!1,R=!1,p=!1,S=!1,n=!1,f,m=P,C,h;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let E;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?E=e.globals.vscode.process:typeof process!="undefined"&&(E=process);const D=typeof((y=E==null?void 0:E.versions)===null||y===void 0?void 0:y.electron)=="string"&&E.type==="renderer";if(e.isElectronSandboxed=D&&(E==null?void 0:E.sandboxed),e.browserCodeLoadingCacheStrategy=(()=>{if(e.isElectronSandboxed)return"bypassHeatCheck";const o=E==null?void 0:E.env.VSCODE_BROWSER_CODE_LOADING;if(typeof o=="string")return o==="none"||o==="code"||o==="bypassHeatCheck"||o==="bypassHeatCheckAndEagerCompile"?o:"bypassHeatCheck"})(),e.isPreferringBrowserCodeLoad=typeof e.browserCodeLoadingCacheStrategy=="string",typeof navigator=="object"&&!D)h=navigator.userAgent,L=h.indexOf("Windows")>=0,k=h.indexOf("Macintosh")>=0,n=(h.indexOf("Macintosh")>=0||h.indexOf("iPad")>=0||h.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,A=h.indexOf("Linux")>=0,S=!0,f=navigator.language,m=f;else if(typeof E=="object"){L=E.platform==="win32",k=E.platform==="darwin",A=E.platform==="linux",R=A&&!!E.env.SNAP&&!!E.env.SNAP_REVISION,f=P,m=P;const o=E.env.VSCODE_NLS_CONFIG;if(o)try{const c=JSON.parse(o),l=c.availableLanguages["*"];f=c.locale,m=l||P,C=c._translationsConfigFile}catch(c){}p=!0}else console.error("Unable to resolve platform.");var b;(function(o){o[o.Web=0]="Web",o[o.Mac=1]="Mac",o[o.Linux=2]="Linux",o[o.Windows=3]="Windows"})(b=e.Platform||(e.Platform={}));function I(o){switch(o){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=I;let g=0;k?g=1:L?g=3:A&&(g=2),e.isWindows=L,e.isMacintosh=k,e.isLinux=A,e.isLinuxSnap=R,e.isNative=p,e.isWeb=S,e.isIOS=n,e.platform=g,e.userAgent=h,e.language=m;var a;(function(o){function c(){return e.language}o.value=c;function l(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}o.isDefaultVariant=l;function u(){return e.language==="en"}o.isDefault=u})(a=e.Language||(e.Language={})),e.locale=f,e.translationsConfigFile=C,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let l=[];e.globals.addEventListener("message",v=>{if(v.data&&v.data.vscodeSetImmediateId)for(let w=0,d=l.length;w<d;w++){const T=l[w];if(T.id===v.data.vscodeSetImmediateId){l.splice(w,1),T.callback();return}}});let u=0;return v=>{const w=++u;l.push({id:w,callback:v}),e.globals.postMessage({vscodeSetImmediateId:w},"*")}}if(typeof(E==null?void 0:E.nextTick)=="function")return E.nextTick.bind(E);const c=Promise.resolve();return l=>c.then(l)}();var s;(function(o){o[o.Windows=1]="Windows",o[o.Macintosh=2]="Macintosh",o[o.Linux=3]="Linux"})(s=e.OperatingSystem||(e.OperatingSystem={})),e.OS=k||n?2:L?1:3;let t=!0,r=!1;function i(){if(!r){r=!0;const o=new Uint8Array(2);o[0]=1,o[1]=2,t=new Uint16Array(o.buffer)[0]===(2<<8)+1}return t}e.isLittleEndian=i}),define(Z[34],ee([0,1,6]),function(G,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let P;if(typeof y.globals.vscode!="undefined"&&typeof y.globals.vscode.process!="undefined"){const L=y.globals.vscode.process;P={get platform(){return L.platform},get env(){return L.env},cwd(){return L.cwd()},nextTick(k){return(0,y.setImmediate)(k)}}}else typeof process!="undefined"?P={get platform(){return process.platform},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(L){return process.nextTick(L)}}:P={get platform(){return y.isWindows?"win32":y.isMacintosh?"darwin":"linux"},nextTick(L){return(0,y.setImmediate)(L)},get env(){return Object.create(null)},cwd(){return"/"}};e.cwd=P.cwd,e.env=P.env,e.platform=P.platform,e.nextTick=P.nextTick}),define(Z[7],ee([0,1,34]),function(G,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const P=65,L=97,k=90,A=122,R=46,p=47,S=92,n=58,f=63;class m extends Error{constructor(a,s,t){let r;typeof s=="string"&&s.indexOf("not ")===0?(r="must not be",s=s.replace(/^not /,"")):r="must be";const i=a.indexOf(".")!==-1?"property":"argument";let o=`The "${a}" ${i} ${r} of type ${s}`;o+=`. Received type ${typeof t}`,super(o),this.code="ERR_INVALID_ARG_TYPE"}}function C(g,a){if(typeof g!="string")throw new m(a,"string",g)}function h(g){return g===p||g===S}function E(g){return g===p}function D(g){return g>=P&&g<=k||g>=L&&g<=A}function b(g,a,s,t){let r="",i=0,o=-1,c=0,l=0;for(let u=0;u<=g.length;++u){if(u<g.length)l=g.charCodeAt(u);else{if(t(l))break;l=p}if(t(l)){if(!(o===u-1||c===1))if(c===2){if(r.length<2||i!==2||r.charCodeAt(r.length-1)!==R||r.charCodeAt(r.length-2)!==R){if(r.length>2){const v=r.lastIndexOf(s);v===-1?(r="",i=0):(r=r.slice(0,v),i=r.length-1-r.lastIndexOf(s)),o=u,c=0;continue}else if(r.length!==0){r="",i=0,o=u,c=0;continue}}a&&(r+=r.length>0?`${s}..`:"..",i=2)}else r.length>0?r+=`${s}${g.slice(o+1,u)}`:r=g.slice(o+1,u),i=u-o-1;o=u,c=0}else l===R&&c!==-1?++c:c=-1}return r}function I(g,a){if(a===null||typeof a!="object")throw new m("pathObject","Object",a);const s=a.dir||a.root,t=a.base||`${a.name||""}${a.ext||""}`;return s?s===a.root?`${s}${t}`:`${s}${g}${t}`:t}e.win32={resolve(...g){let a="",s="",t=!1;for(let r=g.length-1;r>=-1;r--){let i;if(r>=0){if(i=g[r],C(i,"path"),i.length===0)continue}else a.length===0?i=y.cwd():(i=y.env[`=${a}`]||y.cwd(),(i===void 0||i.slice(0,2).toLowerCase()!==a.toLowerCase()&&i.charCodeAt(2)===S)&&(i=`${a}\\`));const o=i.length;let c=0,l="",u=!1;const v=i.charCodeAt(0);if(o===1)h(v)&&(c=1,u=!0);else if(h(v))if(u=!0,h(i.charCodeAt(1))){let w=2,d=w;for(;w<o&&!h(i.charCodeAt(w));)w++;if(w<o&&w!==d){const T=i.slice(d,w);for(d=w;w<o&&h(i.charCodeAt(w));)w++;if(w<o&&w!==d){for(d=w;w<o&&!h(i.charCodeAt(w));)w++;(w===o||w!==d)&&(l=`\\\\${T}\\${i.slice(d,w)}`,c=w)}}}else c=1;else D(v)&&i.charCodeAt(1)===n&&(l=i.slice(0,2),c=2,o>2&&h(i.charCodeAt(2))&&(u=!0,c=3));if(l.length>0)if(a.length>0){if(l.toLowerCase()!==a.toLowerCase())continue}else a=l;if(t){if(a.length>0)break}else if(s=`${i.slice(c)}\\${s}`,t=u,u&&a.length>0)break}return s=b(s,!t,"\\",h),t?`${a}\\${s}`:`${a}${s}`||"."},normalize(g){C(g,"path");const a=g.length;if(a===0)return".";let s=0,t,r=!1;const i=g.charCodeAt(0);if(a===1)return E(i)?"\\":g;if(h(i))if(r=!0,h(g.charCodeAt(1))){let c=2,l=c;for(;c<a&&!h(g.charCodeAt(c));)c++;if(c<a&&c!==l){const u=g.slice(l,c);for(l=c;c<a&&h(g.charCodeAt(c));)c++;if(c<a&&c!==l){for(l=c;c<a&&!h(g.charCodeAt(c));)c++;if(c===a)return`\\\\${u}\\${g.slice(l)}\\`;c!==l&&(t=`\\\\${u}\\${g.slice(l,c)}`,s=c)}}}else s=1;else D(i)&&g.charCodeAt(1)===n&&(t=g.slice(0,2),s=2,a>2&&h(g.charCodeAt(2))&&(r=!0,s=3));let o=s<a?b(g.slice(s),!r,"\\",h):"";return o.length===0&&!r&&(o="."),o.length>0&&h(g.charCodeAt(a-1))&&(o+="\\"),t===void 0?r?`\\${o}`:o:r?`${t}\\${o}`:`${t}${o}`},isAbsolute(g){C(g,"path");const a=g.length;if(a===0)return!1;const s=g.charCodeAt(0);return h(s)||a>2&&D(s)&&g.charCodeAt(1)===n&&h(g.charCodeAt(2))},join(...g){if(g.length===0)return".";let a,s;for(let i=0;i<g.length;++i){const o=g[i];C(o,"path"),o.length>0&&(a===void 0?a=s=o:a+=`\\${o}`)}if(a===void 0)return".";let t=!0,r=0;if(typeof s=="string"&&h(s.charCodeAt(0))){++r;const i=s.length;i>1&&h(s.charCodeAt(1))&&(++r,i>2&&(h(s.charCodeAt(2))?++r:t=!1))}if(t){for(;r<a.length&&h(a.charCodeAt(r));)r++;r>=2&&(a=`\\${a.slice(r)}`)}return e.win32.normalize(a)},relative(g,a){if(C(g,"from"),C(a,"to"),g===a)return"";const s=e.win32.resolve(g),t=e.win32.resolve(a);if(s===t||(g=s.toLowerCase(),a=t.toLowerCase(),g===a))return"";let r=0;for(;r<g.length&&g.charCodeAt(r)===S;)r++;let i=g.length;for(;i-1>r&&g.charCodeAt(i-1)===S;)i--;const o=i-r;let c=0;for(;c<a.length&&a.charCodeAt(c)===S;)c++;let l=a.length;for(;l-1>c&&a.charCodeAt(l-1)===S;)l--;const u=l-c,v=o<u?o:u;let w=-1,d=0;for(;d<v;d++){const F=g.charCodeAt(r+d);if(F!==a.charCodeAt(c+d))break;F===S&&(w=d)}if(d!==v){if(w===-1)return t}else{if(u>v){if(a.charCodeAt(c+d)===S)return t.slice(c+d+1);if(d===2)return t.slice(c+d)}o>v&&(g.charCodeAt(r+d)===S?w=d:d===2&&(w=3)),w===-1&&(w=0)}let T="";for(d=r+w+1;d<=i;++d)(d===i||g.charCodeAt(d)===S)&&(T+=T.length===0?"..":"\\..");return c+=w,T.length>0?`${T}${t.slice(c,l)}`:(t.charCodeAt(c)===S&&++c,t.slice(c,l))},toNamespacedPath(g){if(typeof g!="string")return g;if(g.length===0)return"";const a=e.win32.resolve(g);if(a.length<=2)return g;if(a.charCodeAt(0)===S){if(a.charCodeAt(1)===S){const s=a.charCodeAt(2);if(s!==f&&s!==R)return`\\\\?\\UNC\\${a.slice(2)}`}}else if(D(a.charCodeAt(0))&&a.charCodeAt(1)===n&&a.charCodeAt(2)===S)return`\\\\?\\${a}`;return g},dirname(g){C(g,"path");const a=g.length;if(a===0)return".";let s=-1,t=0;const r=g.charCodeAt(0);if(a===1)return h(r)?g:".";if(h(r)){if(s=t=1,h(g.charCodeAt(1))){let c=2,l=c;for(;c<a&&!h(g.charCodeAt(c));)c++;if(c<a&&c!==l){for(l=c;c<a&&h(g.charCodeAt(c));)c++;if(c<a&&c!==l){for(l=c;c<a&&!h(g.charCodeAt(c));)c++;if(c===a)return g;c!==l&&(s=t=c+1)}}}}else D(r)&&g.charCodeAt(1)===n&&(s=a>2&&h(g.charCodeAt(2))?3:2,t=s);let i=-1,o=!0;for(let c=a-1;c>=t;--c)if(h(g.charCodeAt(c))){if(!o){i=c;break}}else o=!1;if(i===-1){if(s===-1)return".";i=s}return g.slice(0,i)},basename(g,a){a!==void 0&&C(a,"ext"),C(g,"path");let s=0,t=-1,r=!0,i;if(g.length>=2&&D(g.charCodeAt(0))&&g.charCodeAt(1)===n&&(s=2),a!==void 0&&a.length>0&&a.length<=g.length){if(a===g)return"";let o=a.length-1,c=-1;for(i=g.length-1;i>=s;--i){const l=g.charCodeAt(i);if(h(l)){if(!r){s=i+1;break}}else c===-1&&(r=!1,c=i+1),o>=0&&(l===a.charCodeAt(o)?--o==-1&&(t=i):(o=-1,t=c))}return s===t?t=c:t===-1&&(t=g.length),g.slice(s,t)}for(i=g.length-1;i>=s;--i)if(h(g.charCodeAt(i))){if(!r){s=i+1;break}}else t===-1&&(r=!1,t=i+1);return t===-1?"":g.slice(s,t)},extname(g){C(g,"path");let a=0,s=-1,t=0,r=-1,i=!0,o=0;g.length>=2&&g.charCodeAt(1)===n&&D(g.charCodeAt(0))&&(a=t=2);for(let c=g.length-1;c>=a;--c){const l=g.charCodeAt(c);if(h(l)){if(!i){t=c+1;break}continue}r===-1&&(i=!1,r=c+1),l===R?s===-1?s=c:o!==1&&(o=1):s!==-1&&(o=-1)}return s===-1||r===-1||o===0||o===1&&s===r-1&&s===t+1?"":g.slice(s,r)},format:I.bind(null,"\\"),parse(g){C(g,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(g.length===0)return a;const s=g.length;let t=0,r=g.charCodeAt(0);if(s===1)return h(r)?(a.root=a.dir=g,a):(a.base=a.name=g,a);if(h(r)){if(t=1,h(g.charCodeAt(1))){let w=2,d=w;for(;w<s&&!h(g.charCodeAt(w));)w++;if(w<s&&w!==d){for(d=w;w<s&&h(g.charCodeAt(w));)w++;if(w<s&&w!==d){for(d=w;w<s&&!h(g.charCodeAt(w));)w++;w===s?t=w:w!==d&&(t=w+1)}}}}else if(D(r)&&g.charCodeAt(1)===n){if(s<=2)return a.root=a.dir=g,a;if(t=2,h(g.charCodeAt(2))){if(s===3)return a.root=a.dir=g,a;t=3}}t>0&&(a.root=g.slice(0,t));let i=-1,o=t,c=-1,l=!0,u=g.length-1,v=0;for(;u>=t;--u){if(r=g.charCodeAt(u),h(r)){if(!l){o=u+1;break}continue}c===-1&&(l=!1,c=u+1),r===R?i===-1?i=u:v!==1&&(v=1):i!==-1&&(v=-1)}return c!==-1&&(i===-1||v===0||v===1&&i===c-1&&i===o+1?a.base=a.name=g.slice(o,c):(a.name=g.slice(o,i),a.base=g.slice(o,c),a.ext=g.slice(i,c))),o>0&&o!==t?a.dir=g.slice(0,o-1):a.dir=a.root,a},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...g){let a="",s=!1;for(let t=g.length-1;t>=-1&&!s;t--){const r=t>=0?g[t]:y.cwd();C(r,"path"),r.length!==0&&(a=`${r}/${a}`,s=r.charCodeAt(0)===p)}return a=b(a,!s,"/",E),s?`/${a}`:a.length>0?a:"."},normalize(g){if(C(g,"path"),g.length===0)return".";const a=g.charCodeAt(0)===p,s=g.charCodeAt(g.length-1)===p;return g=b(g,!a,"/",E),g.length===0?a?"/":s?"./":".":(s&&(g+="/"),a?`/${g}`:g)},isAbsolute(g){return C(g,"path"),g.length>0&&g.charCodeAt(0)===p},join(...g){if(g.length===0)return".";let a;for(let s=0;s<g.length;++s){const t=g[s];C(t,"path"),t.length>0&&(a===void 0?a=t:a+=`/${t}`)}return a===void 0?".":e.posix.normalize(a)},relative(g,a){if(C(g,"from"),C(a,"to"),g===a||(g=e.posix.resolve(g),a=e.posix.resolve(a),g===a))return"";const s=1,t=g.length,r=t-s,i=1,o=a.length-i,c=r<o?r:o;let l=-1,u=0;for(;u<c;u++){const w=g.charCodeAt(s+u);if(w!==a.charCodeAt(i+u))break;w===p&&(l=u)}if(u===c)if(o>c){if(a.charCodeAt(i+u)===p)return a.slice(i+u+1);if(u===0)return a.slice(i+u)}else r>c&&(g.charCodeAt(s+u)===p?l=u:u===0&&(l=0));let v="";for(u=s+l+1;u<=t;++u)(u===t||g.charCodeAt(u)===p)&&(v+=v.length===0?"..":"/..");return`${v}${a.slice(i+l)}`},toNamespacedPath(g){return g},dirname(g){if(C(g,"path"),g.length===0)return".";const a=g.charCodeAt(0)===p;let s=-1,t=!0;for(let r=g.length-1;r>=1;--r)if(g.charCodeAt(r)===p){if(!t){s=r;break}}else t=!1;return s===-1?a?"/":".":a&&s===1?"//":g.slice(0,s)},basename(g,a){a!==void 0&&C(a,"ext"),C(g,"path");let s=0,t=-1,r=!0,i;if(a!==void 0&&a.length>0&&a.length<=g.length){if(a===g)return"";let o=a.length-1,c=-1;for(i=g.length-1;i>=0;--i){const l=g.charCodeAt(i);if(l===p){if(!r){s=i+1;break}}else c===-1&&(r=!1,c=i+1),o>=0&&(l===a.charCodeAt(o)?--o==-1&&(t=i):(o=-1,t=c))}return s===t?t=c:t===-1&&(t=g.length),g.slice(s,t)}for(i=g.length-1;i>=0;--i)if(g.charCodeAt(i)===p){if(!r){s=i+1;break}}else t===-1&&(r=!1,t=i+1);return t===-1?"":g.slice(s,t)},extname(g){C(g,"path");let a=-1,s=0,t=-1,r=!0,i=0;for(let o=g.length-1;o>=0;--o){const c=g.charCodeAt(o);if(c===p){if(!r){s=o+1;break}continue}t===-1&&(r=!1,t=o+1),c===R?a===-1?a=o:i!==1&&(i=1):a!==-1&&(i=-1)}return a===-1||t===-1||i===0||i===1&&a===t-1&&a===s+1?"":g.slice(a,t)},format:I.bind(null,"/"),parse(g){C(g,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(g.length===0)return a;const s=g.charCodeAt(0)===p;let t;s?(a.root="/",t=1):t=0;let r=-1,i=0,o=-1,c=!0,l=g.length-1,u=0;for(;l>=t;--l){const v=g.charCodeAt(l);if(v===p){if(!c){i=l+1;break}continue}o===-1&&(c=!1,o=l+1),v===R?r===-1?r=l:u!==1&&(u=1):r!==-1&&(u=-1)}if(o!==-1){const v=i===0&&s?1:i;r===-1||u===0||u===1&&r===o-1&&r===i+1?a.base=a.name=g.slice(v,o):(a.name=g.slice(v,r),a.base=g.slice(v,o),a.ext=g.slice(r,o))}return i>0?a.dir=g.slice(0,i-1):s&&(a.dir="/"),a},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=y.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=y.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=y.platform==="win32"?e.win32.join:e.posix.join,e.resolve=y.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=y.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=y.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=y.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=y.platform==="win32"?e.win32.extname:e.posix.extname,e.format=y.platform==="win32"?e.win32.format:e.posix.format,e.parse=y.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=y.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=y.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=y.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),function(G,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var y=e();for(var P in y)(typeof exports=="object"?exports:G)[P]=y[P]}}(typeof self!="undefined"?self:this,function(){return function(G){var e={};function y(P){if(e[P])return e[P].exports;var L=e[P]={i:P,l:!1,exports:{}};return G[P].call(L.exports,L,L.exports,y),L.l=!0,L.exports}return y.m=G,y.c=e,y.d=function(P,L,k){y.o(P,L)||Object.defineProperty(P,L,{enumerable:!0,get:k})},y.r=function(P){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(P,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(P,"__esModule",{value:!0})},y.t=function(P,L){if(1&L&&(P=y(P)),8&L||4&L&&typeof P=="object"&&P&&P.__esModule)return P;var k=Object.create(null);if(y.r(k),Object.defineProperty(k,"default",{enumerable:!0,value:P}),2&L&&typeof P!="string")for(var A in P)y.d(k,A,function(R){return P[R]}.bind(null,A));return k},y.n=function(P){var L=P&&P.__esModule?function(){return P.default}:function(){return P};return y.d(L,"a",L),L},y.o=function(P,L){return Object.prototype.hasOwnProperty.call(P,L)},y.p="",y(y.s=0)}([function(G,e,y){(function(P){var L;e=G.exports=X,L=typeof P=="object"&&P.env&&P.env.NODE_DEBUG&&/\bsemver\b/i.test(P.env.NODE_DEBUG)?function(){var J=Array.prototype.slice.call(arguments,0);J.unshift("SEMVER"),console.log.apply(console,J)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var k=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,R=e.re=[],p=e.src=[],S=0,n=S++;p[n]="0|[1-9]\\d*";var f=S++;p[f]="[0-9]+";var m=S++;p[m]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var C=S++;p[C]="("+p[n]+")\\.("+p[n]+")\\.("+p[n]+")";var h=S++;p[h]="("+p[f]+")\\.("+p[f]+")\\.("+p[f]+")";var E=S++;p[E]="(?:"+p[n]+"|"+p[m]+")";var D=S++;p[D]="(?:"+p[f]+"|"+p[m]+")";var b=S++;p[b]="(?:-("+p[E]+"(?:\\."+p[E]+")*))";var I=S++;p[I]="(?:-?("+p[D]+"(?:\\."+p[D]+")*))";var g=S++;p[g]="[0-9A-Za-z-]+";var a=S++;p[a]="(?:\\+("+p[g]+"(?:\\."+p[g]+")*))";var s=S++,t="v?"+p[C]+p[b]+"?"+p[a]+"?";p[s]="^"+t+"$";var r="[v=\\s]*"+p[h]+p[I]+"?"+p[a]+"?",i=S++;p[i]="^"+r+"$";var o=S++;p[o]="((?:<|>)?=?)";var c=S++;p[c]=p[f]+"|x|X|\\*";var l=S++;p[l]=p[n]+"|x|X|\\*";var u=S++;p[u]="[v=\\s]*("+p[l]+")(?:\\.("+p[l]+")(?:\\.("+p[l]+")(?:"+p[b]+")?"+p[a]+"?)?)?";var v=S++;p[v]="[v=\\s]*("+p[c]+")(?:\\.("+p[c]+")(?:\\.("+p[c]+")(?:"+p[I]+")?"+p[a]+"?)?)?";var w=S++;p[w]="^"+p[o]+"\\s*"+p[u]+"$";var d=S++;p[d]="^"+p[o]+"\\s*"+p[v]+"$";var T=S++;p[T]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var F=S++;p[F]="(?:~>?)";var z=S++;p[z]="(\\s*)"+p[F]+"\\s+",R[z]=new RegExp(p[z],"g");var B=S++;p[B]="^"+p[F]+p[u]+"$";var K=S++;p[K]="^"+p[F]+p[v]+"$";var j=S++;p[j]="(?:\\^)";var H=S++;p[H]="(\\s*)"+p[j]+"\\s+",R[H]=new RegExp(p[H],"g");var q=S++;p[q]="^"+p[j]+p[u]+"$";var $=S++;p[$]="^"+p[j]+p[v]+"$";var M=S++;p[M]="^"+p[o]+"\\s*("+r+")$|^$";var U=S++;p[U]="^"+p[o]+"\\s*("+t+")$|^$";var O=S++;p[O]="(\\s*)"+p[o]+"\\s*("+r+"|"+p[u]+")",R[O]=new RegExp(p[O],"g");var _=S++;p[_]="^\\s*("+p[u]+")\\s+-\\s+("+p[u]+")\\s*$";var N=S++;p[N]="^\\s*("+p[v]+")\\s+-\\s+("+p[v]+")\\s*$";var W=S++;p[W]="(<|>)?=?\\s*\\*";for(var V=0;V<35;V++)L(V,p[V]),R[V]||(R[V]=new RegExp(p[V]));function Q(J,re){if(J instanceof X)return J;if(typeof J!="string"||J.length>k||!(re?R[i]:R[s]).test(J))return null;try{return new X(J,re)}catch(se){return null}}function X(J,re){if(J instanceof X){if(J.loose===re)return J;J=J.version}else if(typeof J!="string")throw new TypeError("Invalid Version: "+J);if(J.length>k)throw new TypeError("version is longer than "+k+" characters");if(!(this instanceof X))return new X(J,re);L("SemVer",J,re),this.loose=re;var se=J.trim().match(re?R[i]:R[s]);if(!se)throw new TypeError("Invalid Version: "+J);if(this.raw=J,this.major=+se[1],this.minor=+se[2],this.patch=+se[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");se[4]?this.prerelease=se[4].split(".").map(function(me){if(/^[0-9]+$/.test(me)){var Se=+me;if(Se>=0&&Se<A)return Se}return me}):this.prerelease=[],this.build=se[5]?se[5].split("."):[],this.format()}e.parse=Q,e.valid=function(J,re){var se=Q(J,re);return se?se.version:null},e.clean=function(J,re){var se=Q(J.trim().replace(/^[=v]+/,""),re);return se?se.version:null},e.SemVer=X,X.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},X.prototype.toString=function(){return this.version},X.prototype.compare=function(J){return L("SemVer.compare",this.version,this.loose,J),J instanceof X||(J=new X(J,this.loose)),this.compareMain(J)||this.comparePre(J)},X.prototype.compareMain=function(J){return J instanceof X||(J=new X(J,this.loose)),ne(this.major,J.major)||ne(this.minor,J.minor)||ne(this.patch,J.patch)},X.prototype.comparePre=function(J){if(J instanceof X||(J=new X(J,this.loose)),this.prerelease.length&&!J.prerelease.length)return-1;if(!this.prerelease.length&&J.prerelease.length)return 1;if(!this.prerelease.length&&!J.prerelease.length)return 0;var re=0;do{var se=this.prerelease[re],me=J.prerelease[re];if(L("prerelease compare",re,se,me),se===void 0&&me===void 0)return 0;if(me===void 0)return 1;if(se===void 0)return-1;if(se!==me)return ne(se,me)}while(++re)},X.prototype.inc=function(J,re){switch(J){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",re);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",re);break;case"prepatch":this.prerelease.length=0,this.inc("patch",re),this.inc("pre",re);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",re),this.inc("pre",re);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var se=this.prerelease.length;--se>=0;)typeof this.prerelease[se]=="number"&&(this.prerelease[se]++,se=-2);se===-1&&this.prerelease.push(0)}re&&(this.prerelease[0]===re?isNaN(this.prerelease[1])&&(this.prerelease=[re,0]):this.prerelease=[re,0]);break;default:throw new Error("invalid increment argument: "+J)}return this.format(),this.raw=this.version,this},e.inc=function(J,re,se,me){typeof se=="string"&&(me=se,se=void 0);try{return new X(J,se).inc(re,me).version}catch(Se){return null}},e.diff=function(J,re){if(pe(J,re))return null;var se=Q(J),me=Q(re);if(se.prerelease.length||me.prerelease.length){for(var Se in se)if((Se==="major"||Se==="minor"||Se==="patch")&&se[Se]!==me[Se])return"pre"+Se;return"prerelease"}for(var Se in se)if((Se==="major"||Se==="minor"||Se==="patch")&&se[Se]!==me[Se])return Se},e.compareIdentifiers=ne;var ie=/^[0-9]+$/;function ne(J,re){var se=ie.test(J),me=ie.test(re);return se&&me&&(J=+J,re=+re),se&&!me?-1:me&&!se?1:J<re?-1:J>re?1:0}function ce(J,re,se){return new X(J,se).compare(new X(re,se))}function le(J,re,se){return ce(J,re,se)>0}function ve(J,re,se){return ce(J,re,se)<0}function pe(J,re,se){return ce(J,re,se)===0}function Ce(J,re,se){return ce(J,re,se)!==0}function Ae(J,re,se){return ce(J,re,se)>=0}function _e(J,re,se){return ce(J,re,se)<=0}function Oe(J,re,se,me){var Se;switch(re){case"===":typeof J=="object"&&(J=J.version),typeof se=="object"&&(se=se.version),Se=J===se;break;case"!==":typeof J=="object"&&(J=J.version),typeof se=="object"&&(se=se.version),Se=J!==se;break;case"":case"=":case"==":Se=pe(J,se,me);break;case"!=":Se=Ce(J,se,me);break;case">":Se=le(J,se,me);break;case">=":Se=Ae(J,se,me);break;case"<":Se=ve(J,se,me);break;case"<=":Se=_e(J,se,me);break;default:throw new TypeError("Invalid operator: "+re)}return Se}function ke(J,re){if(J instanceof ke){if(J.loose===re)return J;J=J.value}if(!(this instanceof ke))return new ke(J,re);L("comparator",J,re),this.loose=re,this.parse(J),this.semver===je?this.value="":this.value=this.operator+this.semver.version,L("comp",this)}e.rcompareIdentifiers=function(J,re){return ne(re,J)},e.major=function(J,re){return new X(J,re).major},e.minor=function(J,re){return new X(J,re).minor},e.patch=function(J,re){return new X(J,re).patch},e.compare=ce,e.compareLoose=function(J,re){return ce(J,re,!0)},e.rcompare=function(J,re,se){return ce(re,J,se)},e.sort=function(J,re){return J.sort(function(se,me){return e.compare(se,me,re)})},e.rsort=function(J,re){return J.sort(function(se,me){return e.rcompare(se,me,re)})},e.gt=le,e.lt=ve,e.eq=pe,e.neq=Ce,e.gte=Ae,e.lte=_e,e.cmp=Oe,e.Comparator=ke;var je={};function Ie(J,re){if(J instanceof Ie)return J.loose===re?J:new Ie(J.raw,re);if(J instanceof ke)return new Ie(J.value,re);if(!(this instanceof Ie))return new Ie(J,re);if(this.loose=re,this.raw=J,this.set=J.split(/\s*\|\|\s*/).map(function(se){return this.parseRange(se.trim())},this).filter(function(se){return se.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+J);this.format()}function Te(J){return!J||J.toLowerCase()==="x"||J==="*"}function Ke(J,re,se,me,Se,Pe,be,Ue,De,x,te,ae,oe){return((re=Te(se)?"":Te(me)?">="+se+".0.0":Te(Se)?">="+se+"."+me+".0":">="+re)+" "+(Ue=Te(De)?"":Te(x)?"<"+(+De+1)+".0.0":Te(te)?"<"+De+"."+(+x+1)+".0":ae?"<="+De+"."+x+"."+te+"-"+ae:"<="+Ue)).trim()}function Ye(J,re){for(var se=0;se<J.length;se++)if(!J[se].test(re))return!1;if(re.prerelease.length){for(se=0;se<J.length;se++)if(L(J[se].semver),J[se].semver!==je&&J[se].semver.prerelease.length>0){var me=J[se].semver;if(me.major===re.major&&me.minor===re.minor&&me.patch===re.patch)return!0}return!1}return!0}function $e(J,re,se){try{re=new Ie(re,se)}catch(me){return!1}return re.test(J)}function qe(J,re,se,me){var Se,Pe,be,Ue,De;switch(J=new X(J,me),re=new Ie(re,me),se){case">":Se=le,Pe=_e,be=ve,Ue=">",De=">=";break;case"<":Se=ve,Pe=Ae,be=le,Ue="<",De="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if($e(J,re,me))return!1;for(var x=0;x<re.set.length;++x){var te=re.set[x],ae=null,oe=null;if(te.forEach(function(he){he.semver===je&&(he=new ke(">=0.0.0")),ae=ae||he,oe=oe||he,Se(he.semver,ae.semver,me)?ae=he:be(he.semver,oe.semver,me)&&(oe=he)}),ae.operator===Ue||ae.operator===De||(!oe.operator||oe.operator===Ue)&&Pe(J,oe.semver)||oe.operator===De&&be(J,oe.semver))return!1}return!0}ke.prototype.parse=function(J){var re=this.loose?R[M]:R[U],se=J.match(re);if(!se)throw new TypeError("Invalid comparator: "+J);this.operator=se[1],this.operator==="="&&(this.operator=""),se[2]?this.semver=new X(se[2],this.loose):this.semver=je},ke.prototype.toString=function(){return this.value},ke.prototype.test=function(J){return L("Comparator.test",J,this.loose),this.semver===je||(typeof J=="string"&&(J=new X(J,this.loose)),Oe(J,this.operator,this.semver,this.loose))},ke.prototype.intersects=function(J,re){if(!(J instanceof ke))throw new TypeError("a Comparator is required");var se;if(this.operator==="")return se=new Ie(J.value,re),$e(this.value,se,re);if(J.operator==="")return se=new Ie(this.value,re),$e(J.semver,se,re);var me=!(this.operator!==">="&&this.operator!==">"||J.operator!==">="&&J.operator!==">"),Se=!(this.operator!=="<="&&this.operator!=="<"||J.operator!=="<="&&J.operator!=="<"),Pe=this.semver.version===J.semver.version,be=!(this.operator!==">="&&this.operator!=="<="||J.operator!==">="&&J.operator!=="<="),Ue=Oe(this.semver,"<",J.semver,re)&&(this.operator===">="||this.operator===">")&&(J.operator==="<="||J.operator==="<"),De=Oe(this.semver,">",J.semver,re)&&(this.operator==="<="||this.operator==="<")&&(J.operator===">="||J.operator===">");return me||Se||Pe&&be||Ue||De},e.Range=Ie,Ie.prototype.format=function(){return this.range=this.set.map(function(J){return J.join(" ").trim()}).join("||").trim(),this.range},Ie.prototype.toString=function(){return this.range},Ie.prototype.parseRange=function(J){var re=this.loose;J=J.trim(),L("range",J,re);var se=re?R[N]:R[_];J=J.replace(se,Ke),L("hyphen replace",J),J=J.replace(R[O],"$1$2$3"),L("comparator trim",J,R[O]),J=(J=(J=J.replace(R[z],"$1~")).replace(R[H],"$1^")).split(/\s+/).join(" ");var me=re?R[M]:R[U],Se=J.split(" ").map(function(Pe){return function(be,Ue){return L("comp",be),be=function(De,x){return De.trim().split(/\s+/).map(function(te){return function(ae,oe){L("caret",ae,oe);var he=oe?R[$]:R[q];return ae.replace(he,function(ge,fe,ye,we,Ee){var ue;return L("caret",ae,ge,fe,ye,we,Ee),Te(fe)?ue="":Te(ye)?ue=">="+fe+".0.0 <"+(+fe+1)+".0.0":Te(we)?ue=fe==="0"?">="+fe+"."+ye+".0 <"+fe+"."+(+ye+1)+".0":">="+fe+"."+ye+".0 <"+(+fe+1)+".0.0":Ee?(L("replaceCaret pr",Ee),Ee.charAt(0)!=="-"&&(Ee="-"+Ee),ue=fe==="0"?ye==="0"?">="+fe+"."+ye+"."+we+Ee+" <"+fe+"."+ye+"."+(+we+1):">="+fe+"."+ye+"."+we+Ee+" <"+fe+"."+(+ye+1)+".0":">="+fe+"."+ye+"."+we+Ee+" <"+(+fe+1)+".0.0"):(L("no pr"),ue=fe==="0"?ye==="0"?">="+fe+"."+ye+"."+we+" <"+fe+"."+ye+"."+(+we+1):">="+fe+"."+ye+"."+we+" <"+fe+"."+(+ye+1)+".0":">="+fe+"."+ye+"."+we+" <"+(+fe+1)+".0.0"),L("caret return",ue),ue})}(te,x)}).join(" ")}(be,Ue),L("caret",be),be=function(De,x){return De.trim().split(/\s+/).map(function(te){return function(ae,oe){var he=oe?R[K]:R[B];return ae.replace(he,function(ge,fe,ye,we,Ee){var ue;return L("tilde",ae,ge,fe,ye,we,Ee),Te(fe)?ue="":Te(ye)?ue=">="+fe+".0.0 <"+(+fe+1)+".0.0":Te(we)?ue=">="+fe+"."+ye+".0 <"+fe+"."+(+ye+1)+".0":Ee?(L("replaceTilde pr",Ee),Ee.charAt(0)!=="-"&&(Ee="-"+Ee),ue=">="+fe+"."+ye+"."+we+Ee+" <"+fe+"."+(+ye+1)+".0"):ue=">="+fe+"."+ye+"."+we+" <"+fe+"."+(+ye+1)+".0",L("tilde return",ue),ue})}(te,x)}).join(" ")}(be,Ue),L("tildes",be),be=function(De,x){return L("replaceXRanges",De,x),De.split(/\s+/).map(function(te){return function(ae,oe){ae=ae.trim();var he=oe?R[d]:R[w];return ae.replace(he,function(ge,fe,ye,we,Ee,ue){L("xRange",ae,ge,fe,ye,we,Ee,ue);var Re=Te(ye),Fe=Re||Te(we),Me=Fe||Te(Ee);return fe==="="&&Me&&(fe=""),Re?ge=fe===">"||fe==="<"?"<0.0.0":"*":fe&&Me?(Fe&&(we=0),Me&&(Ee=0),fe===">"?(fe=">=",Fe?(ye=+ye+1,we=0,Ee=0):Me&&(we=+we+1,Ee=0)):fe==="<="&&(fe="<",Fe?ye=+ye+1:we=+we+1),ge=fe+ye+"."+we+"."+Ee):Fe?ge=">="+ye+".0.0 <"+(+ye+1)+".0.0":Me&&(ge=">="+ye+"."+we+".0 <"+ye+"."+(+we+1)+".0"),L("xRange return",ge),ge})}(te,x)}).join(" ")}(be,Ue),L("xrange",be),be=function(De,x){return L("replaceStars",De,x),De.trim().replace(R[W],"")}(be,Ue),L("stars",be),be}(Pe,re)}).join(" ").split(/\s+/);return this.loose&&(Se=Se.filter(function(Pe){return!!Pe.match(me)})),Se=Se.map(function(Pe){return new ke(Pe,re)})},Ie.prototype.intersects=function(J,re){if(!(J instanceof Ie))throw new TypeError("a Range is required");return this.set.some(function(se){return se.every(function(me){return J.set.some(function(Se){return Se.every(function(Pe){return me.intersects(Pe,re)})})})})},e.toComparators=function(J,re){return new Ie(J,re).set.map(function(se){return se.map(function(me){return me.value}).join(" ").trim().split(" ")})},Ie.prototype.test=function(J){if(!J)return!1;typeof J=="string"&&(J=new X(J,this.loose));for(var re=0;re<this.set.length;re++)if(Ye(this.set[re],J))return!0;return!1},e.satisfies=$e,e.maxSatisfying=function(J,re,se){var me=null,Se=null;try{var Pe=new Ie(re,se)}catch(be){return null}return J.forEach(function(be){Pe.test(be)&&(me&&Se.compare(be)!==-1||(Se=new X(me=be,se)))}),me},e.minSatisfying=function(J,re,se){var me=null,Se=null;try{var Pe=new Ie(re,se)}catch(be){return null}return J.forEach(function(be){Pe.test(be)&&(me&&Se.compare(be)!==1||(Se=new X(me=be,se)))}),me},e.validRange=function(J,re){try{return new Ie(J,re).range||"*"}catch(se){return null}},e.ltr=function(J,re,se){return qe(J,re,"<",se)},e.gtr=function(J,re,se){return qe(J,re,">",se)},e.outside=qe,e.prerelease=function(J,re){var se=Q(J,re);return se&&se.prerelease.length?se.prerelease:null},e.intersects=function(J,re,se){return J=new Ie(J,se),re=new Ie(re,se),J.intersects(re)},e.coerce=function(J){if(J instanceof X)return J;if(typeof J!="string")return null;var re=J.match(R[T]);return re==null?null:Q((re[1]||"0")+"."+(re[2]||"0")+"."+(re[3]||"0"))}}).call(this,y(1))},function(G,e){var y,P,L=G.exports={};function k(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function R(D){if(y===setTimeout)return setTimeout(D,0);if((y===k||!y)&&setTimeout)return y=setTimeout,setTimeout(D,0);try{return y(D,0)}catch(b){try{return y.call(null,D,0)}catch(I){return y.call(this,D,0)}}}(function(){try{y=typeof setTimeout=="function"?setTimeout:k}catch(D){y=k}try{P=typeof clearTimeout=="function"?clearTimeout:A}catch(D){P=A}})();var p,S=[],n=!1,f=-1;function m(){n&&p&&(n=!1,p.length?S=p.concat(S):f=-1,S.length&&C())}function C(){if(!n){var D=R(m);n=!0;for(var b=S.length;b;){for(p=S,S=[];++f<b;)p&&p[f].run();f=-1,b=S.length}p=null,n=!1,function(I){if(P===clearTimeout)return clearTimeout(I);if((P===A||!P)&&clearTimeout)return P=clearTimeout,clearTimeout(I);try{P(I)}catch(g){try{return P.call(null,I)}catch(a){return P.call(this,I)}}}(D)}}function h(D,b){this.fun=D,this.array=b}function E(){}L.nextTick=function(D){var b=new Array(arguments.length-1);if(arguments.length>1)for(var I=1;I<arguments.length;I++)b[I-1]=arguments[I];S.push(new h(D,b)),S.length!==1||n||R(C)},h.prototype.run=function(){this.fun.apply(null,this.array)},L.title="browser",L.browser=!0,L.env={},L.argv=[],L.version="",L.versions={},L.on=E,L.addListener=E,L.once=E,L.off=E,L.removeListener=E,L.removeAllListeners=E,L.emit=E,L.prependListener=E,L.prependOnceListener=E,L.listeners=function(D){return[]},L.binding=function(D){throw new Error("process.binding is not supported")},L.cwd=function(){return"/"},L.chdir=function(D){throw new Error("process.chdir is not supported")},L.umask=function(){return 0}}])}),define(Z[87],ee([0,1,6]),function(G,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const P=y.globals.performance&&typeof y.globals.performance.now=="function";class L{constructor(A){this._highResolution=P&&A,this._startTime=this._now(),this._stopTime=-1}static create(A=!0){return new L(A)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?y.globals.performance.now():Date.now()}}e.StopWatch=L}),define(Z[3],ee([0,1,11,65,2,66,87]),function(G,e,y,P,L,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.PauseableEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var R;(function(b){b.None=()=>L.Disposable.None;function I(j){return(H,q=null,$)=>{let M=!1,U;return U=j(O=>{if(!M)return U?U.dispose():M=!0,H.call(q,O)},null,$),M&&U.dispose(),U}}b.once=I;function g(j,H){return o((q,$=null,M)=>j(U=>q.call($,H(U)),null,M))}b.map=g;function a(j,H){return o((q,$=null,M)=>j(U=>{H(U),q.call($,U)},null,M))}b.forEach=a;function s(j,H){return o((q,$=null,M)=>j(U=>H(U)&&q.call($,U),null,M))}b.filter=s;function t(j){return j}b.signal=t;function r(...j){return(H,q=null,$)=>(0,L.combinedDisposable)(...j.map(M=>M(U=>H.call(q,U),null,$)))}b.any=r;function i(j,H,q){let $=q;return g(j,M=>($=H($,M),$))}b.reduce=i;function o(j){let H;const q=new m({onFirstListenerAdd(){H=j(q.fire,q)},onLastListenerRemove(){H.dispose()}});return q.event}b.snapshot=o;function c(j,H,q=100,$=!1,M){let U,O,_,N=0;const W=new m({leakWarningThreshold:M,onFirstListenerAdd(){U=j(V=>{N++,O=H(O,V),$&&!_&&(W.fire(O),O=void 0),clearTimeout(_),_=setTimeout(()=>{const Q=O;O=void 0,_=void 0,(!$||N>1)&&W.fire(Q),N=0},q)})},onLastListenerRemove(){U.dispose()}});return W.event}b.debounce=c;function l(j){const H=new Date().getTime();return g(I(j),q=>new Date().getTime()-H)}b.stopwatch=l;function u(j,H=(q,$)=>q===$){let q=!0,$;return s(j,M=>{const U=q||!H(M,$);return q=!1,$=M,U})}b.latch=u;function v(j,H){return[b.filter(j,H),b.filter(j,q=>!H(q))]}b.split=v;function w(j,H=!1,q=[]){let $=q.slice(),M=j(_=>{$?$.push(_):O.fire(_)});const U=()=>{$&&$.forEach(_=>O.fire(_)),$=null},O=new m({onFirstListenerAdd(){M||(M=j(_=>O.fire(_)))},onFirstListenerDidAdd(){$&&(H?setTimeout(U):U())},onLastListenerRemove(){M&&M.dispose(),M=null}});return O.event}b.buffer=w;class d{constructor(H){this.event=H}map(H){return new d(g(this.event,H))}forEach(H){return new d(a(this.event,H))}filter(H){return new d(s(this.event,H))}reduce(H,q){return new d(i(this.event,H,q))}latch(){return new d(u(this.event))}debounce(H,q=100,$=!1,M){return new d(c(this.event,H,q,$,M))}on(H,q,$){return this.event(H,q,$)}once(H,q,$){return I(this.event)(H,q,$)}}function T(j){return new d(j)}b.chain=T;function F(j,H,q=$=>$){const $=(..._)=>O.fire(q(..._)),M=()=>j.on(H,$),U=()=>j.removeListener(H,$),O=new m({onFirstListenerAdd:M,onLastListenerRemove:U});return O.event}b.fromNodeEventEmitter=F;function z(j,H,q=$=>$){const $=(..._)=>O.fire(q(..._)),M=()=>j.addEventListener(H,$),U=()=>j.removeEventListener(H,$),O=new m({onFirstListenerAdd:M,onLastListenerRemove:U});return O.event}b.fromDOMEventEmitter=z;function B(j){const H=new m;let q=!1;return j.then(void 0,()=>null).then(()=>{q?H.fire(void 0):setTimeout(()=>H.fire(void 0),0)}),q=!0,H.event}b.fromPromise=B;function K(j){return new Promise(H=>I(j)(H))}b.toPromise=K})(R=e.Event||(e.Event={}));class p{constructor(I){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${I}_${p._idPool++}`}start(I){this._stopWatch=new A.StopWatch(!0),this._listenerCount=I}stop(){if(this._stopWatch){const I=this._stopWatch.elapsed();this._elapsedOverall+=I,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${I.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}p._idPool=0;let S=-1;function n(b){const I=S;return S=b,{dispose(){S=I}}}e.setGlobalLeakWarningThreshold=n;class f{constructor(I,g=Math.random().toString(18).slice(2,5)){this.customThreshold=I,this.name=g,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(I){let g=S;if(typeof this.customThreshold=="number"&&(g=this.customThreshold),g<=0||I<g)return;this._stacks||(this._stacks=new Map);const a=new Error().stack.split(`
`).slice(3).join(`
`),s=this._stacks.get(a)||0;if(this._stacks.set(a,s+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=g*.5;let t,r=0;for(const[i,o]of this._stacks)(!t||r<o)&&(t=i,r=o);console.warn(`[${this.name}] potential listener LEAK detected, having ${I} listeners already. MOST frequent listener (${r}):`),console.warn(t)}return()=>{const t=this._stacks.get(a)||0;this._stacks.set(a,t-1)}}}class m{constructor(I){var g;this._disposed=!1,this._options=I,this._leakageMon=S>0?new f(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=((g=this._options)===null||g===void 0?void 0:g._profName)?new p(this._options._profName):void 0}get event(){return this._event||(this._event=(I,g,a)=>{var s;this._listeners||(this._listeners=new k.LinkedList);const t=this._listeners.isEmpty();t&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const r=this._listeners.push(g?[I,g]:I);t&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,I,g);const i=(s=this._leakageMon)===null||s===void 0?void 0:s.check(this._listeners.size);let o;return o={dispose:()=>{i&&i(),o.dispose=m._noop,this._disposed||(r(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))}},a instanceof L.DisposableStore?a.add(o):Array.isArray(a)&&a.push(o),o}),this._event}fire(I){var g,a;if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new k.LinkedList);for(let s of this._listeners)this._deliveryQueue.push([s,I]);for((g=this._perfMon)===null||g===void 0||g.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[s,t]=this._deliveryQueue.shift();try{typeof s=="function"?s.call(void 0,t):s[0].call(s[1],t)}catch(r){(0,y.onUnexpectedError)(r)}}(a=this._perfMon)===null||a===void 0||a.stop()}}dispose(){var I,g,a,s,t;this._disposed||(this._disposed=!0,(I=this._listeners)===null||I===void 0||I.clear(),(g=this._deliveryQueue)===null||g===void 0||g.clear(),(s=(a=this._options)===null||a===void 0?void 0:a.onLastListenerRemove)===null||s===void 0||s.call(a),(t=this._leakageMon)===null||t===void 0||t.dispose())}}e.Emitter=m,m._noop=function(){};class C extends m{constructor(I){super(I);this._isPaused=0,this._eventQueue=new k.LinkedList,this._mergeFn=I==null?void 0:I.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const I=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(I))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(I){this._listeners&&(this._isPaused!==0?this._eventQueue.push(I):super.fire(I))}}e.PauseableEmitter=C;class h{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new m({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(I){const g={event:I,listener:null};this.events.push(g),this.hasListeners&&this.hook(g);const a=()=>{this.hasListeners&&this.unhook(g);const s=this.events.indexOf(g);this.events.splice(s,1)};return(0,L.toDisposable)((0,P.once)(a))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(I=>this.hook(I))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(I=>this.unhook(I))}hook(I){I.listener=I.event(g=>this.emitter.fire(g))}unhook(I){I.listener&&I.listener.dispose(),I.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=h;class E{constructor(){this.buffers=[]}wrapEvent(I){return(g,a,s)=>I(t=>{const r=this.buffers[this.buffers.length-1];r?r.push(()=>g.call(a,t)):g.call(a,t)},void 0,s)}bufferEvents(I){const g=[];this.buffers.push(g);const a=I();return this.buffers.pop(),g.forEach(s=>s()),a}}e.EventBufferer=E;class D{constructor(){this.listening=!1,this.inputEvent=R.None,this.inputEventListener=L.Disposable.None,this.emitter=new m({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(I){this.inputEvent=I,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=I(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=D}),define(Z[29],ee([0,1,3]),function(G,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const P=Object.freeze(function(R,p){const S=setTimeout(R.bind(p),0);return{dispose(){clearTimeout(S)}}});var L;(function(R){function p(S){return S===R.None||S===R.Cancelled||S instanceof k?!0:!S||typeof S!="object"?!1:typeof S.isCancellationRequested=="boolean"&&typeof S.onCancellationRequested=="function"}R.isCancellationToken=p,R.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:y.Event.None}),R.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:P})})(L=e.CancellationToken||(e.CancellationToken={}));class k{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?P:(this._emitter||(this._emitter=new y.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class A{constructor(p){this._token=void 0,this._parentListener=void 0,this._parentListener=p&&p.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new k),this._token}cancel(){this._token?this._token instanceof k&&this._token.cancel():this._token=L.Cancelled}dispose(p=!1){p&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof k&&this._token.dispose():this._token=L.None}}e.CancellationTokenSource=A}),define(Z[54],ee([0,1,3]),function(G,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class P{constructor(){this._icons=new Map,this._onDidRegister=new y.Emitter}add(f){const m=this._icons.get(f.id);m?f.description?m.description=f.description:console.error(`Duplicate registration of codicon ${f.id}`):(this._icons.set(f.id,f),this._onDidRegister.fire(f))}get(f){return this._icons.get(f)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const L=new P;e.iconRegistry=L;function k(n,f){return new R(n,f)}e.registerCodicon=k;function A(n){return n?n.replace(/\$\((.*?)\)/g,(f,m)=>` ${m} `).trim():""}e.getCodiconAriaLabel=A;class R{constructor(f,m,C){this.id=f,this.definition=m,this.description=C,L.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=R;function p(n,f){const m=["codicon","codicon-"+n];return f&&m.push("codicon-modifier-"+f),m}e.getClassNamesArray=p;var S;(function(n){n.iconNameSegment="[A-Za-z0-9]+",n.iconNameExpression="[A-Za-z0-9\\-]+",n.iconModifierExpression="~[A-Za-z]+";const f=new RegExp(`^(${n.iconNameExpression})(${n.iconModifierExpression})?$`);function m(E){if(E instanceof R)return["codicon","codicon-"+E.id];const D=f.exec(E.id);if(!D)return m(R.error);let[,b,I]=D;const g=["codicon","codicon-"+b];return I&&g.push("codicon-modifier-"+I.substr(1)),g}n.asClassNameArray=m;function C(E){return m(E).join(" ")}n.asClassName=C;function h(E){return"."+m(E).join(".")}n.asCSSSelector=h})(S=e.CSSIcon||(e.CSSIcon={})),function(n){n.add=new n("add",{fontCharacter:"\\ea60"}),n.plus=new n("plus",{fontCharacter:"\\ea60"}),n.gistNew=new n("gist-new",{fontCharacter:"\\ea60"}),n.repoCreate=new n("repo-create",{fontCharacter:"\\ea60"}),n.lightbulb=new n("lightbulb",{fontCharacter:"\\ea61"}),n.lightBulb=new n("light-bulb",{fontCharacter:"\\ea61"}),n.repo=new n("repo",{fontCharacter:"\\ea62"}),n.repoDelete=new n("repo-delete",{fontCharacter:"\\ea62"}),n.gistFork=new n("gist-fork",{fontCharacter:"\\ea63"}),n.repoForked=new n("repo-forked",{fontCharacter:"\\ea63"}),n.gitPullRequest=new n("git-pull-request",{fontCharacter:"\\ea64"}),n.gitPullRequestAbandoned=new n("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),n.recordKeys=new n("record-keys",{fontCharacter:"\\ea65"}),n.keyboard=new n("keyboard",{fontCharacter:"\\ea65"}),n.tag=new n("tag",{fontCharacter:"\\ea66"}),n.tagAdd=new n("tag-add",{fontCharacter:"\\ea66"}),n.tagRemove=new n("tag-remove",{fontCharacter:"\\ea66"}),n.person=new n("person",{fontCharacter:"\\ea67"}),n.personFollow=new n("person-follow",{fontCharacter:"\\ea67"}),n.personOutline=new n("person-outline",{fontCharacter:"\\ea67"}),n.personFilled=new n("person-filled",{fontCharacter:"\\ea67"}),n.gitBranch=new n("git-branch",{fontCharacter:"\\ea68"}),n.gitBranchCreate=new n("git-branch-create",{fontCharacter:"\\ea68"}),n.gitBranchDelete=new n("git-branch-delete",{fontCharacter:"\\ea68"}),n.sourceControl=new n("source-control",{fontCharacter:"\\ea68"}),n.mirror=new n("mirror",{fontCharacter:"\\ea69"}),n.mirrorPublic=new n("mirror-public",{fontCharacter:"\\ea69"}),n.star=new n("star",{fontCharacter:"\\ea6a"}),n.starAdd=new n("star-add",{fontCharacter:"\\ea6a"}),n.starDelete=new n("star-delete",{fontCharacter:"\\ea6a"}),n.starEmpty=new n("star-empty",{fontCharacter:"\\ea6a"}),n.comment=new n("comment",{fontCharacter:"\\ea6b"}),n.commentAdd=new n("comment-add",{fontCharacter:"\\ea6b"}),n.alert=new n("alert",{fontCharacter:"\\ea6c"}),n.warning=new n("warning",{fontCharacter:"\\ea6c"}),n.search=new n("search",{fontCharacter:"\\ea6d"}),n.searchSave=new n("search-save",{fontCharacter:"\\ea6d"}),n.logOut=new n("log-out",{fontCharacter:"\\ea6e"}),n.signOut=new n("sign-out",{fontCharacter:"\\ea6e"}),n.logIn=new n("log-in",{fontCharacter:"\\ea6f"}),n.signIn=new n("sign-in",{fontCharacter:"\\ea6f"}),n.eye=new n("eye",{fontCharacter:"\\ea70"}),n.eyeUnwatch=new n("eye-unwatch",{fontCharacter:"\\ea70"}),n.eyeWatch=new n("eye-watch",{fontCharacter:"\\ea70"}),n.circleFilled=new n("circle-filled",{fontCharacter:"\\ea71"}),n.primitiveDot=new n("primitive-dot",{fontCharacter:"\\ea71"}),n.closeDirty=new n("close-dirty",{fontCharacter:"\\ea71"}),n.debugBreakpoint=new n("debug-breakpoint",{fontCharacter:"\\ea71"}),n.debugBreakpointDisabled=new n("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),n.debugHint=new n("debug-hint",{fontCharacter:"\\ea71"}),n.primitiveSquare=new n("primitive-square",{fontCharacter:"\\ea72"}),n.edit=new n("edit",{fontCharacter:"\\ea73"}),n.pencil=new n("pencil",{fontCharacter:"\\ea73"}),n.info=new n("info",{fontCharacter:"\\ea74"}),n.issueOpened=new n("issue-opened",{fontCharacter:"\\ea74"}),n.gistPrivate=new n("gist-private",{fontCharacter:"\\ea75"}),n.gitForkPrivate=new n("git-fork-private",{fontCharacter:"\\ea75"}),n.lock=new n("lock",{fontCharacter:"\\ea75"}),n.mirrorPrivate=new n("mirror-private",{fontCharacter:"\\ea75"}),n.close=new n("close",{fontCharacter:"\\ea76"}),n.removeClose=new n("remove-close",{fontCharacter:"\\ea76"}),n.x=new n("x",{fontCharacter:"\\ea76"}),n.repoSync=new n("repo-sync",{fontCharacter:"\\ea77"}),n.sync=new n("sync",{fontCharacter:"\\ea77"}),n.clone=new n("clone",{fontCharacter:"\\ea78"}),n.desktopDownload=new n("desktop-download",{fontCharacter:"\\ea78"}),n.beaker=new n("beaker",{fontCharacter:"\\ea79"}),n.microscope=new n("microscope",{fontCharacter:"\\ea79"}),n.vm=new n("vm",{fontCharacter:"\\ea7a"}),n.deviceDesktop=new n("device-desktop",{fontCharacter:"\\ea7a"}),n.file=new n("file",{fontCharacter:"\\ea7b"}),n.fileText=new n("file-text",{fontCharacter:"\\ea7b"}),n.more=new n("more",{fontCharacter:"\\ea7c"}),n.ellipsis=new n("ellipsis",{fontCharacter:"\\ea7c"}),n.kebabHorizontal=new n("kebab-horizontal",{fontCharacter:"\\ea7c"}),n.mailReply=new n("mail-reply",{fontCharacter:"\\ea7d"}),n.reply=new n("reply",{fontCharacter:"\\ea7d"}),n.organization=new n("organization",{fontCharacter:"\\ea7e"}),n.organizationFilled=new n("organization-filled",{fontCharacter:"\\ea7e"}),n.organizationOutline=new n("organization-outline",{fontCharacter:"\\ea7e"}),n.newFile=new n("new-file",{fontCharacter:"\\ea7f"}),n.fileAdd=new n("file-add",{fontCharacter:"\\ea7f"}),n.newFolder=new n("new-folder",{fontCharacter:"\\ea80"}),n.fileDirectoryCreate=new n("file-directory-create",{fontCharacter:"\\ea80"}),n.trash=new n("trash",{fontCharacter:"\\ea81"}),n.trashcan=new n("trashcan",{fontCharacter:"\\ea81"}),n.history=new n("history",{fontCharacter:"\\ea82"}),n.clock=new n("clock",{fontCharacter:"\\ea82"}),n.folder=new n("folder",{fontCharacter:"\\ea83"}),n.fileDirectory=new n("file-directory",{fontCharacter:"\\ea83"}),n.symbolFolder=new n("symbol-folder",{fontCharacter:"\\ea83"}),n.logoGithub=new n("logo-github",{fontCharacter:"\\ea84"}),n.markGithub=new n("mark-github",{fontCharacter:"\\ea84"}),n.github=new n("github",{fontCharacter:"\\ea84"}),n.terminal=new n("terminal",{fontCharacter:"\\ea85"}),n.console=new n("console",{fontCharacter:"\\ea85"}),n.repl=new n("repl",{fontCharacter:"\\ea85"}),n.zap=new n("zap",{fontCharacter:"\\ea86"}),n.symbolEvent=new n("symbol-event",{fontCharacter:"\\ea86"}),n.error=new n("error",{fontCharacter:"\\ea87"}),n.stop=new n("stop",{fontCharacter:"\\ea87"}),n.variable=new n("variable",{fontCharacter:"\\ea88"}),n.symbolVariable=new n("symbol-variable",{fontCharacter:"\\ea88"}),n.array=new n("array",{fontCharacter:"\\ea8a"}),n.symbolArray=new n("symbol-array",{fontCharacter:"\\ea8a"}),n.symbolModule=new n("symbol-module",{fontCharacter:"\\ea8b"}),n.symbolPackage=new n("symbol-package",{fontCharacter:"\\ea8b"}),n.symbolNamespace=new n("symbol-namespace",{fontCharacter:"\\ea8b"}),n.symbolObject=new n("symbol-object",{fontCharacter:"\\ea8b"}),n.symbolMethod=new n("symbol-method",{fontCharacter:"\\ea8c"}),n.symbolFunction=new n("symbol-function",{fontCharacter:"\\ea8c"}),n.symbolConstructor=new n("symbol-constructor",{fontCharacter:"\\ea8c"}),n.symbolBoolean=new n("symbol-boolean",{fontCharacter:"\\ea8f"}),n.symbolNull=new n("symbol-null",{fontCharacter:"\\ea8f"}),n.symbolNumeric=new n("symbol-numeric",{fontCharacter:"\\ea90"}),n.symbolNumber=new n("symbol-number",{fontCharacter:"\\ea90"}),n.symbolStructure=new n("symbol-structure",{fontCharacter:"\\ea91"}),n.symbolStruct=new n("symbol-struct",{fontCharacter:"\\ea91"}),n.symbolParameter=new n("symbol-parameter",{fontCharacter:"\\ea92"}),n.symbolTypeParameter=new n("symbol-type-parameter",{fontCharacter:"\\ea92"}),n.symbolKey=new n("symbol-key",{fontCharacter:"\\ea93"}),n.symbolText=new n("symbol-text",{fontCharacter:"\\ea93"}),n.symbolReference=new n("symbol-reference",{fontCharacter:"\\ea94"}),n.goToFile=new n("go-to-file",{fontCharacter:"\\ea94"}),n.symbolEnum=new n("symbol-enum",{fontCharacter:"\\ea95"}),n.symbolValue=new n("symbol-value",{fontCharacter:"\\ea95"}),n.symbolRuler=new n("symbol-ruler",{fontCharacter:"\\ea96"}),n.symbolUnit=new n("symbol-unit",{fontCharacter:"\\ea96"}),n.activateBreakpoints=new n("activate-breakpoints",{fontCharacter:"\\ea97"}),n.archive=new n("archive",{fontCharacter:"\\ea98"}),n.arrowBoth=new n("arrow-both",{fontCharacter:"\\ea99"}),n.arrowDown=new n("arrow-down",{fontCharacter:"\\ea9a"}),n.arrowLeft=new n("arrow-left",{fontCharacter:"\\ea9b"}),n.arrowRight=new n("arrow-right",{fontCharacter:"\\ea9c"}),n.arrowSmallDown=new n("arrow-small-down",{fontCharacter:"\\ea9d"}),n.arrowSmallLeft=new n("arrow-small-left",{fontCharacter:"\\ea9e"}),n.arrowSmallRight=new n("arrow-small-right",{fontCharacter:"\\ea9f"}),n.arrowSmallUp=new n("arrow-small-up",{fontCharacter:"\\eaa0"}),n.arrowUp=new n("arrow-up",{fontCharacter:"\\eaa1"}),n.bell=new n("bell",{fontCharacter:"\\eaa2"}),n.bold=new n("bold",{fontCharacter:"\\eaa3"}),n.book=new n("book",{fontCharacter:"\\eaa4"}),n.bookmark=new n("bookmark",{fontCharacter:"\\eaa5"}),n.debugBreakpointConditionalUnverified=new n("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),n.debugBreakpointConditional=new n("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),n.debugBreakpointConditionalDisabled=new n("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),n.debugBreakpointDataUnverified=new n("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),n.debugBreakpointData=new n("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),n.debugBreakpointDataDisabled=new n("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),n.debugBreakpointLogUnverified=new n("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),n.debugBreakpointLog=new n("debug-breakpoint-log",{fontCharacter:"\\eaab"}),n.debugBreakpointLogDisabled=new n("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),n.briefcase=new n("briefcase",{fontCharacter:"\\eaac"}),n.broadcast=new n("broadcast",{fontCharacter:"\\eaad"}),n.browser=new n("browser",{fontCharacter:"\\eaae"}),n.bug=new n("bug",{fontCharacter:"\\eaaf"}),n.calendar=new n("calendar",{fontCharacter:"\\eab0"}),n.caseSensitive=new n("case-sensitive",{fontCharacter:"\\eab1"}),n.check=new n("check",{fontCharacter:"\\eab2"}),n.checklist=new n("checklist",{fontCharacter:"\\eab3"}),n.chevronDown=new n("chevron-down",{fontCharacter:"\\eab4"}),n.chevronLeft=new n("chevron-left",{fontCharacter:"\\eab5"}),n.chevronRight=new n("chevron-right",{fontCharacter:"\\eab6"}),n.chevronUp=new n("chevron-up",{fontCharacter:"\\eab7"}),n.chromeClose=new n("chrome-close",{fontCharacter:"\\eab8"}),n.chromeMaximize=new n("chrome-maximize",{fontCharacter:"\\eab9"}),n.chromeMinimize=new n("chrome-minimize",{fontCharacter:"\\eaba"}),n.chromeRestore=new n("chrome-restore",{fontCharacter:"\\eabb"}),n.circleOutline=new n("circle-outline",{fontCharacter:"\\eabc"}),n.debugBreakpointUnverified=new n("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),n.circleSlash=new n("circle-slash",{fontCharacter:"\\eabd"}),n.circuitBoard=new n("circuit-board",{fontCharacter:"\\eabe"}),n.clearAll=new n("clear-all",{fontCharacter:"\\eabf"}),n.clippy=new n("clippy",{fontCharacter:"\\eac0"}),n.closeAll=new n("close-all",{fontCharacter:"\\eac1"}),n.cloudDownload=new n("cloud-download",{fontCharacter:"\\eac2"}),n.cloudUpload=new n("cloud-upload",{fontCharacter:"\\eac3"}),n.code=new n("code",{fontCharacter:"\\eac4"}),n.collapseAll=new n("collapse-all",{fontCharacter:"\\eac5"}),n.colorMode=new n("color-mode",{fontCharacter:"\\eac6"}),n.commentDiscussion=new n("comment-discussion",{fontCharacter:"\\eac7"}),n.compareChanges=new n("compare-changes",{fontCharacter:"\\eafd"}),n.creditCard=new n("credit-card",{fontCharacter:"\\eac9"}),n.dash=new n("dash",{fontCharacter:"\\eacc"}),n.dashboard=new n("dashboard",{fontCharacter:"\\eacd"}),n.database=new n("database",{fontCharacter:"\\eace"}),n.debugContinue=new n("debug-continue",{fontCharacter:"\\eacf"}),n.debugDisconnect=new n("debug-disconnect",{fontCharacter:"\\ead0"}),n.debugPause=new n("debug-pause",{fontCharacter:"\\ead1"}),n.debugRestart=new n("debug-restart",{fontCharacter:"\\ead2"}),n.debugStart=new n("debug-start",{fontCharacter:"\\ead3"}),n.debugStepInto=new n("debug-step-into",{fontCharacter:"\\ead4"}),n.debugStepOut=new n("debug-step-out",{fontCharacter:"\\ead5"}),n.debugStepOver=new n("debug-step-over",{fontCharacter:"\\ead6"}),n.debugStop=new n("debug-stop",{fontCharacter:"\\ead7"}),n.debug=new n("debug",{fontCharacter:"\\ead8"}),n.deviceCameraVideo=new n("device-camera-video",{fontCharacter:"\\ead9"}),n.deviceCamera=new n("device-camera",{fontCharacter:"\\eada"}),n.deviceMobile=new n("device-mobile",{fontCharacter:"\\eadb"}),n.diffAdded=new n("diff-added",{fontCharacter:"\\eadc"}),n.diffIgnored=new n("diff-ignored",{fontCharacter:"\\eadd"}),n.diffModified=new n("diff-modified",{fontCharacter:"\\eade"}),n.diffRemoved=new n("diff-removed",{fontCharacter:"\\eadf"}),n.diffRenamed=new n("diff-renamed",{fontCharacter:"\\eae0"}),n.diff=new n("diff",{fontCharacter:"\\eae1"}),n.discard=new n("discard",{fontCharacter:"\\eae2"}),n.editorLayout=new n("editor-layout",{fontCharacter:"\\eae3"}),n.emptyWindow=new n("empty-window",{fontCharacter:"\\eae4"}),n.exclude=new n("exclude",{fontCharacter:"\\eae5"}),n.extensions=new n("extensions",{fontCharacter:"\\eae6"}),n.eyeClosed=new n("eye-closed",{fontCharacter:"\\eae7"}),n.fileBinary=new n("file-binary",{fontCharacter:"\\eae8"}),n.fileCode=new n("file-code",{fontCharacter:"\\eae9"}),n.fileMedia=new n("file-media",{fontCharacter:"\\eaea"}),n.filePdf=new n("file-pdf",{fontCharacter:"\\eaeb"}),n.fileSubmodule=new n("file-submodule",{fontCharacter:"\\eaec"}),n.fileSymlinkDirectory=new n("file-symlink-directory",{fontCharacter:"\\eaed"}),n.fileSymlinkFile=new n("file-symlink-file",{fontCharacter:"\\eaee"}),n.fileZip=new n("file-zip",{fontCharacter:"\\eaef"}),n.files=new n("files",{fontCharacter:"\\eaf0"}),n.filter=new n("filter",{fontCharacter:"\\eaf1"}),n.flame=new n("flame",{fontCharacter:"\\eaf2"}),n.foldDown=new n("fold-down",{fontCharacter:"\\eaf3"}),n.foldUp=new n("fold-up",{fontCharacter:"\\eaf4"}),n.fold=new n("fold",{fontCharacter:"\\eaf5"}),n.folderActive=new n("folder-active",{fontCharacter:"\\eaf6"}),n.folderOpened=new n("folder-opened",{fontCharacter:"\\eaf7"}),n.gear=new n("gear",{fontCharacter:"\\eaf8"}),n.gift=new n("gift",{fontCharacter:"\\eaf9"}),n.gistSecret=new n("gist-secret",{fontCharacter:"\\eafa"}),n.gist=new n("gist",{fontCharacter:"\\eafb"}),n.gitCommit=new n("git-commit",{fontCharacter:"\\eafc"}),n.gitCompare=new n("git-compare",{fontCharacter:"\\eafd"}),n.gitMerge=new n("git-merge",{fontCharacter:"\\eafe"}),n.githubAction=new n("github-action",{fontCharacter:"\\eaff"}),n.githubAlt=new n("github-alt",{fontCharacter:"\\eb00"}),n.globe=new n("globe",{fontCharacter:"\\eb01"}),n.grabber=new n("grabber",{fontCharacter:"\\eb02"}),n.graph=new n("graph",{fontCharacter:"\\eb03"}),n.gripper=new n("gripper",{fontCharacter:"\\eb04"}),n.heart=new n("heart",{fontCharacter:"\\eb05"}),n.home=new n("home",{fontCharacter:"\\eb06"}),n.horizontalRule=new n("horizontal-rule",{fontCharacter:"\\eb07"}),n.hubot=new n("hubot",{fontCharacter:"\\eb08"}),n.inbox=new n("inbox",{fontCharacter:"\\eb09"}),n.issueClosed=new n("issue-closed",{fontCharacter:"\\eb0a"}),n.issueReopened=new n("issue-reopened",{fontCharacter:"\\eb0b"}),n.issues=new n("issues",{fontCharacter:"\\eb0c"}),n.italic=new n("italic",{fontCharacter:"\\eb0d"}),n.jersey=new n("jersey",{fontCharacter:"\\eb0e"}),n.json=new n("json",{fontCharacter:"\\eb0f"}),n.kebabVertical=new n("kebab-vertical",{fontCharacter:"\\eb10"}),n.key=new n("key",{fontCharacter:"\\eb11"}),n.law=new n("law",{fontCharacter:"\\eb12"}),n.lightbulbAutofix=new n("lightbulb-autofix",{fontCharacter:"\\eb13"}),n.linkExternal=new n("link-external",{fontCharacter:"\\eb14"}),n.link=new n("link",{fontCharacter:"\\eb15"}),n.listOrdered=new n("list-ordered",{fontCharacter:"\\eb16"}),n.listUnordered=new n("list-unordered",{fontCharacter:"\\eb17"}),n.liveShare=new n("live-share",{fontCharacter:"\\eb18"}),n.loading=new n("loading",{fontCharacter:"\\eb19"}),n.location=new n("location",{fontCharacter:"\\eb1a"}),n.mailRead=new n("mail-read",{fontCharacter:"\\eb1b"}),n.mail=new n("mail",{fontCharacter:"\\eb1c"}),n.markdown=new n("markdown",{fontCharacter:"\\eb1d"}),n.megaphone=new n("megaphone",{fontCharacter:"\\eb1e"}),n.mention=new n("mention",{fontCharacter:"\\eb1f"}),n.milestone=new n("milestone",{fontCharacter:"\\eb20"}),n.mortarBoard=new n("mortar-board",{fontCharacter:"\\eb21"}),n.move=new n("move",{fontCharacter:"\\eb22"}),n.multipleWindows=new n("multiple-windows",{fontCharacter:"\\eb23"}),n.mute=new n("mute",{fontCharacter:"\\eb24"}),n.noNewline=new n("no-newline",{fontCharacter:"\\eb25"}),n.note=new n("note",{fontCharacter:"\\eb26"}),n.octoface=new n("octoface",{fontCharacter:"\\eb27"}),n.openPreview=new n("open-preview",{fontCharacter:"\\eb28"}),n.package_=new n("package",{fontCharacter:"\\eb29"}),n.paintcan=new n("paintcan",{fontCharacter:"\\eb2a"}),n.pin=new n("pin",{fontCharacter:"\\eb2b"}),n.play=new n("play",{fontCharacter:"\\eb2c"}),n.run=new n("run",{fontCharacter:"\\eb2c"}),n.plug=new n("plug",{fontCharacter:"\\eb2d"}),n.preserveCase=new n("preserve-case",{fontCharacter:"\\eb2e"}),n.preview=new n("preview",{fontCharacter:"\\eb2f"}),n.project=new n("project",{fontCharacter:"\\eb30"}),n.pulse=new n("pulse",{fontCharacter:"\\eb31"}),n.question=new n("question",{fontCharacter:"\\eb32"}),n.quote=new n("quote",{fontCharacter:"\\eb33"}),n.radioTower=new n("radio-tower",{fontCharacter:"\\eb34"}),n.reactions=new n("reactions",{fontCharacter:"\\eb35"}),n.references=new n("references",{fontCharacter:"\\eb36"}),n.refresh=new n("refresh",{fontCharacter:"\\eb37"}),n.regex=new n("regex",{fontCharacter:"\\eb38"}),n.remoteExplorer=new n("remote-explorer",{fontCharacter:"\\eb39"}),n.remote=new n("remote",{fontCharacter:"\\eb3a"}),n.remove=new n("remove",{fontCharacter:"\\eb3b"}),n.replaceAll=new n("replace-all",{fontCharacter:"\\eb3c"}),n.replace=new n("replace",{fontCharacter:"\\eb3d"}),n.repoClone=new n("repo-clone",{fontCharacter:"\\eb3e"}),n.repoForcePush=new n("repo-force-push",{fontCharacter:"\\eb3f"}),n.repoPull=new n("repo-pull",{fontCharacter:"\\eb40"}),n.repoPush=new n("repo-push",{fontCharacter:"\\eb41"}),n.report=new n("report",{fontCharacter:"\\eb42"}),n.requestChanges=new n("request-changes",{fontCharacter:"\\eb43"}),n.rocket=new n("rocket",{fontCharacter:"\\eb44"}),n.rootFolderOpened=new n("root-folder-opened",{fontCharacter:"\\eb45"}),n.rootFolder=new n("root-folder",{fontCharacter:"\\eb46"}),n.rss=new n("rss",{fontCharacter:"\\eb47"}),n.ruby=new n("ruby",{fontCharacter:"\\eb48"}),n.saveAll=new n("save-all",{fontCharacter:"\\eb49"}),n.saveAs=new n("save-as",{fontCharacter:"\\eb4a"}),n.save=new n("save",{fontCharacter:"\\eb4b"}),n.screenFull=new n("screen-full",{fontCharacter:"\\eb4c"}),n.screenNormal=new n("screen-normal",{fontCharacter:"\\eb4d"}),n.searchStop=new n("search-stop",{fontCharacter:"\\eb4e"}),n.server=new n("server",{fontCharacter:"\\eb50"}),n.settingsGear=new n("settings-gear",{fontCharacter:"\\eb51"}),n.settings=new n("settings",{fontCharacter:"\\eb52"}),n.shield=new n("shield",{fontCharacter:"\\eb53"}),n.smiley=new n("smiley",{fontCharacter:"\\eb54"}),n.sortPrecedence=new n("sort-precedence",{fontCharacter:"\\eb55"}),n.splitHorizontal=new n("split-horizontal",{fontCharacter:"\\eb56"}),n.splitVertical=new n("split-vertical",{fontCharacter:"\\eb57"}),n.squirrel=new n("squirrel",{fontCharacter:"\\eb58"}),n.starFull=new n("star-full",{fontCharacter:"\\eb59"}),n.starHalf=new n("star-half",{fontCharacter:"\\eb5a"}),n.symbolClass=new n("symbol-class",{fontCharacter:"\\eb5b"}),n.symbolColor=new n("symbol-color",{fontCharacter:"\\eb5c"}),n.symbolConstant=new n("symbol-constant",{fontCharacter:"\\eb5d"}),n.symbolEnumMember=new n("symbol-enum-member",{fontCharacter:"\\eb5e"}),n.symbolField=new n("symbol-field",{fontCharacter:"\\eb5f"}),n.symbolFile=new n("symbol-file",{fontCharacter:"\\eb60"}),n.symbolInterface=new n("symbol-interface",{fontCharacter:"\\eb61"}),n.symbolKeyword=new n("symbol-keyword",{fontCharacter:"\\eb62"}),n.symbolMisc=new n("symbol-misc",{fontCharacter:"\\eb63"}),n.symbolOperator=new n("symbol-operator",{fontCharacter:"\\eb64"}),n.symbolProperty=new n("symbol-property",{fontCharacter:"\\eb65"}),n.wrench=new n("wrench",{fontCharacter:"\\eb65"}),n.wrenchSubaction=new n("wrench-subaction",{fontCharacter:"\\eb65"}),n.symbolSnippet=new n("symbol-snippet",{fontCharacter:"\\eb66"}),n.tasklist=new n("tasklist",{fontCharacter:"\\eb67"}),n.telescope=new n("telescope",{fontCharacter:"\\eb68"}),n.textSize=new n("text-size",{fontCharacter:"\\eb69"}),n.threeBars=new n("three-bars",{fontCharacter:"\\eb6a"}),n.thumbsdown=new n("thumbsdown",{fontCharacter:"\\eb6b"}),n.thumbsup=new n("thumbsup",{fontCharacter:"\\eb6c"}),n.tools=new n("tools",{fontCharacter:"\\eb6d"}),n.triangleDown=new n("triangle-down",{fontCharacter:"\\eb6e"}),n.triangleLeft=new n("triangle-left",{fontCharacter:"\\eb6f"}),n.triangleRight=new n("triangle-right",{fontCharacter:"\\eb70"}),n.triangleUp=new n("triangle-up",{fontCharacter:"\\eb71"}),n.twitter=new n("twitter",{fontCharacter:"\\eb72"}),n.unfold=new n("unfold",{fontCharacter:"\\eb73"}),n.unlock=new n("unlock",{fontCharacter:"\\eb74"}),n.unmute=new n("unmute",{fontCharacter:"\\eb75"}),n.unverified=new n("unverified",{fontCharacter:"\\eb76"}),n.verified=new n("verified",{fontCharacter:"\\eb77"}),n.versions=new n("versions",{fontCharacter:"\\eb78"}),n.vmActive=new n("vm-active",{fontCharacter:"\\eb79"}),n.vmOutline=new n("vm-outline",{fontCharacter:"\\eb7a"}),n.vmRunning=new n("vm-running",{fontCharacter:"\\eb7b"}),n.watch=new n("watch",{fontCharacter:"\\eb7c"}),n.whitespace=new n("whitespace",{fontCharacter:"\\eb7d"}),n.wholeWord=new n("whole-word",{fontCharacter:"\\eb7e"}),n.window=new n("window",{fontCharacter:"\\eb7f"}),n.wordWrap=new n("word-wrap",{fontCharacter:"\\eb80"}),n.zoomIn=new n("zoom-in",{fontCharacter:"\\eb81"}),n.zoomOut=new n("zoom-out",{fontCharacter:"\\eb82"}),n.listFilter=new n("list-filter",{fontCharacter:"\\eb83"}),n.listFlat=new n("list-flat",{fontCharacter:"\\eb84"}),n.listSelection=new n("list-selection",{fontCharacter:"\\eb85"}),n.selection=new n("selection",{fontCharacter:"\\eb85"}),n.listTree=new n("list-tree",{fontCharacter:"\\eb86"}),n.debugBreakpointFunctionUnverified=new n("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),n.debugBreakpointFunction=new n("debug-breakpoint-function",{fontCharacter:"\\eb88"}),n.debugBreakpointFunctionDisabled=new n("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),n.debugStackframeActive=new n("debug-stackframe-active",{fontCharacter:"\\eb89"}),n.debugStackframeDot=new n("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),n.debugStackframe=new n("debug-stackframe",{fontCharacter:"\\eb8b"}),n.debugStackframeFocused=new n("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),n.debugBreakpointUnsupported=new n("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),n.symbolString=new n("symbol-string",{fontCharacter:"\\eb8d"}),n.debugReverseContinue=new n("debug-reverse-continue",{fontCharacter:"\\eb8e"}),n.debugStepBack=new n("debug-step-back",{fontCharacter:"\\eb8f"}),n.debugRestartFrame=new n("debug-restart-frame",{fontCharacter:"\\eb90"}),n.callIncoming=new n("call-incoming",{fontCharacter:"\\eb92"}),n.callOutgoing=new n("call-outgoing",{fontCharacter:"\\eb93"}),n.menu=new n("menu",{fontCharacter:"\\eb94"}),n.expandAll=new n("expand-all",{fontCharacter:"\\eb95"}),n.feedback=new n("feedback",{fontCharacter:"\\eb96"}),n.groupByRefType=new n("group-by-ref-type",{fontCharacter:"\\eb97"}),n.ungroupByRefType=new n("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),n.account=new n("account",{fontCharacter:"\\eb99"}),n.bellDot=new n("bell-dot",{fontCharacter:"\\eb9a"}),n.debugConsole=new n("debug-console",{fontCharacter:"\\eb9b"}),n.library=new n("library",{fontCharacter:"\\eb9c"}),n.output=new n("output",{fontCharacter:"\\eb9d"}),n.runAll=new n("run-all",{fontCharacter:"\\eb9e"}),n.syncIgnored=new n("sync-ignored",{fontCharacter:"\\eb9f"}),n.pinned=new n("pinned",{fontCharacter:"\\eba0"}),n.githubInverted=new n("github-inverted",{fontCharacter:"\\eba1"}),n.debugAlt=new n("debug-alt",{fontCharacter:"\\eb91"}),n.serverProcess=new n("server-process",{fontCharacter:"\\eba2"}),n.serverEnvironment=new n("server-environment",{fontCharacter:"\\eba3"}),n.pass=new n("pass",{fontCharacter:"\\eba4"}),n.stopCircle=new n("stop-circle",{fontCharacter:"\\eba5"}),n.playCircle=new n("play-circle",{fontCharacter:"\\eba6"}),n.record=new n("record",{fontCharacter:"\\eba7"}),n.debugAltSmall=new n("debug-alt-small",{fontCharacter:"\\eba8"}),n.vmConnect=new n("vm-connect",{fontCharacter:"\\eba9"}),n.cloud=new n("cloud",{fontCharacter:"\\ebaa"}),n.merge=new n("merge",{fontCharacter:"\\ebab"}),n.exportIcon=new n("export",{fontCharacter:"\\ebac"}),n.graphLeft=new n("graph-left",{fontCharacter:"\\ebad"}),n.magnet=new n("magnet",{fontCharacter:"\\ebae"}),n.notebook=new n("notebook",{fontCharacter:"\\ebaf"}),n.redo=new n("redo",{fontCharacter:"\\ebb0"}),n.checkAll=new n("check-all",{fontCharacter:"\\ebb1"}),n.pinnedDirty=new n("pinned-dirty",{fontCharacter:"\\ebb2"}),n.passFilled=new n("pass-filled",{fontCharacter:"\\ebb3"}),n.circleLargeFilled=new n("circle-large-filled",{fontCharacter:"\\ebb4"}),n.circleLargeOutline=new n("circle-large-outline",{fontCharacter:"\\ebb5"}),n.combine=new n("combine",{fontCharacter:"\\ebb6"}),n.gather=new n("gather",{fontCharacter:"\\ebb6"}),n.table=new n("table",{fontCharacter:"\\ebb7"}),n.variableGroup=new n("variable-group",{fontCharacter:"\\ebb8"}),n.typeHierarchy=new n("type-hierarchy",{fontCharacter:"\\ebb9"}),n.typeHierarchySub=new n("type-hierarchy-sub",{fontCharacter:"\\ebba"}),n.typeHierarchySuper=new n("type-hierarchy-super",{fontCharacter:"\\ebbb"}),n.gitPullRequestCreate=new n("git-pull-request-create",{fontCharacter:"\\ebbc"}),n.runAbove=new n("run-above",{fontCharacter:"\\ebbd"}),n.runBelow=new n("run-below",{fontCharacter:"\\ebbe"}),n.notebookTemplate=new n("notebook-template",{fontCharacter:"\\ebbf"}),n.debugRerun=new n("debug-rerun",{fontCharacter:"\\ebc0"}),n.workspaceTrusted=new n("workspace-trusted",{fontCharacter:"\\ebc1"}),n.workspaceUntrusted=new n("workspace-untrusted",{fontCharacter:"\\ebc2"}),n.workspaceUnspecified=new n("workspace-unspecified",{fontCharacter:"\\ebc3"}),n.terminalCmd=new n("terminal-cmd",{fontCharacter:"\\ebc4"}),n.terminalDebian=new n("terminal-debian",{fontCharacter:"\\ebc5"}),n.terminalLinux=new n("terminal-linux",{fontCharacter:"\\ebc6"}),n.terminalPowershell=new n("terminal-powershell",{fontCharacter:"\\ebc7"}),n.terminalTmux=new n("terminal-tmux",{fontCharacter:"\\ebc8"}),n.terminalUbuntu=new n("terminal-ubuntu",{fontCharacter:"\\ebc9"}),n.terminalBash=new n("terminal-bash",{fontCharacter:"\\ebca"}),n.arrowSwap=new n("arrow-swap",{fontCharacter:"\\ebcb"}),n.copy=new n("copy",{fontCharacter:"\\ebcc"}),n.personAdd=new n("person-add",{fontCharacter:"\\ebcd"}),n.filterFilled=new n("filter-filled",{fontCharacter:"\\ebce"}),n.wand=new n("wand",{fontCharacter:"\\ebcf"}),n.debugLineByLine=new n("debug-line-by-line",{fontCharacter:"\\ebd0"}),n.inspect=new n("inspect",{fontCharacter:"\\ebd1"}),n.dropDownButton=new n("drop-down-button",n.chevronDown.definition)}(R=e.Codicon||(e.Codicon={}))}),define(Z[48],ee([0,1,11,2]),function(G,e,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function L(g){const a=g;return a?[a.on,a.pause,a.resume,a.destroy].every(s=>typeof s=="function"):!1}e.isReadableStream=L;function k(g){const a=g;return a?L(a.stream)&&Array.isArray(a.buffer)&&typeof a.ended=="boolean":!1}e.isReadableBufferedStream=k;function A(g,a){return new R(g,a)}e.newWriteableStream=A;class R{constructor(a,s){this.reducer=a,this.options=s,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(a){var s;if(!this.state.destroyed){if(this.state.flowing)this.emitData(a);else if(this.buffer.data.push(a),typeof((s=this.options)===null||s===void 0?void 0:s.highWaterMark)=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(t=>this.pendingWritePromises.push(t))}}error(a){this.state.destroyed||(this.state.flowing?this.emitError(a):this.buffer.error.push(a))}end(a){this.state.destroyed||(typeof a!="undefined"&&this.write(a),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(a){this.listeners.data.slice(0).forEach(s=>s(a))}emitError(a){this.listeners.error.length===0?(0,y.onUnexpectedError)(a):this.listeners.error.slice(0).forEach(s=>s(a))}emitEnd(){this.listeners.end.slice(0).forEach(a=>a())}on(a,s){if(!this.state.destroyed)switch(a){case"data":this.listeners.data.push(s),this.resume();break;case"end":this.listeners.end.push(s),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(s),this.state.flowing&&this.flowErrors();break}}removeListener(a,s){if(this.state.destroyed)return;let t;switch(a){case"data":t=this.listeners.data;break;case"end":t=this.listeners.end;break;case"error":t=this.listeners.error;break}if(t){const r=t.indexOf(s);r>=0&&t.splice(r,1)}}flowData(){if(this.buffer.data.length>0){const a=this.reducer(this.buffer.data);this.emitData(a),this.buffer.data.length=0;const s=[...this.pendingWritePromises];this.pendingWritePromises.length=0,s.forEach(t=>t())}}flowErrors(){if(this.listeners.error.length>0){for(const a of this.buffer.error)this.emitError(a);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function p(g,a){const s=[];let t;for(;(t=g.read())!==null;)s.push(t);return a(s)}e.consumeReadable=p;function S(g,a,s){const t=[];let r;for(;(r=g.read())!==null&&t.length<s;)t.push(r);return r===null&&t.length>0?a(t):{read:()=>{if(t.length>0)return t.shift();if(typeof r!="undefined"){const i=r;return r=void 0,i}return g.read()}}}e.peekReadable=S;function n(g,a){return new Promise((s,t)=>{const r=[];f(g,{onData:i=>{a&&r.push(i)},onError:i=>{a?t(i):s(void 0)},onEnd:()=>{s(a?a(r):void 0)}})})}e.consumeStream=n;function f(g,a){g.on("error",s=>a.onError(s)),g.on("end",()=>a.onEnd()),g.on("data",s=>a.onData(s))}e.listenStream=f;function m(g,a){return new Promise((s,t)=>{const r=new P.DisposableStore,i=[],o=u=>{if(i.push(u),i.length>a)return r.dispose(),g.pause(),s({stream:g,buffer:i,ended:!1})},c=u=>t(u),l=()=>s({stream:g,buffer:i,ended:!0});r.add((0,P.toDisposable)(()=>g.removeListener("error",c))),g.on("error",c),r.add((0,P.toDisposable)(()=>g.removeListener("end",l))),g.on("end",l),r.add((0,P.toDisposable)(()=>g.removeListener("data",o))),g.on("data",o)})}e.peekStream=m;function C(g,a){const s=A(a);return s.end(g),s}e.toStream=C;function h(){const g=A(()=>{throw new Error("not supported")});return g.end(),g}e.emptyStream=h;function E(g){let a=!1;return{read:()=>a?null:(a=!0,g)}}e.toReadable=E;function D(g,a,s){const t=A(s);return f(g,{onData:r=>t.write(a.data(r)),onError:r=>t.error(a.error?a.error(r):r),onEnd:()=>t.end()}),t}e.transform=D;function b(g,a,s){let t=!1;return{read:()=>{const r=a.read();return t?r:(t=!0,r!==null?s([g,r]):g)}}}e.prefixedReadable=b;function I(g,a,s){let t=!1;const r=A(s);return f(a,{onData:i=>t?r.write(i):(t=!0,r.write(s([g,i]))),onError:i=>r.error(i),onEnd:()=>{t||(t=!0,r.write(g)),r.end()}}),r}e.prefixedStream=I}),define(Z[22],ee([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.decodeUTF8=e.encodeUTF8=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format=e.isFalsyOrWhitespace=void 0;function y(x){return!x||typeof x!="string"?!0:x.trim().length===0}e.isFalsyOrWhitespace=y;const P=/{(\d+)}/g;function L(x,...te){return te.length===0?x:x.replace(P,function(ae,oe){const he=parseInt(oe,10);return isNaN(he)||he<0||he>=te.length?ae:te[he]})}e.format=L;function k(x){return x.replace(/[<>&]/g,function(te){switch(te){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return te}})}e.escape=k;function A(x){return x.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=A;function R(x,te){let ae=0;const oe=te.charCodeAt(0);for(let he=x.length-1;he>=0;he--)x.charCodeAt(he)===oe&&ae++;return ae}e.count=R;function p(x,te,ae="\u2026"){return x.length<=te?x:`${x.substr(0,te)}${ae}`}e.truncate=p;function S(x,te=" "){const ae=n(x,te);return f(ae,te)}e.trim=S;function n(x,te){if(!x||!te)return x;const ae=te.length;if(ae===0||x.length===0)return x;let oe=0;for(;x.indexOf(te,oe)===oe;)oe=oe+ae;return x.substring(oe)}e.ltrim=n;function f(x,te){if(!x||!te)return x;const ae=te.length,oe=x.length;if(ae===0||oe===0)return x;let he=oe,ge=-1;for(;ge=x.lastIndexOf(te,he-1),!(ge===-1||ge+ae!==he);){if(ge===0)return"";he=ge}return x.substring(0,he)}e.rtrim=f;function m(x){return x.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=m;function C(x){return x.replace(/\*/g,"")}e.stripWildcards=C;function h(x,te,ae={}){if(!x)throw new Error("Cannot create regex from empty string");te||(x=A(x)),ae.wholeWord&&(/\B/.test(x.charAt(0))||(x="\\b"+x),/\B/.test(x.charAt(x.length-1))||(x=x+"\\b"));let oe="";return ae.global&&(oe+="g"),ae.matchCase||(oe+="i"),ae.multiline&&(oe+="m"),ae.unicode&&(oe+="u"),new RegExp(x,oe)}e.createRegExp=h;function E(x){return x.source==="^"||x.source==="^$"||x.source==="$"||x.source==="^\\s*$"?!1:!!(x.exec("")&&x.lastIndex===0)}e.regExpLeadsToEndlessLoop=E;function D(x){return!!x.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=D;function b(x){return(x.global?"g":"")+(x.ignoreCase?"i":"")+(x.multiline?"m":"")+(x.unicode?"u":"")}e.regExpFlags=b;function I(x){return x.split(/\r\n|\r|\n/)}e.splitLines=I;function g(x){for(let te=0,ae=x.length;te<ae;te++){const oe=x.charCodeAt(te);if(oe!==32&&oe!==9)return te}return-1}e.firstNonWhitespaceIndex=g;function a(x,te=0,ae=x.length){for(let oe=te;oe<ae;oe++){const he=x.charCodeAt(oe);if(he!==32&&he!==9)return x.substring(te,oe)}return x.substring(te,ae)}e.getLeadingWhitespace=a;function s(x,te=x.length-1){for(let ae=te;ae>=0;ae--){const oe=x.charCodeAt(ae);if(oe!==32&&oe!==9)return ae}return-1}e.lastNonWhitespaceIndex=s;function t(x,te){return x<te?-1:x>te?1:0}e.compare=t;function r(x,te,ae=0,oe=x.length,he=0,ge=te.length){for(;ae<oe&&he<ge;ae++,he++){let we=x.charCodeAt(ae),Ee=te.charCodeAt(he);if(we<Ee)return-1;if(we>Ee)return 1}const fe=oe-ae,ye=ge-he;return fe<ye?-1:fe>ye?1:0}e.compareSubstring=r;function i(x,te){return o(x,te,0,x.length,0,te.length)}e.compareIgnoreCase=i;function o(x,te,ae=0,oe=x.length,he=0,ge=te.length){for(;ae<oe&&he<ge;ae++,he++){let we=x.charCodeAt(ae),Ee=te.charCodeAt(he);if(we===Ee)continue;const ue=we-Ee;if(!(ue===32&&l(Ee))&&!(ue===-32&&l(we)))return c(we)&&c(Ee)?ue:r(x.toLowerCase(),te.toLowerCase(),ae,oe,he,ge)}const fe=oe-ae,ye=ge-he;return fe<ye?-1:fe>ye?1:0}e.compareSubstringIgnoreCase=o;function c(x){return x>=97&&x<=122}e.isLowerAsciiLetter=c;function l(x){return x>=65&&x<=90}e.isUpperAsciiLetter=l;function u(x){return c(x)||l(x)}function v(x,te){return x.length===te.length&&w(x,te)}e.equalsIgnoreCase=v;function w(x,te,ae=x.length){for(let oe=0;oe<ae;oe++){const he=x.charCodeAt(oe),ge=te.charCodeAt(oe);if(he!==ge){if(u(he)&&u(ge)){const fe=Math.abs(he-ge);if(fe!==0&&fe!==32)return!1}else if(String.fromCharCode(he).toLowerCase()!==String.fromCharCode(ge).toLowerCase())return!1}}return!0}function d(x,te){const ae=te.length;return te.length>x.length?!1:w(x,te,ae)}e.startsWithIgnoreCase=d;function T(x,te){let ae,oe=Math.min(x.length,te.length);for(ae=0;ae<oe;ae++)if(x.charCodeAt(ae)!==te.charCodeAt(ae))return ae;return oe}e.commonPrefixLength=T;function F(x,te){let ae,oe=Math.min(x.length,te.length);const he=x.length-1,ge=te.length-1;for(ae=0;ae<oe;ae++)if(x.charCodeAt(he-ae)!==te.charCodeAt(ge-ae))return ae;return oe}e.commonSuffixLength=F;function z(x){return 55296<=x&&x<=56319}e.isHighSurrogate=z;function B(x){return 56320<=x&&x<=57343}e.isLowSurrogate=B;function K(x,te){return(x-55296<<10)+(te-56320)+65536}e.computeCodePoint=K;function j(x,te,ae){const oe=x.charCodeAt(ae);if(z(oe)&&ae+1<te){const he=x.charCodeAt(ae+1);if(B(he))return K(oe,he)}return oe}e.getNextCodePoint=j;function H(x,te){const ae=x.charCodeAt(te-1);if(B(ae)&&te>1){const oe=x.charCodeAt(te-2);if(z(oe))return K(oe,ae)}return ae}function q(x,te){const ae=se.getInstance(),oe=te,he=x.length,ge=j(x,he,te);te+=ge>=65536?2:1;let fe=ae.getGraphemeBreakType(ge);for(;te<he;){const ye=j(x,he,te),we=ae.getGraphemeBreakType(ye);if(J(fe,we))break;te+=ye>=65536?2:1,fe=we}return te-oe}e.nextCharLength=q;function $(x,te){const ae=se.getInstance(),oe=te,he=H(x,te);te-=he>=65536?2:1;let ge=ae.getGraphemeBreakType(he);for(;te>0;){const fe=H(x,te),ye=ae.getGraphemeBreakType(fe);if(J(ye,ge))break;te-=fe>=65536?2:1,ge=ye}return oe-te}e.prevCharLength=$;function M(x,te){const ae=se.getInstance(),oe=x.length,he=te,ge=j(x,oe,te),fe=ae.getGraphemeBreakType(ge);te+=ge>=65536?2:1;let ye=fe;for(;te<oe;){const Ee=j(x,oe,te),ue=ae.getGraphemeBreakType(Ee);if(J(ye,ue))break;te+=Ee>=65536?2:1,ye=ue}const we=te;for(te=he,ye=fe;te>0;){const Ee=H(x,te),ue=ae.getGraphemeBreakType(Ee);if(J(ue,ye))break;te-=Ee>=65536?2:1,ye=ue}return[te,we]}function U(x,te){return te>0&&B(x.charCodeAt(te))?M(x,te-1):M(x,te)}e.getCharContainingOffset=U;function O(x){const te=x.length;let ae=0,oe=0;for(;oe<te;){const fe=j(x,te,oe);oe+=fe>=65536?2:1,fe<128?ae+=1:fe<2048?ae+=2:fe<65536?ae+=3:ae+=4}const he=new Uint8Array(ae);oe=0;let ge=0;for(;oe<te;){const fe=j(x,te,oe);oe+=fe>=65536?2:1,fe<128?he[ge++]=fe:fe<2048?(he[ge++]=192|(fe&1984)>>>6,he[ge++]=128|(fe&63)>>>0):fe<65536?(he[ge++]=224|(fe&61440)>>>12,he[ge++]=128|(fe&4032)>>>6,he[ge++]=128|(fe&63)>>>0):(he[ge++]=240|(fe&1835008)>>>18,he[ge++]=128|(fe&258048)>>>12,he[ge++]=128|(fe&4032)>>>6,he[ge++]=128|(fe&63)>>>0)}return he}e.encodeUTF8=O;function _(x){const te=x.byteLength,ae=[];let oe=0;for(;oe<te;){const he=x[oe];let ge;if(he>=240&&oe+3<te?ge=(x[oe++]&7)<<18>>>0|(x[oe++]&63)<<12>>>0|(x[oe++]&63)<<6>>>0|(x[oe++]&63)<<0>>>0:he>=224&&oe+2<te?ge=(x[oe++]&15)<<12>>>0|(x[oe++]&63)<<6>>>0|(x[oe++]&63)<<0>>>0:he>=192&&oe+1<te?ge=(x[oe++]&31)<<6>>>0|(x[oe++]&63)<<0>>>0:ge=x[oe++],ge>=0&&ge<=55295||ge>=57344&&ge<=65535)ae.push(String.fromCharCode(ge));else if(ge>=65536&&ge<=1114111){const fe=ge-65536,ye=55296+((fe&1047552)>>>10),we=56320+((fe&1023)>>>0);ae.push(String.fromCharCode(ye)),ae.push(String.fromCharCode(we))}else ae.push(String.fromCharCode(65533))}return ae.join("")}e.decodeUTF8=_;const N=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function W(x){return N.test(x)}e.containsRTL=W;const V=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function Q(x){return V.test(x)}e.containsEmoji=Q;const X=/^[\t\n\r\x20-\x7E]*$/;function ie(x){return X.test(x)}e.isBasicASCII=ie,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function ne(x){return e.UNUSUAL_LINE_TERMINATORS.test(x)}e.containsUnusualLineTerminators=ne;function ce(x){for(let te=0,ae=x.length;te<ae;te++)if(le(x.charCodeAt(te)))return!0;return!1}e.containsFullWidthCharacter=ce;function le(x){return x=+x,x>=11904&&x<=55215||x>=63744&&x<=64255||x>=65281&&x<=65374}e.isFullWidthCharacter=le;function ve(x){return x>=127462&&x<=127487||x===8986||x===8987||x===9200||x===9203||x>=9728&&x<=10175||x===11088||x===11093||x>=127744&&x<=128591||x>=128640&&x<=128764||x>=128992&&x<=129003||x>=129280&&x<=129535||x>=129648&&x<=129750}e.isEmojiImprecise=ve;function pe(x,te){if(x.length<te)return x;const ae=/\b/g;let oe=0;for(;ae.test(x)&&!(x.length-ae.lastIndex<te);)oe=ae.lastIndex,ae.lastIndex+=1;return x.substring(oe).replace(/^\s/,"")}e.lcut=pe;const Ce=/\x1B\x5B[12]?K/g,Ae=/\x1b\[\d+m/g,_e=/\x1b\[0?m/g;function Oe(x){return x&&(x=x.replace(Ce,""),x=x.replace(Ae,""),x=x.replace(_e,"")),x}e.removeAnsiEscapeCodes=Oe,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function ke(x){return!!(x&&x.length>0&&x.charCodeAt(0)===65279)}e.startsWithUTF8BOM=ke;function je(x){return ke(x)?x.substr(1):x}e.stripUTF8BOM=je;function Ie(x,te){if(!x||!te||x.length<te.length)return!1;const ae=te.length,oe=x.toLowerCase();let he=0,ge=-1;for(;he<ae;){const fe=oe.indexOf(te[he],ge+1);if(fe<0)return!1;ge=fe,he++}return!0}e.fuzzyContains=Ie;function Te(x,te=!1){return x?(te&&(x=x.replace(/\\./g,"")),x.toLowerCase()!==x):!1}e.containsUppercaseCharacter=Te;function Ke(x){return x.charAt(0).toUpperCase()+x.slice(1)}e.uppercaseFirstLetter=Ke;function Ye(x,te=1){if(te===0)return"";let ae=-1;do ae=x.indexOf(`
`,ae+1),te--;while(te>0&&ae>=0);return ae===-1?x:(x[ae-1]==="\r"&&ae--,x.substr(0,ae))}e.getNLines=Ye;function $e(x){const te=90-65+1;return x=x%(2*te),x<te?String.fromCharCode(97+x):String.fromCharCode(65+x-te)}e.singleLetterHash=$e;function qe(x){return se.getInstance().getGraphemeBreakType(x)}e.getGraphemeBreakType=qe;function J(x,te){return x===0?te!==5&&te!==7:x===2&&te===3?!1:x===4||x===2||x===3||te===4||te===2||te===3?!0:!(x===8&&(te===8||te===9||te===11||te===12)||(x===11||x===9)&&(te===9||te===10)||(x===12||x===10)&&te===10||te===5||te===13||te===7||x===1||x===13&&te===14||x===6&&te===6)}e.breakBetweenGraphemeBreakType=J;var re;(function(x){x[x.Other=0]="Other",x[x.Prepend=1]="Prepend",x[x.CR=2]="CR",x[x.LF=3]="LF",x[x.Control=4]="Control",x[x.Extend=5]="Extend",x[x.Regional_Indicator=6]="Regional_Indicator",x[x.SpacingMark=7]="SpacingMark",x[x.L=8]="L",x[x.V=9]="V",x[x.T=10]="T",x[x.LV=11]="LV",x[x.LVT=12]="LVT",x[x.ZWJ=13]="ZWJ",x[x.Extended_Pictographic=14]="Extended_Pictographic"})(re=e.GraphemeBreakType||(e.GraphemeBreakType={}));class se{constructor(){this._data=me()}static getInstance(){return se._INSTANCE||(se._INSTANCE=new se),se._INSTANCE}getGraphemeBreakType(te){if(te<32)return te===10?3:te===13?2:4;if(te<127)return 0;const ae=this._data,oe=ae.length/3;let he=1;for(;he<=oe;)if(te<ae[3*he])he=2*he;else if(te>ae[3*he+1])he=2*he+1;else return ae[3*he+2];return 0}}se._INSTANCE=null;function me(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function Se(x,te){if(x===0)return 0;const ae=Pe(x,te);if(ae!==void 0)return ae;const oe=H(te,x);return x-=be(oe),x}e.getLeftDeleteOffset=Se;function Pe(x,te){let ae=H(te,x);for(x-=be(ae);Ue(ae)||ae===65039||ae===8419;){if(x===0)return;ae=H(te,x),x-=be(ae)}if(!!ve(ae)){if(x>=0){const oe=H(te,x);oe===8205&&(x-=be(oe))}return x}}function be(x){return x>=65536?2:1}function Ue(x){return 127995<=x&&x<=127999}var De;(function(x){x[x.zwj=8205]="zwj",x[x.emojiVariantSelector=65039]="emojiVariantSelector",x[x.enclosingKeyCap=8419]="enclosingKeyCap"})(De||(De={}))}),define(Z[25],ee([0,1,22,48]),function(G,e,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const L=typeof Buffer!="undefined",k=typeof TextEncoder!="undefined",A=typeof TextDecoder!="undefined";let R,p;class S{constructor(u){this.buffer=u,this.byteLength=this.buffer.byteLength}static alloc(u){return L?new S(Buffer.allocUnsafe(u)):new S(new Uint8Array(u))}static wrap(u){return L&&!Buffer.isBuffer(u)&&(u=Buffer.from(u.buffer,u.byteOffset,u.byteLength)),new S(u)}static fromString(u,v){return!((v==null?void 0:v.dontUseNodeBuffer)||!1)&&L?new S(Buffer.from(u)):k?(R||(R=new TextEncoder),new S(R.encode(u))):new S(y.encodeUTF8(u))}static concat(u,v){if(typeof v=="undefined"){v=0;for(let T=0,F=u.length;T<F;T++)v+=u[T].byteLength}const w=S.alloc(v);let d=0;for(let T=0,F=u.length;T<F;T++){const z=u[T];w.set(z,d),d+=z.byteLength}return w}toString(){return L?this.buffer.toString():A?(p||(p=new TextDecoder),p.decode(this.buffer)):y.decodeUTF8(this.buffer)}slice(u,v){return new S(this.buffer.subarray(u,v))}set(u,v){u instanceof S?this.buffer.set(u.buffer,v):this.buffer.set(u,v)}readUInt32BE(u){return m(this.buffer,u)}writeUInt32BE(u,v){C(this.buffer,u,v)}readUInt32LE(u){return h(this.buffer,u)}writeUInt32LE(u,v){E(this.buffer,u,v)}readUInt8(u){return D(this.buffer,u)}writeUInt8(u,v){b(this.buffer,u,v)}}e.VSBuffer=S;function n(l,u){return l[u+0]<<0>>>0|l[u+1]<<8>>>0}e.readUInt16LE=n;function f(l,u,v){l[v+0]=u&255,u=u>>>8,l[v+1]=u&255}e.writeUInt16LE=f;function m(l,u){return l[u]*2**24+l[u+1]*2**16+l[u+2]*2**8+l[u+3]}e.readUInt32BE=m;function C(l,u,v){l[v+3]=u,u=u>>>8,l[v+2]=u,u=u>>>8,l[v+1]=u,u=u>>>8,l[v]=u}e.writeUInt32BE=C;function h(l,u){return l[u+0]<<0>>>0|l[u+1]<<8>>>0|l[u+2]<<16>>>0|l[u+3]<<24>>>0}e.readUInt32LE=h;function E(l,u,v){l[v+0]=u&255,u=u>>>8,l[v+1]=u&255,u=u>>>8,l[v+2]=u&255,u=u>>>8,l[v+3]=u&255}e.writeUInt32LE=E;function D(l,u){return l[u]}e.readUInt8=D;function b(l,u,v){l[v]=u}e.writeUInt8=b;function I(l){return P.consumeReadable(l,u=>S.concat(u))}e.readableToBuffer=I;function g(l){return P.toReadable(l)}e.bufferToReadable=g;function a(l){return P.consumeStream(l,u=>S.concat(u))}e.streamToBuffer=a;async function s(l){return l.ended?S.concat(l.buffer):S.concat([...l.buffer,await a(l.stream)])}e.bufferedStreamToBuffer=s;function t(l){return P.toStream(l,u=>S.concat(u))}e.bufferToStream=t;function r(l){return P.transform(l,{data:u=>typeof u=="string"?S.fromString(u):S.wrap(u)},u=>S.concat(u))}e.streamToBufferReadableStream=r;function i(l){return P.newWriteableStream(u=>S.concat(u),l)}e.newWriteableBufferStream=i;function o(l,u){return P.prefixedReadable(l,u,v=>S.concat(v))}e.prefixedBufferReadable=o;function c(l,u){return P.prefixedStream(l,u,v=>S.concat(v))}e.prefixedBufferStream=c}),define(Z[15],ee([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function y(u){return Array.isArray(u)}e.isArray=y;function P(u){return typeof u=="string"}e.isString=P;function L(u){return Array.isArray(u)&&u.every(v=>P(v))}e.isStringArray=L;function k(u){return typeof u=="object"&&u!==null&&!Array.isArray(u)&&!(u instanceof RegExp)&&!(u instanceof Date)}e.isObject=k;function A(u){return typeof u=="number"&&!isNaN(u)}e.isNumber=A;function R(u){return!!u&&typeof u[Symbol.iterator]=="function"}e.isIterable=R;function p(u){return u===!0||u===!1}e.isBoolean=p;function S(u){return typeof u=="undefined"}e.isUndefined=S;function n(u){return!f(u)}e.isDefined=n;function f(u){return S(u)||u===null}e.isUndefinedOrNull=f;function m(u,v){if(!u)throw new Error(v?`Unexpected type, expected '${v}'`:"Unexpected type")}e.assertType=m;function C(u){if(f(u))throw new Error("Assertion Failed: argument is undefined or null");return u}e.assertIsDefined=C;function h(...u){const v=[];for(let w=0;w<u.length;w++){const d=u[w];if(f(d))throw new Error(`Assertion Failed: argument at index ${w} is undefined or null`);v.push(d)}return v}e.assertAllDefined=h;const E=Object.prototype.hasOwnProperty;function D(u){if(!k(u))return!1;for(let v in u)if(E.call(u,v))return!1;return!0}e.isEmptyObject=D;function b(u){return typeof u=="function"}e.isFunction=b;function I(...u){return u.length>0&&u.every(b)}e.areFunctions=I;function g(u,v){const w=Math.min(u.length,v.length);for(let d=0;d<w;d++)a(u[d],v[d])}e.validateConstraints=g;function a(u,v){if(P(v)){if(typeof u!==v)throw new Error(`argument does not match constraint: typeof ${v}`)}else if(b(v)){try{if(u instanceof v)return}catch(w){}if(!f(u)&&u.constructor===v||v.length===1&&v.call(void 0,u)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=a;function s(u){let v=[],w=Object.getPrototypeOf(u);for(;Object.prototype!==w;)v=v.concat(Object.getOwnPropertyNames(w)),w=Object.getPrototypeOf(w);return v}e.getAllPropertyNames=s;function t(u){const v=[];for(const w of s(u))typeof u[w]=="function"&&v.push(w);return v}e.getAllMethodNames=t;function r(u,v){const w=T=>function(){const F=Array.prototype.slice.call(arguments,0);return v(T,F)};let d={};for(const T of u)d[T]=w(T);return d}e.createProxyObject=r;function i(u){return u===null?void 0:u}e.withNullAsUndefined=i;function o(u){return typeof u=="undefined"?null:u}e.withUndefinedAsNull=o;function c(u){return class{constructor(){return new Proxy({},{get(v,w){if(v[w])return v[w];throw new Error(`Not Implemented: ${u}->${String(w)}`)}})}}}e.NotImplementedProxy=c;function l(u){throw new Error("Unreachable")}e.assertNever=l}),define(Z[41],ee([0,1,6,22,7,15]),function(G,e,y,P,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function A(i){return i===47||i===92}e.isPathSeparator=A;function R(i){return i.replace(/[\\/]/g,L.posix.sep)}e.toSlashes=R;function p(i){return i.indexOf("/")===-1&&(i=R(i)),/^[a-zA-Z]:(\/|$)/.test(i)&&(i="/"+i),i}e.toPosixPath=p;function S(i,o=L.posix.sep){if(!i)return"";const c=i.length,l=i.charCodeAt(0);if(A(l)){if(A(i.charCodeAt(1))&&!A(i.charCodeAt(2))){let v=3;const w=v;for(;v<c&&!A(i.charCodeAt(v));v++);if(w!==v&&!A(i.charCodeAt(v+1))){for(v+=1;v<c;v++)if(A(i.charCodeAt(v)))return i.slice(0,v+1).replace(/[\\/]/g,o)}}return o}else if(b(l)&&i.charCodeAt(1)===58)return A(i.charCodeAt(2))?i.slice(0,2)+o:i.slice(0,2);let u=i.indexOf("://");if(u!==-1){for(u+=3;u<c;u++)if(A(i.charCodeAt(u)))return i.slice(0,u+1)}return""}e.getRoot=S;function n(i){if(!y.isWindows||!i||i.length<5)return!1;let o=i.charCodeAt(0);if(o!==92||(o=i.charCodeAt(1),o!==92))return!1;let c=2;const l=c;for(;c<i.length&&(o=i.charCodeAt(c),o!==92);c++);return!(l===c||(o=i.charCodeAt(c+1),isNaN(o)||o===92))}e.isUNC=n;const f=/[\\/:\*\?"<>\|]/g,m=/[\\/]/g,C=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function h(i,o=y.isWindows){const c=o?f:m;return!(!i||i.length===0||/^\s+$/.test(i)||(c.lastIndex=0,c.test(i))||o&&C.test(i)||i==="."||i===".."||o&&i[i.length-1]==="."||o&&i.length!==i.trim().length||i.length>255)}e.isValidBasename=h;function E(i,o,c){const l=i===o;return!c||l?l:!i||!o?!1:(0,P.equalsIgnoreCase)(i,o)}e.isEqual=E;function D(i,o,c,l=L.sep){if(i===o)return!0;if(!i||!o||o.length>i.length)return!1;if(c){if(!(0,P.startsWithIgnoreCase)(i,o))return!1;if(o.length===i.length)return!0;let v=o.length;return o.charAt(o.length-1)===l&&v--,i.charAt(v)===l}return o.charAt(o.length-1)!==l&&(o+=l),i.indexOf(o)===0}e.isEqualOrParent=D;function b(i){return i>=65&&i<=90||i>=97&&i<=122}e.isWindowsDriveLetter=b;function I(i,o){return y.isWindows&&i.endsWith(":")&&(i+=L.sep),(0,L.isAbsolute)(i)||(i=(0,L.join)(o,i)),i=(0,L.normalize)(i),y.isWindows?(i=(0,P.rtrim)(i,L.sep),i.endsWith(":")&&(i+=L.sep)):(i=(0,P.rtrim)(i,L.sep),i||(i=L.sep)),i}e.sanitizeFilePath=I;function g(i){const o=(0,L.normalize)(i);return y.isWindows?i.length>3?!1:a(o)&&(i.length===2||o.charCodeAt(2)===92):o===L.posix.sep}e.isRootOrDriveLetter=g;function a(i){return y.isWindows?b(i.charCodeAt(0))&&i.charCodeAt(1)===58:!1}e.hasDriveLetter=a;function s(i){return a(i)?i[0]:void 0}e.getDriveLetter=s;function t(i,o,c){return o.length>i.length?-1:i===o?0:(c&&(i=i.toLowerCase(),o=o.toLowerCase()),i.indexOf(o))}e.indexOfPath=t;function r(i){const o=i.split(":");let c,l,u;if(o.forEach(v=>{const w=Number(v);(0,k.isNumber)(w)?l===void 0?l=w:u===void 0&&(u=w):c=c?[c,v].join(":"):v}),!c)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:c,line:l!==void 0?l:void 0,column:u!==void 0?u:l!==void 0?1:void 0}}e.parseLineAndColumnAware=r}),define(Z[26],ee([0,1,15]),function(G,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function P(E){if(!E||typeof E!="object"||E instanceof RegExp)return E;const D=Array.isArray(E)?[]:{};return Object.keys(E).forEach(b=>{E[b]&&typeof E[b]=="object"?D[b]=P(E[b]):D[b]=E[b]}),D}e.deepClone=P;function L(E){if(!E||typeof E!="object")return E;const D=[E];for(;D.length>0;){const b=D.shift();Object.freeze(b);for(const I in b)if(k.call(b,I)){const g=b[I];typeof g=="object"&&!Object.isFrozen(g)&&D.push(g)}}return E}e.deepFreeze=L;const k=Object.prototype.hasOwnProperty;function A(E,D){return R(E,D,new Set)}e.cloneAndChange=A;function R(E,D,b){if((0,y.isUndefinedOrNull)(E))return E;const I=D(E);if(typeof I!="undefined")return I;if((0,y.isArray)(E)){const g=[];for(const a of E)g.push(R(a,D,b));return g}if((0,y.isObject)(E)){if(b.has(E))throw new Error("Cannot clone recursive data-structure");b.add(E);const g={};for(let a in E)k.call(E,a)&&(g[a]=R(E[a],D,b));return b.delete(E),g}return E}function p(E,D,b=!0){return(0,y.isObject)(E)?((0,y.isObject)(D)&&Object.keys(D).forEach(I=>{I in E?b&&((0,y.isObject)(E[I])&&(0,y.isObject)(D[I])?p(E[I],D[I],b):E[I]=D[I]):E[I]=D[I]}),E):D}e.mixin=p;function S(E,D){if(E===D)return!0;if(E==null||D===null||D===void 0||typeof E!=typeof D||typeof E!="object"||Array.isArray(E)!==Array.isArray(D))return!1;let b,I;if(Array.isArray(E)){if(E.length!==D.length)return!1;for(b=0;b<E.length;b++)if(!S(E[b],D[b]))return!1}else{const g=[];for(I in E)g.push(I);g.sort();const a=[];for(I in D)a.push(I);if(a.sort(),!S(g,a))return!1;for(b=0;b<g.length;b++)if(!S(E[g[b]],D[g[b]]))return!1}return!0}e.equals=S;function n(E){const D=new Set;return JSON.stringify(E,(b,I)=>{if((0,y.isObject)(I)||Array.isArray(I)){if(D.has(I))return"[Circular]";D.add(I)}return I})}e.safeStringify=n;function f(E,D,b){const I=D(E);return typeof I=="undefined"?b:I}e.getOrDefault=f;function m(E,D){const b=Object.create(null);return!E||!D||Object.keys(D).forEach(g=>{const a=E[g],s=D[g];S(a,s)||(b[g]=s)}),b}e.distinct=m;function C(E,D){const b=D.toLowerCase(),I=Object.keys(E).find(g=>g.toLowerCase()===b);return I?E[I]:E[D]}e.getCaseInsensitive=C;function h(E,D){const b=Object.create(null);for(const I of Object.keys(E))D(I,E[I])&&(b[I]=E[I]);return b}e.filter=h}),define(Z[5],ee([0,1,6,7]),function(G,e,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const L=/^\w[\w\d+.-]*$/,k=/^\//,A=/^\/\//;function R(i,o){if(!i.scheme&&o)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!L.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!k.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(A.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function p(i,o){return!i&&!o?"file":i}function S(i,o){switch(i){case"https":case"http":case"file":o?o[0]!==f&&(o=f+o):o=f;break}return o}const n="",f="/",m=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class C{constructor(o,c,l,u,v,w=!1){typeof o=="object"?(this.scheme=o.scheme||n,this.authority=o.authority||n,this.path=o.path||n,this.query=o.query||n,this.fragment=o.fragment||n):(this.scheme=p(o,w),this.authority=c||n,this.path=S(this.scheme,l||n),this.query=u||n,this.fragment=v||n,R(this,w))}static isUri(o){return o instanceof C?!0:o?typeof o.authority=="string"&&typeof o.fragment=="string"&&typeof o.path=="string"&&typeof o.query=="string"&&typeof o.scheme=="string"&&typeof o.fsPath=="string"&&typeof o.with=="function"&&typeof o.toString=="function":!1}get fsPath(){return g(this,!1)}with(o){if(!o)return this;let{scheme:c,authority:l,path:u,query:v,fragment:w}=o;return c===void 0?c=this.scheme:c===null&&(c=n),l===void 0?l=this.authority:l===null&&(l=n),u===void 0?u=this.path:u===null&&(u=n),v===void 0?v=this.query:v===null&&(v=n),w===void 0?w=this.fragment:w===null&&(w=n),c===this.scheme&&l===this.authority&&u===this.path&&v===this.query&&w===this.fragment?this:new E(c,l,u,v,w)}static parse(o,c=!1){const l=m.exec(o);return l?new E(l[2]||n,r(l[4]||n),r(l[5]||n),r(l[7]||n),r(l[9]||n),c):new E(n,n,n,n,n)}static file(o){let c=n;if(y.isWindows&&(o=o.replace(/\\/g,f)),o[0]===f&&o[1]===f){const l=o.indexOf(f,2);l===-1?(c=o.substring(2),o=f):(c=o.substring(2,l),o=o.substring(l)||f)}return new E("file",c,o,n,n)}static from(o){const c=new E(o.scheme,o.authority,o.path,o.query,o.fragment);return R(c,!0),c}static joinPath(o,...c){if(!o.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let l;return y.isWindows&&o.scheme==="file"?l=C.file(P.win32.join(g(o,!0),...c)).path:l=P.posix.join(o.path,...c),o.with({path:l})}toString(o=!1){return a(this,o)}toJSON(){return this}static revive(o){if(o){if(o instanceof C)return o;{const c=new E(o);return c._formatted=o.external,c._fsPath=o._sep===h?o.fsPath:null,c}}else return o}}e.URI=C;const h=y.isWindows?1:void 0;class E extends C{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=g(this,!1)),this._fsPath}toString(o=!1){return o?a(this,!0):(this._formatted||(this._formatted=a(this,!1)),this._formatted)}toJSON(){const o={$mid:1};return this._fsPath&&(o.fsPath=this._fsPath,o._sep=h),this._formatted&&(o.external=this._formatted),this.path&&(o.path=this.path),this.scheme&&(o.scheme=this.scheme),this.authority&&(o.authority=this.authority),this.query&&(o.query=this.query),this.fragment&&(o.fragment=this.fragment),o}}const D={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function b(i,o){let c,l=-1;for(let u=0;u<i.length;u++){const v=i.charCodeAt(u);if(v>=97&&v<=122||v>=65&&v<=90||v>=48&&v<=57||v===45||v===46||v===95||v===126||o&&v===47)l!==-1&&(c+=encodeURIComponent(i.substring(l,u)),l=-1),c!==void 0&&(c+=i.charAt(u));else{c===void 0&&(c=i.substr(0,u));const w=D[v];w!==void 0?(l!==-1&&(c+=encodeURIComponent(i.substring(l,u)),l=-1),c+=w):l===-1&&(l=u)}}return l!==-1&&(c+=encodeURIComponent(i.substring(l))),c!==void 0?c:i}function I(i){let o;for(let c=0;c<i.length;c++){const l=i.charCodeAt(c);l===35||l===63?(o===void 0&&(o=i.substr(0,c)),o+=D[l]):o!==void 0&&(o+=i[c])}return o!==void 0?o:i}function g(i,o){let c;return i.authority&&i.path.length>1&&i.scheme==="file"?c=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?o?c=i.path.substr(1):c=i.path[1].toLowerCase()+i.path.substr(2):c=i.path,y.isWindows&&(c=c.replace(/\//g,"\\")),c}e.uriToFsPath=g;function a(i,o){const c=o?I:b;let l="",{scheme:u,authority:v,path:w,query:d,fragment:T}=i;if(u&&(l+=u,l+=":"),(v||u==="file")&&(l+=f,l+=f),v){let F=v.indexOf("@");if(F!==-1){const z=v.substr(0,F);v=v.substr(F+1),F=z.indexOf(":"),F===-1?l+=c(z,!1):(l+=c(z.substr(0,F),!1),l+=":",l+=c(z.substr(F+1),!1)),l+="@"}v=v.toLowerCase(),F=v.indexOf(":"),F===-1?l+=c(v,!1):(l+=c(v.substr(0,F),!1),l+=v.substr(F))}if(w){if(w.length>=3&&w.charCodeAt(0)===47&&w.charCodeAt(2)===58){const F=w.charCodeAt(1);F>=65&&F<=90&&(w=`/${String.fromCharCode(F+32)}:${w.substr(3)}`)}else if(w.length>=2&&w.charCodeAt(1)===58){const F=w.charCodeAt(0);F>=65&&F<=90&&(w=`${String.fromCharCode(F+32)}:${w.substr(2)}`)}l+=c(w,!0)}return d&&(l+="?",l+=c(d,!1)),T&&(l+="#",l+=o?T:b(T,!1)),l}function s(i){try{return decodeURIComponent(i)}catch(o){return i.length>3?i.substr(0,3)+s(i.substr(3)):i}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(i){return i.match(t)?i.replace(t,o=>s(o)):i}}),define(Z[88],ee([0,1,5]),function(G,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function P(S){const n=S;return n&&typeof n.type=="string"&&typeof n.severity=="string"}e.isRemoteConsoleLog=P;function L(S){const n=[];let f;try{const m=JSON.parse(S.arguments),C=m[m.length-1];C&&C.__$stack&&(m.pop(),f=C.__$stack),n.push(...m)}catch(m){n.push("Unable to log remote console arguments",S.arguments)}return{args:n,stack:f}}e.parse=L;function k(S){if(typeof S!="string")return k(L(S).stack);const n=S;if(n){const f=A(n),m=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(f||"");if(m&&m.length===4)return{uri:y.URI.file(m[1]),line:Number(m[2]),column:Number(m[3])}}}e.getFirstFrame=k;function A(S){if(!S)return S;const n=S.indexOf(`
`);return n===-1?S:S.substring(0,n)}function R(S,n){const{args:f,stack:m}=L(S),C=typeof f[0]=="string"&&f.length===1;let h=A(m);h&&(h=`(${h.trim()})`);let E=[];if(typeof f[0]=="string"?h&&C?E=[`%c[${n}] %c${f[0]} %c${h}`,p("blue"),p(""),p("grey")]:E=[`%c[${n}] %c${f[0]}`,p("blue"),p(""),...f.slice(1)]:E=[`%c[${n}]%`,p("blue"),...f],h&&!C&&E.push(h),typeof console[S.severity]!="function")throw new Error("Unknown console method");console[S.severity].apply(console,E)}e.log=R;function p(S){return`color: ${S}`}});var ft=this&&this.__classPrivateFieldSet||function(G,e,y,P,L){if(P==="m")throw new TypeError("Private method is not writable");if(P==="a"&&!L)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?G!==e||!L:!e.has(G))throw new TypeError("Cannot write private member to an object whose class did not declare it");return P==="a"?L.call(G,y):L?L.value=y:e.set(G,y),y},ze=this&&this.__classPrivateFieldGet||function(G,e,y,P){if(y==="a"&&!P)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?G!==e||!P:!e.has(G))throw new TypeError("Cannot read private member from an object whose class did not declare it");return y==="m"?P:y==="a"?P.call(G):P?P.value:e.get(G)};define(Z[38],ee([0,1,5,22]),function(G,e,y,P){"use strict";var L,k,A;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function R(t,r,i){let o=t.get(r);return o===void 0&&(o=i,t.set(r,o)),o}e.getOrSet=R;function p(t){const r=[];return t.forEach((i,o)=>{r.push(`${o} => ${i}`)}),`Map(${t.size}) {${r.join(", ")}}`}e.mapToString=p;function S(t){const r=[];return t.forEach(i=>{r.push(i)}),`Set(${t.size}) {${r.join(", ")}}`}e.setToString=S;class n{constructor(){this._value="",this._pos=0}reset(r){return this._value=r,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(r){const i=r.charCodeAt(0),o=this._value.charCodeAt(this._pos);return i-o}value(){return this._value[this._pos]}}e.StringIterator=n;class f{constructor(r=!0){this._caseSensitive=r}reset(r){return this._value=r,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(r)this._from++;else break;else r=!1;return this}cmp(r){return this._caseSensitive?(0,P.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,P.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=f;class m{constructor(r=!0,i=!0){this._splitOnBackslash=r,this._caseSensitive=i}reset(r){return this._value=r.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++){const i=this._value.charCodeAt(this._to);if(i===47||this._splitOnBackslash&&i===92)if(r)this._from++;else break;else r=!1}return this}cmp(r){return this._caseSensitive?(0,P.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,P.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=m;var C;(function(t){t[t.Scheme=1]="Scheme",t[t.Authority=2]="Authority",t[t.Path=3]="Path",t[t.Query=4]="Query",t[t.Fragment=5]="Fragment"})(C||(C={}));class h{constructor(r){this._ignorePathCasing=r,this._states=[],this._stateIdx=0}reset(r){return this._value=r,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new m(!1,!this._ignorePathCasing(r)),this._pathIterator.reset(r.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(r){if(this._states[this._stateIdx]===1)return(0,P.compareIgnoreCase)(r,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,P.compareIgnoreCase)(r,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(r);if(this._states[this._stateIdx]===4)return(0,P.compare)(r,this._value.query);if(this._states[this._stateIdx]===5)return(0,P.compare)(r,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=h;class E{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class D{constructor(r){this._iter=r}static forUris(r=()=>!1){return new D(new h(r))}static forPaths(){return new D(new m)}static forStrings(){return new D(new n)}static forConfigKeys(){return new D(new f)}clear(){this._root=void 0}set(r,i){const o=this._iter.reset(r);let c;for(this._root||(this._root=new E,this._root.segment=o.value()),c=this._root;;){const u=o.cmp(c.segment);if(u>0)c.left||(c.left=new E,c.left.segment=o.value()),c=c.left;else if(u<0)c.right||(c.right=new E,c.right.segment=o.value()),c=c.right;else if(o.hasNext())o.next(),c.mid||(c.mid=new E,c.mid.segment=o.value()),c=c.mid;else break}const l=c.value;return c.value=i,c.key=r,l}get(r){var i;return(i=this._getNode(r))===null||i===void 0?void 0:i.value}_getNode(r){const i=this._iter.reset(r);let o=this._root;for(;o;){const c=i.cmp(o.segment);if(c>0)o=o.left;else if(c<0)o=o.right;else if(i.hasNext())i.next(),o=o.mid;else break}return o}has(r){const i=this._getNode(r);return!((i==null?void 0:i.value)===void 0&&(i==null?void 0:i.mid)===void 0)}delete(r){return this._delete(r,!1)}deleteSuperstr(r){return this._delete(r,!0)}_delete(r,i){const o=this._iter.reset(r),c=[];let l=this._root;for(;l;){const u=o.cmp(l.segment);if(u>0)c.push([1,l]),l=l.left;else if(u<0)c.push([-1,l]),l=l.right;else if(o.hasNext())o.next(),c.push([0,l]),l=l.mid;else{for(i?(l.left=void 0,l.mid=void 0,l.right=void 0):l.value=void 0;c.length>0&&l.isEmpty();){let[v,w]=c.pop();switch(v){case 1:w.left=void 0;break;case 0:w.mid=void 0;break;case-1:w.right=void 0;break}l=w}break}}}findSubstr(r){const i=this._iter.reset(r);let o=this._root,c;for(;o;){const l=i.cmp(o.segment);if(l>0)o=o.left;else if(l<0)o=o.right;else if(i.hasNext())i.next(),c=o.value||c,o=o.mid;else break}return o&&o.value||c}findSuperstr(r){const i=this._iter.reset(r);let o=this._root;for(;o;){const c=i.cmp(o.segment);if(c>0)o=o.left;else if(c<0)o=o.right;else if(i.hasNext())i.next(),o=o.mid;else return o.mid?this._entries(o.mid):void 0}}forEach(r){for(const[i,o]of this)r(o,i)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(r){r&&(yield*this._entries(r.left),r.value&&(yield[r.key,r.value]),yield*this._entries(r.mid),yield*this._entries(r.right))}}e.TernarySearchTree=D;class b{constructor(r,i){this[L]="ResourceMap",r instanceof b?(this.map=new Map(r.map),this.toKey=i!=null?i:b.defaultToKey):(this.map=new Map,this.toKey=r!=null?r:b.defaultToKey)}set(r,i){return this.map.set(this.toKey(r),i),this}get(r){return this.map.get(this.toKey(r))}has(r){return this.map.has(this.toKey(r))}get size(){return this.map.size}clear(){this.map.clear()}delete(r){return this.map.delete(this.toKey(r))}forEach(r,i){typeof i!="undefined"&&(r=r.bind(i));for(let[o,c]of this.map)r(c,y.URI.parse(o),this)}values(){return this.map.values()}*keys(){for(let r of this.map.keys())yield y.URI.parse(r)}*entries(){for(let r of this.map.entries())yield[y.URI.parse(r[0]),r[1]]}*[(L=Symbol.toStringTag,Symbol.iterator)](){for(let r of this.map)yield[y.URI.parse(r[0]),r[1]]}}e.ResourceMap=b,b.defaultToKey=t=>t.toString();var I;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(I=e.Touch||(e.Touch={}));class g{constructor(){this[k]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){var r;return(r=this._head)===null||r===void 0?void 0:r.value}get last(){var r;return(r=this._tail)===null||r===void 0?void 0:r.value}has(r){return this._map.has(r)}get(r,i=0){const o=this._map.get(r);if(!!o)return i!==0&&this.touch(o,i),o.value}set(r,i,o=0){let c=this._map.get(r);if(c)c.value=i,o!==0&&this.touch(c,o);else{switch(c={key:r,value:i,next:void 0,previous:void 0},o){case 0:this.addItemLast(c);break;case 1:this.addItemFirst(c);break;case 2:this.addItemLast(c);break;default:this.addItemLast(c);break}this._map.set(r,c),this._size++}return this}delete(r){return!!this.remove(r)}remove(r){const i=this._map.get(r);if(!!i)return this._map.delete(r),this.removeItem(i),this._size--,i.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const r=this._head;return this._map.delete(r.key),this.removeItem(r),this._size--,r.value}forEach(r,i){const o=this._state;let c=this._head;for(;c;){if(i?r.bind(i)(c.value,c.key,this):r(c.value,c.key,this),this._state!==o)throw new Error("LinkedMap got modified during iteration.");c=c.next}}keys(){const r=this,i=this._state;let o=this._head;const c={[Symbol.iterator](){return c},next(){if(r._state!==i)throw new Error("LinkedMap got modified during iteration.");if(o){const l={value:o.key,done:!1};return o=o.next,l}else return{value:void 0,done:!0}}};return c}values(){const r=this,i=this._state;let o=this._head;const c={[Symbol.iterator](){return c},next(){if(r._state!==i)throw new Error("LinkedMap got modified during iteration.");if(o){const l={value:o.value,done:!1};return o=o.next,l}else return{value:void 0,done:!0}}};return c}entries(){const r=this,i=this._state;let o=this._head;const c={[Symbol.iterator](){return c},next(){if(r._state!==i)throw new Error("LinkedMap got modified during iteration.");if(o){const l={value:[o.key,o.value],done:!1};return o=o.next,l}else return{value:void 0,done:!0}}};return c}[(k=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(r){if(r>=this.size)return;if(r===0){this.clear();return}let i=this._head,o=this.size;for(;i&&o>r;)this._map.delete(i.key),i=i.next,o--;this._head=i,this._size=o,i&&(i.previous=void 0),this._state++}addItemFirst(r){if(!this._head&&!this._tail)this._tail=r;else if(this._head)r.next=this._head,this._head.previous=r;else throw new Error("Invalid list");this._head=r,this._state++}addItemLast(r){if(!this._head&&!this._tail)this._head=r;else if(this._tail)r.previous=this._tail,this._tail.next=r;else throw new Error("Invalid list");this._tail=r,this._state++}removeItem(r){if(r===this._head&&r===this._tail)this._head=void 0,this._tail=void 0;else if(r===this._head){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this._head=r.next}else if(r===this._tail){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this._tail=r.previous}else{const i=r.next,o=r.previous;if(!i||!o)throw new Error("Invalid list");i.previous=o,o.next=i}r.next=void 0,r.previous=void 0,this._state++}touch(r,i){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(i!==1&&i!==2)){if(i===1){if(r===this._head)return;const o=r.next,c=r.previous;r===this._tail?(c.next=void 0,this._tail=c):(o.previous=c,c.next=o),r.previous=void 0,r.next=this._head,this._head.previous=r,this._head=r,this._state++}else if(i===2){if(r===this._tail)return;const o=r.next,c=r.previous;r===this._head?(o.previous=void 0,this._head=o):(o.previous=c,c.next=o),r.next=void 0,r.previous=this._tail,this._tail.next=r,this._tail=r,this._state++}}}toJSON(){const r=[];return this.forEach((i,o)=>{r.push([o,i])}),r}fromJSON(r){this.clear();for(const[i,o]of r)this.set(i,o)}}e.LinkedMap=g;class a extends g{constructor(r,i=1){super();this._limit=r,this._ratio=Math.min(Math.max(0,i),1)}get limit(){return this._limit}set limit(r){this._limit=r,this.checkTrim()}get ratio(){return this._ratio}set ratio(r){this._ratio=Math.min(Math.max(0,r),1),this.checkTrim()}get(r,i=2){return super.get(r,i)}peek(r){return super.get(r,0)}set(r,i){return super.set(r,i,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=a;class s{constructor(r){A.set(this,void 0),ft(this,A,r,"f")}get size(){return ze(this,A,"f").size}forEach(r,i){ze(this,A,"f").forEach(r,i)}get(r){return ze(this,A,"f").get(r)}has(r){return ze(this,A,"f").has(r)}entries(){return ze(this,A,"f").entries()}keys(){return ze(this,A,"f").keys()}values(){return ze(this,A,"f").values()}[(A=new WeakMap,Symbol.iterator)](){return ze(this,A,"f").entries()}}e.ReadonlyMapView=s}),define(Z[89],ee([0,1,25,22,5]),function(G,e,y,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function k(S){return JSON.stringify(S,R)}e.stringify=k;function A(S){let n=JSON.parse(S);return n=p(n),n}e.parse=A;function R(S,n){return n instanceof RegExp?{$mid:2,source:n.source,flags:(0,P.regExpFlags)(n)}:n}function p(S,n=0){if(!S||n>200)return S;if(typeof S=="object"){switch(S.$mid){case 1:return L.URI.revive(S);case 2:return new RegExp(S.source,S.flags)}if(S instanceof y.VSBuffer||S instanceof Uint8Array)return S;if(Array.isArray(S))for(let f=0;f<S.length;++f)S[f]=p(S[f],n+1);else for(const f in S)Object.hasOwnProperty.call(S,f)&&(S[f]=p(S[f],n+1))}return S}e.revive=p}),define(Z[16],ee([0,1,5,6]),function(G,e,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var L;(function(R){R.inMemory="inmemory",R.vscode="vscode",R.internal="private",R.walkThrough="walkThrough",R.walkThroughSnippet="walkThroughSnippet",R.http="http",R.https="https",R.file="file",R.mailto="mailto",R.untitled="untitled",R.data="data",R.command="command",R.vscodeRemote="vscode-remote",R.vscodeRemoteResource="vscode-remote-resource",R.userData="vscode-userdata",R.vscodeCustomEditor="vscode-custom-editor",R.vscodeNotebook="vscode-notebook",R.vscodeNotebookCell="vscode-notebook-cell",R.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",R.vscodeNotebookCellOutput="vscode-notebook-cell-output",R.vscodeSettings="vscode-settings",R.vscodeWorkspaceTrust="vscode-workspace-trust",R.vscodeTerminal="vscode-terminal",R.webviewPanel="webview-panel",R.vscodeWebview="vscode-webview",R.extension="extension",R.vscodeFileResource="vscode-file",R.tmp="tmp"})(L=e.Schemas||(e.Schemas={}));class k{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(p){this._preferredWebSchema=p}setDelegate(p){this._delegate=p}set(p,S,n){this._hosts[p]=S,this._ports[p]=n}setConnectionToken(p,S){this._connectionTokens[p]=S}rewrite(p){if(this._delegate)return this._delegate(p);const S=p.authority;let n=this._hosts[S];n&&n.indexOf(":")!==-1&&(n=`[${n}]`);const f=this._ports[S],m=this._connectionTokens[S];let C=`path=${encodeURIComponent(p.path)}`;return typeof m=="string"&&(C+=`&tkn=${encodeURIComponent(m)}`),y.URI.from({scheme:P.isWeb?this._preferredWebSchema:L.vscodeRemoteResource,authority:`${n}:${f}`,path:"/vscode-remote-resource",query:C})}}e.RemoteAuthorities=new k;class A{constructor(){this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(p,S,n){const f=this.toUri(p,S);return f.scheme===L.vscodeRemote?e.RemoteAuthorities.rewrite(f):P.isNative&&(n||P.isPreferringBrowserCodeLoad)&&f.scheme===L.file?f.with({scheme:L.vscodeFileResource,authority:f.authority||this.FALLBACK_AUTHORITY,query:null,fragment:null}):f}asFileUri(p,S){const n=this.toUri(p,S);return n.scheme===L.vscodeFileResource?n.with({scheme:L.file,authority:n.authority!==this.FALLBACK_AUTHORITY?n.authority:null,query:null,fragment:null}):n}toUri(p,S){return y.URI.isUri(p)?p:y.URI.parse(S.toUrl(p))}}e.FileAccess=new A}),define(Z[67],ee([0,1,38]),function(G,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=e.canNormalize=void 0,e.canNormalize=typeof String.prototype.normalize=="function";const P=new y.LRUCache(1e4);function L(S){return p(S,"NFC",P)}e.normalizeNFC=L;const k=new y.LRUCache(1e4);function A(S){return p(S,"NFD",k)}e.normalizeNFD=A;const R=/[^\u0000-\u0080]/;function p(S,n,f){if(!e.canNormalize||!S)return S;const m=f.get(S);if(m)return m;let C;return R.test(S)?C=S.normalize(n):C=S,f.set(S,C),C}e.removeAccents=function(){if(e.canNormalize){const S=/[\u0300-\u036f]/g;return function(n){return A(n).replace(S,"")}}else return function(S){return S}}()}),define(Z[14],ee([0,1,41,7,5,22,16,6]),function(G,e,y,P,L,k,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function p(C){return(0,L.uriToFsPath)(C,!0)}e.originalFSPath=p;class S{constructor(h){this._ignorePathCasing=h}compare(h,E,D=!1){return h===E?0:(0,k.compare)(this.getComparisonKey(h,D),this.getComparisonKey(E,D))}isEqual(h,E,D=!1){return h===E?!0:!h||!E?!1:this.getComparisonKey(h,D)===this.getComparisonKey(E,D)}getComparisonKey(h,E=!1){return h.with({path:this._ignorePathCasing(h)?h.path.toLowerCase():void 0,fragment:E?null:void 0}).toString()}ignorePathCasing(h){return this._ignorePathCasing(h)}isEqualOrParent(h,E,D=!1){if(h.scheme===E.scheme){if(h.scheme===A.Schemas.file)return y.isEqualOrParent(p(h),p(E),this._ignorePathCasing(h))&&h.query===E.query&&(D||h.fragment===E.fragment);if((0,e.isEqualAuthority)(h.authority,E.authority))return y.isEqualOrParent(h.path,E.path,this._ignorePathCasing(h),"/")&&h.query===E.query&&(D||h.fragment===E.fragment)}return!1}joinPath(h,...E){return L.URI.joinPath(h,...E)}basenameOrAuthority(h){return(0,e.basename)(h)||h.authority}basename(h){return P.posix.basename(h.path)}extname(h){return P.posix.extname(h.path)}dirname(h){if(h.path.length===0)return h;let E;return h.scheme===A.Schemas.file?E=L.URI.file(P.dirname(p(h))).path:(E=P.posix.dirname(h.path),h.authority&&E.length&&E.charCodeAt(0)!==47&&(console.error(`dirname("${h.toString})) resulted in a relative path`),E="/")),h.with({path:E})}normalizePath(h){if(!h.path.length)return h;let E;return h.scheme===A.Schemas.file?E=L.URI.file(P.normalize(p(h))).path:E=P.posix.normalize(h.path),h.with({path:E})}relativePath(h,E){if(h.scheme!==E.scheme||!(0,e.isEqualAuthority)(h.authority,E.authority))return;if(h.scheme===A.Schemas.file){const I=P.relative(p(h),p(E));return R.isWindows?y.toSlashes(I):I}let D=h.path||"/",b=E.path||"/";if(this._ignorePathCasing(h)){let I=0;for(const g=Math.min(D.length,b.length);I<g&&!(D.charCodeAt(I)!==b.charCodeAt(I)&&D.charAt(I).toLowerCase()!==b.charAt(I).toLowerCase());I++);D=b.substr(0,I)+D.substr(I)}return P.posix.relative(D,b)}resolvePath(h,E){if(h.scheme===A.Schemas.file){const D=L.URI.file(P.resolve(p(h),E));return h.with({authority:D.authority,path:D.path})}return E=y.toPosixPath(E),h.with({path:P.posix.resolve(h.path,E)})}isAbsolutePath(h){return!!h.path&&h.path[0]==="/"}isEqualAuthority(h,E){return h===E||(0,k.equalsIgnoreCase)(h,E)}hasTrailingPathSeparator(h,E=P.sep){if(h.scheme===A.Schemas.file){const D=p(h);return D.length>y.getRoot(D).length&&D[D.length-1]===E}else{const D=h.path;return D.length>1&&D.charCodeAt(D.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(h.fsPath)}}removeTrailingPathSeparator(h,E=P.sep){return(0,e.hasTrailingPathSeparator)(h,E)?h.with({path:h.path.substr(0,h.path.length-1)}):h}addTrailingPathSeparator(h,E=P.sep){let D=!1;if(h.scheme===A.Schemas.file){const b=p(h);D=b!==void 0&&b.length===y.getRoot(b).length&&b[b.length-1]===E}else{E="/";const b=h.path;D=b.length===1&&b.charCodeAt(b.length-1)===47}return!D&&!(0,e.hasTrailingPathSeparator)(h,E)?h.with({path:h.path+"/"}):h}}e.ExtUri=S,e.extUri=new S(()=>!1),e.extUriBiasedIgnorePathCase=new S(C=>C.scheme===A.Schemas.file?!R.isLinux:!0),e.extUriIgnorePathCase=new S(C=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function n(C,h){const E=[];for(let D=0;D<C.length;D++){const b=h(C[D]);C.some((I,g)=>g===D?!1:(0,e.isEqualOrParent)(b,h(I)))||E.push(C[D])}return E}e.distinctParents=n;var f;(function(C){C.META_DATA_LABEL="label",C.META_DATA_DESCRIPTION="description",C.META_DATA_SIZE="size",C.META_DATA_MIME="mime";function h(E){const D=new Map;E.path.substring(E.path.indexOf(";")+1,E.path.lastIndexOf(";")).split(";").forEach(g=>{const[a,s]=g.split(":");a&&s&&D.set(a,s)});const I=E.path.substring(0,E.path.indexOf(";"));return I&&D.set(C.META_DATA_MIME,I),D}C.parseMetaData=h})(f=e.DataUri||(e.DataUri={}));function m(C,h,E){if(h){let D=C.path;return D&&D[0]!==P.posix.sep&&(D=P.posix.sep+D),C.with({scheme:E,authority:h,path:D})}return C.with({scheme:E})}e.toLocalResource=m}),define(Z[8],ee([0,1,29,11,3,2,66,14]),function(G,e,y,P,L,k,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.AsyncEmitter=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.ignoreErrors=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function p(M){return!!M&&typeof M.then=="function"}e.isThenable=p;function S(M){const U=new y.CancellationTokenSource,O=M(U.token),_=new Promise((N,W)=>{U.token.onCancellationRequested(()=>{W((0,P.canceled)())}),Promise.resolve(O).then(V=>{U.dispose(),N(V)},V=>{U.dispose(),W(V)})});return new class{cancel(){U.cancel()}then(N,W){return _.then(N,W)}catch(N){return this.then(void 0,N)}finally(N){return _.finally(N)}}}e.createCancelablePromise=S;function n(M,U,O){return Promise.race([M,new Promise(_=>U.onCancellationRequested(()=>_(O)))])}e.raceCancellation=n;async function f(M){let U=-1;const O=M.map((N,W)=>N.then(V=>(U=W,V))),_=await Promise.race(O);return M.forEach((N,W)=>{W!==U&&N.cancel()}),_}e.raceCancellablePromises=f;function m(M,U,O){let _;const N=setTimeout(()=>{_==null||_(void 0),O==null||O()},U);return Promise.race([M.finally(()=>clearTimeout(N)),new Promise(W=>_=W)])}e.raceTimeout=m;function C(M){return new Promise((U,O)=>{const _=M();p(_)?_.then(U,O):U(_)})}e.asPromise=C;class h{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(U){if(this.activePromise){if(this.queuedPromiseFactory=U,!this.queuedPromise){const O=()=>{this.queuedPromise=null;const _=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,_};this.queuedPromise=new Promise(_=>{this.activePromise.then(O,O).then(_)})}return new Promise((O,_)=>{this.queuedPromise.then(O,_)})}return this.activePromise=U(),new Promise((O,_)=>{this.activePromise.then(N=>{this.activePromise=null,O(N)},N=>{this.activePromise=null,_(N)})})}}e.Throttler=h;class E{constructor(){this.current=Promise.resolve(null)}queue(U){return this.current=this.current.then(()=>U(),()=>U())}}e.Sequencer=E;class D{constructor(){this.promiseMap=new Map}queue(U,O){var _;const W=((_=this.promiseMap.get(U))!==null&&_!==void 0?_:Promise.resolve()).catch(()=>{}).then(O).finally(()=>{this.promiseMap.get(U)===W&&this.promiseMap.delete(U)});return this.promiseMap.set(U,W),W}}e.SequencerByKey=D;class b{constructor(U){this.defaultDelay=U,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(U,O=this.defaultDelay){return this.task=U,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((_,N)=>{this.doResolve=_,this.doReject=N}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const _=this.task;return this.task=null,_()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},O),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,P.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancelTimeout()}}e.Delayer=b;class I{constructor(U){this.delayer=new b(U),this.throttler=new h}trigger(U,O){return this.delayer.trigger(()=>this.throttler.queue(U),O)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=I;class g{constructor(){this._isOpen=!1,this._promise=new Promise((U,O)=>{this._completePromise=U})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=g;class a extends g{constructor(U){super();this._timeout=setTimeout(()=>this.open(),U)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=a;function s(M,U){return U?new Promise((O,_)=>{const N=setTimeout(O,M);U.onCancellationRequested(()=>{clearTimeout(N),_((0,P.canceled)())})}):S(O=>s(M,O))}e.timeout=s;function t(M,U=0){const O=setTimeout(M,U);return(0,k.toDisposable)(()=>clearTimeout(O))}e.disposableTimeout=t;function r(M){return M.then(void 0,U=>{})}e.ignoreErrors=r;function i(M){const U=[];let O=0;const _=M.length;function N(){return O<_?M[O++]():null}function W(V){V!=null&&U.push(V);const Q=N();return Q?Q.then(W):Promise.resolve(U)}return Promise.resolve(null).then(W)}e.sequence=i;function o(M,U=_=>!!_,O=null){let _=0;const N=M.length,W=()=>{if(_>=N)return Promise.resolve(O);const V=M[_++];return Promise.resolve(V()).then(X=>U(X)?Promise.resolve(X):W())};return W()}e.first=o;function c(M,U=_=>!!_,O=null){if(M.length===0)return Promise.resolve(O);let _=M.length;const N=()=>{var W,V;_=-1;for(const Q of M)(V=(W=Q).cancel)===null||V===void 0||V.call(W)};return new Promise((W,V)=>{for(const Q of M)Q.then(X=>{--_>=0&&U(X)?(N(),W(X)):_===0&&W(O)}).catch(X=>{--_>=0&&(N(),V(X))})})}e.firstParallel=c;class l{constructor(U){this._size=0,this.maxDegreeOfParalellism=U,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new L.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(U){return this._size++,new Promise((O,_)=>{this.outstandingPromises.push({factory:U,c:O,e:_}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const U=this.outstandingPromises.shift();this.runningPromises++;const O=U.factory();O.then(U.c,U.e),O.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=l;class u extends l{constructor(){super(1)}}e.Queue=u;class v{constructor(){this.queues=new Map}queueFor(U,O=R.extUri){const _=O.getComparisonKey(U);let N=this.queues.get(_);return N||(N=new u,L.Event.once(N.onFinished)(()=>{N==null||N.dispose(),this.queues.delete(_)}),this.queues.set(_,N)),N}dispose(){this.queues.forEach(U=>U.dispose()),this.queues.clear()}}e.ResourceQueue=v;class w{constructor(U,O){this._token=-1,typeof U=="function"&&typeof O=="number"&&this.setIfNotSet(U,O)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(U,O){this.cancel(),this._token=setTimeout(()=>{this._token=-1,U()},O)}setIfNotSet(U,O){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,U()},O))}}e.TimeoutTimer=w;class d{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(U,O){this.cancel(),this._token=setInterval(()=>{U()},O)}}e.IntervalTimer=d;class T{constructor(U,O){this.timeoutToken=-1,this.runner=U,this.timeout=O,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(U=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,U)}get delay(){return this.timeout}set delay(U){this.timeout=U}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=T;class F extends T{constructor(U,O){super(U,O);this.units=[]}work(U){this.units.push(U),this.isScheduled()||this.schedule()}doRun(){const U=this.units;this.units=[],this.runner&&this.runner(U)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=F,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const M=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=U=>{const O=setTimeout(()=>U(M));let _=!1;return{dispose(){_||(_=!0,clearTimeout(O))}}}}else e.runWhenIdle=(M,U)=>{const O=requestIdleCallback(M,typeof U=="number"?{timeout:U}:void 0);let _=!1;return{dispose(){_||(_=!0,cancelIdleCallback(O))}}}}();class z{constructor(U){this._didRun=!1,this._executor=()=>{try{this._value=U()}catch(O){this._error=O}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}}e.IdleValue=z;async function B(M,U,O){let _;for(let N=0;N<O;N++)try{return await M()}catch(W){_=W,await s(U)}throw _}e.retry=B;class K{hasPending(U){return this._pending?typeof U=="number"?this._pending.taskId===U:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){var U;(U=this._pending)===null||U===void 0||U.cancel()}setPending(U,O,_){return this._pending={taskId:U,cancel:()=>_==null?void 0:_(),promise:O},O.then(()=>this.donePending(U),()=>this.donePending(U)),O}donePending(U){this._pending&&U===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const U=this._next;this._next=void 0,U.run().then(U.promiseResolve,U.promiseReject)}}setNext(U){if(this._next)this._next.run=U;else{let O,_;const N=new Promise((W,V)=>{O=W,_=V});this._next={run:U,promise:N,promiseResolve:O,promiseReject:_}}return this._next.promise}}e.TaskSequentializer=K;class j{constructor(U){this.interval=U,this.lastIncrementTime=0,this.value=0}increment(){const U=Date.now();return U-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=U,this.value=0),this.value++,this.value}}e.IntervalCounter=j;class H{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((U,O)=>{this.completeCallback=U,this.errorCallback=O})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(U){return new Promise(O=>{this.completeCallback(U),this.resolved=!0,O()})}error(U){return new Promise(O=>{this.errorCallback(U),this.rejected=!0,O()})}cancel(){new Promise(U=>{this.errorCallback((0,P.canceled)()),this.rejected=!0,U()})}}e.DeferredPromise=H;class q extends L.Emitter{async fireAsync(U,O,_){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new A.LinkedList);for(const N of this._listeners)this._asyncDeliveryQueue.push([N,U]);for(;this._asyncDeliveryQueue.size>0&&!O.isCancellationRequested;){const[N,W]=this._asyncDeliveryQueue.shift(),V=[],Q=Object.assign(Object.assign({},W),{waitUntil:X=>{if(Object.isFrozen(V))throw new Error("waitUntil can NOT be called asynchronous");_&&(X=_(X,typeof N=="function"?N:N[0])),V.push(X)}});try{typeof N=="function"?N.call(void 0,Q):N[0].call(N[1],Q)}catch(X){(0,P.onUnexpectedError)(X);continue}Object.freeze(V),await $.settled(V).catch(X=>(0,P.onUnexpectedError)(X))}}}}e.AsyncEmitter=q;var $;(function(M){async function U(W){return typeof Promise.allSettled=="function"?O(W):_(W)}M.allSettled=U;async function O(W){return Promise.allSettled(W)}async function _(W){return Promise.all(W.map(V=>V.then(Q=>({status:"fulfilled",value:Q}),Q=>({status:"rejected",reason:Q}))))}async function N(W){let V;const Q=await Promise.all(W.map(X=>X.then(ie=>ie,ie=>{V||(V=ie)})));if(typeof V!="undefined")throw V;return Q}M.settled=N})($=e.Promises||(e.Promises={}))}),define(Z[90],ee([0,1,22,41,7,38,8]),function(G,e,y,P,L,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function R(){return Object.create(null)}e.getEmptyExpression=R;const p="**",S="/",n="[/\\\\]",f="[^/\\\\]",m=/\//g;function C(O){switch(O){case 0:return"";case 1:return`${f}*?`;default:return`(?:${n}|${f}+${n}|${n}${f}+)*?`}}function h(O,_){if(!O)return[];const N=[];let W=!1,V=!1,Q="";for(const X of O){switch(X){case _:if(!W&&!V){N.push(Q),Q="";continue}break;case"{":W=!0;break;case"}":W=!1;break;case"[":V=!0;break;case"]":V=!1;break}Q+=X}return Q&&N.push(Q),N}e.splitGlobAware=h;function E(O){if(!O)return"";let _="";const N=h(O,S);if(N.every(W=>W===p))_=".*";else{let W=!1;N.forEach((V,Q)=>{if(V===p){W||(_+=C(2),W=!0);return}let X=!1,ie="",ne=!1,ce="";for(const le of V){if(le!=="}"&&X){ie+=le;continue}if(ne&&(le!=="]"||!ce)){let ve;le==="-"?ve=le:(le==="^"||le==="!")&&!ce?ve="^":le===S?ve="":ve=y.escapeRegExpCharacters(le),ce+=ve;continue}switch(le){case"{":X=!0;continue;case"[":ne=!0;continue;case"}":_+=`(?:${h(ie,",").map(Ce=>E(Ce)).join("|")})`,X=!1,ie="";break;case"]":_+="["+ce+"]",ne=!1,ce="";break;case"?":_+=f;continue;case"*":_+=C(1);continue;default:_+=y.escapeRegExpCharacters(le)}}Q<N.length-1&&(N[Q+1]!==p||Q+2<N.length)&&(_+=n),W=!1})}return _}const D=/^\*\*\/\*\.[\w\.-]+$/,b=/^\*\*\/([\w\.-]+)\/?$/,I=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,g=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,a=/^\*\*((\/[\w\.-]+)+)\/?$/,s=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new k.LRUCache(1e4),r=function(){return!1},i=function(){return null};function o(O,_){if(!O)return i;let N;typeof O!="string"?N=O.pattern:N=O,N=N.trim();const W=`${N}_${!!_.trimForExclusions}`;let V=t.get(W);if(V)return c(V,O);let Q;if(D.test(N)){const X=N.substr(4);V=function(ie,ne){return typeof ie=="string"&&ie.endsWith(X)?N:null}}else(Q=b.exec(l(N,_)))?V=u(Q[1],N):(_.trimForExclusions?g:I).test(N)?V=v(N,_):(Q=a.exec(l(N,_)))?V=w(Q[1].substr(1),N,!0):(Q=s.exec(l(N,_)))?V=w(Q[1],N,!1):V=d(N);return t.set(W,V),c(V,O)}function c(O,_){return typeof _=="string"?O:function(N,W){return P.isEqualOrParent(N,_.base)?O(L.relative(_.base,N),W):null}}function l(O,_){return _.trimForExclusions&&O.endsWith("/**")?O.substr(0,O.length-2):O}function u(O,_){const N=`/${O}`,W=`\\${O}`,V=function(X,ie){return typeof X!="string"?null:ie?ie===O?_:null:X===O||X.endsWith(N)||X.endsWith(W)?_:null},Q=[O];return V.basenames=Q,V.patterns=[_],V.allBasenames=Q,V}function v(O,_){const N=U(O.slice(1,-1).split(",").map(ie=>o(ie,_)).filter(ie=>ie!==i),O),W=N.length;if(!W)return i;if(W===1)return N[0];const V=function(ie,ne){for(let ce=0,le=N.length;ce<le;ce++)if(N[ce](ie,ne))return O;return null},Q=N.find(ie=>!!ie.allBasenames);Q&&(V.allBasenames=Q.allBasenames);const X=N.reduce((ie,ne)=>ne.allPaths?ie.concat(ne.allPaths):ie,[]);return X.length&&(V.allPaths=X),V}function w(O,_,N){const W=L.sep===L.posix.sep,V=W?O:O.replace(m,L.sep),Q=L.sep+V,X=L.posix.sep+O,ie=N?function(ne,ce){return typeof ne=="string"&&(ne===V||ne.endsWith(Q)||!W&&(ne===O||ne.endsWith(X)))?_:null}:function(ne,ce){return typeof ne=="string"&&(ne===V||!W&&ne===O)?_:null};return ie.allPaths=[(N?"*/":"./")+O],ie}function d(O){try{const _=new RegExp(`^${E(O)}$`);return function(N){return _.lastIndex=0,typeof N=="string"&&_.test(N)?O:null}}catch(_){return i}}function T(O,_,N){return!O||typeof _!="string"?!1:F(O)(_,void 0,N)}e.match=T;function F(O,_={}){if(!O)return r;if(typeof O=="string"||j(O)){const N=o(O,_);if(N===i)return r;const W=function(V,Q){return!!N(V,Q)};return N.allBasenames&&(W.allBasenames=N.allBasenames),N.allPaths&&(W.allPaths=N.allPaths),W}return $(O,_)}e.parse=F;function z(O){if(!O)return;let _;return N=>(_||(_=(O()||Promise.resolve([])).then(W=>W?K(W):{})),_.then(W=>!!W[N]))}e.hasSiblingPromiseFn=z;function B(O){if(!O)return;let _;return N=>{if(!_){const W=O();_=W?K(W):{}}return!!_[N]}}e.hasSiblingFn=B;function K(O){const _={};for(const N of O)_[N]=!0;return _}function j(O){const _=O;return _&&typeof _.base=="string"&&typeof _.pattern=="string"}e.isRelativePattern=j;function H(O){return O.allBasenames||[]}e.getBasenameTerms=H;function q(O){return O.allPaths||[]}e.getPathTerms=q;function $(O,_){const N=U(Object.getOwnPropertyNames(O).map(ie=>M(ie,O[ie],_)).filter(ie=>ie!==i)),W=N.length;if(!W)return i;if(!N.some(ie=>!!ie.requiresSiblings)){if(W===1)return N[0];const ie=function(le,ve){for(let pe=0,Ce=N.length;pe<Ce;pe++){const Ae=N[pe](le,ve);if(Ae)return Ae}return null},ne=N.find(le=>!!le.allBasenames);ne&&(ie.allBasenames=ne.allBasenames);const ce=N.reduce((le,ve)=>ve.allPaths?le.concat(ve.allPaths):le,[]);return ce.length&&(ie.allPaths=ce),ie}const V=function(ie,ne,ce){let le;for(let ve=0,pe=N.length;ve<pe;ve++){const Ce=N[ve];Ce.requiresSiblings&&ce&&(ne||(ne=L.basename(ie)),le||(le=ne.substr(0,ne.length-L.extname(ie).length)));const Ae=Ce(ie,ne,le,ce);if(Ae)return Ae}return null},Q=N.find(ie=>!!ie.allBasenames);Q&&(V.allBasenames=Q.allBasenames);const X=N.reduce((ie,ne)=>ne.allPaths?ie.concat(ne.allPaths):ie,[]);return X.length&&(V.allPaths=X),V}function M(O,_,N){if(_===!1)return i;const W=o(O,N);if(W===i)return i;if(typeof _=="boolean")return W;if(_){const V=_.when;if(typeof V=="string"){const Q=(X,ie,ne,ce)=>{if(!ce||!W(X,ie))return null;const le=V.replace("$(basename)",ne),ve=ce(le);return(0,A.isThenable)(ve)?ve.then(pe=>pe?O:null):ve?O:null};return Q.requiresSiblings=!0,Q}}return W}function U(O,_){const N=O.filter(ie=>!!ie.basenames);if(N.length<2)return O;const W=N.reduce((ie,ne)=>{const ce=ne.basenames;return ce?ie.concat(ce):ie},[]);let V;if(_){V=[];for(let ie=0,ne=W.length;ie<ne;ie++)V.push(_)}else V=N.reduce((ie,ne)=>{const ce=ne.patterns;return ce?ie.concat(ce):ie},[]);const Q=function(ie,ne){if(typeof ie!="string")return null;if(!ne){let le;for(le=ie.length;le>0;le--){const ve=ie.charCodeAt(le-1);if(ve===47||ve===92)break}ne=ie.substr(le)}const ce=W.indexOf(ne);return ce!==-1?V[ce]:null};Q.basenames=W,Q.patterns=V,Q.allBasenames=W;const X=O.filter(ie=>!ie.basenames);return X.push(Q),X}}),define(Z[91],ee([0,1,5]),function(G,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function P(n){return n.toJSON()}class L{constructor(f){this._uriTransformer=f}transformIncoming(f){const m=this._uriTransformer.transformIncoming(f);return m===f?f:P(y.URI.from(m))}transformOutgoing(f){const m=this._uriTransformer.transformOutgoing(f);return m===f?f:P(y.URI.from(m))}transformOutgoingURI(f){const m=this._uriTransformer.transformOutgoing(f);return m===f?f:y.URI.from(m)}transformOutgoingScheme(f){return this._uriTransformer.transformOutgoingScheme(f)}}e.URITransformer=L,e.DefaultURITransformer=new class{transformIncoming(n){return n}transformOutgoing(n){return n}transformOutgoingURI(n){return n}transformOutgoingScheme(n){return n}};function k(n,f,m){if(!n||m>200)return null;if(typeof n=="object"){if(n instanceof y.URI)return f.transformOutgoing(n);for(let C in n)if(Object.hasOwnProperty.call(n,C)){const h=k(n[C],f,m+1);h!==null&&(n[C]=h)}}return null}function A(n,f){const m=k(n,f,0);return m===null?n:m}e.transformOutgoingURIs=A;function R(n,f,m,C){if(!n||C>200)return null;if(typeof n=="object"){if(n.$mid===1)return m?y.URI.revive(f.transformIncoming(n)):f.transformIncoming(n);for(let h in n)if(Object.hasOwnProperty.call(n,h)){const E=R(n[h],f,m,C+1);E!==null&&(n[h]=E)}}return null}function p(n,f){const m=R(n,f,!1,0);return m===null?n:m}e.transformIncomingURIs=p;function S(n,f){const m=R(n,f,!0,0);return m===null?n:m}e.transformAndReviveIncomingURIs=S}),define(Z[30],ee([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const y=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function P(p){return y.test(p)}e.isUUID=P;const L=new Uint8Array(16),k=[];for(let p=0;p<256;p++)k.push(p.toString(16).padStart(2,"0"));let A;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?A=crypto.getRandomValues.bind(crypto):A=function(p){for(let S=0;S<p.length;S++)p[S]=Math.floor(Math.random()*256);return p};function R(){A(L),L[6]=L[6]&15|64,L[8]=L[8]&63|128;let p=0,S="";return S+=k[L[p++]],S+=k[L[p++]],S+=k[L[p++]],S+=k[L[p++]],S+="-",S+=k[L[p++]],S+=k[L[p++]],S+="-",S+=k[L[p++]],S+=k[L[p++]],S+="-",S+=k[L[p++]],S+=k[L[p++]],S+="-",S+=k[L[p++]],S+=k[L[p++]],S+=k[L[p++]],S+=k[L[p++]],S+=k[L[p++]],S+=k[L[p++]],S}e.generateUuid=R}),define(Z[68],ee([0,1,206]),function(G,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class P{constructor(k="utf8"){this.stringDecoder=new y.StringDecoder(k),this.remaining=null}write(k){const A=[],R=this.remaining?this.remaining+this.stringDecoder.write(k):this.stringDecoder.write(k);if(R.length<1)return A;let p=0,S,n=p;for(;n<R.length;)if(S=R.charCodeAt(n),S===13||S===10){if(A.push(R.substring(p,n)),n++,n<R.length){const f=S;S=R.charCodeAt(n),(f===13&&S===10||f===10&&S===13)&&n++}p=n}else n++;return this.remaining=p<R.length?R.substr(p):null,A}end(){return this.remaining}}e.LineDecoder=P}),define(Z[92],ee([0,1,35]),function(G,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const P=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function L(R){const p=R.replace(/\-/g,":").toLowerCase();return!P.has(p)}function k(){return new Promise(async(R,p)=>{const S=setTimeout(()=>p("Unable to retrieve mac address (timeout after 10s)"),1e4);try{R(await A())}catch(n){p(n)}finally{clearTimeout(S)}})}e.getMac=k;function A(){return new Promise((R,p)=>{try{const S=(0,y.networkInterfaces)();for(let n in S){const f=S[n];if(f){for(const{mac:m}of f)if(L(m))return R(m)}}p("Unable to retrieve mac address (unexpected format)")}catch(S){p(S)}})}}),define(Z[93],ee([0,1,11,30,35,38,92]),function(G,e,y,P,L,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAdress(n){return this._virtualMachineOUIs||(this._virtualMachineOUIs=k.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(n)}value(){if(this._value===void 0){let n=0,f=0;const m=(0,L.networkInterfaces)();for(let C in m){const h=m[C];if(h)for(const{mac:E,internal:D}of h)D||(f+=1,this._isVirtualMachineMacAdress(E.toUpperCase())&&(n+=1))}this._value=f>0?n/f:0}return this._value}};let R;async function p(){return R||(R=(async()=>await S()||P.generateUuid())()),R}e.getMachineId=p;async function S(){try{const n=await new Promise((m,C)=>{G(["crypto"],m,C)}),f=await(0,A.getMac)();return n.createHash("sha256").update(f,"utf8").digest("hex")}catch(n){y.onUnexpectedError(n);return}}}),define(Z[17],ee([0,1,42,35,207,7,8,6,41,30,67,14,5]),function(G,e,y,P,L,k,A,R,p,S,n,f,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.exists=e.copy=e.move=e.writeFileSync=e.writeFile=e.SymlinkSupport=e.whenDeleted=e.readDirsInDir=e.readdirSync=e.readdir=e.rimrafSync=e.rimraf=e.RimRafMode=void 0;var C;(function($){$[$.UNLINK=0]="UNLINK",$[$.MOVE=1]="MOVE"})(C=e.RimRafMode||(e.RimRafMode={}));async function h($,M=C.UNLINK){if((0,p.isRootOrDriveLetter)($))throw new Error("rimraf - will refuse to recursively delete root");return M===C.UNLINK?D($):E($)}e.rimraf=h;async function E($){try{const M=(0,k.join)((0,P.tmpdir)(),(0,S.generateUuid)());try{await q.rename($,M)}catch(U){return D($)}D(M).catch(U=>{})}catch(M){if(M.code!=="ENOENT")throw M}}async function D($){return q.rmdir($,{recursive:!0,maxRetries:3})}function b($){if((0,p.isRootOrDriveLetter)($))throw new Error("rimraf - will refuse to recursively delete root");y.rmdirSync($,{recursive:!0})}e.rimrafSync=b;async function I($,M){return s(await(M?g($):q.readdir($)))}e.readdir=I;async function g($){try{return await q.readdir($,{withFileTypes:!0})}catch(O){console.warn("[node.js fs] readdir with filetypes failed with error: ",O)}const M=[],U=await I($);for(const O of U){let _=!1,N=!1,W=!1;try{const V=await q.lstat((0,k.join)($,O));_=V.isFile(),N=V.isDirectory(),W=V.isSymbolicLink()}catch(V){console.warn("[node.js fs] unexpected error from lstat after readdir: ",V)}M.push({name:O,isFile:()=>_,isDirectory:()=>N,isSymbolicLink:()=>W})}return M}function a($){return s(y.readdirSync($))}e.readdirSync=a;function s($){return $.map(M=>typeof M=="string"?R.isMacintosh?(0,n.normalizeNFC)(M):M:(M.name=R.isMacintosh?(0,n.normalizeNFC)(M.name):M.name,M))}async function t($){const M=await I($),U=[];for(const O of M)await i.existsDirectory((0,k.join)($,O))&&U.push(O);return U}e.readDirsInDir=t;function r($,M=1e3){return new Promise(U=>{let O=!1;const _=setInterval(()=>{O||(O=!0,y.access($,N=>{O=!1,N&&(clearInterval(_),U(void 0))}))},M)})}e.whenDeleted=r;var i;(function($){async function M(_){let N;try{if(N=await q.lstat(_),!N.isSymbolicLink())return{stat:N}}catch(W){}try{return{stat:await q.stat(_),symbolicLink:(N==null?void 0:N.isSymbolicLink())?{dangling:!1}:void 0}}catch(W){if(W.code==="ENOENT"&&N)return{stat:N,symbolicLink:{dangling:!0}};if(R.isWindows&&W.code==="EACCES")try{return{stat:await q.stat(await q.readlink(_)),symbolicLink:{dangling:!1}}}catch(V){if(V.code==="ENOENT"&&N)return{stat:N,symbolicLink:{dangling:!0}};throw V}throw W}}$.stat=M;async function U(_){try{const{stat:N,symbolicLink:W}=await $.stat(_);return N.isFile()&&(W==null?void 0:W.dangling)!==!0}catch(N){}return!1}$.existsFile=U;async function O(_){try{const{stat:N,symbolicLink:W}=await $.stat(_);return N.isDirectory()&&(W==null?void 0:W.dangling)!==!0}catch(N){}return!1}$.existsDirectory=O})(i=e.SymlinkSupport||(e.SymlinkSupport={}));const o=new A.ResourceQueue;function c($,M,U){return o.queueFor(m.URI.file($),f.extUriBiasedIgnorePathCase).queue(()=>{const O=w(U);return new Promise((_,N)=>u($,M,O,W=>W?N(W):_()))})}e.writeFile=c;let l=!0;function u($,M,U,O){if(!l)return y.writeFile($,M,{mode:U.mode,flag:U.flag},O);y.open($,U.flag,U.mode,(_,N)=>{if(_)return O(_);y.writeFile(N,M,W=>{if(W)return y.close(N,()=>O(W));y.fdatasync(N,V=>(V&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",V),l=!1),y.close(N,Q=>O(Q))))})})}function v($,M,U){const O=w(U);if(!l)return y.writeFileSync($,M,{mode:O.mode,flag:O.flag});const _=y.openSync($,O.flag,O.mode);try{y.writeFileSync(_,M);try{y.fdatasyncSync(_)}catch(N){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",N),l=!1}}finally{y.closeSync(_)}}e.writeFileSync=v;function w($){return $?{mode:typeof $.mode=="number"?$.mode:438,flag:typeof $.flag=="string"?$.flag:"w"}:{mode:438,flag:"w"}}async function d($,M){if($===M)return;async function U(O){try{const _=await q.lstat(O);if(_.isDirectory()||_.isSymbolicLink())return;await q.utimes(O,_.atime,new Date)}catch(_){}}try{await q.rename($,M),await U(M)}catch(O){if($.toLowerCase()!==M.toLowerCase()&&O.code==="EXDEV"||$.endsWith("."))await T($,M,{preserveSymlinks:!1}),await h($,C.MOVE),await U(M);else throw O}}e.move=d;async function T($,M,U){return z($,M,{root:{source:$,target:M},options:U,handledSourcePaths:new Set})}e.copy=T;const F=511;async function z($,M,U){if(U.handledSourcePaths.has($))return;U.handledSourcePaths.add($);const{stat:O,symbolicLink:_}=await i.stat($);if(_){if(U.options.preserveSymlinks)try{return await j($,M,U)}catch(N){console.warn("[node.js fs] copy of symlink failed: ",N)}if(_.dangling)return}return O.isDirectory()?B($,M,O.mode&F,U):K($,M,O.mode&F)}async function B($,M,U,O){await q.mkdir(M,{recursive:!0,mode:U});const _=await I($);for(const N of _)await z((0,k.join)($,N),(0,k.join)(M,N),O)}async function K($,M,U){await q.copyFile($,M),await q.chmod(M,U)}async function j($,M,U){let O=await q.readlink($);(0,p.isEqualOrParent)(O,U.root.source,!R.isLinux)&&(O=(0,k.join)(U.root.target,O.substr(U.root.source.length+1))),await q.symlink(O,M)}async function H($){try{return await q.access($),!0}catch(M){return!1}}e.exists=H;var q;(function($){$.access=(0,L.promisify)(y.access),$.stat=(0,L.promisify)(y.stat),$.lstat=(0,L.promisify)(y.lstat),$.utimes=(0,L.promisify)(y.utimes),$.read=(0,L.promisify)(y.read),$.readFile=(0,L.promisify)(y.readFile),$.write=(0,L.promisify)(y.write),$.writeFile=(0,L.promisify)(y.writeFile),$.appendFile=(0,L.promisify)(y.appendFile),$.fdatasync=(0,L.promisify)(y.fdatasync),$.truncate=(0,L.promisify)(y.truncate),$.rename=(0,L.promisify)(y.rename),$.copyFile=(0,L.promisify)(y.copyFile),$.open=(0,L.promisify)(y.open),$.close=(0,L.promisify)(y.close),$.symlink=(0,L.promisify)(y.symlink),$.readlink=(0,L.promisify)(y.readlink),$.chmod=(0,L.promisify)(y.chmod),$.readdir=(0,L.promisify)(y.readdir),$.mkdir=(0,L.promisify)(y.mkdir),$.unlink=(0,L.promisify)(y.unlink),$.rmdir=(0,L.promisify)(y.rmdir),$.realpath=(0,L.promisify)(y.realpath)})(q=e.Promises||(e.Promises={}))}),define(Z[94],ee([0,1,42,22,7,17]),function(G,e,y,P,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function A(n){const f=(0,L.dirname)(n);if(n===f)return n;const m=((0,L.basename)(n)||n).toLowerCase();try{const h=(0,k.readdirSync)(f).filter(E=>E.toLowerCase()===m);if(h.length===1){const E=A(f);if(E)return(0,L.join)(E,h[0])}else if(h.length>1){const E=h.indexOf(m);if(E>=0){const D=A(f);if(D)return(0,L.join)(D,h[E])}}}catch(C){}return null}e.realcaseSync=A;async function R(n){try{return await k.Promises.realpath(n)}catch(f){const m=S(n);return await k.Promises.access(m,y.constants.R_OK),m}}e.realpath=R;function p(n){try{return y.realpathSync(n)}catch(f){const m=S(n);return y.accessSync(m,y.constants.R_OK),m}}e.realpathSync=p;function S(n){return(0,P.rtrim)((0,L.normalize)(n),L.sep)}});var Le=this&&this.__await||function(G){return this instanceof Le?(this.v=G,this):new Le(G)},lt=this&&this.__asyncGenerator||function(G,e,y){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var P=y.apply(G,e||[]),L,k=[];return L={},A("next"),A("throw"),A("return"),L[Symbol.asyncIterator]=function(){return this},L;function A(m){P[m]&&(L[m]=function(C){return new Promise(function(h,E){k.push([m,C,h,E])>1||R(m,C)})})}function R(m,C){try{p(P[m](C))}catch(h){f(k[0][3],h)}}function p(m){m.value instanceof Le?Promise.resolve(m.value.v).then(S,n):f(k[0][2],m)}function S(m){R("next",m)}function n(m){R("throw",m)}function f(m,C){m(C),k.shift(),k.length&&R(k[0][0],k[0][1])}},et=this&&this.__asyncValues||function(G){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var e=G[Symbol.asyncIterator],y;return e?e.call(G):(G=typeof __values=="function"?__values(G):G[Symbol.iterator](),y={},P("next"),P("throw"),P("return"),y[Symbol.asyncIterator]=function(){return this},y);function P(k){y[k]=G[k]&&function(A){return new Promise(function(R,p){A=G[k](A),L(R,p,A.done,A.value)})}}function L(k,A,R,p){Promise.resolve(p).then(function(S){k({value:S,done:R})},A)}};define(Z[95],ee([0,1,17,35,7]),function(G,e,y,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const k=/^\d+$/,A=/^Microsoft.PowerShell_.*/,R=/^Microsoft.PowerShellPreview_.*/;var p;(function(a){a[a.x64=0]="x64",a[a.x86=1]="x86",a[a.ARM=2]="ARM"})(p||(p={}));let S;switch(process.arch){case"ia32":case"x32":S=1;break;case"arm":case"arm64":S=2;break;default:S=0;break}let n;process.env.PROCESSOR_ARCHITEW6432?n=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?n=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?n=1:n=0;class f{constructor(s,t,r){this.exePath=s,this.displayName=t,this.knownToExist=r}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await y.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function m({useAlternateBitness:a=!1}={}){return a?S===0?process.env["ProgramFiles(x86)"]||null:n===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function C({useAlternateBitness:a=!1,findPreview:s=!1}={}){const t=m({useAlternateBitness:a});if(!t)return null;const r=L.join(t,"PowerShell");if(!await y.SymlinkSupport.existsDirectory(r))return null;let i=-1,o=null;for(const u of await y.readdir(r)){let v=-1;if(s){const d=u.indexOf("-");if(d<0)continue;const T=u.substring(0,d);if(!k.test(T)||u.substring(d+1)!=="preview")continue;v=parseInt(T,10)}else{if(!k.test(u))continue;v=parseInt(u,10)}if(v<=i)continue;const w=L.join(r,u,"pwsh.exe");!await y.SymlinkSupport.existsFile(w)||(o=w,i=v)}if(!o)return null;const c=t.includes("x86")?" (x86)":"",l=s?" Preview":"";return new f(o,`PowerShell${l}${c}`,!0)}async function h({findPreview:a}={}){if(!process.env.LOCALAPPDATA)return null;const s=L.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await y.SymlinkSupport.existsDirectory(s))return null;const{pwshMsixDirRegex:t,pwshMsixName:r}=a?{pwshMsixDirRegex:R,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:A,pwshMsixName:"PowerShell (Store)"};for(const i of await y.readdir(s))if(t.test(i)){const o=L.join(s,i,"pwsh.exe");return new f(o,r)}return null}function E(){const a=L.join(P.homedir(),".dotnet","tools","pwsh.exe");return new f(a,".NET Core PowerShell Global Tool")}function D(){const a=L.join(process.env.windir,S===1&&n!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new f(a,"Windows PowerShell",!0)}function b(){return lt(this,arguments,function*(){let s=yield Le(C());s&&(yield yield Le(s)),s=yield Le(C({useAlternateBitness:!0})),s&&(yield yield Le(s)),s=yield Le(h()),s&&(yield yield Le(s)),s=E(),s&&(yield yield Le(s)),s=yield Le(C({findPreview:!0})),s&&(yield yield Le(s)),s=yield Le(h({findPreview:!0})),s&&(yield yield Le(s)),s=yield Le(C({useAlternateBitness:!0,findPreview:!0})),s&&(yield yield Le(s)),s=D(),s&&(yield yield Le(s))})}function I(){return lt(this,arguments,function*(){var s,t;try{for(var r=et(b()),i;i=yield Le(r.next()),!i.done;){const o=i.value;(yield Le(o.exists()))&&(yield yield Le(o))}}catch(o){s={error:o}}finally{try{i&&!i.done&&(t=r.return)&&(yield Le(t.call(r)))}finally{if(s)throw s.error}}})}e.enumeratePowerShellInstallations=I;async function g(){var a,s;try{for(var t=et(I()),r;r=await t.next(),!r.done;)return r.value}catch(i){a={error:i}}finally{try{r&&!r.done&&(s=t.return)&&await s.call(t)}finally{if(a)throw a.error}}return null}e.getFirstAvailablePowerShellInstallation=g}),define(Z[96],ee([0,1,43,16]),function(G,e,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function L(A){return new Promise((R,p)=>{let S;const n=new Map;function f(C,h,E,D,b){const I=n.get(h);if(C===A||I){const g={name:m(E),cmd:E,pid:C,ppid:h,load:D,mem:b};n.set(C,g),C===A&&(S=g),I&&(I.children||(I.children=[]),I.children.push(g),I.children.length>1&&(I.children=I.children.sort((a,s)=>a.pid-s.pid)))}}function m(C){const h=/--disable-blink-features=Auxclick/,E=/\\watcher\\win32\\CodeHelper\.exe/,D=/--crashes-directory/,b=/\\pipe\\winpty-control/,I=/conhost\.exe/,g=/--type=([a-zA-Z-]+)/;if(E.exec(C))return"watcherService ";if(D.exec(C))return"electron-crash-reporter";if(b.exec(C))return"winpty-process";if(I.exec(C))return"console-window-host (Windows internal process)";let a=g.exec(C);if(a&&a.length===2)return a[1]==="renderer"?h.exec(C)?"shared-process":"window":a[1];const s=/[a-zA-Z-]+\.js/g;let t="";do a=s.exec(C),a&&(t+=a+" ");while(a);return t&&C.indexOf("node ")<0&&C.indexOf("node.exe")<0?`electron_node ${t}`:C}if(process.platform==="win32"){const C=h=>h.indexOf("\\\\?\\")===0||h.indexOf("\\??\\")===0?h.substr(4):h.indexOf('"\\\\?\\')===0||h.indexOf('"\\??\\')===0?'"'+h.substr(5):h;new Promise((h,E)=>{G(["windows-process-tree"],h,E)}).then(h=>{h.getProcessList(A,E=>{h.getProcessCpuUsage(E,D=>{const b=new Map;D.forEach(I=>{const g=C(I.commandLine||"");b.set(I.pid,{name:m(g),cmd:g,pid:I.pid,ppid:I.ppid,load:I.cpu||0,mem:I.memory||0})}),S=b.get(A),S?(b.forEach(I=>{const g=b.get(I.ppid);g&&(g.children||(g.children=[]),g.children.push(I))}),b.forEach(I=>{I.children&&(I.children=I.children.sort((g,a)=>g.pid-a.pid))}),R(S)):p(new Error(`Root process ${A} not found`))})},h.ProcessDataFlag.CommandLine|h.ProcessDataFlag.Memory)})}else{let C=function(){let h=[S];const E=[];for(;h.length;){const b=h.shift();b&&(E.push(b.pid),b.children&&(h=h.concat(b.children)))}let D=JSON.stringify(P.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",G).fsPath);D+=" "+E.join(" "),(0,y.exec)(D,{},(b,I,g)=>{if(b||g)p(b||new Error(g.toString()));else{const a=I.toString().split(`
`);for(let s=0;s<E.length;s++){const t=n.get(E[s]);t.load=parseFloat(a[s])}if(!S){p(new Error(`Root process ${A} not found`));return}R(S)}})};(0,y.exec)("which ps",{},(h,E,D)=>{if(h||D)if(process.platform!=="linux")p(h||new Error(D.toString()));else{const b=JSON.stringify(P.FileAccess.asFileUri("vs/base/node/ps.sh",G).fsPath);(0,y.exec)(b,{},(I,g,a)=>{I||a?p(I||new Error(a.toString())):(k(g,f),C())})}else{const b=E.toString().trim(),I="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,y.exec)(`${b} ${I}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(g,a,s)=>{g||s&&!s.includes("screen size is bogus")?p(g||new Error(s.toString())):(k(a,f),process.platform==="linux"?C():S?R(S):p(new Error(`Root process ${A} not found`)))})}})}})}e.listProcesses=L;function k(A,R){const p=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,S=A.toString().split(`
`);for(const n of S){const f=p.exec(n.trim());f&&f.length===6&&R(parseInt(f[1]),parseInt(f[2]),f[5],parseFloat(f[3]),parseFloat(f[4]))}}}),define(Z[97],ee([0,1,7,42,6,67,2,17]),function(G,e,y,P,L,k,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CHANGE_BUFFER_DELAY=e.watchFolder=e.watchFile=void 0;function p(f,m,C){return n({path:f,isDirectory:!1},m,C)}e.watchFile=p;function S(f,m,C){return n({path:f,isDirectory:!0},m,C)}e.watchFolder=S,e.CHANGE_BUFFER_DELAY=100;function n(f,m,C){const h=(0,y.basename)(f.path),E=new Map;let D=!1,b=[(0,A.toDisposable)(()=>{E.forEach(I=>(0,A.dispose)(I)),E.clear()})];try{const I=(0,P.watch)(f.path);b.push((0,A.toDisposable)(()=>{I.removeAllListeners(),I.close()}));const g=new Set;f.isDirectory&&(0,R.readdir)(f.path).then(a=>a.forEach(s=>g.add(s))),I.on("error",(a,s)=>{D||C(`Failed to watch ${f.path} for changes using fs.watch() (${a}, ${s})`)}),I.on("change",(a,s)=>{if(D)return;let t="";if(s&&(t=s.toString(),L.isMacintosh&&(t=(0,k.normalizeNFC)(t))),!t||a!=="change"&&a!=="rename")return;const r=f.isDirectory?(0,y.join)(f.path,t):f.path;if(f.isDirectory)if(a==="rename"){const i=E.get(r);i&&(0,A.dispose)(i);const o=setTimeout(async()=>{E.delete(r);const c=await(0,R.exists)(r);if(D)return;let l;c?g.has(t)?l="changed":(l="added",g.add(t)):(g.delete(t),l="deleted"),m(l,r)},e.CHANGE_BUFFER_DELAY);E.set(r,(0,A.toDisposable)(()=>clearTimeout(o)))}else{let i;g.has(t)?i="changed":(i="added",g.add(t)),m(i,r)}else if(a==="rename"||t!==h){const i=setTimeout(async()=>{const o=await(0,R.exists)(r);D||(o?(m("changed",r),b=[n(f,m,C)]):m("deleted",r))},e.CHANGE_BUFFER_DELAY);(0,A.dispose)(b),b=[(0,A.toDisposable)(()=>clearTimeout(i))]}else m("changed",r)})}catch(I){(0,R.exists)(f.path).then(g=>{g&&!D&&C(`Failed to watch ${f.path} for changes using fs.watch() (${I.toString()})`)})}return(0,A.toDisposable)(()=>{D=!0,b=(0,A.dispose)(b)})}});var de=this&&this.__decorate||function(G,e,y,P){var L=arguments.length,k=L<3?e:P===null?P=Object.getOwnPropertyDescriptor(e,y):P,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")k=Reflect.decorate(G,e,y,P);else for(var R=G.length-1;R>=0;R--)(A=G[R])&&(k=(L<3?A(k):L>3?A(e,y,k):A(e,y))||k);return L>3&&k&&Object.defineProperty(e,y,k),k};define(Z[36],ee([0,1,3,2,8,29,11,25,19,15,89,22,64]),function(G,e,y,P,L,k,A,R,p,S,n,f,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var C;(function(U){U[U.Promise=100]="Promise",U[U.PromiseCancel=101]="PromiseCancel",U[U.EventListen=102]="EventListen",U[U.EventDispose=103]="EventDispose"})(C=e.RequestType||(e.RequestType={}));function h(U){switch(U){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var E;(function(U){U[U.Initialize=200]="Initialize",U[U.PromiseSuccess=201]="PromiseSuccess",U[U.PromiseError=202]="PromiseError",U[U.PromiseErrorObj=203]="PromiseErrorObj",U[U.EventFire=204]="EventFire"})(E=e.ResponseType||(e.ResponseType={}));function D(U){switch(U){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var b;(function(U){U[U.Uninitialized=0]="Uninitialized",U[U.Idle=1]="Idle"})(b||(b={}));class I{constructor(O){this.buffer=O,this.pos=0}read(O){const _=this.buffer.slice(this.pos,this.pos+O);return this.pos+=_.byteLength,_}}class g{constructor(){this.buffers=[]}get buffer(){return R.VSBuffer.concat(this.buffers)}write(O){this.buffers.push(O)}}var a;(function(U){U[U.Undefined=0]="Undefined",U[U.String=1]="String",U[U.Buffer=2]="Buffer",U[U.VSBuffer=3]="VSBuffer",U[U.Array=4]="Array",U[U.Object=5]="Object"})(a||(a={}));function s(U){const O=R.VSBuffer.alloc(4);return O.writeUInt32BE(U,0),O}function t(U){return U.read(4).readUInt32BE(0)}function r(U){const O=R.VSBuffer.alloc(1);return O.writeUInt8(U,0),O}const i={Undefined:r(a.Undefined),String:r(a.String),Buffer:r(a.Buffer),VSBuffer:r(a.VSBuffer),Array:r(a.Array),Object:r(a.Object)},o=typeof Buffer!="undefined";function c(U,O){if(typeof O=="undefined")U.write(i.Undefined);else if(typeof O=="string"){const _=R.VSBuffer.fromString(O);U.write(i.String),U.write(s(_.byteLength)),U.write(_)}else if(o&&Buffer.isBuffer(O)){const _=R.VSBuffer.wrap(O);U.write(i.Buffer),U.write(s(_.byteLength)),U.write(_)}else if(O instanceof R.VSBuffer)U.write(i.VSBuffer),U.write(s(O.byteLength)),U.write(O);else if(Array.isArray(O)){U.write(i.Array),U.write(s(O.length));for(const _ of O)c(U,_)}else{const _=R.VSBuffer.fromString(JSON.stringify(O));U.write(i.Object),U.write(s(_.byteLength)),U.write(_)}}function l(U){switch(U.read(1).readUInt8(0)){case a.Undefined:return;case a.String:return U.read(t(U)).toString();case a.Buffer:return U.read(t(U)).buffer;case a.VSBuffer:return U.read(t(U));case a.Array:{const _=t(U),N=[];for(let W=0;W<_;W++)N.push(l(U));return N}case a.Object:return JSON.parse(U.read(t(U)).toString())}}class u{constructor(O,_,N=null,W=1e3){this.protocol=O,this.ctx=_,this.logger=N,this.timeoutDelay=W,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(V=>this.onRawMessage(V)),this.sendResponse({type:200})}registerChannel(O,_){this.channels.set(O,_),setTimeout(()=>this.flushPendingRequests(O),0)}sendResponse(O){switch(O.type){case 200:{const _=this.send([O.type]);this.logger&&this.logger.logOutgoing(_,0,1,D(O.type));return}case 201:case 202:case 204:case 203:{const _=this.send([O.type,O.id],O.data);this.logger&&this.logger.logOutgoing(_,O.id,1,D(O.type),O.data);return}}}send(O,_=void 0){const N=new g;return c(N,O),c(N,_),this.sendBuffer(N.buffer)}sendBuffer(O){try{return this.protocol.send(O),O.byteLength}catch(_){return 0}}onRawMessage(O){const _=new I(O),N=l(_),W=l(_),V=N[0];switch(V){case 100:return this.logger&&this.logger.logIncoming(O.byteLength,N[1],1,`${h(V)}: ${N[2]}.${N[3]}`,W),this.onPromise({type:V,id:N[1],channelName:N[2],name:N[3],arg:W});case 102:return this.logger&&this.logger.logIncoming(O.byteLength,N[1],1,`${h(V)}: ${N[2]}.${N[3]}`,W),this.onEventListen({type:V,id:N[1],channelName:N[2],name:N[3],arg:W});case 101:return this.logger&&this.logger.logIncoming(O.byteLength,N[1],1,`${h(V)}`),this.disposeActiveRequest({type:V,id:N[1]});case 103:return this.logger&&this.logger.logIncoming(O.byteLength,N[1],1,`${h(V)}`),this.disposeActiveRequest({type:V,id:N[1]})}}onPromise(O){const _=this.channels.get(O.channelName);if(!_){this.collectPendingRequest(O);return}const N=new k.CancellationTokenSource;let W;try{W=_.call(this.ctx,O.name,O.arg,N.token)}catch(X){W=Promise.reject(X)}const V=O.id;W.then(X=>{this.sendResponse({id:V,data:X,type:201}),this.activeRequests.delete(O.id)},X=>{X instanceof Error?this.sendResponse({id:V,data:{message:X.message,name:X.name,stack:X.stack?X.stack.split?X.stack.split(`
`):X.stack:void 0},type:202}):this.sendResponse({id:V,data:X,type:203}),this.activeRequests.delete(O.id)});const Q=(0,P.toDisposable)(()=>N.cancel());this.activeRequests.set(O.id,Q)}onEventListen(O){const _=this.channels.get(O.channelName);if(!_){this.collectPendingRequest(O);return}const N=O.id,V=_.listen(this.ctx,O.name,O.arg)(Q=>this.sendResponse({id:N,data:Q,type:204}));this.activeRequests.set(O.id,V)}disposeActiveRequest(O){const _=this.activeRequests.get(O.id);_&&(_.dispose(),this.activeRequests.delete(O.id))}collectPendingRequest(O){let _=this.pendingRequests.get(O.channelName);_||(_=[],this.pendingRequests.set(O.channelName,_));const N=setTimeout(()=>{console.error(`Unknown channel: ${O.channelName}`),O.type===100&&this.sendResponse({id:O.id,data:{name:"Unknown channel",message:`Channel name '${O.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);_.push({request:O,timeoutTimer:N})}flushPendingRequests(O){const _=this.pendingRequests.get(O);if(_){for(const N of _)switch(clearTimeout(N.timeoutTimer),N.request.type){case 100:this.onPromise(N.request);break;case 102:this.onEventListen(N.request);break}this.pendingRequests.delete(O)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(O=>O.dispose()),this.activeRequests.clear()}}e.ChannelServer=u;var v;(function(U){U[U.LocalSide=0]="LocalSide",U[U.OtherSide=1]="OtherSide"})(v=e.RequestInitiator||(e.RequestInitiator={}));class w{constructor(O,_=null){this.protocol=O,this.isDisposed=!1,this.state=b.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new y.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(N=>this.onBuffer(N)),this.logger=_}getChannel(O){const _=this;return{call(N,W,V){return _.isDisposed?Promise.reject(A.canceled()):_.requestPromise(O,N,W,V)},listen(N,W){return _.isDisposed?Promise.reject(A.canceled()):_.requestEvent(O,N,W)}}}requestPromise(O,_,N,W=k.CancellationToken.None){const V=this.lastRequestId++,X={id:V,type:100,channelName:O,name:_,arg:N};if(W.isCancellationRequested)return Promise.reject(A.canceled());let ie;return new Promise((ce,le)=>{if(W.isCancellationRequested)return le(A.canceled());const ve=()=>{const _e=Oe=>{switch(Oe.type){case 201:this.handlers.delete(V),ce(Oe.data);break;case 202:this.handlers.delete(V);const ke=new Error(Oe.data.message);ke.stack=Oe.data.stack,ke.name=Oe.data.name,le(ke);break;case 203:this.handlers.delete(V),le(Oe.data);break}};this.handlers.set(V,_e),this.sendRequest(X)};let pe=null;this.state===b.Idle?ve():(pe=(0,L.createCancelablePromise)(_e=>this.whenInitialized()),pe.then(()=>{pe=null,ve()}));const Ce=()=>{pe?(pe.cancel(),pe=null):this.sendRequest({id:V,type:101}),le(A.canceled())},Ae=W.onCancellationRequested(Ce);ie=(0,P.combinedDisposable)((0,P.toDisposable)(Ce),Ae),this.activeRequests.add(ie)}).finally(()=>{this.activeRequests.delete(ie)})}requestEvent(O,_,N){const W=this.lastRequestId++,Q={id:W,type:102,channelName:O,name:_,arg:N};let X=null;const ie=new y.Emitter({onFirstListenerAdd:()=>{X=(0,L.createCancelablePromise)(ce=>this.whenInitialized()),X.then(()=>{X=null,this.activeRequests.add(ie),this.sendRequest(Q)})},onLastListenerRemove:()=>{X?(X.cancel(),X=null):(this.activeRequests.delete(ie),this.sendRequest({id:W,type:103}))}}),ne=ce=>ie.fire(ce.data);return this.handlers.set(W,ne),ie.event}sendRequest(O){switch(O.type){case 100:case 102:{const _=this.send([O.type,O.id,O.channelName,O.name],O.arg);this.logger&&this.logger.logOutgoing(_,O.id,0,`${h(O.type)}: ${O.channelName}.${O.name}`,O.arg);return}case 101:case 103:{const _=this.send([O.type,O.id]);this.logger&&this.logger.logOutgoing(_,O.id,0,h(O.type));return}}}send(O,_=void 0){const N=new g;return c(N,O),c(N,_),this.sendBuffer(N.buffer)}sendBuffer(O){try{return this.protocol.send(O),O.byteLength}catch(_){return 0}}onBuffer(O){const _=new I(O),N=l(_),W=l(_),V=N[0];switch(V){case 200:return this.logger&&this.logger.logIncoming(O.byteLength,0,0,D(V)),this.onResponse({type:N[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(O.byteLength,N[1],0,D(V),W),this.onResponse({type:N[0],id:N[1],data:W})}}onResponse(O){if(O.type===200){this.state=b.Idle,this._onDidInitialize.fire();return}const _=this.handlers.get(O.id);_&&_(O)}get onDidInitializePromise(){return y.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===b.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(O=>O.dispose()),this.activeRequests.clear()}}de([m.memoize],w.prototype,"onDidInitializePromise",null),e.ChannelClient=w;class d{constructor(O){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new y.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new y.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,O(({protocol:_,onDidClientDisconnect:N})=>{y.Event.once(_.onMessage)(V=>{const Q=new I(V),X=l(Q),ie=new u(_,X),ne=new w(_);this.channels.forEach((le,ve)=>ie.registerChannel(ve,le));const ce={channelServer:ie,channelClient:ne,ctx:X};this._connections.add(ce),this._onDidAddConnection.fire(ce),N(()=>{ie.dispose(),ne.dispose(),this._connections.delete(ce),this._onDidRemoveConnection.fire(ce)})})})}get connections(){const O=[];return this._connections.forEach(_=>O.push(_)),O}getChannel(O,_){const N=this;return{call(W,V,Q){let X;if((0,S.isFunction)(_)){let ne=(0,p.getRandomElement)(N.connections.filter(_));X=ne?Promise.resolve(ne):y.Event.toPromise(y.Event.filter(N.onDidAddConnection,_))}else X=_.routeCall(N,W,V);const ie=X.then(ne=>ne.channelClient.getChannel(O));return F(ie).call(W,V,Q)},listen(W,V){if((0,S.isFunction)(_))return N.getMulticastEvent(O,_,W,V);const Q=_.routeEvent(N,W,V).then(X=>X.channelClient.getChannel(O));return F(Q).listen(W,V)}}}getMulticastEvent(O,_,N,W){const V=this;let Q=new P.DisposableStore;const X=new y.Emitter({onFirstListenerAdd:()=>{Q=new P.DisposableStore;const ie=new y.EventMultiplexer,ne=new Map,ce=ve=>{const Ce=ve.channelClient.getChannel(O).listen(N,W),Ae=ie.add(Ce);ne.set(ve,Ae)},le=ve=>{const pe=ne.get(ve);!pe||(pe.dispose(),ne.delete(ve))};V.connections.filter(_).forEach(ce),y.Event.filter(V.onDidAddConnection,_)(ce,void 0,Q),V.onDidRemoveConnection(le,void 0,Q),ie.event(X.fire,X,Q),Q.add(ie)},onLastListenerRemove:()=>{Q.dispose()}});return X.event}registerChannel(O,_){this.channels.set(O,_),this._connections.forEach(N=>{N.channelServer.registerChannel(O,_)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=d;class T{constructor(O,_,N=null){const W=new g;c(W,_),O.send(W.buffer),this.channelClient=new w(O,N),this.channelServer=new u(O,_,N)}getChannel(O){return this.channelClient.getChannel(O)}registerChannel(O,_){this.channelServer.registerChannel(O,_)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=T;function F(U){return{call(O,_,N){return U.then(W=>W.call(O,_,N))},listen(O,_){const N=new y.Relay;return U.then(W=>N.input=W.listen(O,_)),N.event}}}e.getDelayedChannel=F;function z(U){let O=!1;return{call(_,N,W){return O?U.call(_,N,W):(0,L.timeout)(0).then(()=>O=!0).then(()=>U.call(_,N,W))},listen(_,N){if(O)return U.listen(_,N);const W=new y.Relay;return(0,L.timeout)(0).then(()=>O=!0).then(()=>W.input=U.listen(_,N)),W.event}}}e.getNextTickChannel=z;class B{constructor(O){this.fn=O}routeCall(O){return this.route(O)}routeEvent(O){return this.route(O)}async route(O){for(const _ of O.connections)if(await Promise.resolve(this.fn(_.ctx)))return Promise.resolve(_);return await y.Event.toPromise(O.onDidAddConnection),await this.route(O)}}e.StaticRouter=B;var K;(function(U){function O(W,V){const Q=W,X=V&&V.disableMarshalling,ie=new Map;for(const ne in Q)N(ne)&&ie.set(ne,y.Event.buffer(Q[ne],!0));return new class{listen(ne,ce){const le=ie.get(ce);if(le)return le;throw new Error(`Event not found: ${ce}`)}call(ne,ce,le){const ve=Q[ce];if(typeof ve=="function"){if(!X&&Array.isArray(le))for(let pe=0;pe<le.length;pe++)le[pe]=(0,n.revive)(le[pe]);return ve.apply(Q,le)}throw new Error(`Method not found: ${ce}`)}}}U.fromService=O;function _(W,V){const Q=V&&V.disableMarshalling;return new Proxy({},{get(X,ie){var ne;if(typeof ie=="string")return((ne=V==null?void 0:V.properties)===null||ne===void 0?void 0:ne.has(ie))?V.properties.get(ie):N(ie)?W.listen(ie):async function(...ce){let le;V&&!(0,S.isUndefinedOrNull)(V.context)?le=[V.context,...ce]:le=ce;const ve=await W.call(ie,le);return Q?ve:(0,n.revive)(ve)};throw new Error(`Property not found: ${String(ie)}`)}})}U.toService=_;function N(W){return W[0]==="o"&&W[1]==="n"&&f.isUpperAsciiLetter(W.charCodeAt(2))}})(K=e.ProxyChannel||(e.ProxyChannel={}));const j=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function H(U){if(Array.isArray(U))return U;if(U&&typeof U=="object"&&typeof U.toString=="function"){let O=U.toString();if(O!=="[object Object]")return O}return U}function q(U){return Array.isArray(U)?U.map(H):H(U)}function $(U,O,_,N,W,V,Q){Q=q(Q);const X=j[W],ie=X[N%X.length];let ne=[`%c[${U}]%c[${String(O).padStart(7," ")}]%c[len: ${String(_).padStart(5," ")}]%c${String(N).padStart(5," ")} - ${V}`,"color: darkgreen","color: grey","color: grey",`color: ${ie}`];/\($/.test(V)?(ne=ne.concat(Q),ne.push(")")):ne.push(Q),console.log.apply(console,ne)}e.logWithColors=$;class M{constructor(O,_){this._outgoingPrefix=O,this._incomingPrefix=_,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(O,_,N,W,V){this._totalOutgoing+=O,$(this._outgoingPrefix,this._totalOutgoing,O,_,N,W,V)}logIncoming(O,_,N,W,V){this._totalIncoming+=O,$(this._incomingPrefix,this._totalIncoming,O,_,N,W,V)}}e.IPCLogger=M}),define(Z[98],ee([0,1,3,36,25]),function(G,e,y,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class k{constructor(p){this.port=p,this.onMessage=y.Event.fromDOMEventEmitter(this.port,"message",S=>L.VSBuffer.wrap(S.data)),p.start()}send(p){this.port.postMessage(p.buffer)}disconnect(){this.port.close()}}e.Protocol=k;class A extends P.IPCClient{constructor(p,S){const n=new k(p);super(n,S);this.protocol=n}dispose(){this.protocol.disconnect()}}e.Client=A}),define(Z[99],ee([0,1,100,3,36,98]),function(G,e,y,P,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;class A extends L.IPCServer{static getOnDidClientConnect(){const p=P.Event.fromNodeEventEmitter(y.ipcRenderer,"vscode:createMessageChannel",(S,n)=>n);return P.Event.map(p,S=>{const{port1:n,port2:f}=new MessageChannel,C={protocol:new k.Protocol(n),onDidClientDisconnect:P.Event.fromDOMEventEmitter(n,"close")};return y.ipcRenderer.postMessage("vscode:createMessageChannelResult",S,[f]),C})}constructor(){super(A.getOnDidClientConnect())}}e.Server=A}),define(Z[101],ee([0,1,11,25]),function(G,e,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.request=void 0;function L(R,p){R.proxyAuthorization&&(R.headers=Object.assign(Object.assign({},R.headers||{}),{"Proxy-Authorization":R.proxyAuthorization}));const S=new XMLHttpRequest;return new Promise((n,f)=>{S.open(R.type||"GET",R.url||"",!0,R.user,R.password),k(S,R),S.responseType="arraybuffer",S.onerror=m=>f(new Error(S.statusText&&"XHR failed: "+S.statusText||"XHR failed")),S.onload=m=>{n({res:{statusCode:S.status,headers:A(S)},stream:(0,P.bufferToStream)(P.VSBuffer.wrap(new Uint8Array(S.response)))})},S.ontimeout=m=>f(new Error(`XHR timeout: ${R.timeout}ms`)),R.timeout&&(S.timeout=R.timeout),S.send(R.data),p.onCancellationRequested(()=>{S.abort(),f((0,y.canceled)())})})}e.request=L;function k(R,p){if(p.headers){e:for(let S in p.headers){switch(S){case"User-Agent":case"Accept-Encoding":case"Content-Length":continue e}R.setRequestHeader(S,p.headers[S])}}}function A(R){const p=Object.create(null);for(const S of R.getAllResponseHeaders().split(/\r\n|\n|\r/g))if(S){const n=S.indexOf(":");p[S.substr(0,n).trim().toLowerCase()]=S.substr(n+1).trim()}return p}}),define(Z[69],ee([0,1,2,3,8,15]),function(G,e,y,P,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageHint=void 0;var A;(function(n){n[n.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(A=e.StorageHint||(e.StorageHint={}));var R;(function(n){n[n.None=0]="None",n[n.Initialized=1]="Initialized",n[n.Closed=2]="Closed"})(R||(R={}));class p extends y.Disposable{constructor(f,m=Object.create(null)){super();this.database=f,this.options=m,this._onDidChangeStorage=this._register(new P.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=R.None,this.cache=new Map,this.flushDelayer=new L.ThrottledDelayer(p.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(f=>this.onDidChangeItemsExternal(f)))}onDidChangeItemsExternal(f){var m,C;(m=f.changed)===null||m===void 0||m.forEach((h,E)=>this.accept(E,h)),(C=f.deleted)===null||C===void 0||C.forEach(h=>this.accept(h,void 0))}accept(f,m){if(this.state===R.Closed)return;let C=!1;(0,k.isUndefinedOrNull)(m)?C=this.cache.delete(f):this.cache.get(f)!==m&&(this.cache.set(f,m),C=!0),C&&this._onDidChangeStorage.fire(f)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===R.None&&(this.state=R.Initialized,this.options.hint!==A.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(f,m){const C=this.cache.get(f);return(0,k.isUndefinedOrNull)(C)?m:C}getBoolean(f,m){const C=this.get(f);return(0,k.isUndefinedOrNull)(C)?m:C==="true"}getNumber(f,m){const C=this.get(f);return(0,k.isUndefinedOrNull)(C)?m:parseInt(C,10)}async set(f,m){if(this.state===R.Closed)return;if((0,k.isUndefinedOrNull)(m))return this.delete(f);const C=String(m);if(this.cache.get(f)!==C)return this.cache.set(f,C),this.pendingInserts.set(f,C),this.pendingDeletes.delete(f),this._onDidChangeStorage.fire(f),this.flushDelayer.trigger(()=>this.flushPending())}async delete(f){if(!(this.state===R.Closed||!this.cache.delete(f)))return this.pendingDeletes.has(f)||this.pendingDeletes.add(f),this.pendingInserts.delete(f),this._onDidChangeStorage.fire(f),this.flushDelayer.trigger(()=>this.flushPending())}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=R.Closed;try{await this.flushDelayer.trigger(()=>this.flushPending(),0)}catch(f){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const f={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(f).finally(()=>{var m;if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)(m=this.whenFlushedCallbacks.pop())===null||m===void 0||m()})}async whenFlushed(){if(!!this.hasPending)return new Promise(f=>this.whenFlushedCallbacks.push(f))}dispose(){this.flushDelayer.cancel(),this.flushDelayer.dispose(),super.dispose()}}e.Storage=p,p.DEFAULT_FLUSH_DELAY=100;class S{constructor(){this.onDidChangeItemsExternal=P.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(f){f.insert&&f.insert.forEach((m,C)=>this.items.set(C,m)),f.delete&&f.delete.forEach(m=>this.items.delete(m))}async close(){}}e.InMemoryStorageDatabase=S}),define(Z[102],ee([12,13]),function(G,e){return G.create("vs/base/common/date",e)}),define(Z[55],ee([0,1,102]),function(G,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const P=60,L=P*60,k=L*24,A=k*7,R=k*30,p=k*365;function S(f,m){typeof f!="number"&&(f=f.getTime());const C=Math.round((new Date().getTime()-f)/1e3);if(C<-30)return(0,y.localize)(0,null,S(new Date().getTime()+C*1e3,!1));if(C<30)return(0,y.localize)(1,null);let h;return C<P?(h=C,m?h===1?(0,y.localize)(2,null,h):(0,y.localize)(3,null,h):h===1?(0,y.localize)(4,null,h):(0,y.localize)(5,null,h)):C<L?(h=Math.floor(C/P),m?h===1?(0,y.localize)(6,null,h):(0,y.localize)(7,null,h):h===1?(0,y.localize)(8,null,h):(0,y.localize)(9,null,h)):C<k?(h=Math.floor(C/L),m?h===1?(0,y.localize)(10,null,h):(0,y.localize)(11,null,h):h===1?(0,y.localize)(12,null,h):(0,y.localize)(13,null,h)):C<A?(h=Math.floor(C/k),m?h===1?(0,y.localize)(14,null,h):(0,y.localize)(15,null,h):h===1?(0,y.localize)(16,null,h):(0,y.localize)(17,null,h)):C<R?(h=Math.floor(C/A),m?h===1?(0,y.localize)(18,null,h):(0,y.localize)(19,null,h):h===1?(0,y.localize)(20,null,h):(0,y.localize)(21,null,h)):C<p?(h=Math.floor(C/R),m?h===1?(0,y.localize)(22,null,h):(0,y.localize)(23,null,h):h===1?(0,y.localize)(24,null,h):(0,y.localize)(25,null,h)):(h=Math.floor(C/p),m?h===1?(0,y.localize)(26,null,h):(0,y.localize)(27,null,h):h===1?(0,y.localize)(28,null,h):(0,y.localize)(29,null,h))}e.fromNow=S;function n(f){return f.getFullYear()+"-"+String(f.getMonth()+1).padStart(2,"0")+"-"+String(f.getDate()).padStart(2,"0")+"T"+String(f.getHours()).padStart(2,"0")+":"+String(f.getMinutes()).padStart(2,"0")+":"+String(f.getSeconds()).padStart(2,"0")+"."+(f.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=n}),define(Z[103],ee([12,13]),function(G,e){return G.create("vs/base/common/errorMessage",e)}),define(Z[44],ee([0,1,103,15,19]),function(G,e,y,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function k(S,n){return n&&(S.stack||S.stacktrace)?y.localize(0,null,R(S),A(S.stack)||A(S.stacktrace)):R(S)}function A(S){return Array.isArray(S)?S.join(`
`):S}function R(S){return typeof S.code=="string"&&typeof S.errno=="number"&&typeof S.syscall=="string"?y.localize(1,null,S.message):S.message||y.localize(2,null)}function p(S=null,n=!1){if(!S)return y.localize(3,null);if(Array.isArray(S)){const f=L.coalesce(S),m=p(f[0],n);return f.length>1?y.localize(4,null,m,f.length):m}if(P.isString(S))return S;if(S.detail){const f=S.detail;if(f.error)return k(f.error,n);if(f.exception)return k(f.exception,n)}return S.stack?k(S,n):S.message?S.message:y.localize(5,null)}e.toErrorMessage=p}),define(Z[104],ee([12,13]),function(G,e){return G.create("vs/base/node/processes",e)}),define(Z[105],ee([0,1,7,17,43,104,34,15,26,41,6,68,16]),function(G,e,y,P,L,k,A,R,p,S,n,f,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0;function C(a){switch(a){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function h(a,s){if(n.isWindows)try{const t={stdio:["pipe","pipe","ignore"]};s&&(t.cwd=s);const r=L.execFile("taskkill",["/T","/F","/PID",a.pid.toString()],t);return new Promise(i=>{r.once("error",o=>{i({success:!1,error:o})}),r.once("exit",(o,c)=>{i(o===0?{success:!0}:{success:!1,code:o!==null?o:1})})})}catch(t){return Promise.resolve({success:!1,error:t,code:t.status?C(t.status):1})}else if(n.isLinux||n.isMacintosh)try{const t=m.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",G).fsPath;return new Promise(r=>{L.execFile(t,[a.pid.toString()],{encoding:"utf8",shell:!0},(i,o,c)=>{r(i?{success:!1,error:i}:{success:!0})})})}catch(t){return Promise.resolve({success:!1,error:t})}else a.kill("SIGKILL");return Promise.resolve({success:!0})}function E(a=A.env){return a.comspec||"cmd.exe"}e.getWindowsShell=E;class D{constructor(s,t,r,i){if(t!==void 0&&r!==void 0&&i!==void 0)this.cmd=s,this.args=t,this.shell=r,this.options=i;else{const o=s;this.cmd=o.command,this.shell=o.isShellCommand,this.args=o.args.slice(0),this.options=o.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const o=Object.create(null);Object.keys(A.env).forEach(c=>{o[c]=A.env[c]}),Object.keys(this.options.env).forEach(c=>{o[c]=this.options.env[c]}),this.options.env=o}}getSanitizedCommand(){let s=this.cmd.toLowerCase();const t=s.lastIndexOf(y.sep);return t!==-1&&(s=s.substring(t+1)),D.WellKnowCommands[s]?s:"other"}start(s){return n.isWindows&&(this.options&&this.options.cwd&&S.isUNC(this.options.cwd)||!this.options&&S.isUNC(A.cwd()))?Promise.reject(new Error(k.localize(0,null))):this.useExec().then(t=>{let r,i;const o=new Promise((c,l)=>{r=c,i=l});if(t){let c=this.cmd;this.args&&(c=c+" "+this.args.join(" ")),this.childProcess=L.exec(c,this.options,(l,u,v)=>{this.childProcess=null;const w=l;w&&w.killed?i({killed:this.terminateRequested,stdout:u.toString(),stderr:v.toString()}):this.handleExec(r,s,l,u,v)})}else{let c=null;const l=u=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(u,r,s,i);const v={terminated:this.terminateRequested};R.isNumber(u)&&(v.cmdCode=u),r(v)};if(this.shell&&n.isWindows){const u=p.deepClone(this.options);u.windowsVerbatimArguments=!0,u.detached=!1;let v=!1,w=!1;const d=[];let T=this.ensureQuotes(this.cmd);d.push(T.value),v=T.quoted,this.args&&this.args.forEach(z=>{T=this.ensureQuotes(z),d.push(T.value),w=w&&T.quoted});const F=["/s","/c"];v?w?F.push('"'+d.join(" ")+'"'):d.length>1?F.push('"'+d[0]+'" '+d.slice(1).join(" ")):F.push('"'+d[0]+'"'):F.push(d.join(" ")),c=L.spawn(E(),F,u)}else this.cmd&&(c=L.spawn(this.cmd,this.args,this.options));c&&(this.childProcess=c,this.childProcessPromise=Promise.resolve(c),this.pidResolve&&(this.pidResolve(R.isNumber(c.pid)?c.pid:-1),this.pidResolve=void 0),c.on("error",u=>{this.childProcess=null,i({terminated:this.terminateRequested,error:u})}),c.pid&&(this.childProcess.on("close",l),this.handleSpawn(c,r,s,i,!0)))}return o})}handleClose(s,t,r,i){}ensureQuotes(s){return D.regexp.test(s)?{value:'"'+s+'"',quoted:!0}:{value:s,quoted:s.length>0&&s[0]==='"'&&s[s.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(s=>s.pid,s=>-1):new Promise(s=>{this.pidResolve=s})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(s=>(this.terminateRequested=!0,h(s,this.options.cwd).then(t=>(t.success&&(this.childProcess=null),t))),s=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(s=>{if(!this.shell||!n.isWindows)return s(!1);const t=L.spawn(E(),["/s","/c"]);t.on("error",r=>s(!0)),t.on("exit",r=>s(!1))})}}e.AbstractProcess=D,D.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},D.regexp=/^[^"].* .*[^"]/;class b extends D{constructor(s,t,r,i){super(s,t,r,i);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(s,t,r,i,o){[i,o].forEach((c,l)=>{const u=new f.LineDecoder;u.write(c).forEach(d=>{t({line:d,source:l===0?0:1})});const w=u.end();w&&t({line:w,source:l===0?0:1})}),s({terminated:this.terminateRequested,error:r})}handleSpawn(s,t,r,i,o){const c=new f.LineDecoder,l=new f.LineDecoder;s.stdout.on("data",u=>{c.write(u).forEach(w=>r({line:w,source:0}))}),s.stderr.on("data",u=>{l.write(u).forEach(w=>r({line:w,source:1}))}),this.stdoutLineDecoder=c,this.stderrLineDecoder=l}handleClose(s,t,r,i){const o=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;o&&r({line:o,source:0});const c=this.stderrLineDecoder?this.stderrLineDecoder.end():null;c&&r({line:c,source:1})}}e.LineProcess=b;function I(a){let s=[],t=!1;const r=function(i){if(t){s.push(i);return}(!a.send(i,c=>{if(c&&console.error(c),t=!1,s.length>0){const l=s.slice(0);s=[],l.forEach(u=>r(u))}})||n.isWindows)&&(t=!0)};return{send:r}}e.createQueuedSender=I;var g;(function(a){async function s(t,r,i){if(y.isAbsolute(t))return t;if(r===void 0&&(r=A.cwd()),y.dirname(t)!=="."||(i===void 0&&R.isString(A.env.PATH)&&(i=A.env.PATH.split(y.delimiter)),i===void 0||i.length===0))return y.join(r,t);async function c(l){return await P.exists(l)?!(await P.Promises.stat(l)).isDirectory():!1}for(let l of i){let u;if(y.isAbsolute(l)?u=y.join(l,t):u=y.join(r,l,t),await c(u))return u;let v=u+".com";if(await c(v)||(v=u+".exe",await c(v)))return v}return y.join(r,t)}a.findExecutable=s})(g=e.win32||(e.win32={}))}),define(Z[49],ee([0,1,43,2,8,26,3,105,36,88,29,11,25,6]),function(G,e,y,P,L,k,A,R,p,S,n,f,m,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class h extends p.ChannelServer{constructor(b){super({send:I=>{try{process.send&&process.send(I.buffer.toString("base64"))}catch(g){}},onMessage:A.Event.fromNodeEventEmitter(process,"message",I=>m.VSBuffer.wrap(Buffer.from(I,"base64")))},b);process.once("disconnect",()=>this.dispose())}}e.Server=h;class E{constructor(b,I){this.modulePath=b,this.options=I,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new A.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const g=I&&I.timeout?I.timeout:6e4;this.disposeDelayer=new L.Delayer(g),this.child=null,this._client=null}getChannel(b){const I=this;return{call(g,a,s){return I.requestPromise(b,g,a,s)},listen(g,a){return I.requestEvent(b,g,a)}}}requestPromise(b,I,g,a=n.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(a.isCancellationRequested)return Promise.reject(f.canceled());this.disposeDelayer.cancel();const s=this.getCachedChannel(b),t=(0,L.createCancelablePromise)(o=>s.call(I,g,o)),r=a.onCancellationRequested(()=>t.cancel()),i=(0,P.toDisposable)(()=>t.cancel());return this.activeRequests.add(i),t.finally(()=>{r.dispose(),this.activeRequests.delete(i),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),t}requestEvent(b,I,g){if(!this.disposeDelayer)return A.Event.None;this.disposeDelayer.cancel();let a;const s=new A.Emitter({onFirstListenerAdd:()=>{a=this.getCachedChannel(b).listen(I,g)(s.fire,s),this.activeRequests.add(a)},onLastListenerRemove:()=>{this.activeRequests.delete(a),a.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return s.event}get client(){if(!this._client){const b=this.options&&this.options.args?this.options.args:[],I=Object.create(null);I.env=Object.assign(Object.assign({},(0,k.deepClone)(process.env)),{VSCODE_PARENT_PID:String(process.pid)}),this.options&&this.options.env&&(I.env=Object.assign(Object.assign({},I.env),this.options.env)),this.options&&this.options.freshExecArgv&&(I.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(I.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(I.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),I.execArgv===void 0&&(I.execArgv=process.execArgv.filter(c=>!/^--inspect(-brk)?=/.test(c))),C.isMacintosh&&I.env&&delete I.env.DYLD_LIBRARY_PATH,this.child=(0,y.fork)(this.modulePath,b,I);const g=new A.Emitter;A.Event.fromNodeEventEmitter(this.child,"message",c=>c)(c=>{if((0,S.isRemoteConsoleLog)(c)){(0,S.log)(c,`IPC Library: ${this.options.serverName}`);return}g.fire(m.VSBuffer.wrap(Buffer.from(c,"base64")))});const s=this.options.useQueue?(0,R.createQueuedSender)(this.child):this.child,t=c=>this.child&&this.child.connected&&s.send(c.buffer.toString("base64")),r=g.event,i={send:t,onMessage:r};this._client=new p.ChannelClient(i);const o=()=>this.disposeClient();process.once("exit",o),this.child.on("error",c=>console.warn('IPC "'+this.options.serverName+'" errored with '+c)),this.child.on("exit",(c,l)=>{process.removeListener("exit",o),this.activeRequests.forEach(u=>(0,P.dispose)(u)),this.activeRequests.clear(),c!==0&&l!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+c+" and signal "+l),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:c,signal:l})})}return this._client}getCachedChannel(b){let I=this.channels.get(b);return I||(I=this.client.getChannel(b),this.channels.set(b,I)),I}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=E}),define(Z[106],ee([12,13]),function(G,e){return G.create("vs/base/node/zip",e)}),define(Z[107],ee([12,13]),function(G,e){return G.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Z[108],ee([12,13]),function(G,e){return G.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Z[109],ee([12,13]),function(G,e){return G.create("vs/platform/extensionManagement/electron-sandbox/extensionTipsService",e)}),define(Z[110],ee([12,13]),function(G,e){return G.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(Z[111],ee([12,13]),function(G,e){return G.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(Z[112],ee([12,13]),function(G,e){return G.create("vs/platform/extensionManagement/node/extensionsScanner",e)}),define(Z[113],ee([12,13]),function(G,e){return G.create("vs/platform/extensions/common/extensionValidator",e)}),define(Z[114],ee([12,13]),function(G,e){return G.create("vs/platform/files/common/fileService",e)}),define(Z[115],ee([12,13]),function(G,e){return G.create("vs/platform/files/common/files",e)}),define(Z[116],ee([12,13]),function(G,e){return G.create("vs/platform/files/common/io",e)}),define(Z[117],ee([12,13]),function(G,e){return G.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(Z[118],ee([12,13]),function(G,e){return G.create("vs/platform/request/common/request",e)}),define(Z[119],ee([12,13]),function(G,e){return G.create("vs/platform/telemetry/common/telemetryService",e)}),define(Z[120],ee([12,13]),function(G,e){return G.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(Z[121],ee([12,13]),function(G,e){return G.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(Z[122],ee([12,13]),function(G,e){return G.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(Z[123],ee([12,13]),function(G,e){return G.create("vs/platform/userDataSync/common/settingsSync",e)}),define(Z[124],ee([12,13]),function(G,e){return G.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(Z[125],ee([12,13]),function(G,e){return G.create("vs/platform/userDataSync/common/userDataSync",e)}),define(Z[126],ee([12,13]),function(G,e){return G.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(Z[127],ee([0,1,7,14,64,55,16,5,34]),function(G,e,y,P,L,k,A,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class S{constructor(h,E,D){this._args=h,this.paths=E,this.productService=D}get appRoot(){return(0,y.dirname)(A.FileAccess.asFileUri("",G).fsPath)}get userHome(){return R.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return R.URI.file((0,y.join)(this.userDataPath,"User"))}get tmpDir(){return R.URI.file(this.paths.tmpDir)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,P.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,P.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const h=(0,k.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,y.join)(this.userDataPath,"logs",h)}return this.args.logsPath}get userDataSyncLogResource(){return R.URI.file((0,y.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,P.joinPath)(R.URI.file((0,y.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return R.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return R.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,P.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,P.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const h=p.env.VSCODE_PORTABLE;return h?R.URI.file((0,y.join)(h,"argv.json")):(0,P.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,P.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return R.URI.file((0,y.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,y.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const h=this.args["builtin-extensions-dir"];return h?(0,y.resolve)(h):(0,y.normalize)((0,y.join)(A.FileAccess.asFileUri("",G).fsPath,"..","extensions"))}get extensionsDownloadPath(){const h=this.args["extensions-download-dir"];return h?(0,y.resolve)(h):(0,y.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const h=this.args["extensions-dir"];if(h)return(0,y.resolve)(h);const E=p.env.VSCODE_EXTENSIONS;if(E)return E;const D=p.env.VSCODE_PORTABLE;return D?(0,y.join)(D,"extensions"):(0,P.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const h=this.args.extensionDevelopmentPath;if(Array.isArray(h))return h.map(E=>/^[^:/?#]+?:\/\//.test(E)?R.URI.parse(E):R.URI.file((0,y.normalize)(E)))}get extensionDevelopmentKind(){var h;return(h=this.args.extensionDevelopmentKind)===null||h===void 0?void 0:h.map(E=>E==="ui"||E==="workspace"||E==="web"?E:"workspace")}get extensionTestsLocationURI(){const h=this.args.extensionTestsPath;if(h)return/^[^:/?#]+?:\/\//.test(h)?R.URI.parse(h):R.URI.file((0,y.normalize)(h))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const h=this.args["disable-extension"];if(h){if(typeof h=="string")return[h];if(Array.isArray(h)&&h.length>0)return h}return!1}get debugExtensionHost(){return n(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!p.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,P.joinPath)(R.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return R.URI.file((0,y.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get args(){return this._args}}de([L.memoize],S.prototype,"appRoot",null),de([L.memoize],S.prototype,"userHome",null),de([L.memoize],S.prototype,"userDataPath",null),de([L.memoize],S.prototype,"appSettingsHome",null),de([L.memoize],S.prototype,"tmpDir",null),de([L.memoize],S.prototype,"userRoamingDataHome",null),de([L.memoize],S.prototype,"settingsResource",null),de([L.memoize],S.prototype,"userDataSyncHome",null),de([L.memoize],S.prototype,"userDataSyncLogResource",null),de([L.memoize],S.prototype,"sync",null),de([L.memoize],S.prototype,"machineSettingsResource",null),de([L.memoize],S.prototype,"globalStorageHome",null),de([L.memoize],S.prototype,"workspaceStorageHome",null),de([L.memoize],S.prototype,"keybindingsResource",null),de([L.memoize],S.prototype,"keyboardLayoutResource",null),de([L.memoize],S.prototype,"argvResource",null),de([L.memoize],S.prototype,"snippetsHome",null),de([L.memoize],S.prototype,"isExtensionDevelopment",null),de([L.memoize],S.prototype,"untitledWorkspacesHome",null),de([L.memoize],S.prototype,"installSourcePath",null),de([L.memoize],S.prototype,"builtinExtensionsPath",null),de([L.memoize],S.prototype,"extensionsPath",null),de([L.memoize],S.prototype,"extensionDevelopmentLocationURI",null),de([L.memoize],S.prototype,"extensionDevelopmentKind",null),de([L.memoize],S.prototype,"extensionTestsLocationURI",null),de([L.memoize],S.prototype,"debugExtensionHost",null),de([L.memoize],S.prototype,"serviceMachineIdResource",null),de([L.memoize],S.prototype,"telemetryLogResource",null),e.AbstractNativeEnvironmentService=S;function n(C,h){return m(C["inspect-extensions"],C["inspect-brk-extensions"],5870,h,C.debugId)}e.parseExtensionHostPort=n;function f(C,h){return m(C["inspect-search"],C["inspect-brk-search"],5876,h)}e.parseSearchPort=f;function m(C,h,E,D,b){const g=Number(h||C)||(D?null:E),a=g?Boolean(!!h):!1;return{port:g,break:a,debugId:b}}}),function(){"use strict";function G(e,y,P,L){function k(R){const p=A(R),S=[p];return e.isAbsolute(p)||S.unshift(L),e.resolve(...S)}function A(R){const p=process.env.VSCODE_PORTABLE;if(p)return e.join(p,"user-data");const S=R["user-data-dir"];if(S)return S;let n=process.env.VSCODE_APPDATA;if(!n)switch(process.platform){case"win32":if(n=process.env.APPDATA,!n){const f=process.env.USERPROFILE;if(typeof f!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");n=e.join(f,"AppData","Roaming")}break;case"darwin":n=e.join(y.homedir(),"Library","Application Support");break;case"linux":n=process.env.XDG_CONFIG_HOME||e.join(y.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(n,P)}return{getUserDataPath:k}}if(typeof define=="function")define(Z[128],ee([0,208,35,16,14,34]),function(e,y,P,L,k,A){const R=k.dirname(L.FileAccess.asFileUri("",e)),p=e.__$__nodeRequire(k.joinPath(R,"package.json").fsPath);return G(y,P,p.name,A.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),y=require("path"),P=require("os");module.exports=G(y,P,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(Z[129],ee([0,1,35,128,127]),function(G,e,y,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class k extends L.AbstractNativeEnvironmentService{constructor(R,p){super(R,{homeDir:(0,y.homedir)(),tmpDir:(0,y.tmpdir)(),userDataDir:(0,P.getUserDataPath)(R)},p)}}e.NativeEnvironmentService=k}),define(Z[130],ee([0,1,5]),function(G,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemotes=e.getDomainsOfRemotes=e.AllowedSecondLevelDomains=void 0;const P=/^([^@:]+@)?([^:]+):/,L=/^([^@:]+@)?([^:]+):(.+)$/,k=/^([^@]+@)?([^:]+)(:\d+)?$/,A=/([^@:.]+\.[^@:.]+)(:\d+)?$/,R=/^\s*url\s*=\s*(.+\S)\s*$/mg,p=/[^.]/g;e.AllowedSecondLevelDomains=["github.com","bitbucket.org","visualstudio.com","gitlab.com","heroku.com","azurewebsites.net","ibm.com","amazon.com","amazonaws.com","cloudapp.net","rhcloud.com","google.com","azure.com"];function S(D){const b=D.match(A);return b?b[1]:null}function n(D){if(D.indexOf("://")===-1){const b=D.match(P);return b?S(b[2]):null}try{const b=y.URI.parse(D);if(b.authority)return S(b.authority)}catch(b){}return null}function f(D,b){const I=new Set;let g;for(;g=R.exec(D);){const s=n(g[1]);s&&I.add(s)}const a=new Set(b);return Array.from(I).map(s=>a.has(s)?s:s.replace(p,"a"))}e.getDomainsOfRemotes=f;function m(D){const b=D.match(k);return b?b[2]:null}function C(D,b,I){return D&&b?(I&&b.endsWith(".git")&&(b=b.substr(0,b.length-4)),b.indexOf("/")===0?`${D}${b}`:`${D}/${b}`):null}function h(D,b){if(D.indexOf("://")===-1){const I=D.match(L);if(I)return C(I[2],I[3],b)}try{const I=y.URI.parse(D);if(I.authority)return C(m(I.authority),I.path,b)}catch(I){}return null}function E(D,b=!1){const I=[];let g;for(;g=R.exec(D);){const a=h(g[1],b);a&&I.push(a)}return I}e.getRemotes=E}),define(Z[131],ee([0,1,3,5,91,26,2]),function(G,e,y,P,L,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function R(h,E){return P.URI.revive(E?E.transformIncoming(h):h)}function p(h,E){return E?E.transformOutgoingURI(h):h}function S(h,E){E=E||L.DefaultURITransformer;const D=h.manifest,b=(0,L.transformAndReviveIncomingURIs)(Object.assign(Object.assign({},h),{manifest:void 0}),E);return Object.assign(Object.assign({},b),{manifest:D})}function n(h,E){return E?(0,k.cloneAndChange)(h,D=>D instanceof P.URI?E.transformOutgoingURI(D):void 0):h}class f{constructor(E,D){this.service=E,this.getUriTransformer=D,this.onInstallExtension=y.Event.buffer(E.onInstallExtension,!0),this.onDidInstallExtension=y.Event.buffer(E.onDidInstallExtension,!0),this.onUninstallExtension=y.Event.buffer(E.onUninstallExtension,!0),this.onDidUninstallExtension=y.Event.buffer(E.onDidUninstallExtension,!0)}listen(E,D){const b=this.getUriTransformer(E);switch(D){case"onInstallExtension":return this.onInstallExtension;case"onDidInstallExtension":return y.Event.map(this.onDidInstallExtension,I=>Object.assign(Object.assign({},I),{local:I.local?n(I.local,b):I.local}));case"onUninstallExtension":return this.onUninstallExtension;case"onDidUninstallExtension":return this.onDidUninstallExtension}throw new Error("Invalid listen")}call(E,D,b){const I=this.getUriTransformer(E);switch(D){case"zip":return this.service.zip(S(b[0],I)).then(g=>p(g,I));case"unzip":return this.service.unzip(R(b[0],I));case"install":return this.service.install(R(b[0],I));case"getManifest":return this.service.getManifest(R(b[0],I));case"canInstall":return this.service.canInstall(b[0]);case"installFromGallery":return this.service.installFromGallery(b[0],b[1]);case"uninstall":return this.service.uninstall(S(b[0],I),b[1]);case"reinstallFromGallery":return this.service.reinstallFromGallery(S(b[0],I));case"getInstalled":return this.service.getInstalled(b[0]).then(g=>g.map(a=>n(a,I)));case"updateMetadata":return this.service.updateMetadata(S(b[0],I),b[1]).then(g=>n(g,I));case"updateExtensionScope":return this.service.updateExtensionScope(S(b[0],I),b[1]).then(g=>n(g,I));case"getExtensionsReport":return this.service.getExtensionsReport()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=f;class m extends A.Disposable{constructor(E){super();this.channel=E,this._onInstallExtension=this._register(new y.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtension=this._register(new y.Emitter),this.onDidInstallExtension=this._onDidInstallExtension.event,this._onUninstallExtension=this._register(new y.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new y.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this._register(this.channel.listen("onInstallExtension")(D=>this._onInstallExtension.fire(D))),this._register(this.channel.listen("onDidInstallExtension")(D=>this._onDidInstallExtension.fire(Object.assign(Object.assign({},D),{local:D.local?S(D.local,null):D.local})))),this._register(this.channel.listen("onUninstallExtension")(D=>this._onUninstallExtension.fire(D))),this._register(this.channel.listen("onDidUninstallExtension")(D=>this._onDidUninstallExtension.fire(D)))}zip(E){return Promise.resolve(this.channel.call("zip",[E]).then(D=>P.URI.revive(D)))}unzip(E){return Promise.resolve(this.channel.call("unzip",[E]))}install(E){return Promise.resolve(this.channel.call("install",[E])).then(D=>S(D,null))}getManifest(E){return Promise.resolve(this.channel.call("getManifest",[E]))}async canInstall(E){return!0}installFromGallery(E,D){return Promise.resolve(this.channel.call("installFromGallery",[E,D])).then(b=>S(b,null))}uninstall(E,D){return Promise.resolve(this.channel.call("uninstall",[E,D]))}reinstallFromGallery(E){return Promise.resolve(this.channel.call("reinstallFromGallery",[E]))}getInstalled(E=null){return Promise.resolve(this.channel.call("getInstalled",[E])).then(D=>D.map(b=>S(b,null)))}updateMetadata(E,D){return Promise.resolve(this.channel.call("updateMetadata",[E,D])).then(b=>S(b,null))}updateExtensionScope(E,D){return Promise.resolve(this.channel.call("updateExtensionScope",[E,D])).then(b=>S(b,null))}getExtensionsReport(){return Promise.resolve(this.channel.call("getExtensionsReport"))}}e.ExtensionManagementChannelClient=m;class C{constructor(E){this.service=E}listen(E,D){throw new Error("Invalid listen")}call(E,D,b){switch(D){case"getConfigBasedTips":return this.service.getConfigBasedTips(P.URI.revive(b[0]));case"getImportantExecutableBasedTips":return this.service.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.service.getOtherExecutableBasedTips();case"getAllWorkspacesTips":return this.service.getAllWorkspacesTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=C}),define(Z[132],ee([0,1,26]),function(G,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;const P=/^%([\w\d.-]+)%$/i;function L(k,A){const R=p=>{if(typeof p!="string")return;const S=P.exec(p);if(!!S)return A[S[1]]||p};return(0,y.cloneAndChange)(k,R)}e.localizeManifest=L}),define(Z[133],ee([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionRecommendationNotificationServiceChannel=e.ExtensionRecommendationNotificationServiceChannelClient=void 0;class y{constructor(k){this.channel=k}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(k,A,R,p){return this.channel.call("promptImportantExtensionsInstallNotification",[k,A,R,p])}promptWorkspaceRecommendations(k){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.ExtensionRecommendationNotificationServiceChannelClient=y;class P{constructor(k){this.service=k}listen(k,A){throw new Error(`Event not found: ${A}`)}call(k,A,R){switch(A){case"promptImportantExtensionsInstallNotification":return this.service.promptImportantExtensionsInstallNotification(R[0],R[1],R[2],R[3])}throw new Error(`Call not found: ${A}`)}}e.ExtensionRecommendationNotificationServiceChannel=P}),define(Z[70],ee([0,1,113]),function(G,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const P=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,L=/^-(\d{4})(\d{2})(\d{2})$/;function k(m){return m=m.trim(),m==="*"||P.test(m)}e.isValidVersionStr=k;function A(m){if(!k(m))return null;if(m=m.trim(),m==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let C=m.match(P);return C?{hasCaret:C[1]==="^",hasGreaterEquals:C[1]===">=",majorBase:C[2]==="x"?0:parseInt(C[2],10),majorMustEqual:C[2]!=="x",minorBase:C[4]==="x"?0:parseInt(C[4],10),minorMustEqual:C[4]!=="x",patchBase:C[6]==="x"?0:parseInt(C[6],10),patchMustEqual:C[6]!=="x",preRelease:C[8]||null}:null}e.parseVersion=A;function R(m){if(!m)return null;let C=m.majorBase,h=m.majorMustEqual,E=m.minorBase,D=m.minorMustEqual,b=m.patchBase,I=m.patchMustEqual;m.hasCaret&&(C===0||(D=!1),I=!1);let g=0;if(m.preRelease){const a=L.exec(m.preRelease);if(a){const[,s,t,r]=a;g=Date.UTC(Number(s),Number(t)-1,Number(r))}}return{majorBase:C,majorMustEqual:h,minorBase:E,minorMustEqual:D,patchBase:b,patchMustEqual:I,isMinimum:m.hasGreaterEquals,notBefore:g}}e.normalizeVersion=R;function p(m,C,h){let E;typeof m=="string"?E=R(A(m)):E=m;let D;C instanceof Date?D=C.getTime():typeof C=="string"&&(D=new Date(C).getTime());let b;if(typeof h=="string"?b=R(A(h)):b=h,!E||!b)return!1;let I=E.majorBase,g=E.minorBase,a=E.patchBase,s=b.majorBase,t=b.minorBase,r=b.patchBase,i=b.notBefore,o=b.majorMustEqual,c=b.minorMustEqual,l=b.patchMustEqual;return b.isMinimum?I>s?!0:I<s?!1:g>t?!0:g<t||D&&D<i?!1:a>=r:(I===1&&s===0&&(!o||!c||!l)&&(s=1,t=0,r=0,o=!0,c=!1,l=!1),I<s?!1:I>s?!o:g<t?!1:g>t?!c:a<r?!1:a>r?!l:!(D&&D<i))}e.isValidVersion=p;function S(m,C,h,E){return h.isBuiltin||typeof h.main=="undefined"?!0:f(m,C,h.engines.vscode,E)}e.isValidExtensionVersion=S;function n(m,C,h){return m==="*"||f(C,h,m)}e.isEngineValid=n;function f(m,C,h,E=[]){let D=R(A(h));if(!D)return E.push(y.localize(0,null,h)),!1;if(D.majorBase===0){if(!D.majorMustEqual||!D.minorMustEqual)return E.push(y.localize(1,null,h)),!1}else if(!D.majorMustEqual)return E.push(y.localize(2,null,h)),!1;return p(m,C,D)?!0:(E.push(y.localize(3,null,m,h)),!1)}}),define(Z[134],ee([0,1,36,49,2,16]),function(G,e,y,P,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class A extends L.Disposable{constructor(p,S,n,f){super();this.folders=p,this.onDidFilesChange=S,this.onLogMessage=n,this.verboseLogging=f,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const p=this._register(new P.Client(k.FileAccess.asFileUri("bootstrap-fork",G).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(p.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=A.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=y.ProxyChannel.toService((0,y.getNextTickChannel)(p.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(S=>!this.isDisposed&&this.onDidFilesChange(S))),this._register(this.service.onDidLogMessage(S=>this.onLogMessage(S))),this.setFolders(this.folders)}setVerboseLogging(p){this.verboseLogging=p,!this.isDisposed&&this.service&&this.service.setVerboseLogging(p)}error(p){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${p}`})}setFolders(p){this.folders=p,this.service&&this.service.setRoots(p)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=A,A.MAX_RESTARTS=5}),define(Z[135],ee([0,1,36,49,2,16]),function(G,e,y,P,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class A extends L.Disposable{constructor(p,S,n,f,m={}){super();this.folders=p,this.onDidFilesChange=S,this.onLogMessage=n,this.verboseLogging=f,this.watcherOptions=m,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const p=this._register(new P.Client(k.FileAccess.asFileUri("bootstrap-fork",G).fsPath,{serverName:"File Watcher (chokidar)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/unix/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(p.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=A.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=y.ProxyChannel.toService((0,y.getNextTickChannel)(p.getChannel("watcher"))),this.service.init(Object.assign(Object.assign({},this.watcherOptions),{verboseLogging:this.verboseLogging})),this._register(this.service.onDidChangeFile(S=>!this.isDisposed&&this.onDidFilesChange(S))),this._register(this.service.onDidLogMessage(S=>this.onLogMessage(S))),this.service.setRoots(this.folders)}error(p){this.onLogMessage({type:"error",message:`[File Watcher (chokidar)] ${p}`})}setVerboseLogging(p){this.verboseLogging=p,this.service&&this.service.setVerboseLogging(p)}setFolders(p){this.folders=p,this.service&&this.service.setRoots(p)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=A,A.MAX_RESTARTS=5}),define(Z[136],ee([0,1,43,68,90,16]),function(G,e,y,P,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutOfProcessWin32FolderWatcher=void 0;class A{constructor(p,S,n,f,m){this.watchedFolder=p,this.eventCallback=n,this.logCallback=f,this.verboseLogging=m,this.restartCounter=0,Array.isArray(S)?this.ignored=S.map(C=>L.parse(C)):this.ignored=[],this.verboseLogging&&this.log(`Start watching: ${p}`),this.startWatcher()}startWatcher(){const p=[this.watchedFolder];this.verboseLogging&&p.push("-verbose"),this.handle=y.spawn(k.FileAccess.asFileUri("vs/platform/files/node/watcher/win32/CodeHelper.exe",G).fsPath,p);const S=new P.LineDecoder;this.handle.stdout.on("data",n=>{const f=[];S.write(n).forEach(m=>{const C=m.split("|");if(C.length===2){const h=Number(C[0]),E=C[1];if(h>=0&&h<3){if(this.ignored&&this.ignored.some(D=>D(E))){this.verboseLogging&&this.log(E);return}f.push({type:A.changeTypeMap[h],path:E})}else this.log(C[1])}}),f.length>0&&this.eventCallback(f)}),this.handle.on("error",n=>this.onError(n)),this.handle.stderr.on("data",n=>this.onError(n)),this.handle.on("exit",(n,f)=>this.onExit(n,f))}onError(p){this.error("process error: "+p.toString())}onExit(p,S){this.handle&&(this.error(`terminated unexpectedly (code: ${p}, signal: ${S})`),this.restartCounter<=A.MAX_RESTARTS?(this.error("is restarted again..."),this.restartCounter++,this.startWatcher()):this.error("Watcher failed to start after retrying for some time, giving up. Please report this as a bug report!"))}error(p){this.logCallback({type:"error",message:`[File Watcher (C#)] ${p}`})}log(p){this.logCallback({type:"trace",message:`[File Watcher (C#)] ${p}`})}dispose(){this.handle&&(this.handle.kill(),this.handle=void 0)}}e.OutOfProcessWin32FolderWatcher=A,A.MAX_RESTARTS=5,A.changeTypeMap=[0,1,2]}),define(Z[137],ee([0,1,136,7,22]),function(G,e,y,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class k{constructor(R,p,S,n){this.onDidFilesChange=p,this.onLogMessage=S,this.verboseLogging=n,this.service=void 0,this.folder=R[0],this.folder.path.indexOf("\\\\")===0&&this.folder.path.endsWith(P.posix.sep)&&(this.folder.path=(0,L.rtrim)(this.folder.path,P.posix.sep)),this.service=this.startWatching()}get isDisposed(){return!this.service}startWatching(){return new y.OutOfProcessWin32FolderWatcher(this.folder.path,this.folder.excludes,R=>this.onFileEvents(R),R=>this.onLogMessage(R),this.verboseLogging)}setVerboseLogging(R){this.verboseLogging=R,this.service&&(this.service.dispose(),this.service=this.startWatching())}onFileEvents(R){this.isDisposed||R.length>0&&this.onDidFilesChange(R)}dispose(){this.service&&(this.service.dispose(),this.service=void 0)}}e.FileWatcher=k}),define(Z[50],ee([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSyncDescriptor=e.SyncDescriptor=void 0;class y{constructor(k,A=[],R=!1){this.ctor=k,this.staticArguments=A,this.supportsDelayedInstantiation=R}}e.SyncDescriptor=y;const P=(L,...k)=>new y(L,k);e.createSyncDescriptor=P}),define(Z[138],ee([0,1,50]),function(G,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const P=[];function L(A,R,p){R instanceof y.SyncDescriptor||(R=new y.SyncDescriptor(R,[],p)),P.push([A,R])}e.registerSingleton=L;function k(){return P}e.getSingletonServiceDescriptors=k}),define(Z[139],ee([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class y{constructor(k){this.incoming=new Map,this.outgoing=new Map,this.data=k}}e.Node=y;class P{constructor(k){this._hashFn=k,this._nodes=new Map}roots(){const k=[];for(let A of this._nodes.values())A.outgoing.size===0&&k.push(A);return k}insertEdge(k,A){const R=this.lookupOrInsertNode(k),p=this.lookupOrInsertNode(A);R.outgoing.set(this._hashFn(A),p),p.incoming.set(this._hashFn(k),R)}removeNode(k){const A=this._hashFn(k);this._nodes.delete(A);for(let R of this._nodes.values())R.outgoing.delete(A),R.incoming.delete(A)}lookupOrInsertNode(k){const A=this._hashFn(k);let R=this._nodes.get(A);return R||(R=new y(k),this._nodes.set(A,R)),R}lookup(k){return this._nodes.get(this._hashFn(k))}isEmpty(){return this._nodes.size===0}toString(){let k=[];for(let[A,R]of this._nodes)k.push(`${A}, (incoming)[${[...R.incoming.keys()].join(", ")}], (outgoing)[${[...R.outgoing.keys()].join(",")}]`);return k.join(`
`)}findCycleSlow(){for(let[k,A]of this._nodes){const R=new Set([k]),p=this._findCycle(A,R);if(p)return p}}_findCycle(k,A){for(let[R,p]of k.outgoing){if(A.has(R))return[...A,R].join(" -> ");A.add(R);const S=this._findCycle(p,A);if(S)return S;A.delete(R)}}}e.Graph=P}),define(Z[4],ee([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var y;(function(R){R.serviceIds=new Map,R.DI_TARGET="$di$target",R.DI_DEPENDENCIES="$di$dependencies";function p(S){return S[R.DI_DEPENDENCIES]||[]}R.getServiceDependencies=p})(y=e._util||(e._util={})),e.IInstantiationService=L("instantiationService");function P(R,p,S,n){p[y.DI_TARGET]===p?p[y.DI_DEPENDENCIES].push({id:R,index:S,optional:n}):(p[y.DI_DEPENDENCIES]=[{id:R,index:S,optional:n}],p[y.DI_TARGET]=p)}function L(R){if(y.serviceIds.has(R))return y.serviceIds.get(R);const p=function(S,n,f){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");P(p,S,f,!1)};return p.toString=()=>R,y.serviceIds.set(R,p),p}e.createDecorator=L;function k(R){return R}e.refineServiceDecorator=k;function A(R){return function(p,S,n){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");P(R,p,n,!0)}}e.optional=A}),define(Z[140],ee([0,1,4]),function(G,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IChecksumService=void 0,e.IChecksumService=(0,y.createDecorator)("checksumService")}),define(Z[141],ee([0,1,22,4,6]),function(G,e,y,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let k=L.userAgent||"";const A=new Map;A.set("false",!1),A.set("true",!0),A.set("isMac",L.isMacintosh),A.set("isLinux",L.isLinux),A.set("isWindows",L.isWindows),A.set("isWeb",L.isWeb),A.set("isMacNative",L.isMacintosh&&!L.isWeb),A.set("isEdge",k.indexOf("Edg/")>=0),A.set("isFirefox",k.indexOf("Firefox")>=0),A.set("isChrome",k.indexOf("Chrome")>=0),A.set("isSafari",k.indexOf("Safari")>=0);const R=Object.prototype.hasOwnProperty;var p;(function(w){w[w.False=0]="False",w[w.True=1]="True",w[w.Defined=2]="Defined",w[w.Not=3]="Not",w[w.Equals=4]="Equals",w[w.NotEquals=5]="NotEquals",w[w.And=6]="And",w[w.Regex=7]="Regex",w[w.NotRegex=8]="NotRegex",w[w.Or=9]="Or",w[w.In=10]="In",w[w.NotIn=11]="NotIn",w[w.Greater=12]="Greater",w[w.GreaterEquals=13]="GreaterEquals",w[w.Smaller=14]="Smaller",w[w.SmallerEquals=15]="SmallerEquals"})(p=e.ContextKeyExprType||(e.ContextKeyExprType={}));class S{static false(){return f.INSTANCE}static true(){return m.INSTANCE}static has(d){return C.create(d)}static equals(d,T){return h.create(d,T)}static notEquals(d,T){return b.create(d,T)}static regex(d,T){return r.create(d,T)}static in(d,T){return E.create(d,T)}static not(d){return I.create(d)}static and(...d){return o.create(d)}static or(...d){return c.create(d)}static greater(d,T){return g.create(d,T)}static less(d,T){return s.create(d,T)}static deserialize(d,T=!1){if(!!d)return this._deserializeOrExpression(d,T)}static _deserializeOrExpression(d,T){let F=d.split("||");return c.create(F.map(z=>this._deserializeAndExpression(z,T)))}static _deserializeAndExpression(d,T){let F=d.split("&&");return o.create(F.map(z=>this._deserializeOne(z,T)))}static _deserializeOne(d,T){if(d=d.trim(),d.indexOf("!=")>=0){let F=d.split("!=");return b.create(F[0].trim(),this._deserializeValue(F[1],T))}if(d.indexOf("==")>=0){let F=d.split("==");return h.create(F[0].trim(),this._deserializeValue(F[1],T))}if(d.indexOf("=~")>=0){let F=d.split("=~");return r.create(F[0].trim(),this._deserializeRegexValue(F[1],T))}if(d.indexOf(" in ")>=0){let F=d.split(" in ");return E.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(d)){const F=d.split(">=");return a.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(d)){const F=d.split(">");return g.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(d)){const F=d.split("<=");return t.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(d)){const F=d.split("<");return s.create(F[0].trim(),F[1].trim())}return/^\!\s*/.test(d)?I.create(d.substr(1).trim()):C.create(d)}static _deserializeValue(d,T){if(d=d.trim(),d==="true")return!0;if(d==="false")return!1;let F=/^'([^']*)'$/.exec(d);return F?F[1].trim():d}static _deserializeRegexValue(d,T){if((0,y.isFalsyOrWhitespace)(d)){if(T)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let F=d.indexOf("/"),z=d.lastIndexOf("/");if(F===z||F<0){if(T)throw new Error(`bad regexp-value '${d}', missing /-enclosure`);return console.warn(`bad regexp-value '${d}', missing /-enclosure`),null}let B=d.slice(F+1,z),K=d[z+1]==="i"?"i":"";try{return new RegExp(B,K)}catch(j){if(T)throw new Error(`bad regexp-value '${d}', parse error: ${j}`);return console.warn(`bad regexp-value '${d}', parse error: ${j}`),null}}}e.ContextKeyExpr=S;function n(w,d){return w.cmp(d)}class f{constructor(){this.type=0}cmp(d){return this.type-d.type}equals(d){return d.type===this.type}evaluate(d){return!1}serialize(){return"false"}keys(){return[]}map(d){return this}negate(){return m.INSTANCE}}e.ContextKeyFalseExpr=f,f.INSTANCE=new f;class m{constructor(){this.type=1}cmp(d){return this.type-d.type}equals(d){return d.type===this.type}evaluate(d){return!0}serialize(){return"true"}keys(){return[]}map(d){return this}negate(){return f.INSTANCE}}e.ContextKeyTrueExpr=m,m.INSTANCE=new m;class C{constructor(d){this.key=d,this.type=2}static create(d){const T=A.get(d);return typeof T=="boolean"?T?m.INSTANCE:f.INSTANCE:new C(d)}cmp(d){return d.type!==this.type?this.type-d.type:u(this.key,d.key)}equals(d){return d.type===this.type?this.key===d.key:!1}evaluate(d){return!!d.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(d){return d.mapDefined(this.key)}negate(){return I.create(this.key)}}e.ContextKeyDefinedExpr=C;class h{constructor(d,T){this.key=d,this.value=T,this.type=4}static create(d,T){if(typeof T=="boolean")return T?C.create(d):I.create(d);const F=A.get(d);return typeof F=="boolean"?T===(F?"true":"false")?m.INSTANCE:f.INSTANCE:new h(d,T)}cmp(d){return d.type!==this.type?this.type-d.type:v(this.key,this.value,d.key,d.value)}equals(d){return d.type===this.type?this.key===d.key&&this.value===d.value:!1}evaluate(d){return d.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(d){return d.mapEquals(this.key,this.value)}negate(){return b.create(this.key,this.value)}}e.ContextKeyEqualsExpr=h;class E{constructor(d,T){this.key=d,this.valueKey=T,this.type=10}static create(d,T){return new E(d,T)}cmp(d){return d.type!==this.type?this.type-d.type:v(this.key,this.valueKey,d.key,d.valueKey)}equals(d){return d.type===this.type?this.key===d.key&&this.valueKey===d.valueKey:!1}evaluate(d){const T=d.getValue(this.valueKey),F=d.getValue(this.key);return Array.isArray(T)?T.indexOf(F)>=0:typeof F=="string"&&typeof T=="object"&&T!==null?R.call(T,F):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(d){return d.mapIn(this.key,this.valueKey)}negate(){return D.create(this)}}e.ContextKeyInExpr=E;class D{constructor(d){this._actual=d,this.type=11}static create(d){return new D(d)}cmp(d){return d.type!==this.type?this.type-d.type:this._actual.cmp(d._actual)}equals(d){return d.type===this.type?this._actual.equals(d._actual):!1}evaluate(d){return!this._actual.evaluate(d)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(d){return new D(this._actual.map(d))}negate(){return this._actual}}e.ContextKeyNotInExpr=D;class b{constructor(d,T){this.key=d,this.value=T,this.type=5}static create(d,T){if(typeof T=="boolean")return T?I.create(d):C.create(d);const F=A.get(d);return typeof F=="boolean"?T===(F?"true":"false")?f.INSTANCE:m.INSTANCE:new b(d,T)}cmp(d){return d.type!==this.type?this.type-d.type:v(this.key,this.value,d.key,d.value)}equals(d){return d.type===this.type?this.key===d.key&&this.value===d.value:!1}evaluate(d){return d.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(d){return d.mapNotEquals(this.key,this.value)}negate(){return h.create(this.key,this.value)}}e.ContextKeyNotEqualsExpr=b;class I{constructor(d){this.key=d,this.type=3}static create(d){const T=A.get(d);return typeof T=="boolean"?T?f.INSTANCE:m.INSTANCE:new I(d)}cmp(d){return d.type!==this.type?this.type-d.type:u(this.key,d.key)}equals(d){return d.type===this.type?this.key===d.key:!1}evaluate(d){return!d.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(d){return d.mapNot(this.key)}negate(){return C.create(this.key)}}e.ContextKeyNotExpr=I;class g{constructor(d,T){this.key=d,this.value=T,this.type=12}static create(d,T){return new g(d,T)}cmp(d){return d.type!==this.type?this.type-d.type:v(this.key,this.value,d.key,d.value)}equals(d){return d.type===this.type?this.key===d.key&&this.value===d.value:!1}evaluate(d){return parseFloat(d.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(d){return d.mapGreater(this.key,this.value)}negate(){return t.create(this.key,this.value)}}e.ContextKeyGreaterExpr=g;class a{constructor(d,T){this.key=d,this.value=T,this.type=13}static create(d,T){return new a(d,T)}cmp(d){return d.type!==this.type?this.type-d.type:v(this.key,this.value,d.key,d.value)}equals(d){return d.type===this.type?this.key===d.key&&this.value===d.value:!1}evaluate(d){return parseFloat(d.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(d){return d.mapGreaterEquals(this.key,this.value)}negate(){return s.create(this.key,this.value)}}e.ContextKeyGreaterEqualsExpr=a;class s{constructor(d,T){this.key=d,this.value=T,this.type=14}static create(d,T){return new s(d,T)}cmp(d){return d.type!==this.type?this.type-d.type:v(this.key,this.value,d.key,d.value)}equals(d){return d.type===this.type?this.key===d.key&&this.value===d.value:!1}evaluate(d){return parseFloat(d.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(d){return d.mapSmaller(this.key,this.value)}negate(){return a.create(this.key,this.value)}}e.ContextKeySmallerExpr=s;class t{constructor(d,T){this.key=d,this.value=T,this.type=15}static create(d,T){return new t(d,T)}cmp(d){return d.type!==this.type?this.type-d.type:v(this.key,this.value,d.key,d.value)}equals(d){return d.type===this.type?this.key===d.key&&this.value===d.value:!1}evaluate(d){return parseFloat(d.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(d){return d.mapSmallerEquals(this.key,this.value)}negate(){return g.create(this.key,this.value)}}e.ContextKeySmallerEqualsExpr=t;class r{constructor(d,T){this.key=d,this.regexp=T,this.type=7}static create(d,T){return new r(d,T)}cmp(d){if(d.type!==this.type)return this.type-d.type;if(this.key<d.key)return-1;if(this.key>d.key)return 1;const T=this.regexp?this.regexp.source:"",F=d.regexp?d.regexp.source:"";return T<F?-1:T>F?1:0}equals(d){if(d.type===this.type){const T=this.regexp?this.regexp.source:"",F=d.regexp?d.regexp.source:"";return this.key===d.key&&T===F}return!1}evaluate(d){let T=d.getValue(this.key);return this.regexp?this.regexp.test(T):!1}serialize(){const d=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${d}`}keys(){return[this.key]}map(d){return d.mapRegex(this.key,this.regexp)}negate(){return i.create(this)}}e.ContextKeyRegexExpr=r;class i{constructor(d){this._actual=d,this.type=8}static create(d){return new i(d)}cmp(d){return d.type!==this.type?this.type-d.type:this._actual.cmp(d._actual)}equals(d){return d.type===this.type?this._actual.equals(d._actual):!1}evaluate(d){return!this._actual.evaluate(d)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(d){return new i(this._actual.map(d))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=i;class o{constructor(d){this.expr=d,this.type=6}static create(d){return o._normalizeArr(d)}cmp(d){if(d.type!==this.type)return this.type-d.type;if(this.expr.length<d.expr.length)return-1;if(this.expr.length>d.expr.length)return 1;for(let T=0,F=this.expr.length;T<F;T++){const z=n(this.expr[T],d.expr[T]);if(z!==0)return z}return 0}equals(d){if(d.type===this.type){if(this.expr.length!==d.expr.length)return!1;for(let T=0,F=this.expr.length;T<F;T++)if(!this.expr[T].equals(d.expr[T]))return!1;return!0}return!1}evaluate(d){for(let T=0,F=this.expr.length;T<F;T++)if(!this.expr[T].evaluate(d))return!1;return!0}static _normalizeArr(d){const T=[];let F=!1;for(const z of d)if(!!z){if(z.type===1){F=!0;continue}if(z.type===0)return f.INSTANCE;if(z.type===6){T.push(...z.expr);continue}T.push(z)}if(T.length===0&&F)return m.INSTANCE;if(T.length!==0){if(T.length===1)return T[0];for(T.sort(n);T.length>1;){const z=T[T.length-1];if(z.type!==9)break;T.pop();const B=T.pop(),K=c.create(z.expr.map(j=>o.create([j,B])));K&&(T.push(K),T.sort(n))}return T.length===1?T[0]:new o(T)}}serialize(){return this.expr.map(d=>d.serialize()).join(" && ")}keys(){const d=[];for(let T of this.expr)d.push(...T.keys());return d}map(d){return new o(this.expr.map(T=>T.map(d)))}negate(){let d=[];for(let T of this.expr)d.push(T.negate());return c.create(d)}}e.ContextKeyAndExpr=o;class c{constructor(d){this.expr=d,this.type=9}static create(d){const T=c._normalizeArr(d);if(T.length!==0)return T.length===1?T[0]:new c(T)}cmp(d){if(d.type!==this.type)return this.type-d.type;if(this.expr.length<d.expr.length)return-1;if(this.expr.length>d.expr.length)return 1;for(let T=0,F=this.expr.length;T<F;T++){const z=n(this.expr[T],d.expr[T]);if(z!==0)return z}return 0}equals(d){if(d.type===this.type){if(this.expr.length!==d.expr.length)return!1;for(let T=0,F=this.expr.length;T<F;T++)if(!this.expr[T].equals(d.expr[T]))return!1;return!0}return!1}evaluate(d){for(let T=0,F=this.expr.length;T<F;T++)if(this.expr[T].evaluate(d))return!0;return!1}static _normalizeArr(d){let T=[],F=!1;if(d){for(let z=0,B=d.length;z<B;z++){const K=d[z];if(!!K){if(K.type===0){F=!0;continue}if(K.type===1)return[m.INSTANCE];if(K.type===9){T=T.concat(K.expr);continue}T.push(K)}}if(T.length===0&&F)return[f.INSTANCE];T.sort(n)}return T}serialize(){return this.expr.map(d=>d.serialize()).join(" || ")}keys(){const d=[];for(let T of this.expr)d.push(...T.keys());return d}map(d){return new c(this.expr.map(T=>T.map(d)))}negate(){let d=[];for(let F of this.expr)d.push(F.negate());const T=F=>F.type===9?F.expr:[F];for(;d.length>1;){const F=d.shift(),z=d.shift(),B=[];for(const K of T(F))for(const j of T(z))B.push(S.and(K,j));d.unshift(S.or(...B))}return d[0]}}e.ContextKeyOrExpr=c;class l extends C{constructor(d,T,F){super(d);this._defaultValue=T,typeof F=="object"?l._info.push(Object.assign(Object.assign({},F),{key:d})):F!==!0&&l._info.push({key:d,description:F,type:T!=null?typeof T:void 0})}static all(){return l._info.values()}bindTo(d){return d.createKey(this.key,this._defaultValue)}getValue(d){return d.getContextKeyValue(this.key)}toNegated(){return S.not(this.key)}isEqualTo(d){return S.equals(this.key,d)}notEqualsTo(d){return S.notEquals(this.key,d)}}e.RawContextKey=l,l._info=[],e.IContextKeyService=(0,P.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function u(w,d){return w<d?-1:w>d?1:0}function v(w,d,T,F){return w<T?-1:w>T?1:d<F?-1:d>F?1:0}}),define(Z[71],ee([0,1,4]),function(G,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,y.createDecorator)(e.ID);function P(L){return!!L.hostName&&!!L.errorMessage}e.isRemoteDiagnosticError=P}),define(Z[72],ee([0,1,4]),function(G,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,y.createDecorator)("downloadService")}),define(Z[9],ee([0,1,4]),function(G,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,y.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,y.refineServiceDecorator)(e.IEnvironmentService)});var Y=this&&this.__param||function(G,e){return function(y,P){e(y,P,G)}};define(Z[142],ee([0,1,9,7,17,11,2,8]),function(G,e,y,P,L,k,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogsDataCleaner=void 0;let p=class extends A.Disposable{constructor(n){super();this.environmentService=n,this.cleanUpOldLogsSoon()}cleanUpOldLogsSoon(){let n=setTimeout(()=>{n=void 0;const f=(0,P.basename)(this.environmentService.logsPath),m=(0,P.dirname)(this.environmentService.logsPath);(0,L.readdir)(m).then(C=>{const E=C.filter(b=>/^\d{8}T\d{6}$/.test(b)).sort().filter((b,I)=>b!==f),D=E.slice(0,Math.max(0,E.length-9));return R.Promises.settled(D.map(b=>(0,L.rimraf)((0,P.join)(m,b))))}).then(null,k.onUnexpectedError)},10*1e3);this._register((0,A.toDisposable)(()=>{n&&(clearTimeout(n),n=void 0)}))}};p=de([Y(0,y.IEnvironmentService)],p),e.LogsDataCleaner=p}),define(Z[143],ee([0,1,9,7,17,11,2]),function(G,e,y,P,L,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDataCleaner=void 0;let R=class ht extends A.Disposable{constructor(S,n){super();this.backupWorkspacesPath=S,this.environmentService=n,this.cleanUpStorageSoon()}cleanUpStorageSoon(){let S=setTimeout(()=>{S=void 0,(async()=>{try{const n=await L.Promises.readFile(this.backupWorkspacesPath,"utf8"),m=JSON.parse(n).emptyWorkspaceInfos.map(E=>E.backupFolder),C=await(0,L.readdir)(this.environmentService.workspaceStorageHome.fsPath),h=[];C.forEach(E=>{E.length!==ht.NON_EMPTY_WORKSPACE_ID_LENGTH&&m.indexOf(E)===-1&&h.push((0,L.rimraf)((0,P.join)(this.environmentService.workspaceStorageHome.fsPath,E)))}),await Promise.all(h)}catch(n){(0,k.onUnexpectedError)(n)}})()},30*1e3);this._register((0,A.toDisposable)(()=>{S&&(clearTimeout(S),S=void 0)}))}};R.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4,R=de([Y(1,y.INativeEnvironmentService)],R),e.StorageDataCleaner=R}),define(Z[28],ee([0,1,108,4,16]),function(G,e,y,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.INSTALL_ERROR_NOT_SUPPORTED=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN);function k(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(!f.uuid||typeof f.uuid=="string")}e.isIExtensionIdentifier=k;var A;(function(f){f[f.NoneOrRelevance=0]="NoneOrRelevance",f[f.LastUpdatedDate=1]="LastUpdatedDate",f[f.Title=2]="Title",f[f.PublisherName=3]="PublisherName",f[f.InstallCount=4]="InstallCount",f[f.PublishedDate=5]="PublishedDate",f[f.AverageRating=6]="AverageRating",f[f.WeightedRating=12]="WeightedRating"})(A=e.SortBy||(e.SortBy={}));var R;(function(f){f[f.Default=0]="Default",f[f.Ascending=1]="Ascending",f[f.Descending=2]="Descending"})(R=e.SortOrder||(e.SortOrder={}));var p;(function(f){f.Uninstall="uninstall"})(p=e.StatisticType||(e.StatisticType={}));var S;(function(f){f[f.None=0]="None",f[f.Install=1]="Install",f[f.Update=2]="Update"})(S=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,P.createDecorator)("extensionGalleryService"),e.INSTALL_ERROR_NOT_SUPPORTED="notsupported",e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class n extends Error{constructor(m,C){super(m);this.code=C}}e.ExtensionManagementError=n,e.IExtensionManagementService=(0,P.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,P.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,P.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=L.FileAccess.asBrowserUri("./media/defaultIcon.png",G).toString(!0),e.ExtensionsLabel=(0,y.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,y.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,P.createDecorator)("IExtensionManagementCLIService")}),define(Z[144],ee([0,1,2,28]),function(G,e,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DeprecatedExtensionsCleaner=void 0;let L=class extends y.Disposable{constructor(A){super();this.extensionManagementService=A,this._register(A),this.cleanUpDeprecatedExtensions()}cleanUpDeprecatedExtensions(){this.extensionManagementService.removeDeprecatedExtensions()}};L=de([Y(0,P.IExtensionManagementService)],L),e.DeprecatedExtensionsCleaner=L}),define(Z[73],ee([0,1,4]),function(G,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionRecommendationNotificationService=e.RecommendationsNotificationResult=e.RecommendationSourceToString=e.RecommendationSource=void 0;var P;(function(A){A[A.FILE=1]="FILE",A[A.WORKSPACE=2]="WORKSPACE",A[A.EXE=3]="EXE"})(P=e.RecommendationSource||(e.RecommendationSource={}));function L(A){switch(A){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.RecommendationSourceToString=L;var k;(function(A){A.Ignored="ignored",A.Cancelled="cancelled",A.TooMany="toomany",A.IncompatibleWindow="incompatibleWindow",A.Accepted="reacted"})(k=e.RecommendationsNotificationResult||(e.RecommendationsNotificationResult={})),e.IExtensionRecommendationNotificationService=(0,y.createDecorator)("IExtensionRecommendationNotificationService")}),define(Z[74],ee([0,1,22,4]),function(G,e,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkpaceSupportTypeMessage=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin";function L(n){if(typeof n=="object"&&n!==null&&n.supported!==!0)return n.description}e.getWorkpaceSupportTypeMessage=L;function k(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(!n.uuid||typeof n.uuid=="string")}e.isIExtensionIdentifier=k,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(n){n[n.System=0]="System",n[n.User=1]="User"})(A=e.ExtensionType||(e.ExtensionType={}));class R{constructor(f){this.value=f,this._lower=f.toLowerCase()}static equals(f,m){if(typeof f=="undefined"||f===null)return typeof m=="undefined"||m===null;if(typeof m=="undefined"||m===null)return!1;if(typeof f=="string"||typeof m=="string"){let C=typeof f=="string"?f:f.value,h=typeof m=="string"?m:m.value;return y.equalsIgnoreCase(C,h)}return f._lower===m._lower}static toKey(f){return typeof f=="string"?f.toLowerCase():f._lower}}e.ExtensionIdentifier=R;function p(n){return n.contributes&&n.contributes.localizations?n.contributes.localizations.length>0:!1}e.isLanguagePackExtension=p;function S(n){return n.contributes&&n.contributes.authentication?n.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=S,e.IBuiltinExtensionsScannerService=(0,P.createDecorator)("IBuiltinExtensionsScannerService")}),define(Z[33],ee([0,1,22,74]),function(G,e,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function L(C,h){return C.uuid&&h.uuid?C.uuid===h.uuid:C.id===h.id?!0:(0,y.compareIgnoreCase)(C.id,h.id)===0}e.areSameExtensions=L;class k{constructor(h,E){this.version=E,this.id=h.id,this.uuid=h.uuid}key(){return`${this.id}-${this.version}`}equals(h){return h instanceof k?L(this,h)&&this.version===h.version:!1}}e.ExtensionIdentifierWithVersion=k;function A(C,h){return`${C}.${h}`}e.getExtensionId=A;function R(C){return C.toLocaleLowerCase()}e.adoptToGalleryExtensionId=R;function p(C,h){return R(A(C,h))}e.getGalleryExtensionId=p;function S(C,h){const E=[],D=b=>{for(const I of E)if(I.some(g=>L(h(g),h(b))))return I;return null};for(const b of C){const I=D(b);I?I.push(b):E.push([b])}return E}e.groupByExtension=S;function n(C){return{id:C.identifier.id,name:C.manifest.name,galleryId:null,publisherId:C.publisherId,publisherName:C.manifest.publisher,publisherDisplayName:C.publisherDisplayName,dependencies:C.manifest.extensionDependencies&&C.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=n;function f(C){return Object.assign({id:C.identifier.id,name:C.name,galleryId:C.identifier.uuid,publisherId:C.publisherId,publisherName:C.publisher,publisherDisplayName:C.publisherDisplayName,dependencies:!!(C.properties.dependencies&&C.properties.dependencies.length>0)},C.telemetryData)}e.getGalleryExtensionTelemetryData=f,e.BetterMergeId=new P.ExtensionIdentifier("pprice.better-merge");function m(C){const h=new Set;for(const E of C)E.malicious&&h.add(E.id.id);return h}e.getMaliciousExtensionsSet=m}),define(Z[145],ee([0,1,2,7,74,17]),function(G,e,y,P,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class A extends y.Disposable{constructor(p,S){super();this.environmentService=p,this.extensionsManifestCache=(0,P.join)(this.environmentService.userDataPath,L.MANIFEST_CACHE_FOLDER,L.USER_MANIFEST_CACHE_FILE),this._register(S.onDidInstallExtension(n=>this.onDidInstallExtension(n))),this._register(S.onDidUninstallExtension(n=>this.onDidUnInstallExtension(n)))}onDidInstallExtension(p){p.error||this.invalidate()}onDidUnInstallExtension(p){p.error||this.invalidate()}invalidate(){k.rimraf(this.extensionsManifestCache,k.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=A}),define(Z[10],ee([0,1,115,7,5,4,22,15,38]),function(G,e,y,P,L,k,A,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,k.createDecorator)("fileService");function S(j){return j.create===!0}e.isFileOpenForWriteOptions=S;var n;(function(j){j[j.Unknown=0]="Unknown",j[j.File=1]="File",j[j.Directory=2]="Directory",j[j.SymbolicLink=64]="SymbolicLink"})(n=e.FileType||(e.FileType={}));var f;(function(j){j[j.Readonly=1]="Readonly"})(f=e.FilePermission||(e.FilePermission={}));var m;(function(j){j[j.FileReadWrite=2]="FileReadWrite",j[j.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",j[j.FileReadStream=16]="FileReadStream",j[j.FileFolderCopy=8]="FileFolderCopy",j[j.PathCaseSensitive=1024]="PathCaseSensitive",j[j.Readonly=2048]="Readonly",j[j.Trash=4096]="Trash",j[j.FileWriteUnlock=8192]="FileWriteUnlock"})(m=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function C(j){return!!(j.capabilities&2)}e.hasReadWriteCapability=C;function h(j){return!!(j.capabilities&8)}e.hasFileFolderCopyCapability=h;function E(j){return!!(j.capabilities&4)}e.hasOpenReadWriteCloseCapability=E;function D(j){return!!(j.capabilities&16)}e.hasFileReadStreamCapability=D;var b;(function(j){j.FileExists="EntryExists",j.FileNotFound="EntryNotFound",j.FileNotADirectory="EntryNotADirectory",j.FileIsADirectory="EntryIsADirectory",j.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",j.FileTooLarge="EntryTooLarge",j.FileWriteLocked="EntryWriteLocked",j.NoPermissions="NoPermissions",j.Unavailable="Unavailable",j.Unknown="Unknown"})(b=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class I extends Error{constructor(H,q){super(H);this.code=q}}e.FileSystemProviderError=I;function g(j,H){const q=new I(j.toString(),H);return s(q,H),q}e.createFileSystemProviderError=g;function a(j){return j||g((0,y.localize)(0,null),b.Unknown)}e.ensureFileSystemProviderError=a;function s(j,H){return j.name=H?`${H} (FileSystemError)`:"FileSystemError",j}e.markAsFileSystemProviderError=s;function t(j){if(!j)return b.Unknown;if(j instanceof I)return j.code;const H=/^(.+) \(FileSystemError\)$/.exec(j.name);if(!H)return b.Unknown;switch(H[1]){case b.FileExists:return b.FileExists;case b.FileIsADirectory:return b.FileIsADirectory;case b.FileNotADirectory:return b.FileNotADirectory;case b.FileNotFound:return b.FileNotFound;case b.FileExceedsMemoryLimit:return b.FileExceedsMemoryLimit;case b.FileTooLarge:return b.FileTooLarge;case b.FileWriteLocked:return b.FileWriteLocked;case b.NoPermissions:return b.NoPermissions;case b.Unavailable:return b.Unavailable}return b.Unknown}e.toFileSystemProviderErrorCode=t;function r(j){if(j instanceof v)return j.fileOperationResult;switch(t(j)){case b.FileNotFound:return 1;case b.FileIsADirectory:return 0;case b.FileNotADirectory:return 10;case b.FileWriteLocked:return 5;case b.NoPermissions:return 6;case b.FileExists:return 4;case b.FileExceedsMemoryLimit:return 9;case b.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=r;var i;(function(j){j[j.CREATE=0]="CREATE",j[j.DELETE=1]="DELETE",j[j.MOVE=2]="MOVE",j[j.COPY=3]="COPY"})(i=e.FileOperation||(e.FileOperation={}));class o{constructor(H,q,$){this.resource=H,this.operation=q,this.target=$}isOperation(H){return this.operation===H}}e.FileOperationEvent=o;var c;(function(j){j[j.UPDATED=0]="UPDATED",j[j.ADDED=1]="ADDED",j[j.DELETED=2]="DELETED"})(c=e.FileChangeType||(e.FileChangeType={}));class l{constructor(H,q){this.ignorePathCasing=q,this.added=void 0,this.updated=void 0,this.deleted=void 0,this.changes=H;for(const $ of H)switch($.type){case 1:this.added||(this.added=p.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.added.set($.resource,$);break;case 0:this.updated||(this.updated=p.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.updated.set($.resource,$);break;case 2:this.deleted||(this.deleted=p.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.deleted.set($.resource,$);break}}contains(H,...q){return this.doContains(H,{includeChildren:!1},...q)}affects(H,...q){return this.doContains(H,{includeChildren:!0},...q)}doContains(H,q,...$){var M,U,O,_,N,W;if(!H)return!1;const V=$.length>0;return!!((!V||$.includes(1))&&(((M=this.added)===null||M===void 0?void 0:M.get(H))||q.includeChildren&&((U=this.added)===null||U===void 0?void 0:U.findSuperstr(H)))||(!V||$.includes(0))&&(((O=this.updated)===null||O===void 0?void 0:O.get(H))||q.includeChildren&&((_=this.updated)===null||_===void 0?void 0:_.findSuperstr(H)))||(!V||$.includes(2))&&(((N=this.deleted)===null||N===void 0?void 0:N.findSubstr(H))||q.includeChildren&&((W=this.deleted)===null||W===void 0?void 0:W.findSuperstr(H))))}getAdded(){return this.getOfType(1)}gotAdded(){return!!this.added}getDeleted(){return this.getOfType(2)}gotDeleted(){return!!this.deleted}getUpdated(){return this.getOfType(0)}gotUpdated(){return!!this.updated}getOfType(H){const q=[],$=H===1?this.added:H===0?this.updated:this.deleted;if($)for(const[,M]of $)q.push(M);return q}filter(H){return new l(this.changes.filter(q=>H(q)),this.ignorePathCasing)}}e.FileChangesEvent=l;function u(j,H,q){return!j||!H||j===H||H.length>j.length?!1:(H.charAt(H.length-1)!==P.sep&&(H+=P.sep),q?(0,A.startsWithIgnoreCase)(j,H):j.indexOf(H)===0)}e.isParent=u;class v extends Error{constructor(H,q,$){super(H);this.fileOperationResult=q,this.options=$}static isFileOperationError(H){return H instanceof Error&&!(0,R.isUndefinedOrNull)(H.fileOperationResult)}}e.FileOperationError=v;var w;(function(j){j[j.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",j[j.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",j[j.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",j[j.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",j[j.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",j[j.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",j[j.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",j[j.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",j[j.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",j[j.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",j[j.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",j[j.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(w=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var d;(function(j){j[j.FILE=0]="FILE",j[j.FOLDER=1]="FOLDER",j[j.ROOT_FOLDER=2]="ROOT_FOLDER"})(d=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function T(j){if(!(typeof j.size!="number"||typeof j.mtime!="number"))return j.mtime.toString(29)+j.size.toString(31)}e.etag=T;async function F(j,H){if(!H.canHandleResource(L.URI.from({scheme:j.scheme})))return new Promise(q=>{const $=H.onDidChangeFileSystemProviderRegistrations(M=>{M.scheme===j.scheme&&M.added&&($.dispose(),q())})})}e.whenProviderRegistered=F,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class z{static formatSize(H){return(0,R.isNumber)(H)||(H=0),H<z.KB?(0,y.localize)(1,null,H.toFixed(0)):H<z.MB?(0,y.localize)(2,null,(H/z.KB).toFixed(2)):H<z.GB?(0,y.localize)(3,null,(H/z.MB).toFixed(2)):H<z.TB?(0,y.localize)(4,null,(H/z.GB).toFixed(2)):(0,y.localize)(5,null,(H/z.TB).toFixed(2))}}e.ByteSize=z,z.KB=1024,z.MB=z.KB*z.KB,z.GB=z.MB*z.KB,z.TB=z.GB*z.KB;var B;(function(j){j[j.IA32=0]="IA32",j[j.OTHER=1]="OTHER"})(B=e.Arch||(e.Arch={}));function K(j){return{maxFileSize:j===0?300*z.MB:16*z.GB,maxHeapSize:j===0?700*z.MB:2*700*z.MB}}e.getPlatformLimits=K}),define(Z[146],ee([0,1,147,48,10]),function(G,e,y,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChecksumService=void 0;let k=class{constructor(R){this.fileService=R}checksum(R){return new Promise(async(p,S)=>{const n=(0,y.createHash)("md5"),f=(await this.fileService.readFileStream(R)).value;(0,P.listenStream)(f,{onData:m=>n.update(m.buffer),onError:m=>S(m),onEnd:()=>p(n.digest("base64").replace(/=+$/,""))})})}};k=de([Y(0,L.IFileService)],k),e.ChecksumService=k}),define(Z[75],ee([0,1,5,10,6]),function(G,e,y,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeFileChanges=e.toFileChanges=void 0;function k(p){return p.map(S=>({type:S.type,resource:y.URI.file(S.path)}))}e.toFileChanges=k;function A(p){const S=new R;for(const n of p)S.processEvent(n);return S.normalize()}e.normalizeFileChanges=A;class R{constructor(){this.normalized=[],this.mapPathToChange=new Map}processEvent(S){const n=this.mapPathToChange.get(S.path);if(n){const f=n.type,m=S.type;f===1&&m===2?(this.mapPathToChange.delete(S.path),this.normalized.splice(this.normalized.indexOf(n),1)):f===2&&m===1?n.type=0:f===1&&m===0||(n.type=m)}else this.normalized.push(S),this.mapPathToChange.set(S.path,S)}normalize(){const S=[],n=[];return this.normalized.filter(f=>f.type!==2?(S.push(f),!1):!0).sort((f,m)=>f.path.length-m.path.length).filter(f=>n.some(m=>(0,P.isParent)(f.path,m,!L.isLinux))?!1:(n.push(f.path),!0)).concat(S)}}}),define(Z[148],ee([0,1,75,2,17,94,97,8,7]),function(G,e,y,P,L,k,A,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class S extends P.Disposable{constructor(f,m,C,h){super();this.path=f,this.onDidFilesChange=m,this.onLogMessage=C,this.verboseLogging=h,this.fileChangesDelayer=this._register(new R.ThrottledDelayer(A.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(f){this.verboseLogging=f}async startWatching(){try{const{stat:f,symbolicLink:m}=await L.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let C=this.path;if(m)try{C=await(0,k.realpath)(C)}catch(h){if(this.onError(h),m.dangling)return}f.isDirectory()?this._register((0,A.watchFolder)(C,(h,E)=>{this.onFileChange({type:h==="changed"?0:h==="added"?1:2,path:(0,p.join)(this.path,(0,p.basename)(E))})},h=>this.onError(h))):this._register((0,A.watchFile)(C,h=>{this.onFileChange({type:h==="changed"?0:2,path:this.path})},h=>this.onError(h)))}catch(f){f.code!=="ENOENT"&&this.onError(f)}}onFileChange(f){this.fileChangesBuffer.push(f),this.verboseLogging&&this.onVerbose(`${f.type===1?"[ADDED]":f.type===2?"[DELETED]":"[CHANGED]"} ${f.path}`),this.fileChangesDelayer.trigger(async()=>{const m=this.fileChangesBuffer;this.fileChangesBuffer=[];const C=(0,y.normalizeFileChanges)(m);this.verboseLogging&&C.forEach(h=>{this.onVerbose(`>> normalized ${h.type===1?"[ADDED]":h.type===2?"[DELETED]":"[CHANGED]"} ${h.path}`)}),C.length>0&&this.onDidFilesChange(C)})}onError(f){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${f}`})}onVerbose(f){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${f}`})}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=S}),define(Z[76],ee([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class y{constructor(...L){this._entries=new Map;for(let[k,A]of L)this.set(k,A)}set(L,k){const A=this._entries.get(L);return this._entries.set(L,k),A}has(L){return this._entries.has(L)}get(L){return this._entries.get(L)}}e.ServiceCollection=y}),define(Z[149],ee([0,1,11,139,50,4,76,8]),function(G,e,y,P,L,k,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const p=!1;class S extends Error{constructor(h){var E;super("cyclic dependency between services");this.message=(E=h.findCycleSlow())!==null&&E!==void 0?E:`UNABLE to detect cycle, dumping graph: 
${h.toString()}`}}class n{constructor(h=new A.ServiceCollection,E=!1,D){this._activeInstantiations=new Set,this._services=h,this._strict=E,this._parent=D,this._services.set(k.IInstantiationService,this)}createChild(h){return new n(h,this._strict,this)}invokeFunction(h,...E){let D=m.traceInvocation(h),b=!1;try{return h({get:(g,a)=>{if(b)throw(0,y.illegalState)("service accessor is only valid during the invocation of its target method");const s=this._getOrCreateServiceInstance(g,D);if(!s&&a!==k.optional)throw new Error(`[invokeFunction] unknown service '${g}'`);return s}},...E)}finally{b=!0,D.stop()}}createInstance(h,...E){let D,b;return h instanceof L.SyncDescriptor?(D=m.traceCreation(h.ctor),b=this._createInstance(h.ctor,h.staticArguments.concat(E),D)):(D=m.traceCreation(h),b=this._createInstance(h,E,D)),D.stop(),b}_createInstance(h,E=[],D){let b=k._util.getServiceDependencies(h).sort((a,s)=>a.index-s.index),I=[];for(const a of b){let s=this._getOrCreateServiceInstance(a.id,D);if(!s&&this._strict&&!a.optional)throw new Error(`[createInstance] ${h.name} depends on UNKNOWN service ${a.id}.`);I.push(s)}let g=b.length>0?b[0].index:E.length;if(E.length!==g){console.warn(`[createInstance] First service dependency of ${h.name} at position ${g+1} conflicts with ${E.length} static arguments`);let a=g-E.length;a>0?E=E.concat(new Array(a)):E=E.slice(0,g)}return new h(...[...E,...I])}_setServiceInstance(h,E){if(this._services.get(h)instanceof L.SyncDescriptor)this._services.set(h,E);else if(this._parent)this._parent._setServiceInstance(h,E);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(h){let E=this._services.get(h);return!E&&this._parent?this._parent._getServiceInstanceOrDescriptor(h):E}_getOrCreateServiceInstance(h,E){let D=this._getServiceInstanceOrDescriptor(h);return D instanceof L.SyncDescriptor?this._safeCreateAndCacheServiceInstance(h,D,E.branch(h,!0)):(E.branch(h,!1),D)}_safeCreateAndCacheServiceInstance(h,E,D){if(this._activeInstantiations.has(h))throw new Error(`illegal state - RECURSIVELY instantiating service '${h}'`);this._activeInstantiations.add(h);try{return this._createAndCacheServiceInstance(h,E,D)}finally{this._activeInstantiations.delete(h)}}_createAndCacheServiceInstance(h,E,D){const b=new P.Graph(a=>a.id.toString());let I=0;const g=[{id:h,desc:E,_trace:D}];for(;g.length;){const a=g.pop();if(b.lookupOrInsertNode(a),I++>1e3)throw new S(b);for(let s of k._util.getServiceDependencies(a.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(s.id);if(!t&&!s.optional&&console.warn(`[createInstance] ${h} depends on ${s.id} which is NOT registered.`),t instanceof L.SyncDescriptor){const r={id:s.id,desc:t,_trace:a._trace.branch(s.id,!0)};b.insertEdge(a,r),g.push(r)}}}for(;;){const a=b.roots();if(a.length===0){if(!b.isEmpty())throw new S(b);break}for(const{data:s}of a){if(this._getServiceInstanceOrDescriptor(s.id)instanceof L.SyncDescriptor){const r=this._createServiceInstanceWithOwner(s.id,s.desc.ctor,s.desc.staticArguments,s.desc.supportsDelayedInstantiation,s._trace);this._setServiceInstance(s.id,r)}b.removeNode(s)}}return this._getServiceInstanceOrDescriptor(h)}_createServiceInstanceWithOwner(h,E,D=[],b,I){if(this._services.get(h)instanceof L.SyncDescriptor)return this._createServiceInstance(E,D,b,I);if(this._parent)return this._parent._createServiceInstanceWithOwner(h,E,D,b,I);throw new Error(`illegalState - creating UNKNOWN service instance ${E.name}`)}_createServiceInstance(h,E=[],D,b){if(D){const I=new R.IdleValue(()=>this._createInstance(h,E,b));return new Proxy(Object.create(null),{get(g,a){if(a in g)return g[a];let s=I.value,t=s[a];return typeof t!="function"||(t=t.bind(s),g[a]=t),t},set(g,a,s){return I.value[a]=s,!0}})}else return this._createInstance(h,E,b)}}e.InstantiationService=n;var f;(function(C){C[C.Creation=0]="Creation",C[C.Invocation=1]="Invocation",C[C.Branch=2]="Branch"})(f||(f={}));class m{constructor(h,E){this.type=h,this.name=E,this._start=Date.now(),this._dep=[]}static traceInvocation(h){return p?new m(1,h.name||h.toString().substring(0,42).replace(/\n/g,"")):m._None}static traceCreation(h){return p?new m(0,h.name):m._None}branch(h,E){let D=new m(2,h.toString());return this._dep.push([h,E,D]),D}stop(){let h=Date.now()-this._start;m._totals+=h;let E=!1;function D(I,g){let a=[],s=new Array(I+1).join("	");for(const[t,r,i]of g._dep)if(r&&i){E=!0,a.push(`${s}CREATES -> ${t}`);let o=D(I+1,i);o&&a.push(o)}else a.push(`${s}uses -> ${t}`);return a.join(`
`)}let b=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${D(1,this)}`,`DONE, took ${h.toFixed(2)}ms (grand total ${m._totals.toFixed(2)}ms)`];(h>2||E)&&console.log(b.join(`
`))}}m._None=new class extends m{constructor(){super(-1,null)}stop(){}branch(){return this}},m._totals=0}),define(Z[150],ee([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MessagePortMainProcessService=void 0;class y{constructor(L,k){this.server=L,this.router=k}getChannel(L){return this.server.getChannel(L,this.router)}registerChannel(L,k){this.server.registerChannel(L,k)}}e.MessagePortMainProcessService=y}),define(Z[151],ee([0,1,36,50,138,4]),function(G,e,y,P,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerSharedProcessRemoteService=e.ISharedProcessService=e.registerMainProcessRemoteService=e.IMainProcessService=void 0;class A{constructor(C,h,E){const D=E.getChannel(C);return R(h)?new h.channelClientCtor(D):y.ProxyChannel.toService(D,h==null?void 0:h.proxyOptions)}}function R(m){const C=m;return!!(C==null?void 0:C.channelClientCtor)}e.IMainProcessService=(0,k.createDecorator)("mainProcessService");let p=class extends A{constructor(C,h,E){super(C,h,E)}};p=de([Y(2,e.IMainProcessService)],p);function S(m,C,h){(0,L.registerSingleton)(m,new P.SyncDescriptor(p,[C,h],h==null?void 0:h.supportsDelayedInstantiation))}e.registerMainProcessRemoteService=S,e.ISharedProcessService=(0,k.createDecorator)("sharedProcessService");let n=class extends A{constructor(C,h,E){super(C,h,E)}};n=de([Y(2,e.ISharedProcessService)],n);function f(m,C,h){(0,L.registerSingleton)(m,new P.SyncDescriptor(n,[C,h],h==null?void 0:h.supportsDelayedInstantiation))}e.registerSharedProcessRemoteService=f}),define(Z[56],ee([0,1,4]),function(G,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isValidLocalization=e.ILocalizationsService=void 0,e.ILocalizationsService=(0,y.createDecorator)("localizationsService");function P(L){if(typeof L.languageId!="string"||!Array.isArray(L.translations)||L.translations.length===0)return!1;for(const k of L.translations)if(typeof k.id!="string"||typeof k.path!="string")return!1;return!(L.languageName&&typeof L.languageName!="string"||L.localizedLanguageName&&typeof L.localizedLanguageName!="string")}e.isValidLocalization=P}),define(Z[152],ee([0,1,2,56]),function(G,e,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsUpdater=void 0;let L=class extends y.Disposable{constructor(A){super();this.localizationsService=A,this.updateLocalizations()}updateLocalizations(){this.localizationsService.update()}};L=de([Y(0,P.ILocalizationsService)],L),e.LocalizationsUpdater=L}),define(Z[18],ee([0,1,4,2,6,3,44]),function(G,e,y,P,L,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,y.createDecorator)("logService"),e.ILoggerService=(0,y.createDecorator)("loggerService");function R(){return new Date().toISOString()}var p;(function(s){s[s.Trace=0]="Trace",s[s.Debug=1]="Debug",s[s.Info=2]="Info",s[s.Warning=3]="Warning",s[s.Error=4]="Error",s[s.Critical=5]="Critical",s[s.Off=6]="Off"})(p=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=p.Info;class S extends P.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new k.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=S;class n extends S{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...r){this.checkLogLevel(p.Trace)&&this.log(p.Trace,this.format([t,...r]))}debug(t,...r){this.checkLogLevel(p.Debug)&&this.log(p.Debug,this.format([t,...r]))}info(t,...r){this.checkLogLevel(p.Info)&&this.log(p.Info,this.format([t,...r]))}warn(t,...r){this.checkLogLevel(p.Warning)&&this.log(p.Warning,this.format([t,...r]))}error(t,...r){if(this.checkLogLevel(p.Error))if(t instanceof Error){const i=Array.prototype.slice.call(arguments);i[0]=t.stack,this.log(p.Error,this.format(i))}else this.log(p.Error,this.format([t,...r]))}critical(t,...r){this.checkLogLevel(p.Critical)&&this.log(p.Critical,this.format([t,...r]))}flush(){}format(t){let r="";for(let i=0;i<t.length;i++){let o=t[i];if(typeof o=="object")try{o=JSON.stringify(o)}catch(c){}r+=(i>0?" ":"")+o}return r}}e.AbstractMessageLogger=n;class f extends S{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!L.isWindows}trace(t,...r){this.getLevel()<=p.Trace&&(this.useColors?console.log(`[90m[main ${R()}][0m`,t,...r):console.log(`[main ${R()}]`,t,...r))}debug(t,...r){this.getLevel()<=p.Debug&&(this.useColors?console.log(`[90m[main ${R()}][0m`,t,...r):console.log(`[main ${R()}]`,t,...r))}info(t,...r){this.getLevel()<=p.Info&&(this.useColors?console.log(`[90m[main ${R()}][0m`,t,...r):console.log(`[main ${R()}]`,t,...r))}warn(t,...r){this.getLevel()<=p.Warning&&(this.useColors?console.warn(`[93m[main ${R()}][0m`,t,...r):console.warn(`[main ${R()}]`,t,...r))}error(t,...r){this.getLevel()<=p.Error&&(this.useColors?console.error(`[91m[main ${R()}][0m`,t,...r):console.error(`[main ${R()}]`,t,...r))}critical(t,...r){this.getLevel()<=p.Critical&&(this.useColors?console.error(`[90m[main ${R()}][0m`,t,...r):console.error(`[main ${R()}]`,t,...r))}dispose(){}flush(){}}e.ConsoleMainLogger=f;class m extends S{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...r){this.getLevel()<=p.Trace&&console.log("%cTRACE","color: #888",t,...r)}debug(t,...r){this.getLevel()<=p.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...r)}info(t,...r){this.getLevel()<=p.Info&&console.log("%c INFO","color: #33f",t,...r)}warn(t,...r){this.getLevel()<=p.Warning&&console.log("%c WARN","color: #993",t,...r)}error(t,...r){this.getLevel()<=p.Error&&console.log("%c  ERR","color: #f33",t,...r)}critical(t,...r){this.getLevel()<=p.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...r)}dispose(){}flush(){}}e.ConsoleLogger=m;class C extends S{constructor(t,r=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(r)}trace(t,...r){this.getLevel()<=p.Trace&&this.adapter.log(p.Trace,[this.extractMessage(t),...r])}debug(t,...r){this.getLevel()<=p.Debug&&this.adapter.log(p.Debug,[this.extractMessage(t),...r])}info(t,...r){this.getLevel()<=p.Info&&this.adapter.log(p.Info,[this.extractMessage(t),...r])}warn(t,...r){this.getLevel()<=p.Warning&&this.adapter.log(p.Warning,[this.extractMessage(t),...r])}error(t,...r){this.getLevel()<=p.Error&&this.adapter.log(p.Error,[this.extractMessage(t),...r])}critical(t,...r){this.getLevel()<=p.Critical&&this.adapter.log(p.Critical,[this.extractMessage(t),...r])}extractMessage(t){return typeof t=="string"?t:(0,A.toErrorMessage)(t,this.getLevel()<=p.Trace)}dispose(){}flush(){}}e.AdapterLogger=C;class h extends S{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const r of this.logServices)r.setLevel(t);super.setLevel(t)}trace(t,...r){for(const i of this.logServices)i.trace(t,...r)}debug(t,...r){for(const i of this.logServices)i.debug(t,...r)}info(t,...r){for(const i of this.logServices)i.info(t,...r)}warn(t,...r){for(const i of this.logServices)i.warn(t,...r)}error(t,...r){for(const i of this.logServices)i.error(t,...r)}critical(t,...r){for(const i of this.logServices)i.critical(t,...r)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=h;class E extends P.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...r){this.logger.trace(t,...r)}debug(t,...r){this.logger.debug(t,...r)}info(t,...r){this.logger.info(t,...r)}warn(t,...r){this.logger.warn(t,...r)}error(t,...r){this.logger.error(t,...r)}critical(t,...r){this.logger.critical(t,...r)}flush(){this.logger.flush()}}e.LogService=E;class D extends P.Disposable{constructor(t,r){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(r(i=>{this.logLevel=i,this.logLevelChangeableLoggers.forEach(o=>o.setLevel(i))}))}createLogger(t,r){let i=this.loggers.get(t.toString());return i||(i=this.doCreateLogger(t,(r==null?void 0:r.always)?p.Trace:this.logLevel,r),this.loggers.set(t.toString(),i),(r==null?void 0:r.always)||this.logLevelChangeableLoggers.push(i)),i}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=D;class b{constructor(){this.onDidChangeLogLevel=new k.Emitter().event}setLevel(t){}getLevel(){return p.Info}trace(t,...r){}debug(t,...r){}info(t,...r){}warn(t,...r){}error(t,...r){}critical(t,...r){}dispose(){}flush(){}}e.NullLogService=b;function I(s){if(s.verbose)return p.Trace;if(typeof s.logLevel=="string"){const t=g(s.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=I;function g(s){switch(s){case"trace":return p.Trace;case"debug":return p.Debug;case"info":return p.Info;case"warn":return p.Warning;case"error":return p.Error;case"critical":return p.Critical;case"off":return p.Off}}e.parseLogLevel=g;function a(s){switch(s){case p.Trace:return"trace";case p.Debug:return"debug";case p.Info:return"info";case p.Warning:return"warn";case p.Error:return"error";case p.Critical:return"critical";case p.Off:return"off"}}e.LogLevelToString=a}),define(Z[153],ee([0,1,17,2,10,28,9,5,14,33,18,30,57,6,8,11]),function(G,e,y,P,L,k,A,R,p,S,n,f,m,C,h,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;const D=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let b=class extends P.Disposable{constructor(g,a,s,t){super();this.fileService=a,this.extensionGalleryService=s,this.logService=t,this.extensionsDownloadDir=R.URI.file(g.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(g,a){await this.cleanUpPromise;const s=this.getName(g),t=(0,p.joinPath)(this.extensionsDownloadDir,s);if(!await this.fileService.exists(t)){const r=(0,p.joinPath)(this.extensionsDownloadDir,`.${(0,f.generateUuid)()}`);await this.fileService.exists(r)||await this.extensionGalleryService.download(g,r,a);try{await this.rename(r,t,Date.now()+2*60*1e3)}catch(i){try{await this.fileService.del(r)}catch(o){}if(i.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",g.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,E.getErrorMessage)(i)}. Deleted the vsix from downloaded location`,r.path),i}}return t}async delete(g){}async rename(g,a,s){try{await y.Promises.rename(g.fsPath,a.fsPath)}catch(t){if(C.isWindows&&t&&t.code==="EPERM"&&Date.now()<s)return this.logService.info(`Failed renaming ${g} to ${a} with 'EPERM' error. Trying again...`),this.rename(g,a,s);throw t}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const g=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(g.children){const a=[],s=[];for(const i of g.children){const o=this.parse(i.name);o&&s.push([o,i])}const t=(0,S.groupByExtension)(s,([i])=>i),r=[];for(const i of t)i.sort((o,c)=>m.rcompare(o[0].version,c[0].version)),a.push(...i.slice(1).map(o=>o[1].resource)),r.push(i[0][1]);r.sort((i,o)=>i.mtime-o.mtime),a.push(...r.slice(0,Math.max(0,r.length-this.cache)).map(i=>i.resource)),await h.Promises.settled(a.map(i=>(this.logService.trace("Deleting vsix from cache",i.path),this.fileService.del(i))))}}catch(g){this.logService.error(g)}}getName(g){return this.cache?new S.ExtensionIdentifierWithVersion(g.identifier,g.version).key().toLowerCase():(0,f.generateUuid)()}parse(g){const a=D.exec(g);return a&&a[1]&&a[2]?new S.ExtensionIdentifierWithVersion({id:a[1]},a[2]):null}};b=de([Y(0,A.INativeEnvironmentService),Y(1,L.IFileService),Y(2,k.IExtensionGalleryService),Y(3,n.ILogService)],b),e.ExtensionsDownloader=b}),define(Z[154],ee([0,1,2,18,43,44,7,8,3,16,17,9]),function(G,e,y,P,L,k,A,R,p,S,n,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let m=class extends y.Disposable{constructor(h,E){super();this.environmentService=h,this.logService=E,this.processesLimiter=new R.Limiter(5)}async postUninstall(h){const E=this.parseScript(h,"uninstall");return E&&(this.logService.info(h.identifier.id,h.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(E.script,"uninstall",E.args,!0,h).then(()=>this.logService.info(h.identifier.id,h.manifest.version,"Finished running post uninstall script"),D=>this.logService.error(h.identifier.id,h.manifest.version,`Failed to run post uninstall script: ${D}`)))),(0,n.rimraf)(this.getExtensionStoragePath(h)).then(void 0,D=>this.logService.error("Error while removing extension storage path",D))}parseScript(h,E){const D=`vscode:${E}`;if(h.location.scheme===S.Schemas.file&&h.manifest&&h.manifest.scripts&&typeof h.manifest.scripts[D]=="string"){const b=h.manifest.scripts[D].split(" ");return b.length<2||b[0]!=="node"||!b[1]?(this.logService.warn(h.identifier.id,h.manifest.version,`${D} should be a node script`),null):{script:(0,A.join)(h.location.fsPath,b[1]),args:b.slice(2)||[]}}return null}runLifecycleHook(h,E,D,b,I){return new Promise((g,a)=>{const s=this.start(h,E,D,I);let t;const r=i=>{t&&(clearTimeout(t),t=null),i?a(i):g(void 0)};s.on("error",i=>{r((0,k.toErrorMessage)(i)||"Unknown")}),s.on("exit",(i,o)=>{r(i?`post-${E} process exited with code ${i}`:void 0)}),b&&(t=setTimeout(()=>{t=null,s.kill(),a("timed out")},5e3))})}start(h,E,D,b){const I={silent:!0,execArgv:void 0},g=(0,L.fork)(h,[`--type=extension-post-${E}`,...D],I);g.stdout.setEncoding("utf8"),g.stderr.setEncoding("utf8");const a=p.Event.fromNodeEventEmitter(g.stdout,"data"),s=p.Event.fromNodeEventEmitter(g.stderr,"data");a(i=>this.logService.info(b.identifier.id,b.manifest.version,`post-${E}`,i)),s(i=>this.logService.error(b.identifier.id,b.manifest.version,`post-${E}`,i));const t=p.Event.any(p.Event.map(a,i=>({data:`%c${i}`,format:[""]})),p.Event.map(s,i=>({data:`%c${i}`,format:["color: red"]})));return p.Event.debounce(t,(i,o)=>i?{data:i.data+o.data,format:[...i.format,...o.format]}:{data:o.data,format:o.format},100)(i=>{console.group(b.identifier.id),console.log(i.data,...i.format),console.groupEnd()}),g}getExtensionStoragePath(h){return(0,A.join)(this.environmentService.globalStorageHome.fsPath,h.identifier.id.toLowerCase())}};m=de([Y(0,f.IEnvironmentService),Y(1,P.ILogService)],m),e.ExtensionsLifecycle=m}),define(Z[155],ee([0,1,2,9,3,10,5,33,14,18]),function(G,e,y,P,L,k,A,R,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;let n=class extends y.Disposable{constructor(m,C,h,E){super();this.extensionsManagementService=m,this.logService=E,this._onDidChangeExtensionsByAnotherSource=this._register(new L.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled(1).then(I=>{this.installedExtensions=I.map(g=>g.identifier),this.startTimestamp=Date.now()}),this._register(m.onInstallExtension(I=>this.onInstallExtension(I))),this._register(m.onDidInstallExtension(I=>this.onDidInstallExtension(I))),this._register(m.onDidUninstallExtension(I=>this.onDidUninstallExtension(I)));const D=A.URI.file(h.extensionsPath),b=new p.ExtUri(I=>!C.hasCapability(I,1024));this._register(C.watch(D)),this._register(L.Event.filter(C.onDidFilesChange,I=>I.changes.some(g=>this.doesChangeAffects(g,D,b)))(()=>this.onDidChange()))}doesChangeAffects(m,C,h){return h.isEqual(h.dirname(m.resource),C)?h.isEqual(m.resource,h.joinPath(C,".obsolete"))?!0:!(m.type!==1&&m.type!==2||h.basename(m.resource).startsWith(".")):!1}onInstallExtension(m){this.addInstallingExtension(m.identifier)}onDidInstallExtension(m){this.removeInstallingExtension(m.identifier),m.error||this.addInstalledExtension(m.identifier)}onDidUninstallExtension(m){m.error||this.removeInstalledExtension(m.identifier)}addInstallingExtension(m){this.removeInstallingExtension(m),this.installingExtensions.push(m)}removeInstallingExtension(m){this.installingExtensions=this.installingExtensions.filter(C=>!(0,R.areSameExtensions)(C,m))}addInstalledExtension(m){this.installedExtensions&&(this.removeInstalledExtension(m),this.installedExtensions.push(m))}removeInstalledExtension(m){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(C=>!(0,R.areSameExtensions)(C,m)))}async onDidChange(){if(this.installedExtensions){const m=await this.extensionsManagementService.getInstalled(1),C=m.filter(E=>[...this.installingExtensions,...this.installedExtensions].some(D=>(0,R.areSameExtensions)(D,E.identifier))?!1:E.installedTimestamp&&E.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",E.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",E.identifier.id),!1)),h=this.installedExtensions.filter(E=>this.installingExtensions.some(D=>(0,R.areSameExtensions)(D,E))?!1:m.every(D=>!(0,R.areSameExtensions)(D.identifier,E))?(this.logService.info("Detected extension removed from another source",E.id),!0):!1);this.installedExtensions=m.map(E=>E.identifier),(C.length||h.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:C,removed:h})}}};n=de([Y(1,k.IFileService),Y(2,P.INativeEnvironmentService),Y(3,S.ILogService)],n),e.ExtensionsWatcher=n}),define(Z[156],ee([0,1,17,147,28,2,9,8,33,18,56,19,3,16,7]),function(G,e,y,P,L,k,A,R,p,S,n,f,m,C,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsService=void 0;let E=class extends k.Disposable{constructor(I,g,a){super();this.extensionManagementService=I,this.logService=a,this._onDidLanguagesChange=this._register(new m.Emitter),this.onDidLanguagesChange=this._onDidLanguagesChange.event,this.cache=this._register(new D(g,a)),this._register(I.onDidInstallExtension(({local:s})=>this.onDidInstallExtension(s))),this._register(I.onDidUninstallExtension(({identifier:s})=>this.onDidUninstallExtension(s)))}getLanguageIds(){return this.cache.getLanguagePacks().then(I=>{const g=["en",...Object.keys(I)];return(0,f.distinct)(g)})}onDidInstallExtension(I){I&&I.manifest&&I.manifest.contributes&&I.manifest.contributes.localizations&&I.manifest.contributes.localizations.length&&(this.logService.debug("Adding language packs from the extension",I.identifier.id),this.update().then(g=>{g&&this._onDidLanguagesChange.fire()}))}onDidUninstallExtension(I){this.cache.getLanguagePacks().then(g=>{Object.keys(g).some(a=>g[a]&&g[a].extensions.some(s=>(0,p.areSameExtensions)(s.extensionIdentifier,I)))&&(this.logService.debug("Removing language packs from the extension",I.id),this.update().then(a=>{a&&this._onDidLanguagesChange.fire()}))})}async update(){const[I,g]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),a=await this.cache.update(g);return!(0,f.equals)(Object.keys(I),Object.keys(a))}};E=de([Y(0,L.IExtensionManagementService),Y(1,A.INativeEnvironmentService),Y(2,S.ILogService)],E),e.LocalizationsService=E;let D=class extends k.Disposable{constructor(I,g){super();this.logService=g,this.languagePacks={},this.languagePacksFilePath=(0,h.join)(I.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new R.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(I){return this.withLanguagePacks(g=>{Object.keys(g).forEach(a=>delete g[a]),this.createLanguagePacksFromExtensions(g,...I)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(I,...g){for(const a of g)a&&a.manifest&&a.manifest.contributes&&a.manifest.contributes.localizations&&a.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(I,a);Object.keys(I).forEach(a=>this.updateHash(I[a]))}createLanguagePacksFromExtension(I,g){const a=g.identifier,s=g.manifest.contributes&&g.manifest.contributes.localizations?g.manifest.contributes.localizations:[];for(const t of s)if(g.location.scheme===C.Schemas.file&&(0,n.isValidLocalization)(t)){let r=I[t.languageId];r||(r={hash:"",extensions:[],translations:{}},I[t.languageId]=r);let i=r.extensions.filter(o=>(0,p.areSameExtensions)(o.extensionIdentifier,a))[0];i?i.version=g.manifest.version:r.extensions.push({extensionIdentifier:a,version:g.manifest.version});for(const o of t.translations)r.translations[o.id]=(0,h.join)(g.location.fsPath,o.path)}}updateHash(I){if(I){const g=(0,P.createHash)("md5");for(const a of I.extensions)g.update(a.extensionIdentifier.uuid||a.extensionIdentifier.id).update(a.version);I.hash=g.digest("hex")}}withLanguagePacks(I=()=>null){return this.languagePacksFileLimiter.queue(()=>{let g=null;return y.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,a=>a.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(a)).then(a=>{try{return JSON.parse(a)}catch(s){return{}}}).then(a=>(g=I(a),a)).then(a=>{for(const t of Object.keys(a))a[t]||delete a[t];this.languagePacks=a,this.initializedCache=!0;const s=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",s),(0,y.writeFile)(this.languagePacksFilePath,s)}).then(()=>g,a=>this.logService.error(a))})}};D=de([Y(0,A.INativeEnvironmentService),Y(1,S.ILogService)],D)}),define(Z[77],ee([0,1,18,3,5]),function(G,e,y,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class k{constructor(m){this.service=m,this.onDidChangeLogLevel=P.Event.buffer(m.onDidChangeLogLevel,!0)}listen(m,C){switch(C){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${C}`)}async call(m,C,h){switch(C){case"setLevel":return this.service.setLevel(h)}throw new Error(`Call not found: ${C}`)}}e.LogLevelChannel=k;class A{constructor(m){this.channel=m}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(m){A.setLevel(this.channel,m)}static setLevel(m,C){return m.call("setLevel",C)}}e.LogLevelChannelClient=A;class R{constructor(m){this.loggerService=m,this.loggers=new Map}listen(m,C){throw new Error(`Event not found: ${C}`)}async call(m,C,h){switch(C){case"createLogger":this.createLogger(L.URI.revive(h[0]),h[1]);return;case"log":return this.log(L.URI.revive(h[0]),h[1]);case"consoleLog":return this.consoleLog(h[0],h[1])}throw new Error(`Call not found: ${C}`)}createLogger(m,C){this.loggers.set(m.toString(),this.loggerService.createLogger(m,C))}consoleLog(m,C){let h=console.log;switch(m){case y.LogLevel.Error:h=console.error;break;case y.LogLevel.Warning:h=console.warn;break;case y.LogLevel.Info:h=console.info;break}h.call(console,...C)}log(m,C){const h=this.loggers.get(m.toString());if(!h)throw new Error("Create the logger before logging");for(const[E,D]of C)switch(E){case y.LogLevel.Trace:h.trace(D);break;case y.LogLevel.Debug:h.debug(D);break;case y.LogLevel.Info:h.info(D);break;case y.LogLevel.Warning:h.warn(D);break;case y.LogLevel.Error:h.error(D);break;case y.LogLevel.Critical:h.critical(D);break;default:throw new Error("Invalid log level")}}}e.LoggerChannel=R;class p extends y.AbstractLoggerService{constructor(m,C,h){super(m,C);this.channel=h}createConsoleMainLogger(){return new y.AdapterLogger({log:(m,C)=>{this.channel.call("consoleLog",[m,C])}})}doCreateLogger(m,C,h){return new S(this.channel,m,C,h)}}e.LoggerChannelClient=p;class S extends y.AbstractMessageLogger{constructor(m,C,h,E){super(E==null?void 0:E.always);this.channel=m,this.file=C,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(h),this.channel.call("createLogger",[C,E]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(m,C){const h=[[m,C]];this.isLoggerCreated?this.doLog(h):this.buffer.push(...h)}doLog(m){this.channel.call("log",[this.file,m])}}class n extends y.LogService{constructor(m,C){super(C);this.parent=m,this._register(m.onDidChangeLogLevel(h=>C.setLevel(h)))}setLevel(m){super.setLevel(m),this.parent.setLevel(m)}}e.FollowerLogService=n}),define(Z[58],ee([0,1,4]),function(G,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeHostService=void 0,e.INativeHostService=(0,y.createDecorator)("nativeHostService")}),define(Z[51],ee([0,1,16,6,34,14]),function(G,e,y,P,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let A;if(typeof P.globals.vscode!="undefined"&&typeof P.globals.vscode.context!="undefined"){const R=P.globals.vscode.context.configuration();if(R)A=R.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof(G==null?void 0:G.__$__nodeRequire)=="function"){const R=(0,k.dirname)(y.FileAccess.asFileUri("",G));A=G.__$__nodeRequire((0,k.joinPath)(R,"product.json").fsPath);const p=G.__$__nodeRequire((0,k.joinPath)(R,"package.json").fsPath);L.env.VSCODE_DEV&&Object.assign(A,{nameShort:`${A.nameShort} Dev`,nameLong:`${A.nameLong} Dev`,dataFolderName:`${A.dataFolderName}-dev`}),Object.assign(A,{version:p.version})}else A={},Object.keys(A).length===0&&Object.assign(A,{version:"1.57.0-dev",nameShort:P.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",nameLong:P.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.github-browser","ms-vscode.github-richnav","ms-vscode.remotehub","ms-vscode.remotehub-insiders"]});e.default=A}),define(Z[78],ee([0,1,116,25,10,11,51]),function(G,e,y,P,L,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function R(f,m,C,h,E,D){let b;try{await p(f,m,C,h,E,D)}catch(I){b=I}finally{b&&E.errorTransformer&&(b=E.errorTransformer(b)),typeof b!="undefined"&&C.error(b),C.end()}}e.readFileIntoStream=R;async function p(f,m,C,h,E,D){S(D);const b=await f.open(m,{create:!1});try{S(D);let I=0,g=0,a=E&&typeof E.length=="number"?E.length:void 0,s=P.VSBuffer.alloc(Math.min(E.bufferSize,typeof a=="number"?a:E.bufferSize)),t=E&&typeof E.position=="number"?E.position:0,r=0;do g=await f.read(b,t,s.buffer,r,s.byteLength-r),t+=g,r+=g,I+=g,typeof a=="number"&&(a-=g),r===s.byteLength&&(await C.write(h(s)),s=P.VSBuffer.alloc(Math.min(E.bufferSize,typeof a=="number"?a:E.bufferSize)),r=0);while(g>0&&(typeof a!="number"||a>0)&&S(D)&&n(I,E));if(r>0){let i=r;typeof a=="number"&&(i=Math.min(r,a)),C.write(h(s.slice(0,i)))}}catch(I){throw(0,L.ensureFileSystemProviderError)(I)}finally{await f.close(b)}}function S(f){if(f.isCancellationRequested)throw(0,k.canceled)();return!0}function n(f,m){if(m==null?void 0:m.limits){if(typeof m.limits.memory=="number"&&f>m.limits.memory)throw(0,L.createFileSystemProviderError)((0,y.localize)(0,null,A.default.nameShort),L.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof m.limits.size=="number"&&f>m.limits.size)throw(0,L.createFileSystemProviderError)((0,y.localize)(1,null),L.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(Z[157],ee([0,1,114,158,2,10,3,14,38,19,18,25,48,8,29,16,78,53]),function(G,e,y,P,L,k,A,R,p,S,n,f,m,C,h,E,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let I=class extends L.Disposable{constructor(a){super();this.logService=a,this.BUFFER_SIZE=64*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new A.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new A.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new A.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new A.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new A.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new A.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this.activeWatchers=new Map,this.writeQueue=this._register(new C.ResourceQueue)}registerProvider(a,s){if(this.provider.has(a))throw new Error(`A filesystem provider for the scheme '${a}' is already registered.`);(0,P.mark)(`code/registerFilesystem/${a}`),this.provider.set(a,s),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:a,provider:s});const t=new L.DisposableStore;return t.add(s.onDidChangeFile(r=>this._onDidFilesChange.fire(new k.FileChangesEvent(r,!this.isPathCaseSensitive(s))))),t.add(s.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:s,scheme:a}))),typeof s.onDidErrorOccur=="function"&&t.add(s.onDidErrorOccur(r=>this._onError.fire(new Error(r)))),(0,L.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:a,provider:s}),this.provider.delete(a),(0,L.dispose)(t)})}getProvider(a){return this.provider.get(a)}async activateProvider(a){const s=[];this._onWillActivateFileSystemProvider.fire({scheme:a,join(t){s.push(t)}}),!this.provider.has(a)&&await C.Promises.settled(s)}canHandleResource(a){return this.provider.has(a.scheme)}hasCapability(a,s){const t=this.provider.get(a.scheme);return!!(t&&t.capabilities&s)}listCapabilities(){return b.Iterable.map(this.provider,([a,s])=>({scheme:a,capabilities:s.capabilities}))}async withProvider(a){if(!(0,R.isAbsolutePath)(a))throw new k.FileOperationError((0,y.localize)(0,null,this.resourceForError(a)),8);await this.activateProvider(a.scheme);const s=this.provider.get(a.scheme);if(!s){const t=new Error;throw t.name="ENOPRO",t.message=(0,y.localize)(1,null,a.toString()),t}return s}async withReadProvider(a){const s=await this.withProvider(a);if((0,k.hasOpenReadWriteCloseCapability)(s)||(0,k.hasReadWriteCapability)(s)||(0,k.hasFileReadStreamCapability)(s))return s;throw new Error(`Filesystem provider for scheme '${a.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(a){const s=await this.withProvider(a);if((0,k.hasOpenReadWriteCloseCapability)(s)||(0,k.hasReadWriteCapability)(s))return s;throw new Error(`Filesystem provider for scheme '${a.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(a,s){try{return await this.doResolveFile(a,s)}catch(t){throw(0,k.toFileSystemProviderErrorCode)(t)===k.FileSystemProviderErrorCode.FileNotFound?new k.FileOperationError((0,y.localize)(2,null,this.resourceForError(a)),1):(0,k.ensureFileSystemProviderError)(t)}}async doResolveFile(a,s){const t=await this.withProvider(a),r=this.isPathCaseSensitive(t),i=s==null?void 0:s.resolveTo,o=s==null?void 0:s.resolveSingleChildDescendants,c=s==null?void 0:s.resolveMetadata,l=await t.stat(a);let u;return this.toFileStat(t,a,l,void 0,!!c,(v,w)=>(u||(u=p.TernarySearchTree.forUris(()=>!r),u.set(a,!0),(0,S.isNonEmptyArray)(i)&&i.forEach(d=>u.set(d,!0))),Boolean(u.findSuperstr(v.resource)||u.get(v.resource))?!0:v.isDirectory&&o?w===1:!1))}async toFileStat(a,s,t,r,i,o){var c;const{providerExtUri:l}=this.getExtUri(a),u={resource:s,name:l.basename(s),isFile:(t.type&k.FileType.File)!=0,isDirectory:(t.type&k.FileType.Directory)!=0,isSymbolicLink:(t.type&k.FileType.SymbolicLink)!=0,mtime:t.mtime,ctime:t.ctime,size:t.size,readonly:Boolean(((c=t.permissions)!==null&&c!==void 0?c:0)&k.FilePermission.Readonly)||Boolean(a.capabilities&2048),etag:(0,k.etag)({mtime:t.mtime,size:t.size})};if(u.isDirectory&&o(u,r)){try{const v=await a.readdir(s),w=await C.Promises.settled(v.map(async([d,T])=>{try{const F=l.joinPath(s,d),z=i?await a.stat(F):{type:T};return await this.toFileStat(a,F,z,v.length,i,o)}catch(F){return this.logService.trace(F),null}}));u.children=(0,S.coalesce)(w)}catch(v){this.logService.trace(v),u.children=[]}return u}return u}async resolveAll(a){return C.Promises.settled(a.map(async s=>{try{return{stat:await this.doResolveFile(s.resource,s.options),success:!0}}catch(t){return this.logService.trace(t),{stat:void 0,success:!1}}}))}async exists(a){const s=await this.withProvider(a);try{return!!await s.stat(a)}catch(t){return!1}}async canCreateFile(a,s){try{await this.doValidateCreateFile(a,s)}catch(t){return t}return!0}async doValidateCreateFile(a,s){if(!(s==null?void 0:s.overwrite)&&await this.exists(a))throw new k.FileOperationError((0,y.localize)(3,null,this.resourceForError(a)),3,s)}async createFile(a,s=f.VSBuffer.fromString(""),t){await this.doValidateCreateFile(a,t);const r=await this.writeFile(a,s);return this._onDidRunOperation.fire(new k.FileOperationEvent(a,0,r)),r}async writeFile(a,s,t){const r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),{providerExtUri:i}=this.getExtUri(r);try{await this.validateWriteFile(r,a,t)||await this.mkdirp(r,i.dirname(a));let c;if((0,k.hasReadWriteCapability)(r)&&!(s instanceof f.VSBuffer))if((0,m.isReadableStream)(s)){const l=await(0,m.peekStream)(s,3);l.ended?c=f.VSBuffer.concat(l.buffer):c=l}else c=(0,m.peekReadable)(s,l=>f.VSBuffer.concat(l),3);else c=s;!(0,k.hasOpenReadWriteCloseCapability)(r)||(0,k.hasReadWriteCapability)(r)&&c instanceof f.VSBuffer?await this.doWriteUnbuffered(r,a,t,c):await this.doWriteBuffered(r,a,t,c instanceof f.VSBuffer?(0,f.bufferToReadable)(c):c)}catch(o){throw new k.FileOperationError((0,y.localize)(4,null,this.resourceForError(a),(0,k.ensureFileSystemProviderError)(o).toString()),(0,k.toFileOperationResult)(o),t)}return this.resolve(a,{resolveMetadata:!0})}async validateWriteFile(a,s,t){if(!!(t==null?void 0:t.unlock)&&!(a.capabilities&8192))throw new Error((0,y.localize)(5,null,this.resourceForError(s)));let i;try{i=await a.stat(s)}catch(o){return}if((i.type&k.FileType.Directory)!=0)throw new k.FileOperationError((0,y.localize)(6,null,this.resourceForError(s)),0,t);if(this.throwIfFileIsReadonly(s,i),t&&typeof t.mtime=="number"&&typeof t.etag=="string"&&t.etag!==k.ETAG_DISABLED&&typeof i.mtime=="number"&&typeof i.size=="number"&&t.mtime<i.mtime&&t.etag!==(0,k.etag)({mtime:t.mtime,size:i.size}))throw new k.FileOperationError((0,y.localize)(7,null),3,t);return i}async readFile(a,s){const t=await this.withReadProvider(a);return(s==null?void 0:s.atomic)?this.doReadFileAtomic(t,a,s):this.doReadFile(t,a,s)}async doReadFileAtomic(a,s,t){return new Promise((r,i)=>{this.writeQueue.queueFor(s,this.getExtUri(a).providerExtUri).queue(async()=>{try{const o=await this.doReadFile(a,s,t);r(o)}catch(o){i(o)}})})}async doReadFile(a,s,t){const r=await this.doReadFileStream(a,s,Object.assign(Object.assign({},t),{preferUnbuffered:!0}));return Object.assign(Object.assign({},r),{value:await(0,f.streamToBuffer)(r.value)})}async readFileStream(a,s){const t=await this.withReadProvider(a);return this.doReadFileStream(t,a,s)}async doReadFileStream(a,s,t){const r=new h.CancellationTokenSource,i=this.validateReadFile(s,t).then(c=>c,c=>{throw r.cancel(),c});let o;try{t&&typeof t.etag=="string"&&t.etag!==k.ETAG_DISABLED&&await i,!((0,k.hasOpenReadWriteCloseCapability)(a)||(0,k.hasFileReadStreamCapability)(a))||(0,k.hasReadWriteCapability)(a)&&(t==null?void 0:t.preferUnbuffered)?o=this.readFileUnbuffered(a,s,t):(0,k.hasFileReadStreamCapability)(a)?o=this.readFileStreamed(a,s,r.token,t):o=this.readFileBuffered(a,s,r.token,t);const c=await i;return Object.assign(Object.assign({},c),{value:o})}catch(c){throw o&&await(0,m.consumeStream)(o),new k.FileOperationError((0,y.localize)(8,null,this.resourceForError(s),(0,k.ensureFileSystemProviderError)(c).toString()),(0,k.toFileOperationResult)(c),t)}}readFileStreamed(a,s,t,r=Object.create(null)){const i=a.readFileStream(s,r,t);return(0,m.transform)(i,{data:o=>o instanceof f.VSBuffer?o:f.VSBuffer.wrap(o),error:o=>new k.FileOperationError((0,y.localize)(9,null,this.resourceForError(s),(0,k.ensureFileSystemProviderError)(o).toString()),(0,k.toFileOperationResult)(o),r)},o=>f.VSBuffer.concat(o))}readFileBuffered(a,s,t,r=Object.create(null)){const i=(0,f.newWriteableBufferStream)();return(0,D.readFileIntoStream)(a,s,i,o=>o,Object.assign(Object.assign({},r),{bufferSize:this.BUFFER_SIZE,errorTransformer:o=>new k.FileOperationError((0,y.localize)(10,null,this.resourceForError(s),(0,k.ensureFileSystemProviderError)(o).toString()),(0,k.toFileOperationResult)(o),r)}),t),i}readFileUnbuffered(a,s,t){const r=(0,m.newWriteableStream)(i=>f.VSBuffer.concat(i));return(async()=>{try{let i=await a.readFile(s);t&&typeof t.position=="number"&&(i=i.slice(t.position)),t&&typeof t.length=="number"&&(i=i.slice(0,t.length)),this.validateReadFileLimits(s,i.byteLength,t),r.end(f.VSBuffer.wrap(i))}catch(i){r.error(i),r.end()}})(),r}async validateReadFile(a,s){const t=await this.resolve(a,{resolveMetadata:!0});if(t.isDirectory)throw new k.FileOperationError((0,y.localize)(11,null,this.resourceForError(a)),0,s);if(s&&typeof s.etag=="string"&&s.etag!==k.ETAG_DISABLED&&s.etag===t.etag)throw new k.FileOperationError((0,y.localize)(12,null),2,s);return this.validateReadFileLimits(a,t.size,s),t}validateReadFileLimits(a,s,t){if(t==null?void 0:t.limits){let r;if(typeof t.limits.memory=="number"&&s>t.limits.memory&&(r=9),typeof t.limits.size=="number"&&s>t.limits.size&&(r=7),typeof r=="number")throw new k.FileOperationError((0,y.localize)(13,null,this.resourceForError(a)),r)}}async canMove(a,s,t){return this.doCanMoveCopy(a,s,"move",t)}async canCopy(a,s,t){return this.doCanMoveCopy(a,s,"copy",t)}async doCanMoveCopy(a,s,t,r){if(a.toString()!==s.toString())try{const i=t==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a):await this.withReadProvider(a),o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s);await this.doValidateMoveCopy(i,a,o,s,t,r)}catch(i){return i}return!0}async move(a,s,t){const r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),o=await this.doMoveCopy(r,a,i,s,"move",!!t),c=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new k.FileOperationEvent(a,o==="move"?2:3,c)),c}async copy(a,s,t){const r=await this.withReadProvider(a),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),o=await this.doMoveCopy(r,a,i,s,"copy",!!t),c=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new k.FileOperationEvent(a,o==="copy"?3:2,c)),c}async doMoveCopy(a,s,t,r,i,o){if(s.toString()===r.toString())return i;const{exists:c,isSameResourceWithDifferentPathCase:l}=await this.doValidateMoveCopy(a,s,t,r,i,o);if(c&&!l&&o&&await this.del(r,{recursive:!0}),await this.mkdirp(t,this.getExtUri(t).providerExtUri.dirname(r)),i==="copy"){if(a===t&&(0,k.hasFileFolderCopyCapability)(a))await a.copy(s,r,{overwrite:o});else{const u=await this.resolve(s);u.isDirectory?await this.doCopyFolder(a,u,t,r):await this.doCopyFile(a,s,t,r)}return i}else return a===t?(await a.rename(s,r,{overwrite:o}),i):(await this.doMoveCopy(a,s,t,r,"copy",o),await this.del(s,{recursive:!0}),"copy")}async doCopyFile(a,s,t,r){if((0,k.hasOpenReadWriteCloseCapability)(a)&&(0,k.hasOpenReadWriteCloseCapability)(t))return this.doPipeBuffered(a,s,t,r);if((0,k.hasOpenReadWriteCloseCapability)(a)&&(0,k.hasReadWriteCapability)(t))return this.doPipeBufferedToUnbuffered(a,s,t,r);if((0,k.hasReadWriteCapability)(a)&&(0,k.hasOpenReadWriteCloseCapability)(t))return this.doPipeUnbufferedToBuffered(a,s,t,r);if((0,k.hasReadWriteCapability)(a)&&(0,k.hasReadWriteCapability)(t))return this.doPipeUnbuffered(a,s,t,r)}async doCopyFolder(a,s,t,r){await t.mkdir(r),Array.isArray(s.children)&&await C.Promises.settled(s.children.map(async i=>{const o=this.getExtUri(t).providerExtUri.joinPath(r,i.name);return i.isDirectory?this.doCopyFolder(a,await this.resolve(i.resource),t,o):this.doCopyFile(a,i.resource,t,o)}))}async doValidateMoveCopy(a,s,t,r,i,o){let c=!1;if(a===t){const{providerExtUri:u,isPathCaseSensitive:v}=this.getExtUri(a);if(v||(c=u.isEqual(s,r)),c&&i==="copy")throw new Error((0,y.localize)(14,null,this.resourceForError(s),this.resourceForError(r)));if(!c&&u.isEqualOrParent(r,s))throw new Error((0,y.localize)(15,null,this.resourceForError(s),this.resourceForError(r)))}const l=await this.exists(r);if(l&&!c){if(!o)throw new k.FileOperationError((0,y.localize)(16,null,this.resourceForError(s),this.resourceForError(r)),4);if(a===t){const{providerExtUri:u}=this.getExtUri(a);if(u.isEqualOrParent(s,r))throw new Error((0,y.localize)(17,null,this.resourceForError(s),this.resourceForError(r)))}}return{exists:l,isSameResourceWithDifferentPathCase:c}}getExtUri(a){const s=this.isPathCaseSensitive(a);return{providerExtUri:s?R.extUri:R.extUriIgnorePathCase,isPathCaseSensitive:s}}isPathCaseSensitive(a){return!!(a.capabilities&1024)}async createFolder(a){const s=this.throwIfFileSystemIsReadonly(await this.withProvider(a),a);await this.mkdirp(s,a);const t=await this.resolve(a,{resolveMetadata:!0});return this._onDidRunOperation.fire(new k.FileOperationEvent(a,0,t)),t}async mkdirp(a,s){const t=[],{providerExtUri:r}=this.getExtUri(a);for(;!r.isEqual(s,r.dirname(s));)try{if(((await a.stat(s)).type&k.FileType.Directory)==0)throw new Error((0,y.localize)(18,null,this.resourceForError(s)));break}catch(i){if((0,k.toFileSystemProviderErrorCode)(i)!==k.FileSystemProviderErrorCode.FileNotFound)throw i;t.push(r.basename(s)),s=r.dirname(s)}for(let i=t.length-1;i>=0;i--){s=r.joinPath(s,t[i]);try{await a.mkdir(s)}catch(o){if((0,k.toFileSystemProviderErrorCode)(o)!==k.FileSystemProviderErrorCode.FileExists)throw o}}}async canDelete(a,s){try{await this.doValidateDelete(a,s)}catch(t){return t}return!0}async doValidateDelete(a,s){const t=this.throwIfFileSystemIsReadonly(await this.withProvider(a),a);if(!!(s==null?void 0:s.useTrash)&&!(t.capabilities&4096))throw new Error((0,y.localize)(19,null,this.resourceForError(a)));let i;try{i=await t.stat(a)}catch(c){}if(i)this.throwIfFileIsReadonly(a,i);else throw new k.FileOperationError((0,y.localize)(20,null,this.resourceForError(a)),1);if(!!!(s==null?void 0:s.recursive)){const c=await this.resolve(a);if(c.isDirectory&&Array.isArray(c.children)&&c.children.length>0)throw new Error((0,y.localize)(21,null,this.resourceForError(a)))}return t}async del(a,s){const t=await this.doValidateDelete(a,s),r=!!(s==null?void 0:s.useTrash),i=!!(s==null?void 0:s.recursive);await t.delete(a,{recursive:i,useTrash:r}),this._onDidRunOperation.fire(new k.FileOperationEvent(a,1))}watch(a,s={recursive:!1,excludes:[]}){let t=!1,r=()=>{t=!0};return this.doWatch(a,s).then(i=>{t?(0,L.dispose)(i):r=()=>(0,L.dispose)(i)},i=>this.logService.error(i)),(0,L.toDisposable)(()=>r())}async doWatch(a,s){const t=await this.withProvider(a),r=this.toWatchKey(t,a,s),i=this.activeWatchers.get(r)||{count:0,disposable:t.watch(a,s)};return this.activeWatchers.has(r)||this.activeWatchers.set(r,i),i.count+=1,(0,L.toDisposable)(()=>{i.count--,i.count===0&&((0,L.dispose)(i.disposable),this.activeWatchers.delete(r))})}toWatchKey(a,s,t){const{providerExtUri:r}=this.getExtUri(a);return[r.getComparisonKey(s),String(t.recursive),t.excludes.join()].join()}dispose(){super.dispose(),this.activeWatchers.forEach(a=>(0,L.dispose)(a.disposable)),this.activeWatchers.clear()}async doWriteBuffered(a,s,t,r){return this.writeQueue.queueFor(s,this.getExtUri(a).providerExtUri).queue(async()=>{var i;const o=await a.open(s,{create:!0,unlock:(i=t==null?void 0:t.unlock)!==null&&i!==void 0?i:!1});try{(0,m.isReadableStream)(r)||(0,m.isReadableBufferedStream)(r)?await this.doWriteStreamBufferedQueued(a,o,r):await this.doWriteReadableBufferedQueued(a,o,r)}catch(c){throw(0,k.ensureFileSystemProviderError)(c)}finally{await a.close(o)}})}async doWriteStreamBufferedQueued(a,s,t){let r=0,i;if((0,m.isReadableBufferedStream)(t)){if(t.buffer.length>0){const o=f.VSBuffer.concat(t.buffer);await this.doWriteBuffer(a,s,o,o.byteLength,r,0),r+=o.byteLength}if(t.ended)return;i=t.stream}else i=t;return new Promise(async(o,c)=>{(0,m.listenStream)(i,{onData:async l=>{i.pause();try{await this.doWriteBuffer(a,s,l,l.byteLength,r,0)}catch(u){return c(u)}r+=l.byteLength,setTimeout(()=>i.resume())},onError:l=>c(l),onEnd:()=>o()})})}async doWriteReadableBufferedQueued(a,s,t){let r=0,i;for(;(i=t.read())!==null;)await this.doWriteBuffer(a,s,i,i.byteLength,r,0),r+=i.byteLength}async doWriteBuffer(a,s,t,r,i,o){let c=0;for(;c<r;)c+=await a.write(s,i+c,t.buffer,o+c,r-c)}async doWriteUnbuffered(a,s,t,r){return this.writeQueue.queueFor(s,this.getExtUri(a).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(a,s,t,r))}async doWriteUnbufferedQueued(a,s,t,r){var i;let o;r instanceof f.VSBuffer?o=r:(0,m.isReadableStream)(r)?o=await(0,f.streamToBuffer)(r):(0,m.isReadableBufferedStream)(r)?o=await(0,f.bufferedStreamToBuffer)(r):o=(0,f.readableToBuffer)(r),await a.writeFile(s,o.buffer,{create:!0,overwrite:!0,unlock:(i=t==null?void 0:t.unlock)!==null&&i!==void 0?i:!1})}async doPipeBuffered(a,s,t,r){return this.writeQueue.queueFor(r,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeBufferedQueued(a,s,t,r))}async doPipeBufferedQueued(a,s,t,r){let i,o;try{i=await a.open(s,{create:!1}),o=await t.open(r,{create:!0,unlock:!1});const c=f.VSBuffer.alloc(this.BUFFER_SIZE);let l=0,u=0,v=0;do v=await a.read(i,l,c.buffer,u,c.byteLength-u),await this.doWriteBuffer(t,o,c,v,l,u),l+=v,u+=v,u===c.byteLength&&(u=0);while(v>0)}catch(c){throw(0,k.ensureFileSystemProviderError)(c)}finally{await C.Promises.settled([typeof i=="number"?a.close(i):Promise.resolve(),typeof o=="number"?t.close(o):Promise.resolve()])}}async doPipeUnbuffered(a,s,t,r){return this.writeQueue.queueFor(r,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(a,s,t,r))}async doPipeUnbufferedQueued(a,s,t,r){return t.writeFile(r,await a.readFile(s),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(a,s,t,r){return this.writeQueue.queueFor(r,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(a,s,t,r))}async doPipeUnbufferedToBufferedQueued(a,s,t,r){const i=await t.open(r,{create:!0,unlock:!1});try{const o=await a.readFile(s);await this.doWriteBuffer(t,i,f.VSBuffer.wrap(o),o.byteLength,0,0)}catch(o){throw(0,k.ensureFileSystemProviderError)(o)}finally{await t.close(i)}}async doPipeBufferedToUnbuffered(a,s,t,r){const i=await(0,f.streamToBuffer)(this.readFileBuffered(a,s,h.CancellationToken.None));await this.doWriteUnbuffered(t,r,void 0,i)}throwIfFileSystemIsReadonly(a,s){if(a.capabilities&2048)throw new k.FileOperationError((0,y.localize)(22,null,this.resourceForError(s)),6);return a}throwIfFileIsReadonly(a,s){var t;if(((t=s.permissions)!==null&&t!==void 0?t:0)&k.FilePermission.Readonly)throw new k.FileOperationError((0,y.localize)(23,null,this.resourceForError(a)),6)}resourceForError(a){return a.scheme===E.Schemas.file?a.fsPath:a.toString(!0)}};I=de([Y(0,n.ILogService)],I),e.FileService=I}),define(Z[159],ee([0,1,2,10,3,6,17,7,14,41,8,18,117,75,135,137,134,148,48,78,19,25]),function(G,e,y,P,L,k,A,R,p,S,n,f,m,C,h,E,D,b,I,g,a,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0;class t extends y.Disposable{constructor(i,o){var c;super();this.logService=i,this.options=o,this.BUFFER_SIZE=((c=this.options)===null||c===void 0?void 0:c.bufferSize)||64*1024,this.onDidChangeCapabilities=L.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0,this._onDidWatchErrorOccur=this._register(new L.Emitter),this.onDidErrorOccur=this._onDidWatchErrorOccur.event,this._onDidChangeFile=this._register(new L.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new n.ThrottledDelayer(0))}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,k.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(i){try{const{stat:o,symbolicLink:c}=await A.SymlinkSupport.stat(this.toFilePath(i));return{type:this.toType(o,c),ctime:o.birthtime.getTime(),mtime:o.mtime.getTime(),size:o.size}}catch(o){throw this.toFileSystemProviderError(o)}}async readdir(i){try{const o=await(0,A.readdir)(this.toFilePath(i),{withFileTypes:!0}),c=[];return await Promise.all(o.map(async l=>{try{let u;l.isSymbolicLink()?u=(await this.stat((0,p.joinPath)(i,l.name))).type:u=this.toType(l),c.push([l.name,u])}catch(u){this.logService.trace(u)}})),c}catch(o){throw this.toFileSystemProviderError(o)}}toType(i,o){let c;return(o==null?void 0:o.dangling)?c=P.FileType.Unknown:i.isFile()?c=P.FileType.File:i.isDirectory()?c=P.FileType.Directory:c=P.FileType.Unknown,o&&(c|=P.FileType.SymbolicLink),c}async readFile(i){try{const o=this.toFilePath(i);return await A.Promises.readFile(o)}catch(o){throw this.toFileSystemProviderError(o)}}readFileStream(i,o,c){const l=(0,I.newWriteableStream)(u=>s.VSBuffer.concat(u.map(v=>s.VSBuffer.wrap(v))).buffer);return(0,g.readFileIntoStream)(this,i,l,u=>u.buffer,Object.assign(Object.assign({},o),{bufferSize:this.BUFFER_SIZE}),c),l}async writeFile(i,o,c){let l;try{const u=this.toFilePath(i);if(!c.create||!c.overwrite){if(await(0,A.exists)(u)){if(!c.overwrite)throw(0,P.createFileSystemProviderError)((0,m.localize)(0,null),P.FileSystemProviderErrorCode.FileExists)}else if(!c.create)throw(0,P.createFileSystemProviderError)((0,m.localize)(1,null),P.FileSystemProviderErrorCode.FileNotFound)}l=await this.open(i,{create:!0,unlock:c.unlock}),await this.write(l,0,o,0,o.byteLength)}catch(u){throw await this.toFileSystemProviderWriteError(i,u)}finally{typeof l=="number"&&await this.close(l)}}async open(i,o){try{const c=this.toFilePath(i);if((0,P.isFileOpenForWriteOptions)(o)&&o.unlock)try{const{stat:v}=await A.SymlinkSupport.stat(c);v.mode&128||await A.Promises.chmod(c,v.mode|128)}catch(v){this.logService.trace(v)}let l;if((0,P.isFileOpenForWriteOptions)(o)){if(k.isWindows)try{await A.Promises.truncate(c,0),l="r+"}catch(v){v.code!=="ENOENT"&&this.logService.trace(v)}l||(l="w")}else l="r";const u=await A.Promises.open(c,l);return this.mapHandleToPos.set(u,0),(0,P.isFileOpenForWriteOptions)(o)&&this.writeHandles.set(u,i),u}catch(c){throw(0,P.isFileOpenForWriteOptions)(o)?await this.toFileSystemProviderWriteError(i,c):this.toFileSystemProviderError(c)}}async close(i){try{if(this.mapHandleToPos.delete(i),this.writeHandles.delete(i)&&this.canFlush)try{await A.Promises.fdatasync(i)}catch(o){this.canFlush=!1,this.logService.error(o)}return await A.Promises.close(i)}catch(o){throw this.toFileSystemProviderError(o)}}async read(i,o,c,l,u){const v=this.normalizePos(i,o);let w=null;try{const d=await A.Promises.read(i,c,l,u,v);return typeof d=="number"?w=d:w=d.bytesRead,w}catch(d){throw this.toFileSystemProviderError(d)}finally{this.updatePos(i,v,w)}}normalizePos(i,o){return o===this.mapHandleToPos.get(i)?null:o}updatePos(i,o,c){const l=this.mapHandleToPos.get(i);typeof l=="number"&&(typeof o=="number"||(typeof c=="number"?this.mapHandleToPos.set(i,l+c):this.mapHandleToPos.delete(i)))}async write(i,o,c,l,u){return(0,n.retry)(()=>this.doWrite(i,o,c,l,u),100,3)}async doWrite(i,o,c,l,u){const v=this.normalizePos(i,o);let w=null;try{const d=await A.Promises.write(i,c,l,u,v);return typeof d=="number"?w=d:w=d.bytesWritten,w}catch(d){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(i),d)}finally{this.updatePos(i,v,w)}}async mkdir(i){try{await A.Promises.mkdir(this.toFilePath(i))}catch(o){throw this.toFileSystemProviderError(o)}}async delete(i,o){try{const c=this.toFilePath(i);await this.doDelete(c,o)}catch(c){throw this.toFileSystemProviderError(c)}}async doDelete(i,o){o.recursive?await(0,A.rimraf)(i,A.RimRafMode.MOVE):await A.Promises.unlink(i)}async rename(i,o,c){const l=this.toFilePath(i),u=this.toFilePath(o);if(l!==u)try{await this.validateTargetDeleted(i,o,"move",c.overwrite),await(0,A.move)(l,u)}catch(v){throw(v.code==="EINVAL"||v.code==="EBUSY"||v.code==="ENAMETOOLONG")&&(v=new Error((0,m.localize)(2,null,(0,R.basename)(l),(0,R.basename)((0,R.dirname)(u)),v.toString()))),this.toFileSystemProviderError(v)}}async copy(i,o,c){const l=this.toFilePath(i),u=this.toFilePath(o);if(l!==u)try{await this.validateTargetDeleted(i,o,"copy",c.overwrite),await(0,A.copy)(l,u,{preserveSymlinks:!0})}catch(v){throw(v.code==="EINVAL"||v.code==="EBUSY"||v.code==="ENAMETOOLONG")&&(v=new Error((0,m.localize)(3,null,(0,R.basename)(l),(0,R.basename)((0,R.dirname)(u)),v.toString()))),this.toFileSystemProviderError(v)}}async validateTargetDeleted(i,o,c,l){const u=this.toFilePath(i),v=this.toFilePath(o);let w=!1;if(!!(this.capabilities&1024)||(w=(0,S.isEqual)(u,v,!0)),w&&c==="copy")throw(0,P.createFileSystemProviderError)((0,m.localize)(4,null),P.FileSystemProviderErrorCode.FileExists);if(!w&&await(0,A.exists)(v)){if(!l)throw(0,P.createFileSystemProviderError)((0,m.localize)(5,null),P.FileSystemProviderErrorCode.FileExists);await this.delete(o,{recursive:!0,useTrash:!1})}}watch(i,o){return o.recursive?this.watchRecursive(i,o.excludes):this.watchNonRecursive(i)}watchRecursive(i,o){const c={path:this.toFilePath(i),excludes:o},l=(0,a.insert)(this.recursiveFoldersToWatch,c);return this.refreshRecursiveWatchers(),(0,y.toDisposable)(()=>{l(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(async()=>{this.doRefreshRecursiveWatchers()})}doRefreshRecursiveWatchers(){var i,o,c;if(this.recursiveWatcher instanceof D.FileWatcher)this.recursiveWatcher.setFolders(this.recursiveFoldersToWatch);else if((0,y.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,this.recursiveFoldersToWatch.length>0){let l,u;((o=(i=this.options)===null||i===void 0?void 0:i.watcher)===null||o===void 0?void 0:o.usePolling)?(l=h.FileWatcher,u=(c=this.options)===null||c===void 0?void 0:c.watcher):this.recursiveFoldersToWatch.length===1?k.isWindows?l=E.FileWatcher:l=h.FileWatcher:l=D.FileWatcher,this.recursiveWatcher=new l(this.recursiveFoldersToWatch,v=>this._onDidChangeFile.fire((0,C.toFileChanges)(v)),v=>{v.type==="error"&&this._onDidWatchErrorOccur.fire(v.message),this.logService[v.type](v.message)},this.logService.getLevel()===f.LogLevel.Trace,u),this.recursiveWatcherLogLevelListener||(this.recursiveWatcherLogLevelListener=this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher&&this.recursiveWatcher.setVerboseLogging(this.logService.getLevel()===f.LogLevel.Trace)}))}}watchNonRecursive(i){const o=new b.FileWatcher(this.toFilePath(i),l=>this._onDidChangeFile.fire((0,C.toFileChanges)(l)),l=>{l.type==="error"&&this._onDidWatchErrorOccur.fire(l.message),this.logService[l.type](l.message)},this.logService.getLevel()===f.LogLevel.Trace),c=this.logService.onDidChangeLogLevel(()=>{o.setVerboseLogging(this.logService.getLevel()===f.LogLevel.Trace)});return(0,y.combinedDisposable)(o,c)}toFilePath(i){return(0,R.normalize)(i.fsPath)}toFileSystemProviderError(i){if(i instanceof P.FileSystemProviderError)return i;let o;switch(i.code){case"ENOENT":o=P.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":o=P.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":o=P.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":o=P.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":o=P.FileSystemProviderErrorCode.NoPermissions;break;default:o=P.FileSystemProviderErrorCode.Unknown}return(0,P.createFileSystemProviderError)(i,o)}async toFileSystemProviderWriteError(i,o){let c=this.toFileSystemProviderError(o);if(i&&c.code===P.FileSystemProviderErrorCode.NoPermissions)try{const{stat:l}=await A.SymlinkSupport.stat(this.toFilePath(i));l.mode&128||(c=(0,P.createFileSystemProviderError)(o,P.FileSystemProviderErrorCode.FileWriteLocked))}catch(l){this.logService.trace(l)}return c}dispose(){super.dispose(),(0,y.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,(0,y.dispose)(this.recursiveWatcherLogLevelListener),this.recursiveWatcherLogLevelListener=void 0}}e.DiskFileSystemProvider=t}),define(Z[27],ee([0,1,4]),function(G,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProductService=void 0,e.IProductService=(0,y.createDecorator)("productService")}),define(Z[160],ee([0,1,7,17,27,2,11,18,9]),function(G,e,y,P,L,k,A,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackCachedDataCleaner=void 0;let S=class extends k.Disposable{constructor(f,m,C){super();this._environmentService=f,this._logService=m,this._productService=C,this._DataMaxAge=this._productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this._environmentService.isBuilt&&this._manageCachedDataSoon()}_manageCachedDataSoon(){let f=setTimeout(async()=>{f=void 0,this._logService.info("Starting to clean up unused language packs.");try{const m=Object.create(null),C=JSON.parse(await P.Promises.readFile(y.join(this._environmentService.userDataPath,"languagepacks.json"),"utf8"));for(let b of Object.keys(C)){const I=C[b];m[`${I.hash}.${b}`]=!0}const h=y.join(this._environmentService.userDataPath,"clp");if(!await P.exists(h))return;for(let b of await P.readdir(h)){if(m[b]){this._logService.info(`Skipping directory ${b}. Language pack still in use.`);continue}this._logService.info("Removing unused language pack:",b),await P.rimraf(y.join(h,b))}const D=Date.now();for(let b of Object.keys(m)){const I=y.join(h,b);for(let g of await P.readdir(I)){if(g==="tcf.json")continue;const a=y.join(I,g),s=await P.Promises.stat(a);s.isDirectory()&&D-s.mtime.getTime()>this._DataMaxAge&&(this._logService.info("Removing language pack cache entry: ",y.join(b,g)),await P.rimraf(a))}}}catch(m){(0,A.onUnexpectedError)(m)}},40*1e3);this._register((0,k.toDisposable)(()=>{f!==void 0&&clearTimeout(f)}))}};S=de([Y(0,p.INativeEnvironmentService),Y(1,R.ILogService),Y(2,L.IProductService)],S),e.LanguagePackCachedDataCleaner=S}),define(Z[161],ee([0,1,7,11,2,17,27]),function(G,e,y,P,L,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeCachedDataCleaner=void 0;let R=class{constructor(S,n){this.nodeCachedDataDir=S,this.productService=n,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this._disposables=new L.DisposableStore,this._manageCachedDataSoon()}dispose(){this._disposables.dispose()}_manageCachedDataSoon(){if(!this.nodeCachedDataDir)return;const S=(0,y.dirname)(this.nodeCachedDataDir),n=(0,y.basename)(this.nodeCachedDataDir);let f=setTimeout(()=>{f=void 0,(0,k.readdir)(S).then(m=>{const C=Date.now(),h=[];return m.forEach(E=>{if(E!==n){const D=(0,y.join)(S,E);h.push(k.Promises.stat(D).then(b=>{if(b.isDirectory()&&C-b.mtime.getTime()>this._DataMaxAge)return(0,k.rimraf)(D)}))}}),Promise.all(h)}).then(void 0,P.onUnexpectedError)},30*1e3);this._disposables.add((0,L.toDisposable)(()=>{f&&(clearTimeout(f),f=void 0)}))}};R=de([Y(1,A.IProductService)],R),e.NodeCachedDataCleaner=R}),define(Z[31],ee([0,1,15,86]),function(G,e,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class L{constructor(){this.data=new Map}add(A,R){P.ok(y.isString(A)),P.ok(y.isObject(R)),P.ok(!this.data.has(A),"There is already an extension with this id"),this.data.set(A,R)}knows(A){return this.data.has(A)}as(A){return this.data.get(A)||null}}e.Registry=new L}),define(Z[79],ee([0,1,31,3]),function(G,e,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function L(R){return R.length>0&&R.charAt(R.length-1)==="#"?R.substring(0,R.length-1):R}class k{constructor(){this._onDidChangeSchema=new P.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(p,S){this.schemasById[L(p)]=S,this._onDidChangeSchema.fire(p)}notifySchemaChanged(p){this._onDidChangeSchema.fire(p)}getSchemaContributions(){return{schemas:this.schemasById}}}const A=new k;y.Registry.add(e.Extensions.JSONContribution,A)}),define(Z[37],ee([0,1,107,3,31,15,79]),function(G,e,y,P,L,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=void 0,e.Extensions={Configuration:"base.contributions.configuration"};var R;(function(D){D[D.APPLICATION=1]="APPLICATION",D[D.MACHINE=2]="MACHINE",D[D.WINDOW=3]="WINDOW",D[D.RESOURCE=4]="RESOURCE",D[D.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",D[D.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(R=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const p=L.Registry.as(A.Extensions.JSONContribution);class S{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new P.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new P.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:y.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},p.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(b,I=!0){this.registerConfigurations([b],I)}registerConfigurations(b,I=!0){const g=[];b.forEach(a=>{g.push(...this.validateAndRegisterProperties(a,I,a.extensionInfo)),this.configurationContributors.push(a),this.registerJSONConfiguration(a)}),p.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(g)}deregisterConfigurations(b){const I=[],g=a=>{if(a.properties)for(const s in a.properties)I.push(s),delete this.configurationProperties[s],this.removeFromSchema(s,a.properties[s]);a.allOf&&a.allOf.forEach(s=>g(s))};for(const a of b){g(a);const s=this.configurationContributors.indexOf(a);s!==-1&&this.configurationContributors.splice(s,1)}p.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(I)}registerDefaultConfigurations(b){const I=[],g=[];for(const a of b)for(const s in a)if(I.push(s),e.OVERRIDE_PROPERTY_PATTERN.test(s)){this.defaultValues[s]=Object.assign(Object.assign({},this.defaultValues[s]||{}),a[s]);const t={type:"object",default:this.defaultValues[s],description:y.localize(1,null,s),$ref:e.resourceLanguageSettingsSchemaId};g.push(f(s)),this.configurationProperties[s]=t,this.defaultLanguageConfigurationOverridesNode.properties[s]=t}else{this.defaultValues[s]=a[s];const t=this.configurationProperties[s];t&&(this.updatePropertyDefaultValue(s,t),this.updateSchema(s,t))}this.registerOverrideIdentifiers(g),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(I)}deregisterDefaultConfigurations(b){const I=[];for(const g of b)for(const a in g)if(I.push(a),delete this.defaultValues[a],e.OVERRIDE_PROPERTY_PATTERN.test(a))delete this.configurationProperties[a],delete this.defaultLanguageConfigurationOverridesNode.properties[a];else{const s=this.configurationProperties[a];s&&(this.updatePropertyDefaultValue(a,s),this.updateSchema(a,s))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(I)}notifyConfigurationSchemaUpdated(...b){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(b){for(const I of b)this.overrideIdentifiers.add(I);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(b,I=!0,g,a=3){var s;a=k.isUndefinedOrNull(b.scope)?a:b.scope;let t=[],r=b.properties;if(r)for(let o in r){if(I&&h(o)){delete r[o];continue}const c=r[o];if(this.updatePropertyDefaultValue(o,c),e.OVERRIDE_PROPERTY_PATTERN.test(o)?c.scope=void 0:(c.scope=k.isUndefinedOrNull(c.scope)?a:c.scope,c.restricted=k.isUndefinedOrNull(c.restricted)?!!((s=g==null?void 0:g.restrictedConfigurations)===null||s===void 0?void 0:s.includes(o)):c.restricted),r[o].hasOwnProperty("included")&&!r[o].included){this.excludedConfigurationProperties[o]=r[o],delete r[o];continue}else this.configurationProperties[o]=r[o];!r[o].deprecationMessage&&r[o].markdownDeprecationMessage&&(r[o].deprecationMessage=r[o].markdownDeprecationMessage),t.push(o)}let i=b.allOf;if(i)for(let o of i)t.push(...this.validateAndRegisterProperties(o,I,g,a));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(b){const I=g=>{let a=g.properties;if(a)for(const t in a)this.updateSchema(t,a[t]);let s=g.allOf;s&&s.forEach(I)};I(b)}updateSchema(b,I){switch(e.allSettings.properties[b]=I,I.scope){case 1:e.applicationSettings.properties[b]=I;break;case 2:e.machineSettings.properties[b]=I;break;case 6:e.machineOverridableSettings.properties[b]=I;break;case 3:e.windowSettings.properties[b]=I;break;case 4:e.resourceSettings.properties[b]=I;break;case 5:e.resourceSettings.properties[b]=I,this.resourceLanguageSettingsSchema.properties[b]=I;break}}removeFromSchema(b,I){switch(delete e.allSettings.properties[b],I.scope){case 1:delete e.applicationSettings.properties[b];break;case 2:delete e.machineSettings.properties[b];break;case 6:delete e.machineOverridableSettings.properties[b];break;case 3:delete e.windowSettings.properties[b];break;case 4:case 5:delete e.resourceSettings.properties[b];break}}updateOverridePropertyPatternKey(){for(const b of this.overrideIdentifiers.values()){const I=`[${b}]`,g={type:"object",description:y.localize(2,null),errorMessage:y.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(I,g),e.allSettings.properties[I]=g,e.applicationSettings.properties[I]=g,e.machineSettings.properties[I]=g,e.machineOverridableSettings.properties[I]=g,e.windowSettings.properties[I]=g,e.resourceSettings.properties[I]=g}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(b,I){let g=this.defaultValues[b];k.isUndefined(g)&&(g=I.default),k.isUndefined(g)&&(g=m(I.type)),I.default=g}}const n="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(n);function f(D){return D.substring(1,D.length-1)}e.overrideIdentifierFromKey=f;function m(D){switch(Array.isArray(D)?D[0]:D){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=m;const C=new S;L.Registry.add(e.Extensions.Configuration,C);function h(D){return D.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(D)?y.localize(5,null,D):C.getConfigurationProperties()[D]!==void 0?y.localize(6,null,D):null:y.localize(4,null)}e.validateProperty=h;function E(){const D=[],b=C.getConfigurationProperties();for(const I of Object.keys(b))D.push([I,b[I].scope]);return D.push(["launch",4]),D.push(["task",4]),D}e.getScopes=E}),define(Z[23],ee([0,1,26,15,5,31,4,37]),function(G,e,y,P,L,k,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,A.createDecorator)("configurationService");function p(r){return r&&typeof r=="object"&&(!r.overrideIdentifier||typeof r.overrideIdentifier=="string")&&(!r.resource||r.resource instanceof L.URI)}e.isConfigurationOverrides=p;var S;(function(r){r[r.USER=1]="USER",r[r.USER_LOCAL=2]="USER_LOCAL",r[r.USER_REMOTE=3]="USER_REMOTE",r[r.WORKSPACE=4]="WORKSPACE",r[r.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",r[r.DEFAULT=6]="DEFAULT",r[r.MEMORY=7]="MEMORY"})(S=e.ConfigurationTarget||(e.ConfigurationTarget={}));function n(r){switch(r){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=n;function f(r,i){const o=i?r?i.keys.filter(T=>r.keys.indexOf(T)===-1):[...i.keys]:[],c=r?i?r.keys.filter(T=>i.keys.indexOf(T)===-1):[...r.keys]:[],l=[];if(i&&r){for(const T of r.keys)if(i.keys.indexOf(T)!==-1){const F=b(r.contents,T),z=b(i.contents,T);y.equals(F,z)||l.push(T)}}const u=[],v=T=>{const F={};for(const z of T)for(const B of z.identifiers)F[s(B)]=z;return F},w=i?v(i.overrides):{},d=r?v(r.overrides):{};if(Object.keys(w).length)for(const T of o){const F=w[T];F&&u.push([(0,R.overrideIdentifierFromKey)(T),F.keys])}if(Object.keys(d).length)for(const T of c){const F=d[T];F&&u.push([(0,R.overrideIdentifierFromKey)(T),F.keys])}if(Object.keys(w).length&&Object.keys(d).length)for(const T of l){const F=d[T],z=w[T];if(F&&z){const B=f({contents:F.contents,keys:F.keys,overrides:[]},{contents:z.contents,keys:z.keys,overrides:[]});u.push([(0,R.overrideIdentifierFromKey)(T),[...B.added,...B.removed,...B.updated]])}}return{added:o,removed:c,updated:l,overrides:u}}e.compare=f;function m(r,i){const o=[];for(const c of Object.keys(r))if(R.OVERRIDE_PROPERTY_PATTERN.test(c)){const l={};for(const u in r[c])l[u]=r[c][u];o.push({identifiers:[(0,R.overrideIdentifierFromKey)(c).trim()],keys:Object.keys(l),contents:C(l,i)})}return o}e.toOverrides=m;function C(r,i){const o=Object.create(null);for(let c in r)h(o,c,r[c],i);return o}e.toValuesTree=C;function h(r,i,o,c){const l=i.split("."),u=l.pop();let v=r;for(let w=0;w<l.length;w++){let d=l[w],T=v[d];switch(typeof T){case"undefined":T=v[d]=Object.create(null);break;case"object":break;default:c(`Ignoring ${i} as ${l.slice(0,w+1).join(".")} is ${JSON.stringify(T)}`);return}v=T}if(typeof v=="object"&&v!==null)try{v[u]=o}catch(w){c(`Ignoring ${i} as ${l.join(".")} is ${JSON.stringify(v)}`)}else c(`Ignoring ${i} as ${l.join(".")} is ${JSON.stringify(v)}`)}e.addToValueTree=h;function E(r,i){const o=i.split(".");D(r,o)}e.removeFromValueTree=E;function D(r,i){const o=i.shift();if(i.length===0){delete r[o];return}if(Object.keys(r).indexOf(o)!==-1){const c=r[o];typeof c=="object"&&!Array.isArray(c)&&(D(c,i),Object.keys(c).length===0&&delete r[o])}}function b(r,i,o){function c(v,w){let d=v;for(const T of w){if(typeof d!="object"||d===null)return;d=d[T]}return d}const l=i.split("."),u=c(r,l);return typeof u=="undefined"?o:u}e.getConfigurationValue=b;function I(r,i,o){Object.keys(i).forEach(c=>{c!=="__proto__"&&(c in r?P.isObject(r[c])&&P.isObject(i[c])?I(r[c],i[c],o):o&&(r[c]=i[c]):r[c]=i[c])})}e.merge=I;function g(){const r=k.Registry.as(R.Extensions.Configuration).getConfigurationProperties();return Object.keys(r)}e.getConfigurationKeys=g;function a(){const r=Object.create(null),i=k.Registry.as(R.Extensions.Configuration).getConfigurationProperties();for(let o in i){let c=i[o].default;h(r,o,c,l=>console.error(`Conflict in default settings: ${l}`))}return r}e.getDefaultValues=a;function s(r){return`[${r}]`}e.keyFromOverrideIdentifier=s;function t(r,i,o){const c=r.inspect(i),l=r.inspect(o);return typeof c.userValue!="undefined"||typeof c.workspaceValue!="undefined"||typeof c.workspaceFolderValue!="undefined"?c.value:typeof l.userValue!="undefined"||typeof l.workspaceValue!="undefined"||typeof l.workspaceFolderValue!="undefined"?l.value:c.defaultValue}e.getMigratedSettingValue=t}),define(Z[162],ee([0,1,32,38,19,15,26,5,37,23,31,2,3]),function(G,e,y,P,L,k,A,R,p,S,n,f,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class C{constructor(t={},r=[],i=[]){this._contents=t,this._keys=r,this._overrides=i,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,S.getConfigurationValue)(this.contents,t):this.contents}getOverrideValue(t,r){const i=this.getContentsForOverrideIdentifer(r);return i?t?(0,S.getConfigurationValue)(i,t):i:void 0}getKeysForOverrideIdentifier(t){for(const r of this.overrides)if(r.identifiers.indexOf(t)!==-1)return r.keys;return[]}override(t){const r=this.getContentsForOverrideIdentifer(t);if(!r||typeof r!="object"||!Object.keys(r).length)return this;let i={};for(const o of L.distinct([...Object.keys(this.contents),...Object.keys(r)])){let c=this.contents[o],l=r[o];l&&(typeof c=="object"&&typeof l=="object"?(c=A.deepClone(c),this.mergeContents(c,l)):c=l),i[o]=c}return new C(i,this.keys,this.overrides)}merge(...t){const r=A.deepClone(this.contents),i=A.deepClone(this.overrides),o=[...this.keys];for(const c of t){this.mergeContents(r,c.contents);for(const l of c.overrides){const[u]=i.filter(v=>L.equals(v.identifiers,l.identifiers));u?this.mergeContents(u.contents,l.contents):i.push(A.deepClone(l))}for(const l of c.keys)o.indexOf(l)===-1&&o.push(l)}return new C(r,o,i)}freeze(){return this.isFrozen=!0,this}mergeContents(t,r){for(const i of Object.keys(r)){if(i in t&&k.isObject(t[i])&&k.isObject(r[i])){this.mergeContents(t[i],r[i]);continue}t[i]=A.deepClone(r[i])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?A.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const r of this.overrides)if(r.identifiers.indexOf(t)!==-1)return r.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,r){this.addKey(t),(0,S.addToValueTree)(this.contents,t,r,i=>{throw new Error(i)})}removeValue(t){this.removeKey(t)&&(0,S.removeFromValueTree)(this.contents,t)}addKey(t){let r=this.keys.length;for(let i=0;i<r;i++)t.indexOf(this.keys[i])===0&&(r=i);this.keys.splice(r,1,t)}removeKey(t){let r=this.keys.indexOf(t);return r!==-1?(this.keys.splice(r,1),!0):!1}}e.ConfigurationModel=C;class h extends C{constructor(){const t=(0,S.getDefaultValues)(),r=(0,S.getConfigurationKeys)(),i=[];for(const o of Object.keys(t))p.OVERRIDE_PROPERTY_PATTERN.test(o)&&i.push({identifiers:[(0,p.overrideIdentifierFromKey)(o).trim()],keys:Object.keys(t[o]),contents:(0,S.toValuesTree)(t[o],c=>console.error(`Conflict in default settings file: ${c}`))});super(t,r,i)}}e.DefaultConfigurationModel=h;class E{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new C}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,r){if(!k.isUndefinedOrNull(t)){const i=this.doParseContent(t);this.parseRaw(i,r)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,r){this._raw=t;const{contents:i,keys:o,overrides:c,restricted:l}=this.doParseRaw(t,r);this._configurationModel=new C(i,o,c),this._restrictedConfigurations=l||[]}doParseContent(t){let r={},i=null,o=[],c=[],l=[];function u(w){Array.isArray(o)?o.push(w):i&&(o[i]=w)}let v={onObjectBegin:()=>{let w={};u(w),c.push(o),o=w,i=null},onObjectProperty:w=>{i=w},onObjectEnd:()=>{o=c.pop()},onArrayBegin:()=>{let w=[];u(w),c.push(o),o=w,i=null},onArrayEnd:()=>{o=c.pop()},onLiteralValue:u,onError:(w,d,T)=>{l.push({error:w,offset:d,length:T})}};if(t)try{y.visit(t,v),r=o[0]||{}}catch(w){console.error(`Error while parsing settings file ${this._name}: ${w}`),this._parseErrors=[w]}return r}doParseRaw(t,r){const i=n.Registry.as(p.Extensions.Configuration).getConfigurationProperties(),o=this.filter(t,i,!0,r);t=o.raw;const c=(0,S.toValuesTree)(t,v=>console.error(`Conflict in settings file ${this._name}: ${v}`)),l=Object.keys(t),u=(0,S.toOverrides)(t,v=>console.error(`Conflict in settings file ${this._name}: ${v}`));return{contents:c,keys:l,overrides:u,restricted:o.restricted}}filter(t,r,i,o){if(!(o==null?void 0:o.scopes)&&!(o==null?void 0:o.skipRestricted))return{raw:t,restricted:[]};const c={},l=[];for(let u in t)if(p.OVERRIDE_PROPERTY_PATTERN.test(u)&&i){const v=this.filter(t[u],r,!1,o);c[u]=v.raw,l.push(...v.restricted)}else{const v=r[u],w=v?typeof v.scope!="undefined"?v.scope:3:void 0;(v==null?void 0:v.restricted)&&l.push(u),(w===void 0||o.scopes===void 0||o.scopes.includes(w))&&(o.skipRestricted&&(v==null?void 0:v.restricted)||(c[u]=t[u]))}return{raw:c,restricted:l}}}e.ConfigurationModelParser=E;class D extends f.Disposable{constructor(t,r,i,o){super();this.userSettingsResource=t,this.scopes=r,this.fileService=o,this._onDidChange=this._register(new m.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new E(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(i.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(m.Event.filter(this.fileService.onDidFilesChange,c=>c.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new C}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=D;class b{constructor(t,r,i=new C,o=new C,c=new P.ResourceMap,l=new C,u=new P.ResourceMap,v=!0){this._defaultConfiguration=t,this._localUserConfiguration=r,this._remoteUserConfiguration=i,this._workspaceConfiguration=o,this._folderConfigurations=c,this._memoryConfiguration=l,this._memoryConfigurationByResource=u,this._freeze=v,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new P.ResourceMap,this._userConfiguration=null}getValue(t,r,i){return this.getConsolidateConfigurationModel(r,i).getValue(t)}updateValue(t,r,i={}){let o;i.resource?(o=this._memoryConfigurationByResource.get(i.resource),o||(o=new C,this._memoryConfigurationByResource.set(i.resource,o))):o=this._memoryConfiguration,r===void 0?o.removeValue(t):o.setValue(t,r),i.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,r,i){const o=this.getConsolidateConfigurationModel(r,i),c=this.getFolderConfigurationModelForResource(r.resource,i),l=r.resource?this._memoryConfigurationByResource.get(r.resource)||this._memoryConfiguration:this._memoryConfiguration,u=r.overrideIdentifier?this._defaultConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),v=r.overrideIdentifier?this.userConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),w=r.overrideIdentifier?this.localUserConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),d=r.overrideIdentifier?this.remoteUserConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),T=i?r.overrideIdentifier?this._workspaceConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,F=c?r.overrideIdentifier?c.freeze().override(r.overrideIdentifier).getValue(t):c.freeze().getValue(t):void 0,z=r.overrideIdentifier?l.override(r.overrideIdentifier).getValue(t):l.getValue(t),B=o.getValue(t),K=L.distinct(L.flatten(o.overrides.map(j=>j.identifiers))).filter(j=>o.getOverrideValue(t,j)!==void 0);return{defaultValue:u,userValue:v,userLocalValue:w,userRemoteValue:d,workspaceValue:T,workspaceFolderValue:F,memoryValue:z,value:B,default:u!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,user:v!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,userLocal:w!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,userRemote:d!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,workspace:T!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,workspaceFolder:F!==void 0?{value:c==null?void 0:c.freeze().getValue(t),override:r.overrideIdentifier?c==null?void 0:c.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,memory:z!==void 0?{value:l.getValue(t),override:r.overrideIdentifier?l.getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,overrideIdentifiers:K.length?K:void 0}}keys(t){const r=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:r?r.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,r){this._folderConfigurations.set(t,r),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,r){const i=r.filter(o=>p.OVERRIDE_PROPERTY_PATTERN.test(o)).map(o=>{const c=(0,p.overrideIdentifierFromKey)(o),l=this._defaultConfiguration.getKeysForOverrideIdentifier(c),u=t.getKeysForOverrideIdentifier(c),v=[...u.filter(w=>l.indexOf(w)===-1),...l.filter(w=>u.indexOf(w)===-1),...l.filter(w=>!A.equals(this._defaultConfiguration.override(c).getValue(w),t.override(c).getValue(w)))];return[c,v]});return this.updateDefaultConfiguration(t),{keys:r,overrides:i}}compareAndUpdateLocalUserConfiguration(t){const{added:r,updated:i,removed:o,overrides:c}=(0,S.compare)(this.localUserConfiguration,t),l=[...r,...i,...o];return l.length&&this.updateLocalUserConfiguration(t),{keys:l,overrides:c}}compareAndUpdateRemoteUserConfiguration(t){const{added:r,updated:i,removed:o,overrides:c}=(0,S.compare)(this.remoteUserConfiguration,t);let l=[...r,...i,...o];return l.length&&this.updateRemoteUserConfiguration(t),{keys:l,overrides:c}}compareAndUpdateWorkspaceConfiguration(t){const{added:r,updated:i,removed:o,overrides:c}=(0,S.compare)(this.workspaceConfiguration,t);let l=[...r,...i,...o];return l.length&&this.updateWorkspaceConfiguration(t),{keys:l,overrides:c}}compareAndUpdateFolderConfiguration(t,r){const i=this.folderConfigurations.get(t),{added:o,updated:c,removed:l,overrides:u}=(0,S.compare)(i,r);let v=[...o,...c,...l];return(v.length||!i)&&this.updateFolderConfiguration(t,r),{keys:v,overrides:u}}compareAndDeleteFolderConfiguration(t){const r=this.folderConfigurations.get(t);if(!r)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:i,updated:o,removed:c,overrides:l}=(0,S.compare)(r,void 0);return{keys:[...i,...o,...c],overrides:l}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,r){let i=this.getConsolidatedConfigurationModelForResource(t,r);return t.overrideIdentifier?i.override(t.overrideIdentifier):i}getConsolidatedConfigurationModelForResource({resource:t},r){let i=this.getWorkspaceConsolidatedConfiguration();if(r&&t){const o=r.getFolder(t);o&&(i=this.getFolderConsolidatedConfiguration(o.uri)||i);const c=this._memoryConfigurationByResource.get(t);c&&(i=i.merge(c))}return i}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let r=this._foldersConsolidatedConfigurations.get(t);if(!r){const i=this.getWorkspaceConsolidatedConfiguration(),o=this._folderConfigurations.get(t);o?(r=i.merge(o),this._freeze&&(r=r.freeze()),this._foldersConsolidatedConfigurations.set(t,r)):r=i}return r}getFolderConfigurationModelForResource(t,r){if(r&&t){const i=r.getFolder(t);if(i)return this._folderConfigurations.get(i.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,r)=>{const{contents:i,overrides:o,keys:c}=this._folderConfigurations.get(r);return t.push([r,{contents:i,overrides:o,keys:c}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(r=>t.add(r)),this.userConfiguration.freeze().keys.forEach(r=>t.add(r)),this._workspaceConfiguration.freeze().keys.forEach(r=>t.add(r)),this._folderConfigurations.forEach(r=>r.freeze().keys.forEach(i=>t.add(i))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const r=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(i=>r.add(i)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(i=>r.add(i)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(i=>r.add(i)),this._folderConfigurations.forEach(i=>i.getKeysForOverrideIdentifier(t).forEach(o=>r.add(o))),[...r.values()]}static parse(t){const r=this.parseConfigurationModel(t.defaults),i=this.parseConfigurationModel(t.user),o=this.parseConfigurationModel(t.workspace),c=t.folders.reduce((l,u)=>(l.set(R.URI.revive(u[0]),this.parseConfigurationModel(u[1])),l),new P.ResourceMap);return new b(r,i,new C,o,c,new C,new P.ResourceMap,!1)}static parseConfigurationModel(t){return new C(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=b;function I(...s){if(s.length===0)return{keys:[],overrides:[]};if(s.length===1)return s[0];const t=new Set,r=new Map;for(const o of s)o.keys.forEach(c=>t.add(c)),o.overrides.forEach(([c,l])=>{const u=(0,P.getOrSet)(r,c,new Set);l.forEach(v=>u.add(v))});const i=[];return r.forEach((o,c)=>i.push([c,[...o.values()]])),{keys:[...t.values()],overrides:i}}e.mergeChanges=I;class g{constructor(t,r,i,o){this.change=t,this.previous=r,this.currentConfiguraiton=i,this.currentWorkspace=o,this._previousConfiguration=void 0;const c=new Set;t.keys.forEach(u=>c.add(u)),t.overrides.forEach(([,u])=>u.forEach(v=>c.add(v))),this.affectedKeys=[...c.values()];const l=new C;this.affectedKeys.forEach(u=>l.setValue(u,{})),this.affectedKeysTree=l.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=b.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,r){var i;if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(r){const o=this.previousConfiguration?this.previousConfiguration.getValue(t,r,(i=this.previous)===null||i===void 0?void 0:i.workspace):void 0,c=this.currentConfiguraiton.getValue(t,r,this.currentWorkspace);return!A.equals(o,c)}return!0}return!1}doesAffectedKeysTreeContains(t,r){let i=(0,S.toValuesTree)({[r]:!0},()=>{}),o;for(;typeof i=="object"&&(o=Object.keys(i)[0]);){if(t=t[o],!t)return!1;i=i[o]}return!0}}e.ConfigurationChangeEvent=g;class a extends g{constructor(t,r,i,o){super({keys:t.allKeys(),overrides:[]},void 0,t,r);this.source=i,this.sourceConfig=o}}e.AllKeysConfigurationChangeEvent=a}),define(Z[163],ee([0,1,31,37,2,23,162,3,8,14]),function(G,e,y,P,L,k,A,R,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class n extends L.Disposable{constructor(m,C){super();this.settingsResource=m,this._onDidChangeConfiguration=this._register(new R.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new A.UserSettings(this.settingsResource,void 0,S.extUriBiasedIgnorePathCase,C)),this.configuration=new A.Configuration(new A.DefaultConfigurationModel,new A.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new p.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(y.Registry.as(P.Extensions.Configuration).onDidUpdateConfiguration(h=>this.onDidDefaultConfigurationChange(h))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const m=await this.userConfiguration.loadConfiguration();this.configuration=new A.Configuration(new A.DefaultConfigurationModel,m)}getConfigurationData(){return this.configuration.toData()}getValue(m,C){const h=typeof m=="string"?m:void 0,E=(0,k.isConfigurationOverrides)(m)?m:(0,k.isConfigurationOverrides)(C)?C:{};return this.configuration.getValue(h,E,void 0)}updateValue(m,C,h,E){return Promise.reject(new Error("not supported"))}inspect(m){return this.configuration.inspect(m,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const m=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(m)}onDidChangeUserConfiguration(m){const C=this.configuration.toData(),h=this.configuration.compareAndUpdateLocalUserConfiguration(m);this.trigger(h,C,1)}onDidDefaultConfigurationChange(m){const C=this.configuration.toData(),h=this.configuration.compareAndUpdateDefaultConfiguration(new A.DefaultConfigurationModel,m);this.trigger(h,C,6)}trigger(m,C,h){const E=new A.ConfigurationChangeEvent(m,{data:C},this.configuration);E.source=h,E.sourceConfig=this.getTargetConfiguration(h),this._onDidChangeConfiguration.fire(E)}getTargetConfiguration(m){switch(m){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=n}),define(Z[164],ee([0,1,23,18,101]),function(G,e,y,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let k=class{constructor(R,p){this.configurationService=R,this.logService=p}request(R,p){return this.logService.trace("RequestService#request",R.url),R.proxyAuthorization||(R.proxyAuthorization=this.configurationService.getValue("http.proxyAuthorization")),(0,L.request)(R,p)}async resolveProxy(R){}};k=de([Y(0,y.IConfigurationService),Y(1,P.ILogService)],k),e.RequestService=k}),define(Z[39],ee([0,1,118,4,37,31,25]),function(G,e,y,P,L,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,P.createDecorator)("requestService");function R(h){return h.res.statusCode&&h.res.statusCode>=200&&h.res.statusCode<300||h.res.statusCode===1223}e.isSuccess=R;function p(h){return h.res.statusCode===204}async function S(h){if(!R(h))throw new Error("Server returned "+h.res.statusCode);return p(h)?null:(await(0,A.streamToBuffer)(h.stream)).toString()}e.asText=S;async function n(h){if(!R(h))throw new Error("Server returned "+h.res.statusCode);if(p(h))return null;const D=(await(0,A.streamToBuffer)(h.stream)).toString();try{return JSON.parse(D)}catch(b){throw b.message+=`:
`+D,b}}e.asJson=n;function f(h){C(h)}e.updateProxyConfigurationsScope=f;let m;function C(h){const E=k.Registry.as(L.Extensions.Configuration);m&&E.deregisterConfigurations([m]),m={id:"http",order:15,title:(0,y.localize)(0,null),type:"object",scope:h,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,y.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,y.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,y.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,y.localize)(4,null),(0,y.localize)(5,null),(0,y.localize)(6,null),(0,y.localize)(7,null)],default:"override",description:(0,y.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,y.localize)(9,null),restricted:!0}}},E.registerConfiguration(m)}C(2)}),define(Z[165],ee([0,1,39,29,10,16]),function(G,e,y,P,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let A=class{constructor(p,S){this.requestService=p,this.fileService=S}async download(p,S,n=P.CancellationToken.None){if(p.scheme===k.Schemas.file||p.scheme===k.Schemas.vscodeRemote){await this.fileService.copy(p,S);return}const f={type:"GET",url:p.toString()},m=await this.requestService.request(f,n);if(m.res.statusCode===200)await this.fileService.writeFile(S,m.stream);else{const C=await(0,y.asText)(m);throw new Error(`Expected 200, got back ${m.res.statusCode} instead.

${C}`)}}};A=de([Y(0,y.IRequestService),Y(1,L.IFileService)],A),e.DownloadService=A}),define(Z[166],ee([0,1,27,10,19,63,39,29,18,14,130,2]),function(G,e,y,P,L,k,A,R,p,S,n,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;let m=class extends f.Disposable{constructor(h,E,D,b){super();this.fileService=h,this.productService=E,this.requestService=D,this.logService=b,this.allConfigBasedTips=new Map,this.productService.configBasedExtensionTips&&(0,k.forEach)(this.productService.configBasedExtensionTips,({value:I})=>this.allConfigBasedTips.set(I.configPath,I))}getConfigBasedTips(h){return this.getValidConfigBasedTips(h)}getAllWorkspacesTips(){return this.fetchWorkspacesTips()}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async getValidConfigBasedTips(h){const E=[];for(const[D,b]of this.allConfigBasedTips)try{const I=await this.fileService.readFile((0,S.joinPath)(h,D)),g=new Map;(0,k.forEach)(b.recommendations,({key:s,value:t})=>{if((0,L.isNonEmptyArray)(t.remotes))for(const r of t.remotes)g.set(r,{extensionId:s,extensionName:t.name,configName:b.configName,important:!!t.important,isExtensionPack:!!t.isExtensionPack});else E.push({extensionId:s,extensionName:t.name,configName:b.configName,important:!!t.important,isExtensionPack:!!t.isExtensionPack})});const a=(0,n.getDomainsOfRemotes)(I.value.toString(),[...g.keys()]);for(const s of a){const t=g.get(s);t&&E.push(t)}}catch(I){}return E}async fetchWorkspacesTips(){var h,E;if(!((h=this.productService.extensionsGallery)===null||h===void 0?void 0:h.recommendationsUrl))return[];try{const D=await this.requestService.request({type:"GET",url:(E=this.productService.extensionsGallery)===null||E===void 0?void 0:E.recommendationsUrl},R.CancellationToken.None);if(D.res.statusCode!==200)return[];const b=await(0,A.asJson)(D);return b?b.workspaceRecommendations||[]:[]}catch(D){return this.logService.error(D),[]}}};m=de([Y(0,P.IFileService),Y(1,y.IProductService),Y(2,A.IRequestService),Y(3,p.ILogService)],m),e.ExtensionTipsService=m}),define(Z[45],ee([0,1,30,25]),function(G,e,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function L(k,A,R){let p=R&&R.get("storage.serviceMachineId",0)||null;if(p)return p;try{const n=(await A.readFile(k.serviceMachineIdResource)).value.toString();p=(0,y.isUUID)(n)?n:null}catch(S){p=null}if(!p){p=(0,y.generateUuid)();try{await A.writeFile(k.serviceMachineIdResource,P.VSBuffer.fromString(p))}catch(S){}}return R&&R.store("storage.serviceMachineId",p,0,1),p}e.getServiceMachineId=L}),define(Z[20],ee([0,1,4,3,2,15,69,8]),function(G,e,y,P,L,k,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const p="__$__targetStorageMarker";e.IStorageService=(0,y.createDecorator)("storageService");var S;(function(E){E[E.NONE=0]="NONE",E[E.SHUTDOWN=1]="SHUTDOWN"})(S=e.WillSaveStateReason||(e.WillSaveStateReason={}));var n;(function(E){E[E.GLOBAL=0]="GLOBAL",E[E.WORKSPACE=1]="WORKSPACE"})(n=e.StorageScope||(e.StorageScope={}));var f;(function(E){E[E.USER=0]="USER",E[E.MACHINE=1]="MACHINE"})(f=e.StorageTarget||(e.StorageTarget={}));class m extends L.Disposable{constructor(D={flushInterval:m.DEFAULT_FLUSH_INTERVAL}){super();this.options=D,this._onDidChangeValue=this._register(new P.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new P.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new P.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new R.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new L.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,R.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,L.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{await this.doInitialize(),this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(D,b){b===p?(D===0?this._globalKeyTargets=void 0:D===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:D})):this._onDidChangeValue.fire({scope:D,key:b,target:this.getKeyTargets(D)[b]})}emitWillSaveState(D){this._onWillSaveState.fire({reason:D})}get(D,b,I){var g;return(g=this.getStorage(b))===null||g===void 0?void 0:g.get(D,I)}getBoolean(D,b,I){var g;return(g=this.getStorage(b))===null||g===void 0?void 0:g.getBoolean(D,I)}getNumber(D,b,I){var g;return(g=this.getStorage(b))===null||g===void 0?void 0:g.getNumber(D,I)}store(D,b,I,g){if((0,k.isUndefinedOrNull)(b)){this.remove(D,I);return}this.withPausedEmitters(()=>{var a;this.updateKeyTarget(D,I,g),(a=this.getStorage(I))===null||a===void 0||a.set(D,b)})}remove(D,b){this.withPausedEmitters(()=>{var I;this.updateKeyTarget(D,b,void 0),(I=this.getStorage(b))===null||I===void 0||I.delete(D)})}withPausedEmitters(D){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{D()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(D,b){const I=[],g=this.getKeyTargets(D);for(const a of Object.keys(g))g[a]===b&&I.push(a);return I}updateKeyTarget(D,b,I){var g,a;const s=this.getKeyTargets(b);typeof I=="number"?s[D]!==I&&(s[D]=I,(g=this.getStorage(b))===null||g===void 0||g.set(p,JSON.stringify(s))):typeof s[D]=="number"&&(delete s[D],(a=this.getStorage(b))===null||a===void 0||a.set(p,JSON.stringify(s)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(D){return D===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(D){const b=this.get(p,D);if(b)try{return JSON.parse(b)}catch(I){}return Object.create(null)}isNew(D){return this.getBoolean(e.IS_NEW_KEY,D)===!0}async flush(){var D,b,I,g;this._onWillSaveState.fire({reason:S.NONE}),await R.Promises.settled([(b=(D=this.getStorage(0))===null||D===void 0?void 0:D.whenFlushed())!==null&&b!==void 0?b:Promise.resolve(),(g=(I=this.getStorage(1))===null||I===void 0?void 0:I.whenFlushed())!==null&&g!==void 0?g:Promise.resolve()])}async logStorage(){var D,b,I,g,a,s;const t=(b=(D=this.getStorage(0))===null||D===void 0?void 0:D.items)!==null&&b!==void 0?b:new Map,r=(g=(I=this.getStorage(1))===null||I===void 0?void 0:I.items)!==null&&g!==void 0?g:new Map;return h(t,r,(a=this.getLogDetails(0))!==null&&a!==void 0?a:"",(s=this.getLogDetails(1))!==null&&s!==void 0?s:"")}}e.AbstractStorageService=m,m.DEFAULT_FLUSH_INTERVAL=60*1e3;class C extends m{constructor(){super();this.globalStorage=new A.Storage(new A.InMemoryStorageDatabase),this.workspaceStorage=new A.Storage(new A.InMemoryStorageDatabase),this._register(this.workspaceStorage.onDidChangeStorage(D=>this.emitDidChangeValue(1,D))),this._register(this.globalStorage.onDidChangeStorage(D=>this.emitDidChangeValue(0,D)))}getStorage(D){return D===0?this.globalStorage:this.workspaceStorage}getLogDetails(D){return D===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(D){}}e.InMemoryStorageService=C;async function h(E,D,b,I){const g=c=>{try{return JSON.parse(c)}catch(l){return c}},a=new Map,s=new Map;E.forEach((c,l)=>{a.set(l,c),s.set(l,g(c))});const t=new Map,r=new Map;D.forEach((c,l)=>{t.set(l,c),r.set(l,g(c))}),console.group(`Storage: Global (path: ${b})`);let i=[];a.forEach((c,l)=>{i.push({key:l,value:c})}),console.table(i),console.groupEnd(),console.log(s),console.group(`Storage: Workspace (path: ${I})`);let o=[];t.forEach((c,l)=>{o.push({key:l,value:c})}),console.table(o),console.groupEnd(),console.log(r)}e.logStorage=h}),define(Z[167],ee([0,1,3,2,28,33,20,15]),function(G,e,y,P,L,k,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageManager=e.GlobalExtensionEnablementService=void 0;let p=class extends P.Disposable{constructor(f){super();this._onDidChangeEnablement=new y.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this.storageManger=this._register(new S(f)),this._register(this.storageManger.onDidChange(m=>this._onDidChangeEnablement.fire({extensions:m,source:"storage"})))}async enableExtension(f,m){return this._removeFromDisabledExtensions(f)?(this._onDidChangeEnablement.fire({extensions:[f],source:m}),!0):!1}async disableExtension(f,m){return this._addToDisabledExtensions(f)?(this._onDidChangeEnablement.fire({extensions:[f],source:m}),!0):!1}getDisabledExtensions(){return this._getExtensions(L.DISABLED_EXTENSIONS_STORAGE_PATH)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}_addToDisabledExtensions(f){let m=this.getDisabledExtensions();return m.every(C=>!(0,k.areSameExtensions)(C,f))?(m.push(f),this._setDisabledExtensions(m),!0):!1}_removeFromDisabledExtensions(f){let m=this.getDisabledExtensions();for(let C=0;C<m.length;C++){const h=m[C];if((0,k.areSameExtensions)(h,f))return m.splice(C,1),this._setDisabledExtensions(m),!0}return!1}_setDisabledExtensions(f){this._setExtensions(L.DISABLED_EXTENSIONS_STORAGE_PATH,f)}_getExtensions(f){return this.storageManger.get(f,0)}_setExtensions(f,m){this.storageManger.set(f,m,0)}};p=de([Y(0,A.IStorageService)],p),e.GlobalExtensionEnablementService=p;class S extends P.Disposable{constructor(f){super();this.storageService=f,this.storage=Object.create(null),this._onDidChange=this._register(new y.Emitter),this.onDidChange=this._onDidChange.event,this._register(f.onDidChangeValue(m=>this.onDidStorageChange(m)))}get(f,m){let C;return m===0?((0,R.isUndefinedOrNull)(this.storage[f])&&(this.storage[f]=this._get(f,m)),C=this.storage[f]):C=this._get(f,m),JSON.parse(C)}set(f,m,C){let h=JSON.stringify(m.map(({id:D,uuid:b})=>({id:D,uuid:b})));this._get(f,C)!==h&&(C===0&&(m.length?this.storage[f]=h:delete this.storage[f]),this._set(f,m.length?h:void 0,C))}onDidStorageChange(f){if(f.scope===0&&!(0,R.isUndefinedOrNull)(this.storage[f.key])&&this._get(f.key,f.scope)!==this.storage[f.key]){const C=this.get(f.key,f.scope);delete this.storage[f.key];const h=this.get(f.key,f.scope),E=C.filter(b=>!h.some(I=>(0,k.areSameExtensions)(b,I))),D=h.filter(b=>!C.some(I=>(0,k.areSameExtensions)(I,b)));(E.length||D.length)&&this._onDidChange.fire([...E,...D])}}_get(f,m){return this.storageService.get(f,m,"[]")}_set(f,m,C){m?this.storageService.store(f,m,C,1):this.storageService.remove(f,C)}}e.StorageManager=S}),define(Z[168],ee([0,1,3,2]),function(G,e,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannelClient=void 0;class L extends P.Disposable{constructor(S,n){super();this.channel=S,this.workspace=n}async getItems(){const S={workspace:this.workspace},n=await this.channel.call("getItems",S);return new Map(n)}updateItems(S){const n={workspace:this.workspace};return S.insert&&(n.insert=Array.from(S.insert.entries())),S.delete&&(n.delete=Array.from(S.delete.values())),this.channel.call("updateItems",n)}}class k extends L{constructor(S){super(S,void 0);this._onDidChangeItemsExternal=this._register(new y.Emitter),this.onDidChangeItemsExternal=this._onDidChangeItemsExternal.event,this.registerListeners()}registerListeners(){this._register(this.channel.listen("onDidChangeGlobalStorage")(S=>this.onDidChangeGlobalStorage(S)))}onDidChangeGlobalStorage(S){(Array.isArray(S.changed)||Array.isArray(S.deleted))&&this._onDidChangeItemsExternal.fire({changed:S.changed?new Map(S.changed):void 0,deleted:S.deleted?new Set(S.deleted):void 0})}async close(){this.dispose()}}class A extends L{constructor(S,n){super(S,n);this.onDidChangeItemsExternal=y.Event.None}async close(){const S={workspace:this.workspace};return this.channel.call("close",S)}}class R extends P.Disposable{constructor(S,n){super();this.channel=S,this.workspace=n,this._globalStorage=void 0,this._workspaceStorage=void 0}get globalStorage(){return this._globalStorage||(this._globalStorage=new k(this.channel)),this._globalStorage}get workspaceStorage(){return!this._workspaceStorage&&this.workspace&&(this._workspaceStorage=new A(this.channel,this.workspace)),this._workspaceStorage}}e.StorageDatabaseChannelClient=R}),define(Z[169],ee([0,1,2,20,69,8,158,168,14]),function(G,e,y,P,L,k,A,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeStorageService=void 0;class S extends P.AbstractStorageService{constructor(f,m,C){super();this.mainProcessService=m,this.environmentService=C,this.workspaceStorage=void 0,this.workspaceStorageId=void 0,this.workspaceStorageDisposable=this._register(new y.MutableDisposable),this.globalStorage=this.createGlobalStorage(),this.workspaceStorage=this.createWorkspaceStorage(f)}createGlobalStorage(){const f=new R.StorageDatabaseChannelClient(this.mainProcessService.getChannel("storage"),void 0),m=new L.Storage(f.globalStorage);return this._register(m.onDidChangeStorage(C=>this.emitDidChangeValue(0,C))),m}createWorkspaceStorage(f){const m=new R.StorageDatabaseChannelClient(this.mainProcessService.getChannel("storage"),f);if(m.workspaceStorage){const C=new L.Storage(m.workspaceStorage);return this.workspaceStorageDisposable.value=C.onDidChangeStorage(h=>this.emitDidChangeValue(1,h)),this.workspaceStorageId=f==null?void 0:f.id,C}else{this.workspaceStorageDisposable.clear(),this.workspaceStorageId=void 0;return}}async doInitialize(){var f,m;(0,A.mark)("code/willInitStorage");try{await k.Promises.settled([this.globalStorage.init(),(m=(f=this.workspaceStorage)===null||f===void 0?void 0:f.init())!==null&&m!==void 0?m:Promise.resolve()])}finally{(0,A.mark)("code/didInitStorage")}}getStorage(f){return f===0?this.globalStorage:this.workspaceStorage}getLogDetails(f){return f===0?this.environmentService.globalStorageHome.fsPath:this.workspaceStorageId?`${(0,p.joinPath)(this.environmentService.workspaceStorageHome,this.workspaceStorageId,"state.vscdb").fsPath}`:void 0}async close(){var f,m;this.stopFlushWhenIdle(),this.emitWillSaveState(P.WillSaveStateReason.SHUTDOWN),await k.Promises.settled([this.globalStorage.close(),(m=(f=this.workspaceStorage)===null||f===void 0?void 0:f.close())!==null&&m!==void 0?m:Promise.resolve()])}async migrate(f){var m;const C=this.workspaceStorage,h=(m=C==null?void 0:C.items)!==null&&m!==void 0?m:new Map;C&&(await C.close(),C.dispose()),this.workspaceStorage=this.createWorkspaceStorage(f),await this.workspaceStorage.init();for(const[E,D]of h)this.workspaceStorage.set(E,D)}}e.NativeStorageService=S}),define(Z[170],ee([0,1,6,34,30,5]),function(G,e,y,P,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function A(S){if(y.platform===2&&/^penguin(\.|$)/i.test(S))return"chromebook"}async function R(S,n,f,m,C,h,E,D,b,I){const g=Object.create(null);g["common.machineId"]=E,g.sessionID=(0,L.generateUuid)()+Date.now(),g.commitHash=C,g.version=h,g["common.platformVersion"]=(n||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),g["common.platform"]=(0,y.PlatformToString)(y.platform),g["common.nodePlatform"]=P.platform,g["common.nodeArch"]=m,g["common.product"]=I||"desktop";const a=p(D||[]);a&&(g["common.msftInternal"]=a);let s=0;const t=Date.now();Object.defineProperties(g,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-t,enumerable:!0},"common.sequence":{get:()=>s++,enumerable:!0}}),y.isLinuxSnap&&(g["common.snap"]="true");const r=A(f);r&&(g["common.platformDetail"]=r);try{const i=await S.readFile(k.URI.file(b));g["common.source"]=i.value.toString().slice(0,30)}catch(i){}return g}e.resolveCommonProperties=R;function p(S){const n=P.env.USERDNSDOMAIN;if(!n)return!1;const f=n.toLowerCase();return S.some(m=>f===m)}e.verifyMicrosoftInternalDomain=p}),define(Z[24],ee([0,1,4]),function(G,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.instanceStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,y.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,y.createDecorator)("customEndpointTelemetryService"),e.instanceStorageKey="telemetry.instanceId",e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId"}),define(Z[171],ee([0,1,35,93,71,42,7,32,96,27,6,5,24,53,16,10,17]),function(G,e,y,P,L,k,A,R,p,S,n,f,m,C,h,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;async function b(t,r){const i=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.yml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i}],o=new Map,c=new Map,l=2e4;function u(d,T,F,z){const B=T.substring(d.length+1);return new Promise(async K=>{var j,H,q;let $;try{$=await(0,D.readdir)(T,{withFileTypes:!0})}catch(O){K();return}if(z.count>=l){z.count+=$.length,z.maxReached=!0,K();return}let M=$.length;if(M===0){K();return}let U=$;z.count+$.length>l&&(z.maxReached=!0,M=l-z.count,U=$.slice(0,M)),z.count+=$.length;for(const O of U)if(O.isDirectory()){if(F.includes(O.name)||await u(d,(0,A.join)(T,O.name),F,z),--M==0){K();return}}else{const _=O.name.lastIndexOf(".");if(_>=0){const N=O.name.substring(_+1);N&&o.set(N,((j=o.get(N))!==null&&j!==void 0?j:0)+1)}for(const N of i)((H=N.relativePathPattern)===null||H===void 0?void 0:H.test(B))!==!1&&N.filePattern.test(O.name)&&c.set(N.tag,((q=c.get(N.tag))!==null&&q!==void 0?q:0)+1);if(--M==0){K();return}}})}const v={count:0,maxReached:!1};await u(t,t,r,v);const w=await a(t);return{configFiles:I(c),fileTypes:I(o),fileCount:v.count,maxFilesReached:v.maxReached,launchConfigFiles:w}}e.collectWorkspaceStats=b;function I(t){return[...C.Iterable.map(t.entries(),([r,i])=>({name:r,count:i}))].sort((r,i)=>i.count-r.count)}function g(){const t={os:`${y.type()} ${y.arch()} ${y.release()}`,memory:`${(y.totalmem()/E.ByteSize.GB).toFixed(2)}GB (${(y.freemem()/E.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(P.virtualMachineHint.value()*100)}%`},r=y.cpus();return r&&r.length>0&&(t.cpus=`${r[0].model} (${r.length} x ${r[0].speed})`),t}e.getMachineInfo=g;function a(t){let r=new Map,i=(0,A.join)(t,".vscode","launch.json");return new Promise((o,c)=>{(0,k.exists)(i,l=>{if(l)(0,k.readFile)(i,(u,v)=>{if(u)return o([]);const w=[],d=(0,R.parse)(v.toString(),w);if(w.length)return console.log(`Unable to parse ${i}`),o([]);if((0,R.getNodeType)(d)==="object"&&d.configurations)for(const T of d.configurations){const F=T.type;F&&(r.has(F)?r.set(F,r.get(F)+1):r.set(F,1))}return o(I(r))});else return o([])})})}e.collectLaunchConfigs=a;let s=class{constructor(r,i){this.telemetryService=r,this.productService=i}formatMachineInfo(r){const i=[];return i.push(`OS Version:       ${r.os}`),i.push(`CPUs:             ${r.cpus}`),i.push(`Memory (System):  ${r.memory}`),i.push(`VM:               ${r.vmHint}`),i.join(`
`)}formatEnvironment(r){const i=[];i.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),i.push(`OS Version:       ${y.type()} ${y.arch()} ${y.release()}`);const o=y.cpus();return o&&o.length>0&&i.push(`CPUs:             ${o[0].model} (${o.length} x ${o[0].speed})`),i.push(`Memory (System):  ${(y.totalmem()/E.ByteSize.GB).toFixed(2)}GB (${(y.freemem()/E.ByteSize.GB).toFixed(2)}GB free)`),n.isWindows||i.push(`Load (avg):       ${y.loadavg().map(c=>Math.round(c)).join(", ")}`),i.push(`VM:               ${Math.round(P.virtualMachineHint.value()*100)}%`),i.push(`Screen Reader:    ${r.screenReader?"yes":"no"}`),i.push(`Process Argv:     ${r.mainArguments.join(" ")}`),i.push(`GPU Status:       ${this.expandGPUFeatures(r.gpuFeatureStatus)}`),i.join(`
`)}async getPerformanceInfo(r,i){return Promise.all([(0,p.listProcesses)(r.mainPID),this.formatWorkspaceMetadata(r)]).then(async o=>{let[c,l]=o,u=this.formatProcessList(r,c);return i.forEach(v=>{if((0,L.isRemoteDiagnosticError)(v))u+=`
${v.errorMessage}`,l+=`
${v.errorMessage}`;else if(u+=`

Remote: ${v.hostName}`,v.processes&&(u+=`
${this.formatProcessList(r,v.processes)}`),v.workspaceMetadata){l+=`
|  Remote: ${v.hostName}`;for(const w of Object.keys(v.workspaceMetadata)){const d=v.workspaceMetadata[w];let T=`${d.fileCount} files`;d.maxFilesReached&&(T=`more than ${T}`),l+=`|    Folder (${w}): ${T}`,l+=this.formatWorkspaceStats(d)}}}),{processInfo:u,workspaceInfo:l}})}async getSystemInfo(r,i){const{memory:o,vmHint:c,os:l,cpus:u}=g(),v={os:l,memory:o,cpus:u,vmHint:c,processArgs:`${r.mainArguments.join(" ")}`,gpuStatus:r.gpuFeatureStatus,screenReader:`${r.screenReader?"yes":"no"}`,remoteData:i};return n.isWindows||(v.load=`${y.loadavg().map(w=>Math.round(w)).join(", ")}`),n.isLinux&&(v.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(v)}async getDiagnostics(r,i){const o=[];return(0,p.listProcesses)(r.mainPID).then(async c=>(o.push(""),o.push(this.formatEnvironment(r)),o.push(""),o.push(this.formatProcessList(r,c)),r.windows.some(l=>l.folderURIs&&l.folderURIs.length>0&&!l.remoteAuthority)&&(o.push(""),o.push("Workspace Stats: "),o.push(await this.formatWorkspaceMetadata(r))),i.forEach(l=>{if((0,L.isRemoteDiagnosticError)(l))o.push(`
${l.errorMessage}`);else if(o.push(`

`),o.push(`Remote:           ${l.hostName}`),o.push(this.formatMachineInfo(l.machineInfo)),l.processes&&o.push(this.formatProcessList(r,l.processes)),l.workspaceMetadata)for(const u of Object.keys(l.workspaceMetadata)){const v=l.workspaceMetadata[u];let w=`${v.fileCount} files`;v.maxFilesReached&&(w=`more than ${w}`),o.push(`Folder (${u}): ${w}`),o.push(this.formatWorkspaceStats(v))}}),o.push(""),o.push(""),o.join(`
`)))}formatWorkspaceStats(r){const i=[],o=60;let c=0;const l=(d,T)=>{const F=` ${d}(${T})`;c+F.length>o?(i.push(u),u="|                 ",c=u.length):c+=F.length,u+=F};let u="|      File types:";const v=10;let w=r.fileTypes.length>v?v:r.fileTypes.length;for(let d=0;d<w;d++){const T=r.fileTypes[d];l(T.name,T.count)}if(i.push(u),r.configFiles.length>=0&&(u="|      Conf files:",c=0,r.configFiles.forEach(d=>{l(d.name,d.count)}),i.push(u)),r.launchConfigFiles.length>0){let d="|      Launch Configs:";r.launchConfigFiles.forEach(T=>{d+=T.count>1?` ${T.name}(${T.count})`:` ${T.name}`}),i.push(d)}return i.join(`
`)}expandGPUFeatures(r){const i=Math.max(...Object.keys(r).map(o=>o.length));return Object.keys(r).map(o=>`${o}:  ${" ".repeat(i-o.length)}  ${r[o]}`).join(`
                  `)}formatWorkspaceMetadata(r){const i=[],o=[];return r.windows.forEach(c=>{c.folderURIs.length===0||!!c.remoteAuthority||(i.push(`|  Window (${c.title})`),c.folderURIs.forEach(l=>{const u=f.URI.revive(l);if(u.scheme===h.Schemas.file){const v=u.fsPath;o.push(b(v,["node_modules",".git"]).then(w=>{let d=`${w.fileCount} files`;w.maxFilesReached&&(d=`more than ${d}`),i.push(`|    Folder (${(0,A.basename)(v)}): ${d}`),i.push(this.formatWorkspaceStats(w))}).catch(w=>{i.push(`|      Error: Unable to collect workspace stats for folder ${v} (${w.toString()})`)}))}else i.push(`|    Folder (${u.toString()}): Workspace stats not available.`)}))}),Promise.all(o).then(c=>i.join(`
`)).catch(c=>`Unable to collect workspace stats: ${c}`)}formatProcessList(r,i){const o=new Map;r.windows.forEach(l=>o.set(l.pid,l.title));const c=[];return c.push("CPU %	Mem MB	   PID	Process"),i&&this.formatProcessItem(r.mainPID,o,c,i,0),c.join(`
`)}formatProcessItem(r,i,o,c,l){const u=l===0;let v;u?v=c.pid===r?`${this.productService.applicationName} main`:"remote agent":(v=`${"  ".repeat(l)} ${c.name}`,c.name==="window"&&(v=`${v} (${i.get(c.pid)})`));const w=process.platform==="win32"?c.mem:y.totalmem()*(c.mem/100);o.push(`${c.load.toFixed(0).padStart(5," ")}	${(w/E.ByteSize.MB).toFixed(0).padStart(6," ")}	${c.pid.toFixed(0).padStart(6," ")}	${v}`),Array.isArray(c.children)&&c.children.forEach(d=>this.formatProcessItem(r,i,o,d,l+1))}async reportWorkspaceStats(r){for(const{uri:i}of r.folders){const o=f.URI.revive(i);if(o.scheme!==h.Schemas.file)continue;const c=o.fsPath;try{const l=await b(c,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":r.telemetryId,rendererSessionId:r.rendererSessionId}),l.fileTypes.forEach(u=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:r.rendererSessionId,type:u.name,count:u.count})}),l.launchConfigFiles.forEach(u=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:r.rendererSessionId,type:u.name,count:u.count})}),l.configFiles.forEach(u=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:r.rendererSessionId,type:u.name,count:u.count})})}catch(l){}}}};s=de([Y(0,m.ITelemetryService),Y(1,S.IProductService)],s),e.DiagnosticsService=s}),define(Z[172],ee([0,1,11,28,33,26,24,39,70,9,29,18,10,5,27,20,45,4,14]),function(G,e,y,P,L,k,A,R,p,S,n,f,m,C,h,E,D,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=e.ExtensionGalleryService=void 0;var g;(function(U){U[U.None=0]="None",U[U.IncludeVersions=1]="IncludeVersions",U[U.IncludeFiles=2]="IncludeFiles",U[U.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",U[U.IncludeSharedAccounts=8]="IncludeSharedAccounts",U[U.IncludeVersionProperties=16]="IncludeVersionProperties",U[U.ExcludeNonValidated=32]="ExcludeNonValidated",U[U.IncludeInstallationTargets=64]="IncludeInstallationTargets",U[U.IncludeAssetUri=128]="IncludeAssetUri",U[U.IncludeStatistics=256]="IncludeStatistics",U[U.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",U[U.Unpublished=4096]="Unpublished"})(g||(g={}));function a(...U){return String(U.reduce((O,_)=>O|_,0))}var s;(function(U){U[U.Tag=1]="Tag",U[U.ExtensionId=4]="ExtensionId",U[U.Category=5]="Category",U[U.ExtensionName=7]="ExtensionName",U[U.Target=8]="Target",U[U.Featured=9]="Featured",U[U.SearchText=10]="SearchText",U[U.ExcludeWithFlags=12]="ExcludeWithFlags"})(s||(s={}));const t={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},r={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},o={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:g.None,criteria:[],assetTypes:[]};class c{constructor(O=o){this.state=O}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(O,_=this.state.pageSize){return new c(Object.assign(Object.assign({},this.state),{pageNumber:O,pageSize:_}))}withFilter(O,..._){const N=[...this.state.criteria,..._.length?_.map(W=>({filterType:O,value:W})):[{filterType:O}]];return new c(Object.assign(Object.assign({},this.state),{criteria:N}))}withSortBy(O){return new c(Object.assign(Object.assign({},this.state),{sortBy:O}))}withSortOrder(O){return new c(Object.assign(Object.assign({},this.state),{sortOrder:O}))}withFlags(...O){return new c(Object.assign(Object.assign({},this.state),{flags:O.reduce((_,N)=>_|N,0)}))}withAssetTypes(...O){return new c(Object.assign(Object.assign({},this.state),{assetTypes:O}))}get raw(){const{criteria:O,pageNumber:_,pageSize:N,sortBy:W,sortOrder:V,flags:Q,assetTypes:X}=this.state;return{filters:[{criteria:O,pageNumber:_,pageSize:N,sortBy:W,sortOrder:V}],assetTypes:X,flags:Q}}get searchText(){const O=this.state.criteria.filter(_=>_.filterType===s.SearchText)[0];return O&&O.value?O.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(O=>String(O.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function l(U,O){const _=(U||[]).filter(N=>N.statisticName===O)[0];return _?_.value:0}function u(U){const O="Microsoft.VisualStudio.Code.Translation.";return U.files.filter(N=>N.assetType.indexOf(O)===0).reduce((N,W)=>{const V=T(U,W.assetType);return V&&N.push([W.assetType.substring(O.length),V]),N},[])}function v(U){if(U.properties){const O=U.properties.filter(W=>W.key===t.Repository),_=new RegExp("((git|ssh|http(s)?)|(git@[w.]+))(:(//)?)([w.@:/-~]+)(.git)(/)?"),N=O.filter(W=>_.test(W.value))[0];return N?{uri:N.value,fallbackUri:N.value}:null}return T(U,t.Repository)}function w(U){return{uri:`${U.fallbackAssetUri}/${t.VSIX}?redirect=true`,fallbackUri:`${U.fallbackAssetUri}/${t.VSIX}`}}function d(U){const O=T(U,t.Icon);if(O)return O;const _=P.DefaultIconPath;return{uri:_,fallbackUri:_}}function T(U,O){return U.files.filter(N=>N.assetType===O)[0]?{uri:`${U.assetUri}/${O}`,fallbackUri:`${U.fallbackAssetUri}/${O}`}:null}function F(U,O){const _=U.properties?U.properties.filter(W=>W.key===O):[],N=_.length>0&&_[0].value;return N?N.split(",").map(W=>(0,L.adoptToGalleryExtensionId)(W)):[]}function z(U){const O=U.properties?U.properties.filter(_=>_.key===r.Engine):[];return O.length>0&&O[0].value||""}function B(U){const O=U.properties?U.properties.filter(N=>N.key===r.LocalizedLanguages):[],_=O.length>0&&O[0].value||"";return _?_.split(","):[]}function K(U){return U.indexOf("preview")!==-1}function j(U){const O=U.properties?U.properties.find(_=>_.key===r.WebExtension):void 0;return!!O&&O.value==="true"}function H(U){return U.files.some(O=>O.assetType.startsWith("Microsoft.VisualStudio.Code.WebResources"))?(0,I.joinPath)(C.URI.parse(U.assetUri),"Microsoft.VisualStudio.Code.WebResources","extension"):void 0}function q(U,O,_,N,W){const V={manifest:T(O,t.Manifest),readme:T(O,t.Details),changelog:T(O,t.Changelog),license:T(O,t.License),repository:v(O),download:w(O),icon:d(O),coreTranslations:u(O)};return{identifier:{id:(0,L.getGalleryExtensionId)(U.publisher.publisherName,U.extensionName),uuid:U.extensionId},name:U.extensionName,version:O.version,date:O.lastUpdated,displayName:U.displayName,publisherId:U.publisher.publisherId,publisher:U.publisher.publisherName,publisherDisplayName:U.publisher.displayName,description:U.shortDescription||"",installCount:l(U.statistics,"install"),rating:l(U.statistics,"averagerating"),ratingCount:l(U.statistics,"ratingcount"),assetUri:C.URI.parse(O.assetUri),webResource:H(O),assetTypes:O.files.map(({assetType:Q})=>Q),assets:V,properties:{dependencies:F(O,r.Dependency),extensionPack:F(O,r.ExtensionPack),engine:z(O),localizedLanguages:B(O),webExtension:j(O)},telemetryData:{index:(N.pageNumber-1)*N.pageSize+_,querySource:W},preview:K(U.flags)}}let $=class{constructor(O,_,N,W,V,Q,X){this.requestService=O,this.logService=_,this.environmentService=N,this.telemetryService=W,this.fileService=V,this.productService=Q;const ie=Q.extensionsGallery;this.extensionsGalleryUrl=ie&&ie.serviceUrl,this.extensionsControlUrl=ie&&ie.controlUrl,this.commonHeadersPromise=M(Q.version,this.environmentService,this.fileService,X)}api(O=""){return`${this.extensionsGalleryUrl}${O}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(O,_){const N=[];let{total:W,firstPage:V,getPage:Q}=await this.query({names:O,pageSize:O.length},_);N.push(...V);for(let X=1;N.length<W&&(V=await Q(X,_),V.length);X++)N.push(...V);return N}async getCompatibleExtension(O,_){const N=await this.getCompatibleExtensionByEngine(O,_);return(N==null?void 0:N.properties.webExtension)?N.webResource?N:null:N}async getCompatibleExtensionByEngine(O,_){const N=(0,P.isIExtensionIdentifier)(O)?null:O;if(N&&N.properties.engine&&(0,p.isEngineValid)(N.properties.engine,this.productService.version,this.productService.date))return N;const{id:W,uuid:V}=N?N.identifier:O;let Q=new c().withFlags(g.IncludeAssetUri,g.IncludeStatistics,g.IncludeFiles,g.IncludeVersionProperties).withPage(1,1).withFilter(s.Target,"Microsoft.VisualStudio.Code");V?Q=Q.withFilter(s.ExtensionId,V):Q=Q.withFilter(s.ExtensionName,W);const{galleryExtensions:X}=await this.queryGallery(Q,n.CancellationToken.None),[ie]=X;if(!ie||!ie.versions.length)return null;if(_){const ce=ie.versions.filter(le=>le.version===_)[0];if(ce){const le=q(ie,ce,0,Q);if(le.properties.engine&&(0,p.isEngineValid)(le.properties.engine,this.productService.version,this.productService.date))return le}return null}const ne=await this.getLastValidExtensionVersion(ie,ie.versions);return ne?q(ie,ne,0,Q):null}async query(O,_){const N=n.CancellationToken.isCancellationToken(O)?{}:O,W=n.CancellationToken.isCancellationToken(O)?O:_;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let V=N.text||"";const Q=(0,k.getOrDefault)(N,ve=>ve.pageSize,50);let X=new c().withFlags(g.IncludeLatestVersionOnly,g.IncludeAssetUri,g.IncludeStatistics,g.IncludeFiles,g.IncludeVersionProperties).withPage(1,Q).withFilter(s.Target,"Microsoft.VisualStudio.Code");V?(V=V.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ve,pe,Ce)=>(X=X.withFilter(s.Category,Ce||pe),"")),V=V.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ve,pe,Ce)=>(X=X.withFilter(s.Tag,Ce||pe),"")),V=V.replace(/\bfeatured(\s+|\b|$)/g,()=>(X=X.withFilter(s.Featured),"")),V=V.trim(),V&&(V=V.length<200?V:V.substring(0,200),X=X.withFilter(s.SearchText,V)),X=X.withSortBy(0)):N.ids?X=X.withFilter(s.ExtensionId,...N.ids):N.names?X=X.withFilter(s.ExtensionName,...N.names):X=X.withSortBy(4),typeof N.sortBy=="number"&&(X=X.withSortBy(N.sortBy)),typeof N.sortOrder=="number"&&(X=X.withSortOrder(N.sortOrder));const{galleryExtensions:ie,total:ne}=await this.queryGallery(X,W),ce=ie.map((ve,pe)=>q(ve,ve.versions[0],pe,X,N.source)),le=async(ve,pe)=>{if(pe.isCancellationRequested)throw(0,y.canceled)();const Ce=X.withPage(ve+1),{galleryExtensions:Ae}=await this.queryGallery(Ce,pe);return Ae.map((_e,Oe)=>q(_e,_e.versions[0],Oe,Ce,N.source))};return{firstPage:ce,total:ne,pageSize:X.pageSize,getPage:le}}async queryGallery(O,_){if(!this.isEnabled())throw new Error("No extension gallery service configured.");O=O.withFlags(O.flags,g.ExcludeNonValidated).withFilter(s.ExcludeWithFlags,a(g.Unpublished));const N=await this.commonHeadersPromise,W=JSON.stringify(O.raw),V=Object.assign(Object.assign({},N),{"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(W.length)}),Q=new Date().getTime();let X,ie,ne=0;try{if(X=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:W,headers:V},_),X.res.statusCode&&X.res.statusCode>=400&&X.res.statusCode<500)return{galleryExtensions:[],total:ne};const ce=await(0,R.asJson)(X);if(ce){const le=ce.results[0],ve=le.extensions,pe=le.resultMetadata&&le.resultMetadata.filter(Ce=>Ce.metadataType==="ResultCount")[0];return ne=pe&&pe.metadataItems.filter(Ce=>Ce.name==="TotalCount")[0].count||0,{galleryExtensions:ve,total:ne}}return{galleryExtensions:[],total:ne}}catch(ce){throw ie=ce,ce}finally{this.telemetryService.publicLog2("galleryService:query",Object.assign(Object.assign({},O.telemetryData),{requestBodySize:String(W.length),duration:new Date().getTime()-Q,success:!!X&&(0,R.isSuccess)(X),responseBodySize:X==null?void 0:X.res.headers["Content-Length"],statusCode:X?String(X.res.statusCode):void 0,errorCode:ie?(0,y.isPromiseCanceledError)(ie)?"canceled":(0,y.getErrorMessage)(ie).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(ne)}))}}async reportStatistic(O,_,N,W){if(!this.isEnabled())return;const V=await this.commonHeadersPromise,Q=Object.assign(Object.assign({},V),{Accept:"*/*;api-version=4.0-preview.1"});try{await this.requestService.request({type:"POST",url:this.api(`/publishers/${O}/extensions/${_}/${N}/stats?statType=${W}`),headers:Q},n.CancellationToken.None)}catch(X){}}async download(O,_,N){this.logService.trace("ExtensionGalleryService#download",O.identifier.id);const W=(0,L.getGalleryExtensionTelemetryData)(O),V=new Date().getTime(),Q=ce=>this.telemetryService.publicLog("galleryService:downloadVSIX",Object.assign(Object.assign({},W),{duration:ce})),X=N===1?"install":N===2?"update":"",ie=X?{uri:`${O.assets.download.uri}&${X}=true`,fallbackUri:`${O.assets.download.fallbackUri}?${X}=true`}:O.assets.download,ne=await this.getAsset(ie);await this.fileService.writeFile(_,ne.stream),Q(new Date().getTime()-V)}async getReadme(O,_){if(O.assets.readme){const N=await this.getAsset(O.assets.readme,{},_);return await(0,R.asText)(N)||""}return""}async getManifest(O,_){if(O.assets.manifest){const N=await this.getAsset(O.assets.manifest,{},_),W=await(0,R.asText)(N);return W?JSON.parse(W):null}return null}async getCoreTranslation(O,_){const N=O.assets.coreTranslations.filter(W=>W[0]===_.toUpperCase())[0];if(N){const W=await this.getAsset(N[1]),V=await(0,R.asText)(W);return V?JSON.parse(V):null}return null}async getChangelog(O,_){if(O.assets.changelog){const N=await this.getAsset(O.assets.changelog,{},_);return await(0,R.asText)(N)||""}return""}async getAllVersions(O,_){let N=new c().withFlags(g.IncludeVersions,g.IncludeFiles,g.IncludeVersionProperties).withPage(1,1).withFilter(s.Target,"Microsoft.VisualStudio.Code");O.identifier.uuid?N=N.withFilter(s.ExtensionId,O.identifier.uuid):N=N.withFilter(s.ExtensionName,O.identifier.id);const W=[],{galleryExtensions:V}=await this.queryGallery(N,n.CancellationToken.None);return V.length&&(_?await Promise.all(V[0].versions.map(async Q=>{let X;try{X=await this.getEngine(Q)}catch(ie){}X&&(0,p.isEngineValid)(X,this.productService.version,this.productService.date)&&W.push({version:Q.version,date:Q.lastUpdated})})):W.push(...V[0].versions.map(Q=>({version:Q.version,date:Q.lastUpdated})))),W}async getAsset(O,_={},N=n.CancellationToken.None){const W=await this.commonHeadersPromise,V={type:"GET"},Q=Object.assign(Object.assign({},W),_.headers||{});_=Object.assign(Object.assign(Object.assign({},_),V),{headers:Q});const X=O.uri,ie=O.fallbackUri,ne=Object.assign(Object.assign({},_),{url:X});try{const ce=await this.requestService.request(ne,N);if(ce.res.statusCode===200)return ce;const le=await(0,R.asText)(ce);throw new Error(`Expected 200, got back ${ce.res.statusCode} instead.

${le}`)}catch(ce){if((0,y.isPromiseCanceledError)(ce))throw ce;const le=(0,y.getErrorMessage)(ce);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:X,message:le});const ve=Object.assign(Object.assign({},_),{url:ie});return this.requestService.request(ve,N)}}async getLastValidExtensionVersion(O,_){const N=this.getLastValidExtensionVersionFromProperties(O,_);return N||this.getLastValidExtensionVersionRecursively(O,_)}getLastValidExtensionVersionFromProperties(O,_){for(const N of _){const W=z(N);if(!W)return null;if((0,p.isEngineValid)(W,this.productService.version,this.productService.date))return N}return null}async getEngine(O){const _=z(O);if(_)return _;const N=T(O,t.Manifest);if(!N)throw new Error("Manifest was not found");const W={"Accept-Encoding":"gzip"},V=await this.getAsset(N,{headers:W}),Q=await(0,R.asJson)(V);if(Q)return Q.engines.vscode;throw new Error("Error while reading manifest")}async getLastValidExtensionVersionRecursively(O,_){if(!_.length)return null;const N=_[0],W=await this.getEngine(N);return(0,p.isEngineValid)(W,this.productService.version,this.productService.date)?(N.properties=N.properties||[],N.properties.push({key:r.Engine,value:W}),N):this.getLastValidExtensionVersionRecursively(O,_.slice(1))}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const O=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},n.CancellationToken.None);if(O.res.statusCode!==200)throw new Error("Could not get extensions report.");const _=await(0,R.asJson)(O),N=new Map;if(_)for(const W of _.malicious){const V=N.get(W)||{id:{id:W},malicious:!0,slow:!1};V.malicious=!0,N.set(W,V)}return[...N.values()]}};$=de([Y(0,R.IRequestService),Y(1,f.ILogService),Y(2,S.IEnvironmentService),Y(3,A.ITelemetryService),Y(4,m.IFileService),Y(5,h.IProductService),Y(6,(0,b.optional)(E.IStorageService))],$),e.ExtensionGalleryService=$;async function M(U,O,_,N){const W={"X-Market-Client-Id":`VSCode ${U}`,"User-Agent":`VSCode ${U}`},V=await(0,D.getServiceMachineId)(O,_,N);return W["X-Market-User-Id"]=V,W}e.resolveMarketplaceHeaders=M}),define(Z[173],ee([0,1,5,7,27,9,34,10,6,19,28,63,39,18,166,8,24,73,109,20,3,58]),function(G,e,y,P,L,k,A,R,p,S,n,f,m,C,h,E,D,b,I,g,a,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;const t="extensionTips/promptedExecutableTips",r="extensionTips/lastPromptedMediumImpExeTime";let i=class extends h.ExtensionTipsService{constructor(c,l,u,v,w,d,T,F,z,B){super(T,F,z,B);this.environmentService=c,this.telemetryService=l,this.extensionManagementService=u,this.storageService=v,this.nativeHostService=w,this.extensionRecommendationNotificationService=d,this.highImportanceExecutableTips=new Map,this.mediumImportanceExecutableTips=new Map,this.allOtherExecutableTips=new Map,this.highImportanceTipsByExe=new Map,this.mediumImportanceTipsByExe=new Map,F.exeBasedExtensionTips&&(0,f.forEach)(F.exeBasedExtensionTips,({key:K,value:j})=>{const H=[],q=[],$=[];(0,f.forEach)(j.recommendations,({key:M,value:U})=>{U.important?j.important?H.push({extensionId:M,extensionName:U.name,isExtensionPack:!!U.isExtensionPack}):q.push({extensionId:M,extensionName:U.name,isExtensionPack:!!U.isExtensionPack}):$.push({extensionId:M,extensionName:U.name,isExtensionPack:!!U.isExtensionPack})}),H.length&&this.highImportanceExecutableTips.set(K,{exeFriendlyName:j.friendlyName,windowsPath:j.windowsPath,recommendations:H}),q.length&&this.mediumImportanceExecutableTips.set(K,{exeFriendlyName:j.friendlyName,windowsPath:j.windowsPath,recommendations:q}),$.length&&this.allOtherExecutableTips.set(K,{exeFriendlyName:j.friendlyName,windowsPath:j.windowsPath,recommendations:$})}),(0,E.timeout)(3e3).then(async()=>{await this.collectTips(),this.promptHighImportanceExeBasedTip(),this.promptMediumImportanceExeBasedTip()})}async getImportantExecutableBasedTips(){const c=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),l=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips);return[...c,...l]}getOtherExecutableBasedTips(){return this.getValidExecutableBasedExtensionTips(this.allOtherExecutableTips)}async collectTips(){const c=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),l=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips),u=await this.extensionManagementService.getInstalled();this.highImportanceTipsByExe=this.groupImportantTipsByExe(c,u),this.mediumImportanceTipsByExe=this.groupImportantTipsByExe(l,u)}groupImportantTipsByExe(c,l){const u=new Map;c.forEach(F=>u.set(F.extensionId.toLowerCase(),F));const{installed:v,uninstalled:w}=this.groupByInstalled([...u.keys()],l);for(const F of v){const z=u.get(F);z&&this.telemetryService.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:F,exeName:(0,P.basename)(z.windowsPath)})}for(const F of w){const z=u.get(F);z&&this.telemetryService.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:F,exeName:(0,P.basename)(z.windowsPath)})}const d=this.getPromptedExecutableTips(),T=new Map;for(const F of w){const z=u.get(F);if(z&&(!d[z.exeName]||!d[z.exeName].includes(z.extensionId))){let B=T.get(z.exeName);B||(B=[],T.set(z.exeName,B)),B.push(z)}}return T}promptHighImportanceExeBasedTip(){if(this.highImportanceTipsByExe.size===0)return;const[c,l]=[...this.highImportanceTipsByExe.entries()][0];this.promptExeRecommendations(l).then(u=>{switch(u){case"reacted":this.addToRecommendedExecutables(l[0].exeName,l);break;case"ignored":this.highImportanceTipsByExe.delete(c);break;case"incompatibleWindow":const v=a.Event.once(a.Event.latch(a.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(v(()=>this.promptHighImportanceExeBasedTip()));break;case"toomany":const w=this._register((0,E.disposableTimeout)(()=>{w.dispose(),this.promptHighImportanceExeBasedTip()},60*60*1e3));break}})}promptMediumImportanceExeBasedTip(){if(this.mediumImportanceTipsByExe.size===0)return;const c=this.getLastPromptedMediumExeTime(),l=Date.now()-c,u=7*24*60*60*1e3;if(l<u){const d=this._register((0,E.disposableTimeout)(()=>{d.dispose(),this.promptMediumImportanceExeBasedTip()},u-l));return}const[v,w]=[...this.mediumImportanceTipsByExe.entries()][0];this.promptExeRecommendations(w).then(d=>{switch(d){case"reacted":this.updateLastPromptedMediumExeTime(Date.now()),this.mediumImportanceTipsByExe.delete(v),this.addToRecommendedExecutables(w[0].exeName,w);const T=this._register((0,E.disposableTimeout)(()=>{T.dispose(),this.promptMediumImportanceExeBasedTip()},u));break;case"ignored":this.mediumImportanceTipsByExe.delete(v),this.promptMediumImportanceExeBasedTip();break;case"incompatibleWindow":const F=a.Event.once(a.Event.latch(a.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(F(()=>this.promptMediumImportanceExeBasedTip()));break;case"toomany":const z=this._register((0,E.disposableTimeout)(()=>{z.dispose(),this.promptMediumImportanceExeBasedTip()},60*60*1e3));break}})}promptExeRecommendations(c){const l=c.map(({extensionId:v})=>v.toLowerCase()),u=(0,I.localize)(0,null,c[0].exeFriendlyName);return this.extensionRecommendationNotificationService.promptImportantExtensionsInstallNotification(l,u,`@exe:"${c[0].exeName}"`,3)}getLastPromptedMediumExeTime(){let c=this.storageService.getNumber(r,0);return c||(c=Date.now(),this.updateLastPromptedMediumExeTime(c)),c}updateLastPromptedMediumExeTime(c){this.storageService.store(r,c,0,1)}getPromptedExecutableTips(){return JSON.parse(this.storageService.get(t,0,"{}"))}addToRecommendedExecutables(c,l){const u=this.getPromptedExecutableTips();u[c]=l.map(({extensionId:v})=>v.toLowerCase()),this.storageService.store(t,JSON.stringify(u),0,0)}groupByInstalled(c,l){const u=[],v=[],w=l.reduce((d,T)=>(d.add(T.identifier.id.toLowerCase()),d),new Set);return c.forEach(d=>{w.has(d.toLowerCase())?u.push(d):v.push(d)}),{installed:u,uninstalled:v}}async getValidExecutableBasedExtensionTips(c){const l=[],u=new Map;for(const v of c.keys()){const w=c.get(v);if(!w||!(0,S.isNonEmptyArray)(w.recommendations))continue;const d=[];p.isWindows?w.windowsPath&&d.push(w.windowsPath.replace("%USERPROFILE%",A.env.USERPROFILE).replace("%ProgramFiles(x86)%",A.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",A.env.ProgramFiles).replace("%APPDATA%",A.env.APPDATA).replace("%WINDIR%",A.env.WINDIR)):(d.push((0,P.join)("/usr/local/bin",v)),d.push((0,P.join)("/usr/bin",v)),d.push((0,P.join)(this.environmentService.userHome.fsPath,v)));for(const T of d){let F=u.get(T);if(F===void 0&&(F=await this.fileService.exists(y.URI.file(T)),u.set(T,F)),F)for(const{extensionId:z,extensionName:B,isExtensionPack:K}of w.recommendations)l.push({extensionId:z,extensionName:B,isExtensionPack:K,exeName:v,exeFriendlyName:w.exeFriendlyName,windowsPath:w.windowsPath})}}return l}};i=de([Y(0,k.INativeEnvironmentService),Y(1,D.ITelemetryService),Y(2,n.IExtensionManagementService),Y(3,g.IStorageService),Y(4,s.INativeHostService),Y(5,b.IExtensionRecommendationNotificationService),Y(6,R.IFileService),Y(7,L.IProductService),Y(8,m.IRequestService),Y(9,C.ILogService)],i),e.ExtensionTipsService=i}),define(Z[80],ee([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class y{constructor(k){this.appender=k}listen(k,A){throw new Error(`Event not found: ${A}`)}call(k,A,{eventName:R,data:p}){return this.appender.log(R,p),Promise.resolve(null)}}e.TelemetryAppenderChannel=y;class P{constructor(k){this.channel=k}log(k,A){return this.channel.call("log",{eventName:k,data:A}).then(void 0,R=>`Failed to log telemetry: ${console.warn(R)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=P}),define(Z[81],ee([0,1,51,119,22,4,23,37,2,26,31]),function(G,e,y,P,L,k,A,R,p,S,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let f=class{constructor(h,E){this._configurationService=E,this._experimentProperties={},this._disposables=new p.DisposableStore,this._cleanupPatterns=[],this._appender=h.appender,this._commonProperties=h.commonProperties||Promise.resolve({}),this._piiPaths=h.piiPaths||[],this._userOptIn=!0,this._enabled=!0,this.sendErrorTelemetry=!!h.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let D of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,L.escapeRegExpCharacters)(D),"gi"));this._configurationService&&(this._updateUserOptIn(),this._configurationService.onDidChangeConfiguration(this._updateUserOptIn,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._userOptIn}),this._commonProperties.then(D=>{const b=/^[a-f0-9]+$/i.test(D["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!b})}))}setExperimentProperty(h,E){this._experimentProperties[h]=E}setEnabled(h){this._enabled=h}_updateUserOptIn(){var h;const E=(h=this._configurationService)===null||h===void 0?void 0:h.getValue(m);this._userOptIn=E?E.enableTelemetry:this._userOptIn}get isOptedIn(){return this._userOptIn&&this._enabled}async getTelemetryInfo(){const h=await this._commonProperties;let E=h.sessionID,D=h["common.instanceId"],b=h["common.machineId"],I=h["common.firstSessionDate"],g=h["common.msftInternal"];return{sessionId:E,instanceId:D,machineId:b,firstSessionDate:I,msftInternal:g}}dispose(){this._disposables.dispose()}publicLog(h,E,D){return this.isOptedIn?this._commonProperties.then(b=>{E=(0,S.mixin)(E,b),E=(0,S.mixin)(E,this._experimentProperties),E=(0,S.cloneAndChange)(E,I=>{if(typeof I=="string")return this._cleanupInfo(I,D)}),this._appender.log(h,E)},b=>{console.error(b)}):Promise.resolve(void 0)}publicLog2(h,E,D){return this.publicLog(h,E,D)}publicLogError(h,E){return this.sendErrorTelemetry?this.publicLog(h,E,!0):Promise.resolve(void 0)}publicLogError2(h,E){return this.publicLogError(h,E)}_cleanupInfo(h,E){let D=h;if(E){const b=[];for(let s of this._cleanupPatterns)for(;;){const t=s.exec(h);if(!t)break;b.push([t.index,s.lastIndex])}const I=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,g=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let a=0;for(D="";;){const s=g.exec(h);if(!s)break;!I.test(s[0])&&b.every(([t,r])=>s.index<t||s.index>=r)&&(D+=h.substring(a,s.index)+"<REDACTED: user-file-path>",a=g.lastIndex)}a<h.length&&(D+=h.substr(a))}for(let b of this._cleanupPatterns)D=D.replace(b,"");return D}};f.IDLE_START_EVENT_NAME="UserIdleStart",f.IDLE_STOP_EVENT_NAME="UserIdleStop",f=de([Y(1,(0,k.optional)(A.IConfigurationService))],f),e.TelemetryService=f;const m="telemetry";n.Registry.as(R.Extensions.Configuration).registerConfiguration({id:m,order:110,type:"object",title:(0,P.localize)(0,null),properties:{"telemetry.enableTelemetry":{type:"boolean",markdownDescription:y.default.privacyStatementUrl?(0,P.localize)(2,null,y.default.privacyStatementUrl):(0,P.localize)(1,null),default:!0,restricted:!0,scope:1,tags:["usesOnlineServices"]}}})}),define(Z[59],ee([0,1,23,26,15,8]),function(G,e,y,P,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanRemoteAuthority=e.validateTelemetryData=e.configurationTelemetry=e.NullAppender=e.combinedAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=void 0,e.NullTelemetryService=new class{constructor(){this.sendErrorTelemetry=!1,this.isOptedIn=!0}publicLog(h,E){return Promise.resolve(void 0)}publicLog2(h,E){return this.publicLog(h,E)}publicLogError(h,E){return Promise.resolve(void 0)}publicLogError2(h,E){return this.publicLogError(h,E)}setExperimentProperty(){}setEnabled(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}};class A{async publicLog(E,D,b){}async publicLogError(E,D,b){}}e.NullEndpointTelemetryService=A;function R(...h){return{log:(E,D)=>h.forEach(b=>b.log(E,D)),flush:()=>k.Promises.settled(h.map(E=>E.flush()))}}e.combinedAppender=R,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function p(h,E){return E.onDidChangeConfiguration(D=>{D.source!==6&&h.publicLog2("updateConfiguration",{configurationSource:(0,y.ConfigurationTargetToString)(D.source),configurationKeys:m(D.sourceConfig)})})}e.configurationTelemetry=p;function S(h){const E=Object.create(null),D=Object.create(null),b=Object.create(null);f(h,b);for(let I in b){I=I.length>150?I.substr(I.length-149):I;const g=b[I];typeof g=="number"?D[I]=g:typeof g=="boolean"?D[I]=g?1:0:typeof g=="string"?E[I]=g.substring(0,1023):typeof g!="undefined"&&g!==null&&(E[I]=g)}return{properties:E,measurements:D}}e.validateTelemetryData=S;function n(h){if(!h)return"none";let E="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(b=>{h.indexOf(`${b}+`)===0&&(E=b)}),E}e.cleanRemoteAuthority=n;function f(h,E,D=0,b){if(!!h)for(let I of Object.getOwnPropertyNames(h)){const g=h[I],a=b?b+I:I;Array.isArray(g)?E[a]=(0,P.safeStringify)(g):g instanceof Date?E[a]=g.toISOString():(0,L.isObject)(g)?D<2?f(g,E,D+1,a+"."):E[a]=(0,P.safeStringify)(g):E[a]=g}}function m(h){if(!h)return[];const E=[];return C(E,"",h),E}function C(h,E,D){D&&typeof D=="object"&&!Array.isArray(D)?Object.keys(D).forEach(b=>C(h,E?`${E}.${b}`:b,D[b])):h.push(E)}}),define(Z[174],ee([0,1,2,9,18,59]),function(G,e,y,P,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryLogAppender=void 0;let A=class extends y.Disposable{constructor(p,S){super();this.logger=this._register(p.createLogger(S.telemetryLogResource)),this.logger.info("The below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.logger.info("===========================================================")}flush(){return Promise.resolve(void 0)}log(p,S){this.logger.trace(`telemetry/${p}`,(0,k.validateTelemetryData)(S))}};A=de([Y(0,L.ILoggerService),Y(1,P.IEnvironmentService)],A),e.TelemetryLogAppender=A}),define(Z[175],ee([0,1,11,26,59]),function(G,e,y,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AppInsightsAppender=void 0;async function k(R){const p=await new Promise((n,f)=>{G(["applicationinsights"],n,f)});let S;return p.defaultClient?(S=new p.TelemetryClient(R),S.channel.setUseDiskRetryCaching(!0)):(p.setup(R).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),S=p.defaultClient),R.indexOf("AIF-")===0&&(S.config.endpointUrl="https://vortex.data.microsoft.com/collect/v1"),S}class A{constructor(p,S,n){this._eventPrefix=p,this._defaultData=S,this._defaultData||(this._defaultData=Object.create(null)),typeof n=="function"?this._aiClient=n():this._aiClient=n,this._asyncAIClient=null}_withAIClient(p){if(!!this._aiClient){if(typeof this._aiClient!="string"){p(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=k(this._aiClient)),this._asyncAIClient.then(S=>{p(S)},S=>{(0,y.onUnexpectedError)(S),console.error(S)})}}log(p,S){!this._aiClient||(S=(0,P.mixin)(S,this._defaultData),S=(0,L.validateTelemetryData)(S),this._withAIClient(n=>n.trackEvent({name:this._eventPrefix+"/"+p,properties:S.properties,measurements:S.measurements})))}flush(){return this._aiClient?new Promise(p=>{this._withAIClient(S=>{S.flush({callback:()=>{this._aiClient=void 0,p(void 0)}})})}):Promise.resolve(void 0)}}e.AppInsightsAppender=A}),define(Z[176],ee([0,1,49,80,16,81,23,24]),function(G,e,y,P,L,k,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CustomEndpointTelemetryService=void 0;let p=class{constructor(n,f){this.configurationService=n,this.telemetryService=f,this.customTelemetryServices=new Map}async getCustomTelemetryService(n){if(!this.customTelemetryServices.has(n.id)){const{machineId:f,sessionId:m}=await this.telemetryService.getTelemetryInfo(),C=Object.create(null);C["common.vscodemachineid"]=f,C["common.vscodesessionid"]=m;const h=[n.id,JSON.stringify(C),n.aiKey],D=new y.Client(L.FileAccess.asFileUri("bootstrap-fork",G).fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:h,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),b=new P.TelemetryAppenderClient(D);this.customTelemetryServices.set(n.id,new k.TelemetryService({appender:b,sendErrorTelemetry:n.sendErrorTelemetry},this.configurationService))}return this.customTelemetryServices.get(n.id)}async publicLog(n,f,m){await(await this.getCustomTelemetryService(n)).publicLog(f,m)}async publicLogError(n,f,m){await(await this.getCustomTelemetryService(n)).publicLogError(f,m)}};p=de([Y(0,A.IConfigurationService),Y(1,R.ITelemetryService)],p),e.CustomEndpointTelemetryService=p}),define(Z[82],ee([0,1,4]),function(G,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.HeartbeatConstants=e.IPtyService=e.ILocalTerminalService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.TerminalSettingId=void 0;var P;(function(f){f.ShellLinux="terminal.integrated.shell.linux",f.ShellMacOs="terminal.integrated.shell.osx",f.ShellWindows="terminal.integrated.shell.windows",f.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",f.AutomationShellLinux="terminal.integrated.automationShell.linux",f.AutomationShellMacOs="terminal.integrated.automationShell.osx",f.AutomationShellWindows="terminal.integrated.automationShell.windows",f.ShellArgsLinux="terminal.integrated.shellArgs.linux",f.ShellArgsMacOs="terminal.integrated.shellArgs.osx",f.ShellArgsWindows="terminal.integrated.shellArgs.windows",f.ProfilesWindows="terminal.integrated.profiles.windows",f.ProfilesMacOs="terminal.integrated.profiles.osx",f.ProfilesLinux="terminal.integrated.profiles.linux",f.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",f.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",f.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",f.UseWslProfiles="terminal.integrated.useWslProfiles",f.TabsEnabled="terminal.integrated.tabs.enabled",f.TabsHideCondition="terminal.integrated.tabs.hideCondition",f.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",f.TabsLocation="terminal.integrated.tabs.location",f.TabsFocusMode="terminal.integrated.tabs.focusMode",f.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",f.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",f.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",f.CopyOnSelection="terminal.integrated.copyOnSelection",f.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",f.FontFamily="terminal.integrated.fontFamily",f.FontSize="terminal.integrated.fontSize",f.LetterSpacing="terminal.integrated.letterSpacing",f.LineHeight="terminal.integrated.lineHeight",f.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",f.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",f.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",f.BellDuration="terminal.integrated.bellDuration",f.FontWeight="terminal.integrated.fontWeight",f.FontWeightBold="terminal.integrated.fontWeightBold",f.CursorBlinking="terminal.integrated.cursorBlinking",f.CursorStyle="terminal.integrated.cursorStyle",f.CursorWidth="terminal.integrated.cursorWidth",f.Scrollback="terminal.integrated.scrollback",f.DetectLocale="terminal.integrated.detectLocale",f.GpuAcceleration="terminal.integrated.gpuAcceleration",f.RightClickBehavior="terminal.integrated.rightClickBehavior",f.Cwd="terminal.integrated.cwd",f.ConfirmOnExit="terminal.integrated.confirmOnExit",f.EnableBell="terminal.integrated.enableBell",f.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",f.AllowChords="terminal.integrated.allowChords",f.AllowMnemonics="terminal.integrated.allowMnemonics",f.EnvMacOs="terminal.integrated.env.osx",f.EnvLinux="terminal.integrated.env.linux",f.EnvWindows="terminal.integrated.env.windows",f.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",f.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",f.ShowExitAlert="terminal.integrated.showExitAlert",f.SplitCwd="terminal.integrated.splitCwd",f.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",f.WordSeparators="terminal.integrated.wordSeparators",f.TitleMode="terminal.integrated.titleMode",f.EnableFileLinks="terminal.integrated.enableFileLinks",f.UnicodeVersion="terminal.integrated.unicodeVersion",f.ExperimentalLinkProvider="terminal.integrated.experimentalLinkProvider",f.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",f.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",f.LocalEchoStyle="terminal.integrated.localEchoStyle",f.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",f.AllowWorkspaceConfiguration="terminal.integrated.allowWorkspaceConfiguration",f.InheritEnv="terminal.integrated.inheritEnv"})(P=e.TerminalSettingId||(e.TerminalSettingId={}));var L;(function(f){f.CommandPrompt="cmd",f.PowerShell="pwsh",f.Wsl="wsl",f.GitBash="gitbash"})(L=e.WindowsShellType||(e.WindowsShellType={}));var k;(function(f){f[f.Api=0]="Api",f[f.Process=1]="Process",f[f.Sequence=2]="Sequence"})(k=e.TitleEventSource||(e.TitleEventSource={}));var A;(function(f){f.LocalPty="localPty",f.PtyHost="ptyHost",f.Log="log",f.Heartbeat="heartbeat"})(A=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.ILocalTerminalService=(0,y.createDecorator)("localTerminalService"),e.IPtyService=(0,y.createDecorator)("ptyService");var R;(function(f){f[f.BeatInterval=5e3]="BeatInterval",f[f.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",f[f.SecondWaitMultiplier=1]="SecondWaitMultiplier",f[f.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(R=e.HeartbeatConstants||(e.HeartbeatConstants={}));var p;(function(f){f[f.ReconnectionGraceTime=6e4]="ReconnectionGraceTime",f[f.ReconnectionShortGraceTime=6e3]="ReconnectionShortGraceTime"})(p=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var S;(function(f){f[f.HighWatermarkChars=1e5]="HighWatermarkChars",f[f.LowWatermarkChars=5e3]="LowWatermarkChars",f[f.CharCountAckSize=5e3]="CharCountAckSize"})(S=e.FlowControlConstants||(e.FlowControlConstants={}));var n;(function(f){f.GitBash="Git Bash",f.Pwsh="PowerShell"})(n=e.ProfileSource||(e.ProfileSource={}))}),define(Z[177],ee([0,1,37,120,31,54]),function(G,e,y,P,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=void 0;const A={type:"object",required:["path"],properties:{path:{description:(0,P.localize)(0,null),type:["string","array"],items:{type:"string"}},args:{description:(0,P.localize)(1,null),type:"array",items:{type:"string"}},overrideName:{description:(0,P.localize)(2,null),type:"boolean"},icon:{description:(0,P.localize)(3,null),type:"string",enum:Array.from(k.iconRegistry.all,E=>E.id),markdownEnumDescriptions:Array.from(k.iconRegistry.all,E=>`$(${E.id})`)},env:{markdownDescription:(0,P.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}}},R=(0,P.localize)(5,null,"`#terminal.integrated.profiles.linux#`","`#terminal.integrated.defaultProfile.linux#`"),p=(0,P.localize)(6,null,"`#terminal.integrated.profiles.osx#`","`#terminal.integrated.defaultProfile.osx#`"),S=(0,P.localize)(7,null,"`#terminal.integrated.profiles.windows#`","`#terminal.integrated.defaultProfile.windows#`"),n={id:"terminal",order:100,title:(0,P.localize)(8,null),type:"object",properties:{["terminal.integrated.automationShell.linux"]:{restricted:!0,markdownDescription:(0,P.localize)(9,null,"`terminal.integrated.shell.linux`","`shellArgs`"),type:["string","null"],default:null},["terminal.integrated.automationShell.osx"]:{restricted:!0,markdownDescription:(0,P.localize)(10,null,"`terminal.integrated.shell.osx`","`shellArgs`"),type:["string","null"],default:null},["terminal.integrated.automationShell.windows"]:{restricted:!0,markdownDescription:(0,P.localize)(11,null,"`terminal.integrated.shell.windows`","`shellArgs`"),type:["string","null"],default:null},["terminal.integrated.shell.linux"]:{restricted:!0,markdownDescription:(0,P.localize)(12,null),type:["string","null"],default:null,markdownDeprecationMessage:R},["terminal.integrated.shell.osx"]:{restricted:!0,markdownDescription:(0,P.localize)(13,null),type:["string","null"],default:null,markdownDeprecationMessage:p},["terminal.integrated.shell.windows"]:{restricted:!0,markdownDescription:(0,P.localize)(14,null),type:["string","null"],default:null,markdownDeprecationMessage:S},["terminal.integrated.shellArgs.linux"]:{restricted:!0,markdownDescription:(0,P.localize)(15,null),type:"array",items:{type:"string"},default:[],markdownDeprecationMessage:R},["terminal.integrated.shellArgs.osx"]:{restricted:!0,markdownDescription:(0,P.localize)(16,null),type:"array",items:{type:"string"},default:["-l"],markdownDeprecationMessage:p},["terminal.integrated.shellArgs.windows"]:{restricted:!0,markdownDescription:(0,P.localize)(17,null),anyOf:[{type:"array",items:{type:"string",markdownDescription:(0,P.localize)(18,null)}},{type:"string",markdownDescription:(0,P.localize)(19,null)}],default:[],markdownDeprecationMessage:S},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:(0,P.localize)(20,null,"`source`","`path`","`args`."),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,P.localize)(21,null),enum:["PowerShell","Git Bash"]},args:{description:(0,P.localize)(22,null),type:"array",items:{type:"string"}},overrideName:{description:(0,P.localize)(23,null),type:"boolean"},icon:{description:(0,P.localize)(24,null),type:"string",enum:Array.from(k.iconRegistry.all,E=>E.id),markdownEnumDescriptions:Array.from(k.iconRegistry.all,E=>`$(${E.id})`)},env:{markdownDescription:(0,P.localize)(25,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}}},{type:"null"},A]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:(0,P.localize)(26,null,"`path`","`args`."),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"null"},A]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:(0,P.localize)(27,null,"`path`","`args`."),type:"object",default:{bash:{path:"bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"null"},A]}},["terminal.integrated.useWslProfiles"]:{description:(0,P.localize)(28,null),type:"boolean",default:!0},["terminal.integrated.allowWorkspaceConfiguration"]:{scope:1,description:(0,P.localize)(29,null),type:"boolean",default:!1},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,P.localize)(30,null),type:"boolean",default:!0}}};function f(){L.Registry.as(y.Extensions.Configuration).registerConfiguration(n),C()}e.registerTerminalPlatformConfiguration=f;let m;function C(E){const D=L.Registry.as(y.Extensions.Configuration);m&&D.deregisterConfigurations([m]);let b,I;if(E){const g=E.profiles.map(a=>({name:a.profileName,description:h(a)}));b=g.map(a=>a.name),I=g.map(a=>a.description)}m={id:"terminal",order:100,title:(0,P.localize)(31,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,P.localize)(32,null,"`#terminal.integrated.shell.linux#`","`#terminal.integrated.shellArgs.linux#`"),type:["string","null"],default:null,enum:(E==null?void 0:E.os)===3?b:void 0,markdownEnumDescriptions:(E==null?void 0:E.os)===3?I:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,description:(0,P.localize)(33,null,"`#terminal.integrated.shell.osx#`","`#terminal.integrated.shellArgs.osx#`"),type:["string","null"],default:null,enum:(E==null?void 0:E.os)===2?b:void 0,markdownEnumDescriptions:(E==null?void 0:E.os)===2?I:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,description:(0,P.localize)(34,null,"`#terminal.integrated.shell.windows#`","`#terminal.integrated.shellArgs.windows#`"),type:["string","null"],default:null,enum:(E==null?void 0:E.os)===1?b:void 0,markdownEnumDescriptions:(E==null?void 0:E.os)===1?I:void 0}}},D.registerConfiguration(m)}e.registerTerminalDefaultProfileConfiguration=C;function h(E){let D=`$(${E.icon||k.Codicon.terminal.id}) ${E.profileName}
- path: ${E.path}`;return E.args&&(typeof E.args=="string"?D+=`
- args: "${E.args}"`:D+=`
- args: [${E.args.length===0?"":E.args.join("','")}]`),E.overrideName!==void 0&&(D+=`
- overrideName: ${E.overrideName}`),E.env&&(D+=`
- env: ${JSON.stringify(E.env)}`),D}}),define(Z[178],ee([0,1,4]),function(G,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILocalPtyService=void 0,e.ILocalPtyService=(0,y.createDecorator)("localPtyService")}),define(Z[179],ee([0,1,35,7,34,17,15,26,6]),function(G,e,y,P,L,k,A,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findExecutable=e.getWindowsBuildNumber=void 0;function S(){const f=/(\d+)\.(\d+)\.(\d+)/g.exec(y.release());let m=0;return f&&f.length===4&&(m=parseInt(f[3])),m}e.getWindowsBuildNumber=S;async function n(f,m,C,h=L.env,E=k.exists){if(P.isAbsolute(f))return await E(f)?f:void 0;if(m===void 0&&(m=L.cwd()),P.dirname(f)!=="."){const g=P.join(m,f);return await E(g)?g:void 0}const b=(0,R.getCaseInsensitive)(h,"PATH");if(C===void 0&&(0,A.isString)(b)&&(C=b.split(P.delimiter)),C===void 0||C.length===0){const g=P.join(m,f);return await E(g)?g:void 0}for(let g of C){let a;if(P.isAbsolute(g)?a=P.join(g,f):a=P.join(m,g,f),await E(a))return a;if(p.isWindows){let s=a+".com";if(await E(s)||(s=a+".exe",await E(s)))return s}}const I=P.join(m,f);return await E(I)?I:void 0}e.findExecutable=n}),define(Z[180],ee([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var y;(function(P){P.DARK="dark",P.LIGHT="light",P.HIGH_CONTRAST="hc"})(y=e.ColorScheme||(e.ColorScheme={}))}),define(Z[181],ee([0,1,4,2,31,3,180,54]),function(G,e,y,P,L,k,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,y.createDecorator)("themeService");var p;(function(D){function b(I){return I&&typeof I=="object"&&typeof I.id=="string"}D.isThemeColor=b})(p=e.ThemeColor||(e.ThemeColor={}));function S(D){return{id:D}}e.themeColorFromId=S;var n;(function(D){function b(r){return r&&typeof r=="object"&&typeof r.id=="string"&&(typeof r.color=="undefined"||p.isThemeColor(r.color))}D.isThemeIcon=b;const I=new RegExp(`^\\$\\((${R.CSSIcon.iconNameExpression}(?:${R.CSSIcon.iconModifierExpression})?)\\)$`);function g(r){const i=I.exec(r);if(!i)return;let[,o]=i;return{id:o}}D.fromString=g;function a(r,i){let o=r.id;const c=o.lastIndexOf("~");return c!==-1&&(o=o.substring(0,c)),i&&(o=`${o}~${i}`),{id:o}}D.modify=a;function s(r,i){var o,c;return r.id===i.id&&((o=r.color)===null||o===void 0?void 0:o.id)===((c=i.color)===null||c===void 0?void 0:c.id)}D.isEqual=s;function t(r){return{id:r.id}}D.asThemeIcon=t,D.asClassNameArray=R.CSSIcon.asClassNameArray,D.asClassName=R.CSSIcon.asClassName,D.asCSSSelector=R.CSSIcon.asCSSSelector})(n=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=R.Codicon.file,e.FolderThemeIcon=R.Codicon.folder;function f(D){switch(D){case A.ColorScheme.DARK:return"vs-dark";case A.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=f,e.Extensions={ThemingContribution:"base.contributions.theming"};class m{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new k.Emitter}onColorThemeChange(b){return this.themingParticipants.push(b),this.onThemingParticipantAddedEmitter.fire(b),(0,P.toDisposable)(()=>{const I=this.themingParticipants.indexOf(b);this.themingParticipants.splice(I,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let C=new m;L.Registry.add(e.Extensions.ThemingContribution,C);function h(D){return C.onColorThemeChange(D)}e.registerThemingParticipant=h;class E extends P.Disposable{constructor(b){super();this.themeService=b,this.theme=b.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(I=>this.onThemeChange(I)))}onThemeChange(b){this.theme=b,this.updateStyles()}updateStyles(){}getColor(b,I){let g=this.theme.getColor(b);return g&&I&&(g=I(g,this.theme)),g?g.toString():null}}e.Themable=E});var et=this&&this.__asyncValues||function(G){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var e=G[Symbol.asyncIterator],y;return e?e.call(G):(G=typeof __values=="function"?__values(G):G[Symbol.iterator](),y={},P("next"),P("throw"),P("return"),y[Symbol.asyncIterator]=function(){return this},y);function P(k){y[k]=G[k]&&function(A){return new Promise(function(R,p){A=G[k](A),L(R,p,A.done,A.value)})}}function L(k,A,R,p){Promise.resolve(p).then(function(S){k({value:S,done:R})},A)}};define(Z[182],ee([0,1,7,95,179,43,17,54,6,181]),function(G,e,y,P,L,k,A,R,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let n;function f(a,s,t,r,i,o){return t=t||{existsFile:A.SymlinkSupport.existsFile,readFile:A.Promises.readFile},p.isWindows?m(a,t,r,s("terminal.integrated.useWslProfiles")!==!1,s("terminal.integrated.profiles.windows"),s("terminal.integrated.defaultProfile.windows"),i):b(t,r,a,s(p.isMacintosh?"terminal.integrated.profiles.osx":"terminal.integrated.profiles.linux"),s(p.isMacintosh?"terminal.integrated.defaultProfile.osx":"terminal.integrated.defaultProfile.linux"),o,i)}e.detectAvailableProfiles=f;async function m(a,s,t,r,i,o,c){const l=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),u=`${process.env.windir}\\${l?"Sysnative":"System32"}`;let v=!1;(0,L.getWindowsBuildNumber)()>=16299&&(v=!0),await h();const w=new Map;a&&(w.set("PowerShell",{source:"PowerShell",icon:R.Codicon.terminalPowershell,isAutoDetected:!0}),w.set("Windows PowerShell",{path:`${u}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:R.Codicon.terminalPowershell,isAutoDetected:!0}),w.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),w.set("Cygwin",{path:[`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`],args:["--login"],isAutoDetected:!0}),w.set("Command Prompt",{path:`${u}\\cmd.exe`,icon:R.Codicon.terminalCmd,isAutoDetected:!0})),I(i,w);const d=await C(w.entries(),o,s,t,c);if(a||!a&&r)try{const T=await D(`${u}\\${v?"wsl":"bash"}.exe`,o);T&&d.push(...T)}catch(T){t==null||t.info("WSL is not installed, so could not detect WSL profiles")}return d}async function C(a,s,t,r,i){const o=[];for(const[c,l]of a){if(l===null)continue;let u,v,w;if("source"in l){const F=n==null?void 0:n.get(l.source);if(!F)continue;u=F.paths,v=l.args||F.args,l.icon?w=l.icon:F.icon&&(w=F.icon)}else u=Array.isArray(l.path)?l.path:[l.path],v=p.isWindows||Array.isArray(l.args)?l.args:void 0,w=l.icon||void 0;const d=await(i==null?void 0:i(u))||u.slice(),T=await g(c,s,d,t,v,l.env,l.overrideName,l.isAutoDetected,r);T?(T.isAutoDetected=l.isAutoDetected,T.icon=w,o.push(T)):r==null||r.trace("profile not validated",c,u)}return o}async function h(){n||(n=new Map,n.set("Git Bash",{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`,`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`,`${process.env.AllUsersProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`],args:["--login"]}),n.set("PowerShell",{profileName:"PowerShell",paths:await E(),icon:S.ThemeIcon.asThemeIcon(R.Codicon.terminalPowershell)}))}async function E(){var a,s;const t=[];try{for(var r=et((0,P.enumeratePowerShellInstallations)()),i;i=await r.next(),!i.done;){const o=i.value;t.push(o.exePath)}}catch(o){a={error:o}}finally{try{i&&!i.done&&(s=r.return)&&await s.call(r)}finally{if(a)throw a.error}}return t}async function D(a,s){const t=[],r=await new Promise((c,l)=>{k.exec("wsl.exe -l -q",{encoding:"utf16le"},(u,v)=>{if(u)return l("Problem occurred when getting wsl distros");c(v)})});if(!r)return[];const i=new RegExp(/[\r?\n]/),o=r.split(i).filter(c=>c.trim().length>0&&c!=="");for(const c of o){if(c===""||c.startsWith("docker-desktop"))continue;const l=`${c} (WSL)`,u={profileName:l,path:a,args:["-d",`${c}`],isDefault:l===s};c.includes("Ubuntu")?u.icon=S.ThemeIcon.asThemeIcon(R.Codicon.terminalUbuntu):c.includes("Debian")?u.icon=S.ThemeIcon.asThemeIcon(R.Codicon.terminalDebian):u.icon=S.ThemeIcon.asThemeIcon(R.Codicon.terminalLinux),t.push(u)}return t}async function b(a,s,t,r,i,o,c){const l=new Map;if(t){const u=(await a.readFile("/etc/shells")).toString(),v=o||u.split(`
`).filter(d=>d.trim().indexOf("#")!==0&&d.trim().length>0),w=new Map;for(const d of v){let T=(0,y.basename)(d),F=w.get(T)||0;F++,F>1&&(T=`${T} (${F})`),w.set(T,F),l.set(T,{path:d,isAutoDetected:!0})}}return I(r,l),await C(l.entries(),i,a,s,c)}function I(a,s){if(!!a)for(const[t,r]of Object.entries(a))r===null||!("path"in r)&&!("source"in r)?s.delete(t):s.set(t,r)}async function g(a,s,t,r,i,o,c,l,u){if(t.length===0)return Promise.resolve(void 0);const v=t.shift();if(v==="")return g(a,s,t,r,i,o,c,l);const w={profileName:a,path:v,args:i,env:o,overrideName:c,isAutoDetected:l,isDefault:a===s};if((0,y.basename)(v)===v){const T=process.env.PATH?process.env.PATH.split(y.delimiter):void 0;return await(0,L.findExecutable)(v,void 0,T,void 0,r.existsFile)?w:g(a,s,t,r,i)}return await r.existsFile((0,y.normalize)(v))?w:g(a,s,t,r,i,o,c,l)}}),define(Z[183],ee([0,1,2,18,82,49,16,36,3,77,24,182,23,177]),function(G,e,y,P,L,k,A,R,p,S,n,f,m,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var h;(function(I){I[I.MaxRestarts=5]="MaxRestarts"})(h||(h={}));let E=0,D=0,b=class extends y.Disposable{constructor(g,a,s){super();this._configurationService=g,this._logService=a,this._telemetryService=s,this._restartCount=0,this._isResponsive=!0,this._isDisposed=!1,this._onPtyHostExit=this._register(new p.Emitter),this.onPtyHostExit=this._onPtyHostExit.event,this._onPtyHostStart=this._register(new p.Emitter),this.onPtyHostStart=this._onPtyHostStart.event,this._onPtyHostUnresponsive=this._register(new p.Emitter),this.onPtyHostUnresponsive=this._onPtyHostUnresponsive.event,this._onPtyHostResponsive=this._register(new p.Emitter),this.onPtyHostResponsive=this._onPtyHostResponsive.event,this._onPtyHostRequestResolveVariables=this._register(new p.Emitter),this.onPtyHostRequestResolveVariables=this._onPtyHostRequestResolveVariables.event,this._onProcessData=this._register(new p.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessExit=this._register(new p.Emitter),this.onProcessExit=this._onProcessExit.event,this._onProcessReady=this._register(new p.Emitter),this.onProcessReady=this._onProcessReady.event,this._onProcessReplay=this._register(new p.Emitter),this.onProcessReplay=this._onProcessReplay.event,this._onProcessTitleChanged=this._register(new p.Emitter),this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessShellTypeChanged=this._register(new p.Emitter),this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event,this._onProcessOverrideDimensions=this._register(new p.Emitter),this.onProcessOverrideDimensions=this._onProcessOverrideDimensions.event,this._onProcessResolvedShellLaunchConfig=this._register(new p.Emitter),this.onProcessResolvedShellLaunchConfig=this._onProcessResolvedShellLaunchConfig.event,this._onProcessOrphanQuestion=this._register(new p.Emitter),this.onProcessOrphanQuestion=this._onProcessOrphanQuestion.event,this._pendingResolveVariablesRequests=new Map,(0,C.registerTerminalPlatformConfiguration)(),this._register((0,y.toDisposable)(()=>this._disposePtyHost())),[this._client,this._proxy]=this._startPtyHost()}_startPtyHost(){const g=new k.Client(A.FileAccess.asFileUri("bootstrap-fork",G).fsPath,{serverName:"Pty Host",args:["--type=ptyHost"],env:{VSCODE_LAST_PTY_ID:E,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}});this._onPtyHostStart.fire(),R.ProxyChannel.toService(g.getChannel(L.TerminalIpcChannels.Heartbeat)).onBeat(()=>this._handleHeartbeat()),this._handleHeartbeat(),this._register(g.onDidProcessExit(r=>{this._telemetryService.publicLog("ptyHost/exit"),this._onPtyHostExit.fire(r.code),this._isDisposed||(this._restartCount<=h.MaxRestarts?(this._logService.error(`ptyHost terminated unexpectedly with code ${r.code}`),this._restartCount++,this.restartPtyHost()):this._logService.error(`ptyHost terminated unexpectedly with code ${r.code}, giving up`))}));const s=g.getChannel(L.TerminalIpcChannels.Log);S.LogLevelChannelClient.setLevel(s,this._logService.getLevel()),this._register(this._logService.onDidChangeLogLevel(()=>{S.LogLevelChannelClient.setLevel(s,this._logService.getLevel())}));const t=R.ProxyChannel.toService(g.getChannel(L.TerminalIpcChannels.PtyHost));return this._register(t.onProcessData(r=>this._onProcessData.fire(r))),this._register(t.onProcessExit(r=>this._onProcessExit.fire(r))),this._register(t.onProcessReady(r=>this._onProcessReady.fire(r))),this._register(t.onProcessTitleChanged(r=>this._onProcessTitleChanged.fire(r))),this._register(t.onProcessShellTypeChanged(r=>this._onProcessShellTypeChanged.fire(r))),this._register(t.onProcessOverrideDimensions(r=>this._onProcessOverrideDimensions.fire(r))),this._register(t.onProcessResolvedShellLaunchConfig(r=>this._onProcessResolvedShellLaunchConfig.fire(r))),this._register(t.onProcessReplay(r=>this._onProcessReplay.fire(r))),this._register(t.onProcessOrphanQuestion(r=>this._onProcessOrphanQuestion.fire(r))),[g,t]}dispose(){this._isDisposed=!0,super.dispose()}async createProcess(g,a,s,t,r,i,o,c,l,u){const v=setTimeout(()=>this._handleUnresponsiveCreateProcess(),L.HeartbeatConstants.CreateProcessTimeout),w=await this._proxy.createProcess(g,a,s,t,r,i,o,c,l,u);return clearTimeout(v),E=Math.max(E,w),w}updateTitle(g,a,s){return this._proxy.updateTitle(g,a,s)}updateIcon(g,a,s){return this._proxy.updateIcon(g,a,s)}attachToProcess(g){return this._proxy.attachToProcess(g)}detachFromProcess(g){return this._proxy.detachFromProcess(g)}listProcesses(){return this._proxy.listProcesses()}reduceConnectionGraceTime(){return this._proxy.reduceConnectionGraceTime()}start(g){return this._proxy.start(g)}shutdown(g,a){return this._proxy.shutdown(g,a)}input(g,a){return this._proxy.input(g,a)}processBinary(g,a){return this._proxy.processBinary(g,a)}resize(g,a,s){return this._proxy.resize(g,a,s)}acknowledgeDataEvent(g,a){return this._proxy.acknowledgeDataEvent(g,a)}getInitialCwd(g){return this._proxy.getInitialCwd(g)}getCwd(g){return this._proxy.getCwd(g)}getLatency(g){return this._proxy.getLatency(g)}orphanQuestionReply(g){return this._proxy.orphanQuestionReply(g)}getDefaultSystemShell(g){return this._proxy.getDefaultSystemShell(g)}async getProfiles(g=!1){return(0,f.detectAvailableProfiles)(g,this._buildSafeConfigProvider(),void 0,this._logService,this._resolveVariables.bind(this))}getEnvironment(){return this._proxy.getEnvironment()}getWslPath(g){return this._proxy.getWslPath(g)}setTerminalLayoutInfo(g){return this._proxy.setTerminalLayoutInfo(g)}async getTerminalLayoutInfo(g){return await this._proxy.getTerminalLayoutInfo(g)}async restartPtyHost(){this._telemetryService.publicLog("ptyHost/restart"),this._isResponsive=!0,this._disposePtyHost(),[this._client,this._proxy]=this._startPtyHost()}_disposePtyHost(){this._proxy.shutdownAll&&this._proxy.shutdownAll(),this._client.dispose()}_handleHeartbeat(){this._clearHeartbeatTimeouts(),this._heartbeatFirstTimeout=setTimeout(()=>this._handleHeartbeatFirstTimeout(),L.HeartbeatConstants.BeatInterval*L.HeartbeatConstants.FirstWaitMultiplier),this._isResponsive||(this._telemetryService.publicLog("ptyHost/responsive"),this._isResponsive=!0),this._onPtyHostResponsive.fire()}_handleHeartbeatFirstTimeout(){this._logService.warn(`No ptyHost heartbeat after ${L.HeartbeatConstants.BeatInterval*L.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this._heartbeatFirstTimeout=void 0,this._heartbeatSecondTimeout=setTimeout(()=>this._handleHeartbeatSecondTimeout(),L.HeartbeatConstants.BeatInterval*L.HeartbeatConstants.SecondWaitMultiplier)}_handleHeartbeatSecondTimeout(){this._logService.error(`No ptyHost heartbeat after ${(L.HeartbeatConstants.BeatInterval*L.HeartbeatConstants.FirstWaitMultiplier+L.HeartbeatConstants.BeatInterval*L.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this._heartbeatSecondTimeout=void 0,this._isResponsive&&(this._telemetryService.publicLog("ptyHost/unresponsive"),this._isResponsive=!1),this._onPtyHostUnresponsive.fire()}_handleUnresponsiveCreateProcess(){this._clearHeartbeatTimeouts(),this._logService.error(`No ptyHost response to createProcess after ${L.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this._telemetryService.publicLog("ptyHost/responsive"),this._onPtyHostUnresponsive.fire()}_clearHeartbeatTimeouts(){this._heartbeatFirstTimeout&&(clearTimeout(this._heartbeatFirstTimeout),this._heartbeatFirstTimeout=void 0),this._heartbeatSecondTimeout&&(clearTimeout(this._heartbeatSecondTimeout),this._heartbeatSecondTimeout=void 0)}_resolveVariables(g){return new Promise(a=>{const s=++D;this._pendingResolveVariablesRequests.set(s,a),this._onPtyHostRequestResolveVariables.fire({id:s,originalText:g})})}async acceptPtyHostResolvedVariables(g,a){const s=this._pendingResolveVariablesRequests.get(g);s?(s(a),this._pendingResolveVariablesRequests.delete(g)):this._logService.warn(`Resolved variables received without matching request ${g}`)}_buildSafeConfigProvider(){return g=>{if(this._configurationService.getValue("terminal.integrated.allowWorkspaceConfiguration"))return this._configurationService.getValue(g);const s=this._configurationService.inspect(g);return(s==null?void 0:s.userValue)||(s==null?void 0:s.defaultValue)}}};b=de([Y(0,m.IConfigurationService),Y(1,P.ILogService),Y(2,n.ITelemetryService)],b),e.PtyHostService=b}),define(Z[52],ee([0,1,40]),function(G,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLineEndOffset=e.getLineStartOffset=e.edit=void 0;function P(A,R,p,S){const n=(0,y.setProperty)(A,R,p,S)[0];return n&&(A=A.substring(0,n.offset)+n.content+A.substring(n.offset+n.length)),A}e.edit=P;function L(A,R,p){let S=p;for(;S>=0;){if(A.charAt(S)===R.charAt(R.length-1)&&R.length===1)return S+1;if(S--,R.length===2&&S>=0&&A.charAt(S)===R.charAt(0))return S+2}return 0}e.getLineStartOffset=L;function k(A,R,p){let S=p;for(;S>=0;)if(A.charAt(S)===R.charAt(R.length-1)&&R.length===1||(S++,R.length===2&&S>=0&&A.charAt(S)===R.charAt(1)))return S;return A.length-1}e.getLineEndOffset=k}),define(Z[184],ee([0,1,26,57]),function(G,e,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function L(f,m,C,h,E){var D,b;const I=[],g=[],a=[];if(!m){const z=f.filter(({identifier:B})=>E.every(K=>K.toLowerCase()!==B.id.toLowerCase()));return{added:I,removed:g,updated:a,remote:z.length>0?z:null}}f=f.map(S),m=m.map(S),C=C?C.map(S):null;const s=new Map,t=z=>{z.uuid&&s.set(z.id.toLowerCase(),z.uuid)};f.forEach(({identifier:z})=>t(z)),m.forEach(({identifier:z})=>t(z)),C&&C.forEach(({identifier:z})=>t(z));const r=z=>{const B=z.identifier.uuid||s.get(z.identifier.id.toLowerCase());return B?`uuid:${B}`:`id:${z.identifier.id.toLowerCase()}`},i=(z,B)=>(z.set(r(B),B),z),o=f.reduce(i,new Map),c=m.reduce(i,new Map),l=m.reduce((z,B)=>{const K=r(B);B=(0,y.deepClone)(B);const j=o.get(K);return j&&(j.installed&&(B.installed=!0),B.version||(B.version=j.version)),i(z,B)},new Map),u=C?C.reduce(i,new Map):null,v=h.reduce(i,new Map),w=E.reduce((z,B)=>{const K=s.get(B.toLowerCase());return z.add(K?`uuid:${K}`:`id:${B.toLowerCase()}`)},new Set),d=k(o,c,w);if(d.added.size>0||d.removed.size>0||d.updated.size>0){const z=k(u,o,w),B=k(u,c,w),K=(j,H)=>{const q=o.get(j);if(q){const $=c.get(j);return Object.assign(Object.assign({},H?$:q),{version:($.version&&P.gt($.version,q.version),q.version),state:A(q,$,u==null?void 0:u.get(j))})}};for(const j of B.removed.values()){const H=o.get(j);H&&g.push(H.identifier)}for(const j of B.added.values())if(z.added.has(j)){if(d.updated.has(j)){const H=K(j,!0);H&&(a.push(n(H,j)),l.set(j,H))}}else{const H=c.get(j);H.installed&&I.push(n(H,j))}for(const j of B.updated.values()){const H=K(j,!0);H&&(a.push(n(H,j)),l.set(j,H))}for(const j of z.added.values())B.added.has(j)||l.set(j,o.get(j));for(const j of z.updated.values())if(!B.removed.has(j)&&!B.updated.has(j)){const H=K(j,!1);H&&(((D=l.get(j))===null||D===void 0?void 0:D.installed)&&(H.installed=!0),l.set(j,H))}for(const j of z.removed.values())!v.has(j)&&!B.updated.has(j)&&((b=u==null?void 0:u.get(j))===null||b===void 0?void 0:b.installed)&&l.delete(j)}const T=[],F=k(c,l,new Set,{checkInstalledProperty:!0,checkVersionProperty:!0});return(F.added.size>0||F.updated.size>0||F.removed.size>0)&&l.forEach((z,B)=>T.push(n(z,B))),{added:I,removed:g,updated:a,remote:T.length?T:null}}e.merge=L;function k(f,m,C,{checkInstalledProperty:h,checkVersionProperty:E}={checkInstalledProperty:!1,checkVersionProperty:!1}){const D=f?[...f.keys()].filter(s=>!C.has(s)):[],b=[...m.keys()].filter(s=>!C.has(s)),I=b.filter(s=>D.indexOf(s)===-1).reduce((s,t)=>(s.add(t),s),new Set),g=D.filter(s=>b.indexOf(s)===-1).reduce((s,t)=>(s.add(t),s),new Set),a=new Set;for(const s of D){if(g.has(s))continue;const t=f.get(s),r=m.get(s);(!r||t.disabled!==r.disabled||!p(t.state,r.state)||E&&t.version!==r.version||h&&t.installed!==r.installed)&&a.add(s)}return{added:I,removed:g,updated:a}}function A(f,m,C){const h=f.state,E=m.state,D=C==null?void 0:C.state;if(!m.version||h&&P.gt(f.version,m.version))return h;if(E&&P.gt(m.version,f.version)||!h)return E;if(!E)return h;const b=(0,y.deepClone)(h),I=D?R(D,E):{added:Object.keys(E).reduce((a,s)=>(a.add(s),a),new Set),removed:new Set,updated:new Set},g=D?R(D,h):{added:Object.keys(h).reduce((a,s)=>(a.add(s),a),new Set),removed:new Set,updated:new Set};for(const a of[...I.added.values(),...I.updated.values()])b[a]=E[a];for(const a of I.removed.values())g.updated.has(a)||delete b[a];return b}function R(f,m){const C=Object.keys(f),h=Object.keys(m),E=h.filter(I=>C.indexOf(I)===-1).reduce((I,g)=>(I.add(g),I),new Set),D=C.filter(I=>h.indexOf(I)===-1).reduce((I,g)=>(I.add(g),I),new Set),b=new Set;for(const I of C){if(D.has(I))continue;const g=f[I],a=m[I];(0,y.equals)(g,a)||b.add(I)}return{added:E,removed:D,updated:b}}function p(f={},m={}){const{added:C,removed:h,updated:E}=R(f,m);return C.size===0&&h.size===0&&E.size===0}function S(f){return Object.assign(Object.assign({},f),{disabled:!!f.disabled,installed:!!f.installed})}function n(f,m){const C={identifier:{id:f.identifier.id,uuid:m.startsWith("uuid:")?m.substring("uuid:".length):void 0}};return f.version&&(C.version=f.version),f.disabled&&(C.disabled=!0),f.installed&&(C.installed=!0),f.state&&(C.state=f.state),C}}),define(Z[83],ee([0,1,19,3,2,33,4,27,20]),function(G,e,y,P,L,k,A,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsStorageSyncService=e.IExtensionsStorageSyncService=void 0,e.IExtensionsStorageSyncService=(0,A.createDecorator)("IExtensionsStorageSyncService");const S=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let n=class Ze extends L.Disposable{constructor(m,C){super();this.storageService=m,this.productService=C,this._onDidChangeExtensionsStorage=this._register(new P.Emitter),this.onDidChangeExtensionsStorage=this._onDidChangeExtensionsStorage.event,this.extensionsWithKeysForSync=new Set,this.initialize(),this._register(this.storageService.onDidChangeValue(h=>this.onDidChangeStorageValue(h)))}static toKey(m){return`extensionKeys/${(0,k.adoptToGalleryExtensionId)(m.id)}@${m.version}`}static fromKey(m){const C=S.exec(m);if(C&&C[1])return{id:C[1],version:C[2]}}initialize(){const m=this.storageService.keys(0,1);for(const C of m){const h=Ze.fromKey(C);h&&this.extensionsWithKeysForSync.add(h.id.toLowerCase())}}onDidChangeStorageValue(m){if(m.scope!==0)return;if(this.extensionsWithKeysForSync.has(m.key.toLowerCase())){this._onDidChangeExtensionsStorage.fire();return}const C=Ze.fromKey(m.key);if(C){this.extensionsWithKeysForSync.add(C.id.toLowerCase()),this._onDidChangeExtensionsStorage.fire();return}}setKeysForSync(m,C){this.storageService.store(Ze.toKey(m),JSON.stringify(C),0,1)}getKeysForSync(m){var C;const h=(C=this.productService.extensionSyncedKeys)===null||C===void 0?void 0:C[m.id.toLowerCase()],E=this.storageService.get(Ze.toKey(m),0),D=E?JSON.parse(E):void 0;return D&&h?(0,y.distinct)([...D,...h]):D||h}};n=de([Y(0,p.IStorageService),Y(1,R.IProductService)],n),e.ExtensionsStorageSyncService=n}),define(Z[84],ee([0,1,19,23,4]),function(G,e,y,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IgnoredExtensionsManagementService=e.IIgnoredExtensionsManagementService=void 0,e.IIgnoredExtensionsManagementService=(0,L.createDecorator)("IIgnoredExtensionsManagementService");let k=class{constructor(R){this.configurationService=R}hasToNeverSyncExtension(R){return this.getConfiguredIgnoredExtensions().includes(R.toLowerCase())}hasToAlwaysSyncExtension(R){return this.getConfiguredIgnoredExtensions().includes(`-${R.toLowerCase()}`)}updateIgnoredExtensions(R,p){let S=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(n=>n.toLowerCase());return S=S.filter(n=>n!==R&&n!==`-${R}`),p&&S.push(R.toLowerCase()),this.configurationService.updateValue("settingsSync.ignoredExtensions",S.length?S:void 0,1)}updateSynchronizedExtensions(R,p){let S=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(n=>n.toLowerCase());return S=S.filter(n=>n!==R&&n!==`-${R}`),p&&S.push(`-${R.toLowerCase()}`),this.configurationService.updateValue("settingsSync.ignoredExtensions",S.length?S:void 0,1)}getIgnoredExtensions(R){const p=R.filter(m=>m.isMachineScoped).map(m=>m.identifier.id.toLowerCase()),S=this.getConfiguredIgnoredExtensions().map(m=>m.toLowerCase()),n=[],f=[];if(Array.isArray(S))for(const m of S)m.startsWith("-")?f.push(m.substring(1)):n.push(m);return(0,y.distinct)([...p,...n].filter(m=>f.indexOf(m)===-1))}getConfiguredIgnoredExtensions(){let R=this.configurationService.inspect("settingsSync.ignoredExtensions").userValue;return R!==void 0||(R=this.configurationService.inspect("sync.ignoredExtensions").userValue,R!==void 0)?R:(this.configurationService.getValue("settingsSync.ignoredExtensions")||[]).map(p=>p.toLowerCase())}};k=de([Y(0,P.IConfigurationService)],k),e.IgnoredExtensionsManagementService=k}),define(Z[185],ee([0,1,26,32,19,141,52]),function(G,e,y,P,L,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=e.parseKeybindings=void 0;function R(a){return(0,P.parse)(a)||[]}e.parseKeybindings=R;async function p(a,s,t,r,i){const o=R(a),c=R(s),l=t?R(t):null,u=[...o,...c,...l||[]].map(q=>q.key),v=await i.resolveUserBindings(u);let w=n(o,c,l,v);if(!w.hasLocalForwarded&&!w.hasRemoteForwarded)return{mergeContent:a,hasChanges:!1,hasConflicts:!1};if(!w.hasLocalForwarded&&w.hasRemoteForwarded)return{mergeContent:s,hasChanges:!0,hasConflicts:!1};if(w.hasLocalForwarded&&!w.hasRemoteForwarded)return{mergeContent:a,hasChanges:!0,hasConflicts:!1};const d=m(o),T=m(c),F=l?m(l):null,z=h(d,T,v),B=F?h(F,d,v):{added:[...d.keys()].reduce((q,$)=>(q.add($),q),new Set),removed:new Set,updated:new Set},K=F?h(F,T,v):{added:[...T.keys()].reduce((q,$)=>(q.add($),q),new Set),removed:new Set,updated:new Set},j=S(z,B,K);let H=a;for(const q of j.removed.values())j.conflicts.has(q)||(H=I(H,q,r));for(const q of j.added.values()){if(j.conflicts.has(q))continue;const $=T.get(q);if($.some(M=>M.command!==`-${q}`&&w.conflicts.has(v[M.key]))){j.conflicts.add(q);continue}H=b(H,$,r)}for(const q of j.updated.values()){if(j.conflicts.has(q))continue;const $=T.get(q);if($.some(M=>M.command!==`-${q}`&&w.conflicts.has(v[M.key]))){j.conflicts.add(q);continue}H=g(H,q,$,r)}return{mergeContent:H,hasChanges:!0,hasConflicts:j.conflicts.size>0}}e.merge=p;function S(a,s,t){const r=new Set,i=new Set,o=new Set,c=new Set;for(const l of s.removed.values())t.updated.has(l)&&c.add(l);for(const l of t.removed.values())c.has(l)||(s.updated.has(l)?c.add(l):i.add(l));for(const l of s.added.values())c.has(l)||t.added.has(l)&&a.updated.has(l)&&c.add(l);for(const l of t.added.values())c.has(l)||(s.added.has(l)?a.updated.has(l)&&c.add(l):r.add(l));for(const l of s.updated.values())c.has(l)||t.updated.has(l)&&a.updated.has(l)&&c.add(l);for(const l of t.updated.values())c.has(l)||(s.updated.has(l)?a.updated.has(l)&&c.add(l):o.add(l));return{added:r,removed:i,updated:o,conflicts:c}}function n(a,s,t,r){const i=new Set,o=f(a,r),c=f(s,r),l=t?f(t,r):null,u=C(o,c);if(u.added.size===0&&u.removed.size===0&&u.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:i,removed:i,updated:i,conflicts:i};const v=l?C(l,o):{added:[...o.keys()].reduce((B,K)=>(B.add(K),B),new Set),removed:new Set,updated:new Set};if(v.added.size===0&&v.removed.size===0&&v.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:i,removed:i,updated:i,conflicts:i};const w=l?C(l,c):{added:[...c.keys()].reduce((B,K)=>(B.add(K),B),new Set),removed:new Set,updated:new Set};if(w.added.size===0&&w.removed.size===0&&w.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:i,removed:i,updated:i,conflicts:i};const{added:d,removed:T,updated:F,conflicts:z}=S(u,v,w);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:d,removed:T,updated:F,conflicts:z}}function f(a,s){const t=new Map;for(const r of a){const i=s[r.key];let o=t.get(i);o||(o=[],t.set(i,o)),o.push(r)}return t}function m(a){const s=new Map;for(const t of a){const r=t.command[0]==="-"?t.command.substring(1):t.command;let i=s.get(r);i||(i=[],s.set(r,i)),i.push(t)}return s}function C(a,s){const t=[...a.keys()],r=[...s.keys()],i=r.filter(l=>t.indexOf(l)===-1).reduce((l,u)=>(l.add(u),l),new Set),o=t.filter(l=>r.indexOf(l)===-1).reduce((l,u)=>(l.add(u),l),new Set),c=new Set;for(const l of t){if(o.has(l))continue;const u=a.get(l).map(w=>Object.assign(Object.assign({},w),{key:l})),v=s.get(l).map(w=>Object.assign(Object.assign({},w),{key:l}));(0,L.equals)(u,v,(w,d)=>D(w,d))||c.add(l)}return{added:i,removed:o,updated:c}}function h(a,s,t){const r=[...a.keys()],i=[...s.keys()],o=i.filter(u=>r.indexOf(u)===-1).reduce((u,v)=>(u.add(v),u),new Set),c=r.filter(u=>i.indexOf(u)===-1).reduce((u,v)=>(u.add(v),u),new Set),l=new Set;for(const u of r){if(c.has(u))continue;const v=a.get(u).map(d=>Object.assign(Object.assign({},d),{key:t[d.key]})),w=s.get(u).map(d=>Object.assign(Object.assign({},d),{key:t[d.key]}));E(v,w)||l.add(u)}return{added:o,removed:c,updated:l}}function E(a,s){return!(!(0,L.equals)(a.filter(({command:t})=>t[0]!=="-"),s.filter(({command:t})=>t[0]!=="-"),(t,r)=>D(t,r))||!(0,L.equals)(a.filter(({command:t})=>t[0]==="-"),s.filter(({command:t})=>t[0]==="-"),(t,r)=>D(t,r)))}function D(a,s){if(a.command!==s.command||a.key!==s.key)return!1;const t=k.ContextKeyExpr.deserialize(a.when),r=k.ContextKeyExpr.deserialize(s.when);return!(t&&!r||!t&&r||t&&r&&!t.equals(r)||!y.equals(a.args,s.args))}function b(a,s,t){for(const r of s)a=A.edit(a,[-1],r,t);return a}function I(a,s,t){const r=R(a);for(let i=r.length-1;i>=0;i--)(r[i].command===s||r[i].command===`-${s}`)&&(a=A.edit(a,[i],void 0,t));return a}function g(a,s,t,r){const i=R(a),o=i.findIndex(c=>c.command===s||c.command===`-${s}`);for(let c=i.length-1;c>=0;c--)(i[c].command===s||i[c].command===`-${s}`)&&(a=A.edit(a,[c],void 0,r));for(let c=t.length-1;c>=0;c--)a=A.edit(a,[o],t[c],r);return a}}),define(Z[186],ee([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.areSame=e.merge=void 0;function y(k,A,R){const p={},S={},n=new Set;if(!A)return{local:{added:p,updated:S,removed:[...n.values()]},remote:{added:k,updated:{},removed:[]},conflicts:[]};const f=P(k,A);if(f.added.size===0&&f.removed.size===0&&f.updated.size===0)return{local:{added:p,updated:S,removed:[...n.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const m=P(R,k),C=P(R,A),h={},E={},D=new Set,b=new Set;for(const I of m.removed.values())C.updated.has(I)?p[I]=A[I]:D.add(I);for(const I of C.removed.values())b.has(I)||(m.updated.has(I)?b.add(I):n.add(I));for(const I of m.updated.values())b.has(I)||(C.updated.has(I)?f.updated.has(I)&&b.add(I):E[I]=k[I]);for(const I of C.updated.values())b.has(I)||(m.updated.has(I)?f.updated.has(I)&&b.add(I):k[I]!==void 0&&(S[I]=A[I]));for(const I of m.added.values())b.has(I)||(C.added.has(I)?f.updated.has(I)&&b.add(I):h[I]=k[I]);for(const I of C.added.values())b.has(I)||(m.added.has(I)?f.updated.has(I)&&b.add(I):p[I]=A[I]);return{local:{added:p,removed:[...n.values()],updated:S},remote:{added:h,removed:[...D.values()],updated:E},conflicts:[...b.values()]}}e.merge=y;function P(k,A){const R=k?Object.keys(k):[],p=A?Object.keys(A):[],S=p.filter(m=>R.indexOf(m)===-1).reduce((m,C)=>(m.add(C),m),new Set),n=R.filter(m=>p.indexOf(m)===-1).reduce((m,C)=>(m.add(C),m),new Set),f=new Set;for(const m of R){if(n.has(m))continue;const C=k[m],h=A[m];C!==h&&f.add(m)}return{added:S,removed:n,updated:f}}function L(k,A){const{added:R,removed:p,updated:S}=P(k,A);return R.size===0&&p.size===0&&S.size===0}e.areSame=L}),define(Z[21],ee([0,1,4,28,31,37,125,79,14,19,15]),function(G,e,y,P,L,k,A,R,p,S,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSyncResourceFromLocalPreview=e.PREVIEW_DIR_NAME=e.USER_DATA_SYNC_SCHEME=e.IUserDataSyncLogService=e.IUserDataSyncUtilService=e.IUserDataAutoSyncService=e.IUserDataAutoSyncEnablementService=e.IUserDataSyncService=e.IUserDataSyncResourceEnablementService=e.getEnablementKey=e.SYNC_SERVICE_URL_TYPE=e.MergeState=e.Change=e.SyncStatus=e.UserDataAutoSyncError=e.UserDataSyncStoreError=e.UserDataSyncError=e.UserDataSyncErrorCode=e.createSyncHeaders=e.HEADER_EXECUTION_ID=e.HEADER_OPERATION_ID=e.IUserDataSyncBackupStoreService=e.IUserDataSyncStoreService=e.IUserDataSyncStoreManagementService=e.ALL_SYNC_RESOURCES=e.SyncResource=e.isAuthenticationProvider=e.registerConfiguration=e.getDefaultIgnoredSettings=e.getDisallowedIgnoredSettings=e.CONFIGURATION_SYNC_STORE_KEY=void 0,e.CONFIGURATION_SYNC_STORE_KEY="configurationSync.store";function f(){const c=L.Registry.as(k.Extensions.Configuration).getConfigurationProperties();return Object.keys(c).filter(l=>!!c[l].disallowSyncIgnore)}e.getDisallowedIgnoredSettings=f;function m(){const c=L.Registry.as(k.Extensions.Configuration).getConfigurationProperties(),l=Object.keys(c).filter(w=>!!c[w].ignoreSync),u=Object.keys(c).filter(w=>c[w].scope===2||c[w].scope===6),v=f();return(0,S.distinct)([e.CONFIGURATION_SYNC_STORE_KEY,...l,...u,...v])}e.getDefaultIgnoredSettings=m;function C(){const c="vscode://schemas/ignoredSettings",l=L.Registry.as(k.Extensions.Configuration);l.registerConfiguration({id:"settingsSync",order:30,title:(0,A.localize)(0,null),type:"object",properties:{"settingsSync.keybindingsPerPlatform":{type:"boolean",description:(0,A.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,A.localize)(2,null),items:[{type:"string",pattern:P.EXTENSION_IDENTIFIER_PATTERN,errorMessage:(0,A.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,A.localize)(4,null),default:[],scope:1,$ref:c,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const u=L.Registry.as(R.Extensions.JSONContribution),v=()=>{const w=f(),d=m().filter(B=>B!==e.CONFIGURATION_SYNC_STORE_KEY),T=Object.keys(k.allSettings.properties).filter(B=>d.indexOf(B)===-1),F=d.filter(B=>w.indexOf(B)===-1),z={items:{type:"string",enum:[...T,...F.map(B=>`-${B}`)]}};u.registerSchema(c,z)};return l.onDidUpdateConfiguration(()=>v())}e.registerConfiguration=C;function h(c){return c&&(0,n.isObject)(c)&&(0,n.isString)(c.id)&&(0,n.isArray)(c.scopes)}e.isAuthenticationProvider=h;var E;(function(c){c.Settings="settings",c.Keybindings="keybindings",c.Snippets="snippets",c.Extensions="extensions",c.GlobalState="globalState"})(E=e.SyncResource||(e.SyncResource={})),e.ALL_SYNC_RESOURCES=["settings","keybindings","snippets","extensions","globalState"],e.IUserDataSyncStoreManagementService=(0,y.createDecorator)("IUserDataSyncStoreManagementService"),e.IUserDataSyncStoreService=(0,y.createDecorator)("IUserDataSyncStoreService"),e.IUserDataSyncBackupStoreService=(0,y.createDecorator)("IUserDataSyncBackupStoreService"),e.HEADER_OPERATION_ID="x-operation-id",e.HEADER_EXECUTION_ID="X-Execution-Id";function D(c){const l={};return l[e.HEADER_EXECUTION_ID]=c,l}e.createSyncHeaders=D;var b;(function(c){c.Unauthorized="Unauthorized",c.Conflict="Conflict",c.Gone="Gone",c.PreconditionFailed="PreconditionFailed",c.TooLarge="TooLarge",c.UpgradeRequired="UpgradeRequired",c.PreconditionRequired="PreconditionRequired",c.TooManyRequests="RemoteTooManyRequests",c.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",c.RequestFailed="RequestFailed",c.RequestCanceled="RequestCanceled",c.RequestTimeout="RequestTimeout",c.NoRef="NoRef",c.TurnedOff="TurnedOff",c.SessionExpired="SessionExpired",c.ServiceChanged="ServiceChanged",c.DefaultServiceChanged="DefaultServiceChanged",c.LocalTooManyRequests="LocalTooManyRequests",c.LocalPreconditionFailed="LocalPreconditionFailed",c.LocalInvalidContent="LocalInvalidContent",c.LocalError="LocalError",c.IncompatibleLocalContent="IncompatibleLocalContent",c.IncompatibleRemoteContent="IncompatibleRemoteContent",c.UnresolvedConflicts="UnresolvedConflicts",c.Unknown="Unknown"})(b=e.UserDataSyncErrorCode||(e.UserDataSyncErrorCode={}));class I extends Error{constructor(l,u,v,w){super(l);this.code=u,this.resource=v,this.operationId=w,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.UserDataSyncError=I;class g extends I{constructor(l,u,v,w){super(l,v,void 0,w);this.url=u}}e.UserDataSyncStoreError=g;class a extends I{constructor(l,u){super(l,u)}}e.UserDataAutoSyncError=a,function(c){function l(u){if(u instanceof c)return u;const v=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(u.name);if(v&&v[1]){const w=v[2]==="unknown"?void 0:v[2],d=v[3]==="unknown"?void 0:v[3];return new c(u.message,v[1],w,d)}return new c(u.message,b.Unknown)}c.toUserDataSyncError=l}(I=e.UserDataSyncError||(e.UserDataSyncError={}));var s;(function(c){c.Uninitialized="uninitialized",c.Idle="idle",c.Syncing="syncing",c.HasConflicts="hasConflicts"})(s=e.SyncStatus||(e.SyncStatus={}));var t;(function(c){c[c.None=0]="None",c[c.Added=1]="Added",c[c.Modified=2]="Modified",c[c.Deleted=3]="Deleted"})(t=e.Change||(e.Change={}));var r;(function(c){c.Preview="preview",c.Conflict="conflict",c.Accepted="accepted"})(r=e.MergeState||(e.MergeState={})),e.SYNC_SERVICE_URL_TYPE="sync.store.url.type";function i(c){return`sync.enable.${c}`}e.getEnablementKey=i,e.IUserDataSyncResourceEnablementService=(0,y.createDecorator)("IUserDataSyncResourceEnablementService"),e.IUserDataSyncService=(0,y.createDecorator)("IUserDataSyncService"),e.IUserDataAutoSyncEnablementService=(0,y.createDecorator)("IUserDataAutoSyncEnablementService"),e.IUserDataAutoSyncService=(0,y.createDecorator)("IUserDataAutoSyncService"),e.IUserDataSyncUtilService=(0,y.createDecorator)("IUserDataSyncUtilService"),e.IUserDataSyncLogService=(0,y.createDecorator)("IUserDataSyncLogService"),e.USER_DATA_SYNC_SCHEME="vscode-userdata-sync",e.PREVIEW_DIR_NAME="preview";function o(c,l){if(c.scheme!==e.USER_DATA_SYNC_SCHEME)return c=c.with({scheme:l.userDataSyncHome.scheme}),e.ALL_SYNC_RESOURCES.filter(u=>(0,p.isEqualOrParent)(c,(0,p.joinPath)(l.userDataSyncHome,u,e.PREVIEW_DIR_NAME)))[0]}e.getSyncResourceFromLocalPreview=o}),define(Z[46],ee([0,1,2,10,25,5,21,9,14,8,3,24,32,121,23,15,22,19,45,20,29]),function(G,e,y,P,L,k,A,R,p,S,n,f,m,C,h,E,D,b,I,g,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractInitializer=e.AbstractJsonFileSynchroniser=e.AbstractFileSynchroniser=e.AbstractSynchroniser=e.isSyncData=void 0;function s(l){return!!(l&&l.version!==void 0&&typeof l.version=="number"&&l.content!==void 0&&typeof l.content=="string"&&(Object.keys(l).length===2||Object.keys(l).length===3&&l.machineId!==void 0&&typeof l.machineId=="string"))}e.isSyncData=s;function t(l,u,v){return v.joinPath(u.userDataSyncHome,l,`lastSync${l}.json`)}let r=class extends y.Disposable{constructor(u,v,w,d,T,F,z,B,K,j){super();this.resource=u,this.fileService=v,this.environmentService=w,this.userDataSyncStoreService=T,this.userDataSyncBackupStoreService=F,this.userDataSyncResourceEnablementService=z,this.telemetryService=B,this.logService=K,this.configurationService=j,this.syncPreviewPromise=null,this._status="idle",this._onDidChangStatus=this._register(new n.Emitter),this.onDidChangeStatus=this._onDidChangStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new n.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this.localChangeTriggerScheduler=new S.RunOnceScheduler(()=>this.doTriggerLocalChange(),50),this._onDidChangeLocal=this._register(new n.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this.hasSyncResourceStateVersionChanged=!1,this.syncHeaders={},this.syncResourceLogLabel=(0,D.uppercaseFirstLetter)(this.resource),this.extUri=this.fileService.hasCapability(w.userDataSyncHome,1024)?p.extUri:p.extUriIgnorePathCase,this.syncFolder=this.extUri.joinPath(w.userDataSyncHome,u),this.syncPreviewFolder=this.extUri.joinPath(this.syncFolder,A.PREVIEW_DIR_NAME),this.lastSyncResource=t(u,w,this.extUri),this.currentMachineIdPromise=(0,I.getServiceMachineId)(w,v,d)}get status(){return this._status}get conflicts(){return this._conflicts}isEnabled(){return this.userDataSyncResourceEnablementService.isResourceEnabled(this.resource)}async triggerLocalChange(){this.isEnabled()&&this.localChangeTriggerScheduler.schedule()}async doTriggerLocalChange(){if(this.status==="hasConflicts"){this.logService.info(`${this.syncResourceLogLabel}: In conflicts state and local change detected. Syncing again...`);const u=await this.syncPreviewPromise;this.syncPreviewPromise=null;const v=await this.performSync(u.remoteUserData,u.lastSyncUserData,!0);this.setStatus(v)}else{this.logService.trace(`${this.syncResourceLogLabel}: Checking for local changes...`);const u=await this.getLastSyncUserData();(u?(await this.doGenerateSyncResourcePreview(u,u,!0,a.CancellationToken.None)).resourcePreviews.some(({remoteChange:w})=>w!==0):!0)&&this._onDidChangeLocal.fire()}}setStatus(u){if(this._status!==u){const v=this._status;u==="hasConflicts"&&this.telemetryService.publicLog2("sync/conflictsDetected",{source:this.resource}),v==="hasConflicts"&&u==="idle"&&this.telemetryService.publicLog2("sync/conflictsResolved",{source:this.resource}),this._status=u,this._onDidChangStatus.fire(u)}}async sync(u,v={}){await this._sync(u,!0,v)}async preview(u,v={}){return this._sync(u,!1,v)}async apply(u,v={}){try{this.syncHeaders=Object.assign({},v);const w=await this.doApply(u);return this.setStatus(w),this.syncPreviewPromise}finally{this.syncHeaders={}}}async _sync(u,v,w){try{if(this.syncHeaders=Object.assign({},w),!this.isEnabled())return this.status!=="idle"&&await this.stop(),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is disabled.`),null;if(this.status==="hasConflicts")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.syncPreviewPromise;if(this.status==="syncing")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.syncPreviewPromise;this.logService.trace(`${this.syncResourceLogLabel}: Started synchronizing ${this.resource.toLowerCase()}...`),this.setStatus("syncing");let d="idle";try{const T=await this.getLastSyncUserData(),F=await this.getLatestRemoteUserData(u,T);return d=await this.performSync(F,T,v),d==="hasConflicts"?this.logService.info(`${this.syncResourceLogLabel}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):d==="idle"&&this.logService.trace(`${this.syncResourceLogLabel}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise||null}finally{this.setStatus(d)}}finally{this.syncHeaders={}}}async replace(u){const v=await this.resolveContent(u);if(!v)return!1;const w=this.parseSyncData(v);if(!w)return!1;await this.stop();try{this.logService.trace(`${this.syncResourceLogLabel}: Started resetting ${this.resource.toLowerCase()}...`),this.setStatus("syncing");const d=await this.getLastSyncUserData(),T=await this.getLatestRemoteUserData(null,d),F=await this.generateSyncPreview({ref:T.ref,syncData:w},d,a.CancellationToken.None),z=[];for(const B of F){const K=await this.getAcceptResult(B,B.remoteResource,void 0,a.CancellationToken.None),{remoteChange:j}=await this.getAcceptResult(B,B.previewResource,B.remoteContent,a.CancellationToken.None);z.push([B,Object.assign(Object.assign({},K),{remoteChange:j!==0?j:2})])}await this.applyResult(T,d,z,!1),this.logService.info(`${this.syncResourceLogLabel}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.setStatus("idle")}return!0}async getLatestRemoteUserData(u,v){if(v){const w=u&&u.latest?u.latest[this.resource]:void 0;if(v.ref===w||w===void 0&&v.syncData===null)return v}return this.getRemoteUserData(v)}async performSync(u,v,w){if(u.syncData&&u.syncData.version>this.version)throw this.telemetryService.publicLog2("sync/incompatible",{source:this.resource}),new A.UserDataSyncError((0,C.localize)(0,null,this.resource,this.version,u.syncData.version),A.UserDataSyncErrorCode.IncompatibleLocalContent,this.resource);try{return await this.doSync(u,v,w)}catch(d){if(d instanceof A.UserDataSyncError)switch(d.code){case A.UserDataSyncErrorCode.LocalPreconditionFailed:return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize ${this.syncResourceLogLabel} as there is a new local version available. Synchronizing again...`),this.performSync(u,v,w);case A.UserDataSyncErrorCode.Conflict:case A.UserDataSyncErrorCode.PreconditionFailed:return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),u=await this.getRemoteUserData(null),v=await this.getLastSyncUserData(),this.performSync(u,v,w)}throw d}}async doSync(u,v,w){try{this.syncPreviewPromise||(this.syncPreviewPromise=(0,S.createCancelablePromise)(T=>this.doGenerateSyncResourcePreview(u,v,w,T)));const d=await this.syncPreviewPromise;return this.updateConflicts(d.resourcePreviews),d.resourcePreviews.some(({mergeState:T})=>T==="conflict")?"hasConflicts":w?await this.doApply(!1):"syncing"}catch(d){throw this.syncPreviewPromise=null,d}}async merge(u){return await this.updateSyncResourcePreview(u,async v=>{const w=await this.getMergeResult(v,a.CancellationToken.None);await this.fileService.writeFile(v.previewResource,L.VSBuffer.fromString((w==null?void 0:w.content)||""));const d=w&&!w.hasConflicts?await this.getAcceptResult(v,v.previewResource,void 0,a.CancellationToken.None):void 0;return v.acceptResult=d,v.mergeState=w.hasConflicts?"conflict":d?"accepted":"preview",v.localChange=d?d.localChange:w.localChange,v.remoteChange=d?d.remoteChange:w.remoteChange,v}),this.syncPreviewPromise}async accept(u,v){return await this.updateSyncResourcePreview(u,async w=>{const d=await this.getAcceptResult(w,u,v,a.CancellationToken.None);return w.acceptResult=d,w.mergeState="accepted",w.localChange=d.localChange,w.remoteChange=d.remoteChange,w}),this.syncPreviewPromise}async discard(u){return await this.updateSyncResourcePreview(u,async v=>{const w=await this.getMergeResult(v,a.CancellationToken.None);return await this.fileService.writeFile(v.previewResource,L.VSBuffer.fromString(w.content||"")),v.acceptResult=void 0,v.mergeState="preview",v.localChange=w.localChange,v.remoteChange=w.remoteChange,v}),this.syncPreviewPromise}async updateSyncResourcePreview(u,v){if(!this.syncPreviewPromise)return;let w=await this.syncPreviewPromise;const d=w.resourcePreviews.findIndex(({localResource:T,remoteResource:F,previewResource:z})=>this.extUri.isEqual(T,u)||this.extUri.isEqual(F,u)||this.extUri.isEqual(z,u));d!==-1&&(this.syncPreviewPromise=(0,S.createCancelablePromise)(async T=>{const F=[...w.resourcePreviews];return F[d]=await v(F[d]),Object.assign(Object.assign({},w),{resourcePreviews:F})}),w=await this.syncPreviewPromise,this.updateConflicts(w.resourcePreviews),w.resourcePreviews.some(({mergeState:T})=>T==="conflict")?this.setStatus("hasConflicts"):this.setStatus("syncing"))}async doApply(u){if(!this.syncPreviewPromise)return"idle";const v=await this.syncPreviewPromise;return v.resourcePreviews.some(({mergeState:w})=>w==="conflict")?"hasConflicts":v.resourcePreviews.some(({mergeState:w})=>w!=="accepted")?"syncing":(await this.applyResult(v.remoteUserData,v.lastSyncUserData,v.resourcePreviews.map(w=>[w,w.acceptResult]),u),this.syncPreviewPromise=null,await this.clearPreviewFolder(),"idle")}async clearPreviewFolder(){try{await this.fileService.del(this.syncPreviewFolder,{recursive:!0})}catch(u){}}updateConflicts(u){const v=u.filter(({mergeState:w})=>w==="conflict");(0,b.equals)(this._conflicts,v,(w,d)=>this.extUri.isEqual(w.previewResource,d.previewResource))||(this._conflicts=v,this._onDidChangeConflicts.fire(v))}async hasPreviouslySynced(){return!!await this.getLastSyncUserData()}async getRemoteSyncResourceHandles(){return(await this.userDataSyncStoreService.getAllRefs(this.resource)).map(({created:v,ref:w})=>({created:v,uri:this.toRemoteBackupResource(w)}))}async getLocalSyncResourceHandles(){return(await this.userDataSyncBackupStoreService.getAllRefs(this.resource)).map(({created:v,ref:w})=>({created:v,uri:this.toLocalBackupResource(w)}))}toRemoteBackupResource(u){return k.URI.from({scheme:A.USER_DATA_SYNC_SCHEME,authority:"remote-backup",path:`/${this.resource}/${u}`})}toLocalBackupResource(u){return k.URI.from({scheme:A.USER_DATA_SYNC_SCHEME,authority:"local-backup",path:`/${this.resource}/${u}`})}async getMachineId({uri:u}){const v=this.extUri.basename(u);if(this.extUri.isEqual(u,this.toRemoteBackupResource(v))){const{content:w}=await this.getUserData(v);if(w){const d=this.parseSyncData(w);return d==null?void 0:d.machineId}}}async resolveContent(u){const v=this.extUri.basename(u);if(this.extUri.isEqual(u,this.toRemoteBackupResource(v))){const{content:w}=await this.getUserData(v);return w}return this.extUri.isEqual(u,this.toLocalBackupResource(v))?this.userDataSyncBackupStoreService.resolveContent(this.resource,v):null}async resolvePreviewContent(u){const v=this.syncPreviewPromise?await this.syncPreviewPromise:null;if(v)for(const w of v.resourcePreviews){if(this.extUri.isEqual(w.acceptedResource,u))return w.acceptResult?w.acceptResult.content:null;if(this.extUri.isEqual(w.remoteResource,u))return w.remoteContent;if(this.extUri.isEqual(w.localResource,u))return w.localContent}return null}async resetLocal(){try{await this.fileService.del(this.lastSyncResource)}catch(u){}}async doGenerateSyncResourcePreview(u,v,w,d){var T;const F=await this.currentMachineIdPromise,z=!!((T=u.syncData)===null||T===void 0?void 0:T.machineId)&&u.syncData.machineId===F,B=v===null&&z&&!this.hasSyncResourceStateVersionChanged?u:v,K=await this.generateSyncPreview(u,B,d),j=[];for(const H of K){const q=H.previewResource.with({scheme:A.USER_DATA_SYNC_SCHEME,authority:"accepted"});if(H.localChange===0&&H.remoteChange===0)j.push(Object.assign(Object.assign({},H),{acceptedResource:q,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"}));else{const $=w?await this.getMergeResult(H,d):void 0;if(d.isCancellationRequested)break;await this.fileService.writeFile(H.previewResource,L.VSBuffer.fromString(($==null?void 0:$.content)||""));const M=$&&!$.hasConflicts?await this.getAcceptResult(H,H.previewResource,void 0,d):void 0;j.push(Object.assign(Object.assign({},H),{acceptResult:M,mergeState:($==null?void 0:$.hasConflicts)?"conflict":M?"accepted":"preview",localChange:M?M.localChange:$?$.localChange:H.localChange,remoteChange:M?M.remoteChange:$?$.remoteChange:H.remoteChange}))}}return{remoteUserData:u,lastSyncUserData:v,resourcePreviews:j,isLastSyncFromCurrentMachine:z}}async getLastSyncUserData(){try{const u=await this.fileService.readFile(this.lastSyncResource),v=JSON.parse(u.value.toString()),w=this.userDataSyncResourceEnablementService.getResourceSyncStateVersion(this.resource);if(this.hasSyncResourceStateVersionChanged=v.version&&w&&v.version!==w,this.hasSyncResourceStateVersionChanged)return this.logService.info(`${this.syncResourceLogLabel}: Reset last sync state because last sync state version ${v.version} is not compatible with current sync state version ${w}.`),await this.resetLocal(),null;const d=v;if(d.content===null)return{ref:v.ref,syncData:null};const T=JSON.parse(d.content);if(s(T))return Object.assign(Object.assign({},v),{syncData:T,content:void 0})}catch(u){u instanceof P.FileOperationError&&u.fileOperationResult===1||this.logService.error(u)}return null}async updateLastSyncUserData(u,v={}){if(v.ref||v.content||v.version)throw new Error("Cannot have core properties as additional");const w=this.userDataSyncResourceEnablementService.getResourceSyncStateVersion(this.resource),d=Object.assign({ref:u.ref,content:u.syncData?JSON.stringify(u.syncData):null,version:w},v);await this.fileService.writeFile(this.lastSyncResource,L.VSBuffer.fromString(JSON.stringify(d)))}async getRemoteUserData(u){const{ref:v,content:w}=await this.getUserData(u);let d=null;return w!==null&&(d=this.parseSyncData(w)),{ref:v,syncData:d}}parseSyncData(u){try{const v=JSON.parse(u);if(s(v))return v}catch(v){this.logService.error(v)}throw new A.UserDataSyncError((0,C.localize)(1,null),A.UserDataSyncErrorCode.IncompatibleRemoteContent,this.resource)}async getUserData(u){if((0,E.isString)(u)){const v=await this.userDataSyncStoreService.resolveContent(this.resource,u);return{ref:u,content:v}}else{const v=u?{ref:u.ref,content:u.syncData?JSON.stringify(u.syncData):null}:null;return this.userDataSyncStoreService.read(this.resource,v,this.syncHeaders)}}async updateRemoteUserData(u,v){const w=await this.currentMachineIdPromise,d={version:this.version,machineId:w,content:u};return v=await this.userDataSyncStoreService.write(this.resource,JSON.stringify(d),v,this.syncHeaders),{ref:v,syncData:d}}async backupLocal(u){const v={version:this.version,content:u};return this.userDataSyncBackupStoreService.backup(this.resource,JSON.stringify(v))}async stop(){this.status!=="idle"&&(this.logService.trace(`${this.syncResourceLogLabel}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise&&(this.syncPreviewPromise.cancel(),this.syncPreviewPromise=null),this.updateConflicts([]),await this.clearPreviewFolder(),this.setStatus("idle"),this.logService.info(`${this.syncResourceLogLabel}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}};r=de([Y(1,P.IFileService),Y(2,R.IEnvironmentService),Y(3,g.IStorageService),Y(4,A.IUserDataSyncStoreService),Y(5,A.IUserDataSyncBackupStoreService),Y(6,A.IUserDataSyncResourceEnablementService),Y(7,f.ITelemetryService),Y(8,A.IUserDataSyncLogService),Y(9,h.IConfigurationService)],r),e.AbstractSynchroniser=r;let i=class extends r{constructor(u,v,w,d,T,F,z,B,K,j,H){super(v,w,d,T,F,z,B,K,j,H);this.file=u,this._register(this.fileService.watch(this.extUri.dirname(u))),this._register(this.fileService.onDidFilesChange(q=>this.onFileChanges(q)))}async getLocalFileContent(){try{return await this.fileService.readFile(this.file)}catch(u){return null}}async updateLocalFileContent(u,v,w){try{v?await this.fileService.writeFile(this.file,L.VSBuffer.fromString(u),w?void 0:v):await this.fileService.createFile(this.file,L.VSBuffer.fromString(u),{overwrite:w})}catch(d){throw d instanceof P.FileOperationError&&d.fileOperationResult===1||d instanceof P.FileOperationError&&d.fileOperationResult===3?new A.UserDataSyncError(d.message,A.UserDataSyncErrorCode.LocalPreconditionFailed):d}}onFileChanges(u){!u.contains(this.file)||this.triggerLocalChange()}};i=de([Y(2,P.IFileService),Y(3,R.IEnvironmentService),Y(4,g.IStorageService),Y(5,A.IUserDataSyncStoreService),Y(6,A.IUserDataSyncBackupStoreService),Y(7,A.IUserDataSyncResourceEnablementService),Y(8,f.ITelemetryService),Y(9,A.IUserDataSyncLogService),Y(10,h.IConfigurationService)],i),e.AbstractFileSynchroniser=i;let o=class extends i{constructor(u,v,w,d,T,F,z,B,K,j,H,q){super(u,v,w,d,T,F,z,B,K,j,q);this.userDataSyncUtilService=H,this._formattingOptions=void 0}hasErrors(u){const v=[];return(0,m.parse)(u,v,{allowEmptyContent:!0,allowTrailingComma:!0}),v.length>0}getFormattingOptions(){return this._formattingOptions||(this._formattingOptions=this.userDataSyncUtilService.resolveFormattingOptions(this.file)),this._formattingOptions}};o=de([Y(2,P.IFileService),Y(3,R.IEnvironmentService),Y(4,g.IStorageService),Y(5,A.IUserDataSyncStoreService),Y(6,A.IUserDataSyncBackupStoreService),Y(7,A.IUserDataSyncResourceEnablementService),Y(8,f.ITelemetryService),Y(9,A.IUserDataSyncLogService),Y(10,A.IUserDataSyncUtilService),Y(11,h.IConfigurationService)],o),e.AbstractJsonFileSynchroniser=o;let c=class{constructor(u,v,w,d){this.resource=u,this.environmentService=v,this.logService=w,this.fileService=d,this.extUri=this.fileService.hasCapability(v.userDataSyncHome,1024)?p.extUri:p.extUriIgnorePathCase,this.lastSyncResource=t(this.resource,v,p.extUri)}async initialize({ref:u,content:v}){if(!v){this.logService.info("Remote content does not exist.",this.resource);return}const w=this.parseSyncData(v);if(!w)return;if(await this.fileService.exists(this.lastSyncResource)){this.logService.info("Remote content does not exist.",this.resource);return}try{await this.doInitialize({ref:u,syncData:w})}catch(T){this.logService.error(T)}}parseSyncData(u){try{const v=JSON.parse(u);if(s(v))return v}catch(v){this.logService.error(v)}this.logService.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async updateLastSyncUserData(u,v={}){const w=Object.assign({ref:u.ref,content:u.syncData?JSON.stringify(u.syncData):null},v);await this.fileService.writeFile(this.lastSyncResource,L.VSBuffer.fromString(JSON.stringify(w)))}};c=de([Y(1,R.IEnvironmentService),Y(2,A.IUserDataSyncLogService),Y(3,P.IFileService)],c),e.AbstractInitializer=c}),define(Z[187],ee([0,1,21,3,9,28,33,10,23,184,46,24,5,47,40,22,20,84,11,83,8]),function(G,e,y,P,L,k,A,R,p,S,n,f,m,C,h,E,D,b,I,g,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsInitializer=e.ExtensionsSynchroniser=e.storeExtensionStorageState=e.getExtensionStorageState=void 0;async function s(c,l){const u=JSON.parse(c.content);if(c.version===1||c.version===2){const v=(await l.getInstalled(0)).filter(w=>w.isBuiltin);for(const w of u)c.version===1&&(w.enabled===!1&&(w.disabled=!0),delete w.enabled),c.version===2&&v.every(d=>!(0,A.areSameExtensions)(d.identifier,w.identifier))&&(w.installed=!0)}return u}function t(c,l,u){const v=u.get((0,A.getExtensionId)(c,l),0)||"{}";return JSON.parse(v)}e.getExtensionStorageState=t;function r(c,l,u,v){v.store((0,A.getExtensionId)(c,l),JSON.stringify(u),0,1)}e.storeExtensionStorageState=r;let i=class ot extends n.AbstractSynchroniser{constructor(l,u,v,w,d,T,F,z,B,K,j,H,q,$){super("extensions",u,l,v,w,d,H,q,B,j);this.storageService=v,this.extensionManagementService=T,this.extensionEnablementService=F,this.ignoredExtensionsManagementService=z,this.extensionGalleryService=K,this.extensionsStorageSyncService=$,this.version=5,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"extensions.json"),this.localResource=this.previewResource.with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(P.Event.debounce(P.Event.any(P.Event.filter(this.extensionManagementService.onDidInstallExtension,M=>!!M.gallery),P.Event.filter(this.extensionManagementService.onDidUninstallExtension,M=>!M.error),this.extensionEnablementService.onDidChangeEnablement,this.extensionsStorageSyncService.onDidChangeExtensionsStorage),()=>{},500)(()=>this.triggerLocalChange()))}isEnabled(){return super.isEnabled()&&this.extensionGalleryService.isEnabled()}async generateSyncPreview(l,u){const v=l.syncData?await s(l.syncData,this.extensionManagementService):null,w=(u==null?void 0:u.skippedExtensions)||[],d=(u==null?void 0:u.syncData)?await s(u.syncData,this.extensionManagementService):null,T=await this.extensionManagementService.getInstalled(),F=this.getLocalExtensions(T),z=this.ignoredExtensionsManagementService.getIgnoredExtensions(T);v?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote extensions with local extensions...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{added:B,removed:K,updated:j,remote:H}=(0,S.merge)(F,v,d,w,z),q={added:B,removed:K,updated:j,remote:H,content:this.getPreviewContent(F,B,j,K),localChange:B.length>0||K.length>0||j.length>0?2:0,remoteChange:H!==null?2:0};return[{skippedExtensions:w,localResource:this.localResource,localContent:this.format(F),localExtensions:F,remoteResource:this.remoteResource,remoteContent:v?this.format(v):null,previewResource:this.previewResource,previewResult:q,localChange:q.localChange,remoteChange:q.remoteChange,acceptedResource:this.acceptedResource}]}getPreviewContent(l,u,v,w){const d=[...u,...v],T=new Set,F=z=>{T.add(z.id.toLowerCase()),z.uuid&&T.add(z.uuid)};d.forEach(({identifier:z})=>F(z)),w.forEach(F);for(const z of l)T.has(z.identifier.id.toLowerCase())||z.identifier.uuid&&T.has(z.identifier.uuid)||d.push(z);return this.format(d)}async getMergeResult(l,u){return Object.assign(Object.assign({},l.previewResult),{hasConflicts:!1})}async getAcceptResult(l,u,v,w){if(this.extUri.isEqual(u,this.localResource))return this.acceptLocal(l);if(this.extUri.isEqual(u,this.remoteResource))return this.acceptRemote(l);if(this.extUri.isEqual(u,this.previewResource))return l.previewResult;throw new Error(`Invalid Resource: ${u.toString()}`)}async acceptLocal(l){const u=await this.extensionManagementService.getInstalled(),v=this.ignoredExtensionsManagementService.getIgnoredExtensions(u),w=(0,S.merge)(l.localExtensions,null,null,l.skippedExtensions,v),{added:d,removed:T,updated:F,remote:z}=w;return{content:l.localContent,added:d,removed:T,updated:F,remote:z,localChange:d.length>0||T.length>0||F.length>0?2:0,remoteChange:z!==null?2:0}}async acceptRemote(l){const u=await this.extensionManagementService.getInstalled(),v=this.ignoredExtensionsManagementService.getIgnoredExtensions(u),w=l.remoteContent?JSON.parse(l.remoteContent):null;if(w!==null){const d=(0,S.merge)(l.localExtensions,w,l.localExtensions,[],v),{added:T,removed:F,updated:z,remote:B}=d;return{content:l.remoteContent,added:T,removed:F,updated:z,remote:B,localChange:T.length>0||F.length>0||z.length>0?2:0,remoteChange:B!==null?2:0}}else return{content:l.remoteContent,added:[],removed:[],updated:[],remote:null,localChange:0,remoteChange:0}}async applyResult(l,u,v,w){let{skippedExtensions:d,localExtensions:T}=v[0][0],{added:F,removed:z,updated:B,remote:K,localChange:j,remoteChange:H}=v[0][1];if(j===0&&H===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing extensions.`),j!==0&&(await this.backupLocal(JSON.stringify(T)),d=await this.updateLocalExtensions(F,z,B,d)),K){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote extensions...`);const q=JSON.stringify(K);l=await this.updateRemoteUserData(q,w?null:l.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote extensions`)}(u==null?void 0:u.ref)!==l.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized extensions...`),await this.updateLastSyncUserData(l,{skippedExtensions:d}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized extensions`))}async getAssociatedResources({uri:l}){return[{resource:this.extUri.joinPath(l,"extensions.json"),comparableResource:ot.EXTENSIONS_DATA_URI}]}async resolveContent(l){if(this.extUri.isEqual(l,ot.EXTENSIONS_DATA_URI)){const v=await this.extensionManagementService.getInstalled(),w=this.ignoredExtensionsManagementService.getIgnoredExtensions(v),d=this.getLocalExtensions(v).filter(T=>!w.some(F=>(0,A.areSameExtensions)({id:F},T.identifier)));return this.format(d)}if(this.extUri.isEqual(this.remoteResource,l)||this.extUri.isEqual(this.localResource,l)||this.extUri.isEqual(this.acceptedResource,l))return this.resolvePreviewContent(l);let u=await super.resolveContent(l);if(u)return u;if(u=await super.resolveContent(this.extUri.dirname(l)),u){const v=this.parseSyncData(u);if(v)switch(this.extUri.basename(l)){case"extensions.json":return this.format(this.parseExtensions(v))}}return null}format(l){l.sort((w,d)=>!w.identifier.uuid&&d.identifier.uuid?-1:w.identifier.uuid&&!d.identifier.uuid?1:(0,E.compare)(w.identifier.id,d.identifier.id));const u=JSON.stringify(l),v=(0,C.format)(u,void 0,{});return(0,h.applyEdits)(u,v)}async hasLocalData(){try{const l=await this.extensionManagementService.getInstalled();if(this.getLocalExtensions(l).some(v=>v.installed||v.disabled))return!0}catch(l){}return!1}async updateLocalExtensions(l,u,v,w){const d=[],T=[],F=await this.extensionManagementService.getInstalled();if(u.length){const B=F.filter(({identifier:K,isBuiltin:j})=>!j&&u.some(H=>(0,A.areSameExtensions)(K,H)));await a.Promises.settled(B.map(async K=>{this.logService.trace(`${this.syncResourceLogLabel}: Uninstalling local extension...`,K.identifier.id),await this.extensionManagementService.uninstall(K,{donotIncludePack:!0,donotCheckDependents:!0}),this.logService.info(`${this.syncResourceLogLabel}: Uninstalled local extension.`,K.identifier.id),d.push(K.identifier)}))}(l.length||v.length)&&await a.Promises.settled([...l,...v].map(async B=>{const K=F.find(H=>(0,A.areSameExtensions)(H.identifier,B.identifier));if(K&&K.isBuiltin){B.state&&K.manifest.version===B.version&&this.updateExtensionState(B.state,K.manifest.publisher,K.manifest.name,K.manifest.version),B.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,B.identifier.id),await this.extensionEnablementService.disableExtension(B.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,B.identifier.id)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,B.identifier.id),await this.extensionEnablementService.enableExtension(B.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,B.identifier.id)),d.push(B.identifier);return}const j=await this.extensionGalleryService.getCompatibleExtension(B.identifier);if(B.state&&(K?K.manifest.version===B.version:!!j)){const H=K?K.manifest.publisher:j.publisher,q=K?K.manifest.name:j.name;this.updateExtensionState(B.state,H,q,K==null?void 0:K.manifest.version)}if(j)try{B.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,B.identifier.id,j.version),await this.extensionEnablementService.disableExtension(j.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,B.identifier.id,j.version)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,B.identifier.id,j.version),await this.extensionEnablementService.enableExtension(j.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,B.identifier.id,j.version)),K||(this.logService.trace(`${this.syncResourceLogLabel}: Installing extension...`,B.identifier.id,j.version),await this.extensionManagementService.installFromGallery(j,{isMachineScoped:!1,donotIncludePackAndDependencies:!0}),this.logService.info(`${this.syncResourceLogLabel}: Installed extension.`,B.identifier.id,j.version),d.push(j.identifier))}catch(H){T.push(B),this.logService.error(H),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension`,j.displayName||j.identifier.id)}else T.push(B)}));const z=[];for(const B of w)d.some(K=>(0,A.areSameExtensions)(K,B.identifier))||z.push(B);for(const B of T)z.some(K=>(0,A.areSameExtensions)(K.identifier,B.identifier))||z.push(B);return z}updateExtensionState(l,u,v,w){const d=t(u,v,this.storageService),T=w?this.extensionsStorageSyncService.getKeysForSync({id:(0,A.getGalleryExtensionId)(u,v),version:w}):void 0;T?T.forEach(F=>{d[F]=l[F]}):Object.keys(l).forEach(F=>d[F]=l[F]),r(u,v,d,this.storageService)}parseExtensions(l){return JSON.parse(l.content)}getLocalExtensions(l){const u=this.extensionEnablementService.getDisabledExtensions();return l.map(({identifier:v,isBuiltin:w,manifest:d})=>{const T={identifier:v,version:d.version};u.some(F=>(0,A.areSameExtensions)(F,v))&&(T.disabled=!0),w||(T.installed=!0);try{const F=this.extensionsStorageSyncService.getKeysForSync({id:v.id,version:d.version});if(F){const z=t(d.publisher,d.name,this.storageService);T.state=Object.keys(z).reduce((B,K)=>(F.includes(K)&&(B[K]=z[K]),B),{})}}catch(F){this.logService.info(`${this.syncResourceLogLabel}: Error while parsing extension state`,(0,I.getErrorMessage)(F))}return T})}};i.EXTENSIONS_DATA_URI=m.URI.from({scheme:y.USER_DATA_SYNC_SCHEME,authority:"extensions",path:"/extensions.json"}),i=de([Y(0,L.IEnvironmentService),Y(1,R.IFileService),Y(2,D.IStorageService),Y(3,y.IUserDataSyncStoreService),Y(4,y.IUserDataSyncBackupStoreService),Y(5,k.IExtensionManagementService),Y(6,k.IGlobalExtensionEnablementService),Y(7,b.IIgnoredExtensionsManagementService),Y(8,y.IUserDataSyncLogService),Y(9,k.IExtensionGalleryService),Y(10,p.IConfigurationService),Y(11,y.IUserDataSyncResourceEnablementService),Y(12,f.ITelemetryService),Y(13,g.IExtensionsStorageSyncService)],i),e.ExtensionsSynchroniser=i;let o=class extends n.AbstractInitializer{constructor(l,u,v,w,d){super("extensions",w,d,v);this.extensionManagementService=l,this.ignoredExtensionsManagementService=u}async parseExtensions(l){return l.syncData?await s(l.syncData,this.extensionManagementService):null}generatePreview(l,u){const v=[],w=[],d=[];for(const T of l){if(this.ignoredExtensionsManagementService.hasToNeverSyncExtension(T.identifier.id))continue;const F=u.find(z=>(0,A.areSameExtensions)(z.identifier,T.identifier));F?(v.push(F),T.disabled&&d.push(T.identifier)):T.installed&&(w.push(T.identifier),T.disabled&&d.push(T.identifier))}return{installedExtensions:v,newExtensions:w,disabledExtensions:d,remoteExtensions:l}}};o=de([Y(0,k.IExtensionManagementService),Y(1,b.IIgnoredExtensionsManagementService),Y(2,R.IFileService),Y(3,L.IEnvironmentService),Y(4,y.IUserDataSyncLogService)],o),e.AbstractExtensionsInitializer=o}),define(Z[188],ee([0,1,26,21]),function(G,e,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function L(R,p,S,n,f){if(!p)return{remote:Object.keys(R).length>0?R:null,local:{added:{},removed:[],updated:{}}};const m=k(R,p);if(m.added.size===0&&m.removed.size===0&&m.updated.size===0)return{remote:null,local:{added:{},removed:[],updated:{}}};const C=S?k(S,p):{added:Object.keys(p).reduce((I,g)=>(I.add(g),I),new Set),removed:new Set,updated:new Set},h=S?k(S,R):{added:Object.keys(R).reduce((I,g)=>(I.add(g),I),new Set),removed:new Set,updated:new Set},E={added:{},removed:[],updated:{}},D=y.deepClone(p),b=!S;for(const I of h.added.values())I!==P.SYNC_SERVICE_URL_TYPE&&b&&C.added.has(I)||(D[I]=R[I]);for(const I of h.updated.values())D[I]=R[I];for(const I of h.removed.values())n.unregistered.includes(I)||delete D[I];for(const I of C.added.values()){const g=p[I];if(n.machine.includes(I)){f.info(`GlobalState: Skipped adding ${I} in local storage because it is declared as machine scoped.`);continue}if(S&&h.added.has(I))continue;const a=R[I];a&&a.value===g.value||I===P.SYNC_SERVICE_URL_TYPE&&b&&h.added.has(I)||(a?E.updated[I]=g:E.added[I]=g)}for(const I of C.updated.values()){const g=p[I];if(n.machine.includes(I)){f.info(`GlobalState: Skipped updating ${I} in local storage because it is declared as machine scoped.`);continue}if(h.updated.has(I)||h.removed.has(I))continue;const a=R[I];a&&a.value===g.value||(E.updated[I]=g)}for(const I of C.removed.values()){if(n.machine.includes(I)){f.trace(`GlobalState: Skipped removing ${I} in local storage because it is declared as machine scoped.`);continue}h.updated.has(I)||h.removed.has(I)||E.removed.push(I)}return{local:E,remote:A(D,p)?null:D}}e.merge=L;function k(R,p){const S=Object.keys(R),n=Object.keys(p),f=n.filter(h=>S.indexOf(h)===-1).reduce((h,E)=>(h.add(E),h),new Set),m=S.filter(h=>n.indexOf(h)===-1).reduce((h,E)=>(h.add(E),h),new Set),C=new Set;for(const h of S){if(m.has(h))continue;const E=R[h],D=p[h];y.equals(E,D)||C.add(h)}return{added:f,removed:m,updated:C}}function A(R,p){const{added:S,removed:n,updated:f}=k(R,p);return S.size===0&&n.size===0&&f.size===0}}),define(Z[189],ee([0,1,21,25,3,9,10,52,188,32,46,24,23,5,47,40,20,6,45,30,18]),function(G,e,y,P,L,k,A,R,p,S,n,f,m,C,h,E,D,b,I,g,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreTypeSynchronizer=e.GlobalStateInitializer=e.GlobalStateSynchroniser=void 0;const s="globalState.argv.",t=["locale"];function r(u){const v=u.storage?Object.keys(u.storage).sort():[],w={};v.forEach(F=>w[F]=u.storage[F]),u.storage=w;const d=JSON.stringify(u),T=(0,h.format)(d,void 0,{});return(0,E.applyEdits)(d,T)}const i=1;let o=class ct extends n.AbstractSynchroniser{constructor(v,w,d,T,F,z,B,K,j){super("globalState",v,F,j,w,d,z,B,T,K);this.storageService=j,this.version=i,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"globalState.json"),this.localResource=this.previewResource.with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(v.watch(this.extUri.dirname(this.environmentService.argvResource))),this._register(L.Event.any(L.Event.filter(v.onDidFilesChange,H=>H.contains(this.environmentService.argvResource)),L.Event.filter(j.onDidChangeValue,H=>H.scope===0&&H.target!==void 0?H.target===0:j.keys(0,0).includes(H.key)),this.storageService.onDidChangeTarget)(()=>this.triggerLocalChange()))}async generateSyncPreview(v,w,d){const T=v.syncData?JSON.parse(v.syncData.content):null,F=w&&w.syncData?JSON.parse(w.syncData.content):null,z=await this.getLocalGlobalState();T?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote ui state with local ui state...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const B=this.getStorageKeys(F),{local:K,remote:j}=(0,p.merge)(z.storage,T?T.storage:null,F?F.storage:null,B,this.logService),H={content:null,local:K,remote:j,localChange:Object.keys(K.added).length>0||Object.keys(K.updated).length>0||K.removed.length>0?2:0,remoteChange:j!==null?2:0};return[{localResource:this.localResource,localContent:r(z),localUserData:z,remoteResource:this.remoteResource,remoteContent:T?r(T):null,previewResource:this.previewResource,previewResult:H,localChange:H.localChange,remoteChange:H.remoteChange,acceptedResource:this.acceptedResource,storageKeys:B}]}async getMergeResult(v,w){return Object.assign(Object.assign({},v.previewResult),{hasConflicts:!1})}async getAcceptResult(v,w,d,T){if(this.extUri.isEqual(w,this.localResource))return this.acceptLocal(v);if(this.extUri.isEqual(w,this.remoteResource))return this.acceptRemote(v);if(this.extUri.isEqual(w,this.previewResource))return v.previewResult;throw new Error(`Invalid Resource: ${w.toString()}`)}async acceptLocal(v){return{content:v.localContent,local:{added:{},removed:[],updated:{}},remote:v.localUserData.storage,localChange:0,remoteChange:2}}async acceptRemote(v){if(v.remoteContent!==null){const w=JSON.parse(v.remoteContent),{local:d,remote:T}=(0,p.merge)(v.localUserData.storage,w.storage,null,v.storageKeys,this.logService);return{content:v.remoteContent,local:d,remote:T,localChange:Object.keys(d.added).length>0||Object.keys(d.updated).length>0||d.removed.length>0?2:0,remoteChange:T!==null?2:0}}else return{content:v.remoteContent,local:{added:{},removed:[],updated:{}},remote:null,localChange:0,remoteChange:0}}async applyResult(v,w,d,T){let{localUserData:F}=d[0][0],{local:z,remote:B,localChange:K,remoteChange:j}=d[0][1];if(K===0&&j===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing ui state.`),K!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local ui state...`),await this.backupLocal(JSON.stringify(F)),await this.writeLocalGlobalState(z),this.logService.info(`${this.syncResourceLogLabel}: Updated local ui state`)),j!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote ui state...`);const H=JSON.stringify({storage:B});v=await this.updateRemoteUserData(H,T?null:v.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote ui state`)}(w==null?void 0:w.ref)!==v.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized ui state...`),await this.updateLastSyncUserData(v),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized ui state`))}async getAssociatedResources({uri:v}){return[{resource:this.extUri.joinPath(v,"globalState.json"),comparableResource:ct.GLOBAL_STATE_DATA_URI}]}async resolveContent(v){if(this.extUri.isEqual(v,ct.GLOBAL_STATE_DATA_URI)){const d=await this.getLocalGlobalState();return r(d)}if(this.extUri.isEqual(this.remoteResource,v)||this.extUri.isEqual(this.localResource,v)||this.extUri.isEqual(this.acceptedResource,v))return this.resolvePreviewContent(v);let w=await super.resolveContent(v);if(w)return w;if(w=await super.resolveContent(this.extUri.dirname(v)),w){const d=this.parseSyncData(w);if(d)switch(this.extUri.basename(v)){case"globalState.json":return r(JSON.parse(d.content))}}return null}async hasLocalData(){var v;try{const{storage:w}=await this.getLocalGlobalState();if(Object.keys(w).length>1||((v=w[`${s}.locale`])===null||v===void 0?void 0:v.value)!=="en")return!0}catch(w){}return!1}async getLocalGlobalState(){const v={},w=await this.getLocalArgvContent(),d=(0,S.parse)(w);for(const T of t)d[T]!==void 0&&(v[`${s}${T}`]={version:1,value:d[T]});for(const T of this.storageService.keys(0,0)){const F=this.storageService.get(T,0);F&&(v[T]={version:1,value:F})}return{storage:v}}async getLocalArgvContent(){try{return(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch(v){}return"{}"}async writeLocalGlobalState({added:v,removed:w,updated:d}){const T={},F={},z=(K,j)=>{for(const H of K){if(H.startsWith(s)){T[H.substring(s.length)]=j?j[H].value:void 0;continue}if(j){const q=j[H];q.value!==String(this.storageService.get(H,0))&&(F[H]=q.value)}else this.storageService.get(H,0)!==void 0&&(F[H]=void 0)}};if(z(Object.keys(v),v),z(Object.keys(d),d),z(w),Object.keys(T).length&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.updateArgv(T),this.logService.info(`${this.syncResourceLogLabel}: Updated locale`)),Object.keys(F).length){this.logService.trace(`${this.syncResourceLogLabel}: Updating global state...`);for(const K of Object.keys(F))this.storageService.store(K,F[K],0,0);this.logService.info(`${this.syncResourceLogLabel}: Updated global state`,Object.keys(F))}}async updateArgv(v){const w=await this.getLocalArgvContent();let d=w;for(const T of Object.keys(v))d=(0,R.edit)(d,[T],v[T],{});w!==d&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.fileService.writeFile(this.environmentService.argvResource,P.VSBuffer.fromString(d)),this.logService.info(`${this.syncResourceLogLabel}: Updated locale.`))}getStorageKeys(v){const w=this.storageService.keys(0,0),d=this.storageService.keys(0,1),T=[...w,...d],F=(v==null?void 0:v.storage)?Object.keys(v.storage).filter(z=>!z.startsWith(s)&&!T.includes(z)&&this.storageService.get(z,0)!==void 0):[];if(!b.isWeb){const z=[...y.ALL_SYNC_RESOURCES.map(B=>(0,y.getEnablementKey)(B)),y.SYNC_SERVICE_URL_TYPE];F.push(...z),d.push(...z)}return{user:w,machine:d,unregistered:F}}};o.GLOBAL_STATE_DATA_URI=C.URI.from({scheme:y.USER_DATA_SYNC_SCHEME,authority:"globalState",path:"/globalState.json"}),o=de([Y(0,A.IFileService),Y(1,y.IUserDataSyncStoreService),Y(2,y.IUserDataSyncBackupStoreService),Y(3,y.IUserDataSyncLogService),Y(4,k.IEnvironmentService),Y(5,y.IUserDataSyncResourceEnablementService),Y(6,f.ITelemetryService),Y(7,m.IConfigurationService),Y(8,D.IStorageService)],o),e.GlobalStateSynchroniser=o;let c=class extends n.AbstractInitializer{constructor(v,w,d,T){super("globalState",d,T,w);this.storageService=v}async doInitialize(v){const w=v.syncData?JSON.parse(v.syncData.content):null;if(!w){this.logService.info("Skipping initializing global state because remote global state does not exist.");return}const d={},T={};for(const F of Object.keys(w.storage))F.startsWith(s)?d[F.substring(s.length)]=w.storage[F].value:this.storageService.get(F,0)===void 0&&(T[F]=w.storage[F].value);if(Object.keys(d).length){let F="{}";try{F=(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch(z){}for(const z of Object.keys(d))F=(0,R.edit)(F,[z],d[z],{});await this.fileService.writeFile(this.environmentService.argvResource,P.VSBuffer.fromString(F))}if(Object.keys(T).length)for(const F of Object.keys(T))this.storageService.store(F,T[F],0,0)}};c=de([Y(0,D.IStorageService),Y(1,A.IFileService),Y(2,k.IEnvironmentService),Y(3,y.IUserDataSyncLogService)],c),e.GlobalStateInitializer=c;let l=class{constructor(v,w,d,T,F){this.userDataSyncStoreClient=v,this.storageService=w,this.environmentService=d,this.fileService=T,this.logService=F}getSyncStoreType(v){var w;const d=this.parseGlobalState(v);return(w=d==null?void 0:d.storage[y.SYNC_SERVICE_URL_TYPE])===null||w===void 0?void 0:w.value}async sync(v){const w=(0,y.createSyncHeaders)((0,g.generateUuid)());try{return await this.doSync(v,w)}catch(d){if(d instanceof y.UserDataSyncError)switch(d.code){case y.UserDataSyncErrorCode.PreconditionFailed:return this.logService.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.doSync(v,w)}throw d}}async doSync(v,w){const d=await this.userDataSyncStoreClient.read("globalState",null,w),T=this.parseGlobalState(d)||{storage:{}};T.storage[y.SYNC_SERVICE_URL_TYPE]={value:v,version:i};const F=await(0,I.getServiceMachineId)(this.environmentService,this.fileService,this.storageService),z={version:i,machineId:F,content:r(T)};await this.userDataSyncStoreClient.write("globalState",JSON.stringify(z),d.ref,w)}parseGlobalState({content:v}){if(!v)return null;const w=JSON.parse(v);if((0,n.isSyncData)(w))return w?JSON.parse(w.content):null;throw new Error("Invalid remote data")}};l=de([Y(1,D.IStorageService),Y(2,k.IEnvironmentService),Y(3,A.IFileService),Y(4,a.ILogService)],l),e.UserDataSyncStoreTypeSynchronizer=l}),define(Z[190],ee([0,1,10,21,185,32,122,9,23,6,15,19,46,24,20,25,3]),function(G,e,y,P,L,k,A,R,p,S,n,f,m,C,h,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingsInitializer=e.KeybindingsSynchroniser=e.getKeybindingsContentFromSyncContent=void 0;function b(a,s){const t=JSON.parse(a);if(!s)return(0,n.isUndefined)(t.all)?null:t.all;switch(S.OS){case 2:return(0,n.isUndefined)(t.mac)?null:t.mac;case 3:return(0,n.isUndefined)(t.linux)?null:t.linux;case 1:return(0,n.isUndefined)(t.windows)?null:t.windows}}e.getKeybindingsContentFromSyncContent=b;let I=class extends m.AbstractJsonFileSynchroniser{constructor(s,t,r,i,o,c,l,u,v,w){super(l.keybindingsResource,"keybindings",c,l,u,s,t,o,w,r,v,i);this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"keybindings.json"),this.localResource=this.previewResource.with({scheme:P.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:P.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:P.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(D.Event.filter(i.onDidChangeConfiguration,d=>d.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.triggerLocalChange()))}async generateSyncPreview(s,t,r){const i=s.syncData?this.getKeybindingsContentFromSyncContent(s.syncData.content):null,o=t?this.getKeybindingsContentFromLastSyncUserData(t):null,c=await this.getLocalFileContent(),l=await this.getFormattingOptions();let u=null,v=!1,w=!1,d=!1;if(i){let F=c?c.value.toString():"[]";if(F=F||"[]",this.hasErrors(F))throw new P.UserDataSyncError((0,A.localize)(0,null),P.UserDataSyncErrorCode.LocalInvalidContent,this.resource);if(!o||o!==F||o!==i){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote keybindings with local keybindings...`);const z=await(0,L.merge)(F,i,o,l,this.userDataSyncUtilService);z.hasChanges&&(u=z.mergeContent,d=z.hasConflicts,v=d||z.mergeContent!==F,w=d||z.mergeContent!==i)}}else c&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),u=c.value.toString(),w=!0);const T={content:u,localChange:v?c?2:1:0,remoteChange:w?2:0,hasConflicts:d};return[{fileContent:c,localResource:this.localResource,localContent:c?c.value.toString():null,localChange:T.localChange,remoteResource:this.remoteResource,remoteContent:i,remoteChange:T.remoteChange,previewResource:this.previewResource,previewResult:T,acceptedResource:this.acceptedResource}]}async getMergeResult(s,t){return s.previewResult}async getAcceptResult(s,t,r,i){if(this.extUri.isEqual(t,this.localResource))return{content:s.fileContent?s.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(t,this.remoteResource))return{content:s.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(t,this.previewResource))return r===void 0?{content:s.previewResult.content,localChange:s.previewResult.localChange,remoteChange:s.previewResult.remoteChange}:{content:r,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${t.toString()}`)}async applyResult(s,t,r,i){var o;const{fileContent:c}=r[0][0];let{content:l,localChange:u,remoteChange:v}=r[0][1];if(u===0&&v===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing keybindings.`),l!==null&&(l=l.trim(),l=l||"[]",this.hasErrors(l)))throw new P.UserDataSyncError((0,A.localize)(1,null),P.UserDataSyncErrorCode.LocalInvalidContent,this.resource);if(u!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local keybindings...`),c&&await this.backupLocal(this.toSyncContent(c.value.toString())),await this.updateLocalFileContent(l||"[]",c,i),this.logService.info(`${this.syncResourceLogLabel}: Updated local keybindings`)),v!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote keybindings...`);const w=this.toSyncContent(l||"[]",(o=s.syncData)===null||o===void 0?void 0:o.content);s=await this.updateRemoteUserData(w,i?null:s.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote keybindings`)}try{await this.fileService.del(this.previewResource)}catch(w){}(t==null?void 0:t.ref)!==s.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized keybindings...`),await this.updateLastSyncUserData(s,{platformSpecific:this.syncKeybindingsPerPlatform()}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized keybindings`))}async hasLocalData(){try{const s=await this.getLocalFileContent();if(s){const t=(0,k.parse)(s.value.toString());if((0,f.isNonEmptyArray)(t))return!0}}catch(s){if(s.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:s}){const t=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(s,"keybindings.json"),comparableResource:t}]}async resolveContent(s){if(this.extUri.isEqual(this.remoteResource,s)||this.extUri.isEqual(this.localResource,s)||this.extUri.isEqual(this.acceptedResource,s))return this.resolvePreviewContent(s);let t=await super.resolveContent(s);if(t)return t;if(t=await super.resolveContent(this.extUri.dirname(s)),t){const r=this.parseSyncData(t);if(r)switch(this.extUri.basename(s)){case"keybindings.json":return this.getKeybindingsContentFromSyncContent(r.content)}}return null}getKeybindingsContentFromLastSyncUserData(s){return!s.syncData||s.platformSpecific!==void 0&&s.platformSpecific!==this.syncKeybindingsPerPlatform()?null:this.getKeybindingsContentFromSyncContent(s.syncData.content)}getKeybindingsContentFromSyncContent(s){try{return b(s,this.syncKeybindingsPerPlatform())}catch(t){return this.logService.error(t),null}}toSyncContent(s,t){let r={};try{r=JSON.parse(t||"{}")}catch(i){this.logService.error(i)}switch(this.syncKeybindingsPerPlatform()?delete r.all:r.all=s,S.OS){case 2:r.mac=s;break;case 3:r.linux=s;break;case 1:r.windows=s;break}return JSON.stringify(r)}syncKeybindingsPerPlatform(){let s=this.configurationService.inspect("settingsSync.keybindingsPerPlatform").userValue;return s!==void 0||(s=this.configurationService.inspect("sync.keybindingsPerPlatform").userValue,s!==void 0)?s:this.configurationService.getValue("settingsSync.keybindingsPerPlatform")}};I=de([Y(0,P.IUserDataSyncStoreService),Y(1,P.IUserDataSyncBackupStoreService),Y(2,P.IUserDataSyncLogService),Y(3,p.IConfigurationService),Y(4,P.IUserDataSyncResourceEnablementService),Y(5,y.IFileService),Y(6,R.IEnvironmentService),Y(7,h.IStorageService),Y(8,P.IUserDataSyncUtilService),Y(9,C.ITelemetryService)],I),e.KeybindingsSynchroniser=I;let g=class extends m.AbstractInitializer{constructor(s,t,r){super("keybindings",t,r,s)}async doInitialize(s){const t=s.syncData?this.getKeybindingsContentFromSyncContent(s.syncData.content):null;if(!t){this.logService.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing keybindings because local keybindings exist.");return}await this.fileService.writeFile(this.environmentService.keybindingsResource,E.VSBuffer.fromString(t)),await this.updateLastSyncUserData(s)}async isEmpty(){try{const s=await this.fileService.readFile(this.environmentService.settingsResource),t=(0,k.parse)(s.value.toString());return!(0,f.isNonEmptyArray)(t)}catch(s){return s.fileOperationResult===1}}getKeybindingsContentFromSyncContent(s){try{return b(s,!0)}catch(t){return this.logService.error(t),null}}};g=de([Y(0,y.IFileService),Y(1,R.IEnvironmentService),Y(2,P.IUserDataSyncLogService)],g),e.KeybindingsInitializer=g}),define(Z[191],ee([0,1,26,32,40,47,52,21,19]),function(G,e,y,P,L,k,A,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.addSetting=e.isEmpty=e.areSame=e.merge=e.updateIgnoredSettings=e.getIgnoredSettings=void 0;function S(l,u,v){let w=[];v?w=f(v):w=n(u);const d=[],T=[...(0,R.getDisallowedIgnoredSettings)()];if(Array.isArray(w))for(const F of w)F.startsWith("-")?T.push(F.substring(1)):d.push(F);return(0,p.distinct)([...l,...d].filter(F=>T.indexOf(F)===-1))}e.getIgnoredSettings=S;function n(l){let u=l.inspect("settingsSync.ignoredSettings").userValue;return u!==void 0||(u=l.inspect("sync.ignoredSettings").userValue,u!==void 0)?u:l.getValue("settingsSync.ignoredSettings")||[]}function f(l){const u=(0,P.parse)(l);return u?u["settingsSync.ignoredSettings"]||u["sync.ignoredSettings"]||[]:[]}function m(l,u,v,w){if(v.length){const d=c(u),T=(0,P.parse)(u),F=(0,P.parse)(l),z=[];for(const B of v){const K=T[B],j=F[B];K===void 0?l=A.edit(l,[B],void 0,w):j!==void 0?l=A.edit(l,[B],K,w):z.push(s(B,d))}z.sort((B,K)=>B.startOffset-K.startOffset),z.forEach(B=>l=b(B.setting.key,u,l,w))}return l}e.updateIgnoredSettings=m;function C(l,u,v,w,d,T){const F=m(l,u,w,T),z=v!==F,B=v!==u;if(!z&&!B)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(z&&!B)return{conflictsSettings:[],localContent:null,remoteContent:F,hasConflicts:!1};if(B&&!z)return{conflictsSettings:[],localContent:m(u,l,w,T),remoteContent:null,hasConflicts:!1};if(v===null&&E(l)){const ne=h(l,u,w)?null:m(u,l,w,T);return{conflictsSettings:[],localContent:ne,remoteContent:null,hasConflicts:!1}}let K=l,j=u;const H=(0,P.parse)(l),q=(0,P.parse)(u),$=v?(0,P.parse)(v):null,M=w.reduce((ne,ce)=>(ne.add(ce),ne),new Set),U=D(H,q,M),O=D($,H,M),_=D($,q,M),N=new Map,W=new Set,V=ne=>{W.add(ne);const ce=d.filter(({key:le})=>le===ne)[0];ce?(K=A.edit(K,[ne],ce.value,T),j=A.edit(j,[ne],ce.value,T)):N.set(ne,{key:ne,localValue:H[ne],remoteValue:q[ne]})};for(const ne of O.removed.values())_.updated.has(ne)?V(ne):j=A.edit(j,[ne],void 0,T);for(const ne of _.removed.values())W.has(ne)||(O.updated.has(ne)?V(ne):K=A.edit(K,[ne],void 0,T));for(const ne of O.updated.values())W.has(ne)||(_.updated.has(ne)?U.updated.has(ne)&&V(ne):j=A.edit(j,[ne],H[ne],T));for(const ne of _.updated.values())W.has(ne)||(O.updated.has(ne)?U.updated.has(ne)&&V(ne):K=A.edit(K,[ne],q[ne],T));for(const ne of O.added.values())W.has(ne)||(_.added.has(ne)?U.updated.has(ne)&&V(ne):j=b(ne,K,j,T));for(const ne of _.added.values())W.has(ne)||(O.added.has(ne)?U.updated.has(ne)&&V(ne):K=b(ne,j,K,T));const Q=N.size>0||!h(K,j,w),X=Q||!h(K,l,[]),ie=Q||!h(j,u,[]);return{localContent:X?K:null,remoteContent:ie?j:null,conflictsSettings:[...N.values()],hasConflicts:Q}}e.merge=C;function h(l,u,v){if(l===u)return!0;const w=(0,P.parse)(l),d=(0,P.parse)(u),T=v.reduce((B,K)=>(B.add(K),B),new Set),F=c(l).filter(B=>!(B.setting&&T.has(B.setting.key))),z=c(u).filter(B=>!(B.setting&&T.has(B.setting.key)));if(F.length!==z.length)return!1;for(let B=0;B<F.length;B++){const K=F[B],j=z[B];if(K.setting&&j.setting){if(K.setting.key!==j.setting.key||!y.equals(w[K.setting.key],d[K.setting.key]))return!1}else if(!K.setting&&!j.setting){if(K.value!==j.value)return!1}else return!1}return!0}e.areSame=h;function E(l){return l?c(l).length===0:!0}e.isEmpty=E;function D(l,u,v){const w=l?Object.keys(l).filter(B=>!v.has(B)):[],d=Object.keys(u).filter(B=>!v.has(B)),T=d.filter(B=>w.indexOf(B)===-1).reduce((B,K)=>(B.add(K),B),new Set),F=w.filter(B=>d.indexOf(B)===-1).reduce((B,K)=>(B.add(K),B),new Set),z=new Set;if(l)for(const B of w){if(F.has(B))continue;const K=l[B],j=u[B];y.equals(K,j)||z.add(B)}return{added:T,removed:F,updated:z}}function b(l,u,v,w){const d=(0,P.parse)(u),T=c(u),F=c(v),z=I(l,T,F);return g(v,l,d[l],z,F,w)}e.addSetting=b;function I(l,u,v){const w=u.findIndex(T=>{var F;return((F=T.setting)===null||F===void 0?void 0:F.key)===l}),d=u[w-1];if(d){if(d.setting){const F=s(d.setting.key,v);if(F)return{index:v.indexOf(F),insertAfter:!0}}else{const F=t(w,u);if(F){const z=s(F.setting.key,v);if(z){const B=r(v.indexOf(z),v),K=i(u,F,u[w]);if(B){const j=i(v,z,B),H=o(K,j);return H?{index:v.indexOf(H),insertAfter:!0}:{index:v.indexOf(B),insertAfter:!1}}else{const j=i(v,z,v[v.length-1]),H=o(K,j);return H?{index:v.indexOf(H),insertAfter:!0}:{index:v.length-1,insertAfter:!0}}}}}const T=u[w+1];if(T)if(T.setting){const F=s(T.setting.key,v);if(F)return{index:v.indexOf(F),insertAfter:!1}}else{const F=r(w,u);if(F){const z=s(F.setting.key,v);if(z){const B=t(v.indexOf(z),v),K=i(u,u[w],F);if(B){const j=i(v,B,z),H=o(K.reverse(),j.reverse());return H?{index:v.indexOf(H),insertAfter:!1}:{index:v.indexOf(B),insertAfter:!0}}else{const j=i(v,v[0],z),H=o(K.reverse(),j.reverse());return H?{index:v.indexOf(H),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:v.length-1,insertAfter:!0}}function g(l,u,v,w,d,T){let F;return w.index===-1?F=(0,L.setProperty)(l,[u],v,T):F=a(l,u,v,w,d,T).map(z=>(0,L.withFormatting)(l,z,T)[0]),(0,L.applyEdits)(l,F)}function a(l,u,v,w,d,T){var F;const z=`${JSON.stringify(u)}: ${JSON.stringify(v)}`,B=(0,k.getEOL)(T,l),K=d[w.index];if(w.insertAfter){const j=[];if(K.setting)j.push({offset:K.endOffset,length:0,content:","+z});else{const H=r(w.index,d),q=t(w.index,d),$=(F=q==null?void 0:q.setting)===null||F===void 0?void 0:F.commaOffset;q&&$===void 0&&j.push({offset:q.endOffset,length:0,content:","});const M=$!==void 0&&$>K.endOffset;j.push({offset:M?$+1:K.endOffset,length:0,content:H?B+z+",":B+z})}return j}else{if(K.setting)return[{offset:K.startOffset,length:0,content:z+","}];const j=(d[w.index-1]&&!d[w.index-1].setting?B:"")+z+(r(w.index,d)?",":"")+B;return[{offset:K.startOffset,length:0,content:j}]}}function s(l,u){return u.filter(v=>{var w;return((w=v.setting)===null||w===void 0?void 0:w.key)===l})[0]}function t(l,u){for(let v=l-1;v>=0;v--)if(u[v].setting)return u[v]}function r(l,u){for(let v=l+1;v<u.length;v++)if(u[v].setting)return u[v]}function i(l,u,v){const w=l.indexOf(u),d=l.indexOf(v);return l.filter((T,F)=>w<F&&F<d)}function o(l,u){if(l.length&&u.length){let v=0;for(;v<u.length&&v<l.length;v++)if(l[v].value!==u[v].value)return u[v-1];return u[v-1]}}function c(l){const u=[];let v=-1,w,d;const T={onObjectBegin:F=>{v++},onObjectProperty:(F,z,B)=>{v===0&&(w=z,d=F)},onObjectEnd:(F,z)=>{v--,v===0&&u.push({startOffset:w,endOffset:F+z,value:l.substring(w,F+z),setting:{key:d,commaOffset:void 0}})},onArrayBegin:(F,z)=>{v++},onArrayEnd:(F,z)=>{v--,v===0&&u.push({startOffset:w,endOffset:F+z,value:l.substring(w,F+z),setting:{key:d,commaOffset:void 0}})},onLiteralValue:(F,z,B)=>{v===0&&u.push({startOffset:w,endOffset:z+B,value:l.substring(w,z+B),setting:{key:d,commaOffset:void 0}})},onSeparator:(F,z,B)=>{if(v===0&&F===","){let K=u.length-1;for(;K>=0&&!u[K].setting;K--);const j=u[K];j&&u.splice(K,1,{startOffset:j.startOffset,endOffset:j.endOffset,value:j.value,setting:{key:j.setting.key,commaOffset:z}})}},onComment:(F,z)=>{v===0&&u.push({startOffset:F,endOffset:F+z,value:l.substring(F,F+z)})}};return(0,P.visit)(l,T),u}}),define(Z[192],ee([0,1,10,21,25,123,3,9,23,191,52,46,24,28,20,40]),function(G,e,y,P,L,k,A,R,p,S,n,f,m,C,h,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SettingsInitializer=e.SettingsSynchroniser=e.parseSettingsSyncContent=void 0;function D(s){return s&&s.settings&&typeof s.settings=="string"&&Object.keys(s).length===1}function b(s){const t=JSON.parse(s);return D(t)?t:{settings:s}}e.parseSettingsSyncContent=b;let I=class extends f.AbstractJsonFileSynchroniser{constructor(t,r,i,o,c,l,u,v,w,d,T){super(r.settingsResource,"settings",t,r,i,o,c,w,d,l,u,v);this.extensionManagementService=T,this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"settings.json"),this.localResource=this.previewResource.with({scheme:P.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:P.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:P.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._defaultIgnoredSettings=void 0}async generateSyncPreview(t,r,i){const o=await this.getLocalFileContent(),c=await this.getFormattingOptions(),l=this.getSettingsSyncContent(t),u=r?this.getSettingsSyncContent(r):null,v=await this.getIgnoredSettings();let w=null,d=!1,T=!1,F=!1;if(l){let B=o?o.value.toString().trim():"{}";B=B||"{}",this.validateContent(B),this.logService.trace(`${this.syncResourceLogLabel}: Merging remote settings with local settings...`);const K=(0,S.merge)(B,l.settings,u?u.settings:null,v,[],c);w=K.localContent||K.remoteContent,d=K.localContent!==null,T=K.remoteContent!==null,F=K.hasConflicts}else o&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote settings does not exist. Synchronizing settings for the first time.`),w=o.value.toString(),T=!0);const z={content:w,localChange:d?2:0,remoteChange:T?2:0,hasConflicts:F};return[{fileContent:o,localResource:this.localResource,localContent:o?o.value.toString():null,localChange:z.localChange,remoteResource:this.remoteResource,remoteContent:l?l.settings:null,remoteChange:z.remoteChange,previewResource:this.previewResource,previewResult:z,acceptedResource:this.acceptedResource}]}async getMergeResult(t,r){const i=await this.getFormattingOptions(),o=await this.getIgnoredSettings();return Object.assign(Object.assign({},t.previewResult),{content:t.previewResult.content?(0,S.updateIgnoredSettings)(t.previewResult.content,"{}",o,i):null})}async getAcceptResult(t,r,i,o){const c=await this.getFormattingOptions(),l=await this.getIgnoredSettings();if(this.extUri.isEqual(r,this.localResource))return{content:t.fileContent?(0,S.updateIgnoredSettings)(t.fileContent.value.toString(),"{}",l,c):null,localChange:0,remoteChange:2};if(this.extUri.isEqual(r,this.remoteResource))return{content:t.remoteContent!==null?(0,S.updateIgnoredSettings)(t.remoteContent,t.fileContent?t.fileContent.value.toString():"{}",l,c):null,localChange:2,remoteChange:0};if(this.extUri.isEqual(r,this.previewResource))return i===void 0?{content:t.previewResult.content,localChange:t.previewResult.localChange,remoteChange:t.previewResult.remoteChange}:{content:i!==null?(0,S.updateIgnoredSettings)(i,t.fileContent?t.fileContent.value.toString():"{}",l,c):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${r.toString()}`)}async applyResult(t,r,i,o){const{fileContent:c}=i[0][0];let{content:l,localChange:u,remoteChange:v}=i[0][1];if(u===0&&v===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing settings.`),l=l?l.trim():"{}",l=l||"{}",this.validateContent(l),u!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local settings...`),c&&await this.backupLocal(JSON.stringify(this.toSettingsSyncContent(c.value.toString()))),await this.updateLocalFileContent(l,c,o),await this.configurationService.reloadConfiguration(2),this.logService.info(`${this.syncResourceLogLabel}: Updated local settings`)),v!==0){const w=await this.getFormattingOptions(),d=this.getSettingsSyncContent(t),T=await this.getIgnoredSettings(l);l=(0,S.updateIgnoredSettings)(l,d?d.settings:"{}",T,w),this.logService.trace(`${this.syncResourceLogLabel}: Updating remote settings...`),t=await this.updateRemoteUserData(JSON.stringify(this.toSettingsSyncContent(l)),o?null:t.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote settings`)}try{await this.fileService.del(this.previewResource)}catch(w){}(r==null?void 0:r.ref)!==t.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized settings...`),await this.updateLastSyncUserData(t),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized settings`))}async hasLocalData(){try{const t=await this.getLocalFileContent();if(t){const r=await this.getFormattingOptions(),i=(0,n.edit)(t.value.toString(),[P.CONFIGURATION_SYNC_STORE_KEY],void 0,r);return!(0,S.isEmpty)(i)}}catch(t){if(t.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:t}){const r=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(t,"settings.json"),comparableResource:r}]}async resolveContent(t){if(this.extUri.isEqual(this.remoteResource,t)||this.extUri.isEqual(this.localResource,t)||this.extUri.isEqual(this.acceptedResource,t))return this.resolvePreviewContent(t);let r=await super.resolveContent(t);if(r)return r;if(r=await super.resolveContent(this.extUri.dirname(t)),r){const i=this.parseSyncData(r);if(i){const o=this.parseSettingsSyncContent(i.content);if(o)switch(this.extUri.basename(t)){case"settings.json":return o.settings}}}return null}async resolvePreviewContent(t){let r=await super.resolvePreviewContent(t);if(r){const i=await this.getFormattingOptions(),o=await this.getIgnoredSettings();r=(0,S.updateIgnoredSettings)(r,"{}",o,i)}return r}getSettingsSyncContent(t){return t.syncData?this.parseSettingsSyncContent(t.syncData.content):null}parseSettingsSyncContent(t){try{return b(t)}catch(r){this.logService.error(r)}return null}toSettingsSyncContent(t){return{settings:t}}async getIgnoredSettings(t){if(!this._defaultIgnoredSettings){this._defaultIgnoredSettings=this.userDataSyncUtilService.resolveDefaultIgnoredSettings();const i=A.Event.any(A.Event.filter(this.extensionManagementService.onDidInstallExtension,o=>!!o.gallery),A.Event.filter(this.extensionManagementService.onDidUninstallExtension,o=>!o.error))(()=>{i.dispose(),this._defaultIgnoredSettings=void 0})}const r=await this._defaultIgnoredSettings;return(0,S.getIgnoredSettings)(r,this.configurationService,t)}validateContent(t){if(this.hasErrors(t))throw new P.UserDataSyncError((0,k.localize)(0,null),P.UserDataSyncErrorCode.LocalInvalidContent,this.resource)}async recoverSettings(){try{const t=await this.getLocalFileContent();if(!t)return;const r=JSON.parse(t.value.toString());if(!a(r))return;this.telemetryService.publicLog2("sync/settingsCorrupted");const i=this.parseSettingsSyncContent(r.content);if(!i||!i.settings)return;let o=i.settings;const c=await this.getFormattingOptions();for(const l in r)if(["version","content","machineId"].indexOf(l)===-1&&r[l]!==void 0){const u=(0,E.setProperty)(o,[l],r[l],c);u.length&&(o=(0,E.applyEdits)(o,u))}await this.fileService.writeFile(this.file,L.VSBuffer.fromString(o))}catch(t){}}};I=de([Y(0,y.IFileService),Y(1,R.IEnvironmentService),Y(2,h.IStorageService),Y(3,P.IUserDataSyncStoreService),Y(4,P.IUserDataSyncBackupStoreService),Y(5,P.IUserDataSyncLogService),Y(6,P.IUserDataSyncUtilService),Y(7,p.IConfigurationService),Y(8,P.IUserDataSyncResourceEnablementService),Y(9,m.ITelemetryService),Y(10,C.IExtensionManagementService)],I),e.SettingsSynchroniser=I;let g=class extends f.AbstractInitializer{constructor(t,r,i){super("settings",r,i,t)}async doInitialize(t){const r=t.syncData?this.parseSettingsSyncContent(t.syncData.content):null;if(!r){this.logService.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing settings because local settings exist.");return}await this.fileService.writeFile(this.environmentService.settingsResource,L.VSBuffer.fromString(r.settings)),await this.updateLastSyncUserData(t)}async isEmpty(){try{const t=await this.fileService.readFile(this.environmentService.settingsResource);return(0,S.isEmpty)(t.value.toString().trim())}catch(t){return t.fileOperationResult===1}}parseSettingsSyncContent(t){try{return b(t)}catch(r){this.logService.error(r)}return null}};g=de([Y(0,y.IFileService),Y(1,R.IEnvironmentService),Y(2,P.IUserDataSyncLogService)],g),e.SettingsInitializer=g;function a(s){return!!(s&&s.version!==void 0&&typeof s.version=="number"&&s.content!==void 0&&typeof s.content=="string"&&s.machineId!==void 0&&typeof s.machineId=="string")}}),define(Z[193],ee([0,1,21,9,10,23,46,24,25,186,20,26,3]),function(G,e,y,P,L,k,A,R,p,S,n,f,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnippetsInitializer=e.SnippetsSynchroniser=void 0;let C=class extends A.AbstractSynchroniser{constructor(D,b,I,g,a,s,t,r,i){super("snippets",b,D,I,g,a,r,i,s,t);this.version=1,this.snippetsFolder=D.snippetsHome,this._register(this.fileService.watch(D.userRoamingDataHome)),this._register(this.fileService.watch(this.snippetsFolder)),this._register(m.Event.filter(this.fileService.onDidFilesChange,o=>o.affects(this.snippetsFolder))(()=>this.triggerLocalChange()))}async generateSyncPreview(D,b,I){const g=await this.getSnippetsFileContents(),a=this.toSnippetsContents(g),s=D.syncData?this.parseSnippets(D.syncData):null,t=b&&b.syncData?this.parseSnippets(b.syncData):null;s?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote snippets with local snippets...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const r=(0,S.merge)(a,s,t);return this.getResourcePreviews(r,g,s||{})}async getMergeResult(D,b){return D.previewResult}async getAcceptResult(D,b,I,g){if(this.extUri.isEqualOrParent(b,this.syncPreviewFolder.with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"local"})))return{content:D.fileContent?D.fileContent.value.toString():null,localChange:0,remoteChange:D.fileContent?D.remoteContent!==null?2:1:3};if(this.extUri.isEqualOrParent(b,this.syncPreviewFolder.with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"remote"})))return{content:D.remoteContent,localChange:D.remoteContent!==null?D.fileContent?2:1:3,remoteChange:0};if(this.extUri.isEqualOrParent(b,this.syncPreviewFolder))return I===void 0?{content:D.previewResult.content,localChange:D.previewResult.localChange,remoteChange:D.previewResult.remoteChange}:{content:I,localChange:I===null?D.fileContent!==null?3:0:2,remoteChange:I===null?D.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${b.toString()}`)}async applyResult(D,b,I,g){const a=I.map(([s,t])=>Object.assign(Object.assign({},s),{acceptResult:t}));a.every(({localChange:s,remoteChange:t})=>s===0&&t===0)&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing snippets.`),a.some(({localChange:s})=>s!==0)&&(await this.updateLocalBackup(a),await this.updateLocalSnippets(a,g)),a.some(({remoteChange:s})=>s!==0)&&(D=await this.updateRemoteSnippets(a,D,g)),(b==null?void 0:b.ref)!==D.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized snippets...`),await this.updateLastSyncUserData(D),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized snippets`));for(const{previewResource:s}of a)try{await this.fileService.del(s)}catch(t){}}getResourcePreviews(D,b,I){const g=new Map;for(const a of Object.keys(D.local.added)){const s={content:D.local.added[a],hasConflicts:!1,localChange:1,remoteChange:0};g.set(a,{fileContent:null,localResource:this.extUri.joinPath(this.syncPreviewFolder,a).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"local"}),localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,a).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:I[a],previewResource:this.extUri.joinPath(this.syncPreviewFolder,a),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,a).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const a of Object.keys(D.local.updated)){const s={content:D.local.updated[a],hasConflicts:!1,localChange:2,remoteChange:0};g.set(a,{localResource:this.extUri.joinPath(this.syncPreviewFolder,a).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:b[a],localContent:b[a].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,a).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:I[a],previewResource:this.extUri.joinPath(this.syncPreviewFolder,a),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,a).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const a of D.local.removed){const s={content:null,hasConflicts:!1,localChange:3,remoteChange:0};g.set(a,{localResource:this.extUri.joinPath(this.syncPreviewFolder,a).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:b[a],localContent:b[a].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,a).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,a),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,a).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const a of Object.keys(D.remote.added)){const s={content:D.remote.added[a],hasConflicts:!1,localChange:0,remoteChange:1};g.set(a,{localResource:this.extUri.joinPath(this.syncPreviewFolder,a).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:b[a],localContent:b[a].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,a).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,a),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,a).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const a of Object.keys(D.remote.updated)){const s={content:D.remote.updated[a],hasConflicts:!1,localChange:0,remoteChange:2};g.set(a,{localResource:this.extUri.joinPath(this.syncPreviewFolder,a).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:b[a],localContent:b[a].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,a).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:I[a],previewResource:this.extUri.joinPath(this.syncPreviewFolder,a),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,a).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const a of D.remote.removed){const s={content:null,hasConflicts:!1,localChange:0,remoteChange:3};g.set(a,{localResource:this.extUri.joinPath(this.syncPreviewFolder,a).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,a).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:I[a],previewResource:this.extUri.joinPath(this.syncPreviewFolder,a),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,a).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const a of D.conflicts){const s={content:b[a]?b[a].value.toString():null,hasConflicts:!0,localChange:b[a]?2:1,remoteChange:I[a]?2:1};g.set(a,{localResource:this.extUri.joinPath(this.syncPreviewFolder,a).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:b[a]||null,localContent:b[a]?b[a].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,a).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:I[a]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,a),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,a).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const a of Object.keys(b))if(!g.has(a)){const s={content:b[a]?b[a].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0};g.set(a,{localResource:this.extUri.joinPath(this.syncPreviewFolder,a).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:b[a]||null,localContent:b[a]?b[a].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,a).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:I[a]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,a),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,a).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}return[...g.values()]}async getAssociatedResources({uri:D}){let b=await super.resolveContent(D);if(b){const I=this.parseSyncData(b);if(I){const g=this.parseSnippets(I),a=[];for(const s of Object.keys(g)){const t=this.extUri.joinPath(D,s),r=this.extUri.joinPath(this.snippetsFolder,s),i=await this.fileService.exists(r);a.push({resource:t,comparableResource:i?r:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"local"})})}return a}}return[]}async resolveContent(D){if(this.extUri.isEqualOrParent(D,this.syncPreviewFolder.with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"remote"}))||this.extUri.isEqualOrParent(D,this.syncPreviewFolder.with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"local"}))||this.extUri.isEqualOrParent(D,this.syncPreviewFolder.with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"accepted"})))return this.resolvePreviewContent(D);let b=await super.resolveContent(D);if(b)return b;if(b=await super.resolveContent(this.extUri.dirname(D)),b){const I=this.parseSyncData(b);if(I)return this.parseSnippets(I)[this.extUri.basename(D)]||null}return null}async hasLocalData(){try{const D=await this.getSnippetsFileContents();if(Object.keys(D).length)return!0}catch(D){}return!1}async updateLocalBackup(D){const b={};for(const I of D)I.fileContent&&(b[this.extUri.basename(I.localResource)]=I.fileContent);await this.backupLocal(JSON.stringify(this.toSnippetsContents(b)))}async updateLocalSnippets(D,b){for(const{fileContent:I,acceptResult:g,localResource:a,remoteResource:s,localChange:t}of D)if(t!==0){const r=s?this.extUri.basename(s):this.extUri.basename(a),i=this.extUri.joinPath(this.snippetsFolder,r);t===3?(this.logService.trace(`${this.syncResourceLogLabel}: Deleting snippet...`,this.extUri.basename(i)),await this.fileService.del(i),this.logService.info(`${this.syncResourceLogLabel}: Deleted snippet`,this.extUri.basename(i))):t===1?(this.logService.trace(`${this.syncResourceLogLabel}: Creating snippet...`,this.extUri.basename(i)),await this.fileService.createFile(i,p.VSBuffer.fromString(g.content),{overwrite:b}),this.logService.info(`${this.syncResourceLogLabel}: Created snippet`,this.extUri.basename(i))):(this.logService.trace(`${this.syncResourceLogLabel}: Updating snippet...`,this.extUri.basename(i)),await this.fileService.writeFile(i,p.VSBuffer.fromString(g.content),b?void 0:I),this.logService.info(`${this.syncResourceLogLabel}: Updated snippet`,this.extUri.basename(i)))}}async updateRemoteSnippets(D,b,I){const g=b.syncData?this.parseSnippets(b.syncData):{},a=(0,f.deepClone)(g);for(const{acceptResult:s,localResource:t,remoteResource:r,remoteChange:i}of D)if(i!==0){const o=t?this.extUri.basename(t):this.extUri.basename(r);i===3?delete a[o]:a[o]=s.content}return(0,S.areSame)(g,a)||(this.logService.trace(`${this.syncResourceLogLabel}: Updating remote snippets...`),b=await this.updateRemoteUserData(JSON.stringify(a),I?null:b.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote snippets`)),b}parseSnippets(D){return JSON.parse(D.content)}toSnippetsContents(D){const b={};for(const I of Object.keys(D))b[I]=D[I].value.toString();return b}async getSnippetsFileContents(){const D={};let b;try{b=await this.fileService.resolve(this.snippetsFolder)}catch(I){if(I instanceof L.FileOperationError&&I.fileOperationResult===1)return D;throw I}for(const I of b.children||[]){const g=I.resource,a=this.extUri.extname(g);if(a===".json"||a===".code-snippets"){const s=this.extUri.relativePath(this.snippetsFolder,g),t=await this.fileService.readFile(g);D[s]=t}}return D}};C=de([Y(0,P.IEnvironmentService),Y(1,L.IFileService),Y(2,n.IStorageService),Y(3,y.IUserDataSyncStoreService),Y(4,y.IUserDataSyncBackupStoreService),Y(5,y.IUserDataSyncLogService),Y(6,k.IConfigurationService),Y(7,y.IUserDataSyncResourceEnablementService),Y(8,R.ITelemetryService)],C),e.SnippetsSynchroniser=C;let h=class extends A.AbstractInitializer{constructor(D,b,I){super("snippets",b,I,D)}async doInitialize(D){const b=D.syncData?JSON.parse(D.syncData.content):null;if(!b){this.logService.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing snippets because local snippets exist.");return}for(const g of Object.keys(b)){const a=b[g];if(a){const s=this.extUri.joinPath(this.environmentService.snippetsHome,g);await this.fileService.createFile(s,p.VSBuffer.fromString(a)),this.logService.info("Created snippet",this.extUri.basename(s))}}await this.updateLastSyncUserData(D)}async isEmpty(){var D;try{return!((D=(await this.fileService.resolve(this.environmentService.snippetsHome)).children)===null||D===void 0?void 0:D.length)}catch(b){return b.fileOperationResult===1}}};h=de([Y(0,L.IFileService),Y(1,P.IEnvironmentService),Y(2,y.IUserDataSyncLogService)],h),e.SnippetsInitializer=h}),define(Z[60],ee([0,1,4,3,2,21]),function(G,e,y,P,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncAccountService=e.IUserDataSyncAccountService=void 0,e.IUserDataSyncAccountService=(0,y.createDecorator)("IUserDataSyncAccountService");let A=class extends L.Disposable{constructor(p){super();this.userDataSyncStoreService=p,this._onDidChangeAccount=this._register(new P.Emitter),this.onDidChangeAccount=this._onDidChangeAccount.event,this._onTokenFailed=this._register(new P.Emitter),this.onTokenFailed=this._onTokenFailed.event,this.wasTokenFailed=!1,this._register(p.onTokenFailed(()=>{this.updateAccount(void 0),this._onTokenFailed.fire(this.wasTokenFailed),this.wasTokenFailed=!0})),this._register(p.onTokenSucceed(()=>this.wasTokenFailed=!1))}get account(){return this._account}async updateAccount(p){(p&&this._account?p.token!==this._account.token||p.authenticationProviderId!==this._account.authenticationProviderId:p!==this._account)&&(this._account=p,this._account&&this.userDataSyncStoreService.setAuthToken(this._account.token,this._account.authenticationProviderId),this._onDidChangeAccount.fire(p))}};A=de([Y(0,k.IUserDataSyncStoreService)],A),e.UserDataSyncAccountService=A}),define(Z[194],ee([0,1,2,21,14,23,10,9,55,25,8]),function(G,e,y,P,L,k,A,R,p,S,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncBackupStoreService=void 0;let f=class extends y.Disposable{constructor(C,h,E,D){super();this.environmentService=C,this.fileService=h,this.configurationService=E,this.logService=D,P.ALL_SYNC_RESOURCES.forEach(b=>this.cleanUpBackup(b))}async getAllRefs(C){const h=(0,L.joinPath)(this.environmentService.userDataSyncHome,C),E=await this.fileService.resolve(h);return E.children?E.children.filter(b=>b.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(b.name)).sort().reverse().map(b=>({ref:b.name,created:this.getCreationTime(b)})):[]}async resolveContent(C,h){if(!h){const E=await this.getAllRefs(C);E.length&&(h=E[E.length-1].ref)}if(h){const E=(0,L.joinPath)(this.environmentService.userDataSyncHome,C,h);return(await this.fileService.readFile(E)).value.toString()}return null}async backup(C,h){const E=(0,L.joinPath)(this.environmentService.userDataSyncHome,C),D=(0,L.joinPath)(E,`${(0,p.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.fileService.writeFile(D,S.VSBuffer.fromString(h))}catch(b){this.logService.error(b)}try{this.cleanUpBackup(C)}catch(b){}}async cleanUpBackup(C){const h=(0,L.joinPath)(this.environmentService.userDataSyncHome,C);try{try{if(!await this.fileService.exists(h))return}catch(D){return}const E=await this.fileService.resolve(h);if(E.children){const D=E.children.filter(a=>a.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(a.name)).sort(),b=1e3*60*60*24*(this.configurationService.getValue("sync.localBackupDuration")||30);let I=D.filter(a=>Date.now()-this.getCreationTime(a)>b);const g=D.length-I.length;g<10&&(I=I.slice(10-g)),await n.Promises.settled(I.map(async a=>{this.logService.info("Deleting from backup",a.resource.path),await this.fileService.del(a.resource)}))}}catch(E){this.logService.error(E)}}getCreationTime(C){return C.ctime||new Date(parseInt(C.name.substring(0,4)),parseInt(C.name.substring(4,6))-1,parseInt(C.name.substring(6,8)),parseInt(C.name.substring(9,11)),parseInt(C.name.substring(11,13)),parseInt(C.name.substring(13,15))).getTime()}};f=de([Y(0,R.IEnvironmentService),Y(1,A.IFileService),Y(2,k.IConfigurationService),Y(3,P.IUserDataSyncLogService)],f),e.UserDataSyncBackupStoreService=f}),define(Z[195],ee([0,1,5,2]),function(G,e,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreManagementServiceChannelClient=e.UserDataSyncStoreManagementServiceChannel=e.UserDataSyncAccountServiceChannel=e.UserDataSyncMachinesServiceChannel=e.UserDataSyncUtilServiceClient=e.UserDataSycnUtilServiceChannel=e.UserDataAutoSyncChannel=void 0;class L{constructor(m){this.service=m}listen(m,C){switch(C){case"onError":return this.service.onError}throw new Error(`Event not found: ${C}`)}call(m,C,h){switch(C){case"triggerSync":return this.service.triggerSync(h[0],h[1],h[2]);case"turnOn":return this.service.turnOn();case"turnOff":return this.service.turnOff(h[0])}throw new Error("Invalid call")}}e.UserDataAutoSyncChannel=L;class k{constructor(m){this.service=m}listen(m,C){throw new Error(`Event not found: ${C}`)}call(m,C,h){switch(C){case"resolveDefaultIgnoredSettings":return this.service.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.service.resolveUserBindings(h[0]);case"resolveFormattingOptions":return this.service.resolveFormattingOptions(y.URI.revive(h[0]))}throw new Error("Invalid call")}}e.UserDataSycnUtilServiceChannel=k;class A{constructor(m){this.channel=m}async resolveDefaultIgnoredSettings(){return this.channel.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(m){return this.channel.call("resolveUserKeybindings",[m])}async resolveFormattingOptions(m){return this.channel.call("resolveFormattingOptions",[m])}}e.UserDataSyncUtilServiceClient=A;class R{constructor(m){this.service=m}listen(m,C){switch(C){case"onDidChange":return this.service.onDidChange}throw new Error(`Event not found: ${C}`)}async call(m,C,h){switch(C){case"getMachines":return this.service.getMachines();case"addCurrentMachine":return this.service.addCurrentMachine();case"removeCurrentMachine":return this.service.removeCurrentMachine();case"renameMachine":return this.service.renameMachine(h[0],h[1]);case"setEnablement":return this.service.setEnablement(h[0],h[1])}throw new Error("Invalid call")}}e.UserDataSyncMachinesServiceChannel=R;class p{constructor(m){this.service=m}listen(m,C){switch(C){case"onDidChangeAccount":return this.service.onDidChangeAccount;case"onTokenFailed":return this.service.onTokenFailed}throw new Error(`Event not found: ${C}`)}call(m,C,h){switch(C){case"_getInitialData":return Promise.resolve(this.service.account);case"updateAccount":return this.service.updateAccount(h)}throw new Error("Invalid call")}}e.UserDataSyncAccountServiceChannel=p;class S{constructor(m){this.service=m}listen(m,C){switch(C){case"onDidChangeUserDataSyncStore":return this.service.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${C}`)}call(m,C,h){switch(C){case"switch":return this.service.switch(h[0]);case"getPreviousUserDataSyncStore":return this.service.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.UserDataSyncStoreManagementServiceChannel=S;class n extends P.Disposable{constructor(m){super();this.channel=m,this.onDidChangeUserDataSyncStore=this.channel.listen("onDidChangeUserDataSyncStore")}async switch(m){return this.channel.call("switch",[m])}async getPreviousUserDataSyncStore(){const m=await this.channel.call("getPreviousUserDataSyncStore");return this.revive(m)}revive(m){return{url:y.URI.revive(m.url),type:m.type,defaultUrl:y.URI.revive(m.defaultUrl),insidersUrl:y.URI.revive(m.insidersUrl),stableUrl:y.URI.revive(m.stableUrl),canSwitch:m.canSwitch,authenticationProviders:m.authenticationProviders}}}e.UserDataSyncStoreManagementServiceChannelClient=n}),define(Z[196],ee([0,1,18,9]),function(G,e,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLogService=void 0;let L=class extends y.AbstractLogger{constructor(A,R){super();this.logger=this._register(A.createLogger(R.userDataSyncLogResource,{name:"settingssync"}))}trace(A,...R){this.logger.trace(A,...R)}debug(A,...R){this.logger.debug(A,...R)}info(A,...R){this.logger.info(A,...R)}warn(A,...R){this.logger.warn(A,...R)}error(A,...R){this.logger.error(A,...R)}critical(A,...R){this.logger.critical(A,...R)}flush(){this.logger.flush()}};L=de([Y(0,y.ILoggerService),Y(1,P.IEnvironmentService)],L),e.UserDataSyncLogService=L}),define(Z[61],ee([0,1,4,2,45,9,10,20,21,126,27,6,22,3]),function(G,e,y,P,L,k,A,R,p,S,n,f,m,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncMachinesService=e.IUserDataSyncMachinesService=void 0,e.IUserDataSyncMachinesService=(0,y.createDecorator)("IUserDataSyncMachinesService");const h="sync.currentMachineName";let E=class Ge extends P.Disposable{constructor(b,I,g,a,s,t){super();this.storageService=g,this.userDataSyncStoreService=a,this.logService=s,this.productService=t,this._onDidChange=this._register(new C.Emitter),this.onDidChange=this._onDidChange.event,this.userData=null,this.currentMachineIdPromise=(0,L.getServiceMachineId)(b,I,g)}async getMachines(b){const I=await this.currentMachineIdPromise;return(await this.readMachinesData(b)).machines.map(a=>Object.assign(Object.assign({},a),{isCurrent:a.id===I}))}async addCurrentMachine(b){const I=await this.currentMachineIdPromise,g=await this.readMachinesData(b);g.machines.some(({id:a})=>a===I)||(g.machines.push({id:I,name:this.computeCurrentMachineName(g.machines)}),await this.writeMachinesData(g))}async removeCurrentMachine(b){const I=await this.currentMachineIdPromise,g=await this.readMachinesData(b),a=g.machines.filter(({id:s})=>s!==I);a.length!==g.machines.length&&(g.machines=a,await this.writeMachinesData(g))}async renameMachine(b,I,g){const a=await this.currentMachineIdPromise,s=await this.readMachinesData(g),t=s.machines.find(({id:r})=>r===b);t&&(t.name=I,await this.writeMachinesData(s),s.machines.some(({id:r})=>r===a)&&this.storageService.store(h,I,0,1))}async setEnablement(b,I){const g=await this.readMachinesData(),a=g.machines.find(({id:s})=>s===b);a&&(a.disabled=I?void 0:!0,await this.writeMachinesData(g))}computeCurrentMachineName(b){const I=this.storageService.get(h,0);if(I)return I;const g=`${this.productService.nameLong} (${(0,f.PlatformToString)(f.isWeb?0:f.platform)})`,a=new RegExp(`${(0,m.escapeRegExpCharacters)(g)}\\s#(\\d+)`);let s=0;for(const t of b){const r=a.exec(t.name),i=r?parseInt(r[1]):0;s=i>s?i:s}return`${g} #${s+1}`}async readMachinesData(b){this.userData=await this.readUserData(b);const I=this.parse(this.userData);if(I.version!==Ge.VERSION)throw new Error((0,S.localize)(0,null,this.productService.nameLong));return I}async writeMachinesData(b){var I;const g=JSON.stringify(b),a=await this.userDataSyncStoreService.write(Ge.RESOURCE,g,((I=this.userData)===null||I===void 0?void 0:I.ref)||null);this.userData={ref:a,content:g},this._onDidChange.fire()}async readUserData(b){if(this.userData){const I=b&&b.latest?b.latest[Ge.RESOURCE]:void 0;if(this.userData.ref===I)return this.userData;if(I===void 0&&this.userData.content===null)return this.userData}return this.userDataSyncStoreService.read(Ge.RESOURCE,this.userData)}parse(b){if(b.content!==null)try{return JSON.parse(b.content)}catch(I){this.logService.error(I)}return{version:Ge.VERSION,machines:[]}}};E.VERSION=1,E.RESOURCE="machines",E=de([Y(0,k.IEnvironmentService),Y(1,A.IFileService),Y(2,R.IStorageService),Y(3,p.IUserDataSyncStoreService),Y(4,p.IUserDataSyncLogService),Y(5,n.IProductService)],E),e.UserDataSyncMachinesService=E}),define(Z[85],ee([0,1,8,3,2,21,60,24,11,20,9,61,124,55,5,14,6,27]),function(G,e,y,P,L,k,A,R,p,S,n,f,m,C,h,E,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=e.UserDataAutoSyncEnablementService=void 0;const I="sync.enable",g="sync.disableMachineEventually",a="sync.sessionId",s="sync.storeUrl",t="sync.productQuality";let r=class extends L.Disposable{constructor(l,u,v){super();this.storageService=l,this.environmentService=u,this.userDataSyncStoreManagementService=v,this._onDidChangeEnablement=new P.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this._register(l.onDidChangeValue(w=>this.onDidStorageChange(w)))}isEnabled(l){switch(this.environmentService.sync){case"on":return!0;case"off":return!1}return this.storageService.getBoolean(I,0,!!l)}canToggleEnablement(){return this.userDataSyncStoreManagementService.userDataSyncStore!==void 0&&this.environmentService.sync===void 0}setEnablement(l){l&&!this.canToggleEnablement()||this.storageService.store(I,l,0,1)}onDidStorageChange(l){if(l.scope===0&&I===l.key){this._onDidChangeEnablement.fire(this.isEnabled());return}}};r=de([Y(0,S.IStorageService),Y(1,n.IEnvironmentService),Y(2,k.IUserDataSyncStoreManagementService)],r),e.UserDataAutoSyncEnablementService=r;let i=class extends L.Disposable{constructor(l,u,v,w,d,T,F,z,B,K,j){var H;super();this.userDataSyncStoreManagementService=u,this.userDataSyncStoreService=v,this.userDataSyncResourceEnablementService=w,this.userDataSyncService=d,this.logService=T,this.userDataSyncAccountService=F,this.telemetryService=z,this.userDataSyncMachinesService=B,this.storageService=K,this.autoSync=this._register(new L.MutableDisposable),this.successiveFailures=0,this.lastSyncTriggerTime=void 0,this._onError=this._register(new P.Emitter),this.onError=this._onError.event,this.sources=[],this.userDataAutoSyncEnablementService=j,this.syncTriggerDelayer=this._register(new y.Delayer(0)),this.lastSyncUrl=this.syncUrl,this.syncUrl=(H=u.userDataSyncStore)===null||H===void 0?void 0:H.url,this.previousProductQuality=this.productQuality,this.productQuality=l.quality,this.syncUrl&&(this.logService.info("Using settings sync service",this.syncUrl.toString()),this._register(u.onDidChangeUserDataSyncStore(()=>{var q,$;(0,E.isEqual)(this.syncUrl,(q=u.userDataSyncStore)===null||q===void 0?void 0:q.url)||(this.lastSyncUrl=this.syncUrl,this.syncUrl=($=u.userDataSyncStore)===null||$===void 0?void 0:$.url,this.syncUrl&&this.logService.info("Using settings sync service",this.syncUrl.toString()))})),this.userDataAutoSyncEnablementService.isEnabled()?this.logService.info("Auto Sync is enabled."):this.logService.info("Auto Sync is disabled."),this.updateAutoSync(),this.hasToDisableMachineEventually()&&this.disableMachineEventually(),this._register(F.onDidChangeAccount(()=>this.updateAutoSync())),this._register(v.onDidChangeDonotMakeRequestsUntil(()=>this.updateAutoSync())),this._register(P.Event.debounce(d.onDidChangeLocal,(q,$)=>q?[...q,$]:[$],1e3)(q=>this.triggerSync(q,!1,!1))),this._register(P.Event.filter(this.userDataSyncResourceEnablementService.onDidChangeResourceEnablement,([,q])=>q)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this._register(this.userDataSyncStoreManagementService.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}get syncUrl(){const l=this.storageService.get(s,0);return l?h.URI.parse(l):void 0}set syncUrl(l){l?this.storageService.store(s,l.toString(),0,1):this.storageService.remove(s,0)}get productQuality(){return this.storageService.get(t,0)}set productQuality(l){l?this.storageService.store(t,l,0,1):this.storageService.remove(t,0)}updateAutoSync(){const{enabled:l,message:u}=this.isAutoSyncEnabled();l?this.autoSync.value===void 0&&(this.autoSync.value=new o(this.lastSyncUrl,1e3*60*5,this.userDataSyncStoreManagementService,this.userDataSyncStoreService,this.userDataSyncService,this.userDataSyncMachinesService,this.logService,this.storageService),this.autoSync.value.register(this.autoSync.value.onDidStartSync(()=>this.lastSyncTriggerTime=new Date().getTime())),this.autoSync.value.register(this.autoSync.value.onDidFinishSync(v=>this.onDidFinishSync(v))),this.startAutoSync()&&this.autoSync.value.start()):(this.syncTriggerDelayer.cancel(),this.autoSync.value!==void 0?(u&&this.logService.info(u),this.autoSync.clear()):u&&this.userDataAutoSyncEnablementService.isEnabled()&&this.logService.info(u))}startAutoSync(){return!0}isAutoSyncEnabled(){return this.userDataAutoSyncEnablementService.isEnabled()?this.userDataSyncAccountService.account?this.userDataSyncStoreService.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,C.toLocalISOString)(this.userDataSyncStoreService.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.stopDisableMachineEventually(),this.lastSyncUrl=this.syncUrl,this.updateEnablement(!0)}async turnOff(l,u,v){try{this.userDataSyncAccountService.account&&!v&&await this.userDataSyncMachinesService.removeCurrentMachine(),this.updateEnablement(!1),this.storageService.remove(a,0),l?(this.telemetryService.publicLog2("sync/turnOffEveryWhere"),await this.userDataSyncService.reset()):await this.userDataSyncService.resetLocal()}catch(w){if(u)this.logService.error(w),this.updateEnablement(!1);else throw w}}updateEnablement(l){this.userDataAutoSyncEnablementService.isEnabled()!==l&&(this.telemetryService.publicLog2(I,{enabled:l}),this.userDataAutoSyncEnablementService.setEnablement(l),this.updateAutoSync())}hasProductQualityChanged(){return!!this.previousProductQuality&&!!this.productQuality&&this.previousProductQuality!==this.productQuality}async onDidFinishSync(l){if(!l){this.successiveFailures=0;return}const u=k.UserDataSyncError.toUserDataSyncError(l);u instanceof k.UserDataAutoSyncError&&this.telemetryService.publicLog2("autosync/error",{code:u.code,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()}),u.code===k.UserDataSyncErrorCode.SessionExpired?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because current session is expired")):u.code===k.UserDataSyncErrorCode.TurnedOff?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):u.code===k.UserDataSyncErrorCode.LocalTooManyRequests||u.code===k.UserDataSyncErrorCode.TooManyRequests?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because of making too many requests to server")):u.code===k.UserDataSyncErrorCode.UpgradeRequired||u.code===k.UserDataSyncErrorCode.Gone?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):u.code===k.UserDataSyncErrorCode.IncompatibleLocalContent?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${u.resource} content with newer version than of client. Requires client upgrade.`)):u.code===k.UserDataSyncErrorCode.IncompatibleRemoteContent?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${u.resource} content with older version than of client. Requires server reset.`)):u.code===k.UserDataSyncErrorCode.ServiceChanged||u.code===k.UserDataSyncErrorCode.DefaultServiceChanged?D.isWeb&&u.code===k.UserDataSyncErrorCode.DefaultServiceChanged&&!this.hasProductQualityChanged()?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.logService.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.logService.error(u),this.successiveFailures++),this._onError.fire(u)}async disableMachineEventually(){this.storageService.store(g,!0,0,1),await(0,y.timeout)(1e3*60*10),!!this.hasToDisableMachineEventually()&&(this.stopDisableMachineEventually(),!this.userDataAutoSyncEnablementService.isEnabled()&&this.userDataSyncAccountService.account&&await this.userDataSyncMachinesService.removeCurrentMachine())}hasToDisableMachineEventually(){return this.storageService.getBoolean(g,0,!1)}stopDisableMachineEventually(){this.storageService.remove(g,0)}async triggerSync(l,u,v){if(this.autoSync.value===void 0)return this.syncTriggerDelayer.cancel();if(u&&this.lastSyncTriggerTime&&Math.round((new Date().getTime()-this.lastSyncTriggerTime)/1e3)<10){this.logService.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.sources.push(...l),this.syncTriggerDelayer.trigger(async()=>{this.logService.trace("activity sources",...this.sources),this.telemetryService.publicLog2("sync/triggered",{sources:this.sources}),this.sources=[],this.autoSync.value&&await this.autoSync.value.sync("Activity",v)},this.successiveFailures?this.getSyncTriggerDelayTime()*1*Math.min(Math.pow(2,this.successiveFailures),60):this.getSyncTriggerDelayTime())}getSyncTriggerDelayTime(){return 1e3}};i=de([Y(0,b.IProductService),Y(1,k.IUserDataSyncStoreManagementService),Y(2,k.IUserDataSyncStoreService),Y(3,k.IUserDataSyncResourceEnablementService),Y(4,k.IUserDataSyncService),Y(5,k.IUserDataSyncLogService),Y(6,A.IUserDataSyncAccountService),Y(7,R.ITelemetryService),Y(8,f.IUserDataSyncMachinesService),Y(9,S.IStorageService),Y(10,k.IUserDataAutoSyncEnablementService)],i),e.UserDataAutoSyncService=i;class o extends L.Disposable{constructor(l,u,v,w,d,T,F,z){super();this.lastSyncUrl=l,this.interval=u,this.userDataSyncStoreManagementService=v,this.userDataSyncStoreService=w,this.userDataSyncService=d,this.userDataSyncMachinesService=T,this.logService=F,this.storageService=z,this.intervalHandler=this._register(new L.MutableDisposable),this._onDidStartSync=this._register(new P.Emitter),this.onDidStartSync=this._onDidStartSync.event,this._onDidFinishSync=this._register(new P.Emitter),this.onDidFinishSync=this._onDidFinishSync.event}start(){this._register(this.onDidFinishSync(()=>this.waitUntilNextIntervalAndSync())),this._register((0,L.toDisposable)(()=>{this.syncPromise&&(this.syncPromise.cancel(),this.logService.info("Auto sync: Cancelled sync that is in progress"),this.syncPromise=void 0),this.syncTask&&this.syncTask.stop(),this.logService.info("Auto Sync: Stopped")})),this.logService.info("Auto Sync: Started"),this.sync(o.INTERVAL_SYNCING,!1)}waitUntilNextIntervalAndSync(){this.intervalHandler.value=(0,y.disposableTimeout)(()=>this.sync(o.INTERVAL_SYNCING,!1),this.interval)}sync(l,u){const v=(0,y.createCancelablePromise)(async w=>{if(this.syncPromise)try{this.logService.debug("Auto Sync: Waiting until sync is finished."),await this.syncPromise}catch(d){if((0,p.isPromiseCanceledError)(d))return}return this.doSync(l,u,w)});return this.syncPromise=v,this.syncPromise.finally(()=>this.syncPromise=void 0),this.syncPromise}hasSyncServiceChanged(){var l;return this.lastSyncUrl!==void 0&&!(0,E.isEqual)(this.lastSyncUrl,(l=this.userDataSyncStoreManagementService.userDataSyncStore)===null||l===void 0?void 0:l.url)}async hasDefaultServiceChanged(){const l=await this.userDataSyncStoreManagementService.getPreviousUserDataSyncStore(),u=this.userDataSyncStoreManagementService.userDataSyncStore;return!!u&&!!l&&(!(0,E.isEqual)(u.defaultUrl,l.defaultUrl)||!(0,E.isEqual)(u.insidersUrl,l.insidersUrl)||!(0,E.isEqual)(u.stableUrl,l.stableUrl))}async doSync(l,u,v){this.logService.info(`Auto Sync: Triggered by ${l}`),this._onDidStartSync.fire();let w;try{if(this.syncTask=await this.userDataSyncService.createSyncTask(u),v.isCancellationRequested)return;let d=this.syncTask.manifest;if(d===null&&await this.userDataSyncService.hasPreviouslySynced())throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new k.UserDataAutoSyncError((0,m.localize)(0,null),k.UserDataSyncErrorCode.DefaultServiceChanged):new k.UserDataAutoSyncError((0,m.localize)(1,null),k.UserDataSyncErrorCode.ServiceChanged):new k.UserDataAutoSyncError((0,m.localize)(2,null),k.UserDataSyncErrorCode.TurnedOff);const T=this.storageService.get(a,0);if(T&&d&&T!==d.session)throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new k.UserDataAutoSyncError((0,m.localize)(3,null),k.UserDataSyncErrorCode.DefaultServiceChanged):new k.UserDataAutoSyncError((0,m.localize)(4,null),k.UserDataSyncErrorCode.ServiceChanged):new k.UserDataAutoSyncError((0,m.localize)(5,null),k.UserDataSyncErrorCode.SessionExpired);const F=await this.userDataSyncMachinesService.getMachines(d||void 0);if(v.isCancellationRequested)return;const z=F.find(B=>B.isCurrent);if(z==null?void 0:z.disabled)throw new k.UserDataAutoSyncError((0,m.localize)(6,null),k.UserDataSyncErrorCode.TurnedOff);if(await this.syncTask.run(),d===null&&(d=await this.userDataSyncStoreService.manifest()),d&&d.session!==T&&this.storageService.store(a,d.session,0,1),v.isCancellationRequested)return;z||await this.userDataSyncMachinesService.addCurrentMachine(d||void 0)}catch(d){this.logService.error(d),w=d}this._onDidFinishSync.fire(w)}register(l){return super._register(l)}}o.INTERVAL_SYNCING="Interval"}),define(Z[197],ee([0,1,21,2,3,20,24,6]),function(G,e,y,P,L,k,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncResourceEnablementService=void 0;let p=class extends P.Disposable{constructor(n,f){super();this.storageService=n,this.telemetryService=f,this._onDidChangeResourceEnablement=new L.Emitter,this.onDidChangeResourceEnablement=this._onDidChangeResourceEnablement.event,this._register(n.onDidChangeValue(m=>this.onDidStorageChange(m)))}isResourceEnabled(n){return this.storageService.getBoolean((0,y.getEnablementKey)(n),0,!0)}setResourceEnablement(n,f){if(this.isResourceEnabled(n)!==f){const m=(0,y.getEnablementKey)(n);this.telemetryService.publicLog2(m,{enabled:f}),this.storeResourceEnablement(m,f)}}getResourceSyncStateVersion(n){}storeResourceEnablement(n,f){this.storageService.store(n,f,0,R.isWeb?0:1)}onDidStorageChange(n){if(n.scope===0){const f=y.ALL_SYNC_RESOURCES.filter(m=>(0,y.getEnablementKey)(m)===n.key)[0];if(f){this._onDidChangeResourceEnablement.fire([f,this.isResourceEnabled(f)]);return}}}};p=de([Y(0,k.IStorageService),Y(1,A.ITelemetryService)],p),e.UserDataSyncResourceEnablementService=p}),define(Z[198],ee([0,1,21,2,4,3,187,190,189,44,24,19,20,192,14,193,30,8,11]),function(G,e,y,P,L,k,A,R,p,S,n,f,m,C,h,E,D,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncService=void 0;const g="sync.lastSyncTime";let a=class extends P.Disposable{constructor(i,o,c,l,u,v){super();this.userDataSyncStoreService=i,this.userDataSyncStoreManagementService=o,this.instantiationService=c,this.logService=l,this.telemetryService=u,this.storageService=v,this._status="uninitialized",this._onDidChangeStatus=this._register(new k.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new k.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._syncErrors=[],this._onSyncErrors=this._register(new k.Emitter),this.onSyncErrors=this._onSyncErrors.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new k.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onDidResetLocal=this._register(new k.Emitter),this.onDidResetLocal=this._onDidResetLocal.event,this._onDidResetRemote=this._register(new k.Emitter),this.onDidResetRemote=this._onDidResetRemote.event,this.recoveredSettings=!1,this.settingsSynchroniser=this._register(this.instantiationService.createInstance(C.SettingsSynchroniser)),this.keybindingsSynchroniser=this._register(this.instantiationService.createInstance(R.KeybindingsSynchroniser)),this.snippetsSynchroniser=this._register(this.instantiationService.createInstance(E.SnippetsSynchroniser)),this.globalStateSynchroniser=this._register(this.instantiationService.createInstance(p.GlobalStateSynchroniser)),this.extensionsSynchroniser=this._register(this.instantiationService.createInstance(A.ExtensionsSynchroniser)),this.synchronisers=[this.settingsSynchroniser,this.keybindingsSynchroniser,this.snippetsSynchroniser,this.globalStateSynchroniser,this.extensionsSynchroniser],this.updateStatus(),this.userDataSyncStoreManagementService.userDataSyncStore&&(this._register(k.Event.any(...this.synchronisers.map(w=>k.Event.map(w.onDidChangeStatus,()=>{})))(()=>this.updateStatus())),this._register(k.Event.any(...this.synchronisers.map(w=>k.Event.map(w.onDidChangeConflicts,()=>{})))(()=>this.updateConflicts()))),this._lastSyncTime=this.storageService.getNumber(g,0,void 0),this.onDidChangeLocal=k.Event.any(...this.synchronisers.map(w=>k.Event.map(w.onDidChangeLocal,()=>w.resource)))}get status(){return this._status}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}async createSyncTask(i){await this.checkEnablement();const o=(0,D.generateUuid)();let c;try{const w=(0,y.createSyncHeaders)(o);i&&(w["Cache-Control"]="no-cache"),c=await this.userDataSyncStoreService.manifest(w)}catch(w){const d=y.UserDataSyncError.toUserDataSyncError(w);throw this.reportUserDataSyncError(d,o),d}let l=!1;const u=this;let v;return{manifest:c,run(){if(l)throw new Error("Can run a task only once");return v=(0,b.createCancelablePromise)(w=>u.sync(c,o,w)),v.finally(()=>v=void 0)},async stop(){if(v&&v.cancel(),u.status!=="idle")return u.stop()}}}async createManualSyncTask(){await this.checkEnablement();const i=(0,D.generateUuid)(),o=(0,y.createSyncHeaders)(i);let c;try{c=await this.userDataSyncStoreService.manifest(o)}catch(l){const u=y.UserDataSyncError.toUserDataSyncError(l);throw this.reportUserDataSyncError(u,i),u}return new s(i,c,o,this.synchronisers,this.logService)}async sync(i,o,c){if(this.recoveredSettings||(await this.settingsSynchroniser.recoverSettings(),this.recoveredSettings=!0),c.isCancellationRequested)return;const l=new Date().getTime();this._syncErrors=[];try{this.logService.trace("Sync started."),this.status!=="hasConflicts"&&this.setStatus("syncing");const u=(0,y.createSyncHeaders)(o);for(const v of this.synchronisers){if(c.isCancellationRequested)return;try{await v.sync(i,u)}catch(w){if(w instanceof y.UserDataSyncError)switch(w.code){case y.UserDataSyncErrorCode.TooLarge:throw new y.UserDataSyncError(w.message,w.code,v.resource);case y.UserDataSyncErrorCode.TooManyRequests:case y.UserDataSyncErrorCode.TooManyRequestsAndRetryAfter:case y.UserDataSyncErrorCode.LocalTooManyRequests:case y.UserDataSyncErrorCode.Gone:case y.UserDataSyncErrorCode.UpgradeRequired:case y.UserDataSyncErrorCode.IncompatibleRemoteContent:case y.UserDataSyncErrorCode.IncompatibleLocalContent:throw w}const d=y.UserDataSyncError.toUserDataSyncError(w);this.reportUserDataSyncError(d,o),this.logService.error(w),this.logService.error(`${v.resource}: ${(0,S.toErrorMessage)(w)}`),this._syncErrors.push([v.resource,d])}}this.logService.info(`Sync done. Took ${new Date().getTime()-l}ms`),this.updateLastSyncTime()}catch(u){const v=y.UserDataSyncError.toUserDataSyncError(u);throw this.reportUserDataSyncError(v,o),v}finally{this.updateStatus(),this._onSyncErrors.fire(this._syncErrors)}}async stop(){if(this.status!=="idle")for(const i of this.synchronisers)try{i.status!=="idle"&&await i.stop()}catch(o){this.logService.error(o)}}async replace(i){await this.checkEnablement();for(const o of this.synchronisers)if(await o.replace(i))return}async accept(i,o,c,l){await this.checkEnablement();const u=this.getSynchroniser(i);await u.accept(o,c),l&&await u.apply(!1,(0,y.createSyncHeaders)((0,D.generateUuid)()))}async resolveContent(i){for(const o of this.synchronisers){const c=await o.resolveContent(i);if(c)return c}return null}getRemoteSyncResourceHandles(i){return this.getSynchroniser(i).getRemoteSyncResourceHandles()}getLocalSyncResourceHandles(i){return this.getSynchroniser(i).getLocalSyncResourceHandles()}getAssociatedResources(i,o){return this.getSynchroniser(i).getAssociatedResources(o)}getMachineId(i,o){return this.getSynchroniser(i).getMachineId(o)}async hasLocalData(){const i=[this.settingsSynchroniser,this.keybindingsSynchroniser,this.snippetsSynchroniser,this.extensionsSynchroniser];for(const o of i)if(await o.hasLocalData())return!0;return!1}async reset(){await this.checkEnablement(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){await this.checkEnablement();try{await this.userDataSyncStoreService.clear(),this.logService.info("Cleared data on server")}catch(i){this.logService.error(i)}this._onDidResetRemote.fire()}async resetLocal(){await this.checkEnablement(),this.storageService.remove(g,0);for(const i of this.synchronisers)try{await i.resetLocal()}catch(o){this.logService.error(`${i.resource}: ${(0,S.toErrorMessage)(o)}`),this.logService.error(o)}this._onDidResetLocal.fire(),this.logService.info("Did reset the local sync state.")}async hasPreviouslySynced(){for(const i of this.synchronisers)if(await i.hasPreviouslySynced())return!0;return!1}setStatus(i){const o=this._status;this._status!==i&&(this._status=i,this._onDidChangeStatus.fire(i),o==="hasConflicts"&&this.updateLastSyncTime())}updateStatus(){this.updateConflicts();const i=this.computeStatus();this.setStatus(i)}updateConflicts(){const i=this.computeConflicts();(0,f.equals)(this._conflicts,i,([o,c],[l,u])=>o===o&&(0,f.equals)(c,u,(v,w)=>(0,h.isEqual)(v.previewResource,w.previewResource)))||(this._conflicts=this.computeConflicts(),this._onDidChangeConflicts.fire(i))}computeStatus(){return this.userDataSyncStoreManagementService.userDataSyncStore?this.synchronisers.some(i=>i.status==="hasConflicts")?"hasConflicts":this.synchronisers.some(i=>i.status==="syncing")?"syncing":"idle":"uninitialized"}updateLastSyncTime(){this.status==="idle"&&(this._lastSyncTime=new Date().getTime(),this.storageService.store(g,this._lastSyncTime,0,1),this._onDidChangeLastSyncTime.fire(this._lastSyncTime))}reportUserDataSyncError(i,o){this.telemetryService.publicLog2("sync/error",{code:i.code,url:i instanceof y.UserDataSyncStoreError?i.url:void 0,resource:i.resource,executionId:o,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()})}computeConflicts(){return this.synchronisers.filter(i=>i.status==="hasConflicts").map(i=>[i.resource,i.conflicts.map(t)])}getSynchroniser(i){return this.synchronisers.find(o=>o.resource===i)}async checkEnablement(){if(!this.userDataSyncStoreManagementService.userDataSyncStore)throw new Error("Not enabled")}};a=de([Y(0,y.IUserDataSyncStoreService),Y(1,y.IUserDataSyncStoreManagementService),Y(2,L.IInstantiationService),Y(3,y.IUserDataSyncLogService),Y(4,n.ITelemetryService),Y(5,m.IStorageService)],a),e.UserDataSyncService=a;class s extends P.Disposable{constructor(i,o,c,l,u){super();this.id=i,this.manifest=o,this.syncHeaders=c,this.synchronisers=l,this.logService=u,this.synchronizingResources=[],this._onSynchronizeResources=this._register(new k.Emitter),this.onSynchronizeResources=this._onSynchronizeResources.event,this.isDisposed=!1}get status(){return this.synchronisers.some(i=>i.status==="hasConflicts")?"hasConflicts":this.synchronisers.some(i=>i.status==="syncing")?"syncing":"idle"}async preview(){try{if(this.isDisposed)throw new Error("Disposed");return this.previewsPromise||(this.previewsPromise=(0,b.createCancelablePromise)(i=>this.getPreviews(i))),this.previews||(this.previews=await this.previewsPromise),this.previews}catch(i){throw this.logService.error(i),i}}async accept(i,o){try{return await this.performAction(i,c=>c.accept(i,o))}catch(c){throw this.logService.error(c),c}}async merge(i){try{return i?await this.performAction(i,o=>o.merge(i)):await this.mergeAll()}catch(o){throw this.logService.error(o),o}}async discard(i){try{return await this.performAction(i,o=>o.discard(i))}catch(o){throw this.logService.error(o),o}}async discardConflicts(){try{if(!this.previews)throw new Error("Missing preview. Create preview and try again.");if(this.synchronizingResources.length)throw new Error("Cannot discard while synchronizing resources");const i=[];for(const[,o]of this.previews)for(const c of o.resourcePreviews)c.mergeState==="conflict"&&i.push(c.previewResource);for(const o of i)await this.discard(o);return this.previews}catch(i){throw this.logService.error(i),i}}async apply(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");const i=[];for(const[o,c]of this.previews){this.synchronizingResources.push([o,c.resourcePreviews.map(v=>v.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const l=this.synchronisers.find(v=>v.resource===o);for(const v of c.resourcePreviews)(v.localChange!==0||v.remoteChange!==0)&&v.mergeState==="preview"&&await l.merge(v.previewResource);const u=await l.apply(!1,this.syncHeaders);u&&i.push(this.toSyncResourcePreview(l.resource,u)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(v=>v[0]===o),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=i,this.previews}catch(i){throw this.logService.error(i),i}}async pull(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[i,o]of this.previews){this.synchronizingResources.push([i,o.resourcePreviews.map(l=>l.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const c=this.synchronisers.find(l=>l.resource===i);for(const l of o.resourcePreviews)await c.accept(l.remoteResource);await c.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(l=>l[0]===i),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(i){throw this.logService.error(i),i}}async push(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[i,o]of this.previews){this.synchronizingResources.push([i,o.resourcePreviews.map(l=>l.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const c=this.synchronisers.find(l=>l.resource===i);for(const l of o.resourcePreviews)await c.accept(l.localResource);await c.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(l=>l[0]===i),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(i){throw this.logService.error(i),i}}async stop(){for(const i of this.synchronisers)try{await i.stop()}catch(o){(0,I.isPromiseCanceledError)(o)||this.logService.error(o)}this.reset()}async performAction(i,o){if(!this.previews)throw new Error("Missing preview. Create preview and try again.");const c=this.previews.findIndex(([,z])=>z.resourcePreviews.some(({localResource:B,previewResource:K,remoteResource:j})=>(0,h.isEqual)(i,B)||(0,h.isEqual)(i,K)||(0,h.isEqual)(i,j)));if(c===-1)return this.previews;const[l,u]=this.previews[c],v=u.resourcePreviews.find(({localResource:z,remoteResource:B,previewResource:K})=>(0,h.isEqual)(z,i)||(0,h.isEqual)(B,i)||(0,h.isEqual)(K,i));if(!v)return this.previews;let w=this.synchronizingResources.find(z=>z[0]===l);w||(w=[l,[]],this.synchronizingResources.push(w)),w[1].some(z=>(0,h.isEqual)(z,v.localResource))||(w[1].push(v.localResource),this._onSynchronizeResources.fire(this.synchronizingResources));const d=this.synchronisers.find(z=>z.resource===this.previews[c][0]),T=await o(d);T?this.previews.splice(c,1,this.toSyncResourcePreview(d.resource,T)):this.previews.splice(c,1);const F=this.synchronizingResources.findIndex(z=>z[0]===l);return this.synchronizingResources[F][1].splice(w[1].findIndex(z=>(0,h.isEqual)(z,v.localResource)),1),w[1].length||(this.synchronizingResources.splice(F,1),this._onSynchronizeResources.fire(this.synchronizingResources)),this.previews}async mergeAll(){if(!this.previews)throw new Error("You need to create preview before merging or applying");if(this.synchronizingResources.length)throw new Error("Cannot merge or apply while synchronizing resources");const i=[];for(const[o,c]of this.previews){this.synchronizingResources.push([o,c.resourcePreviews.map(v=>v.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const l=this.synchronisers.find(v=>v.resource===o);let u=c;for(const v of c.resourcePreviews)(v.localChange!==0||v.remoteChange!==0)&&v.mergeState==="preview"&&(u=await l.merge(v.previewResource));u&&i.push(this.toSyncResourcePreview(l.resource,u)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(v=>v[0]===o),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=i,this.previews}async getPreviews(i){const o=[];for(const c of this.synchronisers){if(i.isCancellationRequested)return[];const l=await c.preview(this.manifest,this.syncHeaders);l&&o.push(this.toSyncResourcePreview(c.resource,l))}return o}toSyncResourcePreview(i,o){return[i,{isLastSyncFromCurrentMachine:o.isLastSyncFromCurrentMachine,resourcePreviews:o.resourcePreviews.map(t)}]}reset(){this.previewsPromise&&(this.previewsPromise.cancel(),this.previewsPromise=void 0),this.previews=void 0,this.synchronizingResources=[]}dispose(){this.reset(),this.isDisposed=!0}}function t(r){return{localResource:r.localResource,previewResource:r.previewResource,remoteResource:r.remoteResource,acceptedResource:r.acceptedResource,localChange:r.localChange,remoteChange:r.remoteChange,mergeState:r.mergeState}}}),define(Z[199],ee([0,1,3,21,5,2,15]),function(G,e,y,P,L,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncChannelClient=e.UserDataSyncChannel=void 0;class R{constructor(f,m){this.service=f,this.logService=m,this.manualSyncTasks=new Map,this.onManualSynchronizeResources=new y.Emitter}listen(f,m){switch(m){case"onDidChangeStatus":return this.service.onDidChangeStatus;case"onDidChangeConflicts":return this.service.onDidChangeConflicts;case"onDidChangeLocal":return this.service.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.service.onDidChangeLastSyncTime;case"onSyncErrors":return this.service.onSyncErrors;case"onDidResetLocal":return this.service.onDidResetLocal;case"onDidResetRemote":return this.service.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.onManualSynchronizeResources.event}throw new Error(`Event not found: ${m}`)}async call(f,m,C){try{return await this._call(f,m,C)}catch(h){throw this.logService.error(h),h}}async _call(f,m,C){switch(m){case"_getInitialData":return Promise.resolve([this.service.status,this.service.conflicts,this.service.lastSyncTime]);case"replace":return this.service.replace(L.URI.revive(C[0]));case"reset":return this.service.reset();case"resetRemote":return this.service.resetRemote();case"resetLocal":return this.service.resetLocal();case"hasPreviouslySynced":return this.service.hasPreviouslySynced();case"hasLocalData":return this.service.hasLocalData();case"accept":return this.service.accept(C[0],L.URI.revive(C[1]),C[2],C[3]);case"resolveContent":return this.service.resolveContent(L.URI.revive(C[0]));case"getLocalSyncResourceHandles":return this.service.getLocalSyncResourceHandles(C[0]);case"getRemoteSyncResourceHandles":return this.service.getRemoteSyncResourceHandles(C[0]);case"getAssociatedResources":return this.service.getAssociatedResources(C[0],{created:C[1].created,uri:L.URI.revive(C[1].uri)});case"getMachineId":return this.service.getMachineId(C[0],{created:C[1].created,uri:L.URI.revive(C[1].uri)});case"createManualSyncTask":return this.createManualSyncTask()}if(m.startsWith("manualSync/")){const h=m.substring("manualSync/".length),E=C[0],D=this.getManualSyncTask(E);switch(C=C.slice(1),h){case"preview":return D.preview();case"accept":return D.accept(L.URI.revive(C[0]),C[1]);case"merge":return D.merge(L.URI.revive(C[0]));case"discard":return D.discard(L.URI.revive(C[0]));case"discardConflicts":return D.discardConflicts();case"apply":return D.apply();case"pull":return D.pull();case"push":return D.push();case"stop":return D.stop();case"_getStatus":return D.status;case"dispose":return this.disposeManualSyncTask(D)}}throw new Error("Invalid call")}getManualSyncTask(f){const m=this.manualSyncTasks.get(this.createKey(f));if(!m)throw new Error(`Manual sync taks not found: ${f}`);return m.manualSyncTask}async createManualSyncTask(){const f=new k.DisposableStore,m=f.add(await this.service.createManualSyncTask());return f.add(m.onSynchronizeResources(C=>this.onManualSynchronizeResources.fire({manualSyncTaskId:m.id,data:C}))),this.manualSyncTasks.set(this.createKey(m.id),{manualSyncTask:m,disposables:f}),{id:m.id,manifest:m.manifest,status:m.status}}disposeManualSyncTask(f){var m;f.dispose();const C=this.createKey(f.id);(m=this.manualSyncTasks.get(C))===null||m===void 0||m.disposables.dispose(),this.manualSyncTasks.delete(C)}createKey(f){return`manualSyncTask-${f}`}}e.UserDataSyncChannel=R;class p extends k.Disposable{constructor(f){super();this._status="uninitialized",this._onDidChangeStatus=this._register(new y.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new y.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new y.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onSyncErrors=this._register(new y.Emitter),this.onSyncErrors=this._onSyncErrors.event,this.channel={call(m,C,h){return f.call(m,C,h).then(null,E=>{throw P.UserDataSyncError.toUserDataSyncError(E)})},listen(m,C){return f.listen(m,C)}},this.channel.call("_getInitialData").then(([m,C,h])=>{this.updateStatus(m),this.updateConflicts(C),h&&this.updateLastSyncTime(h),this._register(this.channel.listen("onDidChangeStatus")(E=>this.updateStatus(E))),this._register(this.channel.listen("onDidChangeLastSyncTime")(E=>this.updateLastSyncTime(E)))}),this._register(this.channel.listen("onDidChangeConflicts")(m=>this.updateConflicts(m))),this._register(this.channel.listen("onSyncErrors")(m=>this._onSyncErrors.fire(m.map(([C,h])=>[C,P.UserDataSyncError.toUserDataSyncError(h)]))))}get status(){return this._status}get onDidChangeLocal(){return this.channel.listen("onDidChangeLocal")}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}get onDidResetLocal(){return this.channel.listen("onDidResetLocal")}get onDidResetRemote(){return this.channel.listen("onDidResetRemote")}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const{id:f,manifest:m,status:C}=await this.channel.call("createManualSyncTask"),h=this,E=new S(f,m,C,{async call(D,b,I){return h.channel.call(`manualSync/${D}`,[f,...(0,A.isArray)(b)?b:[b]],I)},listen(D,b){return y.Event.map(y.Event.filter(h.channel.listen(`manualSync/${D}`,b),I=>!E.isDiposed()&&I.manualSyncTaskId===f),I=>I.data)}});return E}replace(f){return this.channel.call("replace",[f])}reset(){return this.channel.call("reset")}resetRemote(){return this.channel.call("resetRemote")}resetLocal(){return this.channel.call("resetLocal")}hasPreviouslySynced(){return this.channel.call("hasPreviouslySynced")}hasLocalData(){return this.channel.call("hasLocalData")}accept(f,m,C,h){return this.channel.call("accept",[f,m,C,h])}resolveContent(f){return this.channel.call("resolveContent",[f])}async getLocalSyncResourceHandles(f){return(await this.channel.call("getLocalSyncResourceHandles",[f])).map(({created:C,uri:h})=>({created:C,uri:L.URI.revive(h)}))}async getRemoteSyncResourceHandles(f){return(await this.channel.call("getRemoteSyncResourceHandles",[f])).map(({created:C,uri:h})=>({created:C,uri:L.URI.revive(h)}))}async getAssociatedResources(f,m){return(await this.channel.call("getAssociatedResources",[f,m])).map(({resource:h,comparableResource:E})=>({resource:L.URI.revive(h),comparableResource:L.URI.revive(E)}))}async getMachineId(f,m){return this.channel.call("getMachineId",[f,m])}async updateStatus(f){this._status=f,this._onDidChangeStatus.fire(f)}async updateConflicts(f){this._conflicts=f.map(([m,C])=>[m,C.map(h=>Object.assign(Object.assign({},h),{localResource:L.URI.revive(h.localResource),remoteResource:L.URI.revive(h.remoteResource),previewResource:L.URI.revive(h.previewResource)}))]),this._onDidChangeConflicts.fire(this._conflicts)}updateLastSyncTime(f){this._lastSyncTime!==f&&(this._lastSyncTime=f,this._onDidChangeLastSyncTime.fire(f))}}e.UserDataSyncChannelClient=p;class S extends k.Disposable{constructor(f,m,C,h){super();this.id=f,this.manifest=m,this._disposed=!1,this._status=C;const E=this;this.channel={async call(D,b,I){try{const g=await h.call(D,b,I);return E.isDiposed()||(E._status=await h.call("_getStatus")),g}catch(g){throw P.UserDataSyncError.toUserDataSyncError(g)}},listen(D,b){return h.listen(D,b)}}}get onSynchronizeResources(){return this.channel.listen("onSynchronizeResources")}get status(){return this._status}async preview(){const f=await this.channel.call("preview");return this.deserializePreviews(f)}async accept(f,m){const C=await this.channel.call("accept",[f,m]);return this.deserializePreviews(C)}async merge(f){const m=await this.channel.call("merge",[f]);return this.deserializePreviews(m)}async discard(f){const m=await this.channel.call("discard",[f]);return this.deserializePreviews(m)}async discardConflicts(){const f=await this.channel.call("discardConflicts");return this.deserializePreviews(f)}async apply(){const f=await this.channel.call("apply");return this.deserializePreviews(f)}pull(){return this.channel.call("pull")}push(){return this.channel.call("push")}stop(){return this.channel.call("stop")}isDiposed(){return this._disposed}dispose(){this._disposed=!0,this.channel.call("dispose")}deserializePreviews(f){return f.map(([m,C])=>[m,{isLastSyncFromCurrentMachine:C.isLastSyncFromCurrentMachine,resourcePreviews:C.resourcePreviews.map(h=>Object.assign(Object.assign({},h),{localResource:L.URI.revive(h.localResource),remoteResource:L.URI.revive(h.remoteResource),previewResource:L.URI.revive(h.previewResource),acceptedResource:L.URI.revive(h.acceptedResource)}))}])}}}),define(Z[200],ee([0,1,2,21,39,14,29,23,27,45,9,10,20,30,6,3,8,15,5,11]),function(G,e,y,P,L,k,A,R,p,S,n,f,m,C,h,E,D,b,I,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestsSession=e.UserDataSyncStoreService=e.UserDataSyncStoreClient=e.UserDataSyncStoreManagementService=e.AbstractUserDataSyncStoreManagementService=void 0;const a="sync.previous.store",s="sync.donot-make-requests-until",t="sync.user-session-id",r="sync.machine-session-id",i=100,o=1e3*60*5;let c=class extends y.Disposable{constructor(T,F,z){super();this.productService=T,this.configurationService=F,this.storageService=z,this._onDidChangeUserDataSyncStore=this._register(new E.Emitter),this.onDidChangeUserDataSyncStore=this._onDidChangeUserDataSyncStore.event,this.updateUserDataSyncStore(),this._register(E.Event.filter(z.onDidChangeValue,B=>{var K;return B.key===P.SYNC_SERVICE_URL_TYPE&&B.scope===0&&this.userDataSyncStoreType!==((K=this.userDataSyncStore)===null||K===void 0?void 0:K.type)})(()=>this.updateUserDataSyncStore()))}get userDataSyncStore(){return this._userDataSyncStore}get userDataSyncStoreType(){return this.storageService.get(P.SYNC_SERVICE_URL_TYPE,0)}set userDataSyncStoreType(T){this.storageService.store(P.SYNC_SERVICE_URL_TYPE,T,0,h.isWeb?0:1)}updateUserDataSyncStore(){this._userDataSyncStore=this.toUserDataSyncStore(this.productService[P.CONFIGURATION_SYNC_STORE_KEY],this.configurationService.getValue(P.CONFIGURATION_SYNC_STORE_KEY)),this._onDidChangeUserDataSyncStore.fire()}toUserDataSyncStore(T,F){T=h.isWeb&&(T==null?void 0:T.web)?Object.assign(Object.assign({},T),T.web):T;const z=Object.assign(Object.assign({},T||{}),F||{});if(z&&(0,b.isString)(z.url)&&(0,b.isObject)(z.authenticationProviders)&&Object.keys(z.authenticationProviders).every(B=>(0,b.isArray)(z.authenticationProviders[B].scopes))){const B=z,K=!!B.canSwitch&&!(F==null?void 0:F.url),j=B.url===B.insidersUrl?"insiders":"stable",H=(K?this.userDataSyncStoreType:void 0)||j,q=(F==null?void 0:F.url)||(H==="insiders"?B.insidersUrl:H==="stable"?B.stableUrl:B.url);return{url:I.URI.parse(q),type:H,defaultType:j,defaultUrl:I.URI.parse(B.url),stableUrl:I.URI.parse(B.stableUrl),insidersUrl:I.URI.parse(B.insidersUrl),canSwitch:K,authenticationProviders:Object.keys(B.authenticationProviders).reduce(($,M)=>($.push({id:M,scopes:B.authenticationProviders[M].scopes}),$),[])}}}};c=de([Y(0,p.IProductService),Y(1,R.IConfigurationService),Y(2,m.IStorageService)],c),e.AbstractUserDataSyncStoreManagementService=c;let l=class extends c{constructor(T,F,z){super(T,F,z);const B=this.storageService.get(a,0);B&&(this.previousConfigurationSyncStore=JSON.parse(B));const K=this.productService[P.CONFIGURATION_SYNC_STORE_KEY];K?this.storageService.store(a,JSON.stringify(K),0,1):this.storageService.remove(a,0)}async switch(T){T!==this.userDataSyncStoreType&&(this.userDataSyncStoreType=T,this.updateUserDataSyncStore())}async getPreviousUserDataSyncStore(){return this.toUserDataSyncStore(this.previousConfigurationSyncStore)}};l=de([Y(0,p.IProductService),Y(1,R.IConfigurationService),Y(2,m.IStorageService)],l),e.UserDataSyncStoreManagementService=l;let u=class extends y.Disposable{constructor(T,F,z,B,K,j,H){super();this.requestService=z,this.logService=B,this.storageService=H,this._onTokenFailed=this._register(new E.Emitter),this.onTokenFailed=this._onTokenFailed.event,this._onTokenSucceed=this._register(new E.Emitter),this.onTokenSucceed=this._onTokenSucceed.event,this._donotMakeRequestsUntil=void 0,this._onDidChangeDonotMakeRequestsUntil=this._register(new E.Emitter),this.onDidChangeDonotMakeRequestsUntil=this._onDidChangeDonotMakeRequestsUntil.event,this.resetDonotMakeRequestsUntilPromise=void 0,this.updateUserDataSyncStoreUrl(T),this.commonHeadersPromise=(0,S.getServiceMachineId)(K,j,H).then(q=>{const $={"X-Client-Name":`${F.applicationName}${h.isWeb?"-web":""}`,"X-Client-Version":F.version,"X-Machine-Id":q};return F.commit&&($["X-Client-Commit"]=F.commit),$}),this.session=new w(i,o,this.requestService,this.logService),this.initDonotMakeRequestsUntil(),this._register((0,y.toDisposable)(()=>{this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0)}))}get donotMakeRequestsUntil(){return this._donotMakeRequestsUntil}setAuthToken(T,F){this.authToken={token:T,type:F}}updateUserDataSyncStoreUrl(T){this.userDataSyncStoreUrl=T?(0,k.joinPath)(T,"v1"):void 0}initDonotMakeRequestsUntil(){const T=this.storageService.getNumber(s,0);T&&Date.now()<T&&this.setDonotMakeRequestsUntil(new Date(T))}setDonotMakeRequestsUntil(T){var F;((F=this._donotMakeRequestsUntil)===null||F===void 0?void 0:F.getTime())!==(T==null?void 0:T.getTime())&&(this._donotMakeRequestsUntil=T,this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0),this._donotMakeRequestsUntil?(this.storageService.store(s,this._donotMakeRequestsUntil.getTime(),0,1),this.resetDonotMakeRequestsUntilPromise=(0,D.createCancelablePromise)(z=>(0,D.timeout)(this._donotMakeRequestsUntil.getTime()-Date.now(),z).then(()=>this.setDonotMakeRequestsUntil(void 0))),this.resetDonotMakeRequestsUntilPromise.then(null,z=>null)):this.storageService.remove(s,0),this._onDidChangeDonotMakeRequestsUntil.fire())}async getAllRefs(T){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const F=(0,k.joinPath)(this.userDataSyncStoreUrl,"resource",T),z={},B=await this.request(F.toString(),{type:"GET",headers:z},[],A.CancellationToken.None);return(await(0,L.asJson)(B)||[]).map(({url:j,created:H})=>({ref:(0,k.relativePath)(F,F.with({path:j})),created:H*1e3}))}async resolveContent(T,F){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const z=(0,k.joinPath)(this.userDataSyncStoreUrl,"resource",T,F).toString(),B={};B["Cache-Control"]="no-cache";const K=await this.request(z,{type:"GET",headers:B},[],A.CancellationToken.None);return await(0,L.asText)(K)}async delete(T){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const F=(0,k.joinPath)(this.userDataSyncStoreUrl,"resource",T).toString(),z={};await this.request(F,{type:"DELETE",headers:z},[],A.CancellationToken.None)}async read(T,F,z={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const B=(0,k.joinPath)(this.userDataSyncStoreUrl,"resource",T,"latest").toString();z=Object.assign({},z),z["Cache-Control"]="no-cache",F&&(z["If-None-Match"]=F.ref);const K=await this.request(B,{type:"GET",headers:z},[304],A.CancellationToken.None);if(K.res.statusCode===304)return F;const j=K.res.headers.etag;if(!j)throw new P.UserDataSyncStoreError("Server did not return the ref",B,P.UserDataSyncErrorCode.NoRef,K.res.headers[P.HEADER_OPERATION_ID]);const H=await(0,L.asText)(K);return{ref:j,content:H}}async write(T,F,z,B={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const K=(0,k.joinPath)(this.userDataSyncStoreUrl,"resource",T).toString();B=Object.assign({},B),B["Content-Type"]="text/plain",z&&(B["If-Match"]=z);const j=await this.request(K,{type:"POST",data:F,headers:B},[],A.CancellationToken.None),H=j.res.headers.etag;if(!H)throw new P.UserDataSyncStoreError("Server did not return the ref",K,P.UserDataSyncErrorCode.NoRef,j.res.headers[P.HEADER_OPERATION_ID]);return H}async manifest(T={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const F=(0,k.joinPath)(this.userDataSyncStoreUrl,"manifest").toString();T=Object.assign({},T),T["Content-Type"]="application/json";const z=await this.request(F,{type:"GET",headers:T},[],A.CancellationToken.None),B=await(0,L.asJson)(z),K=this.storageService.get(t,0);return K&&B&&K!==B.session&&this.clearSession(),B===null&&K&&this.clearSession(),B&&this.storageService.store(t,B.session,0,1),B}async clear(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const T=(0,k.joinPath)(this.userDataSyncStoreUrl,"resource").toString(),F={"Content-Type":"text/plain"};await this.request(T,{type:"DELETE",headers:F},[],A.CancellationToken.None),this.clearSession()}clearSession(){this.storageService.remove(t,0),this.storageService.remove(r,0)}async request(T,F,z,B){if(!this.authToken)throw new P.UserDataSyncStoreError("No Auth Token Available",T,P.UserDataSyncErrorCode.Unauthorized,void 0);if(this._donotMakeRequestsUntil&&Date.now()<this._donotMakeRequestsUntil.getTime())throw new P.UserDataSyncStoreError(`${F.type} request '${T}' failed because of too many requests (429).`,T,P.UserDataSyncErrorCode.TooManyRequestsAndRetryAfter,void 0);this.setDonotMakeRequestsUntil(void 0);const K=await this.commonHeadersPromise;F.headers=Object.assign(Object.assign(Object.assign({},F.headers||{}),K),{"X-Account-Type":this.authToken.type,authorization:`Bearer ${this.authToken.token}`}),this.addSessionHeaders(F.headers),this.logService.trace("Sending request to server",{url:T,type:F.type,headers:Object.assign(Object.assign({},F.headers),{authorization:void 0})});let j;try{j=await this.session.request(T,F,B)}catch(M){if(!(M instanceof P.UserDataSyncStoreError)){const U=(0,g.isPromiseCanceledError)(M)?P.UserDataSyncErrorCode.RequestCanceled:(0,g.getErrorMessage)(M).startsWith("XHR timeout")?P.UserDataSyncErrorCode.RequestTimeout:P.UserDataSyncErrorCode.RequestFailed;M=new P.UserDataSyncStoreError(`Connection refused for the request '${T}'.`,T,U,void 0)}throw this.logService.info("Request failed",T),M}const H=j.res.headers[P.HEADER_OPERATION_ID],q={url:T,status:j.res.statusCode,"execution-id":F.headers[P.HEADER_EXECUTION_ID],"operation-id":H},$=(0,L.isSuccess)(j)||j.res.statusCode&&z.indexOf(j.res.statusCode)!==-1;if($?this.logService.trace("Request succeeded",q):this.logService.info("Request failed",q),j.res.statusCode===401)throw this.authToken=void 0,this._onTokenFailed.fire(),new P.UserDataSyncStoreError(`Request '${T}' failed because of Unauthorized (401).`,T,P.UserDataSyncErrorCode.Unauthorized,H);if(this._onTokenSucceed.fire(),j.res.statusCode===409)throw new P.UserDataSyncStoreError(`${F.type} request '${T}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,T,P.UserDataSyncErrorCode.Conflict,H);if(j.res.statusCode===410)throw new P.UserDataSyncStoreError(`${F.type} request '${T}' failed because the requested resource is not longer available (410).`,T,P.UserDataSyncErrorCode.Gone,H);if(j.res.statusCode===412)throw new P.UserDataSyncStoreError(`${F.type} request '${T}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,T,P.UserDataSyncErrorCode.PreconditionFailed,H);if(j.res.statusCode===413)throw new P.UserDataSyncStoreError(`${F.type} request '${T}' failed because of too large payload (413).`,T,P.UserDataSyncErrorCode.TooLarge,H);if(j.res.statusCode===426)throw new P.UserDataSyncStoreError(`${F.type} request '${T}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,T,P.UserDataSyncErrorCode.UpgradeRequired,H);if(j.res.statusCode===429){const M=j.res.headers["retry-after"];throw M?(this.setDonotMakeRequestsUntil(new Date(Date.now()+parseInt(M)*1e3)),new P.UserDataSyncStoreError(`${F.type} request '${T}' failed because of too many requests (429).`,T,P.UserDataSyncErrorCode.TooManyRequestsAndRetryAfter,H)):new P.UserDataSyncStoreError(`${F.type} request '${T}' failed because of too many requests (429).`,T,P.UserDataSyncErrorCode.TooManyRequests,H)}if(!$)throw new P.UserDataSyncStoreError("Server returned "+j.res.statusCode,T,P.UserDataSyncErrorCode.Unknown,H);return j}addSessionHeaders(T){let F=this.storageService.get(r,0);F===void 0&&(F=(0,C.generateUuid)(),this.storageService.store(r,F,0,1)),T["X-Machine-Session-Id"]=F;const z=this.storageService.get(t,0);z!==void 0&&(T["X-User-Session-Id"]=z)}};u=de([Y(1,p.IProductService),Y(2,L.IRequestService),Y(3,P.IUserDataSyncLogService),Y(4,n.IEnvironmentService),Y(5,f.IFileService),Y(6,m.IStorageService)],u),e.UserDataSyncStoreClient=u;let v=class extends u{constructor(T,F,z,B,K,j,H){var q;super((q=T.userDataSyncStore)===null||q===void 0?void 0:q.url,F,z,B,K,j,H);this._register(T.onDidChangeUserDataSyncStore(()=>{var $;return this.updateUserDataSyncStoreUrl(($=T.userDataSyncStore)===null||$===void 0?void 0:$.url)}))}};v=de([Y(0,P.IUserDataSyncStoreManagementService),Y(1,p.IProductService),Y(2,L.IRequestService),Y(3,P.IUserDataSyncLogService),Y(4,n.IEnvironmentService),Y(5,f.IFileService),Y(6,m.IStorageService)],v),e.UserDataSyncStoreService=v;class w{constructor(T,F,z,B){this.limit=T,this.interval=F,this.requestService=z,this.logService=B,this.requests=[],this.startTime=void 0}request(T,F,z){if(this.isExpired()&&this.reset(),F.url=T,this.requests.length>=this.limit)throw this.logService.info("Too many requests",...this.requests),new P.UserDataSyncStoreError(`Too many requests. Only ${this.limit} requests allowed in ${this.interval/(1e3*60)} minutes.`,T,P.UserDataSyncErrorCode.LocalTooManyRequests,void 0);return this.startTime=this.startTime||new Date,this.requests.push(T),this.requestService.request(F,z)}isExpired(){return this.startTime!==void 0&&new Date().getTime()-this.startTime.getTime()>this.interval}reset(){this.requests=[],this.startTime=void 0}}e.RequestsSession=w}),define(Z[201],ee([0,1,21,3,58,85,60,24,20,61,27]),function(G,e,y,P,L,k,A,R,p,S,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;let f=class extends k.UserDataAutoSyncService{constructor(C,h,E,D,b,I,g,a,s,t,r,i){super(C,h,E,D,b,g,a,s,t,r,i);this._register(P.Event.debounce(P.Event.any(P.Event.map(I.onDidFocusWindow,()=>"windowFocus"),P.Event.map(I.onDidOpenWindow,()=>"windowOpen")),(o,c)=>o?[...o,c]:[c],1e3)(o=>this.triggerSync(o,!0,!1)))}};f=de([Y(0,n.IProductService),Y(1,y.IUserDataSyncStoreManagementService),Y(2,y.IUserDataSyncStoreService),Y(3,y.IUserDataSyncResourceEnablementService),Y(4,y.IUserDataSyncService),Y(5,L.INativeHostService),Y(6,y.IUserDataSyncLogService),Y(7,A.IUserDataSyncAccountService),Y(8,R.ITelemetryService),Y(9,S.IUserDataSyncMachinesService),Y(10,p.IStorageService),Y(11,y.IUserDataAutoSyncEnablementService)],f),e.UserDataAutoSyncService=f}),define(Z[202],ee([0,1,3,2,8]),function(G,e,y,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class k extends P.Disposable{constructor({onDidOpenWindow:R,onDidFocusWindow:p,getActiveWindowId:S}){super();this.disposables=this._register(new P.DisposableStore),y.Event.latch(y.Event.any(R,p))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,L.createCancelablePromise)(()=>S()),(async()=>{try{const f=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:f}catch(f){}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(R){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=R}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=k}),define(Z[62],ee([0,1,106,7,42,8,17,209,210,15]),function(G,e,y,P,L,k,A,R,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class n extends Error{constructor(t,r){let i=r.message;switch(t){case"CorruptZip":i=`Corrupt ZIP: ${i}`;break}super(i);this.type=t,this.cause=r}}e.ExtractError=n;function f(s){const t=s.externalFileAttributes>>16||33188;return[448,56,7].map(r=>t&r).reduce((r,i)=>r+i,t&61440)}function m(s){if(s instanceof n)return s;let t;return/end of central directory record signature not found/.test(s.message)&&(t="CorruptZip"),new n(t,s)}function C(s,t,r,i,o,c){const l=P.dirname(t),u=P.join(i,l);if(!u.startsWith(i))return Promise.reject(new Error(y.localize(0,null,t)));const v=P.join(i,t);let w;return c.onCancellationRequested(()=>{w&&w.destroy()}),Promise.resolve(A.Promises.mkdir(u,{recursive:!0})).then(()=>new Promise((d,T)=>{if(!c.isCancellationRequested)try{w=(0,L.createWriteStream)(v,{mode:r}),w.once("close",()=>d()),w.once("error",T),s.once("error",T),s.pipe(w)}catch(F){T(F)}}))}function h(s,t,r,i){let o=(0,k.createCancelablePromise)(()=>Promise.resolve()),c=0;return i.onCancellationRequested(()=>{o.cancel(),s.close()}),new Promise((l,u)=>{const v=new k.Sequencer,w=d=>{d.isCancellationRequested||(c++,s.readEntry())};s.once("error",u),s.once("close",()=>o.then(()=>{i.isCancellationRequested||s.entryCount===c?l():u(new n("Incomplete",new Error(y.localize(1,null,c,s.entryCount))))},u)),s.readEntry(),s.on("entry",d=>{if(i.isCancellationRequested)return;if(!r.sourcePathRegex.test(d.fileName)){w(i);return}const T=d.fileName.replace(r.sourcePathRegex,"");if(/\/$/.test(T)){const B=P.join(t,T);o=(0,k.createCancelablePromise)(K=>A.Promises.mkdir(B,{recursive:!0}).then(()=>w(K)).then(void 0,u));return}const F=D(s,d),z=f(d);o=(0,k.createCancelablePromise)(B=>v.queue(()=>F.then(K=>C(K,T,z,t,r,B).then(()=>w(B)))).then(null,u))})})}function E(s,t=!1){return new Promise((r,i)=>{(0,R.open)(s,t?{lazyEntries:!0}:void 0,(o,c)=>{o?i(m(o)):r((0,S.assertIsDefined)(c))})})}function D(s,t){return new Promise((r,i)=>{s.openReadStream(t,(o,c)=>{o?i(m(o)):r((0,S.assertIsDefined)(c))})})}function b(s,t){return new Promise((r,i)=>{const o=new p.ZipFile;t.forEach(l=>{l.contents?o.addBuffer(typeof l.contents=="string"?Buffer.from(l.contents,"utf8"):l.contents,l.path):l.localPath&&o.addFile(l.localPath,l.path)}),o.end();const c=(0,L.createWriteStream)(s);o.outputStream.pipe(c),o.outputStream.once("error",i),c.once("error",i),c.once("finish",()=>r(s))})}e.zip=b;function I(s,t,r={},i){const o=new RegExp(r.sourcePath?`^${r.sourcePath}`:"");let c=E(s,!0);return r.overwrite&&(c=c.then(l=>(0,A.rimraf)(t).then(()=>l))),c.then(l=>h(l,t,{sourcePathRegex:o},i))}e.extract=I;function g(s,t){return E(s).then(r=>new Promise((i,o)=>{r.on("entry",c=>{c.fileName===t&&D(r,c).then(l=>i(l),l=>o(l))}),r.once("close",()=>o(new Error(y.localize(2,null,t))))}))}function a(s,t){return g(s,t).then(r=>new Promise((i,o)=>{const c=[];r.once("error",o),r.on("data",l=>c.push(l)),r.on("end",()=>i(Buffer.concat(c)))}))}e.buffer=a}),define(Z[203],ee([0,1,62,111]),function(G,e,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function L(k){return(0,y.buffer)(k,"extension/package.json").then(A=>{try{return JSON.parse(A.toString("utf8"))}catch(R){throw new Error((0,P.localize)(0,null))}})}e.getManifest=L}),define(Z[204],ee([0,1,57,2,17,7,18,28,33,8,5,9,132,112,27,62,6,19,16,10,14,30,11]),function(G,e,y,P,L,k,A,R,p,S,n,f,m,C,h,E,D,b,I,g,a,s,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScanner=void 0;const r="scanningSystem",i="scanningUser",o="extracting",c="deleting",l="renaming";let u=class extends P.Disposable{constructor(w,d,T,F,z){super();this.beforeRemovingExtension=w,this.fileService=d,this.logService=T,this.environmentService=F,this.productService=z,this._devSystemExtensionsPath=null,this.systemExtensionsPath=F.builtinExtensionsPath,this.extensionsPath=F.extensionsPath,this.uninstalledPath=k.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new S.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(w){const d=[];(w===null||w===0)&&d.push(this.scanSystemExtensions().then(null,T=>Promise.reject(new R.ExtensionManagementError(this.joinErrors(T).message,r)))),(w===null||w===1)&&d.push(this.scanUserExtensions(!0).then(null,T=>Promise.reject(new R.ExtensionManagementError(this.joinErrors(T).message,i))));try{const T=await Promise.all(d);return(0,b.flatten)(T)}catch(T){throw this.joinErrors(T)}}async scanUserExtensions(w){this.logService.trace("Started scanning user extensions");let[d,T]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);return T=T.filter(F=>!d[new p.ExtensionIdentifierWithVersion(F.identifier,F.manifest.version).key()]),w&&(T=(0,p.groupByExtension)(T,z=>z.identifier).map(z=>z.sort((B,K)=>y.rcompare(B.manifest.version,K.manifest.version))[0])),this.logService.trace("Scanned user extensions:",T.length),T}async scanAllUserExtensions(){return this.scanExtensionsInDir(this.extensionsPath,1)}async extractUserExtension(w,d,T){const F=w.key(),z=k.join(this.extensionsPath,`.${(0,s.generateUuid)()}`),B=k.join(this.extensionsPath,F);try{await L.rimraf(B)}catch(j){try{await L.rimraf(B)}catch(H){}throw new R.ExtensionManagementError((0,C.localize)(0,null,B,w.id),c)}await this.extractAtLocation(w,d,z,T);let K=await this.scanExtension(n.URI.file(z),1);if(!K)throw new Error((0,C.localize)(1,null,z));await this.storeMetadata(K,{installedTimestamp:Date.now()});try{await this.rename(w,z,B,Date.now()+2*60*1e3),this.logService.info("Renamed to",B)}catch(j){try{await L.rimraf(z)}catch(H){}if(j.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",w.id);else throw this.logService.info(`Rename failed because of ${(0,t.getErrorMessage)(j)}. Deleted from extracted location`,z),j}try{K=await this.scanExtension(n.URI.file(B),1)}catch(j){}if(K)return K;throw new Error((0,C.localize)(2,null,this.extensionsPath))}async saveMetadataForLocalExtension(w,d){return this.setMetadata(w,d),await this.storeMetadata(w,Object.assign(Object.assign({},d),{installedTimestamp:w.installedTimestamp})),w}async storeMetadata(w,d){d.isMachineScoped=d.isMachineScoped||void 0,d.isBuiltin=d.isBuiltin||void 0,d.installedTimestamp=d.installedTimestamp||void 0;const T=k.join(w.location.fsPath,"package.json"),F=await L.Promises.readFile(T,"utf8"),{manifest:z}=await this.parseManifest(F);return z.__metadata=d,await L.writeFile(T,JSON.stringify(z,null,"	")),w}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...w){const d=w.map(T=>new p.ExtensionIdentifierWithVersion(T.identifier,T.manifest.version));await this.withUninstalledExtensions(T=>{d.forEach(F=>T[F.key()]=!0)})}async setInstalled(w){await this.withUninstalledExtensions(F=>delete F[w.key()]);const T=(await this.scanExtensions(1)).find(F=>new p.ExtensionIdentifierWithVersion(F.identifier,F.manifest.version).equals(w))||null;return T?(await this.storeMetadata(T,{installedTimestamp:Date.now()}),this.scanExtension(T.location,1)):null}async withUninstalledExtensions(w){return this.uninstalledFileLimiter.queue(async()=>{let d;try{d=await L.Promises.readFile(this.uninstalledPath,"utf8")}catch(F){if(F.code!=="ENOENT")throw F}let T={};if(d)try{T=JSON.parse(d)}catch(F){}return w&&(w(T),Object.keys(T).length?await L.writeFile(this.uninstalledPath,JSON.stringify(T)):await L.rimraf(this.uninstalledPath)),T})}async removeExtension(w,d){this.logService.trace(`Deleting ${d} extension from disk`,w.identifier.id,w.location.fsPath),await L.rimraf(w.location.fsPath),this.logService.info("Deleted from disk",w.identifier.id,w.location.fsPath)}async removeUninstalledExtension(w){await this.removeExtension(w,"uninstalled"),await this.withUninstalledExtensions(d=>delete d[new p.ExtensionIdentifierWithVersion(w.identifier,w.manifest.version).key()])}async extractAtLocation(w,d,T,F){this.logService.trace(`Started extracting the extension from ${d} to ${T}`);try{await L.rimraf(T)}catch(z){throw new R.ExtensionManagementError(this.joinErrors(z).message,c)}try{await(0,E.extract)(d,T,{sourcePath:"extension",overwrite:!0},F),this.logService.info(`Extracted extension to ${T}:`,w.id)}catch(z){try{await L.rimraf(T)}catch(B){}throw new R.ExtensionManagementError(z.message,z instanceof E.ExtractError&&z.type?z.type:o)}}async rename(w,d,T,F){try{await L.Promises.rename(d,T)}catch(z){if(D.isWindows&&z&&z.code==="EPERM"&&Date.now()<F)return this.logService.info(`Failed renaming ${d} to ${T} with 'EPERM' error. Trying again...`,w.id),this.rename(w,d,T,F);throw new R.ExtensionManagementError(z.message||(0,C.localize)(3,null,d,T),z.code||l)}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const w=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return w;const d=this.scanDevSystemExtensions(),[T,F]=await Promise.all([w,d]);return[...T,...F]}async scanExtensionsInDir(w,d){const T=new S.Limiter(10),F=await this.fileService.resolve(n.URI.file(w));return F.children?(await Promise.all(F.children.filter(B=>B.isDirectory).map(B=>T.queue(async()=>d===1&&(0,a.basename)(B.resource).indexOf(".")===0?null:this.scanExtension(B.resource,d))))).filter(B=>B&&B.identifier):[]}async scanExtension(w,d){var T,F;try{const z=await this.fileService.resolve(w);if(z.children){const{manifest:B,metadata:K}=await this.readManifest(w.fsPath),j=(T=z.children.find(({name:M})=>/^readme(\.txt|\.md|)$/i.test(M)))===null||T===void 0?void 0:T.resource,H=(F=z.children.find(({name:M})=>/^changelog(\.txt|\.md|)$/i.test(M)))===null||F===void 0?void 0:F.resource,q={id:(0,p.getGalleryExtensionId)(B.publisher,B.name)},$={type:d,identifier:q,manifest:B,location:w,readmeUrl:j,changelogUrl:H,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:d===0};return K&&(this.setMetadata($,K),$.installedTimestamp=K.installedTimestamp),$}}catch(z){d!==0&&this.logService.trace(z)}return null}async scanDefaultSystemExtensions(){const w=await this.scanExtensionsInDir(this.systemExtensionsPath,0);return this.logService.trace("Scanned system extensions:",w.length),w}async scanDevSystemExtensions(){const w=this.getDevSystemExtensionsList();if(w.length){const d=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",d.length),d.filter(T=>w.some(F=>(0,p.areSameExtensions)(T.identifier,{id:F})))}else return[]}setMetadata(w,d){w.publisherDisplayName=d.publisherDisplayName||null,w.publisherId=d.publisherId||null,w.identifier.uuid=d.id,w.isMachineScoped=!!d.isMachineScoped,w.isBuiltin=w.type===0||!!d.isBuiltin}async removeUninstalledExtensions(){const w=await this.getUninstalledExtensions(),d=await this.scanAllUserExtensions(),T=new Set;for(const B of d)w[new p.ExtensionIdentifierWithVersion(B.identifier,B.manifest.version).key()]||T.add(B.identifier.id.toLowerCase());const F=(0,p.groupByExtension)(d,B=>B.identifier);await S.Promises.settled(F.map(async B=>{const K=B.sort((j,H)=>y.rcompare(j.manifest.version,H.manifest.version))[0];T.has(K.identifier.id.toLowerCase())||await this.beforeRemovingExtension(K)}));const z=d.filter(B=>w[new p.ExtensionIdentifierWithVersion(B.identifier,B.manifest.version).key()]);await S.Promises.settled(z.map(B=>this.removeUninstalledExtension(B)))}async removeOutdatedExtensions(){const w=await this.scanAllUserExtensions(),d=[],T=(0,p.groupByExtension)(w,F=>F.identifier);d.push(...(0,b.flatten)(T.map(F=>F.sort((z,B)=>y.rcompare(z.manifest.version,B.manifest.version)).slice(1)))),await S.Promises.settled(d.map(F=>this.removeExtension(F,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(w=>w.name)}joinErrors(w){const d=Array.isArray(w)?w:[w];return d.length===1?d[0]instanceof Error?d[0]:new Error(d[0]):d.reduce((T,F)=>new Error(`${T.message}${T.message?",":""}${F instanceof Error?F.message:F}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=k.normalize(k.join(I.FileAccess.asFileUri("",G).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(w){const d=[L.Promises.readFile(k.join(w,"package.json"),"utf8").then(B=>this.parseManifest(B)),L.Promises.readFile(k.join(w,"package.nls.json"),"utf8").then(void 0,B=>B.code!=="ENOENT"?Promise.reject(B):"{}").then(B=>JSON.parse(B))],[{manifest:T,metadata:F},z]=await Promise.all(d);return{manifest:(0,m.localizeManifest)(T,z),metadata:F}}parseManifest(w){return new Promise((d,T)=>{try{const F=JSON.parse(w),z=F.__metadata||null;d({manifest:F,metadata:z})}catch(F){T(new Error((0,C.localize)(4,null)))}})}};u=de([Y(1,g.IFileService),Y(2,A.ILogService),Y(3,f.INativeEnvironmentService),Y(4,h.IProductService)],u),e.ExtensionsScanner=u}),define(Z[205],ee([0,1,110,7,17,2,19,62,28,33,9,8,3,57,5,51,6,18,145,44,24,70,14,30,72,4,16,29,203,153,204,154,155,10]),function(G,e,y,P,L,k,A,R,p,S,n,f,m,C,h,E,D,b,I,g,a,s,t,r,i,o,c,l,u,v,w,d,T,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementService=void 0;const z="unsetUninstalled",B="downloading",K="validating",j="local",H="unknown";let q=class extends k.Disposable{constructor(M,U,O,_,N,W,V){super();this.environmentService=M,this.galleryService=U,this.logService=O,this.downloadService=_,this.telemetryService=N,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new m.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtension=this._register(new m.Emitter),this.onDidInstallExtension=this._onDidInstallExtension.event,this._onUninstallExtension=this._register(new m.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new m.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event;const Q=this._register(W.createInstance(d.ExtensionsLifecycle));this.extensionsScanner=this._register(W.createInstance(w.ExtensionsScanner,ie=>Q.postUninstall(ie))),this.manifestCache=this._register(new I.ExtensionsManifestCache(M,this)),this.extensionsDownloader=this._register(W.createInstance(v.ExtensionsDownloader));const X=this._register(new T.ExtensionsWatcher(this,V,M,O));this._register(X.onDidChangeExtensionsByAnotherSource(({added:ie,removed:ne})=>{ie.forEach(ce=>this._onDidInstallExtension.fire({identifier:ce.identifier,operation:0,local:ce})),ne.forEach(ce=>this._onDidUninstallExtension.fire({identifier:ce}))})),this._register((0,k.toDisposable)(()=>{this.installingExtensions.forEach(ie=>ie.cancel()),this.uninstallingExtensions.forEach(ie=>ie.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async zip(M){this.logService.trace("ExtensionManagementService#zip",M.identifier.id);const U=await this.collectFiles(M),O=await(0,R.zip)((0,t.joinPath)(this.environmentService.tmpDir,(0,r.generateUuid)()).fsPath,U);return h.URI.file(O)}async unzip(M){return this.logService.trace("ExtensionManagementService#unzip",M.toString()),(await this.install(M)).identifier}async getManifest(M){const U=await this.downloadVsix(M),O=P.resolve(U.fsPath);return(0,u.getManifest)(O)}async collectFiles(M){const U=async _=>{let N=await L.readdir(_);N=N.map(Q=>P.join(_,Q));const W=await Promise.all(N.map(Q=>L.Promises.stat(Q)));let V=Promise.resolve([]);return W.forEach((Q,X)=>{const ie=N[X];Q.isFile()&&(V=V.then(ne=>[...ne,ie])),Q.isDirectory()&&(V=V.then(ne=>U(ie).then(ce=>[...ne,...ce])))}),V};return(await U(M.location.fsPath)).map(_=>({path:`extension/${P.relative(M.location.fsPath,_)}`,localPath:_}))}async install(M,U={}){return this.logService.trace("ExtensionManagementService#install",M.toString()),(0,f.createCancelablePromise)(async O=>{const _=await this.downloadVsix(M),N=P.resolve(_.fsPath),W=await(0,u.getManifest)(N),V={id:(0,S.getGalleryExtensionId)(W.publisher,W.name)};let Q=1;if(W.engines&&W.engines.vscode&&!(0,s.isEngineValid)(W.engines.vscode,E.default.version,E.default.date))throw new Error(y.localize(0,null,V.id,E.default.version));const X=new S.ExtensionIdentifierWithVersion(V,W.version),ne=(await this.getInstalled(1)).find(le=>(0,S.areSameExtensions)(V,le.identifier));if(ne)if(U.isMachineScoped=U.isMachineScoped||ne.isMachineScoped,U.isBuiltin=U.isBuiltin||ne.isBuiltin,Q=2,X.equals(new S.ExtensionIdentifierWithVersion(ne.identifier,ne.manifest.version)))try{await this.extensionsScanner.removeExtension(ne,"existing")}catch(le){throw new Error(y.localize(1,null,W.displayName||W.name))}else C.gt(ne.manifest.version,W.version)&&await this.uninstallExtension(ne);else{const le=await this.unsetUninstalledAndGetLocal(X);if(le)try{await this.extensionsScanner.removeExtension(le,"existing")}catch(ve){throw new Error(y.localize(2,null,W.displayName||W.name))}}this.logService.info("Installing the extension:",V.id),this._onInstallExtension.fire({identifier:V,zipPath:N});let ce;try{ce=await this.getGalleryMetadata((0,S.getGalleryExtensionId)(W.publisher,W.name))}catch(le){}try{const le=await this.installFromZipPath(X,N,Object.assign(Object.assign({},ce||{}),U),U,Q,O);return this.logService.info("Successfully installed the extension:",V.id),le}catch(le){throw this.logService.error("Failed to install the extension:",V.id,le.message),le}})}async downloadVsix(M){if(M.scheme===c.Schemas.file)return M;if(!this.downloadService)throw new Error("Download service is not available");const U=(0,t.joinPath)(this.environmentService.tmpDir,(0,r.generateUuid)());return await this.downloadService.download(M,U),U}async installFromZipPath(M,U,O,_,N,W){try{const V=await this.installExtension({zipPath:U,identifierWithVersion:M,metadata:O},W);try{await this.installDependenciesAndPackExtensions(V,void 0,_)}catch(Q){(0,A.isNonEmptyArray)(V.manifest.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",V.identifier.id,Q.message),(0,A.isNonEmptyArray)(V.manifest.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",V.identifier.id,Q.message)}return this._onDidInstallExtension.fire({identifier:M,zipPath:U,local:V,operation:N}),V}catch(V){throw this._onDidInstallExtension.fire({identifier:M,zipPath:U,operation:N,error:V}),V}}async canInstall(M){return!0}async installFromGallery(M,U={}){if(!this.galleryService.isEnabled())throw new Error(y.localize(3,null));try{M=await this.checkAndGetCompatibleVersion(M)}catch(N){const W=N&&N.code?N.code:H;throw this.logService.error("Failed to install extension:",M.identifier.id,N?N.message:W),this.reportTelemetry(this.getTelemetryEvent(1),(0,S.getGalleryExtensionTelemetryData)(M),void 0,N),N instanceof Error&&(N.name=W),N}const O=new S.ExtensionIdentifierWithVersion(M.identifier,M.version).key();let _=this.installingExtensions.get(O);return _||(_=(0,f.createCancelablePromise)(N=>this.doInstallFromGallery(M,U,N)),this.installingExtensions.set(O,_),_.finally(()=>this.installingExtensions.delete(O))),_}async doInstallFromGallery(M,U,O){const _=new Date().getTime();let N=1;this.logService.info("Installing extension:",M.identifier.id),this._onInstallExtension.fire({identifier:M.identifier,gallery:M});try{const V=(await this.getInstalled(1)).find(ie=>(0,S.areSameExtensions)(ie.identifier,M.identifier));V&&(N=2);const Q=await this.downloadInstallableExtension(M,N);Q.metadata.isMachineScoped=U.isMachineScoped||(V==null?void 0:V.isMachineScoped),Q.metadata.isBuiltin=U.isBuiltin||(V==null?void 0:V.isBuiltin);const X=await this.installExtension(Q,O);try{await this.extensionsDownloader.delete(h.URI.file(Q.zipPath))}catch(ie){}if(!U.donotIncludePackAndDependencies)try{await this.installDependenciesAndPackExtensions(X,V,U)}catch(ie){try{await this.uninstall(X)}catch(ne){}throw ie}return V&&C.neq(V.manifest.version,M.version)&&await this.extensionsScanner.setUninstalled(V),this.logService.info("Extensions installed successfully:",M.identifier.id),this._onDidInstallExtension.fire({identifier:M.identifier,gallery:M,local:X,operation:N}),this.reportTelemetry(this.getTelemetryEvent(N),(0,S.getGalleryExtensionTelemetryData)(M),new Date().getTime()-_,void 0),X}catch(W){const V=W&&W.code?W.code:H;throw this.logService.error("Failed to install extension:",M.identifier.id,W?W.message:V),this._onDidInstallExtension.fire({identifier:M.identifier,gallery:M,operation:N,error:V}),this.reportTelemetry(this.getTelemetryEvent(N),(0,S.getGalleryExtensionTelemetryData)(M),new Date().getTime()-_,W),W instanceof Error&&(W.name=V),W}}async checkAndGetCompatibleVersion(M){if(await this.isMalicious(M))throw new p.ExtensionManagementError(y.localize(4,null),p.INSTALL_ERROR_MALICIOUS);const U=await this.galleryService.getCompatibleExtension(M);if(!U)throw new p.ExtensionManagementError(y.localize(5,null,M.identifier.id,E.default.version),p.INSTALL_ERROR_INCOMPATIBLE);return U}async reinstallFromGallery(M){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",M.identifier.id),!this.galleryService.isEnabled())throw new Error(y.localize(6,null));const U=await this.findGalleryExtension(M);if(!U)throw new Error(y.localize(7,null));await this.extensionsScanner.setUninstalled(M);try{await this.extensionsScanner.removeUninstalledExtension(M)}catch(O){throw new Error(y.localize(8,null,(0,g.toErrorMessage)(O)))}await this.installFromGallery(U)}getTelemetryEvent(M){return M===2?"extensionGallery:update":"extensionGallery:install"}async isMalicious(M){const U=await this.getExtensionsReport();return(0,S.getMaliciousExtensionsSet)(U).has(M.identifier.id)}async downloadInstallableExtension(M,U){const O={id:M.identifier.uuid,publisherId:M.publisherId,publisherDisplayName:M.publisherDisplayName};let _;try{this.logService.trace("Started downloading extension:",M.identifier.id),_=(await this.extensionsDownloader.downloadExtension(M,U)).fsPath,this.logService.info("Downloaded extension:",M.identifier.id,_)}catch(N){throw new p.ExtensionManagementError(this.joinErrors(N).message,B)}try{const N=await(0,u.getManifest)(_);return{zipPath:_,identifierWithVersion:new S.ExtensionIdentifierWithVersion(M.identifier,N.version),metadata:O}}catch(N){throw new p.ExtensionManagementError(this.joinErrors(N).message,K)}}async installExtension(M,U){try{const O=await this.unsetUninstalledAndGetLocal(M.identifierWithVersion);if(O)return M.metadata?this.extensionsScanner.saveMetadataForLocalExtension(O,M.metadata):O}catch(O){throw D.isMacintosh?new p.ExtensionManagementError(y.localize(9,null),z):new p.ExtensionManagementError(y.localize(10,null),z)}return this.extractAndInstall(M,U)}async unsetUninstalledAndGetLocal(M){if(!await this.isUninstalled(M))return null;this.logService.trace("Removing the extension from uninstalled list:",M.id);const O=await this.extensionsScanner.setInstalled(M);return this.logService.info("Removed the extension from uninstalled list:",M.id),O}async extractAndInstall({zipPath:M,identifierWithVersion:U,metadata:O},_){let N=await this.extensionsScanner.extractUserExtension(U,M,_);return this.logService.info("Installation completed.",U.id),O&&(N=await this.extensionsScanner.saveMetadataForLocalExtension(N,O)),N}async installDependenciesAndPackExtensions(M,U,O){if(!this.galleryService.isEnabled())return;const _=M.manifest.extensionDependencies||[];if(M.manifest.extensionPack)for(const N of M.manifest.extensionPack)U&&U.manifest.extensionPack&&U.manifest.extensionPack.some(W=>(0,S.areSameExtensions)({id:W},{id:N}))||_.every(W=>!(0,S.areSameExtensions)({id:W},{id:N}))&&_.push(N);if(_.length){const N=await this.getInstalled(),W=_.filter(V=>N.every(({identifier:Q})=>!(0,S.areSameExtensions)(Q,{id:V})));if(W.length){const Q=(await this.galleryService.query({names:W,pageSize:_.length},l.CancellationToken.None)).firstPage;try{await f.Promises.settled(Q.map(X=>this.installFromGallery(X,O)))}catch(X){try{await this.rollback(Q)}catch(ie){}throw X}}}}async rollback(M){const O=(await this.getInstalled(1)).filter(_=>M.some(N=>new S.ExtensionIdentifierWithVersion(_.identifier,_.manifest.version).equals(new S.ExtensionIdentifierWithVersion(N.identifier,N.version))));await f.Promises.settled(O.map(_=>this.uninstall(_)))}async uninstall(M,U={}){this.logService.trace("ExtensionManagementService#uninstall",M.identifier.id);const O=await this.getInstalled(1),_=O.find(N=>(0,S.areSameExtensions)(N.identifier,M.identifier));if(!_)throw new Error(y.localize(11,null,M.manifest.displayName||M.manifest.name));try{await this.checkForDependenciesAndUninstall(_,O,U)}catch(N){throw this.joinErrors(N)}}async updateMetadata(M,U){return this.logService.trace("ExtensionManagementService#updateMetadata",M.identifier.id),M=await this.extensionsScanner.saveMetadataForLocalExtension(M,Object.assign(Object.assign({},M.manifest.__metadata||{}),U)),this.manifestCache.invalidate(),M}async updateExtensionScope(M,U){return this.logService.trace("ExtensionManagementService#updateExtensionScope",M.identifier.id),M=await this.extensionsScanner.saveMetadataForLocalExtension(M,Object.assign(Object.assign({},M.manifest.__metadata||{}),{isMachineScoped:U})),this.manifestCache.invalidate(),M}async getGalleryMetadata(M){const U=await this.findGalleryExtensionByName(M);return U?{id:U.identifier.uuid,publisherDisplayName:U.publisherDisplayName,publisherId:U.publisherId}:void 0}async findGalleryExtension(M){if(M.identifier.uuid){const U=await this.findGalleryExtensionById(M.identifier.uuid);return U||this.findGalleryExtensionByName(M.identifier.id)}return this.findGalleryExtensionByName(M.identifier.id)}async findGalleryExtensionById(M){return(await this.galleryService.query({ids:[M],pageSize:1},l.CancellationToken.None)).firstPage[0]}async findGalleryExtensionByName(M){return(await this.galleryService.query({names:[M],pageSize:1},l.CancellationToken.None)).firstPage[0]}joinErrors(M){const U=Array.isArray(M)?M:[M];return U.length===1?U[0]instanceof Error?U[0]:new Error(U[0]):U.reduce((O,_)=>new Error(`${O.message}${O.message?",":""}${_ instanceof Error?_.message:_}`),new Error(""))}async checkForDependenciesAndUninstall(M,U,O){try{await this.preUninstallExtension(M);const _=O.donotIncludePack?[]:this.getAllPackExtensionsToUninstall(M,U);await this.uninstallExtensions(M,_,U,O)}catch(_){throw await this.postUninstallExtension(M,new p.ExtensionManagementError(_ instanceof Error?_.message:_,j)),_}await this.postUninstallExtension(M)}async uninstallExtensions(M,U,O,_){const N=[M,...U];if(!_.donotCheckDependents)for(const W of N)this.checkForDependents(W,N,O,M);await f.Promises.settled([this.uninstallExtension(M),...U.map(W=>this.doUninstall(W))])}checkForDependents(M,U,O,_){const N=this.getDependents(M,O);if(N.length){const W=N.filter(V=>U.indexOf(V)===-1);if(W.length)throw new Error(this.getDependentsErrorMessage(M,W,_))}}getDependentsErrorMessage(M,U,O){return O===M?U.length===1?y.localize(12,null,O.manifest.displayName||O.manifest.name,U[0].manifest.displayName||U[0].manifest.name):U.length===2?y.localize(13,null,O.manifest.displayName||O.manifest.name,U[0].manifest.displayName||U[0].manifest.name,U[1].manifest.displayName||U[1].manifest.name):y.localize(14,null,O.manifest.displayName||O.manifest.name,U[0].manifest.displayName||U[0].manifest.name,U[1].manifest.displayName||U[1].manifest.name):U.length===1?y.localize(15,null,O.manifest.displayName||O.manifest.name,M.manifest.displayName||M.manifest.name,U[0].manifest.displayName||U[0].manifest.name):U.length===2?y.localize(16,null,O.manifest.displayName||O.manifest.name,M.manifest.displayName||M.manifest.name,U[0].manifest.displayName||U[0].manifest.name,U[1].manifest.displayName||U[1].manifest.name):y.localize(17,null,O.manifest.displayName||O.manifest.name,M.manifest.displayName||M.manifest.name,U[0].manifest.displayName||U[0].manifest.name,U[1].manifest.displayName||U[1].manifest.name)}getAllPackExtensionsToUninstall(M,U,O=[]){if(O.indexOf(M)!==-1)return[];O.push(M);const _=M.manifest.extensionPack?M.manifest.extensionPack:[];if(_.length){const N=U.filter(V=>!V.isBuiltin&&_.some(Q=>(0,S.areSameExtensions)({id:Q},V.identifier))),W=[];for(const V of N)W.push(...this.getAllPackExtensionsToUninstall(V,U,O));return[...N,...W]}return[]}getDependents(M,U){return U.filter(O=>O.manifest.extensionDependencies&&O.manifest.extensionDependencies.some(_=>(0,S.areSameExtensions)({id:_},M.identifier)))}async doUninstall(M){try{await this.preUninstallExtension(M),await this.uninstallExtension(M)}catch(U){throw await this.postUninstallExtension(M,new p.ExtensionManagementError(U instanceof Error?U.message:U,j)),U}await this.postUninstallExtension(M)}async preUninstallExtension(M){if(!await L.exists(M.location.fsPath))throw new Error(y.localize(18,null));this.logService.info("Uninstalling extension:",M.identifier.id),this._onUninstallExtension.fire(M.identifier)}async uninstallExtension(M){let U=this.uninstallingExtensions.get(M.identifier.id);return U||(U=(0,f.createCancelablePromise)(async()=>{const O=await this.extensionsScanner.scanUserExtensions(!1);await this.extensionsScanner.setUninstalled(...O.filter(_=>(0,S.areSameExtensions)(_.identifier,M.identifier)))}),this.uninstallingExtensions.set(M.identifier.id,U),U.finally(()=>this.uninstallingExtensions.delete(M.identifier.id))),U}async postUninstallExtension(M,U){if(U)this.logService.error("Failed to uninstall extension:",M.identifier.id,U.message);else if(this.logService.info("Successfully uninstalled extension:",M.identifier.id),M.identifier.uuid)try{await this.galleryService.reportStatistic(M.manifest.publisher,M.manifest.name,M.manifest.version,"uninstall")}catch(_){}this.reportTelemetry("extensionGallery:uninstall",(0,S.getLocalExtensionTelemetryData)(M),void 0,U);const O=U?U instanceof p.ExtensionManagementError?U.code:H:void 0;this._onDidUninstallExtension.fire({identifier:M.identifier,error:O})}getInstalled(M=null){return this.extensionsScanner.scanExtensions(M)}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async isUninstalled(M){return(await this.filterUninstalled(M)).length===1}async filterUninstalled(...M){const U=[],O=await this.extensionsScanner.getUninstalledExtensions();for(const _ of M)O[_.key()]&&U.push(_.key());return U}getExtensionsReport(){const M=new Date().getTime();return(!this.reportedExtensions||M-this.lastReportTimestamp>1e3*60*5)&&(this.reportedExtensions=this.updateReportCache(),this.lastReportTimestamp=M),this.reportedExtensions}async updateReportCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const M=await this.galleryService.getExtensionsReport();return this.logService.trace(`ExtensionManagementService.refreshReportedCache - got ${M.length} reported extensions from service`),M}catch(M){return this.logService.trace("ExtensionManagementService.refreshReportedCache - failed to get extension report"),[]}}reportTelemetry(M,U,O,_){const N=_?_ instanceof p.ExtensionManagementError?_.code:H:void 0;this.telemetryService.publicLogError(M,Object.assign(Object.assign({},U),{success:!_,duration:O,errorcode:N}))}};q=de([Y(0,n.INativeEnvironmentService),Y(1,p.IExtensionGalleryService),Y(2,b.ILogService),Y(3,(0,o.optional)(i.IDownloadService)),Y(4,a.ITelemetryService),Y(5,o.IInstantiationService),Y(6,F.IFileService)],q),e.ExtensionManagementService=q}),define(Z[211],ee([0,1,42,35,212,100,51,99,36,76,50,149,9,129,131,28,205,172,23,163,39,164,24,59,170,80,81,175,18,77,156,56,2,165,72,161,160,143,142,151,150,171,71,157,10,159,16,27,21,198,200,195,58,196,201,169,20,167,197,60,194,173,61,73,133,202,174,85,84,83,4,152,144,11,44,82,183,178,199,140,146,176,5,14]),function(G,e,y,P,L,k,A,R,p,S,n,f,m,C,h,E,D,b,I,g,a,s,t,r,i,o,c,l,u,v,w,d,T,F,z,B,K,j,H,q,$,M,U,O,_,N,W,V,Q,X,ie,ne,ce,le,ve,pe,Ce,Ae,_e,Oe,ke,je,Ie,Te,Ke,Ye,$e,qe,J,re,se,me,Se,Pe,be,Ue,De,x,te,ae,oe,he,ge,fe){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class ye extends T.Disposable{constructor(ue){super();this.configuration=ue,this.server=this._register(new R.Server),(0,L.gracefulify)(y),this.registerListeners()}registerListeners(){const ue=()=>this.dispose();process.once("exit",ue),k.ipcRenderer.once("vscode:electron-main->shared-process=exit",ue)}async open(){const ue=await this.initServices();(0,Q.registerConfiguration)(),ue.invokeFunction(Re=>{const Fe=Re.get(u.ILogService);Fe.trace("sharedProcess configuration",JSON.stringify(this.configuration)),this.initChannels(Re),this.registerErrorHandler(Fe)}),this._register((0,T.combinedDisposable)(ue.createInstance(B.NodeCachedDataCleaner,this.configuration.nodeCachedDataDir),ue.createInstance(K.LanguagePackCachedDataCleaner),ue.createInstance(j.StorageDataCleaner,this.configuration.backupWorkspacesPath),ue.createInstance(H.LogsDataCleaner),ue.createInstance(me.LocalizationsUpdater),ue.createInstance(Se.DeprecatedExtensionsCleaner)))}async initServices(){const ue=new S.ServiceCollection,Re=Object.assign({_serviceBrand:void 0},A.default);ue.set(V.IProductService,Re);const Fe=new p.StaticRouter(xe=>xe==="main"),Me=new $.MessagePortMainProcessService(this.server,Fe);ue.set(q.IMainProcessService,Me);const Ne=new C.NativeEnvironmentService(this.configuration.args,Re);ue.set(m.INativeEnvironmentService,Ne);const tt=new v.LogLevelChannelClient(this.server.getChannel("logLevel",Fe)),Je=new v.LoggerChannelClient(this.configuration.logLevel,tt.onDidChangeLogLevel,Me.getChannel("logger"));ue.set(u.ILoggerService,Je);const it=this._register(new u.MultiplexLogService([this._register(new u.ConsoleLogger(this.configuration.logLevel)),this._register(Je.createLogger((0,fe.joinPath)(ge.URI.file(Ne.logsPath),"sharedprocess.log"),{name:"sharedprocess"}))])),We=this._register(new v.FollowerLogService(tt,it));ue.set(u.ILogService,We);const Ve=this._register(new O.FileService(We));ue.set(_.IFileService,Ve);const rt=this._register(new N.DiskFileSystemProvider(We));Ve.registerProvider(W.Schemas.file,rt);const Be=this._register(new g.ConfigurationService(Ne.settingsResource,Ve));ue.set(I.IConfigurationService,Be),await Be.initialize();const Xe=new pe.NativeStorageService(void 0,Me,Ne);ue.set(Ce.IStorageService,Xe),await Xe.initialize(),this._register((0,T.toDisposable)(()=>Xe.flush())),ue.set(a.IRequestService,new n.SyncDescriptor(s.RequestService)),ue.set(ae.IChecksumService,new n.SyncDescriptor(oe.ChecksumService));const nt=p.ProxyChannel.toService(Me.getChannel("nativeHost"),{context:this.configuration.windowId});ue.set(ce.INativeHostService,nt),ue.set(z.IDownloadService,new n.SyncDescriptor(F.DownloadService));const st=this._register(new Ye.ActiveWindowManager(nt)),dt=new p.StaticRouter(xe=>st.getActiveClientId().then(at=>xe===at));ue.set(Te.IExtensionRecommendationNotificationService,new Ke.ExtensionRecommendationNotificationServiceChannelClient(this.server.getChannel("extensionRecommendationNotification",dt)));let Qe,He;if(!Ne.isExtensionDevelopment&&!Ne.disableTelemetry&&Re.enableTelemetry){He=new $e.TelemetryLogAppender(Je,Ne);const{appRoot:xe,extensionsPath:at,isBuilt:mt,installSourcePath:vt}=Ne;if(Re.aiConfig&&Re.aiConfig.asimovKey&&mt){const ut=new l.AppInsightsAppender("monacoworkbench",null,Re.aiConfig.asimovKey);this._register((0,T.toDisposable)(()=>ut.flush())),He=(0,r.combinedAppender)(ut,He)}Qe=new c.TelemetryService({appender:He,commonProperties:(0,i.resolveCommonProperties)(Ve,(0,P.release)(),(0,P.hostname)(),process.arch,Re.commit,Re.version,this.configuration.machineId,Re.msftInternalDomains,vt),sendErrorTelemetry:!0,piiPaths:[xe,at]},Be)}else Qe=r.NullTelemetryService,He=r.NullAppender;this.server.registerChannel("telemetryAppender",new o.TelemetryAppenderChannel(He)),ue.set(t.ITelemetryService,Qe);const gt=new he.CustomEndpointTelemetryService(Be,Qe);return ue.set(t.ICustomEndpointTelemetryService,gt),ue.set(E.IExtensionManagementService,new n.SyncDescriptor(D.ExtensionManagementService)),ue.set(E.IExtensionGalleryService,new n.SyncDescriptor(b.ExtensionGalleryService)),ue.set(E.IExtensionTipsService,new n.SyncDescriptor(je.ExtensionTipsService)),ue.set(d.ILocalizationsService,new n.SyncDescriptor(w.LocalizationsService)),ue.set(U.IDiagnosticsService,new n.SyncDescriptor(M.DiagnosticsService)),ue.set(Oe.IUserDataSyncAccountService,new n.SyncDescriptor(Oe.UserDataSyncAccountService)),ue.set(Q.IUserDataSyncLogService,new n.SyncDescriptor(le.UserDataSyncLogService)),ue.set(Q.IUserDataSyncUtilService,new ne.UserDataSyncUtilServiceClient(this.server.getChannel("userDataSyncUtil",xe=>xe.ctx!=="main"))),ue.set(E.IGlobalExtensionEnablementService,new n.SyncDescriptor(Ae.GlobalExtensionEnablementService)),ue.set(J.IIgnoredExtensionsManagementService,new n.SyncDescriptor(J.IgnoredExtensionsManagementService)),ue.set(re.IExtensionsStorageSyncService,new n.SyncDescriptor(re.ExtensionsStorageSyncService)),ue.set(Q.IUserDataSyncStoreManagementService,new n.SyncDescriptor(ie.UserDataSyncStoreManagementService)),ue.set(Q.IUserDataSyncStoreService,new n.SyncDescriptor(ie.UserDataSyncStoreService)),ue.set(Ie.IUserDataSyncMachinesService,new n.SyncDescriptor(Ie.UserDataSyncMachinesService)),ue.set(Q.IUserDataSyncBackupStoreService,new n.SyncDescriptor(ke.UserDataSyncBackupStoreService)),ue.set(Q.IUserDataAutoSyncEnablementService,new n.SyncDescriptor(qe.UserDataAutoSyncEnablementService)),ue.set(Q.IUserDataSyncResourceEnablementService,new n.SyncDescriptor(_e.UserDataSyncResourceEnablementService)),ue.set(Q.IUserDataSyncService,new n.SyncDescriptor(X.UserDataSyncService)),ue.set(x.ILocalPtyService,this._register(new De.PtyHostService(Be,We,Qe))),new f.InstantiationService(ue)}initChannels(ue){const Re=new h.ExtensionManagementChannel(ue.get(E.IExtensionManagementService),()=>null);this.server.registerChannel("extensions",Re);const Fe=p.ProxyChannel.fromService(ue.get(d.ILocalizationsService));this.server.registerChannel("localizations",Fe);const Me=p.ProxyChannel.fromService(ue.get(U.IDiagnosticsService));this.server.registerChannel("diagnostics",Me);const Ne=new h.ExtensionTipsChannel(ue.get(E.IExtensionTipsService));this.server.registerChannel("extensionTipsService",Ne);const tt=p.ProxyChannel.fromService(ue.get(ae.IChecksumService));this.server.registerChannel("checksum",tt);const Je=new ne.UserDataSyncMachinesServiceChannel(ue.get(Ie.IUserDataSyncMachinesService));this.server.registerChannel("userDataSyncMachines",Je);const it=p.ProxyChannel.fromService(ue.get(t.ICustomEndpointTelemetryService));this.server.registerChannel("customEndpointTelemetry",it);const We=new ne.UserDataSyncAccountServiceChannel(ue.get(Oe.IUserDataSyncAccountService));this.server.registerChannel("userDataSyncAccount",We);const Ve=new ne.UserDataSyncStoreManagementServiceChannel(ue.get(Q.IUserDataSyncStoreManagementService));this.server.registerChannel("userDataSyncStoreManagement",Ve);const rt=new te.UserDataSyncChannel(ue.get(Q.IUserDataSyncService),ue.get(u.ILogService));this.server.registerChannel("userDataSync",rt);const Be=this._register(ue.get(se.IInstantiationService).createInstance(ve.UserDataAutoSyncService)),Xe=new ne.UserDataAutoSyncChannel(Be);this.server.registerChannel("userDataAutoSync",Xe);const nt=ue.get(x.ILocalPtyService),st=p.ProxyChannel.fromService(nt);this.server.registerChannel(Ue.TerminalIpcChannels.LocalPty,st)}registerErrorHandler(ue){window.addEventListener("unhandledrejection",Re=>{(0,Pe.onUnexpectedError)(Re.reason),Re.preventDefault()}),(0,Pe.setUnexpectedErrorHandler)(Re=>{const Fe=(0,be.toErrorMessage)(Re,!0);!Fe||ue.error(`[uncaught exception in sharedProcess]: ${Fe}`)})}}async function we(Ee){const ue=new ye(Ee);k.ipcRenderer.send("vscode:shared-process->electron-main=ipc-ready"),await ue.open(),k.ipcRenderer.send("vscode:shared-process->electron-main=init-done")}e.main=we})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/5319757634f77a050b49c10162939bfe60970c29/core/vs/code/electron-browser/sharedProcess/sharedProcessMain.js.map
