/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var J=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/platform/log/common/log","vs/base/common/uri","vs/base/common/path","vs/base/common/async","vs/base/common/network","vs/nls!vs/code/electron-main/main","vs/nls","vs/base/common/types","electron","vs/base/common/resources","vs/base/node/pfs","vs/platform/configuration/common/configuration","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/common/errors","vs/base/common/buffer","vs/platform/files/common/files","vs/platform/product/common/productService","vs/base/common/strings","vs/platform/environment/electron-main/environmentMainService","vs/base/common/cancellation","os","vs/base/common/uuid","vs/platform/workspaces/common/workspaces","fs","vs/base/common/extpath","vs/platform/telemetry/common/telemetry","vs/base/common/process","vs/base/parts/ipc/common/ipc","vs/platform/windows/electron-main/windows","vs/base/common/arrays","vs/base/common/map","vs/platform/registry/common/platform","vs/platform/state/electron-main/state","vs/base/common/labels","child_process","vs/platform/update/common/update","vs/base/common/functional","vs/base/common/json","vs/base/common/objects","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/decorators","vs/platform/product/common/product","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/platform/backup/electron-main/backup","vs/platform/dialogs/electron-main/dialogMainService","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/environment/common/environment","vs/platform/environment/node/argvHelper","vs/platform/protocol/electron-main/protocol","vs/base/parts/ipc/node/ipc.net","vs/base/common/keyCodes","crypto","net","vs/platform/theme/electron-main/themeMainService","vs/platform/windows/common/windows","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/iterator","vs/base/common/stream","vs/base/common/normalization","vs/base/node/id","vs/base/common/errorMessage","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/diagnostics/common/diagnostics","vs/platform/instantiation/common/serviceCollection","vs/base/common/performance","vs/platform/remote/common/remoteHosts","vs/platform/remote/common/tunnel","vs/platform/sign/common/sign","vs/platform/webview/common/webviewManagerService","vs/platform/update/electron-main/abstractUpdateService","vs/base/common/linkedList","vs/base/common/scanCode","vs/base/common/hash","vs/base/node/decoder","vs/base/node/extpath","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/base/parts/ipc/node/ipc.cp","vs/platform/environment/node/argv","vs/platform/encryption/electron-main/encryptionMainService","vs/platform/externalTerminal/common/externalTerminal","vs/platform/environment/node/shellEnv","vs/platform/files/node/watcher/watcher","vs/platform/log/common/bufferLog","vs/platform/log/node/spdlogLog","vs/platform/files/common/io","vs/platform/storage/common/storage","vs/platform/telemetry/common/telemetryUtils","vs/platform/url/common/url","vs/platform/storage/electron-main/storageMainService","vs/platform/windows/electron-main/windowsFinder","vs/platform/launch/electron-main/launchMainService","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/processes","vs/base/common/keybindingParser","vs/base/common/stopwatch","vs/base/common/codicons","vs/base/common/console","vs/base/common/marshalling","vs/base/common/glob","vs/base/node/crypto","vs/base/node/macAddress","util","vs/base/node/ports","vs/base/node/powershell","vs/base/node/watcher","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/contextmenu/electron-main/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/storage/node/storage","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/keybindingLabels","vs/base/common/keybindingLabels","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/windows/electron-main/window","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/driver/common/driverIpc","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","path","vs/platform/environment/node/environmentService","vs/platform/environment/node/wait","vs/platform/extensions/common/extensionValidator","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/unix/watcherService","vs/platform/files/node/watcher/win32/csharpWatcherService","vs/platform/files/node/watcher/win32/watcherService","vs/platform/instantiation/common/graph","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionUrlTrust","vs/platform/extensions/common/extensions","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/keybinding/common/baseResolvedKeybinding","vs/platform/keybinding/common/usLayoutResolvedKeybinding","vs/platform/lifecycle/common/lifecycle","vs/platform/log/common/fileLog","vs/platform/log/common/logIpc","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/extensionManagement/node/extensionUrlTrustService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/request/node/proxy","url","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/sign/node/signService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/telemetry/common/commonProperties","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryService","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/webview/electron-main/webviewProtocolProvider","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/node/windowTracker","vs/platform/workspace/common/workspace","vs/platform/storage/electron-main/storageIpc","vs/platform/storage/electron-main/storageMain","vs/platform/windows/electron-main/windowsStateHandler","zlib","vs/platform/driver/node/driver","vs/platform/backup/electron-main/backupMainService","vs/code/electron-main/auth","vs/platform/driver/electron-main/driver","vs/platform/remote/node/nodeSocketFactory","vs/platform/remote/node/tunnelService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/state/electron-main/stateMainService","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.snap","vs/platform/update/electron-main/updateService.win32","vs/platform/issue/electron-main/issueMainService","vs/platform/windows/electron-main/window","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","string_decoder","minimist","assert","vs/code/electron-main/main"],Z=function($){for(var e=[],m=0,L=$.length;m<L;m++)e[m]=J[$[m]];return e};define(J[102],Z([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function m(L,A){if(!L)throw new Error(A?`Assertion failed (${A})`:"Assertion Failed")}e.ok=m}),define(J[46],Z([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function m(E){return(n,w,y)=>{let i=null,I=null;if(typeof y.value=="function"?(i="value",I=y.value):typeof y.get=="function"&&(i="get",I=y.get),!I)throw new Error("not supported");y[i]=E(I,w)}}e.createDecorator=m;function L(E,n,w){let y=null,i=null;if(typeof w.value=="function"?(y="value",i=w.value,i.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof w.get=="function"&&(y="get",i=w.get),!i)throw new Error("not supported");const I=`$memoize$${n}`;w[y]=function(...M){return this.hasOwnProperty(I)||Object.defineProperty(this,I,{configurable:!1,enumerable:!1,writable:!1,value:i.apply(this,M)}),this[I]}}e.memoize=L;function A(E,n,w){return m((y,i)=>{const I=`$debounce$${i}`,M=`$debounce$result$${i}`;return function(...p){this[M]||(this[M]=w?w():void 0),clearTimeout(this[I]),n&&(this[M]=n(this[M],...p),p=[this[M]]),this[I]=setTimeout(()=>{y.apply(this,p),this[M]=w?w():void 0},E)}})}e.debounce=A;function b(E,n,w){return m((y,i)=>{const I=`$throttle$timer$${i}`,M=`$throttle$result$${i}`,p=`$throttle$lastRun$${i}`,g=`$throttle$pending$${i}`;return function(...v){if(this[M]||(this[M]=w?w():void 0),(this[p]===null||this[p]===void 0)&&(this[p]=-Number.MAX_VALUE),n&&(this[M]=n(this[M],...v)),this[g])return;const D=this[p]+E;D<=Date.now()?(this[p]=Date.now(),y.apply(this,[this[M]]),this[M]=w?w():void 0):(this[g]=!0,this[I]=setTimeout(()=>{this[g]=!1,this[p]=Date.now(),y.apply(this,[this[M]]),this[M]=w?w():void 0},D-Date.now()))}})}e.throttle=b}),define(J[19],Z([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class m{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(r=>{r(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=m,e.errorHandler=new m;function L(l){e.errorHandler.setUnexpectedErrorHandler(l)}e.setUnexpectedErrorHandler=L;function A(l){w(l)||e.errorHandler.onUnexpectedError(l)}e.onUnexpectedError=A;function b(l){w(l)||e.errorHandler.onUnexpectedExternalError(l)}e.onUnexpectedExternalError=b;function E(l){if(l instanceof Error){let{name:t,message:r}=l;const s=l.stacktrace||l.stack;return{$isError:!0,name:t,message:r,stack:s}}return l}e.transformErrorForSerialization=E;const n="Canceled";function w(l){return l instanceof Error&&l.name===n&&l.message===n}e.isPromiseCanceledError=w;class y extends Error{constructor(){super(n);this.name=this.message}}e.CancellationError=y;function i(){const l=new Error(n);return l.name=l.message,l}e.canceled=i;function I(l){return l?new Error(`Illegal argument: ${l}`):new Error("Illegal argument")}e.illegalArgument=I;function M(l){return l?new Error(`Illegal state: ${l}`):new Error("Illegal state")}e.illegalState=M;function p(l){return l?new Error(`readonly property '${l} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=p;function g(l){const t=new Error(`${l} has been disposed`);return t.name="DISPOSED",t}e.disposed=g;function v(l){return l?l.message?l.message:l.stack?l.stack.split(`
`)[0]:String(l):"Error"}e.getErrorMessage=v;class D extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=D;class S extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=S;class a extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=a;function u(l){const t=l;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=u;function c(l,t=Object.create(null)){const r=new Error(l);return t.actions&&(r.actions=t.actions),r}e.createErrorWithActions=c}),define(J[35],Z([0,1,19]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function L(N,C=0){return N[N.length-(1+C)]}e.tail=L;function A(N){if(N.length===0)throw new Error("Invalid tail call");return[N.slice(0,N.length-1),N[N.length-1]]}e.tail2=A;function b(N,C,z=(F,R)=>F===R){if(N===C)return!0;if(!N||!C||N.length!==C.length)return!1;for(let F=0,R=N.length;F<R;F++)if(!z(N[F],C[F]))return!1;return!0}e.equals=b;function E(N,C,z){let F=0,R=N.length-1;for(;F<=R;){const W=(F+R)/2|0,k=z(N[W],C);if(k<0)F=W+1;else if(k>0)R=W-1;else return W}return-(F+1)}e.binarySearch=E;function n(N,C){let z=0,F=N.length;if(F===0)return 0;for(;z<F;){const R=Math.floor((z+F)/2);C(N[R])?F=R:z=R+1}return z}e.findFirstInSorted=n;function w(N,C,z){if(N=N|0,N>=C.length)throw new TypeError("invalid index");let F=C[Math.floor(C.length*Math.random())],R=[],W=[],k=[];for(let O of C){const _=z(O,F);_<0?R.push(O):_>0?W.push(O):k.push(O)}return N<R.length?w(N,R,z):N<R.length+k.length?k[0]:w(N-(R.length+k.length),W,z)}e.quickSelect=w;function y(N,C){const z=[];let F;for(const R of N.slice(0).sort(C))!F||C(F[0],R)!==0?(F=[R],z.push(F)):F.push(R);return z}e.groupBy=y;function i(N,C,z){const F=[];function R(O,_,K){if(_===0&&K.length===0)return;const G=F[F.length-1];G&&G.start+G.deleteCount===O?(G.deleteCount+=_,G.toInsert.push(...K)):F.push({start:O,deleteCount:_,toInsert:K})}let W=0,k=0;for(;;){if(W===N.length){R(W,0,C.slice(k));break}if(k===C.length){R(W,N.length-W,[]);break}const O=N[W],_=C[k],K=z(O,_);K===0?(W+=1,k+=1):K<0?(R(W,1,[]),W+=1):K>0&&(R(W,0,[_]),k+=1)}return F}e.sortedDiff=i;function I(N,C,z){const F=i(N,C,z),R=[],W=[];for(const k of F)R.push(...N.slice(k.start,k.start+k.deleteCount)),W.push(...k.toInsert);return{removed:R,added:W}}e.delta=I;function M(N,C,z){if(z===0)return[];const F=N.slice(0,z).sort(C);return g(N,C,F,z,N.length),F}e.top=M;function p(N,C,z,F,R){return z===0?Promise.resolve([]):new Promise((W,k)=>{(async()=>{const O=N.length,_=N.slice(0,z).sort(C);for(let K=z,G=Math.min(z+F,O);K<O;K=G,G=Math.min(G+F,O)){if(K>z&&await new Promise(Y=>setTimeout(Y)),R&&R.isCancellationRequested)throw(0,m.canceled)();g(N,C,_,K,G)}return _})().then(W,k)})}e.topAsync=p;function g(N,C,z,F,R){for(const W=z.length;F<R;F++){const k=N[F];if(C(k,z[W-1])<0){z.pop();const O=n(z,_=>C(k,_)<0);z.splice(O,0,k)}}}function v(N){return N.filter(C=>!!C)}e.coalesce=v;function D(N){let C=0;for(let z=0;z<N.length;z++)N[z]&&(N[C]=N[z],C+=1);N.length=C}e.coalesceInPlace=D;function S(N,C,z){N.splice(z,0,N.splice(C,1)[0])}e.move=S;function a(N){return!Array.isArray(N)||N.length===0}e.isFalsyOrEmpty=a;function u(N){return Array.isArray(N)&&N.length>0}e.isNonEmptyArray=u;function c(N,C){if(!C)return N.filter((F,R)=>N.indexOf(F)===R);const z=Object.create(null);return N.filter(F=>{const R=C(F);return z[R]?!1:(z[R]=!0,!0)})}e.distinct=c;function l(N){const C=new Set;return N.filter(z=>C.has(z)?!1:(C.add(z),!0))}e.distinctES6=l;function t(N){const C=Object.create(null);return z=>{const F=N(z);return C[F]?!1:(C[F]=!0,!0)}}e.uniqueFilter=t;function r(N,C){for(let z=N.length-1;z>=0;z--){const F=N[z];if(C(F))return z}return-1}e.lastIndex=r;function s(N,C){return N.length>0?N[0]:C}e.firstOrDefault=s;function o(N,C,z=(F,R)=>F===R){let F=0;for(let R=0,W=Math.min(N.length,C.length);R<W&&z(N[R],C[R]);R++)F++;return F}e.commonPrefixLength=o;function d(N){return[].concat(...N)}e.flatten=d;function f(N,C){let z=typeof C=="number"?N:0;typeof C=="number"?z=N:(z=0,C=N);const F=[];if(z<=C)for(let R=z;R<C;R++)F.push(R);else for(let R=z;R>C;R--)F.push(R);return F}e.range=f;function h(N,C,z){return N.reduce((F,R)=>(F[C(R)]=z?z(R):R,F),Object.create(null))}e.index=h;function P(N,C){return N.push(C),()=>T(N,C)}e.insert=P;function T(N,C){const z=N.indexOf(C);if(z>-1)return N.splice(z,1),C}e.remove=T;function U(N,C,z){const F=N.slice(0,C),R=N.slice(C);return F.concat(z,R)}e.arrayInsert=U;function q(N,C){let z;if(typeof C=="number"){let F=C;z=()=>{const R=Math.sin(F++)*179426549;return R-Math.floor(R)}}else z=Math.random;for(let F=N.length-1;F>0;F-=1){const R=Math.floor(z()*(F+1)),W=N[F];N[F]=N[R],N[R]=W}}e.shuffle=q;function Q(N,C){const z=N.indexOf(C);z>-1&&(N.splice(z,1),N.unshift(C))}e.pushToStart=Q;function x(N,C){const z=N.indexOf(C);z>-1&&(N.splice(z,1),N.push(C))}e.pushToEnd=x;function j(N,C){return Array.isArray(N)?N.map(C):C(N)}e.mapArrayOrNot=j;function X(N){return Array.isArray(N)?N:[N]}e.asArray=X;function B(N){return N[Math.floor(Math.random()*N.length)]}e.getRandomElement=B;function V(N,C){for(const z of N){const F=C(z);if(F!==void 0)return F}}e.mapFind=V}),define(J[42],Z([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function m(L){const A=this;let b=!1,E;return function(){return b||(b=!0,E=L.apply(A,arguments)),E}}e.once=m}),define(J[63],Z([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var m;(function(L){function A(l){return l&&typeof l=="object"&&typeof l[Symbol.iterator]=="function"}L.is=A;const b=Object.freeze([]);function E(){return b}L.empty=E;function*n(l){yield l}L.single=n;function w(l){return l||b}L.from=w;function y(l){return!l||l[Symbol.iterator]().next().done===!0}L.isEmpty=y;function i(l){return l[Symbol.iterator]().next().value}L.first=i;function I(l,t){for(const r of l)if(t(r))return!0;return!1}L.some=I;function M(l,t){for(const r of l)if(t(r))return r}L.find=M;function*p(l,t){for(const r of l)t(r)&&(yield r)}L.filter=p;function*g(l,t){for(const r of l)yield t(r)}L.map=g;function*v(...l){for(const t of l)for(const r of t)yield r}L.concat=v;function*D(l){for(const t of l)for(const r of t)yield r}L.concatNested=D;function S(l,t,r){let s=r;for(const o of l)s=t(s,o);return s}L.reduce=S;function*a(l,t,r=l.length){for(t<0&&(t+=l.length),r<0?r+=l.length:r>l.length&&(r=l.length);t<r;t++)yield l[t]}L.slice=a;function u(l,t=Number.POSITIVE_INFINITY){const r=[];if(t===0)return[r,l];const s=l[Symbol.iterator]();for(let o=0;o<t;o++){const d=s.next();if(d.done)return[r,L.empty()];r.push(d.value)}return[r,{[Symbol.iterator](){return s}}]}L.consume=u;function c(l,t,r=(s,o)=>s===o){const s=l[Symbol.iterator](),o=t[Symbol.iterator]();for(;;){const d=s.next(),f=o.next();if(d.done!==f.done)return!1;if(d.done)return!0;if(!r(d.value,f.value))return!1}}L.equals=c})(m=e.Iterable||(e.Iterable={}))}),define(J[43],Z([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var m;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(m=e.ScanError||(e.ScanError={}));var L;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(L=e.SyntaxKind||(e.SyntaxKind={}));var A;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(A=e.ParseErrorCode||(e.ParseErrorCode={}));var b;(function(t){t.DEFAULT={allowTrailingComma:!0}})(b=e.ParseOptions||(e.ParseOptions={}));function E(t,r=!1){let s=0,o=t.length,d="",f=0,h=16,P=0;function T(B){let V=0,N=0;for(;V<B;){const C=t.charCodeAt(s);if(C>=48&&C<=57)N=N*16+C-48;else if(C>=65&&C<=70)N=N*16+C-65+10;else if(C>=97&&C<=102)N=N*16+C-97+10;else break;s++,V++}return V<B&&(N=-1),N}function U(B){s=B,d="",f=0,h=16,P=0}function q(){const B=s;if(t.charCodeAt(s)===48)s++;else for(s++;s<t.length&&y(t.charCodeAt(s));)s++;if(s<t.length&&t.charCodeAt(s)===46)if(s++,s<t.length&&y(t.charCodeAt(s)))for(s++;s<t.length&&y(t.charCodeAt(s));)s++;else return P=3,t.substring(B,s);let V=s;if(s<t.length&&(t.charCodeAt(s)===69||t.charCodeAt(s)===101))if(s++,(s<t.length&&t.charCodeAt(s)===43||t.charCodeAt(s)===45)&&s++,s<t.length&&y(t.charCodeAt(s))){for(s++;s<t.length&&y(t.charCodeAt(s));)s++;V=s}else P=3;return t.substring(B,V)}function Q(){let B="",V=s;for(;;){if(s>=o){B+=t.substring(V,s),P=2;break}const N=t.charCodeAt(s);if(N===34){B+=t.substring(V,s),s++;break}if(N===92){if(B+=t.substring(V,s),s++,s>=o){P=2;break}switch(t.charCodeAt(s++)){case 34:B+='"';break;case 92:B+="\\";break;case 47:B+="/";break;case 98:B+="\b";break;case 102:B+="\f";break;case 110:B+=`
`;break;case 114:B+="\r";break;case 116:B+="	";break;case 117:const z=T(4);z>=0?B+=String.fromCharCode(z):P=4;break;default:P=5}V=s;continue}if(N>=0&&N<=31)if(w(N)){B+=t.substring(V,s),P=2;break}else P=6;s++}return B}function x(){if(d="",P=0,f=s,s>=o)return f=o,h=17;let B=t.charCodeAt(s);if(n(B)){do s++,d+=String.fromCharCode(B),B=t.charCodeAt(s);while(n(B));return h=15}if(w(B))return s++,d+=String.fromCharCode(B),B===13&&t.charCodeAt(s)===10&&(s++,d+=`
`),h=14;switch(B){case 123:return s++,h=1;case 125:return s++,h=2;case 91:return s++,h=3;case 93:return s++,h=4;case 58:return s++,h=6;case 44:return s++,h=5;case 34:return s++,d=Q(),h=10;case 47:const V=s-1;if(t.charCodeAt(s+1)===47){for(s+=2;s<o&&!w(t.charCodeAt(s));)s++;return d=t.substring(V,s),h=12}if(t.charCodeAt(s+1)===42){s+=2;const N=o-1;let C=!1;for(;s<N;){if(t.charCodeAt(s)===42&&t.charCodeAt(s+1)===47){s+=2,C=!0;break}s++}return C||(s++,P=1),d=t.substring(V,s),h=13}return d+=String.fromCharCode(B),s++,h=16;case 45:if(d+=String.fromCharCode(B),s++,s===o||!y(t.charCodeAt(s)))return h=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return d+=q(),h=11;default:for(;s<o&&j(B);)s++,B=t.charCodeAt(s);if(f!==s){switch(d=t.substring(f,s),d){case"true":return h=8;case"false":return h=9;case"null":return h=7}return h=16}return d+=String.fromCharCode(B),s++,h=16}}function j(B){if(n(B)||w(B))return!1;switch(B){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function X(){let B;do B=x();while(B>=12&&B<=15);return B}return{setPosition:U,getPosition:()=>s,scan:r?X:x,getToken:()=>h,getTokenValue:()=>d,getTokenOffset:()=>f,getTokenLength:()=>s-f,getTokenError:()=>P}}e.createScanner=E;function n(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function w(t){return t===10||t===13||t===8232||t===8233}function y(t){return t>=48&&t<=57}var i;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(i||(i={}));function I(t,r){const s=[],o=new Object;let d;const f={value:{},offset:0,length:0,type:"object",parent:void 0};let h=!1;function P(T,U,q,Q){f.value=T,f.offset=U,f.length=q,f.type=Q,f.colonOffset=void 0,d=f}try{u(t,{onObjectBegin:(T,U)=>{if(r<=T)throw o;d=void 0,h=r>T,s.push("")},onObjectProperty:(T,U,q)=>{if(r<U||(P(T,U,q,"property"),s[s.length-1]=T,r<=U+q))throw o},onObjectEnd:(T,U)=>{if(r<=T)throw o;d=void 0,s.pop()},onArrayBegin:(T,U)=>{if(r<=T)throw o;d=void 0,s.push(0)},onArrayEnd:(T,U)=>{if(r<=T)throw o;d=void 0,s.pop()},onLiteralValue:(T,U,q)=>{if(r<U||(P(T,U,q,l(T)),r<=U+q))throw o},onSeparator:(T,U,q)=>{if(r<=U)throw o;if(T===":"&&d&&d.type==="property")d.colonOffset=U,h=!1,d=void 0;else if(T===","){const Q=s[s.length-1];typeof Q=="number"?s[s.length-1]=Q+1:(h=!0,s[s.length-1]=""),d=void 0}}})}catch(T){if(T!==o)throw T}return{path:s,previousNode:d,isAtPropertyKey:h,matches:T=>{let U=0;for(let q=0;U<T.length&&q<s.length;q++)if(T[U]===s[q]||T[U]==="*")U++;else if(T[U]!=="**")return!1;return U===T.length}}}e.getLocation=I;function M(t,r=[],s=b.DEFAULT){let o=null,d=[];const f=[];function h(T){Array.isArray(d)?d.push(T):o!==null&&(d[o]=T)}return u(t,{onObjectBegin:()=>{const T={};h(T),f.push(d),d=T,o=null},onObjectProperty:T=>{o=T},onObjectEnd:()=>{d=f.pop()},onArrayBegin:()=>{const T=[];h(T),f.push(d),d=T,o=null},onArrayEnd:()=>{d=f.pop()},onLiteralValue:h,onError:(T,U,q)=>{r.push({error:T,offset:U,length:q})}},s),d[0]}e.parse=M;function p(t,r=[],s=b.DEFAULT){let o={type:"array",offset:-1,length:-1,children:[],parent:void 0};function d(T){o.type==="property"&&(o.length=T-o.offset,o=o.parent)}function f(T){return o.children.push(T),T}u(t,{onObjectBegin:T=>{o=f({type:"object",offset:T,length:-1,parent:o,children:[]})},onObjectProperty:(T,U,q)=>{o=f({type:"property",offset:U,length:-1,parent:o,children:[]}),o.children.push({type:"string",value:T,offset:U,length:q,parent:o})},onObjectEnd:(T,U)=>{o.length=T+U-o.offset,o=o.parent,d(T+U)},onArrayBegin:(T,U)=>{o=f({type:"array",offset:T,length:-1,parent:o,children:[]})},onArrayEnd:(T,U)=>{o.length=T+U-o.offset,o=o.parent,d(T+U)},onLiteralValue:(T,U,q)=>{f({type:l(T),offset:U,length:q,parent:o,value:T}),d(U+q)},onSeparator:(T,U,q)=>{o.type==="property"&&(T===":"?o.colonOffset=U:T===","&&d(U))},onError:(T,U,q)=>{r.push({error:T,offset:U,length:q})}},s);const P=o.children[0];return P&&delete P.parent,P}e.parseTree=p;function g(t,r){if(!t)return;let s=t;for(let o of r)if(typeof o=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let d=!1;for(const f of s.children)if(Array.isArray(f.children)&&f.children[0].value===o){s=f.children[1],d=!0;break}if(!d)return}else{const d=o;if(s.type!=="array"||d<0||!Array.isArray(s.children)||d>=s.children.length)return;s=s.children[d]}return s}e.findNodeAtLocation=g;function v(t){if(!t.parent||!t.parent.children)return[];const r=v(t.parent);if(t.parent.type==="property"){const s=t.parent.children[0].value;r.push(s)}else if(t.parent.type==="array"){const s=t.parent.children.indexOf(t);s!==-1&&r.push(s)}return r}e.getNodePath=v;function D(t){switch(t.type){case"array":return t.children.map(D);case"object":const r=Object.create(null);for(let s of t.children){const o=s.children[1];o&&(r[s.children[0].value]=D(o))}return r;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=D;function S(t,r,s=!1){return r>=t.offset&&r<t.offset+t.length||s&&r===t.offset+t.length}e.contains=S;function a(t,r,s=!1){if(S(t,r,s)){const o=t.children;if(Array.isArray(o))for(let d=0;d<o.length&&o[d].offset<=r;d++){const f=a(o[d],r,s);if(f)return f}return t}}e.findNodeAtOffset=a;function u(t,r,s=b.DEFAULT){const o=E(t,!1);function d(_){return _?()=>_(o.getTokenOffset(),o.getTokenLength()):()=>!0}function f(_){return _?K=>_(K,o.getTokenOffset(),o.getTokenLength()):()=>!0}const h=d(r.onObjectBegin),P=f(r.onObjectProperty),T=d(r.onObjectEnd),U=d(r.onArrayBegin),q=d(r.onArrayEnd),Q=f(r.onLiteralValue),x=f(r.onSeparator),j=d(r.onComment),X=f(r.onError),B=s&&s.disallowComments,V=s&&s.allowTrailingComma;function N(){for(;;){const _=o.scan();switch(o.getTokenError()){case 4:C(14);break;case 5:C(15);break;case 3:C(13);break;case 1:B||C(11);break;case 2:C(12);break;case 6:C(16);break}switch(_){case 12:case 13:B?C(10):j();break;case 16:C(1);break;case 15:case 14:break;default:return _}}}function C(_,K=[],G=[]){if(X(_),K.length+G.length>0){let Y=o.getToken();for(;Y!==17;){if(K.indexOf(Y)!==-1){N();break}else if(G.indexOf(Y)!==-1)break;Y=N()}}}function z(_){const K=o.getTokenValue();return _?Q(K):P(K),N(),!0}function F(){switch(o.getToken()){case 11:let _=0;try{_=JSON.parse(o.getTokenValue()),typeof _!="number"&&(C(2),_=0)}catch(K){C(2)}Q(_);break;case 7:Q(null);break;case 8:Q(!0);break;case 9:Q(!1);break;default:return!1}return N(),!0}function R(){return o.getToken()!==10?(C(3,[],[2,5]),!1):(z(!1),o.getToken()===6?(x(":"),N(),O()||C(4,[],[2,5])):C(5,[],[2,5]),!0)}function W(){h(),N();let _=!1;for(;o.getToken()!==2&&o.getToken()!==17;){if(o.getToken()===5){if(_||C(4,[],[]),x(","),N(),o.getToken()===2&&V)break}else _&&C(6,[],[]);R()||C(4,[],[2,5]),_=!0}return T(),o.getToken()!==2?C(7,[2],[]):N(),!0}function k(){U(),N();let _=!1;for(;o.getToken()!==4&&o.getToken()!==17;){if(o.getToken()===5){if(_||C(4,[],[]),x(","),N(),o.getToken()===4&&V)break}else _&&C(6,[],[]);O()||C(4,[],[4,5]),_=!0}return q(),o.getToken()!==4?C(8,[4],[]):N(),!0}function O(){switch(o.getToken()){case 3:return k();case 1:return W();case 10:return z(!0);default:return F()}}return N(),o.getToken()===17?s.allowEmptyContent?!0:(C(4,[],[]),!1):O()?(o.getToken()!==17&&C(9,[],[]),!0):(C(4,[],[]),!1)}e.visit=u;function c(t,r){let s=E(t),o=[],d,f=0,h;do switch(h=s.getPosition(),d=s.scan(),d){case 12:case 13:case 17:f!==h&&o.push(t.substring(f,h)),r!==void 0&&o.push(s.getTokenValue().replace(/[^\r\n]/g,r)),f=s.getPosition();break}while(d!==17);return o.join("")}e.stripComments=c;function l(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=l}),define(J[103],Z([0,1,43]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function L(w,y,i){let I,M,p,g,v;if(y){for(g=y.offset,v=g+y.length,p=g;p>0&&!n(w,p-1);)p--;let f=v;for(;f<w.length&&!n(w,f);)f++;M=w.substring(p,f),I=b(M,i)}else M=w,I=0,p=0,g=0,v=w.length;const D=E(i,w);let S=!1,a=0,u;i.insertSpaces?u=A(" ",i.tabSize||4):u="	";const c=(0,m.createScanner)(M,!1);let l=!1;function t(){return D+A(u,I+a)}function r(){let f=c.scan();for(S=!1;f===15||f===14;)S=S||f===14,f=c.scan();return l=f===16||c.getTokenError()!==0,f}const s=[];function o(f,h,P){!l&&h<v&&P>g&&w.substring(h,P)!==f&&s.push({offset:h,length:P-h,content:f})}let d=r();if(d!==17){const f=c.getTokenOffset()+p,h=A(u,I);o(h,p,f)}for(;d!==17;){let f=c.getTokenOffset()+c.getTokenLength()+p,h=r(),P="";for(;!S&&(h===12||h===13);){const U=c.getTokenOffset()+p;o(" ",f,U),f=c.getTokenOffset()+c.getTokenLength()+p,P=h===12?t():"",h=r()}if(h===2)d!==1&&(a--,P=t());else if(h===4)d!==3&&(a--,P=t());else{switch(d){case 3:case 1:a++,P=t();break;case 5:case 12:P=t();break;case 13:S?P=t():P=" ";break;case 6:P=" ";break;case 10:if(h===6){P="";break}case 7:case 8:case 9:case 11:case 2:case 4:h===12||h===13?P=" ":h!==5&&h!==17&&(l=!0);break;case 16:l=!0;break}S&&(h===12||h===13)&&(P=t())}const T=c.getTokenOffset()+p;o(P,f,T),d=h}return s}e.format=L;function A(w,y){let i="";for(let I=0;I<y;I++)i+=w;return i}function b(w,y){let i=0,I=0;const M=y.tabSize||4;for(;i<w.length;){const p=w.charAt(i);if(p===" ")I++;else if(p==="	")I+=M;else break;i++}return Math.floor(I/M)}function E(w,y){for(let i=0;i<y.length;i++){const I=y.charAt(i);if(I==="\r")return i+1<y.length&&y.charAt(i+1)===`
`?`\r
`:"\r";if(I===`
`)return`
`}return w&&w.eol||`
`}e.getEOL=E;function n(w,y){return`\r
`.indexOf(w.charAt(y))!==-1}e.isEOL=n}),define(J[104],Z([0,1,43,103]),function($,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function A(y,i,I){return b(y,i,void 0,I)}e.removeProperty=A;function b(y,i,I,M,p){const g=i.slice(),v=[],D=(0,m.parseTree)(y,v);let S,a;for(;g.length>0&&(a=g.pop(),S=(0,m.findNodeAtLocation)(D,g),S===void 0&&I!==void 0);)typeof a=="string"?I={[a]:I}:I=[I];if(S)if(S.type==="object"&&typeof a=="string"&&Array.isArray(S.children)){const u=(0,m.findNodeAtLocation)(S,[a]);if(u!==void 0)if(I===void 0){if(!u.parent)throw new Error("Malformed AST");const c=S.children.indexOf(u.parent);let l,t=u.parent.offset+u.parent.length;if(c>0){const r=S.children[c-1];l=r.offset+r.length}else l=S.offset+1,S.children.length>1&&(t=S.children[1].offset);return E(y,{offset:l,length:t-l,content:""},M)}else return E(y,{offset:u.offset,length:u.length,content:JSON.stringify(I)},M);else{if(I===void 0)return[];const c=`${JSON.stringify(a)}: ${JSON.stringify(I)}`,l=p?p(S.children.map(r=>r.children[0].value)):S.children.length;let t;if(l>0){const r=S.children[l-1];t={offset:r.offset+r.length,length:0,content:","+c}}else S.children.length===0?t={offset:S.offset+1,length:0,content:c}:t={offset:S.offset+1,length:0,content:c+","};return E(y,t,M)}}else if(S.type==="array"&&typeof a=="number"&&Array.isArray(S.children))if(I!==void 0){const u=`${JSON.stringify(I)}`;let c;if(S.children.length===0||a===0)c={offset:S.offset+1,length:0,content:S.children.length===0?u:u+","};else{const l=a===-1||a>S.children.length?S.children.length:a,t=S.children[l-1];c={offset:t.offset+t.length,length:0,content:","+u}}return E(y,c,M)}else{const u=a,c=S.children[u];let l;if(S.children.length===1)l={offset:S.offset+1,length:S.length-2,content:""};else if(S.children.length-1===u){const t=S.children[u-1],r=t.offset+t.length,s=S.offset+S.length;l={offset:r,length:s-2-r,content:""}}else l={offset:c.offset,length:S.children[u+1].offset-c.offset,content:""};return E(y,l,M)}else throw new Error(`Can not add ${typeof a!="number"?"index":"property"} to parent of type ${S.type}`);else{if(I===void 0)throw new Error("Can not delete in empty document");return E(y,{offset:D?D.offset:0,length:D?D.length:0,content:JSON.stringify(I)},M)}}e.setProperty=b;function E(y,i,I){let M=n(y,i),p=i.offset,g=i.offset+i.content.length;if(i.length===0||i.content.length===0){for(;p>0&&!(0,L.isEOL)(M,p-1);)p--;for(;g<M.length&&!(0,L.isEOL)(M,g);)g++}const v=(0,L.format)(M,{offset:p,length:g-p},I);for(let S=v.length-1;S>=0;S--){const a=v[S];M=n(M,a),p=Math.min(p,a.offset),g=Math.max(g,a.offset+a.length),g+=a.content.length-a.length}const D=y.length-(M.length-g)-p;return[{offset:p,length:D,content:M.substring(p,g)}]}e.withFormatting=E;function n(y,i){return y.substring(0,i.offset)+i.content+y.substring(i.offset+i.length)}e.applyEdit=n;function w(y,i){let I=i.slice(0).sort((p,g)=>{const v=p.offset-g.offset;return v===0?p.length-g.length:v}),M=y.length;for(let p=I.length-1;p>=0;p--){let g=I[p];if(g.offset+g.length<=M)y=n(y,g);else throw new Error("Overlapping edit");M=g.offset}return y}e.applyEdits=w}),define(J[57],Z([0,1,19]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedKeybinding=e.ResolvedKeybindingPart=e.ChordKeybinding=e.SimpleKeybinding=e.createSimpleKeybinding=e.createKeybinding=e.KeyChord=e.KeyMod=e.KeyCodeUtils=e.KeyCode=void 0;var L;(function(a){a[a.DependsOnKbLayout=-1]="DependsOnKbLayout",a[a.Unknown=0]="Unknown",a[a.Backspace=1]="Backspace",a[a.Tab=2]="Tab",a[a.Enter=3]="Enter",a[a.Shift=4]="Shift",a[a.Ctrl=5]="Ctrl",a[a.Alt=6]="Alt",a[a.PauseBreak=7]="PauseBreak",a[a.CapsLock=8]="CapsLock",a[a.Escape=9]="Escape",a[a.Space=10]="Space",a[a.PageUp=11]="PageUp",a[a.PageDown=12]="PageDown",a[a.End=13]="End",a[a.Home=14]="Home",a[a.LeftArrow=15]="LeftArrow",a[a.UpArrow=16]="UpArrow",a[a.RightArrow=17]="RightArrow",a[a.DownArrow=18]="DownArrow",a[a.Insert=19]="Insert",a[a.Delete=20]="Delete",a[a.KEY_0=21]="KEY_0",a[a.KEY_1=22]="KEY_1",a[a.KEY_2=23]="KEY_2",a[a.KEY_3=24]="KEY_3",a[a.KEY_4=25]="KEY_4",a[a.KEY_5=26]="KEY_5",a[a.KEY_6=27]="KEY_6",a[a.KEY_7=28]="KEY_7",a[a.KEY_8=29]="KEY_8",a[a.KEY_9=30]="KEY_9",a[a.KEY_A=31]="KEY_A",a[a.KEY_B=32]="KEY_B",a[a.KEY_C=33]="KEY_C",a[a.KEY_D=34]="KEY_D",a[a.KEY_E=35]="KEY_E",a[a.KEY_F=36]="KEY_F",a[a.KEY_G=37]="KEY_G",a[a.KEY_H=38]="KEY_H",a[a.KEY_I=39]="KEY_I",a[a.KEY_J=40]="KEY_J",a[a.KEY_K=41]="KEY_K",a[a.KEY_L=42]="KEY_L",a[a.KEY_M=43]="KEY_M",a[a.KEY_N=44]="KEY_N",a[a.KEY_O=45]="KEY_O",a[a.KEY_P=46]="KEY_P",a[a.KEY_Q=47]="KEY_Q",a[a.KEY_R=48]="KEY_R",a[a.KEY_S=49]="KEY_S",a[a.KEY_T=50]="KEY_T",a[a.KEY_U=51]="KEY_U",a[a.KEY_V=52]="KEY_V",a[a.KEY_W=53]="KEY_W",a[a.KEY_X=54]="KEY_X",a[a.KEY_Y=55]="KEY_Y",a[a.KEY_Z=56]="KEY_Z",a[a.Meta=57]="Meta",a[a.ContextMenu=58]="ContextMenu",a[a.F1=59]="F1",a[a.F2=60]="F2",a[a.F3=61]="F3",a[a.F4=62]="F4",a[a.F5=63]="F5",a[a.F6=64]="F6",a[a.F7=65]="F7",a[a.F8=66]="F8",a[a.F9=67]="F9",a[a.F10=68]="F10",a[a.F11=69]="F11",a[a.F12=70]="F12",a[a.F13=71]="F13",a[a.F14=72]="F14",a[a.F15=73]="F15",a[a.F16=74]="F16",a[a.F17=75]="F17",a[a.F18=76]="F18",a[a.F19=77]="F19",a[a.NumLock=78]="NumLock",a[a.ScrollLock=79]="ScrollLock",a[a.US_SEMICOLON=80]="US_SEMICOLON",a[a.US_EQUAL=81]="US_EQUAL",a[a.US_COMMA=82]="US_COMMA",a[a.US_MINUS=83]="US_MINUS",a[a.US_DOT=84]="US_DOT",a[a.US_SLASH=85]="US_SLASH",a[a.US_BACKTICK=86]="US_BACKTICK",a[a.US_OPEN_SQUARE_BRACKET=87]="US_OPEN_SQUARE_BRACKET",a[a.US_BACKSLASH=88]="US_BACKSLASH",a[a.US_CLOSE_SQUARE_BRACKET=89]="US_CLOSE_SQUARE_BRACKET",a[a.US_QUOTE=90]="US_QUOTE",a[a.OEM_8=91]="OEM_8",a[a.OEM_102=92]="OEM_102",a[a.NUMPAD_0=93]="NUMPAD_0",a[a.NUMPAD_1=94]="NUMPAD_1",a[a.NUMPAD_2=95]="NUMPAD_2",a[a.NUMPAD_3=96]="NUMPAD_3",a[a.NUMPAD_4=97]="NUMPAD_4",a[a.NUMPAD_5=98]="NUMPAD_5",a[a.NUMPAD_6=99]="NUMPAD_6",a[a.NUMPAD_7=100]="NUMPAD_7",a[a.NUMPAD_8=101]="NUMPAD_8",a[a.NUMPAD_9=102]="NUMPAD_9",a[a.NUMPAD_MULTIPLY=103]="NUMPAD_MULTIPLY",a[a.NUMPAD_ADD=104]="NUMPAD_ADD",a[a.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",a[a.NUMPAD_SUBTRACT=106]="NUMPAD_SUBTRACT",a[a.NUMPAD_DECIMAL=107]="NUMPAD_DECIMAL",a[a.NUMPAD_DIVIDE=108]="NUMPAD_DIVIDE",a[a.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",a[a.ABNT_C1=110]="ABNT_C1",a[a.ABNT_C2=111]="ABNT_C2",a[a.MAX_VALUE=112]="MAX_VALUE"})(L=e.KeyCode||(e.KeyCode={}));class A{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(u,c){this._keyCodeToStr[u]=c,this._strToKeyCode[c.toLowerCase()]=u}keyCodeToStr(u){return this._keyCodeToStr[u]}strToKeyCode(u){return this._strToKeyCode[u.toLowerCase()]||0}}const b=new A,E=new A,n=new A;(function(){function a(u,c,l=c,t=l){b.define(u,c),E.define(u,l),n.define(u,t)}a(0,"unknown"),a(1,"Backspace"),a(2,"Tab"),a(3,"Enter"),a(4,"Shift"),a(5,"Ctrl"),a(6,"Alt"),a(7,"PauseBreak"),a(8,"CapsLock"),a(9,"Escape"),a(10,"Space"),a(11,"PageUp"),a(12,"PageDown"),a(13,"End"),a(14,"Home"),a(15,"LeftArrow","Left"),a(16,"UpArrow","Up"),a(17,"RightArrow","Right"),a(18,"DownArrow","Down"),a(19,"Insert"),a(20,"Delete"),a(21,"0"),a(22,"1"),a(23,"2"),a(24,"3"),a(25,"4"),a(26,"5"),a(27,"6"),a(28,"7"),a(29,"8"),a(30,"9"),a(31,"A"),a(32,"B"),a(33,"C"),a(34,"D"),a(35,"E"),a(36,"F"),a(37,"G"),a(38,"H"),a(39,"I"),a(40,"J"),a(41,"K"),a(42,"L"),a(43,"M"),a(44,"N"),a(45,"O"),a(46,"P"),a(47,"Q"),a(48,"R"),a(49,"S"),a(50,"T"),a(51,"U"),a(52,"V"),a(53,"W"),a(54,"X"),a(55,"Y"),a(56,"Z"),a(57,"Meta"),a(58,"ContextMenu"),a(59,"F1"),a(60,"F2"),a(61,"F3"),a(62,"F4"),a(63,"F5"),a(64,"F6"),a(65,"F7"),a(66,"F8"),a(67,"F9"),a(68,"F10"),a(69,"F11"),a(70,"F12"),a(71,"F13"),a(72,"F14"),a(73,"F15"),a(74,"F16"),a(75,"F17"),a(76,"F18"),a(77,"F19"),a(78,"NumLock"),a(79,"ScrollLock"),a(80,";",";","OEM_1"),a(81,"=","=","OEM_PLUS"),a(82,",",",","OEM_COMMA"),a(83,"-","-","OEM_MINUS"),a(84,".",".","OEM_PERIOD"),a(85,"/","/","OEM_2"),a(86,"`","`","OEM_3"),a(110,"ABNT_C1"),a(111,"ABNT_C2"),a(87,"[","[","OEM_4"),a(88,"\\","\\","OEM_5"),a(89,"]","]","OEM_6"),a(90,"'","'","OEM_7"),a(91,"OEM_8"),a(92,"OEM_102"),a(93,"NumPad0"),a(94,"NumPad1"),a(95,"NumPad2"),a(96,"NumPad3"),a(97,"NumPad4"),a(98,"NumPad5"),a(99,"NumPad6"),a(100,"NumPad7"),a(101,"NumPad8"),a(102,"NumPad9"),a(103,"NumPad_Multiply"),a(104,"NumPad_Add"),a(105,"NumPad_Separator"),a(106,"NumPad_Subtract"),a(107,"NumPad_Decimal"),a(108,"NumPad_Divide")})();var w;(function(a){function u(s){return b.keyCodeToStr(s)}a.toString=u;function c(s){return b.strToKeyCode(s)}a.fromString=c;function l(s){return E.keyCodeToStr(s)}a.toUserSettingsUS=l;function t(s){return n.keyCodeToStr(s)}a.toUserSettingsGeneral=t;function r(s){return E.strToKeyCode(s)||n.strToKeyCode(s)}a.fromUserSettings=r})(w=e.KeyCodeUtils||(e.KeyCodeUtils={}));var y;(function(a){a[a.CtrlCmd=2048]="CtrlCmd",a[a.Shift=1024]="Shift",a[a.Alt=512]="Alt",a[a.WinCtrl=256]="WinCtrl",a[a.KeyCode=255]="KeyCode"})(y||(y={}));var i;(function(a){a[a.CtrlCmd=2048]="CtrlCmd",a[a.Shift=1024]="Shift",a[a.Alt=512]="Alt",a[a.WinCtrl=256]="WinCtrl"})(i=e.KeyMod||(e.KeyMod={}));function I(a,u){const c=(u&65535)<<16>>>0;return(a|c)>>>0}e.KeyChord=I;function M(a,u){if(a===0)return null;const c=(a&65535)>>>0,l=(a&4294901760)>>>16;return l!==0?new v([p(c,u),p(l,u)]):new v([p(c,u)])}e.createKeybinding=M;function p(a,u){const c=!!(a&2048),l=!!(a&256),t=u===2?l:c,r=!!(a&1024),s=!!(a&512),o=u===2?c:l,d=a&255;return new g(t,r,s,o,d)}e.createSimpleKeybinding=p;class g{constructor(u,c,l,t,r){this.ctrlKey=u,this.shiftKey=c,this.altKey=l,this.metaKey=t,this.keyCode=r}equals(u){return this.ctrlKey===u.ctrlKey&&this.shiftKey===u.shiftKey&&this.altKey===u.altKey&&this.metaKey===u.metaKey&&this.keyCode===u.keyCode}getHashCode(){const u=this.ctrlKey?"1":"0",c=this.shiftKey?"1":"0",l=this.altKey?"1":"0",t=this.metaKey?"1":"0";return`${u}${c}${l}${t}${this.keyCode}`}isModifierKey(){return this.keyCode===0||this.keyCode===5||this.keyCode===57||this.keyCode===6||this.keyCode===4}toChord(){return new v([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===5||this.shiftKey&&this.keyCode===4||this.altKey&&this.keyCode===6||this.metaKey&&this.keyCode===57}}e.SimpleKeybinding=g;class v{constructor(u){if(u.length===0)throw(0,m.illegalArgument)("parts");this.parts=u}getHashCode(){let u="";for(let c=0,l=this.parts.length;c<l;c++)c!==0&&(u+=";"),u+=this.parts[c].getHashCode();return u}equals(u){if(u===null||this.parts.length!==u.parts.length)return!1;for(let c=0;c<this.parts.length;c++)if(!this.parts[c].equals(u.parts[c]))return!1;return!0}}e.ChordKeybinding=v;class D{constructor(u,c,l,t,r,s){this.ctrlKey=u,this.shiftKey=c,this.altKey=l,this.metaKey=t,this.keyLabel=r,this.keyAriaLabel=s}}e.ResolvedKeybindingPart=D;class S{}e.ResolvedKeybinding=S}),define(J[2],Z([0,1,42,63]),function($,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.ReferenceCollection=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.trackDisposable=e.setDisposableTracker=void 0;const A=!1;let b=null;function E(u){b=u}if(e.setDisposableTracker=E,A){const u="__is_disposable_tracked__";b=new class{trackDisposable(c){const l=new Error("Potentially leaked disposable").stack;setTimeout(()=>{c[u]||console.log(l)},3e3)}markTracked(c){if(c&&c!==v.None)try{c[u]=!0}catch(l){}}}}function n(u){!b||b.markTracked(u)}function w(u){return b&&b.trackDisposable(u),u}e.trackDisposable=w;class y extends Error{constructor(c){super(`Encountered errors while disposing of store. Errors: [${c.join(", ")}]`);this.errors=c}}e.MultiDisposeError=y;function i(u){return typeof u.dispose=="function"&&u.dispose.length===0}e.isDisposable=i;function I(u){if(L.Iterable.is(u)){let c=[];for(const l of u)if(l){n(l);try{l.dispose()}catch(t){c.push(t)}}if(c.length===1)throw c[0];if(c.length>1)throw new y(c);return Array.isArray(u)?[]:u}else if(u)return n(u),u.dispose(),u}e.dispose=I;function M(...u){return u.forEach(n),p(()=>I(u))}e.combinedDisposable=M;function p(u){const c=w({dispose:()=>{n(c),u()}});return c}e.toDisposable=p;class g{constructor(){this._toDispose=new Set,this._isDisposed=!1}dispose(){this._isDisposed||(n(this),this._isDisposed=!0,this.clear())}clear(){try{I(this._toDispose.values())}finally{this._toDispose.clear()}}add(c){if(!c)return c;if(c===this)throw new Error("Cannot register a disposable on itself!");return n(c),this._isDisposed?g.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(c),c}}e.DisposableStore=g,g.DISABLE_DISPOSED_WARNING=!1;class v{constructor(){this._store=new g,w(this)}dispose(){n(this),this._store.dispose()}_register(c){if(c===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(c)}}e.Disposable=v,v.None=Object.freeze({dispose(){}});class D{constructor(){this._isDisposed=!1,w(this)}get value(){return this._isDisposed?void 0:this._value}set value(c){var l;this._isDisposed||c===this._value||((l=this._value)===null||l===void 0||l.dispose(),c&&n(c),this._value=c)}clear(){this.value=void 0}dispose(){var c;this._isDisposed=!0,n(this),(c=this._value)===null||c===void 0||c.dispose(),this._value=void 0}}e.MutableDisposable=D;class S{constructor(){this.references=new Map}acquire(c,...l){let t=this.references.get(c);t||(t={counter:0,object:this.createReferencedObject(c,...l)},this.references.set(c,t));const{object:r}=t,s=(0,m.once)(()=>{--t.counter==0&&(this.destroyReferencedObject(c,t.object),this.references.delete(c))});return t.counter++,{object:r,dispose:s}}}e.ReferenceCollection=S;class a{constructor(c){this.object=c}dispose(){}}e.ImmortalReference=a}),define(J[78],Z([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class m{constructor(b){this.element=b,this.next=m.Undefined,this.prev=m.Undefined}}m.Undefined=new m(void 0);class L{constructor(){this._first=m.Undefined,this._last=m.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===m.Undefined}clear(){let b=this._first;for(;b!==m.Undefined;){const E=b.next;b.prev=m.Undefined,b.next=m.Undefined,b=E}this._first=m.Undefined,this._last=m.Undefined,this._size=0}unshift(b){return this._insert(b,!1)}push(b){return this._insert(b,!0)}_insert(b,E){const n=new m(b);if(this._first===m.Undefined)this._first=n,this._last=n;else if(E){const y=this._last;this._last=n,n.prev=y,y.next=n}else{const y=this._first;this._first=n,n.next=y,y.prev=n}this._size+=1;let w=!1;return()=>{w||(w=!0,this._remove(n))}}shift(){if(this._first!==m.Undefined){const b=this._first.element;return this._remove(this._first),b}}pop(){if(this._last!==m.Undefined){const b=this._last.element;return this._remove(this._last),b}}_remove(b){if(b.prev!==m.Undefined&&b.next!==m.Undefined){const E=b.prev;E.next=b.next,b.next.prev=E}else b.prev===m.Undefined&&b.next===m.Undefined?(this._first=m.Undefined,this._last=m.Undefined):b.next===m.Undefined?(this._last=this._last.prev,this._last.next=m.Undefined):b.prev===m.Undefined&&(this._first=this._first.next,this._first.prev=m.Undefined);this._size-=1}*[Symbol.iterator](){let b=this._first;for(;b!==m.Undefined;)yield b.element,b=b.next}}e.LinkedList=L}),function(){function $(A){const b=[];typeof A=="number"&&b.push("code/timeOrigin",A);function E(w){b.push(w,Date.now())}function n(){const w=[];for(let y=0;y<b.length;y+=2)w.push({name:b[y],startTime:b[y+1]});return w}return{mark:E,getMarks:n}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?$():{mark(A){performance.mark(A)},getMarks(){let A=performance.timeOrigin;typeof A!="number"&&(A=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const b=[{name:"code/timeOrigin",startTime:Math.round(A)}];for(const E of performance.getEntriesByType("mark"))b.push({name:E.name,startTime:Math.round(A+E.startTime)});return b}};if(typeof process=="object"){const A=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return $(A)}else return console.trace("perf-util loaded in UNKNOWN environment"),$()}function m(A){return A.MonacoPerformanceMarks||(A.MonacoPerformanceMarks=e()),A.MonacoPerformanceMarks}var L;typeof global=="object"?L=global:typeof self=="object"?L=self:L={},typeof define=="function"?define("vs/base/common/performance",[],function(){return m(L)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=m(L):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),L.perf=m(L))}(),define(J[3],Z([0,1]),function($,e){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isPreferringBrowserCodeLoad=e.browserCodeLoadingCacheStrategy=e.isElectronSandboxed=e.globals=void 0;const L="en";let A=!1,b=!1,E=!1,n=!1,w=!1,y=!1,i=!1,I,M=L,p,g;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let v;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?v=e.globals.vscode.process:typeof process!="undefined"&&(v=process);const D=typeof((m=v==null?void 0:v.versions)===null||m===void 0?void 0:m.electron)=="string"&&v.type==="renderer";if(e.isElectronSandboxed=D&&(v==null?void 0:v.sandboxed),e.browserCodeLoadingCacheStrategy=(()=>{if(e.isElectronSandboxed)return"bypassHeatCheck";const o=v==null?void 0:v.env.VSCODE_BROWSER_CODE_LOADING;if(typeof o=="string")return o==="none"||o==="code"||o==="bypassHeatCheck"||o==="bypassHeatCheckAndEagerCompile"?o:"bypassHeatCheck"})(),e.isPreferringBrowserCodeLoad=typeof e.browserCodeLoadingCacheStrategy=="string",typeof navigator=="object"&&!D)g=navigator.userAgent,A=g.indexOf("Windows")>=0,b=g.indexOf("Macintosh")>=0,i=(g.indexOf("Macintosh")>=0||g.indexOf("iPad")>=0||g.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,E=g.indexOf("Linux")>=0,y=!0,I=navigator.language,M=I;else if(typeof v=="object"){A=v.platform==="win32",b=v.platform==="darwin",E=v.platform==="linux",n=E&&!!v.env.SNAP&&!!v.env.SNAP_REVISION,I=L,M=L;const o=v.env.VSCODE_NLS_CONFIG;if(o)try{const d=JSON.parse(o),f=d.availableLanguages["*"];I=d.locale,M=f||L,p=d._translationsConfigFile}catch(d){}w=!0}else console.error("Unable to resolve platform.");var S;(function(o){o[o.Web=0]="Web",o[o.Mac=1]="Mac",o[o.Linux=2]="Linux",o[o.Windows=3]="Windows"})(S=e.Platform||(e.Platform={}));function a(o){switch(o){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=a;let u=0;b?u=1:A?u=3:E&&(u=2),e.isWindows=A,e.isMacintosh=b,e.isLinux=E,e.isLinuxSnap=n,e.isNative=w,e.isWeb=y,e.isIOS=i,e.platform=u,e.userAgent=g,e.language=M;var c;(function(o){function d(){return e.language}o.value=d;function f(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}o.isDefaultVariant=f;function h(){return e.language==="en"}o.isDefault=h})(c=e.Language||(e.Language={})),e.locale=I,e.translationsConfigFile=p,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let f=[];e.globals.addEventListener("message",P=>{if(P.data&&P.data.vscodeSetImmediateId)for(let T=0,U=f.length;T<U;T++){const q=f[T];if(q.id===P.data.vscodeSetImmediateId){f.splice(T,1),q.callback();return}}});let h=0;return P=>{const T=++h;f.push({id:T,callback:P}),e.globals.postMessage({vscodeSetImmediateId:T},"*")}}if(typeof(v==null?void 0:v.nextTick)=="function")return v.nextTick.bind(v);const d=Promise.resolve();return f=>d.then(f)}();var l;(function(o){o[o.Windows=1]="Windows",o[o.Macintosh=2]="Macintosh",o[o.Linux=3]="Linux"})(l=e.OperatingSystem||(e.OperatingSystem={})),e.OS=b||i?2:A?1:3;let t=!0,r=!1;function s(){if(!r){r=!0;const o=new Uint8Array(2);o[0]=1,o[1]=2,t=new Uint16Array(o.buffer)[0]===(2<<8)+1}return t}e.isLittleEndian=s}),define(J[32],Z([0,1,3]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let L;if(typeof m.globals.vscode!="undefined"&&typeof m.globals.vscode.process!="undefined"){const A=m.globals.vscode.process;L={get platform(){return A.platform},get env(){return A.env},cwd(){return A.cwd()},nextTick(b){return(0,m.setImmediate)(b)}}}else typeof process!="undefined"?L={get platform(){return process.platform},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(A){return process.nextTick(A)}}:L={get platform(){return m.isWindows?"win32":m.isMacintosh?"darwin":"linux"},nextTick(A){return(0,m.setImmediate)(A)},get env(){return Object.create(null)},cwd(){return"/"}};e.cwd=L.cwd,e.env=L.env,e.platform=L.platform,e.nextTick=L.nextTick}),define(J[8],Z([0,1,32]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const L=65,A=97,b=90,E=122,n=46,w=47,y=92,i=58,I=63;class M extends Error{constructor(c,l,t){let r;typeof l=="string"&&l.indexOf("not ")===0?(r="must not be",l=l.replace(/^not /,"")):r="must be";const s=c.indexOf(".")!==-1?"property":"argument";let o=`The "${c}" ${s} ${r} of type ${l}`;o+=`. Received type ${typeof t}`,super(o),this.code="ERR_INVALID_ARG_TYPE"}}function p(u,c){if(typeof u!="string")throw new M(c,"string",u)}function g(u){return u===w||u===y}function v(u){return u===w}function D(u){return u>=L&&u<=b||u>=A&&u<=E}function S(u,c,l,t){let r="",s=0,o=-1,d=0,f=0;for(let h=0;h<=u.length;++h){if(h<u.length)f=u.charCodeAt(h);else{if(t(f))break;f=w}if(t(f)){if(!(o===h-1||d===1))if(d===2){if(r.length<2||s!==2||r.charCodeAt(r.length-1)!==n||r.charCodeAt(r.length-2)!==n){if(r.length>2){const P=r.lastIndexOf(l);P===-1?(r="",s=0):(r=r.slice(0,P),s=r.length-1-r.lastIndexOf(l)),o=h,d=0;continue}else if(r.length!==0){r="",s=0,o=h,d=0;continue}}c&&(r+=r.length>0?`${l}..`:"..",s=2)}else r.length>0?r+=`${l}${u.slice(o+1,h)}`:r=u.slice(o+1,h),s=h-o-1;o=h,d=0}else f===n&&d!==-1?++d:d=-1}return r}function a(u,c){if(c===null||typeof c!="object")throw new M("pathObject","Object",c);const l=c.dir||c.root,t=c.base||`${c.name||""}${c.ext||""}`;return l?l===c.root?`${l}${t}`:`${l}${u}${t}`:t}e.win32={resolve(...u){let c="",l="",t=!1;for(let r=u.length-1;r>=-1;r--){let s;if(r>=0){if(s=u[r],p(s,"path"),s.length===0)continue}else c.length===0?s=m.cwd():(s=m.env[`=${c}`]||m.cwd(),(s===void 0||s.slice(0,2).toLowerCase()!==c.toLowerCase()&&s.charCodeAt(2)===y)&&(s=`${c}\\`));const o=s.length;let d=0,f="",h=!1;const P=s.charCodeAt(0);if(o===1)g(P)&&(d=1,h=!0);else if(g(P))if(h=!0,g(s.charCodeAt(1))){let T=2,U=T;for(;T<o&&!g(s.charCodeAt(T));)T++;if(T<o&&T!==U){const q=s.slice(U,T);for(U=T;T<o&&g(s.charCodeAt(T));)T++;if(T<o&&T!==U){for(U=T;T<o&&!g(s.charCodeAt(T));)T++;(T===o||T!==U)&&(f=`\\\\${q}\\${s.slice(U,T)}`,d=T)}}}else d=1;else D(P)&&s.charCodeAt(1)===i&&(f=s.slice(0,2),d=2,o>2&&g(s.charCodeAt(2))&&(h=!0,d=3));if(f.length>0)if(c.length>0){if(f.toLowerCase()!==c.toLowerCase())continue}else c=f;if(t){if(c.length>0)break}else if(l=`${s.slice(d)}\\${l}`,t=h,h&&c.length>0)break}return l=S(l,!t,"\\",g),t?`${c}\\${l}`:`${c}${l}`||"."},normalize(u){p(u,"path");const c=u.length;if(c===0)return".";let l=0,t,r=!1;const s=u.charCodeAt(0);if(c===1)return v(s)?"\\":u;if(g(s))if(r=!0,g(u.charCodeAt(1))){let d=2,f=d;for(;d<c&&!g(u.charCodeAt(d));)d++;if(d<c&&d!==f){const h=u.slice(f,d);for(f=d;d<c&&g(u.charCodeAt(d));)d++;if(d<c&&d!==f){for(f=d;d<c&&!g(u.charCodeAt(d));)d++;if(d===c)return`\\\\${h}\\${u.slice(f)}\\`;d!==f&&(t=`\\\\${h}\\${u.slice(f,d)}`,l=d)}}}else l=1;else D(s)&&u.charCodeAt(1)===i&&(t=u.slice(0,2),l=2,c>2&&g(u.charCodeAt(2))&&(r=!0,l=3));let o=l<c?S(u.slice(l),!r,"\\",g):"";return o.length===0&&!r&&(o="."),o.length>0&&g(u.charCodeAt(c-1))&&(o+="\\"),t===void 0?r?`\\${o}`:o:r?`${t}\\${o}`:`${t}${o}`},isAbsolute(u){p(u,"path");const c=u.length;if(c===0)return!1;const l=u.charCodeAt(0);return g(l)||c>2&&D(l)&&u.charCodeAt(1)===i&&g(u.charCodeAt(2))},join(...u){if(u.length===0)return".";let c,l;for(let s=0;s<u.length;++s){const o=u[s];p(o,"path"),o.length>0&&(c===void 0?c=l=o:c+=`\\${o}`)}if(c===void 0)return".";let t=!0,r=0;if(typeof l=="string"&&g(l.charCodeAt(0))){++r;const s=l.length;s>1&&g(l.charCodeAt(1))&&(++r,s>2&&(g(l.charCodeAt(2))?++r:t=!1))}if(t){for(;r<c.length&&g(c.charCodeAt(r));)r++;r>=2&&(c=`\\${c.slice(r)}`)}return e.win32.normalize(c)},relative(u,c){if(p(u,"from"),p(c,"to"),u===c)return"";const l=e.win32.resolve(u),t=e.win32.resolve(c);if(l===t||(u=l.toLowerCase(),c=t.toLowerCase(),u===c))return"";let r=0;for(;r<u.length&&u.charCodeAt(r)===y;)r++;let s=u.length;for(;s-1>r&&u.charCodeAt(s-1)===y;)s--;const o=s-r;let d=0;for(;d<c.length&&c.charCodeAt(d)===y;)d++;let f=c.length;for(;f-1>d&&c.charCodeAt(f-1)===y;)f--;const h=f-d,P=o<h?o:h;let T=-1,U=0;for(;U<P;U++){const Q=u.charCodeAt(r+U);if(Q!==c.charCodeAt(d+U))break;Q===y&&(T=U)}if(U!==P){if(T===-1)return t}else{if(h>P){if(c.charCodeAt(d+U)===y)return t.slice(d+U+1);if(U===2)return t.slice(d+U)}o>P&&(u.charCodeAt(r+U)===y?T=U:U===2&&(T=3)),T===-1&&(T=0)}let q="";for(U=r+T+1;U<=s;++U)(U===s||u.charCodeAt(U)===y)&&(q+=q.length===0?"..":"\\..");return d+=T,q.length>0?`${q}${t.slice(d,f)}`:(t.charCodeAt(d)===y&&++d,t.slice(d,f))},toNamespacedPath(u){if(typeof u!="string")return u;if(u.length===0)return"";const c=e.win32.resolve(u);if(c.length<=2)return u;if(c.charCodeAt(0)===y){if(c.charCodeAt(1)===y){const l=c.charCodeAt(2);if(l!==I&&l!==n)return`\\\\?\\UNC\\${c.slice(2)}`}}else if(D(c.charCodeAt(0))&&c.charCodeAt(1)===i&&c.charCodeAt(2)===y)return`\\\\?\\${c}`;return u},dirname(u){p(u,"path");const c=u.length;if(c===0)return".";let l=-1,t=0;const r=u.charCodeAt(0);if(c===1)return g(r)?u:".";if(g(r)){if(l=t=1,g(u.charCodeAt(1))){let d=2,f=d;for(;d<c&&!g(u.charCodeAt(d));)d++;if(d<c&&d!==f){for(f=d;d<c&&g(u.charCodeAt(d));)d++;if(d<c&&d!==f){for(f=d;d<c&&!g(u.charCodeAt(d));)d++;if(d===c)return u;d!==f&&(l=t=d+1)}}}}else D(r)&&u.charCodeAt(1)===i&&(l=c>2&&g(u.charCodeAt(2))?3:2,t=l);let s=-1,o=!0;for(let d=c-1;d>=t;--d)if(g(u.charCodeAt(d))){if(!o){s=d;break}}else o=!1;if(s===-1){if(l===-1)return".";s=l}return u.slice(0,s)},basename(u,c){c!==void 0&&p(c,"ext"),p(u,"path");let l=0,t=-1,r=!0,s;if(u.length>=2&&D(u.charCodeAt(0))&&u.charCodeAt(1)===i&&(l=2),c!==void 0&&c.length>0&&c.length<=u.length){if(c===u)return"";let o=c.length-1,d=-1;for(s=u.length-1;s>=l;--s){const f=u.charCodeAt(s);if(g(f)){if(!r){l=s+1;break}}else d===-1&&(r=!1,d=s+1),o>=0&&(f===c.charCodeAt(o)?--o==-1&&(t=s):(o=-1,t=d))}return l===t?t=d:t===-1&&(t=u.length),u.slice(l,t)}for(s=u.length-1;s>=l;--s)if(g(u.charCodeAt(s))){if(!r){l=s+1;break}}else t===-1&&(r=!1,t=s+1);return t===-1?"":u.slice(l,t)},extname(u){p(u,"path");let c=0,l=-1,t=0,r=-1,s=!0,o=0;u.length>=2&&u.charCodeAt(1)===i&&D(u.charCodeAt(0))&&(c=t=2);for(let d=u.length-1;d>=c;--d){const f=u.charCodeAt(d);if(g(f)){if(!s){t=d+1;break}continue}r===-1&&(s=!1,r=d+1),f===n?l===-1?l=d:o!==1&&(o=1):l!==-1&&(o=-1)}return l===-1||r===-1||o===0||o===1&&l===r-1&&l===t+1?"":u.slice(l,r)},format:a.bind(null,"\\"),parse(u){p(u,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(u.length===0)return c;const l=u.length;let t=0,r=u.charCodeAt(0);if(l===1)return g(r)?(c.root=c.dir=u,c):(c.base=c.name=u,c);if(g(r)){if(t=1,g(u.charCodeAt(1))){let T=2,U=T;for(;T<l&&!g(u.charCodeAt(T));)T++;if(T<l&&T!==U){for(U=T;T<l&&g(u.charCodeAt(T));)T++;if(T<l&&T!==U){for(U=T;T<l&&!g(u.charCodeAt(T));)T++;T===l?t=T:T!==U&&(t=T+1)}}}}else if(D(r)&&u.charCodeAt(1)===i){if(l<=2)return c.root=c.dir=u,c;if(t=2,g(u.charCodeAt(2))){if(l===3)return c.root=c.dir=u,c;t=3}}t>0&&(c.root=u.slice(0,t));let s=-1,o=t,d=-1,f=!0,h=u.length-1,P=0;for(;h>=t;--h){if(r=u.charCodeAt(h),g(r)){if(!f){o=h+1;break}continue}d===-1&&(f=!1,d=h+1),r===n?s===-1?s=h:P!==1&&(P=1):s!==-1&&(P=-1)}return d!==-1&&(s===-1||P===0||P===1&&s===d-1&&s===o+1?c.base=c.name=u.slice(o,d):(c.name=u.slice(o,s),c.base=u.slice(o,d),c.ext=u.slice(s,d))),o>0&&o!==t?c.dir=u.slice(0,o-1):c.dir=c.root,c},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...u){let c="",l=!1;for(let t=u.length-1;t>=-1&&!l;t--){const r=t>=0?u[t]:m.cwd();p(r,"path"),r.length!==0&&(c=`${r}/${c}`,l=r.charCodeAt(0)===w)}return c=S(c,!l,"/",v),l?`/${c}`:c.length>0?c:"."},normalize(u){if(p(u,"path"),u.length===0)return".";const c=u.charCodeAt(0)===w,l=u.charCodeAt(u.length-1)===w;return u=S(u,!c,"/",v),u.length===0?c?"/":l?"./":".":(l&&(u+="/"),c?`/${u}`:u)},isAbsolute(u){return p(u,"path"),u.length>0&&u.charCodeAt(0)===w},join(...u){if(u.length===0)return".";let c;for(let l=0;l<u.length;++l){const t=u[l];p(t,"path"),t.length>0&&(c===void 0?c=t:c+=`/${t}`)}return c===void 0?".":e.posix.normalize(c)},relative(u,c){if(p(u,"from"),p(c,"to"),u===c||(u=e.posix.resolve(u),c=e.posix.resolve(c),u===c))return"";const l=1,t=u.length,r=t-l,s=1,o=c.length-s,d=r<o?r:o;let f=-1,h=0;for(;h<d;h++){const T=u.charCodeAt(l+h);if(T!==c.charCodeAt(s+h))break;T===w&&(f=h)}if(h===d)if(o>d){if(c.charCodeAt(s+h)===w)return c.slice(s+h+1);if(h===0)return c.slice(s+h)}else r>d&&(u.charCodeAt(l+h)===w?f=h:h===0&&(f=0));let P="";for(h=l+f+1;h<=t;++h)(h===t||u.charCodeAt(h)===w)&&(P+=P.length===0?"..":"/..");return`${P}${c.slice(s+f)}`},toNamespacedPath(u){return u},dirname(u){if(p(u,"path"),u.length===0)return".";const c=u.charCodeAt(0)===w;let l=-1,t=!0;for(let r=u.length-1;r>=1;--r)if(u.charCodeAt(r)===w){if(!t){l=r;break}}else t=!1;return l===-1?c?"/":".":c&&l===1?"//":u.slice(0,l)},basename(u,c){c!==void 0&&p(c,"ext"),p(u,"path");let l=0,t=-1,r=!0,s;if(c!==void 0&&c.length>0&&c.length<=u.length){if(c===u)return"";let o=c.length-1,d=-1;for(s=u.length-1;s>=0;--s){const f=u.charCodeAt(s);if(f===w){if(!r){l=s+1;break}}else d===-1&&(r=!1,d=s+1),o>=0&&(f===c.charCodeAt(o)?--o==-1&&(t=s):(o=-1,t=d))}return l===t?t=d:t===-1&&(t=u.length),u.slice(l,t)}for(s=u.length-1;s>=0;--s)if(u.charCodeAt(s)===w){if(!r){l=s+1;break}}else t===-1&&(r=!1,t=s+1);return t===-1?"":u.slice(l,t)},extname(u){p(u,"path");let c=-1,l=0,t=-1,r=!0,s=0;for(let o=u.length-1;o>=0;--o){const d=u.charCodeAt(o);if(d===w){if(!r){l=o+1;break}continue}t===-1&&(r=!1,t=o+1),d===n?c===-1?c=o:s!==1&&(s=1):c!==-1&&(s=-1)}return c===-1||t===-1||s===0||s===1&&c===t-1&&c===l+1?"":u.slice(c,t)},format:a.bind(null,"/"),parse(u){p(u,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(u.length===0)return c;const l=u.charCodeAt(0)===w;let t;l?(c.root="/",t=1):t=0;let r=-1,s=0,o=-1,d=!0,f=u.length-1,h=0;for(;f>=t;--f){const P=u.charCodeAt(f);if(P===w){if(!d){s=f+1;break}continue}o===-1&&(d=!1,o=f+1),P===n?r===-1?r=f:h!==1&&(h=1):r!==-1&&(h=-1)}if(o!==-1){const P=s===0&&l?1:s;r===-1||h===0||h===1&&r===o-1&&r===s+1?c.base=c.name=u.slice(P,o):(c.name=u.slice(P,r),c.base=u.slice(P,o),c.ext=u.slice(r,o))}return s>0?c.dir=u.slice(0,s-1):l&&(c.dir="/"),c},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=m.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=m.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=m.platform==="win32"?e.win32.join:e.posix.join,e.resolve=m.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=m.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=m.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=m.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=m.platform==="win32"?e.win32.extname:e.posix.extname,e.format=m.platform==="win32"?e.win32.format:e.posix.format,e.parse=m.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=m.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=m.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=m.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(J[105],Z([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var m;(function(b){b[b.stdout=0]="stdout",b[b.stderr=1]="stderr"})(m=e.Source||(e.Source={}));var L;(function(b){b[b.Success=0]="Success",b[b.Unknown=1]="Unknown",b[b.AccessDenied=2]="AccessDenied",b[b.ProcessNotFound=3]="ProcessNotFound"})(L=e.TerminateResponseCode||(e.TerminateResponseCode={}));function A(b,...E){const n=E.reduce((i,I)=>(i[I]=!0,i),{}),w=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(b).filter(i=>!n[i]).forEach(i=>{for(let I=0;I<w.length;I++)if(i.search(w[I])!==-1){delete b[i];break}})}e.sanitizeProcessEnvironment=A}),define(J[79],Z([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ScanCodeBinding=e.IMMUTABLE_KEY_CODE_TO_CODE=e.IMMUTABLE_CODE_TO_KEY_CODE=e.ScanCodeUtils=e.ScanCode=void 0;var m;(function(n){n[n.DependsOnKbLayout=-1]="DependsOnKbLayout",n[n.None=0]="None",n[n.Hyper=1]="Hyper",n[n.Super=2]="Super",n[n.Fn=3]="Fn",n[n.FnLock=4]="FnLock",n[n.Suspend=5]="Suspend",n[n.Resume=6]="Resume",n[n.Turbo=7]="Turbo",n[n.Sleep=8]="Sleep",n[n.WakeUp=9]="WakeUp",n[n.KeyA=10]="KeyA",n[n.KeyB=11]="KeyB",n[n.KeyC=12]="KeyC",n[n.KeyD=13]="KeyD",n[n.KeyE=14]="KeyE",n[n.KeyF=15]="KeyF",n[n.KeyG=16]="KeyG",n[n.KeyH=17]="KeyH",n[n.KeyI=18]="KeyI",n[n.KeyJ=19]="KeyJ",n[n.KeyK=20]="KeyK",n[n.KeyL=21]="KeyL",n[n.KeyM=22]="KeyM",n[n.KeyN=23]="KeyN",n[n.KeyO=24]="KeyO",n[n.KeyP=25]="KeyP",n[n.KeyQ=26]="KeyQ",n[n.KeyR=27]="KeyR",n[n.KeyS=28]="KeyS",n[n.KeyT=29]="KeyT",n[n.KeyU=30]="KeyU",n[n.KeyV=31]="KeyV",n[n.KeyW=32]="KeyW",n[n.KeyX=33]="KeyX",n[n.KeyY=34]="KeyY",n[n.KeyZ=35]="KeyZ",n[n.Digit1=36]="Digit1",n[n.Digit2=37]="Digit2",n[n.Digit3=38]="Digit3",n[n.Digit4=39]="Digit4",n[n.Digit5=40]="Digit5",n[n.Digit6=41]="Digit6",n[n.Digit7=42]="Digit7",n[n.Digit8=43]="Digit8",n[n.Digit9=44]="Digit9",n[n.Digit0=45]="Digit0",n[n.Enter=46]="Enter",n[n.Escape=47]="Escape",n[n.Backspace=48]="Backspace",n[n.Tab=49]="Tab",n[n.Space=50]="Space",n[n.Minus=51]="Minus",n[n.Equal=52]="Equal",n[n.BracketLeft=53]="BracketLeft",n[n.BracketRight=54]="BracketRight",n[n.Backslash=55]="Backslash",n[n.IntlHash=56]="IntlHash",n[n.Semicolon=57]="Semicolon",n[n.Quote=58]="Quote",n[n.Backquote=59]="Backquote",n[n.Comma=60]="Comma",n[n.Period=61]="Period",n[n.Slash=62]="Slash",n[n.CapsLock=63]="CapsLock",n[n.F1=64]="F1",n[n.F2=65]="F2",n[n.F3=66]="F3",n[n.F4=67]="F4",n[n.F5=68]="F5",n[n.F6=69]="F6",n[n.F7=70]="F7",n[n.F8=71]="F8",n[n.F9=72]="F9",n[n.F10=73]="F10",n[n.F11=74]="F11",n[n.F12=75]="F12",n[n.PrintScreen=76]="PrintScreen",n[n.ScrollLock=77]="ScrollLock",n[n.Pause=78]="Pause",n[n.Insert=79]="Insert",n[n.Home=80]="Home",n[n.PageUp=81]="PageUp",n[n.Delete=82]="Delete",n[n.End=83]="End",n[n.PageDown=84]="PageDown",n[n.ArrowRight=85]="ArrowRight",n[n.ArrowLeft=86]="ArrowLeft",n[n.ArrowDown=87]="ArrowDown",n[n.ArrowUp=88]="ArrowUp",n[n.NumLock=89]="NumLock",n[n.NumpadDivide=90]="NumpadDivide",n[n.NumpadMultiply=91]="NumpadMultiply",n[n.NumpadSubtract=92]="NumpadSubtract",n[n.NumpadAdd=93]="NumpadAdd",n[n.NumpadEnter=94]="NumpadEnter",n[n.Numpad1=95]="Numpad1",n[n.Numpad2=96]="Numpad2",n[n.Numpad3=97]="Numpad3",n[n.Numpad4=98]="Numpad4",n[n.Numpad5=99]="Numpad5",n[n.Numpad6=100]="Numpad6",n[n.Numpad7=101]="Numpad7",n[n.Numpad8=102]="Numpad8",n[n.Numpad9=103]="Numpad9",n[n.Numpad0=104]="Numpad0",n[n.NumpadDecimal=105]="NumpadDecimal",n[n.IntlBackslash=106]="IntlBackslash",n[n.ContextMenu=107]="ContextMenu",n[n.Power=108]="Power",n[n.NumpadEqual=109]="NumpadEqual",n[n.F13=110]="F13",n[n.F14=111]="F14",n[n.F15=112]="F15",n[n.F16=113]="F16",n[n.F17=114]="F17",n[n.F18=115]="F18",n[n.F19=116]="F19",n[n.F20=117]="F20",n[n.F21=118]="F21",n[n.F22=119]="F22",n[n.F23=120]="F23",n[n.F24=121]="F24",n[n.Open=122]="Open",n[n.Help=123]="Help",n[n.Select=124]="Select",n[n.Again=125]="Again",n[n.Undo=126]="Undo",n[n.Cut=127]="Cut",n[n.Copy=128]="Copy",n[n.Paste=129]="Paste",n[n.Find=130]="Find",n[n.AudioVolumeMute=131]="AudioVolumeMute",n[n.AudioVolumeUp=132]="AudioVolumeUp",n[n.AudioVolumeDown=133]="AudioVolumeDown",n[n.NumpadComma=134]="NumpadComma",n[n.IntlRo=135]="IntlRo",n[n.KanaMode=136]="KanaMode",n[n.IntlYen=137]="IntlYen",n[n.Convert=138]="Convert",n[n.NonConvert=139]="NonConvert",n[n.Lang1=140]="Lang1",n[n.Lang2=141]="Lang2",n[n.Lang3=142]="Lang3",n[n.Lang4=143]="Lang4",n[n.Lang5=144]="Lang5",n[n.Abort=145]="Abort",n[n.Props=146]="Props",n[n.NumpadParenLeft=147]="NumpadParenLeft",n[n.NumpadParenRight=148]="NumpadParenRight",n[n.NumpadBackspace=149]="NumpadBackspace",n[n.NumpadMemoryStore=150]="NumpadMemoryStore",n[n.NumpadMemoryRecall=151]="NumpadMemoryRecall",n[n.NumpadMemoryClear=152]="NumpadMemoryClear",n[n.NumpadMemoryAdd=153]="NumpadMemoryAdd",n[n.NumpadMemorySubtract=154]="NumpadMemorySubtract",n[n.NumpadClear=155]="NumpadClear",n[n.NumpadClearEntry=156]="NumpadClearEntry",n[n.ControlLeft=157]="ControlLeft",n[n.ShiftLeft=158]="ShiftLeft",n[n.AltLeft=159]="AltLeft",n[n.MetaLeft=160]="MetaLeft",n[n.ControlRight=161]="ControlRight",n[n.ShiftRight=162]="ShiftRight",n[n.AltRight=163]="AltRight",n[n.MetaRight=164]="MetaRight",n[n.BrightnessUp=165]="BrightnessUp",n[n.BrightnessDown=166]="BrightnessDown",n[n.MediaPlay=167]="MediaPlay",n[n.MediaRecord=168]="MediaRecord",n[n.MediaFastForward=169]="MediaFastForward",n[n.MediaRewind=170]="MediaRewind",n[n.MediaTrackNext=171]="MediaTrackNext",n[n.MediaTrackPrevious=172]="MediaTrackPrevious",n[n.MediaStop=173]="MediaStop",n[n.Eject=174]="Eject",n[n.MediaPlayPause=175]="MediaPlayPause",n[n.MediaSelect=176]="MediaSelect",n[n.LaunchMail=177]="LaunchMail",n[n.LaunchApp2=178]="LaunchApp2",n[n.LaunchApp1=179]="LaunchApp1",n[n.SelectTask=180]="SelectTask",n[n.LaunchScreenSaver=181]="LaunchScreenSaver",n[n.BrowserSearch=182]="BrowserSearch",n[n.BrowserHome=183]="BrowserHome",n[n.BrowserBack=184]="BrowserBack",n[n.BrowserForward=185]="BrowserForward",n[n.BrowserStop=186]="BrowserStop",n[n.BrowserRefresh=187]="BrowserRefresh",n[n.BrowserFavorites=188]="BrowserFavorites",n[n.ZoomToggle=189]="ZoomToggle",n[n.MailReply=190]="MailReply",n[n.MailForward=191]="MailForward",n[n.MailSend=192]="MailSend",n[n.MAX_VALUE=193]="MAX_VALUE"})(m=e.ScanCode||(e.ScanCode={}));const L=[],A=Object.create(null),b=Object.create(null);e.ScanCodeUtils={lowerCaseToEnum:n=>b[n]||0,toEnum:n=>A[n]||0,toString:n=>L[n]||"None"},e.IMMUTABLE_CODE_TO_KEY_CODE=[],e.IMMUTABLE_KEY_CODE_TO_CODE=[];class E{constructor(w,y,i,I,M){this.ctrlKey=w,this.shiftKey=y,this.altKey=i,this.metaKey=I,this.scanCode=M}equals(w){return this.ctrlKey===w.ctrlKey&&this.shiftKey===w.shiftKey&&this.altKey===w.altKey&&this.metaKey===w.metaKey&&this.scanCode===w.scanCode}isDuplicateModifierCase(){return this.ctrlKey&&(this.scanCode===157||this.scanCode===161)||this.shiftKey&&(this.scanCode===158||this.scanCode===162)||this.altKey&&(this.scanCode===159||this.scanCode===163)||this.metaKey&&(this.scanCode===160||this.scanCode===164)}}e.ScanCodeBinding=E,function(){function n(w,y){L[w]=y,A[y]=w,b[y.toLowerCase()]=w}n(0,"None"),n(1,"Hyper"),n(2,"Super"),n(3,"Fn"),n(4,"FnLock"),n(5,"Suspend"),n(6,"Resume"),n(7,"Turbo"),n(8,"Sleep"),n(9,"WakeUp"),n(10,"KeyA"),n(11,"KeyB"),n(12,"KeyC"),n(13,"KeyD"),n(14,"KeyE"),n(15,"KeyF"),n(16,"KeyG"),n(17,"KeyH"),n(18,"KeyI"),n(19,"KeyJ"),n(20,"KeyK"),n(21,"KeyL"),n(22,"KeyM"),n(23,"KeyN"),n(24,"KeyO"),n(25,"KeyP"),n(26,"KeyQ"),n(27,"KeyR"),n(28,"KeyS"),n(29,"KeyT"),n(30,"KeyU"),n(31,"KeyV"),n(32,"KeyW"),n(33,"KeyX"),n(34,"KeyY"),n(35,"KeyZ"),n(36,"Digit1"),n(37,"Digit2"),n(38,"Digit3"),n(39,"Digit4"),n(40,"Digit5"),n(41,"Digit6"),n(42,"Digit7"),n(43,"Digit8"),n(44,"Digit9"),n(45,"Digit0"),n(46,"Enter"),n(47,"Escape"),n(48,"Backspace"),n(49,"Tab"),n(50,"Space"),n(51,"Minus"),n(52,"Equal"),n(53,"BracketLeft"),n(54,"BracketRight"),n(55,"Backslash"),n(56,"IntlHash"),n(57,"Semicolon"),n(58,"Quote"),n(59,"Backquote"),n(60,"Comma"),n(61,"Period"),n(62,"Slash"),n(63,"CapsLock"),n(64,"F1"),n(65,"F2"),n(66,"F3"),n(67,"F4"),n(68,"F5"),n(69,"F6"),n(70,"F7"),n(71,"F8"),n(72,"F9"),n(73,"F10"),n(74,"F11"),n(75,"F12"),n(76,"PrintScreen"),n(77,"ScrollLock"),n(78,"Pause"),n(79,"Insert"),n(80,"Home"),n(81,"PageUp"),n(82,"Delete"),n(83,"End"),n(84,"PageDown"),n(85,"ArrowRight"),n(86,"ArrowLeft"),n(87,"ArrowDown"),n(88,"ArrowUp"),n(89,"NumLock"),n(90,"NumpadDivide"),n(91,"NumpadMultiply"),n(92,"NumpadSubtract"),n(93,"NumpadAdd"),n(94,"NumpadEnter"),n(95,"Numpad1"),n(96,"Numpad2"),n(97,"Numpad3"),n(98,"Numpad4"),n(99,"Numpad5"),n(100,"Numpad6"),n(101,"Numpad7"),n(102,"Numpad8"),n(103,"Numpad9"),n(104,"Numpad0"),n(105,"NumpadDecimal"),n(106,"IntlBackslash"),n(107,"ContextMenu"),n(108,"Power"),n(109,"NumpadEqual"),n(110,"F13"),n(111,"F14"),n(112,"F15"),n(113,"F16"),n(114,"F17"),n(115,"F18"),n(116,"F19"),n(117,"F20"),n(118,"F21"),n(119,"F22"),n(120,"F23"),n(121,"F24"),n(122,"Open"),n(123,"Help"),n(124,"Select"),n(125,"Again"),n(126,"Undo"),n(127,"Cut"),n(128,"Copy"),n(129,"Paste"),n(130,"Find"),n(131,"AudioVolumeMute"),n(132,"AudioVolumeUp"),n(133,"AudioVolumeDown"),n(134,"NumpadComma"),n(135,"IntlRo"),n(136,"KanaMode"),n(137,"IntlYen"),n(138,"Convert"),n(139,"NonConvert"),n(140,"Lang1"),n(141,"Lang2"),n(142,"Lang3"),n(143,"Lang4"),n(144,"Lang5"),n(145,"Abort"),n(146,"Props"),n(147,"NumpadParenLeft"),n(148,"NumpadParenRight"),n(149,"NumpadBackspace"),n(150,"NumpadMemoryStore"),n(151,"NumpadMemoryRecall"),n(152,"NumpadMemoryClear"),n(153,"NumpadMemoryAdd"),n(154,"NumpadMemorySubtract"),n(155,"NumpadClear"),n(156,"NumpadClearEntry"),n(157,"ControlLeft"),n(158,"ShiftLeft"),n(159,"AltLeft"),n(160,"MetaLeft"),n(161,"ControlRight"),n(162,"ShiftRight"),n(163,"AltRight"),n(164,"MetaRight"),n(165,"BrightnessUp"),n(166,"BrightnessDown"),n(167,"MediaPlay"),n(168,"MediaRecord"),n(169,"MediaFastForward"),n(170,"MediaRewind"),n(171,"MediaTrackNext"),n(172,"MediaTrackPrevious"),n(173,"MediaStop"),n(174,"Eject"),n(175,"MediaPlayPause"),n(176,"MediaSelect"),n(177,"LaunchMail"),n(178,"LaunchApp2"),n(179,"LaunchApp1"),n(180,"SelectTask"),n(181,"LaunchScreenSaver"),n(182,"BrowserSearch"),n(183,"BrowserHome"),n(184,"BrowserBack"),n(185,"BrowserForward"),n(186,"BrowserStop"),n(187,"BrowserRefresh"),n(188,"BrowserFavorites"),n(189,"ZoomToggle"),n(190,"MailReply"),n(191,"MailForward"),n(192,"MailSend")}(),function(){for(let w=0;w<=193;w++)e.IMMUTABLE_CODE_TO_KEY_CODE[w]=-1;for(let w=0;w<=112;w++)e.IMMUTABLE_KEY_CODE_TO_CODE[w]=-1;function n(w,y){e.IMMUTABLE_CODE_TO_KEY_CODE[w]=y,y!==0&&y!==3&&y!==5&&y!==4&&y!==6&&y!==57&&(e.IMMUTABLE_KEY_CODE_TO_CODE[y]=w)}e.IMMUTABLE_KEY_CODE_TO_CODE[3]=46,n(0,0),n(1,0),n(2,0),n(3,0),n(4,0),n(5,0),n(6,0),n(7,0),n(8,0),n(9,0),n(46,3),n(47,9),n(48,1),n(49,2),n(50,10),n(63,8),n(64,59),n(65,60),n(66,61),n(67,62),n(68,63),n(69,64),n(70,65),n(71,66),n(72,67),n(73,68),n(74,69),n(75,70),n(76,0),n(77,79),n(78,7),n(79,19),n(80,14),n(81,11),n(82,20),n(83,13),n(84,12),n(85,17),n(86,15),n(87,18),n(88,16),n(89,78),n(90,108),n(91,103),n(92,106),n(93,104),n(94,3),n(95,94),n(96,95),n(97,96),n(98,97),n(99,98),n(100,99),n(101,100),n(102,101),n(103,102),n(104,93),n(105,107),n(107,58),n(108,0),n(109,0),n(110,71),n(111,72),n(112,73),n(113,74),n(114,75),n(115,76),n(116,77),n(117,0),n(118,0),n(119,0),n(120,0),n(121,0),n(122,0),n(123,0),n(124,0),n(125,0),n(126,0),n(127,0),n(128,0),n(129,0),n(130,0),n(131,0),n(132,0),n(133,0),n(134,105),n(136,0),n(138,0),n(139,0),n(140,0),n(141,0),n(142,0),n(143,0),n(144,0),n(145,0),n(146,0),n(147,0),n(148,0),n(149,0),n(150,0),n(151,0),n(152,0),n(153,0),n(154,0),n(155,0),n(156,0),n(157,5),n(158,4),n(159,6),n(160,57),n(161,5),n(162,4),n(163,6),n(164,57),n(165,0),n(166,0),n(167,0),n(168,0),n(169,0),n(170,0),n(171,0),n(172,0),n(173,0),n(174,0),n(175,0),n(176,0),n(177,0),n(178,0),n(179,0),n(180,0),n(181,0),n(182,0),n(183,0),n(184,0),n(185,0),n(186,0),n(187,0),n(188,0),n(189,0),n(190,0),n(191,0),n(192,0)}()}),define(J[106],Z([0,1,57,79]),function($,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingParser=void 0;class A{static _readModifiers(E){E=E.toLowerCase().trim();let n=!1,w=!1,y=!1,i=!1,I;do I=!1,/^ctrl(\+|\-)/.test(E)&&(n=!0,E=E.substr("ctrl-".length),I=!0),/^shift(\+|\-)/.test(E)&&(w=!0,E=E.substr("shift-".length),I=!0),/^alt(\+|\-)/.test(E)&&(y=!0,E=E.substr("alt-".length),I=!0),/^meta(\+|\-)/.test(E)&&(i=!0,E=E.substr("meta-".length),I=!0),/^win(\+|\-)/.test(E)&&(i=!0,E=E.substr("win-".length),I=!0),/^cmd(\+|\-)/.test(E)&&(i=!0,E=E.substr("cmd-".length),I=!0);while(I);let M;const p=E.indexOf(" ");return p>0?(M=E.substring(0,p),E=E.substring(p)):(M=E,E=""),{remains:E,ctrl:n,shift:w,alt:y,meta:i,key:M}}static parseSimpleKeybinding(E){const n=this._readModifiers(E),w=m.KeyCodeUtils.fromUserSettings(n.key);return[new m.SimpleKeybinding(n.ctrl,n.shift,n.alt,n.meta,w),n.remains]}static parseKeybinding(E,n){if(!E)return null;const w=[];let y;do[y,E]=this.parseSimpleKeybinding(E),w.push(y);while(E.length>0);return new m.ChordKeybinding(w)}static parseSimpleUserBinding(E){const n=this._readModifiers(E),w=n.key.match(/^\[([^\]]+)\]$/);if(w){const i=w[1],I=L.ScanCodeUtils.lowerCaseToEnum(i);return[new L.ScanCodeBinding(n.ctrl,n.shift,n.alt,n.meta,I),n.remains]}const y=m.KeyCodeUtils.fromUserSettings(n.key);return[new m.SimpleKeybinding(n.ctrl,n.shift,n.alt,n.meta,y),n.remains]}static parseUserBinding(E){if(!E)return[];const n=[];let w;for(;E.length>0;)[w,E]=this.parseSimpleUserBinding(E),n.push(w);return n}}e.KeybindingParser=A}),define(J[107],Z([0,1,3]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const L=m.globals.performance&&typeof m.globals.performance.now=="function";class A{constructor(E){this._highResolution=L&&E,this._startTime=this._now(),this._stopTime=-1}static create(E=!0){return new A(E)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?m.globals.performance.now():Date.now()}}e.StopWatch=A}),define(J[5],Z([0,1,19,42,2,78,107]),function($,e,m,L,A,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.PauseableEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var n;(function(S){S.None=()=>A.Disposable.None;function a(B){return(V,N=null,C)=>{let z=!1,F;return F=B(R=>{if(!z)return F?F.dispose():z=!0,V.call(N,R)},null,C),z&&F.dispose(),F}}S.once=a;function u(B,V){return o((N,C=null,z)=>B(F=>N.call(C,V(F)),null,z))}S.map=u;function c(B,V){return o((N,C=null,z)=>B(F=>{V(F),N.call(C,F)},null,z))}S.forEach=c;function l(B,V){return o((N,C=null,z)=>B(F=>V(F)&&N.call(C,F),null,z))}S.filter=l;function t(B){return B}S.signal=t;function r(...B){return(V,N=null,C)=>(0,A.combinedDisposable)(...B.map(z=>z(F=>V.call(N,F),null,C)))}S.any=r;function s(B,V,N){let C=N;return u(B,z=>(C=V(C,z),C))}S.reduce=s;function o(B){let V;const N=new M({onFirstListenerAdd(){V=B(N.fire,N)},onLastListenerRemove(){V.dispose()}});return N.event}S.snapshot=o;function d(B,V,N=100,C=!1,z){let F,R,W,k=0;const O=new M({leakWarningThreshold:z,onFirstListenerAdd(){F=B(_=>{k++,R=V(R,_),C&&!W&&(O.fire(R),R=void 0),clearTimeout(W),W=setTimeout(()=>{const K=R;R=void 0,W=void 0,(!C||k>1)&&O.fire(K),k=0},N)})},onLastListenerRemove(){F.dispose()}});return O.event}S.debounce=d;function f(B){const V=new Date().getTime();return u(a(B),N=>new Date().getTime()-V)}S.stopwatch=f;function h(B,V=(N,C)=>N===C){let N=!0,C;return l(B,z=>{const F=N||!V(z,C);return N=!1,C=z,F})}S.latch=h;function P(B,V){return[S.filter(B,V),S.filter(B,N=>!V(N))]}S.split=P;function T(B,V=!1,N=[]){let C=N.slice(),z=B(W=>{C?C.push(W):R.fire(W)});const F=()=>{C&&C.forEach(W=>R.fire(W)),C=null},R=new M({onFirstListenerAdd(){z||(z=B(W=>R.fire(W)))},onFirstListenerDidAdd(){C&&(V?setTimeout(F):F())},onLastListenerRemove(){z&&z.dispose(),z=null}});return R.event}S.buffer=T;class U{constructor(V){this.event=V}map(V){return new U(u(this.event,V))}forEach(V){return new U(c(this.event,V))}filter(V){return new U(l(this.event,V))}reduce(V,N){return new U(s(this.event,V,N))}latch(){return new U(h(this.event))}debounce(V,N=100,C=!1,z){return new U(d(this.event,V,N,C,z))}on(V,N,C){return this.event(V,N,C)}once(V,N,C){return a(this.event)(V,N,C)}}function q(B){return new U(B)}S.chain=q;function Q(B,V,N=C=>C){const C=(...W)=>R.fire(N(...W)),z=()=>B.on(V,C),F=()=>B.removeListener(V,C),R=new M({onFirstListenerAdd:z,onLastListenerRemove:F});return R.event}S.fromNodeEventEmitter=Q;function x(B,V,N=C=>C){const C=(...W)=>R.fire(N(...W)),z=()=>B.addEventListener(V,C),F=()=>B.removeEventListener(V,C),R=new M({onFirstListenerAdd:z,onLastListenerRemove:F});return R.event}S.fromDOMEventEmitter=x;function j(B){const V=new M;let N=!1;return B.then(void 0,()=>null).then(()=>{N?V.fire(void 0):setTimeout(()=>V.fire(void 0),0)}),N=!0,V.event}S.fromPromise=j;function X(B){return new Promise(V=>a(B)(V))}S.toPromise=X})(n=e.Event||(e.Event={}));class w{constructor(a){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${a}_${w._idPool++}`}start(a){this._stopWatch=new E.StopWatch(!0),this._listenerCount=a}stop(){if(this._stopWatch){const a=this._stopWatch.elapsed();this._elapsedOverall+=a,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${a.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}w._idPool=0;let y=-1;function i(S){const a=y;return y=S,{dispose(){y=a}}}e.setGlobalLeakWarningThreshold=i;class I{constructor(a,u=Math.random().toString(18).slice(2,5)){this.customThreshold=a,this.name=u,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(a){let u=y;if(typeof this.customThreshold=="number"&&(u=this.customThreshold),u<=0||a<u)return;this._stacks||(this._stacks=new Map);const c=new Error().stack.split(`
`).slice(3).join(`
`),l=this._stacks.get(c)||0;if(this._stacks.set(c,l+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=u*.5;let t,r=0;for(const[s,o]of this._stacks)(!t||r<o)&&(t=s,r=o);console.warn(`[${this.name}] potential listener LEAK detected, having ${a} listeners already. MOST frequent listener (${r}):`),console.warn(t)}return()=>{const t=this._stacks.get(c)||0;this._stacks.set(c,t-1)}}}class M{constructor(a){var u;this._disposed=!1,this._options=a,this._leakageMon=y>0?new I(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=((u=this._options)===null||u===void 0?void 0:u._profName)?new w(this._options._profName):void 0}get event(){return this._event||(this._event=(a,u,c)=>{var l;this._listeners||(this._listeners=new b.LinkedList);const t=this._listeners.isEmpty();t&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const r=this._listeners.push(u?[a,u]:a);t&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,a,u);const s=(l=this._leakageMon)===null||l===void 0?void 0:l.check(this._listeners.size);let o;return o={dispose:()=>{s&&s(),o.dispose=M._noop,this._disposed||(r(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))}},c instanceof A.DisposableStore?c.add(o):Array.isArray(c)&&c.push(o),o}),this._event}fire(a){var u,c;if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new b.LinkedList);for(let l of this._listeners)this._deliveryQueue.push([l,a]);for((u=this._perfMon)===null||u===void 0||u.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[l,t]=this._deliveryQueue.shift();try{typeof l=="function"?l.call(void 0,t):l[0].call(l[1],t)}catch(r){(0,m.onUnexpectedError)(r)}}(c=this._perfMon)===null||c===void 0||c.stop()}}dispose(){var a,u,c,l,t;this._disposed||(this._disposed=!0,(a=this._listeners)===null||a===void 0||a.clear(),(u=this._deliveryQueue)===null||u===void 0||u.clear(),(l=(c=this._options)===null||c===void 0?void 0:c.onLastListenerRemove)===null||l===void 0||l.call(c),(t=this._leakageMon)===null||t===void 0||t.dispose())}}e.Emitter=M,M._noop=function(){};class p extends M{constructor(a){super(a);this._isPaused=0,this._eventQueue=new b.LinkedList,this._mergeFn=a==null?void 0:a.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const a=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(a))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(a){this._listeners&&(this._isPaused!==0?this._eventQueue.push(a):super.fire(a))}}e.PauseableEmitter=p;class g{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new M({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(a){const u={event:a,listener:null};this.events.push(u),this.hasListeners&&this.hook(u);const c=()=>{this.hasListeners&&this.unhook(u);const l=this.events.indexOf(u);this.events.splice(l,1)};return(0,A.toDisposable)((0,L.once)(c))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(a=>this.hook(a))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(a=>this.unhook(a))}hook(a){a.listener=a.event(u=>this.emitter.fire(u))}unhook(a){a.listener&&a.listener.dispose(),a.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=g;class v{constructor(){this.buffers=[]}wrapEvent(a){return(u,c,l)=>a(t=>{const r=this.buffers[this.buffers.length-1];r?r.push(()=>u.call(c,t)):u.call(c,t)},void 0,l)}bufferEvents(a){const u=[];this.buffers.push(u);const c=a();return this.buffers.pop(),u.forEach(l=>l()),c}}e.EventBufferer=v;class D{constructor(){this.listening=!1,this.inputEvent=n.None,this.inputEventListener=A.Disposable.None,this.emitter=new M({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(a){this.inputEvent=a,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=a(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=D}),define(J[25],Z([0,1,5]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const L=Object.freeze(function(n,w){const y=setTimeout(n.bind(w),0);return{dispose(){clearTimeout(y)}}});var A;(function(n){function w(y){return y===n.None||y===n.Cancelled||y instanceof b?!0:!y||typeof y!="object"?!1:typeof y.isCancellationRequested=="boolean"&&typeof y.onCancellationRequested=="function"}n.isCancellationToken=w,n.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:m.Event.None}),n.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:L})})(A=e.CancellationToken||(e.CancellationToken={}));class b{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?L:(this._emitter||(this._emitter=new m.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class E{constructor(w){this._token=void 0,this._parentListener=void 0,this._parentListener=w&&w.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new b),this._token}cancel(){this._token?this._token instanceof b&&this._token.cancel():this._token=A.Cancelled}dispose(w=!1){w&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof b&&this._token.dispose():this._token=A.None}}e.CancellationTokenSource=E}),define(J[108],Z([0,1,5]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class L{constructor(){this._icons=new Map,this._onDidRegister=new m.Emitter}add(I){const M=this._icons.get(I.id);M?I.description?M.description=I.description:console.error(`Duplicate registration of codicon ${I.id}`):(this._icons.set(I.id,I),this._onDidRegister.fire(I))}get(I){return this._icons.get(I)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const A=new L;e.iconRegistry=A;function b(i,I){return new n(i,I)}e.registerCodicon=b;function E(i){return i?i.replace(/\$\((.*?)\)/g,(I,M)=>` ${M} `).trim():""}e.getCodiconAriaLabel=E;class n{constructor(I,M,p){this.id=I,this.definition=M,this.description=p,A.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=n;function w(i,I){const M=["codicon","codicon-"+i];return I&&M.push("codicon-modifier-"+I),M}e.getClassNamesArray=w;var y;(function(i){i.iconNameSegment="[A-Za-z0-9]+",i.iconNameExpression="[A-Za-z0-9\\-]+",i.iconModifierExpression="~[A-Za-z]+";const I=new RegExp(`^(${i.iconNameExpression})(${i.iconModifierExpression})?$`);function M(v){if(v instanceof n)return["codicon","codicon-"+v.id];const D=I.exec(v.id);if(!D)return M(n.error);let[,S,a]=D;const u=["codicon","codicon-"+S];return a&&u.push("codicon-modifier-"+a.substr(1)),u}i.asClassNameArray=M;function p(v){return M(v).join(" ")}i.asClassName=p;function g(v){return"."+M(v).join(".")}i.asCSSSelector=g})(y=e.CSSIcon||(e.CSSIcon={})),function(i){i.add=new i("add",{fontCharacter:"\\ea60"}),i.plus=new i("plus",{fontCharacter:"\\ea60"}),i.gistNew=new i("gist-new",{fontCharacter:"\\ea60"}),i.repoCreate=new i("repo-create",{fontCharacter:"\\ea60"}),i.lightbulb=new i("lightbulb",{fontCharacter:"\\ea61"}),i.lightBulb=new i("light-bulb",{fontCharacter:"\\ea61"}),i.repo=new i("repo",{fontCharacter:"\\ea62"}),i.repoDelete=new i("repo-delete",{fontCharacter:"\\ea62"}),i.gistFork=new i("gist-fork",{fontCharacter:"\\ea63"}),i.repoForked=new i("repo-forked",{fontCharacter:"\\ea63"}),i.gitPullRequest=new i("git-pull-request",{fontCharacter:"\\ea64"}),i.gitPullRequestAbandoned=new i("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),i.recordKeys=new i("record-keys",{fontCharacter:"\\ea65"}),i.keyboard=new i("keyboard",{fontCharacter:"\\ea65"}),i.tag=new i("tag",{fontCharacter:"\\ea66"}),i.tagAdd=new i("tag-add",{fontCharacter:"\\ea66"}),i.tagRemove=new i("tag-remove",{fontCharacter:"\\ea66"}),i.person=new i("person",{fontCharacter:"\\ea67"}),i.personFollow=new i("person-follow",{fontCharacter:"\\ea67"}),i.personOutline=new i("person-outline",{fontCharacter:"\\ea67"}),i.personFilled=new i("person-filled",{fontCharacter:"\\ea67"}),i.gitBranch=new i("git-branch",{fontCharacter:"\\ea68"}),i.gitBranchCreate=new i("git-branch-create",{fontCharacter:"\\ea68"}),i.gitBranchDelete=new i("git-branch-delete",{fontCharacter:"\\ea68"}),i.sourceControl=new i("source-control",{fontCharacter:"\\ea68"}),i.mirror=new i("mirror",{fontCharacter:"\\ea69"}),i.mirrorPublic=new i("mirror-public",{fontCharacter:"\\ea69"}),i.star=new i("star",{fontCharacter:"\\ea6a"}),i.starAdd=new i("star-add",{fontCharacter:"\\ea6a"}),i.starDelete=new i("star-delete",{fontCharacter:"\\ea6a"}),i.starEmpty=new i("star-empty",{fontCharacter:"\\ea6a"}),i.comment=new i("comment",{fontCharacter:"\\ea6b"}),i.commentAdd=new i("comment-add",{fontCharacter:"\\ea6b"}),i.alert=new i("alert",{fontCharacter:"\\ea6c"}),i.warning=new i("warning",{fontCharacter:"\\ea6c"}),i.search=new i("search",{fontCharacter:"\\ea6d"}),i.searchSave=new i("search-save",{fontCharacter:"\\ea6d"}),i.logOut=new i("log-out",{fontCharacter:"\\ea6e"}),i.signOut=new i("sign-out",{fontCharacter:"\\ea6e"}),i.logIn=new i("log-in",{fontCharacter:"\\ea6f"}),i.signIn=new i("sign-in",{fontCharacter:"\\ea6f"}),i.eye=new i("eye",{fontCharacter:"\\ea70"}),i.eyeUnwatch=new i("eye-unwatch",{fontCharacter:"\\ea70"}),i.eyeWatch=new i("eye-watch",{fontCharacter:"\\ea70"}),i.circleFilled=new i("circle-filled",{fontCharacter:"\\ea71"}),i.primitiveDot=new i("primitive-dot",{fontCharacter:"\\ea71"}),i.closeDirty=new i("close-dirty",{fontCharacter:"\\ea71"}),i.debugBreakpoint=new i("debug-breakpoint",{fontCharacter:"\\ea71"}),i.debugBreakpointDisabled=new i("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),i.debugHint=new i("debug-hint",{fontCharacter:"\\ea71"}),i.primitiveSquare=new i("primitive-square",{fontCharacter:"\\ea72"}),i.edit=new i("edit",{fontCharacter:"\\ea73"}),i.pencil=new i("pencil",{fontCharacter:"\\ea73"}),i.info=new i("info",{fontCharacter:"\\ea74"}),i.issueOpened=new i("issue-opened",{fontCharacter:"\\ea74"}),i.gistPrivate=new i("gist-private",{fontCharacter:"\\ea75"}),i.gitForkPrivate=new i("git-fork-private",{fontCharacter:"\\ea75"}),i.lock=new i("lock",{fontCharacter:"\\ea75"}),i.mirrorPrivate=new i("mirror-private",{fontCharacter:"\\ea75"}),i.close=new i("close",{fontCharacter:"\\ea76"}),i.removeClose=new i("remove-close",{fontCharacter:"\\ea76"}),i.x=new i("x",{fontCharacter:"\\ea76"}),i.repoSync=new i("repo-sync",{fontCharacter:"\\ea77"}),i.sync=new i("sync",{fontCharacter:"\\ea77"}),i.clone=new i("clone",{fontCharacter:"\\ea78"}),i.desktopDownload=new i("desktop-download",{fontCharacter:"\\ea78"}),i.beaker=new i("beaker",{fontCharacter:"\\ea79"}),i.microscope=new i("microscope",{fontCharacter:"\\ea79"}),i.vm=new i("vm",{fontCharacter:"\\ea7a"}),i.deviceDesktop=new i("device-desktop",{fontCharacter:"\\ea7a"}),i.file=new i("file",{fontCharacter:"\\ea7b"}),i.fileText=new i("file-text",{fontCharacter:"\\ea7b"}),i.more=new i("more",{fontCharacter:"\\ea7c"}),i.ellipsis=new i("ellipsis",{fontCharacter:"\\ea7c"}),i.kebabHorizontal=new i("kebab-horizontal",{fontCharacter:"\\ea7c"}),i.mailReply=new i("mail-reply",{fontCharacter:"\\ea7d"}),i.reply=new i("reply",{fontCharacter:"\\ea7d"}),i.organization=new i("organization",{fontCharacter:"\\ea7e"}),i.organizationFilled=new i("organization-filled",{fontCharacter:"\\ea7e"}),i.organizationOutline=new i("organization-outline",{fontCharacter:"\\ea7e"}),i.newFile=new i("new-file",{fontCharacter:"\\ea7f"}),i.fileAdd=new i("file-add",{fontCharacter:"\\ea7f"}),i.newFolder=new i("new-folder",{fontCharacter:"\\ea80"}),i.fileDirectoryCreate=new i("file-directory-create",{fontCharacter:"\\ea80"}),i.trash=new i("trash",{fontCharacter:"\\ea81"}),i.trashcan=new i("trashcan",{fontCharacter:"\\ea81"}),i.history=new i("history",{fontCharacter:"\\ea82"}),i.clock=new i("clock",{fontCharacter:"\\ea82"}),i.folder=new i("folder",{fontCharacter:"\\ea83"}),i.fileDirectory=new i("file-directory",{fontCharacter:"\\ea83"}),i.symbolFolder=new i("symbol-folder",{fontCharacter:"\\ea83"}),i.logoGithub=new i("logo-github",{fontCharacter:"\\ea84"}),i.markGithub=new i("mark-github",{fontCharacter:"\\ea84"}),i.github=new i("github",{fontCharacter:"\\ea84"}),i.terminal=new i("terminal",{fontCharacter:"\\ea85"}),i.console=new i("console",{fontCharacter:"\\ea85"}),i.repl=new i("repl",{fontCharacter:"\\ea85"}),i.zap=new i("zap",{fontCharacter:"\\ea86"}),i.symbolEvent=new i("symbol-event",{fontCharacter:"\\ea86"}),i.error=new i("error",{fontCharacter:"\\ea87"}),i.stop=new i("stop",{fontCharacter:"\\ea87"}),i.variable=new i("variable",{fontCharacter:"\\ea88"}),i.symbolVariable=new i("symbol-variable",{fontCharacter:"\\ea88"}),i.array=new i("array",{fontCharacter:"\\ea8a"}),i.symbolArray=new i("symbol-array",{fontCharacter:"\\ea8a"}),i.symbolModule=new i("symbol-module",{fontCharacter:"\\ea8b"}),i.symbolPackage=new i("symbol-package",{fontCharacter:"\\ea8b"}),i.symbolNamespace=new i("symbol-namespace",{fontCharacter:"\\ea8b"}),i.symbolObject=new i("symbol-object",{fontCharacter:"\\ea8b"}),i.symbolMethod=new i("symbol-method",{fontCharacter:"\\ea8c"}),i.symbolFunction=new i("symbol-function",{fontCharacter:"\\ea8c"}),i.symbolConstructor=new i("symbol-constructor",{fontCharacter:"\\ea8c"}),i.symbolBoolean=new i("symbol-boolean",{fontCharacter:"\\ea8f"}),i.symbolNull=new i("symbol-null",{fontCharacter:"\\ea8f"}),i.symbolNumeric=new i("symbol-numeric",{fontCharacter:"\\ea90"}),i.symbolNumber=new i("symbol-number",{fontCharacter:"\\ea90"}),i.symbolStructure=new i("symbol-structure",{fontCharacter:"\\ea91"}),i.symbolStruct=new i("symbol-struct",{fontCharacter:"\\ea91"}),i.symbolParameter=new i("symbol-parameter",{fontCharacter:"\\ea92"}),i.symbolTypeParameter=new i("symbol-type-parameter",{fontCharacter:"\\ea92"}),i.symbolKey=new i("symbol-key",{fontCharacter:"\\ea93"}),i.symbolText=new i("symbol-text",{fontCharacter:"\\ea93"}),i.symbolReference=new i("symbol-reference",{fontCharacter:"\\ea94"}),i.goToFile=new i("go-to-file",{fontCharacter:"\\ea94"}),i.symbolEnum=new i("symbol-enum",{fontCharacter:"\\ea95"}),i.symbolValue=new i("symbol-value",{fontCharacter:"\\ea95"}),i.symbolRuler=new i("symbol-ruler",{fontCharacter:"\\ea96"}),i.symbolUnit=new i("symbol-unit",{fontCharacter:"\\ea96"}),i.activateBreakpoints=new i("activate-breakpoints",{fontCharacter:"\\ea97"}),i.archive=new i("archive",{fontCharacter:"\\ea98"}),i.arrowBoth=new i("arrow-both",{fontCharacter:"\\ea99"}),i.arrowDown=new i("arrow-down",{fontCharacter:"\\ea9a"}),i.arrowLeft=new i("arrow-left",{fontCharacter:"\\ea9b"}),i.arrowRight=new i("arrow-right",{fontCharacter:"\\ea9c"}),i.arrowSmallDown=new i("arrow-small-down",{fontCharacter:"\\ea9d"}),i.arrowSmallLeft=new i("arrow-small-left",{fontCharacter:"\\ea9e"}),i.arrowSmallRight=new i("arrow-small-right",{fontCharacter:"\\ea9f"}),i.arrowSmallUp=new i("arrow-small-up",{fontCharacter:"\\eaa0"}),i.arrowUp=new i("arrow-up",{fontCharacter:"\\eaa1"}),i.bell=new i("bell",{fontCharacter:"\\eaa2"}),i.bold=new i("bold",{fontCharacter:"\\eaa3"}),i.book=new i("book",{fontCharacter:"\\eaa4"}),i.bookmark=new i("bookmark",{fontCharacter:"\\eaa5"}),i.debugBreakpointConditionalUnverified=new i("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),i.debugBreakpointConditional=new i("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),i.debugBreakpointConditionalDisabled=new i("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),i.debugBreakpointDataUnverified=new i("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),i.debugBreakpointData=new i("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),i.debugBreakpointDataDisabled=new i("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),i.debugBreakpointLogUnverified=new i("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),i.debugBreakpointLog=new i("debug-breakpoint-log",{fontCharacter:"\\eaab"}),i.debugBreakpointLogDisabled=new i("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),i.briefcase=new i("briefcase",{fontCharacter:"\\eaac"}),i.broadcast=new i("broadcast",{fontCharacter:"\\eaad"}),i.browser=new i("browser",{fontCharacter:"\\eaae"}),i.bug=new i("bug",{fontCharacter:"\\eaaf"}),i.calendar=new i("calendar",{fontCharacter:"\\eab0"}),i.caseSensitive=new i("case-sensitive",{fontCharacter:"\\eab1"}),i.check=new i("check",{fontCharacter:"\\eab2"}),i.checklist=new i("checklist",{fontCharacter:"\\eab3"}),i.chevronDown=new i("chevron-down",{fontCharacter:"\\eab4"}),i.chevronLeft=new i("chevron-left",{fontCharacter:"\\eab5"}),i.chevronRight=new i("chevron-right",{fontCharacter:"\\eab6"}),i.chevronUp=new i("chevron-up",{fontCharacter:"\\eab7"}),i.chromeClose=new i("chrome-close",{fontCharacter:"\\eab8"}),i.chromeMaximize=new i("chrome-maximize",{fontCharacter:"\\eab9"}),i.chromeMinimize=new i("chrome-minimize",{fontCharacter:"\\eaba"}),i.chromeRestore=new i("chrome-restore",{fontCharacter:"\\eabb"}),i.circleOutline=new i("circle-outline",{fontCharacter:"\\eabc"}),i.debugBreakpointUnverified=new i("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),i.circleSlash=new i("circle-slash",{fontCharacter:"\\eabd"}),i.circuitBoard=new i("circuit-board",{fontCharacter:"\\eabe"}),i.clearAll=new i("clear-all",{fontCharacter:"\\eabf"}),i.clippy=new i("clippy",{fontCharacter:"\\eac0"}),i.closeAll=new i("close-all",{fontCharacter:"\\eac1"}),i.cloudDownload=new i("cloud-download",{fontCharacter:"\\eac2"}),i.cloudUpload=new i("cloud-upload",{fontCharacter:"\\eac3"}),i.code=new i("code",{fontCharacter:"\\eac4"}),i.collapseAll=new i("collapse-all",{fontCharacter:"\\eac5"}),i.colorMode=new i("color-mode",{fontCharacter:"\\eac6"}),i.commentDiscussion=new i("comment-discussion",{fontCharacter:"\\eac7"}),i.compareChanges=new i("compare-changes",{fontCharacter:"\\eafd"}),i.creditCard=new i("credit-card",{fontCharacter:"\\eac9"}),i.dash=new i("dash",{fontCharacter:"\\eacc"}),i.dashboard=new i("dashboard",{fontCharacter:"\\eacd"}),i.database=new i("database",{fontCharacter:"\\eace"}),i.debugContinue=new i("debug-continue",{fontCharacter:"\\eacf"}),i.debugDisconnect=new i("debug-disconnect",{fontCharacter:"\\ead0"}),i.debugPause=new i("debug-pause",{fontCharacter:"\\ead1"}),i.debugRestart=new i("debug-restart",{fontCharacter:"\\ead2"}),i.debugStart=new i("debug-start",{fontCharacter:"\\ead3"}),i.debugStepInto=new i("debug-step-into",{fontCharacter:"\\ead4"}),i.debugStepOut=new i("debug-step-out",{fontCharacter:"\\ead5"}),i.debugStepOver=new i("debug-step-over",{fontCharacter:"\\ead6"}),i.debugStop=new i("debug-stop",{fontCharacter:"\\ead7"}),i.debug=new i("debug",{fontCharacter:"\\ead8"}),i.deviceCameraVideo=new i("device-camera-video",{fontCharacter:"\\ead9"}),i.deviceCamera=new i("device-camera",{fontCharacter:"\\eada"}),i.deviceMobile=new i("device-mobile",{fontCharacter:"\\eadb"}),i.diffAdded=new i("diff-added",{fontCharacter:"\\eadc"}),i.diffIgnored=new i("diff-ignored",{fontCharacter:"\\eadd"}),i.diffModified=new i("diff-modified",{fontCharacter:"\\eade"}),i.diffRemoved=new i("diff-removed",{fontCharacter:"\\eadf"}),i.diffRenamed=new i("diff-renamed",{fontCharacter:"\\eae0"}),i.diff=new i("diff",{fontCharacter:"\\eae1"}),i.discard=new i("discard",{fontCharacter:"\\eae2"}),i.editorLayout=new i("editor-layout",{fontCharacter:"\\eae3"}),i.emptyWindow=new i("empty-window",{fontCharacter:"\\eae4"}),i.exclude=new i("exclude",{fontCharacter:"\\eae5"}),i.extensions=new i("extensions",{fontCharacter:"\\eae6"}),i.eyeClosed=new i("eye-closed",{fontCharacter:"\\eae7"}),i.fileBinary=new i("file-binary",{fontCharacter:"\\eae8"}),i.fileCode=new i("file-code",{fontCharacter:"\\eae9"}),i.fileMedia=new i("file-media",{fontCharacter:"\\eaea"}),i.filePdf=new i("file-pdf",{fontCharacter:"\\eaeb"}),i.fileSubmodule=new i("file-submodule",{fontCharacter:"\\eaec"}),i.fileSymlinkDirectory=new i("file-symlink-directory",{fontCharacter:"\\eaed"}),i.fileSymlinkFile=new i("file-symlink-file",{fontCharacter:"\\eaee"}),i.fileZip=new i("file-zip",{fontCharacter:"\\eaef"}),i.files=new i("files",{fontCharacter:"\\eaf0"}),i.filter=new i("filter",{fontCharacter:"\\eaf1"}),i.flame=new i("flame",{fontCharacter:"\\eaf2"}),i.foldDown=new i("fold-down",{fontCharacter:"\\eaf3"}),i.foldUp=new i("fold-up",{fontCharacter:"\\eaf4"}),i.fold=new i("fold",{fontCharacter:"\\eaf5"}),i.folderActive=new i("folder-active",{fontCharacter:"\\eaf6"}),i.folderOpened=new i("folder-opened",{fontCharacter:"\\eaf7"}),i.gear=new i("gear",{fontCharacter:"\\eaf8"}),i.gift=new i("gift",{fontCharacter:"\\eaf9"}),i.gistSecret=new i("gist-secret",{fontCharacter:"\\eafa"}),i.gist=new i("gist",{fontCharacter:"\\eafb"}),i.gitCommit=new i("git-commit",{fontCharacter:"\\eafc"}),i.gitCompare=new i("git-compare",{fontCharacter:"\\eafd"}),i.gitMerge=new i("git-merge",{fontCharacter:"\\eafe"}),i.githubAction=new i("github-action",{fontCharacter:"\\eaff"}),i.githubAlt=new i("github-alt",{fontCharacter:"\\eb00"}),i.globe=new i("globe",{fontCharacter:"\\eb01"}),i.grabber=new i("grabber",{fontCharacter:"\\eb02"}),i.graph=new i("graph",{fontCharacter:"\\eb03"}),i.gripper=new i("gripper",{fontCharacter:"\\eb04"}),i.heart=new i("heart",{fontCharacter:"\\eb05"}),i.home=new i("home",{fontCharacter:"\\eb06"}),i.horizontalRule=new i("horizontal-rule",{fontCharacter:"\\eb07"}),i.hubot=new i("hubot",{fontCharacter:"\\eb08"}),i.inbox=new i("inbox",{fontCharacter:"\\eb09"}),i.issueClosed=new i("issue-closed",{fontCharacter:"\\eb0a"}),i.issueReopened=new i("issue-reopened",{fontCharacter:"\\eb0b"}),i.issues=new i("issues",{fontCharacter:"\\eb0c"}),i.italic=new i("italic",{fontCharacter:"\\eb0d"}),i.jersey=new i("jersey",{fontCharacter:"\\eb0e"}),i.json=new i("json",{fontCharacter:"\\eb0f"}),i.kebabVertical=new i("kebab-vertical",{fontCharacter:"\\eb10"}),i.key=new i("key",{fontCharacter:"\\eb11"}),i.law=new i("law",{fontCharacter:"\\eb12"}),i.lightbulbAutofix=new i("lightbulb-autofix",{fontCharacter:"\\eb13"}),i.linkExternal=new i("link-external",{fontCharacter:"\\eb14"}),i.link=new i("link",{fontCharacter:"\\eb15"}),i.listOrdered=new i("list-ordered",{fontCharacter:"\\eb16"}),i.listUnordered=new i("list-unordered",{fontCharacter:"\\eb17"}),i.liveShare=new i("live-share",{fontCharacter:"\\eb18"}),i.loading=new i("loading",{fontCharacter:"\\eb19"}),i.location=new i("location",{fontCharacter:"\\eb1a"}),i.mailRead=new i("mail-read",{fontCharacter:"\\eb1b"}),i.mail=new i("mail",{fontCharacter:"\\eb1c"}),i.markdown=new i("markdown",{fontCharacter:"\\eb1d"}),i.megaphone=new i("megaphone",{fontCharacter:"\\eb1e"}),i.mention=new i("mention",{fontCharacter:"\\eb1f"}),i.milestone=new i("milestone",{fontCharacter:"\\eb20"}),i.mortarBoard=new i("mortar-board",{fontCharacter:"\\eb21"}),i.move=new i("move",{fontCharacter:"\\eb22"}),i.multipleWindows=new i("multiple-windows",{fontCharacter:"\\eb23"}),i.mute=new i("mute",{fontCharacter:"\\eb24"}),i.noNewline=new i("no-newline",{fontCharacter:"\\eb25"}),i.note=new i("note",{fontCharacter:"\\eb26"}),i.octoface=new i("octoface",{fontCharacter:"\\eb27"}),i.openPreview=new i("open-preview",{fontCharacter:"\\eb28"}),i.package_=new i("package",{fontCharacter:"\\eb29"}),i.paintcan=new i("paintcan",{fontCharacter:"\\eb2a"}),i.pin=new i("pin",{fontCharacter:"\\eb2b"}),i.play=new i("play",{fontCharacter:"\\eb2c"}),i.run=new i("run",{fontCharacter:"\\eb2c"}),i.plug=new i("plug",{fontCharacter:"\\eb2d"}),i.preserveCase=new i("preserve-case",{fontCharacter:"\\eb2e"}),i.preview=new i("preview",{fontCharacter:"\\eb2f"}),i.project=new i("project",{fontCharacter:"\\eb30"}),i.pulse=new i("pulse",{fontCharacter:"\\eb31"}),i.question=new i("question",{fontCharacter:"\\eb32"}),i.quote=new i("quote",{fontCharacter:"\\eb33"}),i.radioTower=new i("radio-tower",{fontCharacter:"\\eb34"}),i.reactions=new i("reactions",{fontCharacter:"\\eb35"}),i.references=new i("references",{fontCharacter:"\\eb36"}),i.refresh=new i("refresh",{fontCharacter:"\\eb37"}),i.regex=new i("regex",{fontCharacter:"\\eb38"}),i.remoteExplorer=new i("remote-explorer",{fontCharacter:"\\eb39"}),i.remote=new i("remote",{fontCharacter:"\\eb3a"}),i.remove=new i("remove",{fontCharacter:"\\eb3b"}),i.replaceAll=new i("replace-all",{fontCharacter:"\\eb3c"}),i.replace=new i("replace",{fontCharacter:"\\eb3d"}),i.repoClone=new i("repo-clone",{fontCharacter:"\\eb3e"}),i.repoForcePush=new i("repo-force-push",{fontCharacter:"\\eb3f"}),i.repoPull=new i("repo-pull",{fontCharacter:"\\eb40"}),i.repoPush=new i("repo-push",{fontCharacter:"\\eb41"}),i.report=new i("report",{fontCharacter:"\\eb42"}),i.requestChanges=new i("request-changes",{fontCharacter:"\\eb43"}),i.rocket=new i("rocket",{fontCharacter:"\\eb44"}),i.rootFolderOpened=new i("root-folder-opened",{fontCharacter:"\\eb45"}),i.rootFolder=new i("root-folder",{fontCharacter:"\\eb46"}),i.rss=new i("rss",{fontCharacter:"\\eb47"}),i.ruby=new i("ruby",{fontCharacter:"\\eb48"}),i.saveAll=new i("save-all",{fontCharacter:"\\eb49"}),i.saveAs=new i("save-as",{fontCharacter:"\\eb4a"}),i.save=new i("save",{fontCharacter:"\\eb4b"}),i.screenFull=new i("screen-full",{fontCharacter:"\\eb4c"}),i.screenNormal=new i("screen-normal",{fontCharacter:"\\eb4d"}),i.searchStop=new i("search-stop",{fontCharacter:"\\eb4e"}),i.server=new i("server",{fontCharacter:"\\eb50"}),i.settingsGear=new i("settings-gear",{fontCharacter:"\\eb51"}),i.settings=new i("settings",{fontCharacter:"\\eb52"}),i.shield=new i("shield",{fontCharacter:"\\eb53"}),i.smiley=new i("smiley",{fontCharacter:"\\eb54"}),i.sortPrecedence=new i("sort-precedence",{fontCharacter:"\\eb55"}),i.splitHorizontal=new i("split-horizontal",{fontCharacter:"\\eb56"}),i.splitVertical=new i("split-vertical",{fontCharacter:"\\eb57"}),i.squirrel=new i("squirrel",{fontCharacter:"\\eb58"}),i.starFull=new i("star-full",{fontCharacter:"\\eb59"}),i.starHalf=new i("star-half",{fontCharacter:"\\eb5a"}),i.symbolClass=new i("symbol-class",{fontCharacter:"\\eb5b"}),i.symbolColor=new i("symbol-color",{fontCharacter:"\\eb5c"}),i.symbolConstant=new i("symbol-constant",{fontCharacter:"\\eb5d"}),i.symbolEnumMember=new i("symbol-enum-member",{fontCharacter:"\\eb5e"}),i.symbolField=new i("symbol-field",{fontCharacter:"\\eb5f"}),i.symbolFile=new i("symbol-file",{fontCharacter:"\\eb60"}),i.symbolInterface=new i("symbol-interface",{fontCharacter:"\\eb61"}),i.symbolKeyword=new i("symbol-keyword",{fontCharacter:"\\eb62"}),i.symbolMisc=new i("symbol-misc",{fontCharacter:"\\eb63"}),i.symbolOperator=new i("symbol-operator",{fontCharacter:"\\eb64"}),i.symbolProperty=new i("symbol-property",{fontCharacter:"\\eb65"}),i.wrench=new i("wrench",{fontCharacter:"\\eb65"}),i.wrenchSubaction=new i("wrench-subaction",{fontCharacter:"\\eb65"}),i.symbolSnippet=new i("symbol-snippet",{fontCharacter:"\\eb66"}),i.tasklist=new i("tasklist",{fontCharacter:"\\eb67"}),i.telescope=new i("telescope",{fontCharacter:"\\eb68"}),i.textSize=new i("text-size",{fontCharacter:"\\eb69"}),i.threeBars=new i("three-bars",{fontCharacter:"\\eb6a"}),i.thumbsdown=new i("thumbsdown",{fontCharacter:"\\eb6b"}),i.thumbsup=new i("thumbsup",{fontCharacter:"\\eb6c"}),i.tools=new i("tools",{fontCharacter:"\\eb6d"}),i.triangleDown=new i("triangle-down",{fontCharacter:"\\eb6e"}),i.triangleLeft=new i("triangle-left",{fontCharacter:"\\eb6f"}),i.triangleRight=new i("triangle-right",{fontCharacter:"\\eb70"}),i.triangleUp=new i("triangle-up",{fontCharacter:"\\eb71"}),i.twitter=new i("twitter",{fontCharacter:"\\eb72"}),i.unfold=new i("unfold",{fontCharacter:"\\eb73"}),i.unlock=new i("unlock",{fontCharacter:"\\eb74"}),i.unmute=new i("unmute",{fontCharacter:"\\eb75"}),i.unverified=new i("unverified",{fontCharacter:"\\eb76"}),i.verified=new i("verified",{fontCharacter:"\\eb77"}),i.versions=new i("versions",{fontCharacter:"\\eb78"}),i.vmActive=new i("vm-active",{fontCharacter:"\\eb79"}),i.vmOutline=new i("vm-outline",{fontCharacter:"\\eb7a"}),i.vmRunning=new i("vm-running",{fontCharacter:"\\eb7b"}),i.watch=new i("watch",{fontCharacter:"\\eb7c"}),i.whitespace=new i("whitespace",{fontCharacter:"\\eb7d"}),i.wholeWord=new i("whole-word",{fontCharacter:"\\eb7e"}),i.window=new i("window",{fontCharacter:"\\eb7f"}),i.wordWrap=new i("word-wrap",{fontCharacter:"\\eb80"}),i.zoomIn=new i("zoom-in",{fontCharacter:"\\eb81"}),i.zoomOut=new i("zoom-out",{fontCharacter:"\\eb82"}),i.listFilter=new i("list-filter",{fontCharacter:"\\eb83"}),i.listFlat=new i("list-flat",{fontCharacter:"\\eb84"}),i.listSelection=new i("list-selection",{fontCharacter:"\\eb85"}),i.selection=new i("selection",{fontCharacter:"\\eb85"}),i.listTree=new i("list-tree",{fontCharacter:"\\eb86"}),i.debugBreakpointFunctionUnverified=new i("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),i.debugBreakpointFunction=new i("debug-breakpoint-function",{fontCharacter:"\\eb88"}),i.debugBreakpointFunctionDisabled=new i("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),i.debugStackframeActive=new i("debug-stackframe-active",{fontCharacter:"\\eb89"}),i.debugStackframeDot=new i("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),i.debugStackframe=new i("debug-stackframe",{fontCharacter:"\\eb8b"}),i.debugStackframeFocused=new i("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),i.debugBreakpointUnsupported=new i("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),i.symbolString=new i("symbol-string",{fontCharacter:"\\eb8d"}),i.debugReverseContinue=new i("debug-reverse-continue",{fontCharacter:"\\eb8e"}),i.debugStepBack=new i("debug-step-back",{fontCharacter:"\\eb8f"}),i.debugRestartFrame=new i("debug-restart-frame",{fontCharacter:"\\eb90"}),i.callIncoming=new i("call-incoming",{fontCharacter:"\\eb92"}),i.callOutgoing=new i("call-outgoing",{fontCharacter:"\\eb93"}),i.menu=new i("menu",{fontCharacter:"\\eb94"}),i.expandAll=new i("expand-all",{fontCharacter:"\\eb95"}),i.feedback=new i("feedback",{fontCharacter:"\\eb96"}),i.groupByRefType=new i("group-by-ref-type",{fontCharacter:"\\eb97"}),i.ungroupByRefType=new i("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),i.account=new i("account",{fontCharacter:"\\eb99"}),i.bellDot=new i("bell-dot",{fontCharacter:"\\eb9a"}),i.debugConsole=new i("debug-console",{fontCharacter:"\\eb9b"}),i.library=new i("library",{fontCharacter:"\\eb9c"}),i.output=new i("output",{fontCharacter:"\\eb9d"}),i.runAll=new i("run-all",{fontCharacter:"\\eb9e"}),i.syncIgnored=new i("sync-ignored",{fontCharacter:"\\eb9f"}),i.pinned=new i("pinned",{fontCharacter:"\\eba0"}),i.githubInverted=new i("github-inverted",{fontCharacter:"\\eba1"}),i.debugAlt=new i("debug-alt",{fontCharacter:"\\eb91"}),i.serverProcess=new i("server-process",{fontCharacter:"\\eba2"}),i.serverEnvironment=new i("server-environment",{fontCharacter:"\\eba3"}),i.pass=new i("pass",{fontCharacter:"\\eba4"}),i.stopCircle=new i("stop-circle",{fontCharacter:"\\eba5"}),i.playCircle=new i("play-circle",{fontCharacter:"\\eba6"}),i.record=new i("record",{fontCharacter:"\\eba7"}),i.debugAltSmall=new i("debug-alt-small",{fontCharacter:"\\eba8"}),i.vmConnect=new i("vm-connect",{fontCharacter:"\\eba9"}),i.cloud=new i("cloud",{fontCharacter:"\\ebaa"}),i.merge=new i("merge",{fontCharacter:"\\ebab"}),i.exportIcon=new i("export",{fontCharacter:"\\ebac"}),i.graphLeft=new i("graph-left",{fontCharacter:"\\ebad"}),i.magnet=new i("magnet",{fontCharacter:"\\ebae"}),i.notebook=new i("notebook",{fontCharacter:"\\ebaf"}),i.redo=new i("redo",{fontCharacter:"\\ebb0"}),i.checkAll=new i("check-all",{fontCharacter:"\\ebb1"}),i.pinnedDirty=new i("pinned-dirty",{fontCharacter:"\\ebb2"}),i.passFilled=new i("pass-filled",{fontCharacter:"\\ebb3"}),i.circleLargeFilled=new i("circle-large-filled",{fontCharacter:"\\ebb4"}),i.circleLargeOutline=new i("circle-large-outline",{fontCharacter:"\\ebb5"}),i.combine=new i("combine",{fontCharacter:"\\ebb6"}),i.gather=new i("gather",{fontCharacter:"\\ebb6"}),i.table=new i("table",{fontCharacter:"\\ebb7"}),i.variableGroup=new i("variable-group",{fontCharacter:"\\ebb8"}),i.typeHierarchy=new i("type-hierarchy",{fontCharacter:"\\ebb9"}),i.typeHierarchySub=new i("type-hierarchy-sub",{fontCharacter:"\\ebba"}),i.typeHierarchySuper=new i("type-hierarchy-super",{fontCharacter:"\\ebbb"}),i.gitPullRequestCreate=new i("git-pull-request-create",{fontCharacter:"\\ebbc"}),i.runAbove=new i("run-above",{fontCharacter:"\\ebbd"}),i.runBelow=new i("run-below",{fontCharacter:"\\ebbe"}),i.notebookTemplate=new i("notebook-template",{fontCharacter:"\\ebbf"}),i.debugRerun=new i("debug-rerun",{fontCharacter:"\\ebc0"}),i.workspaceTrusted=new i("workspace-trusted",{fontCharacter:"\\ebc1"}),i.workspaceUntrusted=new i("workspace-untrusted",{fontCharacter:"\\ebc2"}),i.workspaceUnspecified=new i("workspace-unspecified",{fontCharacter:"\\ebc3"}),i.terminalCmd=new i("terminal-cmd",{fontCharacter:"\\ebc4"}),i.terminalDebian=new i("terminal-debian",{fontCharacter:"\\ebc5"}),i.terminalLinux=new i("terminal-linux",{fontCharacter:"\\ebc6"}),i.terminalPowershell=new i("terminal-powershell",{fontCharacter:"\\ebc7"}),i.terminalTmux=new i("terminal-tmux",{fontCharacter:"\\ebc8"}),i.terminalUbuntu=new i("terminal-ubuntu",{fontCharacter:"\\ebc9"}),i.terminalBash=new i("terminal-bash",{fontCharacter:"\\ebca"}),i.arrowSwap=new i("arrow-swap",{fontCharacter:"\\ebcb"}),i.copy=new i("copy",{fontCharacter:"\\ebcc"}),i.personAdd=new i("person-add",{fontCharacter:"\\ebcd"}),i.filterFilled=new i("filter-filled",{fontCharacter:"\\ebce"}),i.wand=new i("wand",{fontCharacter:"\\ebcf"}),i.debugLineByLine=new i("debug-line-by-line",{fontCharacter:"\\ebd0"}),i.inspect=new i("inspect",{fontCharacter:"\\ebd1"}),i.dropDownButton=new i("drop-down-button",i.chevronDown.definition)}(n=e.Codicon||(e.Codicon={}))}),define(J[64],Z([0,1,19,2]),function($,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function A(u){const c=u;return c?[c.on,c.pause,c.resume,c.destroy].every(l=>typeof l=="function"):!1}e.isReadableStream=A;function b(u){const c=u;return c?A(c.stream)&&Array.isArray(c.buffer)&&typeof c.ended=="boolean":!1}e.isReadableBufferedStream=b;function E(u,c){return new n(u,c)}e.newWriteableStream=E;class n{constructor(c,l){this.reducer=c,this.options=l,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(c){var l;if(!this.state.destroyed){if(this.state.flowing)this.emitData(c);else if(this.buffer.data.push(c),typeof((l=this.options)===null||l===void 0?void 0:l.highWaterMark)=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(t=>this.pendingWritePromises.push(t))}}error(c){this.state.destroyed||(this.state.flowing?this.emitError(c):this.buffer.error.push(c))}end(c){this.state.destroyed||(typeof c!="undefined"&&this.write(c),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(c){this.listeners.data.slice(0).forEach(l=>l(c))}emitError(c){this.listeners.error.length===0?(0,m.onUnexpectedError)(c):this.listeners.error.slice(0).forEach(l=>l(c))}emitEnd(){this.listeners.end.slice(0).forEach(c=>c())}on(c,l){if(!this.state.destroyed)switch(c){case"data":this.listeners.data.push(l),this.resume();break;case"end":this.listeners.end.push(l),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(l),this.state.flowing&&this.flowErrors();break}}removeListener(c,l){if(this.state.destroyed)return;let t;switch(c){case"data":t=this.listeners.data;break;case"end":t=this.listeners.end;break;case"error":t=this.listeners.error;break}if(t){const r=t.indexOf(l);r>=0&&t.splice(r,1)}}flowData(){if(this.buffer.data.length>0){const c=this.reducer(this.buffer.data);this.emitData(c),this.buffer.data.length=0;const l=[...this.pendingWritePromises];this.pendingWritePromises.length=0,l.forEach(t=>t())}}flowErrors(){if(this.listeners.error.length>0){for(const c of this.buffer.error)this.emitError(c);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function w(u,c){const l=[];let t;for(;(t=u.read())!==null;)l.push(t);return c(l)}e.consumeReadable=w;function y(u,c,l){const t=[];let r;for(;(r=u.read())!==null&&t.length<l;)t.push(r);return r===null&&t.length>0?c(t):{read:()=>{if(t.length>0)return t.shift();if(typeof r!="undefined"){const s=r;return r=void 0,s}return u.read()}}}e.peekReadable=y;function i(u,c){return new Promise((l,t)=>{const r=[];I(u,{onData:s=>{c&&r.push(s)},onError:s=>{c?t(s):l(void 0)},onEnd:()=>{l(c?c(r):void 0)}})})}e.consumeStream=i;function I(u,c){u.on("error",l=>c.onError(l)),u.on("end",()=>c.onEnd()),u.on("data",l=>c.onData(l))}e.listenStream=I;function M(u,c){return new Promise((l,t)=>{const r=new L.DisposableStore,s=[],o=h=>{if(s.push(h),s.length>c)return r.dispose(),u.pause(),l({stream:u,buffer:s,ended:!1})},d=h=>t(h),f=()=>l({stream:u,buffer:s,ended:!0});r.add((0,L.toDisposable)(()=>u.removeListener("error",d))),u.on("error",d),r.add((0,L.toDisposable)(()=>u.removeListener("end",f))),u.on("end",f),r.add((0,L.toDisposable)(()=>u.removeListener("data",o))),u.on("data",o)})}e.peekStream=M;function p(u,c){const l=E(c);return l.end(u),l}e.toStream=p;function g(){const u=E(()=>{throw new Error("not supported")});return u.end(),u}e.emptyStream=g;function v(u){let c=!1;return{read:()=>c?null:(c=!0,u)}}e.toReadable=v;function D(u,c,l){const t=E(l);return I(u,{onData:r=>t.write(c.data(r)),onError:r=>t.error(c.error?c.error(r):r),onEnd:()=>t.end()}),t}e.transform=D;function S(u,c,l){let t=!1;return{read:()=>{const r=c.read();return t?r:(t=!0,r!==null?l([u,r]):u)}}}e.prefixedReadable=S;function a(u,c,l){let t=!1;const r=E(l);return I(c,{onData:s=>t?r.write(s):(t=!0,r.write(l([u,s]))),onError:s=>r.error(s),onEnd:()=>{t||(t=!0,r.write(u)),r.end()}}),r}e.prefixedStream=a}),define(J[23],Z([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.decodeUTF8=e.encodeUTF8=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format=e.isFalsyOrWhitespace=void 0;function m(H){return!H||typeof H!="string"?!0:H.trim().length===0}e.isFalsyOrWhitespace=m;const L=/{(\d+)}/g;function A(H,...ie){return ie.length===0?H:H.replace(L,function(ae,ce){const fe=parseInt(ce,10);return isNaN(fe)||fe<0||fe>=ie.length?ae:ie[fe]})}e.format=A;function b(H){return H.replace(/[<>&]/g,function(ie){switch(ie){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ie}})}e.escape=b;function E(H){return H.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=E;function n(H,ie){let ae=0;const ce=ie.charCodeAt(0);for(let fe=H.length-1;fe>=0;fe--)H.charCodeAt(fe)===ce&&ae++;return ae}e.count=n;function w(H,ie,ae="\u2026"){return H.length<=ie?H:`${H.substr(0,ie)}${ae}`}e.truncate=w;function y(H,ie=" "){const ae=i(H,ie);return I(ae,ie)}e.trim=y;function i(H,ie){if(!H||!ie)return H;const ae=ie.length;if(ae===0||H.length===0)return H;let ce=0;for(;H.indexOf(ie,ce)===ce;)ce=ce+ae;return H.substring(ce)}e.ltrim=i;function I(H,ie){if(!H||!ie)return H;const ae=ie.length,ce=H.length;if(ae===0||ce===0)return H;let fe=ce,be=-1;for(;be=H.lastIndexOf(ie,fe-1),!(be===-1||be+ae!==fe);){if(be===0)return"";fe=be}return H.substring(0,fe)}e.rtrim=I;function M(H){return H.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=M;function p(H){return H.replace(/\*/g,"")}e.stripWildcards=p;function g(H,ie,ae={}){if(!H)throw new Error("Cannot create regex from empty string");ie||(H=E(H)),ae.wholeWord&&(/\B/.test(H.charAt(0))||(H="\\b"+H),/\B/.test(H.charAt(H.length-1))||(H=H+"\\b"));let ce="";return ae.global&&(ce+="g"),ae.matchCase||(ce+="i"),ae.multiline&&(ce+="m"),ae.unicode&&(ce+="u"),new RegExp(H,ce)}e.createRegExp=g;function v(H){return H.source==="^"||H.source==="^$"||H.source==="$"||H.source==="^\\s*$"?!1:!!(H.exec("")&&H.lastIndex===0)}e.regExpLeadsToEndlessLoop=v;function D(H){return!!H.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=D;function S(H){return(H.global?"g":"")+(H.ignoreCase?"i":"")+(H.multiline?"m":"")+(H.unicode?"u":"")}e.regExpFlags=S;function a(H){return H.split(/\r\n|\r|\n/)}e.splitLines=a;function u(H){for(let ie=0,ae=H.length;ie<ae;ie++){const ce=H.charCodeAt(ie);if(ce!==32&&ce!==9)return ie}return-1}e.firstNonWhitespaceIndex=u;function c(H,ie=0,ae=H.length){for(let ce=ie;ce<ae;ce++){const fe=H.charCodeAt(ce);if(fe!==32&&fe!==9)return H.substring(ie,ce)}return H.substring(ie,ae)}e.getLeadingWhitespace=c;function l(H,ie=H.length-1){for(let ae=ie;ae>=0;ae--){const ce=H.charCodeAt(ae);if(ce!==32&&ce!==9)return ae}return-1}e.lastNonWhitespaceIndex=l;function t(H,ie){return H<ie?-1:H>ie?1:0}e.compare=t;function r(H,ie,ae=0,ce=H.length,fe=0,be=ie.length){for(;ae<ce&&fe<be;ae++,fe++){let Ue=H.charCodeAt(ae),ze=ie.charCodeAt(fe);if(Ue<ze)return-1;if(Ue>ze)return 1}const Me=ce-ae,Fe=be-fe;return Me<Fe?-1:Me>Fe?1:0}e.compareSubstring=r;function s(H,ie){return o(H,ie,0,H.length,0,ie.length)}e.compareIgnoreCase=s;function o(H,ie,ae=0,ce=H.length,fe=0,be=ie.length){for(;ae<ce&&fe<be;ae++,fe++){let Ue=H.charCodeAt(ae),ze=ie.charCodeAt(fe);if(Ue===ze)continue;const de=Ue-ze;if(!(de===32&&f(ze))&&!(de===-32&&f(Ue)))return d(Ue)&&d(ze)?de:r(H.toLowerCase(),ie.toLowerCase(),ae,ce,fe,be)}const Me=ce-ae,Fe=be-fe;return Me<Fe?-1:Me>Fe?1:0}e.compareSubstringIgnoreCase=o;function d(H){return H>=97&&H<=122}e.isLowerAsciiLetter=d;function f(H){return H>=65&&H<=90}e.isUpperAsciiLetter=f;function h(H){return d(H)||f(H)}function P(H,ie){return H.length===ie.length&&T(H,ie)}e.equalsIgnoreCase=P;function T(H,ie,ae=H.length){for(let ce=0;ce<ae;ce++){const fe=H.charCodeAt(ce),be=ie.charCodeAt(ce);if(fe!==be){if(h(fe)&&h(be)){const Me=Math.abs(fe-be);if(Me!==0&&Me!==32)return!1}else if(String.fromCharCode(fe).toLowerCase()!==String.fromCharCode(be).toLowerCase())return!1}}return!0}function U(H,ie){const ae=ie.length;return ie.length>H.length?!1:T(H,ie,ae)}e.startsWithIgnoreCase=U;function q(H,ie){let ae,ce=Math.min(H.length,ie.length);for(ae=0;ae<ce;ae++)if(H.charCodeAt(ae)!==ie.charCodeAt(ae))return ae;return ce}e.commonPrefixLength=q;function Q(H,ie){let ae,ce=Math.min(H.length,ie.length);const fe=H.length-1,be=ie.length-1;for(ae=0;ae<ce;ae++)if(H.charCodeAt(fe-ae)!==ie.charCodeAt(be-ae))return ae;return ce}e.commonSuffixLength=Q;function x(H){return 55296<=H&&H<=56319}e.isHighSurrogate=x;function j(H){return 56320<=H&&H<=57343}e.isLowSurrogate=j;function X(H,ie){return(H-55296<<10)+(ie-56320)+65536}e.computeCodePoint=X;function B(H,ie,ae){const ce=H.charCodeAt(ae);if(x(ce)&&ae+1<ie){const fe=H.charCodeAt(ae+1);if(j(fe))return X(ce,fe)}return ce}e.getNextCodePoint=B;function V(H,ie){const ae=H.charCodeAt(ie-1);if(j(ae)&&ie>1){const ce=H.charCodeAt(ie-2);if(x(ce))return X(ce,ae)}return ae}function N(H,ie){const ae=Be.getInstance(),ce=ie,fe=H.length,be=B(H,fe,ie);ie+=be>=65536?2:1;let Me=ae.getGraphemeBreakType(be);for(;ie<fe;){const Fe=B(H,fe,ie),Ue=ae.getGraphemeBreakType(Fe);if(je(Me,Ue))break;ie+=Fe>=65536?2:1,Me=Ue}return ie-ce}e.nextCharLength=N;function C(H,ie){const ae=Be.getInstance(),ce=ie,fe=V(H,ie);ie-=fe>=65536?2:1;let be=ae.getGraphemeBreakType(fe);for(;ie>0;){const Me=V(H,ie),Fe=ae.getGraphemeBreakType(Me);if(je(Fe,be))break;ie-=Me>=65536?2:1,be=Fe}return ce-ie}e.prevCharLength=C;function z(H,ie){const ae=Be.getInstance(),ce=H.length,fe=ie,be=B(H,ce,ie),Me=ae.getGraphemeBreakType(be);ie+=be>=65536?2:1;let Fe=Me;for(;ie<ce;){const ze=B(H,ce,ie),de=ae.getGraphemeBreakType(ze);if(je(Fe,de))break;ie+=ze>=65536?2:1,Fe=de}const Ue=ie;for(ie=fe,Fe=Me;ie>0;){const ze=V(H,ie),de=ae.getGraphemeBreakType(ze);if(je(de,Fe))break;ie-=ze>=65536?2:1,Fe=de}return[ie,Ue]}function F(H,ie){return ie>0&&j(H.charCodeAt(ie))?z(H,ie-1):z(H,ie)}e.getCharContainingOffset=F;function R(H){const ie=H.length;let ae=0,ce=0;for(;ce<ie;){const Me=B(H,ie,ce);ce+=Me>=65536?2:1,Me<128?ae+=1:Me<2048?ae+=2:Me<65536?ae+=3:ae+=4}const fe=new Uint8Array(ae);ce=0;let be=0;for(;ce<ie;){const Me=B(H,ie,ce);ce+=Me>=65536?2:1,Me<128?fe[be++]=Me:Me<2048?(fe[be++]=192|(Me&1984)>>>6,fe[be++]=128|(Me&63)>>>0):Me<65536?(fe[be++]=224|(Me&61440)>>>12,fe[be++]=128|(Me&4032)>>>6,fe[be++]=128|(Me&63)>>>0):(fe[be++]=240|(Me&1835008)>>>18,fe[be++]=128|(Me&258048)>>>12,fe[be++]=128|(Me&4032)>>>6,fe[be++]=128|(Me&63)>>>0)}return fe}e.encodeUTF8=R;function W(H){const ie=H.byteLength,ae=[];let ce=0;for(;ce<ie;){const fe=H[ce];let be;if(fe>=240&&ce+3<ie?be=(H[ce++]&7)<<18>>>0|(H[ce++]&63)<<12>>>0|(H[ce++]&63)<<6>>>0|(H[ce++]&63)<<0>>>0:fe>=224&&ce+2<ie?be=(H[ce++]&15)<<12>>>0|(H[ce++]&63)<<6>>>0|(H[ce++]&63)<<0>>>0:fe>=192&&ce+1<ie?be=(H[ce++]&31)<<6>>>0|(H[ce++]&63)<<0>>>0:be=H[ce++],be>=0&&be<=55295||be>=57344&&be<=65535)ae.push(String.fromCharCode(be));else if(be>=65536&&be<=1114111){const Me=be-65536,Fe=55296+((Me&1047552)>>>10),Ue=56320+((Me&1023)>>>0);ae.push(String.fromCharCode(Fe)),ae.push(String.fromCharCode(Ue))}else ae.push(String.fromCharCode(65533))}return ae.join("")}e.decodeUTF8=W;const k=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function O(H){return k.test(H)}e.containsRTL=O;const _=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function K(H){return _.test(H)}e.containsEmoji=K;const G=/^[\t\n\r\x20-\x7E]*$/;function Y(H){return G.test(H)}e.isBasicASCII=Y,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function ee(H){return e.UNUSUAL_LINE_TERMINATORS.test(H)}e.containsUnusualLineTerminators=ee;function ne(H){for(let ie=0,ae=H.length;ie<ae;ie++)if(re(H.charCodeAt(ie)))return!0;return!1}e.containsFullWidthCharacter=ne;function re(H){return H=+H,H>=11904&&H<=55215||H>=63744&&H<=64255||H>=65281&&H<=65374}e.isFullWidthCharacter=re;function se(H){return H>=127462&&H<=127487||H===8986||H===8987||H===9200||H===9203||H>=9728&&H<=10175||H===11088||H===11093||H>=127744&&H<=128591||H>=128640&&H<=128764||H>=128992&&H<=129003||H>=129280&&H<=129535||H>=129648&&H<=129750}e.isEmojiImprecise=se;function le(H,ie){if(H.length<ie)return H;const ae=/\b/g;let ce=0;for(;ae.test(H)&&!(H.length-ae.lastIndex<ie);)ce=ae.lastIndex,ae.lastIndex+=1;return H.substring(ce).replace(/^\s/,"")}e.lcut=le;const oe=/\x1B\x5B[12]?K/g,ue=/\x1b\[\d+m/g,me=/\x1b\[0?m/g;function Se(H){return H&&(H=H.replace(oe,""),H=H.replace(ue,""),H=H.replace(me,"")),H}e.removeAnsiEscapeCodes=Se,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Le(H){return!!(H&&H.length>0&&H.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Le;function Ie(H){return Le(H)?H.substr(1):H}e.stripUTF8BOM=Ie;function we(H,ie){if(!H||!ie||H.length<ie.length)return!1;const ae=ie.length,ce=H.toLowerCase();let fe=0,be=-1;for(;fe<ae;){const Me=ce.indexOf(ie[fe],be+1);if(Me<0)return!1;be=Me,fe++}return!0}e.fuzzyContains=we;function ye(H,ie=!1){return H?(ie&&(H=H.replace(/\\./g,"")),H.toLowerCase()!==H):!1}e.containsUppercaseCharacter=ye;function Re(H){return H.charAt(0).toUpperCase()+H.slice(1)}e.uppercaseFirstLetter=Re;function Te(H,ie=1){if(ie===0)return"";let ae=-1;do ae=H.indexOf(`
`,ae+1),ie--;while(ie>0&&ae>=0);return ae===-1?H:(H[ae-1]==="\r"&&ae--,H.substr(0,ae))}e.getNLines=Te;function $e(H){const ie=90-65+1;return H=H%(2*ie),H<ie?String.fromCharCode(97+H):String.fromCharCode(65+H-ie)}e.singleLetterHash=$e;function Ne(H){return Be.getInstance().getGraphemeBreakType(H)}e.getGraphemeBreakType=Ne;function je(H,ie){return H===0?ie!==5&&ie!==7:H===2&&ie===3?!1:H===4||H===2||H===3||ie===4||ie===2||ie===3?!0:!(H===8&&(ie===8||ie===9||ie===11||ie===12)||(H===11||H===9)&&(ie===9||ie===10)||(H===12||H===10)&&ie===10||ie===5||ie===13||ie===7||H===1||H===13&&ie===14||H===6&&ie===6)}e.breakBetweenGraphemeBreakType=je;var tt;(function(H){H[H.Other=0]="Other",H[H.Prepend=1]="Prepend",H[H.CR=2]="CR",H[H.LF=3]="LF",H[H.Control=4]="Control",H[H.Extend=5]="Extend",H[H.Regional_Indicator=6]="Regional_Indicator",H[H.SpacingMark=7]="SpacingMark",H[H.L=8]="L",H[H.V=9]="V",H[H.T=10]="T",H[H.LV=11]="LV",H[H.LVT=12]="LVT",H[H.ZWJ=13]="ZWJ",H[H.Extended_Pictographic=14]="Extended_Pictographic"})(tt=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Be{constructor(){this._data=ot()}static getInstance(){return Be._INSTANCE||(Be._INSTANCE=new Be),Be._INSTANCE}getGraphemeBreakType(ie){if(ie<32)return ie===10?3:ie===13?2:4;if(ie<127)return 0;const ae=this._data,ce=ae.length/3;let fe=1;for(;fe<=ce;)if(ie<ae[3*fe])fe=2*fe;else if(ie>ae[3*fe+1])fe=2*fe+1;else return ae[3*fe+2];return 0}}Be._INSTANCE=null;function ot(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function it(H,ie){if(H===0)return 0;const ae=ht(H,ie);if(ae!==void 0)return ae;const ce=V(ie,H);return H-=Ge(ce),H}e.getLeftDeleteOffset=it;function ht(H,ie){let ae=V(ie,H);for(H-=Ge(ae);dt(ae)||ae===65039||ae===8419;){if(H===0)return;ae=V(ie,H),H-=Ge(ae)}if(!!se(ae)){if(H>=0){const ce=V(ie,H);ce===8205&&(H-=Ge(ce))}return H}}function Ge(H){return H>=65536?2:1}function dt(H){return 127995<=H&&H<=127999}var at;(function(H){H[H.zwj=8205]="zwj",H[H.emojiVariantSelector=65039]="emojiVariantSelector",H[H.enclosingKeyCap=8419]="enclosingKeyCap"})(at||(at={}))}),define(J[20],Z([0,1,23,64]),function($,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const A=typeof Buffer!="undefined",b=typeof TextEncoder!="undefined",E=typeof TextDecoder!="undefined";let n,w;class y{constructor(h){this.buffer=h,this.byteLength=this.buffer.byteLength}static alloc(h){return A?new y(Buffer.allocUnsafe(h)):new y(new Uint8Array(h))}static wrap(h){return A&&!Buffer.isBuffer(h)&&(h=Buffer.from(h.buffer,h.byteOffset,h.byteLength)),new y(h)}static fromString(h,P){return!((P==null?void 0:P.dontUseNodeBuffer)||!1)&&A?new y(Buffer.from(h)):b?(n||(n=new TextEncoder),new y(n.encode(h))):new y(m.encodeUTF8(h))}static concat(h,P){if(typeof P=="undefined"){P=0;for(let q=0,Q=h.length;q<Q;q++)P+=h[q].byteLength}const T=y.alloc(P);let U=0;for(let q=0,Q=h.length;q<Q;q++){const x=h[q];T.set(x,U),U+=x.byteLength}return T}toString(){return A?this.buffer.toString():E?(w||(w=new TextDecoder),w.decode(this.buffer)):m.decodeUTF8(this.buffer)}slice(h,P){return new y(this.buffer.subarray(h,P))}set(h,P){h instanceof y?this.buffer.set(h.buffer,P):this.buffer.set(h,P)}readUInt32BE(h){return M(this.buffer,h)}writeUInt32BE(h,P){p(this.buffer,h,P)}readUInt32LE(h){return g(this.buffer,h)}writeUInt32LE(h,P){v(this.buffer,h,P)}readUInt8(h){return D(this.buffer,h)}writeUInt8(h,P){S(this.buffer,h,P)}}e.VSBuffer=y;function i(f,h){return f[h+0]<<0>>>0|f[h+1]<<8>>>0}e.readUInt16LE=i;function I(f,h,P){f[P+0]=h&255,h=h>>>8,f[P+1]=h&255}e.writeUInt16LE=I;function M(f,h){return f[h]*2**24+f[h+1]*2**16+f[h+2]*2**8+f[h+3]}e.readUInt32BE=M;function p(f,h,P){f[P+3]=h,h=h>>>8,f[P+2]=h,h=h>>>8,f[P+1]=h,h=h>>>8,f[P]=h}e.writeUInt32BE=p;function g(f,h){return f[h+0]<<0>>>0|f[h+1]<<8>>>0|f[h+2]<<16>>>0|f[h+3]<<24>>>0}e.readUInt32LE=g;function v(f,h,P){f[P+0]=h&255,h=h>>>8,f[P+1]=h&255,h=h>>>8,f[P+2]=h&255,h=h>>>8,f[P+3]=h&255}e.writeUInt32LE=v;function D(f,h){return f[h]}e.readUInt8=D;function S(f,h,P){f[P]=h}e.writeUInt8=S;function a(f){return L.consumeReadable(f,h=>y.concat(h))}e.readableToBuffer=a;function u(f){return L.toReadable(f)}e.bufferToReadable=u;function c(f){return L.consumeStream(f,h=>y.concat(h))}e.streamToBuffer=c;async function l(f){return f.ended?y.concat(f.buffer):y.concat([...f.buffer,await c(f.stream)])}e.bufferedStreamToBuffer=l;function t(f){return L.toStream(f,h=>y.concat(h))}e.bufferToStream=t;function r(f){return L.transform(f,{data:h=>typeof h=="string"?y.fromString(h):y.wrap(h)},h=>y.concat(h))}e.streamToBufferReadableStream=r;function s(f){return L.newWriteableStream(h=>y.concat(h),f)}e.newWriteableBufferStream=s;function o(f,h){return L.prefixedReadable(f,h,P=>y.concat(P))}e.prefixedBufferReadable=o;function d(f,h){return L.prefixedStream(f,h,P=>y.concat(P))}e.prefixedBufferStream=d}),define(J[80],Z([0,1,23]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.doHash=e.hash=void 0;function L(S){return A(S,0)}e.hash=L;function A(S,a){switch(typeof S){case"object":return S===null?b(349,a):Array.isArray(S)?w(S,a):y(S,a);case"string":return n(S,a);case"boolean":return E(S,a);case"number":return b(S,a);case"undefined":return b(937,a);default:return b(617,a)}}e.doHash=A;function b(S,a){return(a<<5)-a+S|0}function E(S,a){return b(S?433:863,a)}function n(S,a){a=b(149417,a);for(let u=0,c=S.length;u<c;u++)a=b(S.charCodeAt(u),a);return a}e.stringHash=n;function w(S,a){return a=b(104579,a),S.reduce((u,c)=>A(c,u),a)}function y(S,a){return a=b(181387,a),Object.keys(S).sort().reduce((u,c)=>(u=n(c,u),A(S[c],u)),a)}class i{constructor(){this._value=0}get value(){return this._value}hash(a){return this._value=A(a,this._value),this._value}}e.Hasher=i;var I;(function(S){S[S.BLOCK_SIZE=64]="BLOCK_SIZE",S[S.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(I||(I={}));function M(S,a,u=32){const c=u-a,l=~((1<<c)-1);return(S<<a|(l&S)>>>c)>>>0}function p(S,a=0,u=S.byteLength,c=0){for(let l=0;l<u;l++)S[a+l]=c}function g(S,a,u="0"){for(;S.length<a;)S=u+S;return S}function v(S,a=32){return S instanceof ArrayBuffer?Array.from(new Uint8Array(S)).map(u=>u.toString(16).padStart(2,"0")).join(""):g((S>>>0).toString(16),a/4)}e.toHexString=v;class D{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(a){const u=a.length;if(u===0)return;const c=this._buff;let l=this._buffLen,t=this._leftoverHighSurrogate,r,s;for(t!==0?(r=t,s=-1,t=0):(r=a.charCodeAt(0),s=0);;){let o=r;if(m.isHighSurrogate(r))if(s+1<u){const d=a.charCodeAt(s+1);m.isLowSurrogate(d)?(s++,o=m.computeCodePoint(r,d)):o=65533}else{t=r;break}else m.isLowSurrogate(r)&&(o=65533);if(l=this._push(c,l,o),s++,s<u)r=a.charCodeAt(s);else break}this._buffLen=l,this._leftoverHighSurrogate=t}_push(a,u,c){return c<128?a[u++]=c:c<2048?(a[u++]=192|(c&1984)>>>6,a[u++]=128|(c&63)>>>0):c<65536?(a[u++]=224|(c&61440)>>>12,a[u++]=128|(c&4032)>>>6,a[u++]=128|(c&63)>>>0):(a[u++]=240|(c&1835008)>>>18,a[u++]=128|(c&258048)>>>12,a[u++]=128|(c&4032)>>>6,a[u++]=128|(c&63)>>>0),u>=64&&(this._step(),u-=64,this._totalLen+=64,a[0]=a[64+0],a[1]=a[64+1],a[2]=a[64+2]),u}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),v(this._h0)+v(this._h1)+v(this._h2)+v(this._h3)+v(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,p(this._buff,this._buffLen),this._buffLen>56&&(this._step(),p(this._buff));const a=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(a/4294967296),!1),this._buffDV.setUint32(60,a%4294967296,!1),this._step()}_step(){const a=D._bigBlock32,u=this._buffDV;for(let h=0;h<64;h+=4)a.setUint32(h,u.getUint32(h,!1),!1);for(let h=64;h<320;h+=4)a.setUint32(h,M(a.getUint32(h-12,!1)^a.getUint32(h-32,!1)^a.getUint32(h-56,!1)^a.getUint32(h-64,!1),1),!1);let c=this._h0,l=this._h1,t=this._h2,r=this._h3,s=this._h4,o,d,f;for(let h=0;h<80;h++)h<20?(o=l&t|~l&r,d=1518500249):h<40?(o=l^t^r,d=1859775393):h<60?(o=l&t|l&r|t&r,d=2400959708):(o=l^t^r,d=3395469782),f=M(c,5)+o+s+d+a.getUint32(h*4,!1)&4294967295,s=r,r=t,t=M(l,30),l=c,c=f;this._h0=this._h0+c&4294967295,this._h1=this._h1+l&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+r&4294967295,this._h4=this._h4+s&4294967295}}e.StringSHA1=D,D._bigBlock32=new DataView(new ArrayBuffer(320))}),define(J[13],Z([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function m(h){return Array.isArray(h)}e.isArray=m;function L(h){return typeof h=="string"}e.isString=L;function A(h){return Array.isArray(h)&&h.every(P=>L(P))}e.isStringArray=A;function b(h){return typeof h=="object"&&h!==null&&!Array.isArray(h)&&!(h instanceof RegExp)&&!(h instanceof Date)}e.isObject=b;function E(h){return typeof h=="number"&&!isNaN(h)}e.isNumber=E;function n(h){return!!h&&typeof h[Symbol.iterator]=="function"}e.isIterable=n;function w(h){return h===!0||h===!1}e.isBoolean=w;function y(h){return typeof h=="undefined"}e.isUndefined=y;function i(h){return!I(h)}e.isDefined=i;function I(h){return y(h)||h===null}e.isUndefinedOrNull=I;function M(h,P){if(!h)throw new Error(P?`Unexpected type, expected '${P}'`:"Unexpected type")}e.assertType=M;function p(h){if(I(h))throw new Error("Assertion Failed: argument is undefined or null");return h}e.assertIsDefined=p;function g(...h){const P=[];for(let T=0;T<h.length;T++){const U=h[T];if(I(U))throw new Error(`Assertion Failed: argument at index ${T} is undefined or null`);P.push(U)}return P}e.assertAllDefined=g;const v=Object.prototype.hasOwnProperty;function D(h){if(!b(h))return!1;for(let P in h)if(v.call(h,P))return!1;return!0}e.isEmptyObject=D;function S(h){return typeof h=="function"}e.isFunction=S;function a(...h){return h.length>0&&h.every(S)}e.areFunctions=a;function u(h,P){const T=Math.min(h.length,P.length);for(let U=0;U<T;U++)c(h[U],P[U])}e.validateConstraints=u;function c(h,P){if(L(P)){if(typeof h!==P)throw new Error(`argument does not match constraint: typeof ${P}`)}else if(S(P)){try{if(h instanceof P)return}catch(T){}if(!I(h)&&h.constructor===P||P.length===1&&P.call(void 0,h)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=c;function l(h){let P=[],T=Object.getPrototypeOf(h);for(;Object.prototype!==T;)P=P.concat(Object.getOwnPropertyNames(T)),T=Object.getPrototypeOf(T);return P}e.getAllPropertyNames=l;function t(h){const P=[];for(const T of l(h))typeof h[T]=="function"&&P.push(T);return P}e.getAllMethodNames=t;function r(h,P){const T=q=>function(){const Q=Array.prototype.slice.call(arguments,0);return P(q,Q)};let U={};for(const q of h)U[q]=T(q);return U}e.createProxyObject=r;function s(h){return h===null?void 0:h}e.withNullAsUndefined=s;function o(h){return typeof h=="undefined"?null:h}e.withUndefinedAsNull=o;function d(h){return class{constructor(){return new Proxy({},{get(P,T){if(P[T])return P[T];throw new Error(`Not Implemented: ${h}->${String(T)}`)}})}}}e.NotImplementedProxy=d;function f(h){throw new Error("Unreachable")}e.assertNever=f}),define(J[30],Z([0,1,3,23,8,13]),function($,e,m,L,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function E(s){return s===47||s===92}e.isPathSeparator=E;function n(s){return s.replace(/[\\/]/g,A.posix.sep)}e.toSlashes=n;function w(s){return s.indexOf("/")===-1&&(s=n(s)),/^[a-zA-Z]:(\/|$)/.test(s)&&(s="/"+s),s}e.toPosixPath=w;function y(s,o=A.posix.sep){if(!s)return"";const d=s.length,f=s.charCodeAt(0);if(E(f)){if(E(s.charCodeAt(1))&&!E(s.charCodeAt(2))){let P=3;const T=P;for(;P<d&&!E(s.charCodeAt(P));P++);if(T!==P&&!E(s.charCodeAt(P+1))){for(P+=1;P<d;P++)if(E(s.charCodeAt(P)))return s.slice(0,P+1).replace(/[\\/]/g,o)}}return o}else if(S(f)&&s.charCodeAt(1)===58)return E(s.charCodeAt(2))?s.slice(0,2)+o:s.slice(0,2);let h=s.indexOf("://");if(h!==-1){for(h+=3;h<d;h++)if(E(s.charCodeAt(h)))return s.slice(0,h+1)}return""}e.getRoot=y;function i(s){if(!m.isWindows||!s||s.length<5)return!1;let o=s.charCodeAt(0);if(o!==92||(o=s.charCodeAt(1),o!==92))return!1;let d=2;const f=d;for(;d<s.length&&(o=s.charCodeAt(d),o!==92);d++);return!(f===d||(o=s.charCodeAt(d+1),isNaN(o)||o===92))}e.isUNC=i;const I=/[\\/:\*\?"<>\|]/g,M=/[\\/]/g,p=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function g(s,o=m.isWindows){const d=o?I:M;return!(!s||s.length===0||/^\s+$/.test(s)||(d.lastIndex=0,d.test(s))||o&&p.test(s)||s==="."||s===".."||o&&s[s.length-1]==="."||o&&s.length!==s.trim().length||s.length>255)}e.isValidBasename=g;function v(s,o,d){const f=s===o;return!d||f?f:!s||!o?!1:(0,L.equalsIgnoreCase)(s,o)}e.isEqual=v;function D(s,o,d,f=A.sep){if(s===o)return!0;if(!s||!o||o.length>s.length)return!1;if(d){if(!(0,L.startsWithIgnoreCase)(s,o))return!1;if(o.length===s.length)return!0;let P=o.length;return o.charAt(o.length-1)===f&&P--,s.charAt(P)===f}return o.charAt(o.length-1)!==f&&(o+=f),s.indexOf(o)===0}e.isEqualOrParent=D;function S(s){return s>=65&&s<=90||s>=97&&s<=122}e.isWindowsDriveLetter=S;function a(s,o){return m.isWindows&&s.endsWith(":")&&(s+=A.sep),(0,A.isAbsolute)(s)||(s=(0,A.join)(o,s)),s=(0,A.normalize)(s),m.isWindows?(s=(0,L.rtrim)(s,A.sep),s.endsWith(":")&&(s+=A.sep)):(s=(0,L.rtrim)(s,A.sep),s||(s=A.sep)),s}e.sanitizeFilePath=a;function u(s){const o=(0,A.normalize)(s);return m.isWindows?s.length>3?!1:c(o)&&(s.length===2||o.charCodeAt(2)===92):o===A.posix.sep}e.isRootOrDriveLetter=u;function c(s){return m.isWindows?S(s.charCodeAt(0))&&s.charCodeAt(1)===58:!1}e.hasDriveLetter=c;function l(s){return c(s)?s[0]:void 0}e.getDriveLetter=l;function t(s,o,d){return o.length>s.length?-1:s===o?0:(d&&(s=s.toLowerCase(),o=o.toLowerCase()),s.indexOf(o))}e.indexOfPath=t;function r(s){const o=s.split(":");let d,f,h;if(o.forEach(P=>{const T=Number(P);(0,b.isNumber)(T)?f===void 0?f=T:h===void 0&&(h=T):d=d?[d,P].join(":"):P}),!d)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:d,line:f!==void 0?f:void 0,column:h!==void 0?h:f!==void 0?1:void 0}}e.parseLineAndColumnAware=r}),define(J[44],Z([0,1,13]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function L(v){if(!v||typeof v!="object"||v instanceof RegExp)return v;const D=Array.isArray(v)?[]:{};return Object.keys(v).forEach(S=>{v[S]&&typeof v[S]=="object"?D[S]=L(v[S]):D[S]=v[S]}),D}e.deepClone=L;function A(v){if(!v||typeof v!="object")return v;const D=[v];for(;D.length>0;){const S=D.shift();Object.freeze(S);for(const a in S)if(b.call(S,a)){const u=S[a];typeof u=="object"&&!Object.isFrozen(u)&&D.push(u)}}return v}e.deepFreeze=A;const b=Object.prototype.hasOwnProperty;function E(v,D){return n(v,D,new Set)}e.cloneAndChange=E;function n(v,D,S){if((0,m.isUndefinedOrNull)(v))return v;const a=D(v);if(typeof a!="undefined")return a;if((0,m.isArray)(v)){const u=[];for(const c of v)u.push(n(c,D,S));return u}if((0,m.isObject)(v)){if(S.has(v))throw new Error("Cannot clone recursive data-structure");S.add(v);const u={};for(let c in v)b.call(v,c)&&(u[c]=n(v[c],D,S));return S.delete(v),u}return v}function w(v,D,S=!0){return(0,m.isObject)(v)?((0,m.isObject)(D)&&Object.keys(D).forEach(a=>{a in v?S&&((0,m.isObject)(v[a])&&(0,m.isObject)(D[a])?w(v[a],D[a],S):v[a]=D[a]):v[a]=D[a]}),v):D}e.mixin=w;function y(v,D){if(v===D)return!0;if(v==null||D===null||D===void 0||typeof v!=typeof D||typeof v!="object"||Array.isArray(v)!==Array.isArray(D))return!1;let S,a;if(Array.isArray(v)){if(v.length!==D.length)return!1;for(S=0;S<v.length;S++)if(!y(v[S],D[S]))return!1}else{const u=[];for(a in v)u.push(a);u.sort();const c=[];for(a in D)c.push(a);if(c.sort(),!y(u,c))return!1;for(S=0;S<u.length;S++)if(!y(v[u[S]],D[u[S]]))return!1}return!0}e.equals=y;function i(v){const D=new Set;return JSON.stringify(v,(S,a)=>{if((0,m.isObject)(a)||Array.isArray(a)){if(D.has(a))return"[Circular]";D.add(a)}return a})}e.safeStringify=i;function I(v,D,S){const a=D(v);return typeof a=="undefined"?S:a}e.getOrDefault=I;function M(v,D){const S=Object.create(null);return!v||!D||Object.keys(D).forEach(u=>{const c=v[u],l=D[u];y(c,l)||(S[u]=l)}),S}e.distinct=M;function p(v,D){const S=D.toLowerCase(),a=Object.keys(v).find(u=>u.toLowerCase()===S);return a?v[a]:v[D]}e.getCaseInsensitive=p;function g(v,D){const S=Object.create(null);for(const a of Object.keys(v))D(a,v[a])&&(S[a]=v[a]);return S}e.filter=g}),define(J[7],Z([0,1,3,8]),function($,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const A=/^\w[\w\d+.-]*$/,b=/^\//,E=/^\/\//;function n(s,o){if(!s.scheme&&o)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${s.authority}", path: "${s.path}", query: "${s.query}", fragment: "${s.fragment}"}`);if(s.scheme&&!A.test(s.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(s.path){if(s.authority){if(!b.test(s.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(E.test(s.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function w(s,o){return!s&&!o?"file":s}function y(s,o){switch(s){case"https":case"http":case"file":o?o[0]!==I&&(o=I+o):o=I;break}return o}const i="",I="/",M=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class p{constructor(o,d,f,h,P,T=!1){typeof o=="object"?(this.scheme=o.scheme||i,this.authority=o.authority||i,this.path=o.path||i,this.query=o.query||i,this.fragment=o.fragment||i):(this.scheme=w(o,T),this.authority=d||i,this.path=y(this.scheme,f||i),this.query=h||i,this.fragment=P||i,n(this,T))}static isUri(o){return o instanceof p?!0:o?typeof o.authority=="string"&&typeof o.fragment=="string"&&typeof o.path=="string"&&typeof o.query=="string"&&typeof o.scheme=="string"&&typeof o.fsPath=="string"&&typeof o.with=="function"&&typeof o.toString=="function":!1}get fsPath(){return u(this,!1)}with(o){if(!o)return this;let{scheme:d,authority:f,path:h,query:P,fragment:T}=o;return d===void 0?d=this.scheme:d===null&&(d=i),f===void 0?f=this.authority:f===null&&(f=i),h===void 0?h=this.path:h===null&&(h=i),P===void 0?P=this.query:P===null&&(P=i),T===void 0?T=this.fragment:T===null&&(T=i),d===this.scheme&&f===this.authority&&h===this.path&&P===this.query&&T===this.fragment?this:new v(d,f,h,P,T)}static parse(o,d=!1){const f=M.exec(o);return f?new v(f[2]||i,r(f[4]||i),r(f[5]||i),r(f[7]||i),r(f[9]||i),d):new v(i,i,i,i,i)}static file(o){let d=i;if(m.isWindows&&(o=o.replace(/\\/g,I)),o[0]===I&&o[1]===I){const f=o.indexOf(I,2);f===-1?(d=o.substring(2),o=I):(d=o.substring(2,f),o=o.substring(f)||I)}return new v("file",d,o,i,i)}static from(o){const d=new v(o.scheme,o.authority,o.path,o.query,o.fragment);return n(d,!0),d}static joinPath(o,...d){if(!o.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let f;return m.isWindows&&o.scheme==="file"?f=p.file(L.win32.join(u(o,!0),...d)).path:f=L.posix.join(o.path,...d),o.with({path:f})}toString(o=!1){return c(this,o)}toJSON(){return this}static revive(o){if(o){if(o instanceof p)return o;{const d=new v(o);return d._formatted=o.external,d._fsPath=o._sep===g?o.fsPath:null,d}}else return o}}e.URI=p;const g=m.isWindows?1:void 0;class v extends p{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=u(this,!1)),this._fsPath}toString(o=!1){return o?c(this,!0):(this._formatted||(this._formatted=c(this,!1)),this._formatted)}toJSON(){const o={$mid:1};return this._fsPath&&(o.fsPath=this._fsPath,o._sep=g),this._formatted&&(o.external=this._formatted),this.path&&(o.path=this.path),this.scheme&&(o.scheme=this.scheme),this.authority&&(o.authority=this.authority),this.query&&(o.query=this.query),this.fragment&&(o.fragment=this.fragment),o}}const D={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function S(s,o){let d,f=-1;for(let h=0;h<s.length;h++){const P=s.charCodeAt(h);if(P>=97&&P<=122||P>=65&&P<=90||P>=48&&P<=57||P===45||P===46||P===95||P===126||o&&P===47)f!==-1&&(d+=encodeURIComponent(s.substring(f,h)),f=-1),d!==void 0&&(d+=s.charAt(h));else{d===void 0&&(d=s.substr(0,h));const T=D[P];T!==void 0?(f!==-1&&(d+=encodeURIComponent(s.substring(f,h)),f=-1),d+=T):f===-1&&(f=h)}}return f!==-1&&(d+=encodeURIComponent(s.substring(f))),d!==void 0?d:s}function a(s){let o;for(let d=0;d<s.length;d++){const f=s.charCodeAt(d);f===35||f===63?(o===void 0&&(o=s.substr(0,d)),o+=D[f]):o!==void 0&&(o+=s[d])}return o!==void 0?o:s}function u(s,o){let d;return s.authority&&s.path.length>1&&s.scheme==="file"?d=`//${s.authority}${s.path}`:s.path.charCodeAt(0)===47&&(s.path.charCodeAt(1)>=65&&s.path.charCodeAt(1)<=90||s.path.charCodeAt(1)>=97&&s.path.charCodeAt(1)<=122)&&s.path.charCodeAt(2)===58?o?d=s.path.substr(1):d=s.path[1].toLowerCase()+s.path.substr(2):d=s.path,m.isWindows&&(d=d.replace(/\//g,"\\")),d}e.uriToFsPath=u;function c(s,o){const d=o?a:S;let f="",{scheme:h,authority:P,path:T,query:U,fragment:q}=s;if(h&&(f+=h,f+=":"),(P||h==="file")&&(f+=I,f+=I),P){let Q=P.indexOf("@");if(Q!==-1){const x=P.substr(0,Q);P=P.substr(Q+1),Q=x.indexOf(":"),Q===-1?f+=d(x,!1):(f+=d(x.substr(0,Q),!1),f+=":",f+=d(x.substr(Q+1),!1)),f+="@"}P=P.toLowerCase(),Q=P.indexOf(":"),Q===-1?f+=d(P,!1):(f+=d(P.substr(0,Q),!1),f+=P.substr(Q))}if(T){if(T.length>=3&&T.charCodeAt(0)===47&&T.charCodeAt(2)===58){const Q=T.charCodeAt(1);Q>=65&&Q<=90&&(T=`/${String.fromCharCode(Q+32)}:${T.substr(3)}`)}else if(T.length>=2&&T.charCodeAt(1)===58){const Q=T.charCodeAt(0);Q>=65&&Q<=90&&(T=`${String.fromCharCode(Q+32)}:${T.substr(2)}`)}f+=d(T,!0)}return U&&(f+="?",f+=d(U,!1)),q&&(f+="#",f+=o?q:S(q,!1)),f}function l(s){try{return decodeURIComponent(s)}catch(o){return s.length>3?s.substr(0,3)+l(s.substr(3)):s}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(s){return s.match(t)?s.replace(t,o=>l(o)):s}}),define(J[109],Z([0,1,7]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function L(y){const i=y;return i&&typeof i.type=="string"&&typeof i.severity=="string"}e.isRemoteConsoleLog=L;function A(y){const i=[];let I;try{const M=JSON.parse(y.arguments),p=M[M.length-1];p&&p.__$stack&&(M.pop(),I=p.__$stack),i.push(...M)}catch(M){i.push("Unable to log remote console arguments",y.arguments)}return{args:i,stack:I}}e.parse=A;function b(y){if(typeof y!="string")return b(A(y).stack);const i=y;if(i){const I=E(i),M=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(I||"");if(M&&M.length===4)return{uri:m.URI.file(M[1]),line:Number(M[2]),column:Number(M[3])}}}e.getFirstFrame=b;function E(y){if(!y)return y;const i=y.indexOf(`
`);return i===-1?y:y.substring(0,i)}function n(y,i){const{args:I,stack:M}=A(y),p=typeof I[0]=="string"&&I.length===1;let g=E(M);g&&(g=`(${g.trim()})`);let v=[];if(typeof I[0]=="string"?g&&p?v=[`%c[${i}] %c${I[0]} %c${g}`,w("blue"),w(""),w("grey")]:v=[`%c[${i}] %c${I[0]}`,w("blue"),w(""),...I.slice(1)]:v=[`%c[${i}]%`,w("blue"),...I],g&&!p&&v.push(g),typeof console[y.severity]!="function")throw new Error("Unknown console method");console[y.severity].apply(console,v)}e.log=n;function w(y){return`color: ${y}`}});var kt=this&&this.__classPrivateFieldSet||function($,e,m,L,A){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!A)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?$!==e||!A:!e.has($))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?A.call($,m):A?A.value=m:e.set($,m),m},Ke=this&&this.__classPrivateFieldGet||function($,e,m,L){if(m==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?$!==e||!L:!e.has($))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?L:m==="a"?L.call($):L?L.value:e.get($)};define(J[36],Z([0,1,7,23]),function($,e,m,L){"use strict";var A,b,E;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function n(t,r,s){let o=t.get(r);return o===void 0&&(o=s,t.set(r,o)),o}e.getOrSet=n;function w(t){const r=[];return t.forEach((s,o)=>{r.push(`${o} => ${s}`)}),`Map(${t.size}) {${r.join(", ")}}`}e.mapToString=w;function y(t){const r=[];return t.forEach(s=>{r.push(s)}),`Set(${t.size}) {${r.join(", ")}}`}e.setToString=y;class i{constructor(){this._value="",this._pos=0}reset(r){return this._value=r,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(r){const s=r.charCodeAt(0),o=this._value.charCodeAt(this._pos);return s-o}value(){return this._value[this._pos]}}e.StringIterator=i;class I{constructor(r=!0){this._caseSensitive=r}reset(r){return this._value=r,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(r)this._from++;else break;else r=!1;return this}cmp(r){return this._caseSensitive?(0,L.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=I;class M{constructor(r=!0,s=!0){this._splitOnBackslash=r,this._caseSensitive=s}reset(r){return this._value=r.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++){const s=this._value.charCodeAt(this._to);if(s===47||this._splitOnBackslash&&s===92)if(r)this._from++;else break;else r=!1}return this}cmp(r){return this._caseSensitive?(0,L.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=M;var p;(function(t){t[t.Scheme=1]="Scheme",t[t.Authority=2]="Authority",t[t.Path=3]="Path",t[t.Query=4]="Query",t[t.Fragment=5]="Fragment"})(p||(p={}));class g{constructor(r){this._ignorePathCasing=r,this._states=[],this._stateIdx=0}reset(r){return this._value=r,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new M(!1,!this._ignorePathCasing(r)),this._pathIterator.reset(r.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(r){if(this._states[this._stateIdx]===1)return(0,L.compareIgnoreCase)(r,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,L.compareIgnoreCase)(r,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(r);if(this._states[this._stateIdx]===4)return(0,L.compare)(r,this._value.query);if(this._states[this._stateIdx]===5)return(0,L.compare)(r,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=g;class v{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class D{constructor(r){this._iter=r}static forUris(r=()=>!1){return new D(new g(r))}static forPaths(){return new D(new M)}static forStrings(){return new D(new i)}static forConfigKeys(){return new D(new I)}clear(){this._root=void 0}set(r,s){const o=this._iter.reset(r);let d;for(this._root||(this._root=new v,this._root.segment=o.value()),d=this._root;;){const h=o.cmp(d.segment);if(h>0)d.left||(d.left=new v,d.left.segment=o.value()),d=d.left;else if(h<0)d.right||(d.right=new v,d.right.segment=o.value()),d=d.right;else if(o.hasNext())o.next(),d.mid||(d.mid=new v,d.mid.segment=o.value()),d=d.mid;else break}const f=d.value;return d.value=s,d.key=r,f}get(r){var s;return(s=this._getNode(r))===null||s===void 0?void 0:s.value}_getNode(r){const s=this._iter.reset(r);let o=this._root;for(;o;){const d=s.cmp(o.segment);if(d>0)o=o.left;else if(d<0)o=o.right;else if(s.hasNext())s.next(),o=o.mid;else break}return o}has(r){const s=this._getNode(r);return!((s==null?void 0:s.value)===void 0&&(s==null?void 0:s.mid)===void 0)}delete(r){return this._delete(r,!1)}deleteSuperstr(r){return this._delete(r,!0)}_delete(r,s){const o=this._iter.reset(r),d=[];let f=this._root;for(;f;){const h=o.cmp(f.segment);if(h>0)d.push([1,f]),f=f.left;else if(h<0)d.push([-1,f]),f=f.right;else if(o.hasNext())o.next(),d.push([0,f]),f=f.mid;else{for(s?(f.left=void 0,f.mid=void 0,f.right=void 0):f.value=void 0;d.length>0&&f.isEmpty();){let[P,T]=d.pop();switch(P){case 1:T.left=void 0;break;case 0:T.mid=void 0;break;case-1:T.right=void 0;break}f=T}break}}}findSubstr(r){const s=this._iter.reset(r);let o=this._root,d;for(;o;){const f=s.cmp(o.segment);if(f>0)o=o.left;else if(f<0)o=o.right;else if(s.hasNext())s.next(),d=o.value||d,o=o.mid;else break}return o&&o.value||d}findSuperstr(r){const s=this._iter.reset(r);let o=this._root;for(;o;){const d=s.cmp(o.segment);if(d>0)o=o.left;else if(d<0)o=o.right;else if(s.hasNext())s.next(),o=o.mid;else return o.mid?this._entries(o.mid):void 0}}forEach(r){for(const[s,o]of this)r(o,s)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(r){r&&(yield*this._entries(r.left),r.value&&(yield[r.key,r.value]),yield*this._entries(r.mid),yield*this._entries(r.right))}}e.TernarySearchTree=D;class S{constructor(r,s){this[A]="ResourceMap",r instanceof S?(this.map=new Map(r.map),this.toKey=s!=null?s:S.defaultToKey):(this.map=new Map,this.toKey=r!=null?r:S.defaultToKey)}set(r,s){return this.map.set(this.toKey(r),s),this}get(r){return this.map.get(this.toKey(r))}has(r){return this.map.has(this.toKey(r))}get size(){return this.map.size}clear(){this.map.clear()}delete(r){return this.map.delete(this.toKey(r))}forEach(r,s){typeof s!="undefined"&&(r=r.bind(s));for(let[o,d]of this.map)r(d,m.URI.parse(o),this)}values(){return this.map.values()}*keys(){for(let r of this.map.keys())yield m.URI.parse(r)}*entries(){for(let r of this.map.entries())yield[m.URI.parse(r[0]),r[1]]}*[(A=Symbol.toStringTag,Symbol.iterator)](){for(let r of this.map)yield[m.URI.parse(r[0]),r[1]]}}e.ResourceMap=S,S.defaultToKey=t=>t.toString();var a;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(a=e.Touch||(e.Touch={}));class u{constructor(){this[b]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){var r;return(r=this._head)===null||r===void 0?void 0:r.value}get last(){var r;return(r=this._tail)===null||r===void 0?void 0:r.value}has(r){return this._map.has(r)}get(r,s=0){const o=this._map.get(r);if(!!o)return s!==0&&this.touch(o,s),o.value}set(r,s,o=0){let d=this._map.get(r);if(d)d.value=s,o!==0&&this.touch(d,o);else{switch(d={key:r,value:s,next:void 0,previous:void 0},o){case 0:this.addItemLast(d);break;case 1:this.addItemFirst(d);break;case 2:this.addItemLast(d);break;default:this.addItemLast(d);break}this._map.set(r,d),this._size++}return this}delete(r){return!!this.remove(r)}remove(r){const s=this._map.get(r);if(!!s)return this._map.delete(r),this.removeItem(s),this._size--,s.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const r=this._head;return this._map.delete(r.key),this.removeItem(r),this._size--,r.value}forEach(r,s){const o=this._state;let d=this._head;for(;d;){if(s?r.bind(s)(d.value,d.key,this):r(d.value,d.key,this),this._state!==o)throw new Error("LinkedMap got modified during iteration.");d=d.next}}keys(){const r=this,s=this._state;let o=this._head;const d={[Symbol.iterator](){return d},next(){if(r._state!==s)throw new Error("LinkedMap got modified during iteration.");if(o){const f={value:o.key,done:!1};return o=o.next,f}else return{value:void 0,done:!0}}};return d}values(){const r=this,s=this._state;let o=this._head;const d={[Symbol.iterator](){return d},next(){if(r._state!==s)throw new Error("LinkedMap got modified during iteration.");if(o){const f={value:o.value,done:!1};return o=o.next,f}else return{value:void 0,done:!0}}};return d}entries(){const r=this,s=this._state;let o=this._head;const d={[Symbol.iterator](){return d},next(){if(r._state!==s)throw new Error("LinkedMap got modified during iteration.");if(o){const f={value:[o.key,o.value],done:!1};return o=o.next,f}else return{value:void 0,done:!0}}};return d}[(b=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(r){if(r>=this.size)return;if(r===0){this.clear();return}let s=this._head,o=this.size;for(;s&&o>r;)this._map.delete(s.key),s=s.next,o--;this._head=s,this._size=o,s&&(s.previous=void 0),this._state++}addItemFirst(r){if(!this._head&&!this._tail)this._tail=r;else if(this._head)r.next=this._head,this._head.previous=r;else throw new Error("Invalid list");this._head=r,this._state++}addItemLast(r){if(!this._head&&!this._tail)this._head=r;else if(this._tail)r.previous=this._tail,this._tail.next=r;else throw new Error("Invalid list");this._tail=r,this._state++}removeItem(r){if(r===this._head&&r===this._tail)this._head=void 0,this._tail=void 0;else if(r===this._head){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this._head=r.next}else if(r===this._tail){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this._tail=r.previous}else{const s=r.next,o=r.previous;if(!s||!o)throw new Error("Invalid list");s.previous=o,o.next=s}r.next=void 0,r.previous=void 0,this._state++}touch(r,s){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(r===this._head)return;const o=r.next,d=r.previous;r===this._tail?(d.next=void 0,this._tail=d):(o.previous=d,d.next=o),r.previous=void 0,r.next=this._head,this._head.previous=r,this._head=r,this._state++}else if(s===2){if(r===this._tail)return;const o=r.next,d=r.previous;r===this._head?(o.previous=void 0,this._head=o):(o.previous=d,d.next=o),r.next=void 0,r.previous=this._tail,this._tail.next=r,this._tail=r,this._state++}}}toJSON(){const r=[];return this.forEach((s,o)=>{r.push([o,s])}),r}fromJSON(r){this.clear();for(const[s,o]of r)this.set(s,o)}}e.LinkedMap=u;class c extends u{constructor(r,s=1){super();this._limit=r,this._ratio=Math.min(Math.max(0,s),1)}get limit(){return this._limit}set limit(r){this._limit=r,this.checkTrim()}get ratio(){return this._ratio}set ratio(r){this._ratio=Math.min(Math.max(0,r),1),this.checkTrim()}get(r,s=2){return super.get(r,s)}peek(r){return super.get(r,0)}set(r,s){return super.set(r,s,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=c;class l{constructor(r){E.set(this,void 0),kt(this,E,r,"f")}get size(){return Ke(this,E,"f").size}forEach(r,s){Ke(this,E,"f").forEach(r,s)}get(r){return Ke(this,E,"f").get(r)}has(r){return Ke(this,E,"f").has(r)}entries(){return Ke(this,E,"f").entries()}keys(){return Ke(this,E,"f").keys()}values(){return Ke(this,E,"f").values()}[(E=new WeakMap,Symbol.iterator)](){return Ke(this,E,"f").entries()}}e.ReadonlyMapView=l}),define(J[110],Z([0,1,20,23,7]),function($,e,m,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function b(y){return JSON.stringify(y,n)}e.stringify=b;function E(y){let i=JSON.parse(y);return i=w(i),i}e.parse=E;function n(y,i){return i instanceof RegExp?{$mid:2,source:i.source,flags:(0,L.regExpFlags)(i)}:i}function w(y,i=0){if(!y||i>200)return y;if(typeof y=="object"){switch(y.$mid){case 1:return A.URI.revive(y);case 2:return new RegExp(y.source,y.flags)}if(y instanceof m.VSBuffer||y instanceof Uint8Array)return y;if(Array.isArray(y))for(let I=0;I<y.length;++I)y[I]=w(y[I],i+1);else for(const I in y)Object.hasOwnProperty.call(y,I)&&(y[I]=w(y[I],i+1))}return y}e.revive=w}),define(J[10],Z([0,1,7,3]),function($,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var A;(function(n){n.inMemory="inmemory",n.vscode="vscode",n.internal="private",n.walkThrough="walkThrough",n.walkThroughSnippet="walkThroughSnippet",n.http="http",n.https="https",n.file="file",n.mailto="mailto",n.untitled="untitled",n.data="data",n.command="command",n.vscodeRemote="vscode-remote",n.vscodeRemoteResource="vscode-remote-resource",n.userData="vscode-userdata",n.vscodeCustomEditor="vscode-custom-editor",n.vscodeNotebook="vscode-notebook",n.vscodeNotebookCell="vscode-notebook-cell",n.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",n.vscodeNotebookCellOutput="vscode-notebook-cell-output",n.vscodeSettings="vscode-settings",n.vscodeWorkspaceTrust="vscode-workspace-trust",n.vscodeTerminal="vscode-terminal",n.webviewPanel="webview-panel",n.vscodeWebview="vscode-webview",n.extension="extension",n.vscodeFileResource="vscode-file",n.tmp="tmp"})(A=e.Schemas||(e.Schemas={}));class b{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(w){this._preferredWebSchema=w}setDelegate(w){this._delegate=w}set(w,y,i){this._hosts[w]=y,this._ports[w]=i}setConnectionToken(w,y){this._connectionTokens[w]=y}rewrite(w){if(this._delegate)return this._delegate(w);const y=w.authority;let i=this._hosts[y];i&&i.indexOf(":")!==-1&&(i=`[${i}]`);const I=this._ports[y],M=this._connectionTokens[y];let p=`path=${encodeURIComponent(w.path)}`;return typeof M=="string"&&(p+=`&tkn=${encodeURIComponent(M)}`),m.URI.from({scheme:L.isWeb?this._preferredWebSchema:A.vscodeRemoteResource,authority:`${i}:${I}`,path:"/vscode-remote-resource",query:p})}}e.RemoteAuthorities=new b;class E{constructor(){this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(w,y,i){const I=this.toUri(w,y);return I.scheme===A.vscodeRemote?e.RemoteAuthorities.rewrite(I):L.isNative&&(i||L.isPreferringBrowserCodeLoad)&&I.scheme===A.file?I.with({scheme:A.vscodeFileResource,authority:I.authority||this.FALLBACK_AUTHORITY,query:null,fragment:null}):I}asFileUri(w,y){const i=this.toUri(w,y);return i.scheme===A.vscodeFileResource?i.with({scheme:A.file,authority:i.authority!==this.FALLBACK_AUTHORITY?i.authority:null,query:null,fragment:null}):i}toUri(w,y){return m.URI.isUri(w)?w:m.URI.parse(y.toUrl(w))}}e.FileAccess=new E}),define(J[65],Z([0,1,36]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=e.canNormalize=void 0,e.canNormalize=typeof String.prototype.normalize=="function";const L=new m.LRUCache(1e4);function A(y){return w(y,"NFC",L)}e.normalizeNFC=A;const b=new m.LRUCache(1e4);function E(y){return w(y,"NFD",b)}e.normalizeNFD=E;const n=/[^\u0000-\u0080]/;function w(y,i,I){if(!e.canNormalize||!y)return y;const M=I.get(y);if(M)return M;let p;return n.test(y)?p=y.normalize(i):p=y,I.set(y,p),p}e.removeAccents=function(){if(e.canNormalize){const y=/[\u0300-\u036f]/g;return function(i){return E(i).replace(y,"")}}else return function(y){return y}}()}),define(J[15],Z([0,1,30,8,7,23,10,3]),function($,e,m,L,A,b,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function w(p){return(0,A.uriToFsPath)(p,!0)}e.originalFSPath=w;class y{constructor(g){this._ignorePathCasing=g}compare(g,v,D=!1){return g===v?0:(0,b.compare)(this.getComparisonKey(g,D),this.getComparisonKey(v,D))}isEqual(g,v,D=!1){return g===v?!0:!g||!v?!1:this.getComparisonKey(g,D)===this.getComparisonKey(v,D)}getComparisonKey(g,v=!1){return g.with({path:this._ignorePathCasing(g)?g.path.toLowerCase():void 0,fragment:v?null:void 0}).toString()}ignorePathCasing(g){return this._ignorePathCasing(g)}isEqualOrParent(g,v,D=!1){if(g.scheme===v.scheme){if(g.scheme===E.Schemas.file)return m.isEqualOrParent(w(g),w(v),this._ignorePathCasing(g))&&g.query===v.query&&(D||g.fragment===v.fragment);if((0,e.isEqualAuthority)(g.authority,v.authority))return m.isEqualOrParent(g.path,v.path,this._ignorePathCasing(g),"/")&&g.query===v.query&&(D||g.fragment===v.fragment)}return!1}joinPath(g,...v){return A.URI.joinPath(g,...v)}basenameOrAuthority(g){return(0,e.basename)(g)||g.authority}basename(g){return L.posix.basename(g.path)}extname(g){return L.posix.extname(g.path)}dirname(g){if(g.path.length===0)return g;let v;return g.scheme===E.Schemas.file?v=A.URI.file(L.dirname(w(g))).path:(v=L.posix.dirname(g.path),g.authority&&v.length&&v.charCodeAt(0)!==47&&(console.error(`dirname("${g.toString})) resulted in a relative path`),v="/")),g.with({path:v})}normalizePath(g){if(!g.path.length)return g;let v;return g.scheme===E.Schemas.file?v=A.URI.file(L.normalize(w(g))).path:v=L.posix.normalize(g.path),g.with({path:v})}relativePath(g,v){if(g.scheme!==v.scheme||!(0,e.isEqualAuthority)(g.authority,v.authority))return;if(g.scheme===E.Schemas.file){const a=L.relative(w(g),w(v));return n.isWindows?m.toSlashes(a):a}let D=g.path||"/",S=v.path||"/";if(this._ignorePathCasing(g)){let a=0;for(const u=Math.min(D.length,S.length);a<u&&!(D.charCodeAt(a)!==S.charCodeAt(a)&&D.charAt(a).toLowerCase()!==S.charAt(a).toLowerCase());a++);D=S.substr(0,a)+D.substr(a)}return L.posix.relative(D,S)}resolvePath(g,v){if(g.scheme===E.Schemas.file){const D=A.URI.file(L.resolve(w(g),v));return g.with({authority:D.authority,path:D.path})}return v=m.toPosixPath(v),g.with({path:L.posix.resolve(g.path,v)})}isAbsolutePath(g){return!!g.path&&g.path[0]==="/"}isEqualAuthority(g,v){return g===v||(0,b.equalsIgnoreCase)(g,v)}hasTrailingPathSeparator(g,v=L.sep){if(g.scheme===E.Schemas.file){const D=w(g);return D.length>m.getRoot(D).length&&D[D.length-1]===v}else{const D=g.path;return D.length>1&&D.charCodeAt(D.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(g.fsPath)}}removeTrailingPathSeparator(g,v=L.sep){return(0,e.hasTrailingPathSeparator)(g,v)?g.with({path:g.path.substr(0,g.path.length-1)}):g}addTrailingPathSeparator(g,v=L.sep){let D=!1;if(g.scheme===E.Schemas.file){const S=w(g);D=S!==void 0&&S.length===m.getRoot(S).length&&S[S.length-1]===v}else{v="/";const S=g.path;D=S.length===1&&S.charCodeAt(S.length-1)===47}return!D&&!(0,e.hasTrailingPathSeparator)(g,v)?g.with({path:g.path+"/"}):g}}e.ExtUri=y,e.extUri=new y(()=>!1),e.extUriBiasedIgnorePathCase=new y(p=>p.scheme===E.Schemas.file?!n.isLinux:!0),e.extUriIgnorePathCase=new y(p=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function i(p,g){const v=[];for(let D=0;D<p.length;D++){const S=g(p[D]);p.some((a,u)=>u===D?!1:(0,e.isEqualOrParent)(S,g(a)))||v.push(p[D])}return v}e.distinctParents=i;var I;(function(p){p.META_DATA_LABEL="label",p.META_DATA_DESCRIPTION="description",p.META_DATA_SIZE="size",p.META_DATA_MIME="mime";function g(v){const D=new Map;v.path.substring(v.path.indexOf(";")+1,v.path.lastIndexOf(";")).split(";").forEach(u=>{const[c,l]=u.split(":");c&&l&&D.set(c,l)});const a=v.path.substring(0,v.path.indexOf(";"));return a&&D.set(p.META_DATA_MIME,a),D}p.parseMetaData=g})(I=e.DataUri||(e.DataUri={}));function M(p,g,v){if(g){let D=p.path;return D&&D[0]!==L.posix.sep&&(D=L.posix.sep+D),p.with({scheme:v,authority:g,path:D})}return p.with({scheme:v})}e.toLocalResource=M}),define(J[9],Z([0,1,25,19,5,2,78,15]),function($,e,m,L,A,b,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.AsyncEmitter=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.ignoreErrors=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function w(z){return!!z&&typeof z.then=="function"}e.isThenable=w;function y(z){const F=new m.CancellationTokenSource,R=z(F.token),W=new Promise((k,O)=>{F.token.onCancellationRequested(()=>{O((0,L.canceled)())}),Promise.resolve(R).then(_=>{F.dispose(),k(_)},_=>{F.dispose(),O(_)})});return new class{cancel(){F.cancel()}then(k,O){return W.then(k,O)}catch(k){return this.then(void 0,k)}finally(k){return W.finally(k)}}}e.createCancelablePromise=y;function i(z,F,R){return Promise.race([z,new Promise(W=>F.onCancellationRequested(()=>W(R)))])}e.raceCancellation=i;async function I(z){let F=-1;const R=z.map((k,O)=>k.then(_=>(F=O,_))),W=await Promise.race(R);return z.forEach((k,O)=>{O!==F&&k.cancel()}),W}e.raceCancellablePromises=I;function M(z,F,R){let W;const k=setTimeout(()=>{W==null||W(void 0),R==null||R()},F);return Promise.race([z.finally(()=>clearTimeout(k)),new Promise(O=>W=O)])}e.raceTimeout=M;function p(z){return new Promise((F,R)=>{const W=z();w(W)?W.then(F,R):F(W)})}e.asPromise=p;class g{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(F){if(this.activePromise){if(this.queuedPromiseFactory=F,!this.queuedPromise){const R=()=>{this.queuedPromise=null;const W=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,W};this.queuedPromise=new Promise(W=>{this.activePromise.then(R,R).then(W)})}return new Promise((R,W)=>{this.queuedPromise.then(R,W)})}return this.activePromise=F(),new Promise((R,W)=>{this.activePromise.then(k=>{this.activePromise=null,R(k)},k=>{this.activePromise=null,W(k)})})}}e.Throttler=g;class v{constructor(){this.current=Promise.resolve(null)}queue(F){return this.current=this.current.then(()=>F(),()=>F())}}e.Sequencer=v;class D{constructor(){this.promiseMap=new Map}queue(F,R){var W;const O=((W=this.promiseMap.get(F))!==null&&W!==void 0?W:Promise.resolve()).catch(()=>{}).then(R).finally(()=>{this.promiseMap.get(F)===O&&this.promiseMap.delete(F)});return this.promiseMap.set(F,O),O}}e.SequencerByKey=D;class S{constructor(F){this.defaultDelay=F,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(F,R=this.defaultDelay){return this.task=F,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((W,k)=>{this.doResolve=W,this.doReject=k}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const W=this.task;return this.task=null,W()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},R),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,L.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancelTimeout()}}e.Delayer=S;class a{constructor(F){this.delayer=new S(F),this.throttler=new g}trigger(F,R){return this.delayer.trigger(()=>this.throttler.queue(F),R)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=a;class u{constructor(){this._isOpen=!1,this._promise=new Promise((F,R)=>{this._completePromise=F})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=u;class c extends u{constructor(F){super();this._timeout=setTimeout(()=>this.open(),F)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=c;function l(z,F){return F?new Promise((R,W)=>{const k=setTimeout(R,z);F.onCancellationRequested(()=>{clearTimeout(k),W((0,L.canceled)())})}):y(R=>l(z,R))}e.timeout=l;function t(z,F=0){const R=setTimeout(z,F);return(0,b.toDisposable)(()=>clearTimeout(R))}e.disposableTimeout=t;function r(z){return z.then(void 0,F=>{})}e.ignoreErrors=r;function s(z){const F=[];let R=0;const W=z.length;function k(){return R<W?z[R++]():null}function O(_){_!=null&&F.push(_);const K=k();return K?K.then(O):Promise.resolve(F)}return Promise.resolve(null).then(O)}e.sequence=s;function o(z,F=W=>!!W,R=null){let W=0;const k=z.length,O=()=>{if(W>=k)return Promise.resolve(R);const _=z[W++];return Promise.resolve(_()).then(G=>F(G)?Promise.resolve(G):O())};return O()}e.first=o;function d(z,F=W=>!!W,R=null){if(z.length===0)return Promise.resolve(R);let W=z.length;const k=()=>{var O,_;W=-1;for(const K of z)(_=(O=K).cancel)===null||_===void 0||_.call(O)};return new Promise((O,_)=>{for(const K of z)K.then(G=>{--W>=0&&F(G)?(k(),O(G)):W===0&&O(R)}).catch(G=>{--W>=0&&(k(),_(G))})})}e.firstParallel=d;class f{constructor(F){this._size=0,this.maxDegreeOfParalellism=F,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new A.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(F){return this._size++,new Promise((R,W)=>{this.outstandingPromises.push({factory:F,c:R,e:W}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const F=this.outstandingPromises.shift();this.runningPromises++;const R=F.factory();R.then(F.c,F.e),R.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=f;class h extends f{constructor(){super(1)}}e.Queue=h;class P{constructor(){this.queues=new Map}queueFor(F,R=n.extUri){const W=R.getComparisonKey(F);let k=this.queues.get(W);return k||(k=new h,A.Event.once(k.onFinished)(()=>{k==null||k.dispose(),this.queues.delete(W)}),this.queues.set(W,k)),k}dispose(){this.queues.forEach(F=>F.dispose()),this.queues.clear()}}e.ResourceQueue=P;class T{constructor(F,R){this._token=-1,typeof F=="function"&&typeof R=="number"&&this.setIfNotSet(F,R)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(F,R){this.cancel(),this._token=setTimeout(()=>{this._token=-1,F()},R)}setIfNotSet(F,R){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,F()},R))}}e.TimeoutTimer=T;class U{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(F,R){this.cancel(),this._token=setInterval(()=>{F()},R)}}e.IntervalTimer=U;class q{constructor(F,R){this.timeoutToken=-1,this.runner=F,this.timeout=R,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(F=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,F)}get delay(){return this.timeout}set delay(F){this.timeout=F}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=q;class Q extends q{constructor(F,R){super(F,R);this.units=[]}work(F){this.units.push(F),this.isScheduled()||this.schedule()}doRun(){const F=this.units;this.units=[],this.runner&&this.runner(F)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=Q,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const z=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=F=>{const R=setTimeout(()=>F(z));let W=!1;return{dispose(){W||(W=!0,clearTimeout(R))}}}}else e.runWhenIdle=(z,F)=>{const R=requestIdleCallback(z,typeof F=="number"?{timeout:F}:void 0);let W=!1;return{dispose(){W||(W=!0,cancelIdleCallback(R))}}}}();class x{constructor(F){this._didRun=!1,this._executor=()=>{try{this._value=F()}catch(R){this._error=R}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}}e.IdleValue=x;async function j(z,F,R){let W;for(let k=0;k<R;k++)try{return await z()}catch(O){W=O,await l(F)}throw W}e.retry=j;class X{hasPending(F){return this._pending?typeof F=="number"?this._pending.taskId===F:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){var F;(F=this._pending)===null||F===void 0||F.cancel()}setPending(F,R,W){return this._pending={taskId:F,cancel:()=>W==null?void 0:W(),promise:R},R.then(()=>this.donePending(F),()=>this.donePending(F)),R}donePending(F){this._pending&&F===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const F=this._next;this._next=void 0,F.run().then(F.promiseResolve,F.promiseReject)}}setNext(F){if(this._next)this._next.run=F;else{let R,W;const k=new Promise((O,_)=>{R=O,W=_});this._next={run:F,promise:k,promiseResolve:R,promiseReject:W}}return this._next.promise}}e.TaskSequentializer=X;class B{constructor(F){this.interval=F,this.lastIncrementTime=0,this.value=0}increment(){const F=Date.now();return F-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=F,this.value=0),this.value++,this.value}}e.IntervalCounter=B;class V{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((F,R)=>{this.completeCallback=F,this.errorCallback=R})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(F){return new Promise(R=>{this.completeCallback(F),this.resolved=!0,R()})}error(F){return new Promise(R=>{this.errorCallback(F),this.rejected=!0,R()})}cancel(){new Promise(F=>{this.errorCallback((0,L.canceled)()),this.rejected=!0,F()})}}e.DeferredPromise=V;class N extends A.Emitter{async fireAsync(F,R,W){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new E.LinkedList);for(const k of this._listeners)this._asyncDeliveryQueue.push([k,F]);for(;this._asyncDeliveryQueue.size>0&&!R.isCancellationRequested;){const[k,O]=this._asyncDeliveryQueue.shift(),_=[],K=Object.assign(Object.assign({},O),{waitUntil:G=>{if(Object.isFrozen(_))throw new Error("waitUntil can NOT be called asynchronous");W&&(G=W(G,typeof k=="function"?k:k[0])),_.push(G)}});try{typeof k=="function"?k.call(void 0,K):k[0].call(k[1],K)}catch(G){(0,L.onUnexpectedError)(G);continue}Object.freeze(_),await C.settled(_).catch(G=>(0,L.onUnexpectedError)(G))}}}}e.AsyncEmitter=N;var C;(function(z){async function F(O){return typeof Promise.allSettled=="function"?R(O):W(O)}z.allSettled=F;async function R(O){return Promise.allSettled(O)}async function W(O){return Promise.all(O.map(_=>_.then(K=>({status:"fulfilled",value:K}),K=>({status:"rejected",reason:K}))))}async function k(O){let _;const K=await Promise.all(O.map(G=>G.then(Y=>Y,Y=>{_||(_=Y)})));if(typeof _!="undefined")throw _;return K}z.settled=k})(C=e.Promises||(e.Promises={}))}),define(J[111],Z([0,1,23,30,8,36,9]),function($,e,m,L,A,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function n(){return Object.create(null)}e.getEmptyExpression=n;const w="**",y="/",i="[/\\\\]",I="[^/\\\\]",M=/\//g;function p(R){switch(R){case 0:return"";case 1:return`${I}*?`;default:return`(?:${i}|${I}+${i}|${i}${I}+)*?`}}function g(R,W){if(!R)return[];const k=[];let O=!1,_=!1,K="";for(const G of R){switch(G){case W:if(!O&&!_){k.push(K),K="";continue}break;case"{":O=!0;break;case"}":O=!1;break;case"[":_=!0;break;case"]":_=!1;break}K+=G}return K&&k.push(K),k}e.splitGlobAware=g;function v(R){if(!R)return"";let W="";const k=g(R,y);if(k.every(O=>O===w))W=".*";else{let O=!1;k.forEach((_,K)=>{if(_===w){O||(W+=p(2),O=!0);return}let G=!1,Y="",ee=!1,ne="";for(const re of _){if(re!=="}"&&G){Y+=re;continue}if(ee&&(re!=="]"||!ne)){let se;re==="-"?se=re:(re==="^"||re==="!")&&!ne?se="^":re===y?se="":se=m.escapeRegExpCharacters(re),ne+=se;continue}switch(re){case"{":G=!0;continue;case"[":ee=!0;continue;case"}":W+=`(?:${g(Y,",").map(oe=>v(oe)).join("|")})`,G=!1,Y="";break;case"]":W+="["+ne+"]",ee=!1,ne="";break;case"?":W+=I;continue;case"*":W+=p(1);continue;default:W+=m.escapeRegExpCharacters(re)}}K<k.length-1&&(k[K+1]!==w||K+2<k.length)&&(W+=i),O=!1})}return W}const D=/^\*\*\/\*\.[\w\.-]+$/,S=/^\*\*\/([\w\.-]+)\/?$/,a=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,u=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,c=/^\*\*((\/[\w\.-]+)+)\/?$/,l=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new b.LRUCache(1e4),r=function(){return!1},s=function(){return null};function o(R,W){if(!R)return s;let k;typeof R!="string"?k=R.pattern:k=R,k=k.trim();const O=`${k}_${!!W.trimForExclusions}`;let _=t.get(O);if(_)return d(_,R);let K;if(D.test(k)){const G=k.substr(4);_=function(Y,ee){return typeof Y=="string"&&Y.endsWith(G)?k:null}}else(K=S.exec(f(k,W)))?_=h(K[1],k):(W.trimForExclusions?u:a).test(k)?_=P(k,W):(K=c.exec(f(k,W)))?_=T(K[1].substr(1),k,!0):(K=l.exec(f(k,W)))?_=T(K[1],k,!1):_=U(k);return t.set(O,_),d(_,R)}function d(R,W){return typeof W=="string"?R:function(k,O){return L.isEqualOrParent(k,W.base)?R(A.relative(W.base,k),O):null}}function f(R,W){return W.trimForExclusions&&R.endsWith("/**")?R.substr(0,R.length-2):R}function h(R,W){const k=`/${R}`,O=`\\${R}`,_=function(G,Y){return typeof G!="string"?null:Y?Y===R?W:null:G===R||G.endsWith(k)||G.endsWith(O)?W:null},K=[R];return _.basenames=K,_.patterns=[W],_.allBasenames=K,_}function P(R,W){const k=F(R.slice(1,-1).split(",").map(Y=>o(Y,W)).filter(Y=>Y!==s),R),O=k.length;if(!O)return s;if(O===1)return k[0];const _=function(Y,ee){for(let ne=0,re=k.length;ne<re;ne++)if(k[ne](Y,ee))return R;return null},K=k.find(Y=>!!Y.allBasenames);K&&(_.allBasenames=K.allBasenames);const G=k.reduce((Y,ee)=>ee.allPaths?Y.concat(ee.allPaths):Y,[]);return G.length&&(_.allPaths=G),_}function T(R,W,k){const O=A.sep===A.posix.sep,_=O?R:R.replace(M,A.sep),K=A.sep+_,G=A.posix.sep+R,Y=k?function(ee,ne){return typeof ee=="string"&&(ee===_||ee.endsWith(K)||!O&&(ee===R||ee.endsWith(G)))?W:null}:function(ee,ne){return typeof ee=="string"&&(ee===_||!O&&ee===R)?W:null};return Y.allPaths=[(k?"*/":"./")+R],Y}function U(R){try{const W=new RegExp(`^${v(R)}$`);return function(k){return W.lastIndex=0,typeof k=="string"&&W.test(k)?R:null}}catch(W){return s}}function q(R,W,k){return!R||typeof W!="string"?!1:Q(R)(W,void 0,k)}e.match=q;function Q(R,W={}){if(!R)return r;if(typeof R=="string"||B(R)){const k=o(R,W);if(k===s)return r;const O=function(_,K){return!!k(_,K)};return k.allBasenames&&(O.allBasenames=k.allBasenames),k.allPaths&&(O.allPaths=k.allPaths),O}return C(R,W)}e.parse=Q;function x(R){if(!R)return;let W;return k=>(W||(W=(R()||Promise.resolve([])).then(O=>O?X(O):{})),W.then(O=>!!O[k]))}e.hasSiblingPromiseFn=x;function j(R){if(!R)return;let W;return k=>{if(!W){const O=R();W=O?X(O):{}}return!!W[k]}}e.hasSiblingFn=j;function X(R){const W={};for(const k of R)W[k]=!0;return W}function B(R){const W=R;return W&&typeof W.base=="string"&&typeof W.pattern=="string"}e.isRelativePattern=B;function V(R){return R.allBasenames||[]}e.getBasenameTerms=V;function N(R){return R.allPaths||[]}e.getPathTerms=N;function C(R,W){const k=F(Object.getOwnPropertyNames(R).map(Y=>z(Y,R[Y],W)).filter(Y=>Y!==s)),O=k.length;if(!O)return s;if(!k.some(Y=>!!Y.requiresSiblings)){if(O===1)return k[0];const Y=function(re,se){for(let le=0,oe=k.length;le<oe;le++){const ue=k[le](re,se);if(ue)return ue}return null},ee=k.find(re=>!!re.allBasenames);ee&&(Y.allBasenames=ee.allBasenames);const ne=k.reduce((re,se)=>se.allPaths?re.concat(se.allPaths):re,[]);return ne.length&&(Y.allPaths=ne),Y}const _=function(Y,ee,ne){let re;for(let se=0,le=k.length;se<le;se++){const oe=k[se];oe.requiresSiblings&&ne&&(ee||(ee=A.basename(Y)),re||(re=ee.substr(0,ee.length-A.extname(Y).length)));const ue=oe(Y,ee,re,ne);if(ue)return ue}return null},K=k.find(Y=>!!Y.allBasenames);K&&(_.allBasenames=K.allBasenames);const G=k.reduce((Y,ee)=>ee.allPaths?Y.concat(ee.allPaths):Y,[]);return G.length&&(_.allPaths=G),_}function z(R,W,k){if(W===!1)return s;const O=o(R,k);if(O===s)return s;if(typeof W=="boolean")return O;if(W){const _=W.when;if(typeof _=="string"){const K=(G,Y,ee,ne)=>{if(!ne||!O(G,Y))return null;const re=_.replace("$(basename)",ee),se=ne(re);return(0,E.isThenable)(se)?se.then(le=>le?R:null):se?R:null};return K.requiresSiblings=!0,K}}return O}function F(R,W){const k=R.filter(Y=>!!Y.basenames);if(k.length<2)return R;const O=k.reduce((Y,ee)=>{const ne=ee.basenames;return ne?Y.concat(ne):Y},[]);let _;if(W){_=[];for(let Y=0,ee=O.length;Y<ee;Y++)_.push(W)}else _=k.reduce((Y,ee)=>{const ne=ee.patterns;return ne?Y.concat(ne):Y},[]);const K=function(Y,ee){if(typeof Y!="string")return null;if(!ee){let re;for(re=Y.length;re>0;re--){const se=Y.charCodeAt(re-1);if(se===47||se===92)break}ee=Y.substr(re)}const ne=O.indexOf(ee);return ne!==-1?_[ne]:null};K.basenames=O,K.patterns=_,K.allBasenames=O;const G=R.filter(Y=>!Y.basenames);return G.push(K),G}}),define(J[39],Z([0,1,7,8,23,10,3,15,30]),function($,e,m,L,A,b,E,n,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function y(o,d,f){if(typeof o=="string"&&(o=m.URI.file(o)),f){const P=f.getWorkspaceFolder(o);if(P){const T=f.getWorkspace().folders.length>1;let U;if((0,n.isEqual)(P.uri,o)?U="":U=(0,n.relativePath)(P.uri,o),T){const q=P.name?P.name:(0,n.basename)(P.uri);U=U?q+" \u2022 "+U:q}return U}}if(o.scheme!==b.Schemas.file&&o.scheme!==b.Schemas.untitled)return o.with({query:null,fragment:null}).toString(!0);if((0,w.hasDriveLetter)(o.fsPath))return(0,L.normalize)(I(o.fsPath));let h=(0,L.normalize)(o.fsPath);return!E.isWindows&&(d==null?void 0:d.userHome)&&(h=p(h,d.userHome.fsPath)),h}e.getPathLabel=y;function i(o){if(!o)return;typeof o=="string"&&(o=m.URI.file(o));const d=(0,n.basename)(o)||(o.scheme===b.Schemas.file?o.fsPath:o.path);return E.isWindows&&(0,w.isRootOrDriveLetter)(d)?I(d):d}e.getBaseLabel=i;function I(o){return(0,w.hasDriveLetter)(o)?o.charAt(0).toUpperCase()+o.slice(1):o}e.normalizeDriveLetter=I;let M=Object.create(null);function p(o,d){if(E.isWindows||!o||!d)return o;let f=M.original===d?M.normalized:void 0;return f||(f=`${(0,A.rtrim)(d,L.posix.sep)}${L.posix.sep}`,M={original:d,normalized:f}),(E.isLinux?o.startsWith(f):(0,A.startsWithIgnoreCase)(o,f))&&(o=`~/${o.substr(f.length)}`),o}e.tildify=p;function g(o,d){return o.replace(/^~($|\/|\\)/,`${d}$1`)}e.untildify=g;const v="\u2026",D="\\\\",S="~";function a(o,d=L.sep){const f=new Array(o.length);let h=!1;for(let P=0;P<o.length;P++){let T=o[P];if(T===""){f[P]=`.${d}`;continue}if(!T){f[P]=T;continue}h=!0;let U="";T.indexOf(D)===0?(U=T.substr(0,T.indexOf(D)+D.length),T=T.substr(T.indexOf(D)+D.length)):T.indexOf(d)===0?(U=T.substr(0,T.indexOf(d)+d.length),T=T.substr(T.indexOf(d)+d.length)):T.indexOf(S)===0&&(U=T.substr(0,T.indexOf(S)+S.length),T=T.substr(T.indexOf(S)+S.length));const q=T.split(d);for(let Q=1;h&&Q<=q.length;Q++)for(let x=q.length-Q;h&&x>=0;x--){h=!1;let j=q.slice(x,x+Q).join(d);for(let X=0;!h&&X<o.length;X++)if(X!==P&&o[X]&&o[X].indexOf(j)>-1){const B=x+Q===q.length,V=x>0&&o[X].indexOf(d)>-1?d+j:j,N=o[X].endsWith(V);h=!B||N}if(!h){let X="";(q[0].endsWith(":")||U!=="")&&(x===1&&(x=0,Q++,j=q[0]+d+j),x>0&&(X=q[0]+d),X=U+X),x>0&&(X=X+v+d),X=X+j,x+Q<q.length&&(X=X+d+v),f[P]=X}}h&&(f[P]=T)}return f}e.shorten=a;var u;(function(o){o[o.TEXT=0]="TEXT",o[o.VARIABLE=1]="VARIABLE",o[o.SEPARATOR=2]="SEPARATOR"})(u||(u={}));function c(o,d=Object.create(null)){const f=[];let h=!1,P="";for(const T of o)if(T==="$"||h&&T==="{")P&&f.push({value:P,type:u.TEXT}),P="",h=!0;else if(T==="}"&&h){const U=d[P];if(typeof U=="string")U.length&&f.push({value:U,type:u.VARIABLE});else if(U){const q=f[f.length-1];(!q||q.type!==u.SEPARATOR)&&f.push({value:U.label,type:u.SEPARATOR})}P="",h=!1}else P+=T;return P&&!h&&f.push({value:P,type:u.TEXT}),f.filter((T,U)=>{if(T.type===u.SEPARATOR){const q=f[U-1],Q=f[U+1];return[q,Q].every(x=>x&&(x.type===u.VARIABLE||x.type===u.TEXT)&&x.value.length>0)}return!0}).map(T=>T.value).join("")}e.template=c;function l(o,d){return E.isMacintosh||d?o.replace(/\(&&\w\)|&&/g,"").replace(/&/g,E.isMacintosh?"&":"&&"):o.replace(/&&|&/g,f=>f==="&"?"&&":"&")}e.mnemonicMenuLabel=l;function t(o,d){return E.isMacintosh||d?o.replace(/\(&&\w\)|&&/g,""):E.isWindows?o.replace(/&&|&/g,f=>f==="&"?"&&":"&"):o.replace(/&&/g,"_")}e.mnemonicButtonLabel=t;function r(o){return o.replace(/&/g,"&&")}e.unmnemonicLabel=r;function s(o){const d=o.indexOf("/")!==-1?L.posix:L.win32,f=d.basename(o),h=d.dirname(o);return f.length?{name:f,parentPath:h}:{name:h,parentPath:""}}e.splitName=s}),define(J[27],Z([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const m=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function L(w){return m.test(w)}e.isUUID=L;const A=new Uint8Array(16),b=[];for(let w=0;w<256;w++)b.push(w.toString(16).padStart(2,"0"));let E;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?E=crypto.getRandomValues.bind(crypto):E=function(w){for(let y=0;y<w.length;y++)w[y]=Math.floor(Math.random()*256);return w};function n(){E(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let w=0,y="";return y+=b[A[w++]],y+=b[A[w++]],y+=b[A[w++]],y+=b[A[w++]],y+="-",y+=b[A[w++]],y+=b[A[w++]],y+="-",y+=b[A[w++]],y+=b[A[w++]],y+="-",y+=b[A[w++]],y+=b[A[w++]],y+="-",y+=b[A[w++]],y+=b[A[w++]],y+=b[A[w++]],y+=b[A[w++]],y+=b[A[w++]],y+=b[A[w++]],y}e.generateUuid=n}),define(J[112],Z([0,1,29,58,42]),function($,e,m,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checksum=void 0;async function b(E,n){if(await new Promise((i,I)=>{const M=m.createReadStream(E),p=L.createHash("sha1");M.pipe(p);const g=(0,A.once)((v,D)=>{M.removeAllListeners(),p.removeAllListeners(),v?I(v):i(D)});M.once("error",g),M.once("end",g),p.once("error",g),p.once("data",v=>g(void 0,v.toString("hex")))})!==n)throw new Error("Hash mismatch")}e.checksum=b}),define(J[81],Z([0,1,237]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class L{constructor(b="utf8"){this.stringDecoder=new m.StringDecoder(b),this.remaining=null}write(b){const E=[],n=this.remaining?this.remaining+this.stringDecoder.write(b):this.stringDecoder.write(b);if(n.length<1)return E;let w=0,y,i=w;for(;i<n.length;)if(y=n.charCodeAt(i),y===13||y===10){if(E.push(n.substring(w,i)),i++,i<n.length){const I=y;y=n.charCodeAt(i),(I===13&&y===10||I===10&&y===13)&&i++}w=i}else i++;return this.remaining=w<n.length?n.substr(w):null,E}end(){return this.remaining}}e.LineDecoder=L}),define(J[113],Z([0,1,26]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const L=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function A(n){const w=n.replace(/\-/g,":").toLowerCase();return!L.has(w)}function b(){return new Promise(async(n,w)=>{const y=setTimeout(()=>w("Unable to retrieve mac address (timeout after 10s)"),1e4);try{n(await E())}catch(i){w(i)}finally{clearTimeout(y)}})}e.getMac=b;function E(){return new Promise((n,w)=>{try{const y=(0,m.networkInterfaces)();for(let i in y){const I=y[i];if(I){for(const{mac:M}of I)if(A(M))return n(M)}}w("Unable to retrieve mac address (unexpected format)")}catch(y){w(y)}})}}),define(J[66],Z([0,1,19,27,26,36,113]),function($,e,m,L,A,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAdress(i){return this._virtualMachineOUIs||(this._virtualMachineOUIs=b.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(i)}value(){if(this._value===void 0){let i=0,I=0;const M=(0,A.networkInterfaces)();for(let p in M){const g=M[p];if(g)for(const{mac:v,internal:D}of g)D||(I+=1,this._isVirtualMachineMacAdress(v.toUpperCase())&&(i+=1))}this._value=I>0?i/I:0}return this._value}};let n;async function w(){return n||(n=(async()=>await y()||L.generateUuid())()),n}e.getMachineId=w;async function y(){try{const i=await new Promise((M,p)=>{$(["crypto"],M,p)}),I=await(0,E.getMac)();return i.createHash("sha256").update(I,"utf8").digest("hex")}catch(i){m.onUnexpectedError(i);return}}}),define(J[16],Z([0,1,29,26,114,8,9,3,30,27,65,15,7]),function($,e,m,L,A,b,E,n,w,y,i,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.exists=e.copy=e.move=e.writeFileSync=e.writeFile=e.SymlinkSupport=e.whenDeleted=e.readDirsInDir=e.readdirSync=e.readdir=e.rimrafSync=e.rimraf=e.RimRafMode=void 0;var p;(function(C){C[C.UNLINK=0]="UNLINK",C[C.MOVE=1]="MOVE"})(p=e.RimRafMode||(e.RimRafMode={}));async function g(C,z=p.UNLINK){if((0,w.isRootOrDriveLetter)(C))throw new Error("rimraf - will refuse to recursively delete root");return z===p.UNLINK?D(C):v(C)}e.rimraf=g;async function v(C){try{const z=(0,b.join)((0,L.tmpdir)(),(0,y.generateUuid)());try{await N.rename(C,z)}catch(F){return D(C)}D(z).catch(F=>{})}catch(z){if(z.code!=="ENOENT")throw z}}async function D(C){return N.rmdir(C,{recursive:!0,maxRetries:3})}function S(C){if((0,w.isRootOrDriveLetter)(C))throw new Error("rimraf - will refuse to recursively delete root");m.rmdirSync(C,{recursive:!0})}e.rimrafSync=S;async function a(C,z){return l(await(z?u(C):N.readdir(C)))}e.readdir=a;async function u(C){try{return await N.readdir(C,{withFileTypes:!0})}catch(R){console.warn("[node.js fs] readdir with filetypes failed with error: ",R)}const z=[],F=await a(C);for(const R of F){let W=!1,k=!1,O=!1;try{const _=await N.lstat((0,b.join)(C,R));W=_.isFile(),k=_.isDirectory(),O=_.isSymbolicLink()}catch(_){console.warn("[node.js fs] unexpected error from lstat after readdir: ",_)}z.push({name:R,isFile:()=>W,isDirectory:()=>k,isSymbolicLink:()=>O})}return z}function c(C){return l(m.readdirSync(C))}e.readdirSync=c;function l(C){return C.map(z=>typeof z=="string"?n.isMacintosh?(0,i.normalizeNFC)(z):z:(z.name=n.isMacintosh?(0,i.normalizeNFC)(z.name):z.name,z))}async function t(C){const z=await a(C),F=[];for(const R of z)await s.existsDirectory((0,b.join)(C,R))&&F.push(R);return F}e.readDirsInDir=t;function r(C,z=1e3){return new Promise(F=>{let R=!1;const W=setInterval(()=>{R||(R=!0,m.access(C,k=>{R=!1,k&&(clearInterval(W),F(void 0))}))},z)})}e.whenDeleted=r;var s;(function(C){async function z(W){let k;try{if(k=await N.lstat(W),!k.isSymbolicLink())return{stat:k}}catch(O){}try{return{stat:await N.stat(W),symbolicLink:(k==null?void 0:k.isSymbolicLink())?{dangling:!1}:void 0}}catch(O){if(O.code==="ENOENT"&&k)return{stat:k,symbolicLink:{dangling:!0}};if(n.isWindows&&O.code==="EACCES")try{return{stat:await N.stat(await N.readlink(W)),symbolicLink:{dangling:!1}}}catch(_){if(_.code==="ENOENT"&&k)return{stat:k,symbolicLink:{dangling:!0}};throw _}throw O}}C.stat=z;async function F(W){try{const{stat:k,symbolicLink:O}=await C.stat(W);return k.isFile()&&(O==null?void 0:O.dangling)!==!0}catch(k){}return!1}C.existsFile=F;async function R(W){try{const{stat:k,symbolicLink:O}=await C.stat(W);return k.isDirectory()&&(O==null?void 0:O.dangling)!==!0}catch(k){}return!1}C.existsDirectory=R})(s=e.SymlinkSupport||(e.SymlinkSupport={}));const o=new E.ResourceQueue;function d(C,z,F){return o.queueFor(M.URI.file(C),I.extUriBiasedIgnorePathCase).queue(()=>{const R=T(F);return new Promise((W,k)=>h(C,z,R,O=>O?k(O):W()))})}e.writeFile=d;let f=!0;function h(C,z,F,R){if(!f)return m.writeFile(C,z,{mode:F.mode,flag:F.flag},R);m.open(C,F.flag,F.mode,(W,k)=>{if(W)return R(W);m.writeFile(k,z,O=>{if(O)return m.close(k,()=>R(O));m.fdatasync(k,_=>(_&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",_),f=!1),m.close(k,K=>R(K))))})})}function P(C,z,F){const R=T(F);if(!f)return m.writeFileSync(C,z,{mode:R.mode,flag:R.flag});const W=m.openSync(C,R.flag,R.mode);try{m.writeFileSync(W,z);try{m.fdatasyncSync(W)}catch(k){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",k),f=!1}}finally{m.closeSync(W)}}e.writeFileSync=P;function T(C){return C?{mode:typeof C.mode=="number"?C.mode:438,flag:typeof C.flag=="string"?C.flag:"w"}:{mode:438,flag:"w"}}async function U(C,z){if(C===z)return;async function F(R){try{const W=await N.lstat(R);if(W.isDirectory()||W.isSymbolicLink())return;await N.utimes(R,W.atime,new Date)}catch(W){}}try{await N.rename(C,z),await F(z)}catch(R){if(C.toLowerCase()!==z.toLowerCase()&&R.code==="EXDEV"||C.endsWith("."))await q(C,z,{preserveSymlinks:!1}),await g(C,p.MOVE),await F(z);else throw R}}e.move=U;async function q(C,z,F){return x(C,z,{root:{source:C,target:z},options:F,handledSourcePaths:new Set})}e.copy=q;const Q=511;async function x(C,z,F){if(F.handledSourcePaths.has(C))return;F.handledSourcePaths.add(C);const{stat:R,symbolicLink:W}=await s.stat(C);if(W){if(F.options.preserveSymlinks)try{return await B(C,z,F)}catch(k){console.warn("[node.js fs] copy of symlink failed: ",k)}if(W.dangling)return}return R.isDirectory()?j(C,z,R.mode&Q,F):X(C,z,R.mode&Q)}async function j(C,z,F,R){await N.mkdir(z,{recursive:!0,mode:F});const W=await a(C);for(const k of W)await x((0,b.join)(C,k),(0,b.join)(z,k),R)}async function X(C,z,F){await N.copyFile(C,z),await N.chmod(z,F)}async function B(C,z,F){let R=await N.readlink(C);(0,w.isEqualOrParent)(R,F.root.source,!n.isLinux)&&(R=(0,b.join)(F.root.target,R.substr(F.root.source.length+1))),await N.symlink(R,z)}async function V(C){try{return await N.access(C),!0}catch(z){return!1}}e.exists=V;var N;(function(C){C.access=(0,A.promisify)(m.access),C.stat=(0,A.promisify)(m.stat),C.lstat=(0,A.promisify)(m.lstat),C.utimes=(0,A.promisify)(m.utimes),C.read=(0,A.promisify)(m.read),C.readFile=(0,A.promisify)(m.readFile),C.write=(0,A.promisify)(m.write),C.writeFile=(0,A.promisify)(m.writeFile),C.appendFile=(0,A.promisify)(m.appendFile),C.fdatasync=(0,A.promisify)(m.fdatasync),C.truncate=(0,A.promisify)(m.truncate),C.rename=(0,A.promisify)(m.rename),C.copyFile=(0,A.promisify)(m.copyFile),C.open=(0,A.promisify)(m.open),C.close=(0,A.promisify)(m.close),C.symlink=(0,A.promisify)(m.symlink),C.readlink=(0,A.promisify)(m.readlink),C.chmod=(0,A.promisify)(m.chmod),C.readdir=(0,A.promisify)(m.readdir),C.mkdir=(0,A.promisify)(m.mkdir),C.unlink=(0,A.promisify)(m.unlink),C.rmdir=(0,A.promisify)(m.rmdir),C.realpath=(0,A.promisify)(m.realpath)})(N=e.Promises||(e.Promises={}))}),define(J[82],Z([0,1,29,23,8,16]),function($,e,m,L,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function E(i){const I=(0,A.dirname)(i);if(i===I)return i;const M=((0,A.basename)(i)||i).toLowerCase();try{const g=(0,b.readdirSync)(I).filter(v=>v.toLowerCase()===M);if(g.length===1){const v=E(I);if(v)return(0,A.join)(v,g[0])}else if(g.length>1){const v=g.indexOf(M);if(v>=0){const D=E(I);if(D)return(0,A.join)(D,g[v])}}}catch(p){}return null}e.realcaseSync=E;async function n(i){try{return await b.Promises.realpath(i)}catch(I){const M=y(i);return await b.Promises.access(M,m.constants.R_OK),M}}e.realpath=n;function w(i){try{return m.realpathSync(i)}catch(I){const M=y(i);return m.accessSync(M,m.constants.R_OK),M}}e.realpathSync=w;function y(i){return(0,L.rtrim)((0,A.normalize)(i),A.sep)}}),define(J[115],Z([0,1,59]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.findFreePort=void 0;function L(n,w,y){let i=!1;return new Promise(I=>{const M=setTimeout(()=>{if(!i)return i=!0,I(0)},y);A(n,w,p=>{if(!i)return i=!0,clearTimeout(M),I(p)})})}e.findFreePort=L;function A(n,w,y){if(w===0)return y(0);const i=new m.Socket;i.once("connect",()=>(E(i),A(n+1,w-1,y))),i.once("data",()=>{}),i.once("error",I=>(E(i),I.code!=="ECONNREFUSED"?A(n+1,w-1,y):y(n))),i.connect(n,"127.0.0.1")}function b(n,w,y){let i=!1,I,M=1;const p=m.createServer({pauseOnConnect:!0});function g(v,D){i||(i=!0,p.removeAllListeners(),p.close(),I&&clearTimeout(I),D(v))}return new Promise(v=>{I=setTimeout(()=>{g(0,v)},y),p.on("listening",()=>{g(n,v)}),p.on("error",D=>{D&&(D.code==="EADDRINUSE"||D.code==="EACCES")&&M<w?(n++,M++,p.listen(n,"127.0.0.1")):g(0,v)}),p.on("close",()=>{g(0,v)}),p.listen(n,"127.0.0.1")})}e.findFreePortFaster=b;function E(n){try{n.removeAllListeners("connect"),n.removeAllListeners("error"),n.end(),n.destroy(),n.unref()}catch(w){console.error(w)}}});var Oe=this&&this.__await||function($){return this instanceof Oe?(this.v=$,this):new Oe($)},yt=this&&this.__asyncGenerator||function($,e,m){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var L=m.apply($,e||[]),A,b=[];return A={},E("next"),E("throw"),E("return"),A[Symbol.asyncIterator]=function(){return this},A;function E(M){L[M]&&(A[M]=function(p){return new Promise(function(g,v){b.push([M,p,g,v])>1||n(M,p)})})}function n(M,p){try{w(L[M](p))}catch(g){I(b[0][3],g)}}function w(M){M.value instanceof Oe?Promise.resolve(M.value.v).then(y,i):I(b[0][2],M)}function y(M){n("next",M)}function i(M){n("throw",M)}function I(M,p){M(p),b.shift(),b.length&&n(b[0][0],b[0][1])}},St=this&&this.__asyncValues||function($){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var e=$[Symbol.asyncIterator],m;return e?e.call($):($=typeof __values=="function"?__values($):$[Symbol.iterator](),m={},L("next"),L("throw"),L("return"),m[Symbol.asyncIterator]=function(){return this},m);function L(b){m[b]=$[b]&&function(E){return new Promise(function(n,w){E=$[b](E),A(n,w,E.done,E.value)})}}function A(b,E,n,w){Promise.resolve(w).then(function(y){b({value:y,done:n})},E)}};define(J[116],Z([0,1,16,26,8]),function($,e,m,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const b=/^\d+$/,E=/^Microsoft.PowerShell_.*/,n=/^Microsoft.PowerShellPreview_.*/;var w;(function(c){c[c.x64=0]="x64",c[c.x86=1]="x86",c[c.ARM=2]="ARM"})(w||(w={}));let y;switch(process.arch){case"ia32":case"x32":y=1;break;case"arm":case"arm64":y=2;break;default:y=0;break}let i;process.env.PROCESSOR_ARCHITEW6432?i=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?i=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?i=1:i=0;class I{constructor(l,t,r){this.exePath=l,this.displayName=t,this.knownToExist=r}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await m.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function M({useAlternateBitness:c=!1}={}){return c?y===0?process.env["ProgramFiles(x86)"]||null:i===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function p({useAlternateBitness:c=!1,findPreview:l=!1}={}){const t=M({useAlternateBitness:c});if(!t)return null;const r=A.join(t,"PowerShell");if(!await m.SymlinkSupport.existsDirectory(r))return null;let s=-1,o=null;for(const h of await m.readdir(r)){let P=-1;if(l){const U=h.indexOf("-");if(U<0)continue;const q=h.substring(0,U);if(!b.test(q)||h.substring(U+1)!=="preview")continue;P=parseInt(q,10)}else{if(!b.test(h))continue;P=parseInt(h,10)}if(P<=s)continue;const T=A.join(r,h,"pwsh.exe");!await m.SymlinkSupport.existsFile(T)||(o=T,s=P)}if(!o)return null;const d=t.includes("x86")?" (x86)":"",f=l?" Preview":"";return new I(o,`PowerShell${f}${d}`,!0)}async function g({findPreview:c}={}){if(!process.env.LOCALAPPDATA)return null;const l=A.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await m.SymlinkSupport.existsDirectory(l))return null;const{pwshMsixDirRegex:t,pwshMsixName:r}=c?{pwshMsixDirRegex:n,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:E,pwshMsixName:"PowerShell (Store)"};for(const s of await m.readdir(l))if(t.test(s)){const o=A.join(l,s,"pwsh.exe");return new I(o,r)}return null}function v(){const c=A.join(L.homedir(),".dotnet","tools","pwsh.exe");return new I(c,".NET Core PowerShell Global Tool")}function D(){const c=A.join(process.env.windir,y===1&&i!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new I(c,"Windows PowerShell",!0)}function S(){return yt(this,arguments,function*(){let l=yield Oe(p());l&&(yield yield Oe(l)),l=yield Oe(p({useAlternateBitness:!0})),l&&(yield yield Oe(l)),l=yield Oe(g()),l&&(yield yield Oe(l)),l=v(),l&&(yield yield Oe(l)),l=yield Oe(p({findPreview:!0})),l&&(yield yield Oe(l)),l=yield Oe(g({findPreview:!0})),l&&(yield yield Oe(l)),l=yield Oe(p({useAlternateBitness:!0,findPreview:!0})),l&&(yield yield Oe(l)),l=D(),l&&(yield yield Oe(l))})}function a(){return yt(this,arguments,function*(){var l,t;try{for(var r=St(S()),s;s=yield Oe(r.next()),!s.done;){const o=s.value;(yield Oe(o.exists()))&&(yield yield Oe(o))}}catch(o){l={error:o}}finally{try{s&&!s.done&&(t=r.return)&&(yield Oe(t.call(r)))}finally{if(l)throw l.error}}})}e.enumeratePowerShellInstallations=a;async function u(){var c,l;try{for(var t=St(a()),r;r=await t.next(),!r.done;)return r.value}catch(s){c={error:s}}finally{try{r&&!r.done&&(l=t.return)&&await l.call(t)}finally{if(c)throw c.error}}return null}e.getFirstAvailablePowerShellInstallation=u}),define(J[83],Z([0,1,40,10]),function($,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function A(E){return new Promise((n,w)=>{let y;const i=new Map;function I(p,g,v,D,S){const a=i.get(g);if(p===E||a){const u={name:M(v),cmd:v,pid:p,ppid:g,load:D,mem:S};i.set(p,u),p===E&&(y=u),a&&(a.children||(a.children=[]),a.children.push(u),a.children.length>1&&(a.children=a.children.sort((c,l)=>c.pid-l.pid)))}}function M(p){const g=/--disable-blink-features=Auxclick/,v=/\\watcher\\win32\\CodeHelper\.exe/,D=/--crashes-directory/,S=/\\pipe\\winpty-control/,a=/conhost\.exe/,u=/--type=([a-zA-Z-]+)/;if(v.exec(p))return"watcherService ";if(D.exec(p))return"electron-crash-reporter";if(S.exec(p))return"winpty-process";if(a.exec(p))return"console-window-host (Windows internal process)";let c=u.exec(p);if(c&&c.length===2)return c[1]==="renderer"?g.exec(p)?"shared-process":"window":c[1];const l=/[a-zA-Z-]+\.js/g;let t="";do c=l.exec(p),c&&(t+=c+" ");while(c);return t&&p.indexOf("node ")<0&&p.indexOf("node.exe")<0?`electron_node ${t}`:p}if(process.platform==="win32"){const p=g=>g.indexOf("\\\\?\\")===0||g.indexOf("\\??\\")===0?g.substr(4):g.indexOf('"\\\\?\\')===0||g.indexOf('"\\??\\')===0?'"'+g.substr(5):g;new Promise((g,v)=>{$(["windows-process-tree"],g,v)}).then(g=>{g.getProcessList(E,v=>{g.getProcessCpuUsage(v,D=>{const S=new Map;D.forEach(a=>{const u=p(a.commandLine||"");S.set(a.pid,{name:M(u),cmd:u,pid:a.pid,ppid:a.ppid,load:a.cpu||0,mem:a.memory||0})}),y=S.get(E),y?(S.forEach(a=>{const u=S.get(a.ppid);u&&(u.children||(u.children=[]),u.children.push(a))}),S.forEach(a=>{a.children&&(a.children=a.children.sort((u,c)=>u.pid-c.pid))}),n(y)):w(new Error(`Root process ${E} not found`))})},g.ProcessDataFlag.CommandLine|g.ProcessDataFlag.Memory)})}else{let p=function(){let g=[y];const v=[];for(;g.length;){const S=g.shift();S&&(v.push(S.pid),S.children&&(g=g.concat(S.children)))}let D=JSON.stringify(L.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",$).fsPath);D+=" "+v.join(" "),(0,m.exec)(D,{},(S,a,u)=>{if(S||u)w(S||new Error(u.toString()));else{const c=a.toString().split(`
`);for(let l=0;l<v.length;l++){const t=i.get(v[l]);t.load=parseFloat(c[l])}if(!y){w(new Error(`Root process ${E} not found`));return}n(y)}})};(0,m.exec)("which ps",{},(g,v,D)=>{if(g||D)if(process.platform!=="linux")w(g||new Error(D.toString()));else{const S=JSON.stringify(L.FileAccess.asFileUri("vs/base/node/ps.sh",$).fsPath);(0,m.exec)(S,{},(a,u,c)=>{a||c?w(a||new Error(c.toString())):(b(u,I),p())})}else{const S=v.toString().trim(),a="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,m.exec)(`${S} ${a}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(u,c,l)=>{u||l&&!l.includes("screen size is bogus")?w(u||new Error(l.toString())):(b(c,I),process.platform==="linux"?p():y?n(y):w(new Error(`Root process ${E} not found`)))})}})}})}e.listProcesses=A;function b(E,n){const w=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,y=E.toString().split(`
`);for(const i of y){const I=w.exec(i.trim());I&&I.length===6&&n(parseInt(I[1]),parseInt(I[2]),I[5],parseFloat(I[3]),parseFloat(I[4]))}}}),define(J[117],Z([0,1,8,29,3,65,2,16]),function($,e,m,L,A,b,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CHANGE_BUFFER_DELAY=e.watchFolder=e.watchFile=void 0;function w(I,M,p){return i({path:I,isDirectory:!1},M,p)}e.watchFile=w;function y(I,M,p){return i({path:I,isDirectory:!0},M,p)}e.watchFolder=y,e.CHANGE_BUFFER_DELAY=100;function i(I,M,p){const g=(0,m.basename)(I.path),v=new Map;let D=!1,S=[(0,E.toDisposable)(()=>{v.forEach(a=>(0,E.dispose)(a)),v.clear()})];try{const a=(0,L.watch)(I.path);S.push((0,E.toDisposable)(()=>{a.removeAllListeners(),a.close()}));const u=new Set;I.isDirectory&&(0,n.readdir)(I.path).then(c=>c.forEach(l=>u.add(l))),a.on("error",(c,l)=>{D||p(`Failed to watch ${I.path} for changes using fs.watch() (${c}, ${l})`)}),a.on("change",(c,l)=>{if(D)return;let t="";if(l&&(t=l.toString(),A.isMacintosh&&(t=(0,b.normalizeNFC)(t))),!t||c!=="change"&&c!=="rename")return;const r=I.isDirectory?(0,m.join)(I.path,t):I.path;if(I.isDirectory)if(c==="rename"){const s=v.get(r);s&&(0,E.dispose)(s);const o=setTimeout(async()=>{v.delete(r);const d=await(0,n.exists)(r);if(D)return;let f;d?u.has(t)?f="changed":(f="added",u.add(t)):(u.delete(t),f="deleted"),M(f,r)},e.CHANGE_BUFFER_DELAY);v.set(r,(0,E.toDisposable)(()=>clearTimeout(o)))}else{let s;u.has(t)?s="changed":(s="added",u.add(t)),M(s,r)}else if(c==="rename"||t!==g){const s=setTimeout(async()=>{const o=await(0,n.exists)(r);D||(o?(M("changed",r),S=[i(I,M,p)]):M("deleted",r))},e.CHANGE_BUFFER_DELAY);(0,E.dispose)(S),S=[(0,E.toDisposable)(()=>clearTimeout(s))]}else M("changed",r)})}catch(a){(0,n.exists)(I.path).then(u=>{u&&!D&&p(`Failed to watch ${I.path} for changes using fs.watch() (${a.toString()})`)})}return(0,E.toDisposable)(()=>{D=!0,S=(0,E.dispose)(S)})}}),define(J[118],Z([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_MENU_CLOSE_CHANNEL=e.CONTEXT_MENU_CHANNEL=void 0,e.CONTEXT_MENU_CHANNEL="vscode:contextmenu",e.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(J[119],Z([0,1,14,118,13]),function($,e,m,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerContextMenuListener=void 0;function b(){m.ipcMain.on(L.CONTEXT_MENU_CHANNEL,(n,w,y,i,I)=>{const M=E(n,i,y);M.popup({window:(0,A.withNullAsUndefined)(m.BrowserWindow.fromWebContents(n.sender)),x:I?I.x:void 0,y:I?I.y:void 0,positioningItem:I?I.positioningItem:void 0,callback:()=>{M&&n.sender.send(L.CONTEXT_MENU_CLOSE_CHANNEL,w)}})})}e.registerContextMenuListener=b;function E(n,w,y){const i=new m.Menu;return y.forEach(I=>{let M;I.type==="separator"?M=new m.MenuItem({type:I.type}):Array.isArray(I.submenu)?M=new m.MenuItem({submenu:E(n,w,I.submenu),label:I.label}):M=new m.MenuItem({label:I.label,type:I.type,accelerator:I.accelerator,checked:I.checked,enabled:I.enabled,visible:I.visible,click:(p,g,v)=>n.sender.send(w,I.id,v)}),i.append(M)}),i}});var he=this&&this.__decorate||function($,e,m,L){var A=arguments.length,b=A<3?e:L===null?L=Object.getOwnPropertyDescriptor(e,m):L,E;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")b=Reflect.decorate($,e,m,L);else for(var n=$.length-1;n>=0;n--)(E=$[n])&&(b=(A<3?E(b):A>3?E(e,m,b):E(e,m))||b);return A>3&&b&&Object.defineProperty(e,m,b),b};define(J[33],Z([0,1,5,2,9,25,19,20,35,13,110,23,46]),function($,e,m,L,A,b,E,n,w,y,i,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var p;(function(F){F[F.Promise=100]="Promise",F[F.PromiseCancel=101]="PromiseCancel",F[F.EventListen=102]="EventListen",F[F.EventDispose=103]="EventDispose"})(p=e.RequestType||(e.RequestType={}));function g(F){switch(F){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var v;(function(F){F[F.Initialize=200]="Initialize",F[F.PromiseSuccess=201]="PromiseSuccess",F[F.PromiseError=202]="PromiseError",F[F.PromiseErrorObj=203]="PromiseErrorObj",F[F.EventFire=204]="EventFire"})(v=e.ResponseType||(e.ResponseType={}));function D(F){switch(F){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var S;(function(F){F[F.Uninitialized=0]="Uninitialized",F[F.Idle=1]="Idle"})(S||(S={}));class a{constructor(R){this.buffer=R,this.pos=0}read(R){const W=this.buffer.slice(this.pos,this.pos+R);return this.pos+=W.byteLength,W}}class u{constructor(){this.buffers=[]}get buffer(){return n.VSBuffer.concat(this.buffers)}write(R){this.buffers.push(R)}}var c;(function(F){F[F.Undefined=0]="Undefined",F[F.String=1]="String",F[F.Buffer=2]="Buffer",F[F.VSBuffer=3]="VSBuffer",F[F.Array=4]="Array",F[F.Object=5]="Object"})(c||(c={}));function l(F){const R=n.VSBuffer.alloc(4);return R.writeUInt32BE(F,0),R}function t(F){return F.read(4).readUInt32BE(0)}function r(F){const R=n.VSBuffer.alloc(1);return R.writeUInt8(F,0),R}const s={Undefined:r(c.Undefined),String:r(c.String),Buffer:r(c.Buffer),VSBuffer:r(c.VSBuffer),Array:r(c.Array),Object:r(c.Object)},o=typeof Buffer!="undefined";function d(F,R){if(typeof R=="undefined")F.write(s.Undefined);else if(typeof R=="string"){const W=n.VSBuffer.fromString(R);F.write(s.String),F.write(l(W.byteLength)),F.write(W)}else if(o&&Buffer.isBuffer(R)){const W=n.VSBuffer.wrap(R);F.write(s.Buffer),F.write(l(W.byteLength)),F.write(W)}else if(R instanceof n.VSBuffer)F.write(s.VSBuffer),F.write(l(R.byteLength)),F.write(R);else if(Array.isArray(R)){F.write(s.Array),F.write(l(R.length));for(const W of R)d(F,W)}else{const W=n.VSBuffer.fromString(JSON.stringify(R));F.write(s.Object),F.write(l(W.byteLength)),F.write(W)}}function f(F){switch(F.read(1).readUInt8(0)){case c.Undefined:return;case c.String:return F.read(t(F)).toString();case c.Buffer:return F.read(t(F)).buffer;case c.VSBuffer:return F.read(t(F));case c.Array:{const W=t(F),k=[];for(let O=0;O<W;O++)k.push(f(F));return k}case c.Object:return JSON.parse(F.read(t(F)).toString())}}class h{constructor(R,W,k=null,O=1e3){this.protocol=R,this.ctx=W,this.logger=k,this.timeoutDelay=O,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(_=>this.onRawMessage(_)),this.sendResponse({type:200})}registerChannel(R,W){this.channels.set(R,W),setTimeout(()=>this.flushPendingRequests(R),0)}sendResponse(R){switch(R.type){case 200:{const W=this.send([R.type]);this.logger&&this.logger.logOutgoing(W,0,1,D(R.type));return}case 201:case 202:case 204:case 203:{const W=this.send([R.type,R.id],R.data);this.logger&&this.logger.logOutgoing(W,R.id,1,D(R.type),R.data);return}}}send(R,W=void 0){const k=new u;return d(k,R),d(k,W),this.sendBuffer(k.buffer)}sendBuffer(R){try{return this.protocol.send(R),R.byteLength}catch(W){return 0}}onRawMessage(R){const W=new a(R),k=f(W),O=f(W),_=k[0];switch(_){case 100:return this.logger&&this.logger.logIncoming(R.byteLength,k[1],1,`${g(_)}: ${k[2]}.${k[3]}`,O),this.onPromise({type:_,id:k[1],channelName:k[2],name:k[3],arg:O});case 102:return this.logger&&this.logger.logIncoming(R.byteLength,k[1],1,`${g(_)}: ${k[2]}.${k[3]}`,O),this.onEventListen({type:_,id:k[1],channelName:k[2],name:k[3],arg:O});case 101:return this.logger&&this.logger.logIncoming(R.byteLength,k[1],1,`${g(_)}`),this.disposeActiveRequest({type:_,id:k[1]});case 103:return this.logger&&this.logger.logIncoming(R.byteLength,k[1],1,`${g(_)}`),this.disposeActiveRequest({type:_,id:k[1]})}}onPromise(R){const W=this.channels.get(R.channelName);if(!W){this.collectPendingRequest(R);return}const k=new b.CancellationTokenSource;let O;try{O=W.call(this.ctx,R.name,R.arg,k.token)}catch(G){O=Promise.reject(G)}const _=R.id;O.then(G=>{this.sendResponse({id:_,data:G,type:201}),this.activeRequests.delete(R.id)},G=>{G instanceof Error?this.sendResponse({id:_,data:{message:G.message,name:G.name,stack:G.stack?G.stack.split?G.stack.split(`
`):G.stack:void 0},type:202}):this.sendResponse({id:_,data:G,type:203}),this.activeRequests.delete(R.id)});const K=(0,L.toDisposable)(()=>k.cancel());this.activeRequests.set(R.id,K)}onEventListen(R){const W=this.channels.get(R.channelName);if(!W){this.collectPendingRequest(R);return}const k=R.id,_=W.listen(this.ctx,R.name,R.arg)(K=>this.sendResponse({id:k,data:K,type:204}));this.activeRequests.set(R.id,_)}disposeActiveRequest(R){const W=this.activeRequests.get(R.id);W&&(W.dispose(),this.activeRequests.delete(R.id))}collectPendingRequest(R){let W=this.pendingRequests.get(R.channelName);W||(W=[],this.pendingRequests.set(R.channelName,W));const k=setTimeout(()=>{console.error(`Unknown channel: ${R.channelName}`),R.type===100&&this.sendResponse({id:R.id,data:{name:"Unknown channel",message:`Channel name '${R.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);W.push({request:R,timeoutTimer:k})}flushPendingRequests(R){const W=this.pendingRequests.get(R);if(W){for(const k of W)switch(clearTimeout(k.timeoutTimer),k.request.type){case 100:this.onPromise(k.request);break;case 102:this.onEventListen(k.request);break}this.pendingRequests.delete(R)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(R=>R.dispose()),this.activeRequests.clear()}}e.ChannelServer=h;var P;(function(F){F[F.LocalSide=0]="LocalSide",F[F.OtherSide=1]="OtherSide"})(P=e.RequestInitiator||(e.RequestInitiator={}));class T{constructor(R,W=null){this.protocol=R,this.isDisposed=!1,this.state=S.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new m.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(k=>this.onBuffer(k)),this.logger=W}getChannel(R){const W=this;return{call(k,O,_){return W.isDisposed?Promise.reject(E.canceled()):W.requestPromise(R,k,O,_)},listen(k,O){return W.isDisposed?Promise.reject(E.canceled()):W.requestEvent(R,k,O)}}}requestPromise(R,W,k,O=b.CancellationToken.None){const _=this.lastRequestId++,G={id:_,type:100,channelName:R,name:W,arg:k};if(O.isCancellationRequested)return Promise.reject(E.canceled());let Y;return new Promise((ne,re)=>{if(O.isCancellationRequested)return re(E.canceled());const se=()=>{const me=Se=>{switch(Se.type){case 201:this.handlers.delete(_),ne(Se.data);break;case 202:this.handlers.delete(_);const Le=new Error(Se.data.message);Le.stack=Se.data.stack,Le.name=Se.data.name,re(Le);break;case 203:this.handlers.delete(_),re(Se.data);break}};this.handlers.set(_,me),this.sendRequest(G)};let le=null;this.state===S.Idle?se():(le=(0,A.createCancelablePromise)(me=>this.whenInitialized()),le.then(()=>{le=null,se()}));const oe=()=>{le?(le.cancel(),le=null):this.sendRequest({id:_,type:101}),re(E.canceled())},ue=O.onCancellationRequested(oe);Y=(0,L.combinedDisposable)((0,L.toDisposable)(oe),ue),this.activeRequests.add(Y)}).finally(()=>{this.activeRequests.delete(Y)})}requestEvent(R,W,k){const O=this.lastRequestId++,K={id:O,type:102,channelName:R,name:W,arg:k};let G=null;const Y=new m.Emitter({onFirstListenerAdd:()=>{G=(0,A.createCancelablePromise)(ne=>this.whenInitialized()),G.then(()=>{G=null,this.activeRequests.add(Y),this.sendRequest(K)})},onLastListenerRemove:()=>{G?(G.cancel(),G=null):(this.activeRequests.delete(Y),this.sendRequest({id:O,type:103}))}}),ee=ne=>Y.fire(ne.data);return this.handlers.set(O,ee),Y.event}sendRequest(R){switch(R.type){case 100:case 102:{const W=this.send([R.type,R.id,R.channelName,R.name],R.arg);this.logger&&this.logger.logOutgoing(W,R.id,0,`${g(R.type)}: ${R.channelName}.${R.name}`,R.arg);return}case 101:case 103:{const W=this.send([R.type,R.id]);this.logger&&this.logger.logOutgoing(W,R.id,0,g(R.type));return}}}send(R,W=void 0){const k=new u;return d(k,R),d(k,W),this.sendBuffer(k.buffer)}sendBuffer(R){try{return this.protocol.send(R),R.byteLength}catch(W){return 0}}onBuffer(R){const W=new a(R),k=f(W),O=f(W),_=k[0];switch(_){case 200:return this.logger&&this.logger.logIncoming(R.byteLength,0,0,D(_)),this.onResponse({type:k[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(R.byteLength,k[1],0,D(_),O),this.onResponse({type:k[0],id:k[1],data:O})}}onResponse(R){if(R.type===200){this.state=S.Idle,this._onDidInitialize.fire();return}const W=this.handlers.get(R.id);W&&W(R)}get onDidInitializePromise(){return m.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===S.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(R=>R.dispose()),this.activeRequests.clear()}}he([M.memoize],T.prototype,"onDidInitializePromise",null),e.ChannelClient=T;class U{constructor(R){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new m.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new m.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,R(({protocol:W,onDidClientDisconnect:k})=>{m.Event.once(W.onMessage)(_=>{const K=new a(_),G=f(K),Y=new h(W,G),ee=new T(W);this.channels.forEach((re,se)=>Y.registerChannel(se,re));const ne={channelServer:Y,channelClient:ee,ctx:G};this._connections.add(ne),this._onDidAddConnection.fire(ne),k(()=>{Y.dispose(),ee.dispose(),this._connections.delete(ne),this._onDidRemoveConnection.fire(ne)})})})}get connections(){const R=[];return this._connections.forEach(W=>R.push(W)),R}getChannel(R,W){const k=this;return{call(O,_,K){let G;if((0,y.isFunction)(W)){let ee=(0,w.getRandomElement)(k.connections.filter(W));G=ee?Promise.resolve(ee):m.Event.toPromise(m.Event.filter(k.onDidAddConnection,W))}else G=W.routeCall(k,O,_);const Y=G.then(ee=>ee.channelClient.getChannel(R));return Q(Y).call(O,_,K)},listen(O,_){if((0,y.isFunction)(W))return k.getMulticastEvent(R,W,O,_);const K=W.routeEvent(k,O,_).then(G=>G.channelClient.getChannel(R));return Q(K).listen(O,_)}}}getMulticastEvent(R,W,k,O){const _=this;let K=new L.DisposableStore;const G=new m.Emitter({onFirstListenerAdd:()=>{K=new L.DisposableStore;const Y=new m.EventMultiplexer,ee=new Map,ne=se=>{const oe=se.channelClient.getChannel(R).listen(k,O),ue=Y.add(oe);ee.set(se,ue)},re=se=>{const le=ee.get(se);!le||(le.dispose(),ee.delete(se))};_.connections.filter(W).forEach(ne),m.Event.filter(_.onDidAddConnection,W)(ne,void 0,K),_.onDidRemoveConnection(re,void 0,K),Y.event(G.fire,G,K),K.add(Y)},onLastListenerRemove:()=>{K.dispose()}});return G.event}registerChannel(R,W){this.channels.set(R,W),this._connections.forEach(k=>{k.channelServer.registerChannel(R,W)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=U;class q{constructor(R,W,k=null){const O=new u;d(O,W),R.send(O.buffer),this.channelClient=new T(R,k),this.channelServer=new h(R,W,k)}getChannel(R){return this.channelClient.getChannel(R)}registerChannel(R,W){this.channelServer.registerChannel(R,W)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=q;function Q(F){return{call(R,W,k){return F.then(O=>O.call(R,W,k))},listen(R,W){const k=new m.Relay;return F.then(O=>k.input=O.listen(R,W)),k.event}}}e.getDelayedChannel=Q;function x(F){let R=!1;return{call(W,k,O){return R?F.call(W,k,O):(0,A.timeout)(0).then(()=>R=!0).then(()=>F.call(W,k,O))},listen(W,k){if(R)return F.listen(W,k);const O=new m.Relay;return(0,A.timeout)(0).then(()=>R=!0).then(()=>O.input=F.listen(W,k)),O.event}}}e.getNextTickChannel=x;class j{constructor(R){this.fn=R}routeCall(R){return this.route(R)}routeEvent(R){return this.route(R)}async route(R){for(const W of R.connections)if(await Promise.resolve(this.fn(W.ctx)))return Promise.resolve(W);return await m.Event.toPromise(R.onDidAddConnection),await this.route(R)}}e.StaticRouter=j;var X;(function(F){function R(O,_){const K=O,G=_&&_.disableMarshalling,Y=new Map;for(const ee in K)k(ee)&&Y.set(ee,m.Event.buffer(K[ee],!0));return new class{listen(ee,ne){const re=Y.get(ne);if(re)return re;throw new Error(`Event not found: ${ne}`)}call(ee,ne,re){const se=K[ne];if(typeof se=="function"){if(!G&&Array.isArray(re))for(let le=0;le<re.length;le++)re[le]=(0,i.revive)(re[le]);return se.apply(K,re)}throw new Error(`Method not found: ${ne}`)}}}F.fromService=R;function W(O,_){const K=_&&_.disableMarshalling;return new Proxy({},{get(G,Y){var ee;if(typeof Y=="string")return((ee=_==null?void 0:_.properties)===null||ee===void 0?void 0:ee.has(Y))?_.properties.get(Y):k(Y)?O.listen(Y):async function(...ne){let re;_&&!(0,y.isUndefinedOrNull)(_.context)?re=[_.context,...ne]:re=ne;const se=await O.call(Y,re);return K?se:(0,i.revive)(se)};throw new Error(`Property not found: ${String(Y)}`)}})}F.toService=W;function k(O){return O[0]==="o"&&O[1]==="n"&&I.isUpperAsciiLetter(O.charCodeAt(2))}})(X=e.ProxyChannel||(e.ProxyChannel={}));const B=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function V(F){if(Array.isArray(F))return F;if(F&&typeof F=="object"&&typeof F.toString=="function"){let R=F.toString();if(R!=="[object Object]")return R}return F}function N(F){return Array.isArray(F)?F.map(V):V(F)}function C(F,R,W,k,O,_,K){K=N(K);const G=B[O],Y=G[k%G.length];let ee=[`%c[${F}]%c[${String(R).padStart(7," ")}]%c[len: ${String(W).padStart(5," ")}]%c${String(k).padStart(5," ")} - ${_}`,"color: darkgreen","color: grey","color: grey",`color: ${Y}`];/\($/.test(_)?(ee=ee.concat(K),ee.push(")")):ee.push(K),console.log.apply(console,ee)}e.logWithColors=C;class z{constructor(R,W){this._outgoingPrefix=R,this._incomingPrefix=W,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(R,W,k,O,_){this._totalOutgoing+=R,C(this._outgoingPrefix,this._totalOutgoing,R,W,k,O,_)}logIncoming(R,W,k,O,_){this._totalIncoming+=R,C(this._incomingPrefix,this._totalIncoming,R,W,k,O,_)}}e.IPCLogger=z}),define(J[120],Z([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Protocol=void 0;class m{constructor(A,b){this.sender=A,this.onMessage=b}send(A){try{this.sender.send("vscode:message",A.buffer)}catch(b){}}disconnect(){this.sender.send("vscode:disconnect",null)}}e.Protocol=m}),define(J[121],Z([0,1,5,33,20]),function($,e,m,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class b{constructor(w){this.port=w,this.onMessage=m.Event.fromDOMEventEmitter(this.port,"message",y=>A.VSBuffer.wrap(y.data)),w.start()}send(w){this.port.postMessage(w.buffer)}disconnect(){this.port.close()}}e.Protocol=b;class E extends L.IPCClient{constructor(w,y){const i=new b(w);super(i,y);this.protocol=i}dispose(){this.protocol.disconnect()}}e.Client=E}),define(J[84],Z([0,1,5,33,2,20,3,32]),function($,e,m,L,A,b,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=void 0;let w=null;function y(){return w||(w=b.VSBuffer.alloc(0)),w}class i{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(s){this._chunks.push(s),this._totalLength+=s.byteLength}read(s){return this._read(s,!0)}peek(s){return this._read(s,!1)}_read(s,o){if(s===0)return y();if(s>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===s){const P=this._chunks[0];return o&&(this._chunks.shift(),this._totalLength-=s),P}if(this._chunks[0].byteLength>s){const P=this._chunks[0].slice(0,s);return o&&(this._chunks[0]=this._chunks[0].slice(s),this._totalLength-=s),P}let d=b.VSBuffer.alloc(s),f=0,h=0;for(;s>0;){const P=this._chunks[h];if(P.byteLength>s){const T=P.slice(0,s);d.set(T,f),f+=s,o&&(this._chunks[h]=P.slice(s),this._totalLength-=s),s-=s}else d.set(P,f),f+=P.byteLength,o?(this._chunks.shift(),this._totalLength-=P.byteLength):h++,s-=P.byteLength}return d}}e.ChunkStream=i;var I;(function(r){r[r.None=0]="None",r[r.Regular=1]="Regular",r[r.Control=2]="Control",r[r.Ack=3]="Ack",r[r.KeepAlive=4]="KeepAlive",r[r.Disconnect=5]="Disconnect",r[r.ReplayRequest=6]="ReplayRequest"})(I||(I={}));var M;(function(r){r[r.HeaderLength=13]="HeaderLength",r[r.AcknowledgeTime=2e3]="AcknowledgeTime",r[r.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",r[r.KeepAliveTime=5e3]="KeepAliveTime",r[r.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",r[r.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",r[r.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(M=e.ProtocolConstants||(e.ProtocolConstants={}));class p{constructor(s,o,d,f){this.type=s,this.id=o,this.ack=d,this.data=f,this.writtenTime=0}get size(){return this.data.byteLength}}class g extends A.Disposable{constructor(s){super();this._onMessage=this._register(new m.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=s,this._isDisposed=!1,this._incomingData=new i,this._register(this._socket.onData(o=>this.acceptChunk(o))),this.lastReadTime=Date.now()}acceptChunk(s){if(!(!s||s.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(s);this._incomingData.byteLength>=this._state.readLen;){const o=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=o.readUInt32BE(9),this._state.messageType=o.readUInt8(0),this._state.id=o.readUInt32BE(1),this._state.ack=o.readUInt32BE(5);else{const d=this._state.messageType,f=this._state.id,h=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new p(d,f,h,o)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class v{constructor(s){this._isDisposed=!1,this._socket=s,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(s){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}write(s){if(this._isDisposed)return;s.writtenTime=Date.now(),this.lastWriteTime=Date.now();const o=b.VSBuffer.alloc(13);o.writeUInt8(s.type,0),o.writeUInt32BE(s.id,1),o.writeUInt32BE(s.ack,5),o.writeUInt32BE(s.data.byteLength,9),this._writeSoon(o,s.data)}_bufferAdd(s,o){const d=this._totalLength===0;return this._data.push(s,o),this._totalLength+=s.byteLength+o.byteLength,d}_bufferTake(){const s=b.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,s}_writeSoon(s,o){this._bufferAdd(s,o)&&E.setImmediate(()=>{this._writeNow()})}_writeNow(){this._totalLength!==0&&this._socket.write(this._bufferTake())}}class D extends A.Disposable{constructor(s){super();this._onMessage=new m.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new m.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=s,this._socketWriter=this._register(new v(this._socket)),this._socketReader=this._register(new g(this._socket)),this._register(this._socketReader.onMessage(o=>{o.type===1&&this._onMessage.fire(o.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(s){this._socketWriter.write(new p(1,0,0,s))}}e.Protocol=D;class S extends L.IPCClient{constructor(s,o,d=null){super(s,o,d);this.protocol=s}static fromSocket(s,o){return new S(new D(s),o)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const s=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),s.end()}}e.Client=S;class a{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new m.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,n.nextTick(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(s){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(s):this._emitter.fire(s):this._bufferedMessages.push(s)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=a;class u{constructor(s){this.data=s,this.next=null}}class c{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let s=[],o=0,d=this._first;for(;d;)s[o++]=d.data,d=d.next;return s}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(s){const o=new u(s);if(!this._first){this._first=o,this._last=o;return}this._last.next=o,this._last=o}}class l{constructor(){this.lastRuns=[];const s=Date.now();for(let o=0;o<l._HISTORY_LENGTH;o++)this.lastRuns[o]=s-1e3*o;setInterval(()=>{for(let o=l._HISTORY_LENGTH;o>=1;o--)this.lastRuns[o]=this.lastRuns[o-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return l._INSTANCE||(l._INSTANCE=new l),l._INSTANCE}load(){const s=Date.now(),o=(1+l._HISTORY_LENGTH)*1e3;let d=0;for(let f=0;f<l._HISTORY_LENGTH;f++)s-this.lastRuns[f]<=o&&d++;return 1-d/l._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}l._HISTORY_LENGTH=10,l._INSTANCE=null;class t{constructor(s,o=null){this._loadEstimator=l.getInstance(),this._onControlMessage=new a,this.onControlMessage=this._onControlMessage.event,this._onMessage=new a,this.onMessage=this._onMessage.event,this._onDidDispose=new a,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new a,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new a,this.onSocketTimeout=this._onSocketTimeout.event,this._isReconnecting=!1,this._outgoingUnackMsg=new c,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._lastReplayRequestTime=0,this._socketDisposables=[],this._socket=s,this._socketWriter=new v(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new g(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(d=>this._receiveMessage(d))),this._socketDisposables.push(this._socket.onClose(()=>this._onSocketClose.fire())),o&&this._socketReader.acceptChunk(o),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=(0,A.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const s=new p(5,0,0,y());this._socketWriter.write(s),this._socketWriter.flush()}_sendKeepAliveCheck(){if(this._outgoingKeepAliveTimeout)return;const s=Date.now()-this._socketWriter.lastWriteTime;if(s>=5e3){const o=new p(4,0,0,y());this._socketWriter.write(o),this._sendKeepAliveCheck();return}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-s+5)}_recvKeepAliveCheck(){if(this._incomingKeepAliveTimeout)return;const s=Date.now()-this._socketReader.lastReadTime;if(s>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._incomingKeepAliveTimeout=setTimeout(()=>{this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},Math.max(2e4-s,0)+5)}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(s,o){this._isReconnecting=!0,this._socketDisposables=(0,A.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._socket=s,this._socketWriter=new v(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new g(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(d=>this._receiveMessage(d))),this._socketDisposables.push(this._socket.onClose(()=>this._onSocketClose.fire())),this._socketReader.acceptChunk(o)}endAcceptReconnection(){this._isReconnecting=!1;const s=this._outgoingUnackMsg.toArray();for(let o=0,d=s.length;o<d;o++)this._socketWriter.write(s[o]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(s){if(s.ack>this._outgoingAckId){this._outgoingAckId=s.ack;do{const o=this._outgoingUnackMsg.peek();if(o&&o.id<=s.ack)this._outgoingUnackMsg.pop();else break}while(!0)}if(s.type===1){if(s.id>this._incomingMsgId)if(s.id!==this._incomingMsgId+1){const o=Date.now();o-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=o,this._socketWriter.write(new p(6,0,0,y())))}else this._incomingMsgId=s.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(s.data)}else if(s.type===2)this._onControlMessage.fire(s.data);else if(s.type===5)this._onDidDispose.fire();else if(s.type===6){const o=this._outgoingUnackMsg.toArray();for(let d=0,f=o.length;d<f;d++)this._socketWriter.write(o[d]);this._recvAckCheck()}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(s){const o=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const d=new p(1,o,this._incomingAckId,s);this._outgoingUnackMsg.push(d),this._isReconnecting||(this._socketWriter.write(d),this._recvAckCheck())}sendControl(s){const o=new p(2,0,0,s);this._socketWriter.write(o)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const s=Date.now()-this._incomingMsgLastTime;if(s>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-s+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout)return;const s=this._outgoingUnackMsg.peek(),o=Date.now()-s.writtenTime;if(o>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-o,0)+5)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const s=new p(3,0,this._incomingAckId,y());this._socketWriter.write(s)}}e.PersistentProtocol=t}),define(J[122],Z([0,1,14,5,33,120,2,20]),function($,e,m,L,A,b,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;function w(i,I){const M=L.Event.fromNodeEventEmitter(m.ipcMain,I,(g,v)=>({event:g,message:v})),p=L.Event.filter(M,({event:g})=>g.sender.id===i);return L.Event.map(p,({message:g})=>g&&n.VSBuffer.wrap(g))}class y extends A.IPCServer{constructor(){super(y.getOnDidClientConnect())}static getOnDidClientConnect(){const I=L.Event.fromNodeEventEmitter(m.ipcMain,"vscode:hello",({sender:M})=>M);return L.Event.map(I,M=>{const p=M.id,g=y.Clients.get(p);g&&g.dispose();const v=new L.Emitter;y.Clients.set(p,(0,E.toDisposable)(()=>v.fire()));const D=w(p,"vscode:message"),S=L.Event.any(L.Event.signal(w(p,"vscode:disconnect")),v.event);return{protocol:new b.Protocol(M,D),onDidClientDisconnect:S}})}}e.Server=y,y.Clients=new Map}),define(J[85],Z([0,1,14,5,27,121]),function($,e,m,L,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.Client=void 0;class E extends b.Client{constructor(y,i){super({addEventListener:(I,M)=>y.addListener(I,M),removeEventListener:(I,M)=>y.removeListener(I,M),postMessage:I=>y.postMessage(I),start:()=>y.start(),close:()=>y.close()},i)}}e.Client=E;async function n(w){if(w.isDestroyed()||w.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const y=(0,A.generateUuid)();w.webContents.send("vscode:createMessageChannel",y);const i=L.Event.fromNodeEventEmitter(m.ipcMain,"vscode:createMessageChannelResult",(M,p)=>({nonce:p,port:M.ports[0]})),{port:I}=await L.Event.toPromise(L.Event.once(L.Event.filter(i,M=>M.nonce===y)));return I}e.connect=n}),define(J[86],Z([0,1,2,5,9,13]),function($,e,m,L,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageHint=void 0;var E;(function(i){i[i.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(E=e.StorageHint||(e.StorageHint={}));var n;(function(i){i[i.None=0]="None",i[i.Initialized=1]="Initialized",i[i.Closed=2]="Closed"})(n||(n={}));class w extends m.Disposable{constructor(I,M=Object.create(null)){super();this.database=I,this.options=M,this._onDidChangeStorage=this._register(new L.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=n.None,this.cache=new Map,this.flushDelayer=new A.ThrottledDelayer(w.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(I=>this.onDidChangeItemsExternal(I)))}onDidChangeItemsExternal(I){var M,p;(M=I.changed)===null||M===void 0||M.forEach((g,v)=>this.accept(v,g)),(p=I.deleted)===null||p===void 0||p.forEach(g=>this.accept(g,void 0))}accept(I,M){if(this.state===n.Closed)return;let p=!1;(0,b.isUndefinedOrNull)(M)?p=this.cache.delete(I):this.cache.get(I)!==M&&(this.cache.set(I,M),p=!0),p&&this._onDidChangeStorage.fire(I)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===n.None&&(this.state=n.Initialized,this.options.hint!==E.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(I,M){const p=this.cache.get(I);return(0,b.isUndefinedOrNull)(p)?M:p}getBoolean(I,M){const p=this.get(I);return(0,b.isUndefinedOrNull)(p)?M:p==="true"}getNumber(I,M){const p=this.get(I);return(0,b.isUndefinedOrNull)(p)?M:parseInt(p,10)}async set(I,M){if(this.state===n.Closed)return;if((0,b.isUndefinedOrNull)(M))return this.delete(I);const p=String(M);if(this.cache.get(I)!==p)return this.cache.set(I,p),this.pendingInserts.set(I,p),this.pendingDeletes.delete(I),this._onDidChangeStorage.fire(I),this.flushDelayer.trigger(()=>this.flushPending())}async delete(I){if(!(this.state===n.Closed||!this.cache.delete(I)))return this.pendingDeletes.has(I)||this.pendingDeletes.add(I),this.pendingInserts.delete(I),this._onDidChangeStorage.fire(I),this.flushDelayer.trigger(()=>this.flushPending())}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=n.Closed;try{await this.flushDelayer.trigger(()=>this.flushPending(),0)}catch(I){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const I={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(I).finally(()=>{var M;if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)(M=this.whenFlushedCallbacks.pop())===null||M===void 0||M()})}async whenFlushed(){if(!!this.hasPending)return new Promise(I=>this.whenFlushedCallbacks.push(I))}dispose(){this.flushDelayer.cancel(),this.flushDelayer.dispose(),super.dispose()}}e.Storage=w,w.DEFAULT_FLUSH_DELAY=100;class y{constructor(){this.onDidChangeItemsExternal=L.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(I){I.insert&&I.insert.forEach((M,p)=>this.items.set(p,M)),I.delete&&I.delete.forEach(M=>this.items.delete(M))}async close(){}}e.InMemoryStorageDatabase=y}),define(J[123],Z([0,1,5,9,36,8,16]),function($,e,m,L,A,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SQLiteStorageDatabase=void 0;class n{constructor(i,I=Object.create(null)){this.path=i,this.options=I,this.name=(0,b.basename)(this.path),this.logger=new w(this.options.logging),this.whenConnected=this.connect(this.path)}get onDidChangeItemsExternal(){return m.Event.None}async getItems(){const i=await this.whenConnected,I=new Map;return(await this.all(i,"SELECT * FROM ItemTable")).forEach(p=>I.set(p.key,p.value)),this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] getItems(): ${I.size} rows`),I}async updateItems(i){const I=await this.whenConnected;return this.doUpdateItems(I,i)}doUpdateItems(i,I){return this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] updateItems(): insert(${I.insert?(0,A.mapToString)(I.insert):"0"}), delete(${I.delete?(0,A.setToString)(I.delete):"0"})`),this.transaction(i,()=>{const M=I.insert,p=I.delete;if(M&&M.size>0){const g=[];g.push([]);let v=0;M.forEach((D,S)=>{let a=g[v];a.length>n.MAX_HOST_PARAMETERS&&(v++,a=[],g.push(a)),a.push(S,D)}),g.forEach(D=>{this.prepare(i,`INSERT INTO ItemTable VALUES ${new Array(D.length/2).fill("(?,?)").join(",")}`,S=>S.run(D),()=>{const S=[];let a=0;return M.forEach((u,c)=>{S.push(c),a+=u.length}),`Keys: ${S.join(", ")} Length: ${a}`})})}if(p&&p.size){const g=[];g.push([]);let v=0;p.forEach(D=>{let S=g[v];S.length>n.MAX_HOST_PARAMETERS&&(v++,S=[],g.push(S)),S.push(D)}),g.forEach(D=>{this.prepare(i,`DELETE FROM ItemTable WHERE key IN (${new Array(D.length).fill("?").join(",")})`,S=>S.run(D),()=>{const S=[];return p.forEach(a=>{S.push(a)}),`Keys: ${S.join(", ")}`})})}})}async close(i){this.logger.trace(`[storage ${this.name}] close()`);const I=await this.whenConnected;return this.doClose(I,i)}doClose(i,I){return new Promise((M,p)=>{i.db.close(g=>(g&&this.handleSQLiteError(i,`[storage ${this.name}] close(): ${g}`),this.path===n.IN_MEMORY_PATH?M():!i.isErroneous&&!i.isInMemory?this.backup().then(M,v=>(this.logger.error(`[storage ${this.name}] backup(): ${v}`),M())):typeof I=="function"?E.Promises.unlink(this.path).then(()=>this.doConnect(this.path).then(v=>{const D=()=>this.doClose(v,void 0);return this.doUpdateItems(v,{insert:I()}).then(()=>D(),S=>(D(),Promise.reject(S)))})).then(M,p):p(g||new Error("Database has errors or is in-memory without recovery option"))))})}backup(){const i=this.toBackupPath(this.path);return(0,E.copy)(this.path,i,{preserveSymlinks:!1})}toBackupPath(i){return`${i}.backup`}async checkIntegrity(i){this.logger.trace(`[storage ${this.name}] checkIntegrity(full: ${i})`);const I=await this.whenConnected,M=await this.get(I,i?"PRAGMA integrity_check":"PRAGMA quick_check"),p=i?M.integrity_check:M.quick_check;return I.isErroneous?`${p} (last error: ${I.lastError})`:I.isInMemory?`${p} (in-memory!)`:p}async connect(i,I=!0){this.logger.trace(`[storage ${this.name}] open(${i}, retryOnBusy: ${I})`);try{return await this.doConnect(i)}catch(M){if(this.logger.error(`[storage ${this.name}] open(): Unable to open DB due to ${M}`),M.code==="SQLITE_BUSY"&&I)return await(0,L.timeout)(n.BUSY_OPEN_TIMEOUT),this.connect(i,!1);try{await E.Promises.unlink(i);try{await E.Promises.rename(this.toBackupPath(i),i)}catch(p){}return await this.doConnect(i)}catch(p){return this.logger.error(`[storage ${this.name}] open(): Unable to use backup due to ${p}`),this.doConnect(n.IN_MEMORY_PATH)}}}handleSQLiteError(i,I){i.isErroneous=!0,i.lastError=I,this.logger.error(I)}doConnect(i){return new Promise((I,M)=>{new Promise((p,g)=>{$(["vscode-sqlite3"],p,g)}).then(p=>{const g={db:new(this.logger.isTracing?p.verbose().Database:p.Database)(i,v=>v?g.db?g.db.close(()=>M(v)):M(v):this.exec(g,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>I(g),D=>g.db.close(()=>M(D)))),isInMemory:i===n.IN_MEMORY_PATH};g.db.on("error",v=>this.handleSQLiteError(g,`[storage ${this.name}] Error (event): ${v}`)),this.logger.isTracing&&g.db.on("trace",v=>this.logger.trace(`[storage ${this.name}] Trace (event): ${v}`))},M)})}exec(i,I){return new Promise((M,p)=>{i.db.exec(I,g=>g?(this.handleSQLiteError(i,`[storage ${this.name}] exec(): ${g}`),p(g)):M())})}get(i,I){return new Promise((M,p)=>{i.db.get(I,(g,v)=>g?(this.handleSQLiteError(i,`[storage ${this.name}] get(): ${g}`),p(g)):M(v))})}all(i,I){return new Promise((M,p)=>{i.db.all(I,(g,v)=>g?(this.handleSQLiteError(i,`[storage ${this.name}] all(): ${g}`),p(g)):M(v))})}transaction(i,I){return new Promise((M,p)=>{i.db.serialize(()=>{i.db.run("BEGIN TRANSACTION"),I(),i.db.run("END TRANSACTION",g=>g?(this.handleSQLiteError(i,`[storage ${this.name}] transaction(): ${g}`),p(g)):M())})})}prepare(i,I,M,p){const g=i.db.prepare(I),v=D=>{this.handleSQLiteError(i,`[storage ${this.name}] prepare(): ${D} (${I}). Details: ${p()}`)};g.on("error",v),M(g),g.finalize(D=>{D&&v(D),g.removeListener("error",v)})}}e.SQLiteStorageDatabase=n,n.IN_MEMORY_PATH=":memory:",n.BUSY_OPEN_TIMEOUT=2e3,n.MAX_HOST_PARAMETERS=256;class w{constructor(i){i&&typeof i.logTrace=="function"&&process.env[w.VSCODE_TRACE_STORAGE]&&(this.logTrace=i.logTrace),i&&typeof i.logError=="function"&&(this.logError=i.logError)}get isTracing(){return!!this.logTrace}trace(i){this.logTrace&&this.logTrace(i)}error(i){this.logError&&this.logError(i)}}w.VSCODE_TRACE_STORAGE="VSCODE_TRACE_STORAGE"}),define(J[124],Z([12,11]),function($,e){return $.create("vs/base/common/date",e)}),define(J[125],Z([0,1,124]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const L=60,A=L*60,b=A*24,E=b*7,n=b*30,w=b*365;function y(I,M){typeof I!="number"&&(I=I.getTime());const p=Math.round((new Date().getTime()-I)/1e3);if(p<-30)return(0,m.localize)(0,null,y(new Date().getTime()+p*1e3,!1));if(p<30)return(0,m.localize)(1,null);let g;return p<L?(g=p,M?g===1?(0,m.localize)(2,null,g):(0,m.localize)(3,null,g):g===1?(0,m.localize)(4,null,g):(0,m.localize)(5,null,g)):p<A?(g=Math.floor(p/L),M?g===1?(0,m.localize)(6,null,g):(0,m.localize)(7,null,g):g===1?(0,m.localize)(8,null,g):(0,m.localize)(9,null,g)):p<b?(g=Math.floor(p/A),M?g===1?(0,m.localize)(10,null,g):(0,m.localize)(11,null,g):g===1?(0,m.localize)(12,null,g):(0,m.localize)(13,null,g)):p<E?(g=Math.floor(p/b),M?g===1?(0,m.localize)(14,null,g):(0,m.localize)(15,null,g):g===1?(0,m.localize)(16,null,g):(0,m.localize)(17,null,g)):p<n?(g=Math.floor(p/E),M?g===1?(0,m.localize)(18,null,g):(0,m.localize)(19,null,g):g===1?(0,m.localize)(20,null,g):(0,m.localize)(21,null,g)):p<w?(g=Math.floor(p/n),M?g===1?(0,m.localize)(22,null,g):(0,m.localize)(23,null,g):g===1?(0,m.localize)(24,null,g):(0,m.localize)(25,null,g)):(g=Math.floor(p/w),M?g===1?(0,m.localize)(26,null,g):(0,m.localize)(27,null,g):g===1?(0,m.localize)(28,null,g):(0,m.localize)(29,null,g))}e.fromNow=y;function i(I){return I.getFullYear()+"-"+String(I.getMonth()+1).padStart(2,"0")+"-"+String(I.getDate()).padStart(2,"0")+"T"+String(I.getHours()).padStart(2,"0")+":"+String(I.getMinutes()).padStart(2,"0")+":"+String(I.getSeconds()).padStart(2,"0")+"."+(I.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=i}),define(J[126],Z([12,11]),function($,e){return $.create("vs/base/common/errorMessage",e)}),define(J[67],Z([0,1,126,13,35]),function($,e,m,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function b(y,i){return i&&(y.stack||y.stacktrace)?m.localize(0,null,n(y),E(y.stack)||E(y.stacktrace)):n(y)}function E(y){return Array.isArray(y)?y.join(`
`):y}function n(y){return typeof y.code=="string"&&typeof y.errno=="number"&&typeof y.syscall=="string"?m.localize(1,null,y.message):y.message||m.localize(2,null)}function w(y=null,i=!1){if(!y)return m.localize(3,null);if(Array.isArray(y)){const I=A.coalesce(y),M=w(I[0],i);return I.length>1?m.localize(4,null,M,I.length):M}if(L.isString(y))return y;if(y.detail){const I=y.detail;if(I.error)return b(I.error,i);if(I.exception)return b(I.exception,i)}return y.stack?b(y,i):y.message?y.message:m.localize(5,null)}e.toErrorMessage=w}),define(J[127],Z([12,11]),function($,e){return $.create("vs/base/common/keybindingLabels",e)}),define(J[128],Z([0,1,127]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserSettingsLabelProvider=e.ElectronAcceleratorLabelProvider=e.AriaLabelProvider=e.UILabelProvider=e.ModifierLabelProvider=void 0;class L{constructor(E,n,w=n){this.modifierLabels=[null],this.modifierLabels[2]=E,this.modifierLabels[1]=n,this.modifierLabels[3]=w}toLabel(E,n,w){if(n.length===0)return null;const y=[];for(let i=0,I=n.length;i<I;i++){const M=n[i],p=w(M);if(p===null)return null;y[i]=A(M,p,this.modifierLabels[E])}return y.join(" ")}}e.ModifierLabelProvider=L,e.UILabelProvider=new L({ctrlKey:"\u2303",shiftKey:"\u21E7",altKey:"\u2325",metaKey:"\u2318",separator:""},{ctrlKey:m.localize(0,null),shiftKey:m.localize(1,null),altKey:m.localize(2,null),metaKey:m.localize(3,null),separator:"+"},{ctrlKey:m.localize(4,null),shiftKey:m.localize(5,null),altKey:m.localize(6,null),metaKey:m.localize(7,null),separator:"+"}),e.AriaLabelProvider=new L({ctrlKey:m.localize(8,null),shiftKey:m.localize(9,null),altKey:m.localize(10,null),metaKey:m.localize(11,null),separator:"+"},{ctrlKey:m.localize(12,null),shiftKey:m.localize(13,null),altKey:m.localize(14,null),metaKey:m.localize(15,null),separator:"+"},{ctrlKey:m.localize(16,null),shiftKey:m.localize(17,null),altKey:m.localize(18,null),metaKey:m.localize(19,null),separator:"+"}),e.ElectronAcceleratorLabelProvider=new L({ctrlKey:"Ctrl",shiftKey:"Shift",altKey:"Alt",metaKey:"Cmd",separator:"+"},{ctrlKey:"Ctrl",shiftKey:"Shift",altKey:"Alt",metaKey:"Super",separator:"+"}),e.UserSettingsLabelProvider=new L({ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"cmd",separator:"+"},{ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"win",separator:"+"},{ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"meta",separator:"+"});function A(b,E,n){if(E===null)return"";const w=[];return b.ctrlKey&&w.push(n.ctrlKey),b.shiftKey&&w.push(n.shiftKey),b.altKey&&w.push(n.altKey),b.metaKey&&w.push(n.metaKey),E!==""&&w.push(E),w.join(n.separator)}}),define(J[129],Z([12,11]),function($,e){return $.create("vs/base/node/processes",e)}),define(J[68],Z([0,1,8,16,40,129,32,13,44,30,3,81,10]),function($,e,m,L,A,b,E,n,w,y,i,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0;function p(c){switch(c){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function g(c,l){if(i.isWindows)try{const t={stdio:["pipe","pipe","ignore"]};l&&(t.cwd=l);const r=A.execFile("taskkill",["/T","/F","/PID",c.pid.toString()],t);return new Promise(s=>{r.once("error",o=>{s({success:!1,error:o})}),r.once("exit",(o,d)=>{s(o===0?{success:!0}:{success:!1,code:o!==null?o:1})})})}catch(t){return Promise.resolve({success:!1,error:t,code:t.status?p(t.status):1})}else if(i.isLinux||i.isMacintosh)try{const t=M.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",$).fsPath;return new Promise(r=>{A.execFile(t,[c.pid.toString()],{encoding:"utf8",shell:!0},(s,o,d)=>{r(s?{success:!1,error:s}:{success:!0})})})}catch(t){return Promise.resolve({success:!1,error:t})}else c.kill("SIGKILL");return Promise.resolve({success:!0})}function v(c=E.env){return c.comspec||"cmd.exe"}e.getWindowsShell=v;class D{constructor(l,t,r,s){if(t!==void 0&&r!==void 0&&s!==void 0)this.cmd=l,this.args=t,this.shell=r,this.options=s;else{const o=l;this.cmd=o.command,this.shell=o.isShellCommand,this.args=o.args.slice(0),this.options=o.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const o=Object.create(null);Object.keys(E.env).forEach(d=>{o[d]=E.env[d]}),Object.keys(this.options.env).forEach(d=>{o[d]=this.options.env[d]}),this.options.env=o}}getSanitizedCommand(){let l=this.cmd.toLowerCase();const t=l.lastIndexOf(m.sep);return t!==-1&&(l=l.substring(t+1)),D.WellKnowCommands[l]?l:"other"}start(l){return i.isWindows&&(this.options&&this.options.cwd&&y.isUNC(this.options.cwd)||!this.options&&y.isUNC(E.cwd()))?Promise.reject(new Error(b.localize(0,null))):this.useExec().then(t=>{let r,s;const o=new Promise((d,f)=>{r=d,s=f});if(t){let d=this.cmd;this.args&&(d=d+" "+this.args.join(" ")),this.childProcess=A.exec(d,this.options,(f,h,P)=>{this.childProcess=null;const T=f;T&&T.killed?s({killed:this.terminateRequested,stdout:h.toString(),stderr:P.toString()}):this.handleExec(r,l,f,h,P)})}else{let d=null;const f=h=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(h,r,l,s);const P={terminated:this.terminateRequested};n.isNumber(h)&&(P.cmdCode=h),r(P)};if(this.shell&&i.isWindows){const h=w.deepClone(this.options);h.windowsVerbatimArguments=!0,h.detached=!1;let P=!1,T=!1;const U=[];let q=this.ensureQuotes(this.cmd);U.push(q.value),P=q.quoted,this.args&&this.args.forEach(x=>{q=this.ensureQuotes(x),U.push(q.value),T=T&&q.quoted});const Q=["/s","/c"];P?T?Q.push('"'+U.join(" ")+'"'):U.length>1?Q.push('"'+U[0]+'" '+U.slice(1).join(" ")):Q.push('"'+U[0]+'"'):Q.push(U.join(" ")),d=A.spawn(v(),Q,h)}else this.cmd&&(d=A.spawn(this.cmd,this.args,this.options));d&&(this.childProcess=d,this.childProcessPromise=Promise.resolve(d),this.pidResolve&&(this.pidResolve(n.isNumber(d.pid)?d.pid:-1),this.pidResolve=void 0),d.on("error",h=>{this.childProcess=null,s({terminated:this.terminateRequested,error:h})}),d.pid&&(this.childProcess.on("close",f),this.handleSpawn(d,r,l,s,!0)))}return o})}handleClose(l,t,r,s){}ensureQuotes(l){return D.regexp.test(l)?{value:'"'+l+'"',quoted:!0}:{value:l,quoted:l.length>0&&l[0]==='"'&&l[l.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(l=>l.pid,l=>-1):new Promise(l=>{this.pidResolve=l})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(l=>(this.terminateRequested=!0,g(l,this.options.cwd).then(t=>(t.success&&(this.childProcess=null),t))),l=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(l=>{if(!this.shell||!i.isWindows)return l(!1);const t=A.spawn(v(),["/s","/c"]);t.on("error",r=>l(!0)),t.on("exit",r=>l(!1))})}}e.AbstractProcess=D,D.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},D.regexp=/^[^"].* .*[^"]/;class S extends D{constructor(l,t,r,s){super(l,t,r,s);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(l,t,r,s,o){[s,o].forEach((d,f)=>{const h=new I.LineDecoder;h.write(d).forEach(U=>{t({line:U,source:f===0?0:1})});const T=h.end();T&&t({line:T,source:f===0?0:1})}),l({terminated:this.terminateRequested,error:r})}handleSpawn(l,t,r,s,o){const d=new I.LineDecoder,f=new I.LineDecoder;l.stdout.on("data",h=>{d.write(h).forEach(T=>r({line:T,source:0}))}),l.stderr.on("data",h=>{f.write(h).forEach(T=>r({line:T,source:1}))}),this.stdoutLineDecoder=d,this.stderrLineDecoder=f}handleClose(l,t,r,s){const o=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;o&&r({line:o,source:0});const d=this.stderrLineDecoder?this.stderrLineDecoder.end():null;d&&r({line:d,source:1})}}e.LineProcess=S;function a(c){let l=[],t=!1;const r=function(s){if(t){l.push(s);return}(!c.send(s,d=>{if(d&&console.error(d),t=!1,l.length>0){const f=l.slice(0);l=[],f.forEach(h=>r(h))}})||i.isWindows)&&(t=!0)};return{send:r}}e.createQueuedSender=a;var u;(function(c){async function l(t,r,s){if(m.isAbsolute(t))return t;if(r===void 0&&(r=E.cwd()),m.dirname(t)!=="."||(s===void 0&&n.isString(E.env.PATH)&&(s=E.env.PATH.split(m.delimiter)),s===void 0||s.length===0))return m.join(r,t);async function d(f){return await L.exists(f)?!(await L.Promises.stat(f)).isDirectory():!1}for(let f of s){let h;if(m.isAbsolute(f)?h=m.join(f,t):h=m.join(r,f,t),await d(h))return h;let P=h+".com";if(await d(P)||(P=h+".exe",await d(P)))return P}return m.join(r,t)}c.findExecutable=l})(u=e.win32||(e.win32={}))}),define(J[130],Z([0,1,26,3,116,68]),function($,e,m,L,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function E(p,g){return p===1?L.isWindows?I():b.getWindowsShell(g):y(p,g)}e.getSystemShell=E;function n(p,g){return p===1?L.isWindows?M(g):b.getWindowsShell(g):y(p,g)}e.getSystemShellSync=n;let w=null;function y(p,g){if(L.isLinux&&p===2||L.isMacintosh&&p===3)return"/bin/bash";if(!w){let v;if(L.isWindows)v="/bin/bash";else{if(v=g.SHELL,!v)try{v=(0,m.userInfo)().shell}catch(D){}v||(v="sh"),v==="/bin/false"&&(v="/bin/bash")}w=v}return w}let i=null;async function I(){return i||(i=(await(0,A.getFirstAvailablePowerShellInstallation)()).exePath),i}function M(p){if(i)return i;const g=L.isWindows&&parseFloat((0,m.release)())>=10,v=p.hasOwnProperty("PROCESSOR_ARCHITEW6432"),D=`${p.windir}\\${v?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return g?D:b.getWindowsShell(p)}}),define(J[87],Z([0,1,40,2,9,44,5,68,33,109,25,19,20,3]),function($,e,m,L,A,b,E,n,w,y,i,I,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class g extends w.ChannelServer{constructor(S){super({send:a=>{try{process.send&&process.send(a.buffer.toString("base64"))}catch(u){}},onMessage:E.Event.fromNodeEventEmitter(process,"message",a=>M.VSBuffer.wrap(Buffer.from(a,"base64")))},S);process.once("disconnect",()=>this.dispose())}}e.Server=g;class v{constructor(S,a){this.modulePath=S,this.options=a,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new E.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const u=a&&a.timeout?a.timeout:6e4;this.disposeDelayer=new A.Delayer(u),this.child=null,this._client=null}getChannel(S){const a=this;return{call(u,c,l){return a.requestPromise(S,u,c,l)},listen(u,c){return a.requestEvent(S,u,c)}}}requestPromise(S,a,u,c=i.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(c.isCancellationRequested)return Promise.reject(I.canceled());this.disposeDelayer.cancel();const l=this.getCachedChannel(S),t=(0,A.createCancelablePromise)(o=>l.call(a,u,o)),r=c.onCancellationRequested(()=>t.cancel()),s=(0,L.toDisposable)(()=>t.cancel());return this.activeRequests.add(s),t.finally(()=>{r.dispose(),this.activeRequests.delete(s),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),t}requestEvent(S,a,u){if(!this.disposeDelayer)return E.Event.None;this.disposeDelayer.cancel();let c;const l=new E.Emitter({onFirstListenerAdd:()=>{c=this.getCachedChannel(S).listen(a,u)(l.fire,l),this.activeRequests.add(c)},onLastListenerRemove:()=>{this.activeRequests.delete(c),c.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return l.event}get client(){if(!this._client){const S=this.options&&this.options.args?this.options.args:[],a=Object.create(null);a.env=Object.assign(Object.assign({},(0,b.deepClone)(process.env)),{VSCODE_PARENT_PID:String(process.pid)}),this.options&&this.options.env&&(a.env=Object.assign(Object.assign({},a.env),this.options.env)),this.options&&this.options.freshExecArgv&&(a.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(a.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(a.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),a.execArgv===void 0&&(a.execArgv=process.execArgv.filter(d=>!/^--inspect(-brk)?=/.test(d))),p.isMacintosh&&a.env&&delete a.env.DYLD_LIBRARY_PATH,this.child=(0,m.fork)(this.modulePath,S,a);const u=new E.Emitter;E.Event.fromNodeEventEmitter(this.child,"message",d=>d)(d=>{if((0,y.isRemoteConsoleLog)(d)){(0,y.log)(d,`IPC Library: ${this.options.serverName}`);return}u.fire(M.VSBuffer.wrap(Buffer.from(d,"base64")))});const l=this.options.useQueue?(0,n.createQueuedSender)(this.child):this.child,t=d=>this.child&&this.child.connected&&l.send(d.buffer.toString("base64")),r=u.event,s={send:t,onMessage:r};this._client=new w.ChannelClient(s);const o=()=>this.disposeClient();process.once("exit",o),this.child.on("error",d=>console.warn('IPC "'+this.options.serverName+'" errored with '+d)),this.child.on("exit",(d,f)=>{process.removeListener("exit",o),this.activeRequests.forEach(h=>(0,L.dispose)(h)),this.activeRequests.clear(),d!==0&&f!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+d+" and signal "+f),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:d,signal:f})})}return this._client}getCachedChannel(S){let a=this.channels.get(S);return a||(a=this.client.getChannel(S),this.channels.set(S,a)),a}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=v}),define(J[131],Z([12,11]),function($,e){return $.create("vs/code/electron-main/app",e)}),define(J[132],Z([12,11]),function($,e){return $.create("vs/platform/configuration/common/configurationRegistry",e)}),define(J[133],Z([12,11]),function($,e){return $.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(J[134],Z([12,11]),function($,e){return $.create("vs/platform/environment/node/argv",e)}),define(J[135],Z([12,11]),function($,e){return $.create("vs/platform/environment/node/argvHelper",e)}),define(J[136],Z([12,11]),function($,e){return $.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(J[137],Z([12,11]),function($,e){return $.create("vs/platform/extensions/common/extensionValidator",e)}),define(J[138],Z([12,11]),function($,e){return $.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(J[139],Z([12,11]),function($,e){return $.create("vs/platform/files/common/fileService",e)}),define(J[140],Z([12,11]),function($,e){return $.create("vs/platform/files/common/files",e)}),define(J[141],Z([12,11]),function($,e){return $.create("vs/platform/files/common/io",e)}),define(J[142],Z([12,11]),function($,e){return $.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(J[143],Z([12,11]),function($,e){return $.create("vs/platform/issue/electron-main/issueMainService",e)}),define(J[144],Z([12,11]),function($,e){return $.create("vs/platform/menubar/electron-main/menubar",e)}),define(J[145],Z([12,11]),function($,e){return $.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(J[146],Z([12,11]),function($,e){return $.create("vs/platform/request/common/request",e)}),define(J[147],Z([12,11]),function($,e){return $.create("vs/platform/telemetry/common/telemetryService",e)}),define(J[148],Z([12,11]),function($,e){return $.create("vs/platform/update/common/update.config.contribution",e)}),define(J[149],Z([12,11]),function($,e){return $.create("vs/platform/windows/electron-main/window",e)}),define(J[150],Z([12,11]),function($,e){return $.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(J[151],Z([12,11]),function($,e){return $.create("vs/platform/workspaces/common/workspaces",e)}),define(J[152],Z([12,11]),function($,e){return $.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(J[153],Z([12,11]),function($,e){return $.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(J[154],Z([0,1,5,2]),function($,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class A{constructor(){this._onCloseEmitter=new m.Emitter,this._onReloadEmitter=new m.Emitter,this._onTerminateEmitter=new m.Emitter,this._onAttachEmitter=new m.Emitter}call(n,w,y){switch(w){case"close":return Promise.resolve(this._onCloseEmitter.fire({sessionId:y[0]}));case"reload":return Promise.resolve(this._onReloadEmitter.fire({sessionId:y[0]}));case"terminate":return Promise.resolve(this._onTerminateEmitter.fire({sessionId:y[0]}));case"attach":return Promise.resolve(this._onAttachEmitter.fire({sessionId:y[0],port:y[1],subId:y[2]}))}throw new Error("Method not implemented.")}listen(n,w,y){switch(w){case"close":return this._onCloseEmitter.event;case"reload":return this._onReloadEmitter.event;case"terminate":return this._onTerminateEmitter.event;case"attach":return this._onAttachEmitter.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=A,A.ChannelName="extensionhostdebugservice";class b extends L.Disposable{constructor(n){super();this.channel=n}reload(n){this.channel.call("reload",[n])}get onReload(){return this.channel.listen("reload")}close(n){this.channel.call("close",[n])}get onClose(){return this.channel.listen("close")}attachSession(n,w,y){this.channel.call("attach",[n,w,y])}get onAttachSession(){return this.channel.listen("attach")}terminateSession(n,w){this.channel.call("terminate",[n,w])}get onTerminateSession(){return this.channel.listen("terminate")}openExtensionDevelopmentHostWindow(n,w,y){return this.channel.call("openExtensionDevelopmentHostWindow",[n,w||{},y])}}e.ExtensionHostDebugChannelClient=b}),define(J[155],Z([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowDriverRegistryChannelClient=e.WindowDriverChannelClient=e.WindowDriverChannel=void 0;class m{constructor(E){this.driver=E}listen(E,n){throw new Error(`No event found: ${n}`)}call(E,n,w){switch(n){case"click":return this.driver.click(w[0],w[1],w[2]);case"doubleClick":return this.driver.doubleClick(w);case"setValue":return this.driver.setValue(w[0],w[1]);case"getTitle":return this.driver.getTitle();case"isActiveElement":return this.driver.isActiveElement(w);case"getElements":return this.driver.getElements(w[0],w[1]);case"getElementXY":return this.driver.getElementXY(w[0],w[1],w[2]);case"typeInEditor":return this.driver.typeInEditor(w[0],w[1]);case"getTerminalBuffer":return this.driver.getTerminalBuffer(w);case"writeInTerminal":return this.driver.writeInTerminal(w[0],w[1])}throw new Error(`Call not found: ${n}`)}}e.WindowDriverChannel=m;class L{constructor(E){this.channel=E}click(E,n,w){return this.channel.call("click",[E,n,w])}doubleClick(E){return this.channel.call("doubleClick",E)}setValue(E,n){return this.channel.call("setValue",[E,n])}getTitle(){return this.channel.call("getTitle")}isActiveElement(E){return this.channel.call("isActiveElement",E)}getElements(E,n){return this.channel.call("getElements",[E,n])}getElementXY(E,n,w){return this.channel.call("getElementXY",[E,n,w])}typeInEditor(E,n){return this.channel.call("typeInEditor",[E,n])}getTerminalBuffer(E){return this.channel.call("getTerminalBuffer",E)}writeInTerminal(E,n){return this.channel.call("writeInTerminal",[E,n])}}e.WindowDriverChannelClient=L;class A{constructor(E){this.channel=E}registerWindowDriver(E){return this.channel.call("registerWindowDriver",E)}reloadWindowDriver(E){return this.channel.call("reloadWindowDriver",E)}}e.WindowDriverRegistryChannelClient=A}),define(J[156],Z([0,1,8,15,46,125,10,7,32]),function($,e,m,L,A,b,E,n,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class y{constructor(g,v,D){this._args=g,this.paths=v,this.productService=D}get appRoot(){return(0,m.dirname)(E.FileAccess.asFileUri("",$).fsPath)}get userHome(){return n.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return n.URI.file((0,m.join)(this.userDataPath,"User"))}get tmpDir(){return n.URI.file(this.paths.tmpDir)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,L.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,L.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const g=(0,b.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,m.join)(this.userDataPath,"logs",g)}return this.args.logsPath}get userDataSyncLogResource(){return n.URI.file((0,m.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,L.joinPath)(n.URI.file((0,m.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return n.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return n.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,L.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,L.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const g=w.env.VSCODE_PORTABLE;return g?n.URI.file((0,m.join)(g,"argv.json")):(0,L.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,L.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return n.URI.file((0,m.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,m.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const g=this.args["builtin-extensions-dir"];return g?(0,m.resolve)(g):(0,m.normalize)((0,m.join)(E.FileAccess.asFileUri("",$).fsPath,"..","extensions"))}get extensionsDownloadPath(){const g=this.args["extensions-download-dir"];return g?(0,m.resolve)(g):(0,m.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const g=this.args["extensions-dir"];if(g)return(0,m.resolve)(g);const v=w.env.VSCODE_EXTENSIONS;if(v)return v;const D=w.env.VSCODE_PORTABLE;return D?(0,m.join)(D,"extensions"):(0,L.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const g=this.args.extensionDevelopmentPath;if(Array.isArray(g))return g.map(v=>/^[^:/?#]+?:\/\//.test(v)?n.URI.parse(v):n.URI.file((0,m.normalize)(v)))}get extensionDevelopmentKind(){var g;return(g=this.args.extensionDevelopmentKind)===null||g===void 0?void 0:g.map(v=>v==="ui"||v==="workspace"||v==="web"?v:"workspace")}get extensionTestsLocationURI(){const g=this.args.extensionTestsPath;if(g)return/^[^:/?#]+?:\/\//.test(g)?n.URI.parse(g):n.URI.file((0,m.normalize)(g))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const g=this.args["disable-extension"];if(g){if(typeof g=="string")return[g];if(Array.isArray(g)&&g.length>0)return g}return!1}get debugExtensionHost(){return i(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!w.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,L.joinPath)(n.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return n.URI.file((0,m.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get args(){return this._args}}he([A.memoize],y.prototype,"appRoot",null),he([A.memoize],y.prototype,"userHome",null),he([A.memoize],y.prototype,"userDataPath",null),he([A.memoize],y.prototype,"appSettingsHome",null),he([A.memoize],y.prototype,"tmpDir",null),he([A.memoize],y.prototype,"userRoamingDataHome",null),he([A.memoize],y.prototype,"settingsResource",null),he([A.memoize],y.prototype,"userDataSyncHome",null),he([A.memoize],y.prototype,"userDataSyncLogResource",null),he([A.memoize],y.prototype,"sync",null),he([A.memoize],y.prototype,"machineSettingsResource",null),he([A.memoize],y.prototype,"globalStorageHome",null),he([A.memoize],y.prototype,"workspaceStorageHome",null),he([A.memoize],y.prototype,"keybindingsResource",null),he([A.memoize],y.prototype,"keyboardLayoutResource",null),he([A.memoize],y.prototype,"argvResource",null),he([A.memoize],y.prototype,"snippetsHome",null),he([A.memoize],y.prototype,"isExtensionDevelopment",null),he([A.memoize],y.prototype,"untitledWorkspacesHome",null),he([A.memoize],y.prototype,"installSourcePath",null),he([A.memoize],y.prototype,"builtinExtensionsPath",null),he([A.memoize],y.prototype,"extensionsPath",null),he([A.memoize],y.prototype,"extensionDevelopmentLocationURI",null),he([A.memoize],y.prototype,"extensionDevelopmentKind",null),he([A.memoize],y.prototype,"extensionTestsLocationURI",null),he([A.memoize],y.prototype,"debugExtensionHost",null),he([A.memoize],y.prototype,"serviceMachineIdResource",null),he([A.memoize],y.prototype,"telemetryLogResource",null),e.AbstractNativeEnvironmentService=y;function i(p,g){return M(p["inspect-extensions"],p["inspect-brk-extensions"],5870,g,p.debugId)}e.parseExtensionHostPort=i;function I(p,g){return M(p["inspect-search"],p["inspect-brk-search"],5876,g)}e.parseSearchPort=I;function M(p,g,v,D,S){const u=Number(g||p)||(D?null:v),c=u?Boolean(!!g):!1;return{port:u,break:c,debugId:S}}}),define(J[88],Z([0,1,238,134,3]),function($,e,m,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const b={o:(0,L.localize)(0,null),e:(0,L.localize)(1,null),t:(0,L.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,L.localize)(3,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,L.localize)(4,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,L.localize)(5,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,L.localize)(6,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,L.localize)(7,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,L.localize)(8,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,L.localize)(9,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,L.localize)(10,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,L.localize)(11,null)},"extensions-dir":{type:"string",deprecates:"extensionHomePath",cat:"e",args:"dir",description:(0,L.localize)(12,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,L.localize)(13,null)},"show-versions":{type:"boolean",cat:"e",description:(0,L.localize)(14,null)},category:{type:"string",cat:"e",description:(0,L.localize)(15,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"extension-id[@version] | path-to-vsix",description:(0,L.localize)(16,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"extension-id",description:(0,L.localize)(17,null)},"enable-proposed-api":{type:"string[]",cat:"e",args:"extension-id",description:(0,L.localize)(18,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,L.localize)(19,null)},verbose:{type:"boolean",cat:"t",description:(0,L.localize)(20,null)},log:{type:"string",cat:"t",args:"level",description:(0,L.localize)(21,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,L.localize)(22,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,L.localize)(23,null)},"prof-append-timers":{type:"string"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:"disableExtensions",cat:"t",description:(0,L.localize)(24,null)},"disable-extension":{type:"string[]",cat:"t",args:"extension-id",description:(0,L.localize)(25,null)},sync:{type:"string",cat:"t",description:(0,L.localize)(26,null),args:["on","off"]},"inspect-extensions":{type:"string",deprecates:"debugPluginHost",args:"port",cat:"t",description:(0,L.localize)(27,null)},"inspect-brk-extensions":{type:"string",deprecates:"debugBrkPluginHost",args:"port",cat:"t",description:(0,L.localize)(28,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,L.localize)(29,null)},"max-memory":{type:"string",cat:"t",description:(0,L.localize)(30,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,L.localize)(31,null)},remote:{type:"string"},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-search":{type:"string",deprecates:"debugSearch"},"inspect-brk-search":{type:"string",deprecates:"debugBrkSearch"},"export-default-configuration":{type:"string"},"install-source":{type:"string"},driver:{type:"string"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"driver-verbose":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},__sandbox:{type:"boolean"},logsPath:{type:"string"},"no-proxy-server":{type:"boolean"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string"},"inspect-brk":{type:"string"},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},_:{type:"string[]"}};const E={onUnknownOption:()=>{},onMultipleValues:()=>{}};function n(g,v,D=E){const S={},a=[],u=[];for(let r in v){const s=v[r];s.alias&&(S[r]=s.alias),s.type==="string"||s.type==="string[]"?(a.push(r),s.deprecates&&a.push(s.deprecates)):s.type==="boolean"&&(u.push(r),s.deprecates&&u.push(s.deprecates))}const c=m(g,{string:a,boolean:u,alias:S}),l={},t=c;l._=c._.map(r=>String(r)).filter(r=>r.length>0),delete t._;for(let r in v){const s=v[r];s.alias&&delete t[s.alias];let o=t[r];s.deprecates&&t.hasOwnProperty(s.deprecates)&&(o||(o=t[s.deprecates]),delete t[s.deprecates]),typeof o!="undefined"&&(s.type==="string[]"?o&&!Array.isArray(o)&&(o=[o]):s.type==="string"&&Array.isArray(o)&&(o=o.pop(),D.onMultipleValues(r,o)),l[r]=o),delete t[r]}for(let r in t)D.onUnknownOption(r);return l}e.parseArgs=n;function w(g,v){let D="";return v.args&&(Array.isArray(v.args)?D=` <${v.args.join("> <")}>`:D=` <${v.args}>`),v.alias?`-${v.alias} --${g}${D}`:`--${g}${D}`}function y(g,v){let D=0,S=[];for(const l in g){const t=g[l],r=w(l,t);D=Math.max(D,r.length),S.push([r,t.description])}let a=D+2+1;if(v-a<25)return S.reduce((l,t)=>l.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);let u=v-a-1,c=[];for(const l of S){let t=l[0],r=I(l[1],u),s=i(a-t.length-2);c.push("  "+t+s+r[0]);for(let o=1;o<r.length;o++)c.push(i(a)+r[o])}return c}e.formatOptions=y;function i(g){return" ".repeat(g)}function I(g,v){let D=[];for(;g.length;){let S=g.length<v?g.length:g.lastIndexOf(" ",v),a=g.slice(0,S).trim();g=g.slice(S),D.push(a)}return D}function M(g,v,D,S,a=!0){const u=process.stdout.isTTY&&process.stdout.columns||80;let c=[`${g} ${D}`];c.push(""),c.push(`${(0,L.localize)(32,null)}: ${v} [${(0,L.localize)(33,null)}][${(0,L.localize)(34,null)}...]`),c.push(""),a&&(A.isWindows?c.push((0,L.localize)(35,null,v)):c.push((0,L.localize)(36,null,v)),c.push(""));const l={};for(const t in S){const r=S[t];if(r.description&&r.cat){let s=l[r.cat];s||(l[r.cat]=s={}),s[t]=r}}for(let t in l){const r=t;let s=l[r];s&&(c.push(b[r]),c.push(...y(s,u)),c.push(""))}return c.join(`
`)}e.buildHelpMessage=M;function p(g,v){return`${g||(0,L.localize)(37,null)}
${v||(0,L.localize)(38,null)}
${process.arch}`}e.buildVersionMessage=p}),define(J[157],Z([0,1,88,59,154]),function($,e,m,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronExtensionHostDebugBroadcastChannel=void 0;class b extends A.ExtensionHostDebugBroadcastChannel{constructor(n){super();this.windowsMainService=n}call(n,w,y){return w==="openExtensionDevelopmentHostWindow"?this.openExtensionDevelopmentHostWindow(y[0],y[1],y[2]):super.call(n,w,y)}async openExtensionDevelopmentHostWindow(n,w,y){const i=(0,m.parseArgs)(n,m.OPTIONS);i.debugRenderer=y;const I=i.extensionDevelopmentPath;if(!I)return{success:!1};let M;const p=Object.keys(w);for(let u of p){let c=w[u];c===null||(M||(M=Object.create(null)),M[u]=c)}const[g]=this.windowsMainService.openExtensionDevelopmentHostWindow(I,{context:5,cli:i,userEnv:M});if(!y)return{success:!0};const v=g.win;if(!v)return{success:!0};const D=v.webContents.debugger;let S=D.isAttached()?Infinity:0;const a=(0,L.createServer)(u=>{S++==0&&D.attach();let c=!1;const l=s=>{c||u.write(JSON.stringify(s)+"\0")},t=(s,o,d,f)=>l({method:o,params:d,sessionId:f});v.on("close",()=>{D.removeListener("message",t),u.end(),c=!0}),D.addListener("message",t);let r=Buffer.alloc(0);u.on("data",s=>{r=Buffer.concat([r,s]);for(let o=r.indexOf(0);o!==-1;o=r.indexOf(0)){let d;try{const f=r.slice(0,o).toString("utf8");r=r.slice(o+1),d=JSON.parse(f)}catch(f){console.error("error reading cdp line",f)}D.sendCommand(d.method,d.params,d.sessionId).then(f=>l({id:d.id,sessionId:d.sessionId,result:f})).catch(f=>l({id:d.id,sessionId:d.sessionId,error:{code:0,message:f.message}}))}}),u.on("error",s=>{console.error("error on cdp pipe:",s)}),u.on("close",()=>{c=!0,--S==0&&D.detach()})});return await new Promise(u=>a.listen(0,u)),v.on("close",()=>a.close()),{rendererDebugPort:a.address().port,success:!0}}}e.ElectronExtensionHostDebugBroadcastChannel=b}),function(){"use strict";function $(e,m,L,A){function b(n){const w=E(n),y=[w];return e.isAbsolute(w)||y.unshift(A),e.resolve(...y)}function E(n){const w=process.env.VSCODE_PORTABLE;if(w)return e.join(w,"user-data");const y=n["user-data-dir"];if(y)return y;let i=process.env.VSCODE_APPDATA;if(!i)switch(process.platform){case"win32":if(i=process.env.APPDATA,!i){const I=process.env.USERPROFILE;if(typeof I!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");i=e.join(I,"AppData","Roaming")}break;case"darwin":i=e.join(m.homedir(),"Library","Application Support");break;case"linux":i=process.env.XDG_CONFIG_HOME||e.join(m.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(i,L)}return{getUserDataPath:b}}if(typeof define=="function")define(J[158],Z([0,159,26,10,15,32]),function(e,m,L,A,b,E){const n=b.dirname(A.FileAccess.asFileUri("",e)),w=e.__$__nodeRequire(b.joinPath(n,"package.json").fsPath);return $(m,L,w.name,E.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),m=require("path"),L=require("os");module.exports=$(m,L,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(J[160],Z([0,1,26,158,156]),function($,e,m,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class b extends A.AbstractNativeEnvironmentService{constructor(n,w){super(n,{homeDir:(0,m.homedir)(),tmpDir:(0,m.tmpdir)(),userDataDir:(0,L.getUserDataPath)(n)},w)}}e.NativeEnvironmentService=b}),define(J[161],Z([0,1,29,26,8]),function($,e,m,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createWaitMarkerFile=void 0;function b(E){const n=(0,A.join)((0,L.tmpdir)(),Math.random().toString(36).replace(/[^a-z]+/g,"").substr(0,10));try{return m.writeFileSync(n,""),E&&console.log(`Marker file for --wait created: ${n}`),n}catch(w){E&&console.error(`Failed to create marker file for --wait: ${w}`);return}}e.createWaitMarkerFile=b}),define(J[162],Z([0,1,137]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const L=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,A=/^-(\d{4})(\d{2})(\d{2})$/;function b(M){return M=M.trim(),M==="*"||L.test(M)}e.isValidVersionStr=b;function E(M){if(!b(M))return null;if(M=M.trim(),M==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let p=M.match(L);return p?{hasCaret:p[1]==="^",hasGreaterEquals:p[1]===">=",majorBase:p[2]==="x"?0:parseInt(p[2],10),majorMustEqual:p[2]!=="x",minorBase:p[4]==="x"?0:parseInt(p[4],10),minorMustEqual:p[4]!=="x",patchBase:p[6]==="x"?0:parseInt(p[6],10),patchMustEqual:p[6]!=="x",preRelease:p[8]||null}:null}e.parseVersion=E;function n(M){if(!M)return null;let p=M.majorBase,g=M.majorMustEqual,v=M.minorBase,D=M.minorMustEqual,S=M.patchBase,a=M.patchMustEqual;M.hasCaret&&(p===0||(D=!1),a=!1);let u=0;if(M.preRelease){const c=A.exec(M.preRelease);if(c){const[,l,t,r]=c;u=Date.UTC(Number(l),Number(t)-1,Number(r))}}return{majorBase:p,majorMustEqual:g,minorBase:v,minorMustEqual:D,patchBase:S,patchMustEqual:a,isMinimum:M.hasGreaterEquals,notBefore:u}}e.normalizeVersion=n;function w(M,p,g){let v;typeof M=="string"?v=n(E(M)):v=M;let D;p instanceof Date?D=p.getTime():typeof p=="string"&&(D=new Date(p).getTime());let S;if(typeof g=="string"?S=n(E(g)):S=g,!v||!S)return!1;let a=v.majorBase,u=v.minorBase,c=v.patchBase,l=S.majorBase,t=S.minorBase,r=S.patchBase,s=S.notBefore,o=S.majorMustEqual,d=S.minorMustEqual,f=S.patchMustEqual;return S.isMinimum?a>l?!0:a<l?!1:u>t?!0:u<t||D&&D<s?!1:c>=r:(a===1&&l===0&&(!o||!d||!f)&&(l=1,t=0,r=0,o=!0,d=!1,f=!1),a<l?!1:a>l?!o:u<t?!1:u>t?!d:c<r?!1:c>r?!f:!(D&&D<s))}e.isValidVersion=w;function y(M,p,g,v){return g.isBuiltin||typeof g.main=="undefined"?!0:I(M,p,g.engines.vscode,v)}e.isValidExtensionVersion=y;function i(M,p,g){return M==="*"||I(p,g,M)}e.isEngineValid=i;function I(M,p,g,v=[]){let D=n(E(g));if(!D)return v.push(m.localize(0,null,g)),!1;if(D.majorBase===0){if(!D.majorMustEqual||!D.minorMustEqual)return v.push(m.localize(1,null,g)),!1}else if(!D.majorMustEqual)return v.push(m.localize(2,null,g)),!1;return w(M,p,D)?!0:(v.push(m.localize(3,null,M,g)),!1)}}),define(J[163],Z([0,1,33,87,2,10]),function($,e,m,L,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class E extends A.Disposable{constructor(w,y,i,I){super();this.folders=w,this.onDidFilesChange=y,this.onLogMessage=i,this.verboseLogging=I,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const w=this._register(new L.Client(b.FileAccess.asFileUri("bootstrap-fork",$).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(w.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=E.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=m.ProxyChannel.toService((0,m.getNextTickChannel)(w.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(y=>!this.isDisposed&&this.onDidFilesChange(y))),this._register(this.service.onDidLogMessage(y=>this.onLogMessage(y))),this.setFolders(this.folders)}setVerboseLogging(w){this.verboseLogging=w,!this.isDisposed&&this.service&&this.service.setVerboseLogging(w)}error(w){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${w}`})}setFolders(w){this.folders=w,this.service&&this.service.setRoots(w)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=E,E.MAX_RESTARTS=5}),define(J[164],Z([0,1,33,87,2,10]),function($,e,m,L,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class E extends A.Disposable{constructor(w,y,i,I,M={}){super();this.folders=w,this.onDidFilesChange=y,this.onLogMessage=i,this.verboseLogging=I,this.watcherOptions=M,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const w=this._register(new L.Client(b.FileAccess.asFileUri("bootstrap-fork",$).fsPath,{serverName:"File Watcher (chokidar)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/unix/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(w.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=E.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=m.ProxyChannel.toService((0,m.getNextTickChannel)(w.getChannel("watcher"))),this.service.init(Object.assign(Object.assign({},this.watcherOptions),{verboseLogging:this.verboseLogging})),this._register(this.service.onDidChangeFile(y=>!this.isDisposed&&this.onDidFilesChange(y))),this._register(this.service.onDidLogMessage(y=>this.onLogMessage(y))),this.service.setRoots(this.folders)}error(w){this.onLogMessage({type:"error",message:`[File Watcher (chokidar)] ${w}`})}setVerboseLogging(w){this.verboseLogging=w,this.service&&this.service.setVerboseLogging(w)}setFolders(w){this.folders=w,this.service&&this.service.setRoots(w)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=E,E.MAX_RESTARTS=5}),define(J[165],Z([0,1,40,81,111,10]),function($,e,m,L,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutOfProcessWin32FolderWatcher=void 0;class E{constructor(w,y,i,I,M){this.watchedFolder=w,this.eventCallback=i,this.logCallback=I,this.verboseLogging=M,this.restartCounter=0,Array.isArray(y)?this.ignored=y.map(p=>A.parse(p)):this.ignored=[],this.verboseLogging&&this.log(`Start watching: ${w}`),this.startWatcher()}startWatcher(){const w=[this.watchedFolder];this.verboseLogging&&w.push("-verbose"),this.handle=m.spawn(b.FileAccess.asFileUri("vs/platform/files/node/watcher/win32/CodeHelper.exe",$).fsPath,w);const y=new L.LineDecoder;this.handle.stdout.on("data",i=>{const I=[];y.write(i).forEach(M=>{const p=M.split("|");if(p.length===2){const g=Number(p[0]),v=p[1];if(g>=0&&g<3){if(this.ignored&&this.ignored.some(D=>D(v))){this.verboseLogging&&this.log(v);return}I.push({type:E.changeTypeMap[g],path:v})}else this.log(p[1])}}),I.length>0&&this.eventCallback(I)}),this.handle.on("error",i=>this.onError(i)),this.handle.stderr.on("data",i=>this.onError(i)),this.handle.on("exit",(i,I)=>this.onExit(i,I))}onError(w){this.error("process error: "+w.toString())}onExit(w,y){this.handle&&(this.error(`terminated unexpectedly (code: ${w}, signal: ${y})`),this.restartCounter<=E.MAX_RESTARTS?(this.error("is restarted again..."),this.restartCounter++,this.startWatcher()):this.error("Watcher failed to start after retrying for some time, giving up. Please report this as a bug report!"))}error(w){this.logCallback({type:"error",message:`[File Watcher (C#)] ${w}`})}log(w){this.logCallback({type:"trace",message:`[File Watcher (C#)] ${w}`})}dispose(){this.handle&&(this.handle.kill(),this.handle=void 0)}}e.OutOfProcessWin32FolderWatcher=E,E.MAX_RESTARTS=5,E.changeTypeMap=[0,1,2]}),define(J[166],Z([0,1,165,8,23]),function($,e,m,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class b{constructor(n,w,y,i){this.onDidFilesChange=w,this.onLogMessage=y,this.verboseLogging=i,this.service=void 0,this.folder=n[0],this.folder.path.indexOf("\\\\")===0&&this.folder.path.endsWith(L.posix.sep)&&(this.folder.path=(0,A.rtrim)(this.folder.path,L.posix.sep)),this.service=this.startWatching()}get isDisposed(){return!this.service}startWatching(){return new m.OutOfProcessWin32FolderWatcher(this.folder.path,this.folder.excludes,n=>this.onFileEvents(n),n=>this.onLogMessage(n),this.verboseLogging)}setVerboseLogging(n){this.verboseLogging=n,this.service&&(this.service.dispose(),this.service=this.startWatching())}onFileEvents(n){this.isDisposed||n.length>0&&this.onDidFilesChange(n)}dispose(){this.service&&(this.service.dispose(),this.service=void 0)}}e.FileWatcher=b}),define(J[69],Z([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSyncDescriptor=e.SyncDescriptor=void 0;class m{constructor(b,E=[],n=!1){this.ctor=b,this.staticArguments=E,this.supportsDelayedInstantiation=n}}e.SyncDescriptor=m;const L=(A,...b)=>new m(A,b);e.createSyncDescriptor=L}),define(J[167],Z([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class m{constructor(b){this.incoming=new Map,this.outgoing=new Map,this.data=b}}e.Node=m;class L{constructor(b){this._hashFn=b,this._nodes=new Map}roots(){const b=[];for(let E of this._nodes.values())E.outgoing.size===0&&b.push(E);return b}insertEdge(b,E){const n=this.lookupOrInsertNode(b),w=this.lookupOrInsertNode(E);n.outgoing.set(this._hashFn(E),w),w.incoming.set(this._hashFn(b),n)}removeNode(b){const E=this._hashFn(b);this._nodes.delete(E);for(let n of this._nodes.values())n.outgoing.delete(E),n.incoming.delete(E)}lookupOrInsertNode(b){const E=this._hashFn(b);let n=this._nodes.get(E);return n||(n=new m(b),this._nodes.set(E,n)),n}lookup(b){return this._nodes.get(this._hashFn(b))}isEmpty(){return this._nodes.size===0}toString(){let b=[];for(let[E,n]of this._nodes)b.push(`${E}, (incoming)[${[...n.incoming.keys()].join(", ")}], (outgoing)[${[...n.outgoing.keys()].join(",")}]`);return b.join(`
`)}findCycleSlow(){for(let[b,E]of this._nodes){const n=new Set([b]),w=this._findCycle(E,n);if(w)return w}}_findCycle(b,E){for(let[n,w]of b.outgoing){if(E.has(n))return[...E,n].join(" -> ");E.add(n);const y=this._findCycle(w,E);if(y)return y;E.delete(n)}}}e.Graph=L}),define(J[4],Z([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var m;(function(n){n.serviceIds=new Map,n.DI_TARGET="$di$target",n.DI_DEPENDENCIES="$di$dependencies";function w(y){return y[n.DI_DEPENDENCIES]||[]}n.getServiceDependencies=w})(m=e._util||(e._util={})),e.IInstantiationService=A("instantiationService");function L(n,w,y,i){w[m.DI_TARGET]===w?w[m.DI_DEPENDENCIES].push({id:n,index:y,optional:i}):(w[m.DI_DEPENDENCIES]=[{id:n,index:y,optional:i}],w[m.DI_TARGET]=w)}function A(n){if(m.serviceIds.has(n))return m.serviceIds.get(n);const w=function(y,i,I){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");L(w,y,I,!1)};return w.toString=()=>n,m.serviceIds.set(n,w),w}e.createDecorator=A;function b(n){return n}e.refineServiceDecorator=b;function E(n){return function(w,y,i){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");L(n,w,i,!0)}}e.optional=E}),define(J[70],Z([0,1,4]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,m.createDecorator)(e.ID);function L(A){return!!A.hostName&&!!A.errorMessage}e.isRemoteDiagnosticError=L}),define(J[89],Z([0,1,4]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=e.IEncryptionMainService=void 0,e.IEncryptionMainService=(0,m.createDecorator)("encryptionMainService");class L{constructor(b){this.machineId=b}encryption(){return new Promise((b,E)=>$(["vscode-encrypt"],b,E))}async encrypt(b){try{return(await this.encryption()).encrypt(this.machineId,b)}catch(E){return b}}async decrypt(b){try{return(await this.encryption()).decrypt(this.machineId,b)}catch(E){return b}}}e.EncryptionMainService=L}),define(J[53],Z([0,1,4]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,m.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,m.refineServiceDecorator)(e.IEnvironmentService)}),define(J[168],Z([0,1,136,4,10]),function($,e,m,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.INSTALL_ERROR_NOT_SUPPORTED=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN);function b(I){return I&&typeof I=="object"&&typeof I.id=="string"&&(!I.uuid||typeof I.uuid=="string")}e.isIExtensionIdentifier=b;var E;(function(I){I[I.NoneOrRelevance=0]="NoneOrRelevance",I[I.LastUpdatedDate=1]="LastUpdatedDate",I[I.Title=2]="Title",I[I.PublisherName=3]="PublisherName",I[I.InstallCount=4]="InstallCount",I[I.PublishedDate=5]="PublishedDate",I[I.AverageRating=6]="AverageRating",I[I.WeightedRating=12]="WeightedRating"})(E=e.SortBy||(e.SortBy={}));var n;(function(I){I[I.Default=0]="Default",I[I.Ascending=1]="Ascending",I[I.Descending=2]="Descending"})(n=e.SortOrder||(e.SortOrder={}));var w;(function(I){I.Uninstall="uninstall"})(w=e.StatisticType||(e.StatisticType={}));var y;(function(I){I[I.None=0]="None",I[I.Install=1]="Install",I[I.Update=2]="Update"})(y=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,L.createDecorator)("extensionGalleryService"),e.INSTALL_ERROR_NOT_SUPPORTED="notsupported",e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class i extends Error{constructor(M,p){super(M);this.code=p}}e.ExtensionManagementError=i,e.IExtensionManagementService=(0,L.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,L.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,L.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=A.FileAccess.asBrowserUri("./media/defaultIcon.png",$).toString(!0),e.ExtensionsLabel=(0,m.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,m.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,L.createDecorator)("IExtensionManagementCLIService")}),define(J[169],Z([0,1,4]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionUrlTrustService=void 0,e.IExtensionUrlTrustService=(0,m.createDecorator)("extensionUrlTrustService")}),define(J[170],Z([0,1,23,4]),function($,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkpaceSupportTypeMessage=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin";function A(i){if(typeof i=="object"&&i!==null&&i.supported!==!0)return i.description}e.getWorkpaceSupportTypeMessage=A;function b(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(!i.uuid||typeof i.uuid=="string")}e.isIExtensionIdentifier=b,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var E;(function(i){i[i.System=0]="System",i[i.User=1]="User"})(E=e.ExtensionType||(e.ExtensionType={}));class n{constructor(I){this.value=I,this._lower=I.toLowerCase()}static equals(I,M){if(typeof I=="undefined"||I===null)return typeof M=="undefined"||M===null;if(typeof M=="undefined"||M===null)return!1;if(typeof I=="string"||typeof M=="string"){let p=typeof I=="string"?I:I.value,g=typeof M=="string"?M:M.value;return m.equalsIgnoreCase(p,g)}return I._lower===M._lower}static toKey(I){return typeof I=="string"?I.toLowerCase():I._lower}}e.ExtensionIdentifier=n;function w(i){return i.contributes&&i.contributes.localizations?i.contributes.localizations.length>0:!1}e.isLanguagePackExtension=w;function y(i){return i.contributes&&i.contributes.authentication?i.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=y,e.IBuiltinExtensionsScannerService=(0,L.createDecorator)("IBuiltinExtensionsScannerService")}),define(J[171],Z([0,1,23,170]),function($,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function A(p,g){return p.uuid&&g.uuid?p.uuid===g.uuid:p.id===g.id?!0:(0,m.compareIgnoreCase)(p.id,g.id)===0}e.areSameExtensions=A;class b{constructor(g,v){this.version=v,this.id=g.id,this.uuid=g.uuid}key(){return`${this.id}-${this.version}`}equals(g){return g instanceof b?A(this,g)&&this.version===g.version:!1}}e.ExtensionIdentifierWithVersion=b;function E(p,g){return`${p}.${g}`}e.getExtensionId=E;function n(p){return p.toLocaleLowerCase()}e.adoptToGalleryExtensionId=n;function w(p,g){return n(E(p,g))}e.getGalleryExtensionId=w;function y(p,g){const v=[],D=S=>{for(const a of v)if(a.some(u=>A(g(u),g(S))))return a;return null};for(const S of p){const a=D(S);a?a.push(S):v.push([S])}return v}e.groupByExtension=y;function i(p){return{id:p.identifier.id,name:p.manifest.name,galleryId:null,publisherId:p.publisherId,publisherName:p.manifest.publisher,publisherDisplayName:p.publisherDisplayName,dependencies:p.manifest.extensionDependencies&&p.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=i;function I(p){return Object.assign({id:p.identifier.id,name:p.name,galleryId:p.identifier.uuid,publisherId:p.publisherId,publisherName:p.publisher,publisherDisplayName:p.publisherDisplayName,dependencies:!!(p.properties.dependencies&&p.properties.dependencies.length>0)},p.telemetryData)}e.getGalleryExtensionTelemetryData=I,e.BetterMergeId=new L.ExtensionIdentifier("pprice.better-merge");function M(p){const g=new Set;for(const v of p)v.malicious&&g.add(v.id.id);return g}e.getMaliciousExtensionsSet=M}),define(J[90],Z([0,1,4]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,m.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,m.createDecorator)("externalTerminal")}),define(J[21],Z([0,1,140,8,7,4,23,13,36]),function($,e,m,L,A,b,E,n,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,b.createDecorator)("fileService");function y(B){return B.create===!0}e.isFileOpenForWriteOptions=y;var i;(function(B){B[B.Unknown=0]="Unknown",B[B.File=1]="File",B[B.Directory=2]="Directory",B[B.SymbolicLink=64]="SymbolicLink"})(i=e.FileType||(e.FileType={}));var I;(function(B){B[B.Readonly=1]="Readonly"})(I=e.FilePermission||(e.FilePermission={}));var M;(function(B){B[B.FileReadWrite=2]="FileReadWrite",B[B.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",B[B.FileReadStream=16]="FileReadStream",B[B.FileFolderCopy=8]="FileFolderCopy",B[B.PathCaseSensitive=1024]="PathCaseSensitive",B[B.Readonly=2048]="Readonly",B[B.Trash=4096]="Trash",B[B.FileWriteUnlock=8192]="FileWriteUnlock"})(M=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function p(B){return!!(B.capabilities&2)}e.hasReadWriteCapability=p;function g(B){return!!(B.capabilities&8)}e.hasFileFolderCopyCapability=g;function v(B){return!!(B.capabilities&4)}e.hasOpenReadWriteCloseCapability=v;function D(B){return!!(B.capabilities&16)}e.hasFileReadStreamCapability=D;var S;(function(B){B.FileExists="EntryExists",B.FileNotFound="EntryNotFound",B.FileNotADirectory="EntryNotADirectory",B.FileIsADirectory="EntryIsADirectory",B.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",B.FileTooLarge="EntryTooLarge",B.FileWriteLocked="EntryWriteLocked",B.NoPermissions="NoPermissions",B.Unavailable="Unavailable",B.Unknown="Unknown"})(S=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class a extends Error{constructor(V,N){super(V);this.code=N}}e.FileSystemProviderError=a;function u(B,V){const N=new a(B.toString(),V);return l(N,V),N}e.createFileSystemProviderError=u;function c(B){return B||u((0,m.localize)(0,null),S.Unknown)}e.ensureFileSystemProviderError=c;function l(B,V){return B.name=V?`${V} (FileSystemError)`:"FileSystemError",B}e.markAsFileSystemProviderError=l;function t(B){if(!B)return S.Unknown;if(B instanceof a)return B.code;const V=/^(.+) \(FileSystemError\)$/.exec(B.name);if(!V)return S.Unknown;switch(V[1]){case S.FileExists:return S.FileExists;case S.FileIsADirectory:return S.FileIsADirectory;case S.FileNotADirectory:return S.FileNotADirectory;case S.FileNotFound:return S.FileNotFound;case S.FileExceedsMemoryLimit:return S.FileExceedsMemoryLimit;case S.FileTooLarge:return S.FileTooLarge;case S.FileWriteLocked:return S.FileWriteLocked;case S.NoPermissions:return S.NoPermissions;case S.Unavailable:return S.Unavailable}return S.Unknown}e.toFileSystemProviderErrorCode=t;function r(B){if(B instanceof P)return B.fileOperationResult;switch(t(B)){case S.FileNotFound:return 1;case S.FileIsADirectory:return 0;case S.FileNotADirectory:return 10;case S.FileWriteLocked:return 5;case S.NoPermissions:return 6;case S.FileExists:return 4;case S.FileExceedsMemoryLimit:return 9;case S.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=r;var s;(function(B){B[B.CREATE=0]="CREATE",B[B.DELETE=1]="DELETE",B[B.MOVE=2]="MOVE",B[B.COPY=3]="COPY"})(s=e.FileOperation||(e.FileOperation={}));class o{constructor(V,N,C){this.resource=V,this.operation=N,this.target=C}isOperation(V){return this.operation===V}}e.FileOperationEvent=o;var d;(function(B){B[B.UPDATED=0]="UPDATED",B[B.ADDED=1]="ADDED",B[B.DELETED=2]="DELETED"})(d=e.FileChangeType||(e.FileChangeType={}));class f{constructor(V,N){this.ignorePathCasing=N,this.added=void 0,this.updated=void 0,this.deleted=void 0,this.changes=V;for(const C of V)switch(C.type){case 1:this.added||(this.added=w.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.added.set(C.resource,C);break;case 0:this.updated||(this.updated=w.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.updated.set(C.resource,C);break;case 2:this.deleted||(this.deleted=w.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.deleted.set(C.resource,C);break}}contains(V,...N){return this.doContains(V,{includeChildren:!1},...N)}affects(V,...N){return this.doContains(V,{includeChildren:!0},...N)}doContains(V,N,...C){var z,F,R,W,k,O;if(!V)return!1;const _=C.length>0;return!!((!_||C.includes(1))&&(((z=this.added)===null||z===void 0?void 0:z.get(V))||N.includeChildren&&((F=this.added)===null||F===void 0?void 0:F.findSuperstr(V)))||(!_||C.includes(0))&&(((R=this.updated)===null||R===void 0?void 0:R.get(V))||N.includeChildren&&((W=this.updated)===null||W===void 0?void 0:W.findSuperstr(V)))||(!_||C.includes(2))&&(((k=this.deleted)===null||k===void 0?void 0:k.findSubstr(V))||N.includeChildren&&((O=this.deleted)===null||O===void 0?void 0:O.findSuperstr(V))))}getAdded(){return this.getOfType(1)}gotAdded(){return!!this.added}getDeleted(){return this.getOfType(2)}gotDeleted(){return!!this.deleted}getUpdated(){return this.getOfType(0)}gotUpdated(){return!!this.updated}getOfType(V){const N=[],C=V===1?this.added:V===0?this.updated:this.deleted;if(C)for(const[,z]of C)N.push(z);return N}filter(V){return new f(this.changes.filter(N=>V(N)),this.ignorePathCasing)}}e.FileChangesEvent=f;function h(B,V,N){return!B||!V||B===V||V.length>B.length?!1:(V.charAt(V.length-1)!==L.sep&&(V+=L.sep),N?(0,E.startsWithIgnoreCase)(B,V):B.indexOf(V)===0)}e.isParent=h;class P extends Error{constructor(V,N,C){super(V);this.fileOperationResult=N,this.options=C}static isFileOperationError(V){return V instanceof Error&&!(0,n.isUndefinedOrNull)(V.fileOperationResult)}}e.FileOperationError=P;var T;(function(B){B[B.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",B[B.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",B[B.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",B[B.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",B[B.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",B[B.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",B[B.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",B[B.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",B[B.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",B[B.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",B[B.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",B[B.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(T=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var U;(function(B){B[B.FILE=0]="FILE",B[B.FOLDER=1]="FOLDER",B[B.ROOT_FOLDER=2]="ROOT_FOLDER"})(U=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function q(B){if(!(typeof B.size!="number"||typeof B.mtime!="number"))return B.mtime.toString(29)+B.size.toString(31)}e.etag=q;async function Q(B,V){if(!V.canHandleResource(A.URI.from({scheme:B.scheme})))return new Promise(N=>{const C=V.onDidChangeFileSystemProviderRegistrations(z=>{z.scheme===B.scheme&&z.added&&(C.dispose(),N())})})}e.whenProviderRegistered=Q,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class x{static formatSize(V){return(0,n.isNumber)(V)||(V=0),V<x.KB?(0,m.localize)(1,null,V.toFixed(0)):V<x.MB?(0,m.localize)(2,null,(V/x.KB).toFixed(2)):V<x.GB?(0,m.localize)(3,null,(V/x.MB).toFixed(2)):V<x.TB?(0,m.localize)(4,null,(V/x.GB).toFixed(2)):(0,m.localize)(5,null,(V/x.TB).toFixed(2))}}e.ByteSize=x,x.KB=1024,x.MB=x.KB*x.KB,x.GB=x.MB*x.KB,x.TB=x.GB*x.KB;var j;(function(B){B[B.IA32=0]="IA32",B[B.OTHER=1]="OTHER"})(j=e.Arch||(e.Arch={}));function X(B){return{maxFileSize:B===0?300*x.MB:16*x.GB,maxHeapSize:B===0?700*x.MB:2*700*x.MB}}e.getPlatformLimits=X}),define(J[54],Z([0,1,239,135,21,88]),function($,e,m,L,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;function E(M,p){const g={onUnknownOption:D=>{console.warn((0,L.localize)(0,null,D))},onMultipleValues:(D,S)=>{console.warn((0,L.localize)(1,null,D,S))}},v=(0,b.parseArgs)(M,b.OPTIONS,p?g:void 0);return v.goto&&v._.forEach(D=>m(/^(\w:)?[^:]+(:\d*){0,2}$/.test(D),(0,L.localize)(2,null))),v["max-memory"]&&m(parseInt(v["max-memory"])>=A.MIN_MAX_MEMORY_SIZE_MB,`The max-memory argument cannot be specified lower than ${A.MIN_MAX_MEMORY_SIZE_MB} MB.`),v}function n(M){const p=M.findIndex(g=>!/^-/.test(g));if(p>-1)return[...M.slice(0,p),...M.slice(p+1)]}function w(M){let[,...p]=M;process.env.VSCODE_DEV&&(p=n(p)||[]);const g=!I(process.env);return E(p,g)}e.parseMainProcessArgv=w;function y(M){const[,,...p]=M;return E(p,!0)}e.parseCLIProcessArgv=y;function i(M,...p){const g=M.indexOf("--");return g===-1?M.push(...p):M.splice(g,0,...p),M}e.addArg=i;function I(M){return M.VSCODE_CLI==="1"}e.isLaunchedFromCli=I}),define(J[91],Z([0,1,159,40,27,3,54,67,130]),function($,e,m,L,A,b,E,n,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveShellEnv=void 0;async function y(M,p,g){return p["force-disable-user-env"]?(M.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):b.isWindows?(M.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,E.isLaunchedFromCli)(g)&&!p["force-user-env"]?(M.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,E.isLaunchedFromCli)(g)?M.trace("resolveShellEnv(): running (--force-user-env)"):M.trace("resolveShellEnv(): running (macOS/Linux)"),i||(i=I(M)),i)}e.resolveShellEnv=y;let i;async function I(M){const p=new Promise(async(g,v)=>{const D=process.env.ELECTRON_RUN_AS_NODE;M.trace("getUnixShellEnvironment#runAsNode",D);const S=process.env.ELECTRON_NO_ATTACH_CONSOLE;M.trace("getUnixShellEnvironment#noAttach",S);const a=(0,A.generateUuid)().replace(/-/g,"").substr(0,12),u=new RegExp(a+"(.*)"+a),c=Object.assign(Object.assign({},process.env),{ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"});M.trace("getUnixShellEnvironment#env",c);const l=await(0,w.getSystemShell)(b.OS,c);M.trace("getUnixShellEnvironment#shell",l);const t=m.basename(l);let r,s;/^pwsh(-preview)?$/.test(t)?(r=`& '${process.execPath}' -p '''${a}'' + JSON.stringify(process.env) + ''${a}'''`,s=["-Login","-Command"]):(r=`'${process.execPath}' -p '"${a}" + JSON.stringify(process.env) + "${a}"'`,s=["-ilc"]),M.trace("getUnixShellEnvironment#spawn",JSON.stringify(s),r);const o=(0,L.spawn)(l,[...s,r],{detached:!0,stdio:["ignore","pipe","pipe"],env:c});o.on("error",h=>{M.error("getUnixShellEnvironment#errorChildProcess",(0,n.toErrorMessage)(h)),g({})});const d=[];o.stdout.on("data",h=>d.push(h));const f=[];o.stderr.on("data",h=>f.push(h)),o.on("close",(h,P)=>{const T=Buffer.concat(d).toString("utf8");M.trace("getUnixShellEnvironment#raw",T);const U=Buffer.concat(f).toString("utf8");if(U.trim()&&M.trace("getUnixShellEnvironment#stderr",U),h||P)return v(new Error(`Failed to get environment (code ${h}, signal ${P})`));const q=u.exec(T),Q=q?q[1]:"{}";try{const x=JSON.parse(Q);D?x.ELECTRON_RUN_AS_NODE=D:delete x.ELECTRON_RUN_AS_NODE,S?x.ELECTRON_NO_ATTACH_CONSOLE=S:delete x.ELECTRON_NO_ATTACH_CONSOLE,delete x.XDG_RUNTIME_DIR,M.trace("getUnixShellEnvironment#result",x),g(x)}catch(x){M.error("getUnixShellEnvironment#errorCaught",(0,n.toErrorMessage)(x)),v(x)}})});try{return await p}catch(g){return M.error("getUnixShellEnvironment#error",(0,n.toErrorMessage)(g)),{}}}}),define(J[92],Z([0,1,7,21,3]),function($,e,m,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeFileChanges=e.toFileChanges=void 0;function b(w){return w.map(y=>({type:y.type,resource:m.URI.file(y.path)}))}e.toFileChanges=b;function E(w){const y=new n;for(const i of w)y.processEvent(i);return y.normalize()}e.normalizeFileChanges=E;class n{constructor(){this.normalized=[],this.mapPathToChange=new Map}processEvent(y){const i=this.mapPathToChange.get(y.path);if(i){const I=i.type,M=y.type;I===1&&M===2?(this.mapPathToChange.delete(y.path),this.normalized.splice(this.normalized.indexOf(i),1)):I===2&&M===1?i.type=0:I===1&&M===0||(i.type=M)}else this.normalized.push(y),this.mapPathToChange.set(y.path,y)}normalize(){const y=[],i=[];return this.normalized.filter(I=>I.type!==2?(y.push(I),!1):!0).sort((I,M)=>I.path.length-M.path.length).filter(I=>i.some(M=>(0,L.isParent)(I.path,M,!A.isLinux))?!1:(i.push(I.path),!0)).concat(y)}}}),define(J[172],Z([0,1,92,2,16,82,117,9,8]),function($,e,m,L,A,b,E,n,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class y extends L.Disposable{constructor(I,M,p,g){super();this.path=I,this.onDidFilesChange=M,this.onLogMessage=p,this.verboseLogging=g,this.fileChangesDelayer=this._register(new n.ThrottledDelayer(E.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(I){this.verboseLogging=I}async startWatching(){try{const{stat:I,symbolicLink:M}=await A.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let p=this.path;if(M)try{p=await(0,b.realpath)(p)}catch(g){if(this.onError(g),M.dangling)return}I.isDirectory()?this._register((0,E.watchFolder)(p,(g,v)=>{this.onFileChange({type:g==="changed"?0:g==="added"?1:2,path:(0,w.join)(this.path,(0,w.basename)(v))})},g=>this.onError(g))):this._register((0,E.watchFile)(p,g=>{this.onFileChange({type:g==="changed"?0:2,path:this.path})},g=>this.onError(g)))}catch(I){I.code!=="ENOENT"&&this.onError(I)}}onFileChange(I){this.fileChangesBuffer.push(I),this.verboseLogging&&this.onVerbose(`${I.type===1?"[ADDED]":I.type===2?"[DELETED]":"[CHANGED]"} ${I.path}`),this.fileChangesDelayer.trigger(async()=>{const M=this.fileChangesBuffer;this.fileChangesBuffer=[];const p=(0,m.normalizeFileChanges)(M);this.verboseLogging&&p.forEach(g=>{this.onVerbose(`>> normalized ${g.type===1?"[ADDED]":g.type===2?"[DELETED]":"[CHANGED]"} ${g.path}`)}),p.length>0&&this.onDidFilesChange(p)})}onError(I){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${I}`})}onVerbose(I){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${I}`})}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=y}),define(J[71],Z([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class m{constructor(...A){this._entries=new Map;for(let[b,E]of A)this.set(b,E)}set(A,b){const E=this._entries.get(A);return this._entries.set(A,b),E}has(A){return this._entries.has(A)}get(A){return this._entries.get(A)}}e.ServiceCollection=m}),define(J[173],Z([0,1,19,167,69,4,71,9]),function($,e,m,L,A,b,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const w=!1;class y extends Error{constructor(g){var v;super("cyclic dependency between services");this.message=(v=g.findCycleSlow())!==null&&v!==void 0?v:`UNABLE to detect cycle, dumping graph: 
${g.toString()}`}}class i{constructor(g=new E.ServiceCollection,v=!1,D){this._activeInstantiations=new Set,this._services=g,this._strict=v,this._parent=D,this._services.set(b.IInstantiationService,this)}createChild(g){return new i(g,this._strict,this)}invokeFunction(g,...v){let D=M.traceInvocation(g),S=!1;try{return g({get:(u,c)=>{if(S)throw(0,m.illegalState)("service accessor is only valid during the invocation of its target method");const l=this._getOrCreateServiceInstance(u,D);if(!l&&c!==b.optional)throw new Error(`[invokeFunction] unknown service '${u}'`);return l}},...v)}finally{S=!0,D.stop()}}createInstance(g,...v){let D,S;return g instanceof A.SyncDescriptor?(D=M.traceCreation(g.ctor),S=this._createInstance(g.ctor,g.staticArguments.concat(v),D)):(D=M.traceCreation(g),S=this._createInstance(g,v,D)),D.stop(),S}_createInstance(g,v=[],D){let S=b._util.getServiceDependencies(g).sort((c,l)=>c.index-l.index),a=[];for(const c of S){let l=this._getOrCreateServiceInstance(c.id,D);if(!l&&this._strict&&!c.optional)throw new Error(`[createInstance] ${g.name} depends on UNKNOWN service ${c.id}.`);a.push(l)}let u=S.length>0?S[0].index:v.length;if(v.length!==u){console.warn(`[createInstance] First service dependency of ${g.name} at position ${u+1} conflicts with ${v.length} static arguments`);let c=u-v.length;c>0?v=v.concat(new Array(c)):v=v.slice(0,u)}return new g(...[...v,...a])}_setServiceInstance(g,v){if(this._services.get(g)instanceof A.SyncDescriptor)this._services.set(g,v);else if(this._parent)this._parent._setServiceInstance(g,v);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(g){let v=this._services.get(g);return!v&&this._parent?this._parent._getServiceInstanceOrDescriptor(g):v}_getOrCreateServiceInstance(g,v){let D=this._getServiceInstanceOrDescriptor(g);return D instanceof A.SyncDescriptor?this._safeCreateAndCacheServiceInstance(g,D,v.branch(g,!0)):(v.branch(g,!1),D)}_safeCreateAndCacheServiceInstance(g,v,D){if(this._activeInstantiations.has(g))throw new Error(`illegal state - RECURSIVELY instantiating service '${g}'`);this._activeInstantiations.add(g);try{return this._createAndCacheServiceInstance(g,v,D)}finally{this._activeInstantiations.delete(g)}}_createAndCacheServiceInstance(g,v,D){const S=new L.Graph(c=>c.id.toString());let a=0;const u=[{id:g,desc:v,_trace:D}];for(;u.length;){const c=u.pop();if(S.lookupOrInsertNode(c),a++>1e3)throw new y(S);for(let l of b._util.getServiceDependencies(c.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(l.id);if(!t&&!l.optional&&console.warn(`[createInstance] ${g} depends on ${l.id} which is NOT registered.`),t instanceof A.SyncDescriptor){const r={id:l.id,desc:t,_trace:c._trace.branch(l.id,!0)};S.insertEdge(c,r),u.push(r)}}}for(;;){const c=S.roots();if(c.length===0){if(!S.isEmpty())throw new y(S);break}for(const{data:l}of c){if(this._getServiceInstanceOrDescriptor(l.id)instanceof A.SyncDescriptor){const r=this._createServiceInstanceWithOwner(l.id,l.desc.ctor,l.desc.staticArguments,l.desc.supportsDelayedInstantiation,l._trace);this._setServiceInstance(l.id,r)}S.removeNode(l)}}return this._getServiceInstanceOrDescriptor(g)}_createServiceInstanceWithOwner(g,v,D=[],S,a){if(this._services.get(g)instanceof A.SyncDescriptor)return this._createServiceInstance(v,D,S,a);if(this._parent)return this._parent._createServiceInstanceWithOwner(g,v,D,S,a);throw new Error(`illegalState - creating UNKNOWN service instance ${v.name}`)}_createServiceInstance(g,v=[],D,S){if(D){const a=new n.IdleValue(()=>this._createInstance(g,v,S));return new Proxy(Object.create(null),{get(u,c){if(c in u)return u[c];let l=a.value,t=l[c];return typeof t!="function"||(t=t.bind(l),u[c]=t),t},set(u,c,l){return a.value[c]=l,!0}})}else return this._createInstance(g,v,S)}}e.InstantiationService=i;var I;(function(p){p[p.Creation=0]="Creation",p[p.Invocation=1]="Invocation",p[p.Branch=2]="Branch"})(I||(I={}));class M{constructor(g,v){this.type=g,this.name=v,this._start=Date.now(),this._dep=[]}static traceInvocation(g){return w?new M(1,g.name||g.toString().substring(0,42).replace(/\n/g,"")):M._None}static traceCreation(g){return w?new M(0,g.name):M._None}branch(g,v){let D=new M(2,g.toString());return this._dep.push([g,v,D]),D}stop(){let g=Date.now()-this._start;M._totals+=g;let v=!1;function D(a,u){let c=[],l=new Array(a+1).join("	");for(const[t,r,s]of u._dep)if(r&&s){v=!0,c.push(`${l}CREATES -> ${t}`);let o=D(a+1,s);o&&c.push(o)}else c.push(`${l}uses -> ${t}`);return c.join(`
`)}let S=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${D(1,this)}`,`DONE, took ${g.toFixed(2)}ms (grand total ${M._totals.toFixed(2)}ms)`];(g>2||v)&&console.log(S.join(`
`))}}M._None=new class extends M{constructor(){super(-1,null)}stop(){}branch(){return this}},M._totals=0}),define(J[174],Z([0,1,19,128,57]),function($,e,m,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseResolvedKeybinding=void 0;class b extends A.ResolvedKeybinding{constructor(n,w){super();if(w.length===0)throw(0,m.illegalArgument)("parts");this._os=n,this._parts=w}getLabel(){return L.UILabelProvider.toLabel(this._os,this._parts,n=>this._getLabel(n))}getAriaLabel(){return L.AriaLabelProvider.toLabel(this._os,this._parts,n=>this._getAriaLabel(n))}getElectronAccelerator(){return this._parts.length>1?null:L.ElectronAcceleratorLabelProvider.toLabel(this._os,this._parts,n=>this._getElectronAccelerator(n))}getUserSettingsLabel(){return L.UserSettingsLabelProvider.toLabel(this._os,this._parts,n=>this._getUserSettingsLabel(n))}isWYSIWYG(){return this._parts.every(n=>this._isWYSIWYG(n))}isChord(){return this._parts.length>1}getParts(){return this._parts.map(n=>this._getPart(n))}_getPart(n){return new A.ResolvedKeybindingPart(n.ctrlKey,n.shiftKey,n.altKey,n.metaKey,this._getLabel(n),this._getAriaLabel(n))}getDispatchParts(){return this._parts.map(n=>this._getDispatchPart(n))}getSingleModifierDispatchParts(){return this._parts.map(n=>this._getSingleModifierDispatchPart(n))}}e.BaseResolvedKeybinding=b}),define(J[175],Z([0,1,57,174]),function($,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USLayoutResolvedKeybinding=void 0;class A extends L.BaseResolvedKeybinding{constructor(E,n){super(n,E.parts)}_keyCodeToUILabel(E){if(this._os===2)switch(E){case 15:return"\u2190";case 16:return"\u2191";case 17:return"\u2192";case 18:return"\u2193"}return m.KeyCodeUtils.toString(E)}_getLabel(E){return E.isDuplicateModifierCase()?"":this._keyCodeToUILabel(E.keyCode)}_getAriaLabel(E){return E.isDuplicateModifierCase()?"":m.KeyCodeUtils.toString(E.keyCode)}_keyCodeToElectronAccelerator(E){if(E>=93&&E<=108)return null;switch(E){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return m.KeyCodeUtils.toString(E)}_getElectronAccelerator(E){return E.isDuplicateModifierCase()?null:this._keyCodeToElectronAccelerator(E.keyCode)}_getUserSettingsLabel(E){if(E.isDuplicateModifierCase())return"";const n=m.KeyCodeUtils.toUserSettingsUS(E.keyCode);return n&&n.toLowerCase()}_isWYSIWYG(){return!0}_getDispatchPart(E){return A.getDispatchStr(E)}static getDispatchStr(E){if(E.isModifierKey())return null;let n="";return E.ctrlKey&&(n+="ctrl+"),E.shiftKey&&(n+="shift+"),E.altKey&&(n+="alt+"),E.metaKey&&(n+="meta+"),n+=m.KeyCodeUtils.toString(E.keyCode),n}_getSingleModifierDispatchPart(E){return E.keyCode===5&&!E.shiftKey&&!E.altKey&&!E.metaKey?"ctrl":E.keyCode===4&&!E.ctrlKey&&!E.altKey&&!E.metaKey?"shift":E.keyCode===6&&!E.ctrlKey&&!E.shiftKey&&!E.metaKey?"alt":E.keyCode===57&&!E.ctrlKey&&!E.shiftKey&&!E.altKey?"meta":null}}e.USLayoutResolvedKeybinding=A}),define(J[176],Z([0,1,9]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.handleVetos=void 0;function L(A,b){if(A.length===0)return Promise.resolve(!1);const E=[];let n=!1;for(let w of A){if(w===!0)return Promise.resolve(!0);(0,m.isThenable)(w)&&E.push(w.then(y=>{y&&(n=!0)},y=>{b(y),n=!0}))}return m.Promises.settled(E).then(()=>n)}e.handleVetos=L}),define(J[6],Z([0,1,4,2,3,5,67]),function($,e,m,L,A,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,m.createDecorator)("logService"),e.ILoggerService=(0,m.createDecorator)("loggerService");function n(){return new Date().toISOString()}var w;(function(l){l[l.Trace=0]="Trace",l[l.Debug=1]="Debug",l[l.Info=2]="Info",l[l.Warning=3]="Warning",l[l.Error=4]="Error",l[l.Critical=5]="Critical",l[l.Off=6]="Off"})(w=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=w.Info;class y extends L.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new b.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=y;class i extends y{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...r){this.checkLogLevel(w.Trace)&&this.log(w.Trace,this.format([t,...r]))}debug(t,...r){this.checkLogLevel(w.Debug)&&this.log(w.Debug,this.format([t,...r]))}info(t,...r){this.checkLogLevel(w.Info)&&this.log(w.Info,this.format([t,...r]))}warn(t,...r){this.checkLogLevel(w.Warning)&&this.log(w.Warning,this.format([t,...r]))}error(t,...r){if(this.checkLogLevel(w.Error))if(t instanceof Error){const s=Array.prototype.slice.call(arguments);s[0]=t.stack,this.log(w.Error,this.format(s))}else this.log(w.Error,this.format([t,...r]))}critical(t,...r){this.checkLogLevel(w.Critical)&&this.log(w.Critical,this.format([t,...r]))}flush(){}format(t){let r="";for(let s=0;s<t.length;s++){let o=t[s];if(typeof o=="object")try{o=JSON.stringify(o)}catch(d){}r+=(s>0?" ":"")+o}return r}}e.AbstractMessageLogger=i;class I extends y{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!A.isWindows}trace(t,...r){this.getLevel()<=w.Trace&&(this.useColors?console.log(`[90m[main ${n()}][0m`,t,...r):console.log(`[main ${n()}]`,t,...r))}debug(t,...r){this.getLevel()<=w.Debug&&(this.useColors?console.log(`[90m[main ${n()}][0m`,t,...r):console.log(`[main ${n()}]`,t,...r))}info(t,...r){this.getLevel()<=w.Info&&(this.useColors?console.log(`[90m[main ${n()}][0m`,t,...r):console.log(`[main ${n()}]`,t,...r))}warn(t,...r){this.getLevel()<=w.Warning&&(this.useColors?console.warn(`[93m[main ${n()}][0m`,t,...r):console.warn(`[main ${n()}]`,t,...r))}error(t,...r){this.getLevel()<=w.Error&&(this.useColors?console.error(`[91m[main ${n()}][0m`,t,...r):console.error(`[main ${n()}]`,t,...r))}critical(t,...r){this.getLevel()<=w.Critical&&(this.useColors?console.error(`[90m[main ${n()}][0m`,t,...r):console.error(`[main ${n()}]`,t,...r))}dispose(){}flush(){}}e.ConsoleMainLogger=I;class M extends y{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...r){this.getLevel()<=w.Trace&&console.log("%cTRACE","color: #888",t,...r)}debug(t,...r){this.getLevel()<=w.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...r)}info(t,...r){this.getLevel()<=w.Info&&console.log("%c INFO","color: #33f",t,...r)}warn(t,...r){this.getLevel()<=w.Warning&&console.log("%c WARN","color: #993",t,...r)}error(t,...r){this.getLevel()<=w.Error&&console.log("%c  ERR","color: #f33",t,...r)}critical(t,...r){this.getLevel()<=w.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...r)}dispose(){}flush(){}}e.ConsoleLogger=M;class p extends y{constructor(t,r=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(r)}trace(t,...r){this.getLevel()<=w.Trace&&this.adapter.log(w.Trace,[this.extractMessage(t),...r])}debug(t,...r){this.getLevel()<=w.Debug&&this.adapter.log(w.Debug,[this.extractMessage(t),...r])}info(t,...r){this.getLevel()<=w.Info&&this.adapter.log(w.Info,[this.extractMessage(t),...r])}warn(t,...r){this.getLevel()<=w.Warning&&this.adapter.log(w.Warning,[this.extractMessage(t),...r])}error(t,...r){this.getLevel()<=w.Error&&this.adapter.log(w.Error,[this.extractMessage(t),...r])}critical(t,...r){this.getLevel()<=w.Critical&&this.adapter.log(w.Critical,[this.extractMessage(t),...r])}extractMessage(t){return typeof t=="string"?t:(0,E.toErrorMessage)(t,this.getLevel()<=w.Trace)}dispose(){}flush(){}}e.AdapterLogger=p;class g extends y{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const r of this.logServices)r.setLevel(t);super.setLevel(t)}trace(t,...r){for(const s of this.logServices)s.trace(t,...r)}debug(t,...r){for(const s of this.logServices)s.debug(t,...r)}info(t,...r){for(const s of this.logServices)s.info(t,...r)}warn(t,...r){for(const s of this.logServices)s.warn(t,...r)}error(t,...r){for(const s of this.logServices)s.error(t,...r)}critical(t,...r){for(const s of this.logServices)s.critical(t,...r)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=g;class v extends L.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...r){this.logger.trace(t,...r)}debug(t,...r){this.logger.debug(t,...r)}info(t,...r){this.logger.info(t,...r)}warn(t,...r){this.logger.warn(t,...r)}error(t,...r){this.logger.error(t,...r)}critical(t,...r){this.logger.critical(t,...r)}flush(){this.logger.flush()}}e.LogService=v;class D extends L.Disposable{constructor(t,r){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(r(s=>{this.logLevel=s,this.logLevelChangeableLoggers.forEach(o=>o.setLevel(s))}))}createLogger(t,r){let s=this.loggers.get(t.toString());return s||(s=this.doCreateLogger(t,(r==null?void 0:r.always)?w.Trace:this.logLevel,r),this.loggers.set(t.toString(),s),(r==null?void 0:r.always)||this.logLevelChangeableLoggers.push(s)),s}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=D;class S{constructor(){this.onDidChangeLogLevel=new b.Emitter().event}setLevel(t){}getLevel(){return w.Info}trace(t,...r){}debug(t,...r){}info(t,...r){}warn(t,...r){}error(t,...r){}critical(t,...r){}dispose(){}flush(){}}e.NullLogService=S;function a(l){if(l.verbose)return w.Trace;if(typeof l.logLevel=="string"){const t=u(l.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=a;function u(l){switch(l){case"trace":return w.Trace;case"debug":return w.Debug;case"info":return w.Info;case"warn":return w.Warning;case"error":return w.Error;case"critical":return w.Critical;case"off":return w.Off}}e.parseLogLevel=u;function c(l){switch(l){case w.Trace:return"trace";case w.Debug:return"debug";case w.Info:return"info";case w.Warning:return"warn";case w.Error:return"error";case w.Critical:return"critical";case w.Off:return"off"}}e.LogLevelToString=c}),define(J[93],Z([0,1,6]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferLogService=void 0;function L(b,E){switch(E){case m.LogLevel.Trace:return b.trace;case m.LogLevel.Debug:return b.debug;case m.LogLevel.Info:return b.info;case m.LogLevel.Warning:return b.warn;case m.LogLevel.Error:return b.error;case m.LogLevel.Critical:return b.critical;default:throw new Error("Invalid log level")}}class A extends m.AbstractLogger{constructor(E=m.DEFAULT_LOG_LEVEL){super();this.buffer=[],this._logger=void 0,this.setLevel(E),this._register(this.onDidChangeLogLevel(n=>{this._logger&&this._logger.setLevel(n)}))}set logger(E){this._logger=E;for(const{level:n,args:w}of this.buffer)L(E,n).apply(E,w);this.buffer=[]}_log(E,...n){this._logger?L(this._logger,E).apply(this._logger,n):this.getLevel()<=E&&this.buffer.push({level:E,args:n})}trace(E,...n){this._log(m.LogLevel.Trace,E,...n)}debug(E,...n){this._log(m.LogLevel.Debug,E,...n)}info(E,...n){this._log(m.LogLevel.Info,E,...n)}warn(E,...n){this._log(m.LogLevel.Warning,E,...n)}error(E,...n){this._log(m.LogLevel.Error,E,...n)}critical(E,...n){this._log(m.LogLevel.Critical,E,...n)}dispose(){this._logger&&this._logger.dispose()}flush(){this._logger&&this._logger.flush()}}e.BufferLogService=A});var te=this&&this.__param||function($,e){return function(m,L){e(m,L,$)}};define(J[177],Z([0,1,6,21,9,20,15,4,93]),function($,e,m,L,A,b,E,n,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileLoggerService=e.FileLogger=void 0;const y=5*L.ByteSize.MB;let i=class extends m.AbstractLogger{constructor(p,g,v,D){super();this.name=p,this.resource=g,this.fileService=D,this.backupIndex=1,this.setLevel(v),this.queue=this._register(new A.Queue),this.initializePromise=this.initialize()}trace(){this.getLevel()<=m.LogLevel.Trace&&this._log(m.LogLevel.Trace,this.format(arguments))}debug(){this.getLevel()<=m.LogLevel.Debug&&this._log(m.LogLevel.Debug,this.format(arguments))}info(){this.getLevel()<=m.LogLevel.Info&&this._log(m.LogLevel.Info,this.format(arguments))}warn(){this.getLevel()<=m.LogLevel.Warning&&this._log(m.LogLevel.Warning,this.format(arguments))}error(){if(this.getLevel()<=m.LogLevel.Error){const p=arguments[0];if(p instanceof Error){const g=Array.prototype.slice.call(arguments);g[0]=p.stack,this._log(m.LogLevel.Error,this.format(g))}else this._log(m.LogLevel.Error,this.format(arguments))}}critical(){this.getLevel()<=m.LogLevel.Critical&&this._log(m.LogLevel.Critical,this.format(arguments))}flush(){}log(p,g){this._log(p,this.format(g))}async initialize(){try{await this.fileService.createFile(this.resource)}catch(p){if(p.fileOperationResult!==3)throw p}}_log(p,g){this.queue.queue(async()=>{await this.initializePromise;let v=await this.loadContent();v.length>y&&(await this.fileService.writeFile(this.getBackupResource(),b.VSBuffer.fromString(v)),v=""),v+=`[${this.getCurrentTimestamp()}] [${this.name}] [${this.stringifyLogLevel(p)}] ${g}
`,await this.fileService.writeFile(this.resource,b.VSBuffer.fromString(v))})}getCurrentTimestamp(){const p=D=>D<10?`0${D}`:D,g=D=>D<10?`00${D}`:D<100?`0${D}`:D,v=new Date;return`${v.getFullYear()}-${p(v.getMonth()+1)}-${p(v.getDate())} ${p(v.getHours())}:${p(v.getMinutes())}:${p(v.getSeconds())}.${g(v.getMilliseconds())}`}getBackupResource(){return this.backupIndex=this.backupIndex>5?1:this.backupIndex,(0,E.joinPath)((0,E.dirname)(this.resource),`${(0,E.basename)(this.resource)}_${this.backupIndex++}`)}async loadContent(){try{return(await this.fileService.readFile(this.resource)).value.toString()}catch(p){return""}}stringifyLogLevel(p){switch(p){case m.LogLevel.Critical:return"critical";case m.LogLevel.Debug:return"debug";case m.LogLevel.Error:return"error";case m.LogLevel.Info:return"info";case m.LogLevel.Trace:return"trace";case m.LogLevel.Warning:return"warning"}return""}format(p){let g="";for(let v=0;v<p.length;v++){let D=p[v];if(typeof D=="object")try{D=JSON.stringify(D)}catch(S){}g+=(v>0?" ":"")+D}return g}};i=he([te(3,L.IFileService)],i),e.FileLogger=i;let I=class extends m.AbstractLoggerService{constructor(p,g,v){super(p.getLevel(),p.onDidChangeLogLevel);this.instantiationService=g,this.fileService=v}doCreateLogger(p,g){const v=new w.BufferLogService(g);return(0,L.whenProviderRegistered)(p,this.fileService).then(()=>v.logger=this.instantiationService.createInstance(i,(0,E.basename)(p),p,v.getLevel())),v}};I=he([te(0,m.ILogService),te(1,n.IInstantiationService),te(2,L.IFileService)],I),e.FileLoggerService=I}),define(J[178],Z([0,1,6,5,7]),function($,e,m,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class b{constructor(M){this.service=M,this.onDidChangeLogLevel=L.Event.buffer(M.onDidChangeLogLevel,!0)}listen(M,p){switch(p){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${p}`)}async call(M,p,g){switch(p){case"setLevel":return this.service.setLevel(g)}throw new Error(`Call not found: ${p}`)}}e.LogLevelChannel=b;class E{constructor(M){this.channel=M}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(M){E.setLevel(this.channel,M)}static setLevel(M,p){return M.call("setLevel",p)}}e.LogLevelChannelClient=E;class n{constructor(M){this.loggerService=M,this.loggers=new Map}listen(M,p){throw new Error(`Event not found: ${p}`)}async call(M,p,g){switch(p){case"createLogger":this.createLogger(A.URI.revive(g[0]),g[1]);return;case"log":return this.log(A.URI.revive(g[0]),g[1]);case"consoleLog":return this.consoleLog(g[0],g[1])}throw new Error(`Call not found: ${p}`)}createLogger(M,p){this.loggers.set(M.toString(),this.loggerService.createLogger(M,p))}consoleLog(M,p){let g=console.log;switch(M){case m.LogLevel.Error:g=console.error;break;case m.LogLevel.Warning:g=console.warn;break;case m.LogLevel.Info:g=console.info;break}g.call(console,...p)}log(M,p){const g=this.loggers.get(M.toString());if(!g)throw new Error("Create the logger before logging");for(const[v,D]of p)switch(v){case m.LogLevel.Trace:g.trace(D);break;case m.LogLevel.Debug:g.debug(D);break;case m.LogLevel.Info:g.info(D);break;case m.LogLevel.Warning:g.warn(D);break;case m.LogLevel.Error:g.error(D);break;case m.LogLevel.Critical:g.critical(D);break;default:throw new Error("Invalid log level")}}}e.LoggerChannel=n;class w extends m.AbstractLoggerService{constructor(M,p,g){super(M,p);this.channel=g}createConsoleMainLogger(){return new m.AdapterLogger({log:(M,p)=>{this.channel.call("consoleLog",[M,p])}})}doCreateLogger(M,p,g){return new y(this.channel,M,p,g)}}e.LoggerChannelClient=w;class y extends m.AbstractMessageLogger{constructor(M,p,g,v){super(v==null?void 0:v.always);this.channel=M,this.file=p,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(g),this.channel.call("createLogger",[p,v]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(M,p){const g=[[M,p]];this.isLoggerCreated?this.doLog(g):this.buffer.push(...g)}doLog(M){this.channel.call("log",[this.file,M])}}class i extends m.LogService{constructor(M,p){super(p);this.parent=M,this._register(M.onDidChangeLogLevel(g=>p.setLevel(g)))}setLevel(M){super.setLevel(M),this.parent.setLevel(M)}}e.FollowerLogService=i}),define(J[94],Z([0,1,6,21]),function($,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=e.createRotatingLogger=void 0;async function A(w,y,i,I){try{const M=await new Promise((p,g)=>{$(["spdlog"],p,g)});return M.setFlushOn(m.LogLevel.Info),M.createAsyncRotatingLogger(w,y,i,I)}catch(M){console.error(M)}return null}function b(w,y,i,I){const M=$.__$__nodeRequire("spdlog");return M.setFlushOn(m.LogLevel.Info),M.createRotatingLogger(w,y,i,I)}e.createRotatingLogger=b;function E(w,y,i){switch(y){case m.LogLevel.Trace:w.trace(i);break;case m.LogLevel.Debug:w.debug(i);break;case m.LogLevel.Info:w.info(i);break;case m.LogLevel.Warning:w.warn(i);break;case m.LogLevel.Error:w.error(i);break;case m.LogLevel.Critical:w.critical(i);break;default:throw new Error("Invalid log level")}}class n extends m.AbstractMessageLogger{constructor(y,i,I,M){super();this.name=y,this.filepath=i,this.rotating=I,this.buffer=[],this.setLevel(M),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(p=>{this._logger&&this._logger.setLevel(p)}))}_createSpdLogLogger(){const y=this.rotating?6:1,i=30/y*L.ByteSize.MB;return A(this.name,this.filepath,i,y).then(I=>{if(I){this._logger=I,this._logger.setLevel(this.getLevel());for(const{level:M,message:p}of this.buffer)E(this._logger,M,p);this.buffer=[]}})}log(y,i){this._logger?E(this._logger,y,i):this.getLevel()<=y&&this.buffer.push({level:y,message:i})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=n}),define(J[179],Z([0,1,6,15,10,177,94,21,27]),function($,e,m,L,A,b,E,n,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;let y=class extends m.AbstractLoggerService{constructor(I,M){super(I.getLevel(),I.onDidChangeLogLevel);this.fileService=M}doCreateLogger(I,M,p){var g;if(I.scheme===A.Schemas.file){const v=new E.SpdLogLogger((p==null?void 0:p.name)||(0,w.generateUuid)(),I.fsPath,!(p==null?void 0:p.donotRotate),M);return(p==null?void 0:p.donotUseFormatters)&&v.clearFormatters(),v}else return new b.FileLogger((g=p==null?void 0:p.name)!==null&&g!==void 0?g:(0,L.basename)(I),I,M,this.fileService)}};y=he([te(0,m.ILogService),te(1,n.IFileService)],y),e.LoggerService=y}),define(J[180],Z([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMenubarMenuItemAction=e.isMenubarMenuItemRecentAction=e.isMenubarMenuItemSeparator=e.isMenubarMenuItemSubmenu=void 0;function m(E){return E.submenu!==void 0}e.isMenubarMenuItemSubmenu=m;function L(E){return E.id==="vscode.menubar.separator"}e.isMenubarMenuItemSeparator=L;function A(E){return E.uri!==void 0}e.isMenubarMenuItemRecentAction=A;function b(E){return!m(E)&&!L(E)&&!A(E)}e.isMenubarMenuItemAction=b}),define(J[47],Z([0,1,10,3,32,15]),function($,e,m,L,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let E;if(typeof L.globals.vscode!="undefined"&&typeof L.globals.vscode.context!="undefined"){const n=L.globals.vscode.context.configuration();if(n)E=n.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof($==null?void 0:$.__$__nodeRequire)=="function"){const n=(0,b.dirname)(m.FileAccess.asFileUri("",$));E=$.__$__nodeRequire((0,b.joinPath)(n,"product.json").fsPath);const w=$.__$__nodeRequire((0,b.joinPath)(n,"package.json").fsPath);A.env.VSCODE_DEV&&Object.assign(E,{nameShort:`${E.nameShort} Dev`,nameLong:`${E.nameLong} Dev`,dataFolderName:`${E.dataFolderName}-dev`}),Object.assign(E,{version:w.version})}else E={},Object.keys(E).length===0&&Object.assign(E,{version:"1.57.0-dev",nameShort:L.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",nameLong:L.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.github-browser","ms-vscode.github-richnav","ms-vscode.remotehub","ms-vscode.remotehub-insiders"]});e.default=E}),define(J[95],Z([0,1,141,20,21,19,47]),function($,e,m,L,A,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function n(I,M,p,g,v,D){let S;try{await w(I,M,p,g,v,D)}catch(a){S=a}finally{S&&v.errorTransformer&&(S=v.errorTransformer(S)),typeof S!="undefined"&&p.error(S),p.end()}}e.readFileIntoStream=n;async function w(I,M,p,g,v,D){y(D);const S=await I.open(M,{create:!1});try{y(D);let a=0,u=0,c=v&&typeof v.length=="number"?v.length:void 0,l=L.VSBuffer.alloc(Math.min(v.bufferSize,typeof c=="number"?c:v.bufferSize)),t=v&&typeof v.position=="number"?v.position:0,r=0;do u=await I.read(S,t,l.buffer,r,l.byteLength-r),t+=u,r+=u,a+=u,typeof c=="number"&&(c-=u),r===l.byteLength&&(await p.write(g(l)),l=L.VSBuffer.alloc(Math.min(v.bufferSize,typeof c=="number"?c:v.bufferSize)),r=0);while(u>0&&(typeof c!="number"||c>0)&&y(D)&&i(a,v));if(r>0){let s=r;typeof c=="number"&&(s=Math.min(r,c)),p.write(g(l.slice(0,s)))}}catch(a){throw(0,A.ensureFileSystemProviderError)(a)}finally{await I.close(S)}}function y(I){if(I.isCancellationRequested)throw(0,b.canceled)();return!0}function i(I,M){if(M==null?void 0:M.limits){if(typeof M.limits.memory=="number"&&I>M.limits.memory)throw(0,A.createFileSystemProviderError)((0,m.localize)(0,null,E.default.nameShort),A.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof M.limits.size=="number"&&I>M.limits.size)throw(0,A.createFileSystemProviderError)((0,m.localize)(1,null),A.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(J[181],Z([0,1,139,72,2,21,5,15,36,35,6,20,64,9,25,10,95,63]),function($,e,m,L,A,b,E,n,w,y,i,I,M,p,g,v,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let a=class extends A.Disposable{constructor(c){super();this.logService=c,this.BUFFER_SIZE=64*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new E.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new E.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new E.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new E.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new E.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new E.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this.activeWatchers=new Map,this.writeQueue=this._register(new p.ResourceQueue)}registerProvider(c,l){if(this.provider.has(c))throw new Error(`A filesystem provider for the scheme '${c}' is already registered.`);(0,L.mark)(`code/registerFilesystem/${c}`),this.provider.set(c,l),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:c,provider:l});const t=new A.DisposableStore;return t.add(l.onDidChangeFile(r=>this._onDidFilesChange.fire(new b.FileChangesEvent(r,!this.isPathCaseSensitive(l))))),t.add(l.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:l,scheme:c}))),typeof l.onDidErrorOccur=="function"&&t.add(l.onDidErrorOccur(r=>this._onError.fire(new Error(r)))),(0,A.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:c,provider:l}),this.provider.delete(c),(0,A.dispose)(t)})}getProvider(c){return this.provider.get(c)}async activateProvider(c){const l=[];this._onWillActivateFileSystemProvider.fire({scheme:c,join(t){l.push(t)}}),!this.provider.has(c)&&await p.Promises.settled(l)}canHandleResource(c){return this.provider.has(c.scheme)}hasCapability(c,l){const t=this.provider.get(c.scheme);return!!(t&&t.capabilities&l)}listCapabilities(){return S.Iterable.map(this.provider,([c,l])=>({scheme:c,capabilities:l.capabilities}))}async withProvider(c){if(!(0,n.isAbsolutePath)(c))throw new b.FileOperationError((0,m.localize)(0,null,this.resourceForError(c)),8);await this.activateProvider(c.scheme);const l=this.provider.get(c.scheme);if(!l){const t=new Error;throw t.name="ENOPRO",t.message=(0,m.localize)(1,null,c.toString()),t}return l}async withReadProvider(c){const l=await this.withProvider(c);if((0,b.hasOpenReadWriteCloseCapability)(l)||(0,b.hasReadWriteCapability)(l)||(0,b.hasFileReadStreamCapability)(l))return l;throw new Error(`Filesystem provider for scheme '${c.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(c){const l=await this.withProvider(c);if((0,b.hasOpenReadWriteCloseCapability)(l)||(0,b.hasReadWriteCapability)(l))return l;throw new Error(`Filesystem provider for scheme '${c.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(c,l){try{return await this.doResolveFile(c,l)}catch(t){throw(0,b.toFileSystemProviderErrorCode)(t)===b.FileSystemProviderErrorCode.FileNotFound?new b.FileOperationError((0,m.localize)(2,null,this.resourceForError(c)),1):(0,b.ensureFileSystemProviderError)(t)}}async doResolveFile(c,l){const t=await this.withProvider(c),r=this.isPathCaseSensitive(t),s=l==null?void 0:l.resolveTo,o=l==null?void 0:l.resolveSingleChildDescendants,d=l==null?void 0:l.resolveMetadata,f=await t.stat(c);let h;return this.toFileStat(t,c,f,void 0,!!d,(P,T)=>(h||(h=w.TernarySearchTree.forUris(()=>!r),h.set(c,!0),(0,y.isNonEmptyArray)(s)&&s.forEach(U=>h.set(U,!0))),Boolean(h.findSuperstr(P.resource)||h.get(P.resource))?!0:P.isDirectory&&o?T===1:!1))}async toFileStat(c,l,t,r,s,o){var d;const{providerExtUri:f}=this.getExtUri(c),h={resource:l,name:f.basename(l),isFile:(t.type&b.FileType.File)!=0,isDirectory:(t.type&b.FileType.Directory)!=0,isSymbolicLink:(t.type&b.FileType.SymbolicLink)!=0,mtime:t.mtime,ctime:t.ctime,size:t.size,readonly:Boolean(((d=t.permissions)!==null&&d!==void 0?d:0)&b.FilePermission.Readonly)||Boolean(c.capabilities&2048),etag:(0,b.etag)({mtime:t.mtime,size:t.size})};if(h.isDirectory&&o(h,r)){try{const P=await c.readdir(l),T=await p.Promises.settled(P.map(async([U,q])=>{try{const Q=f.joinPath(l,U),x=s?await c.stat(Q):{type:q};return await this.toFileStat(c,Q,x,P.length,s,o)}catch(Q){return this.logService.trace(Q),null}}));h.children=(0,y.coalesce)(T)}catch(P){this.logService.trace(P),h.children=[]}return h}return h}async resolveAll(c){return p.Promises.settled(c.map(async l=>{try{return{stat:await this.doResolveFile(l.resource,l.options),success:!0}}catch(t){return this.logService.trace(t),{stat:void 0,success:!1}}}))}async exists(c){const l=await this.withProvider(c);try{return!!await l.stat(c)}catch(t){return!1}}async canCreateFile(c,l){try{await this.doValidateCreateFile(c,l)}catch(t){return t}return!0}async doValidateCreateFile(c,l){if(!(l==null?void 0:l.overwrite)&&await this.exists(c))throw new b.FileOperationError((0,m.localize)(3,null,this.resourceForError(c)),3,l)}async createFile(c,l=I.VSBuffer.fromString(""),t){await this.doValidateCreateFile(c,t);const r=await this.writeFile(c,l);return this._onDidRunOperation.fire(new b.FileOperationEvent(c,0,r)),r}async writeFile(c,l,t){const r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),{providerExtUri:s}=this.getExtUri(r);try{await this.validateWriteFile(r,c,t)||await this.mkdirp(r,s.dirname(c));let d;if((0,b.hasReadWriteCapability)(r)&&!(l instanceof I.VSBuffer))if((0,M.isReadableStream)(l)){const f=await(0,M.peekStream)(l,3);f.ended?d=I.VSBuffer.concat(f.buffer):d=f}else d=(0,M.peekReadable)(l,f=>I.VSBuffer.concat(f),3);else d=l;!(0,b.hasOpenReadWriteCloseCapability)(r)||(0,b.hasReadWriteCapability)(r)&&d instanceof I.VSBuffer?await this.doWriteUnbuffered(r,c,t,d):await this.doWriteBuffered(r,c,t,d instanceof I.VSBuffer?(0,I.bufferToReadable)(d):d)}catch(o){throw new b.FileOperationError((0,m.localize)(4,null,this.resourceForError(c),(0,b.ensureFileSystemProviderError)(o).toString()),(0,b.toFileOperationResult)(o),t)}return this.resolve(c,{resolveMetadata:!0})}async validateWriteFile(c,l,t){if(!!(t==null?void 0:t.unlock)&&!(c.capabilities&8192))throw new Error((0,m.localize)(5,null,this.resourceForError(l)));let s;try{s=await c.stat(l)}catch(o){return}if((s.type&b.FileType.Directory)!=0)throw new b.FileOperationError((0,m.localize)(6,null,this.resourceForError(l)),0,t);if(this.throwIfFileIsReadonly(l,s),t&&typeof t.mtime=="number"&&typeof t.etag=="string"&&t.etag!==b.ETAG_DISABLED&&typeof s.mtime=="number"&&typeof s.size=="number"&&t.mtime<s.mtime&&t.etag!==(0,b.etag)({mtime:t.mtime,size:s.size}))throw new b.FileOperationError((0,m.localize)(7,null),3,t);return s}async readFile(c,l){const t=await this.withReadProvider(c);return(l==null?void 0:l.atomic)?this.doReadFileAtomic(t,c,l):this.doReadFile(t,c,l)}async doReadFileAtomic(c,l,t){return new Promise((r,s)=>{this.writeQueue.queueFor(l,this.getExtUri(c).providerExtUri).queue(async()=>{try{const o=await this.doReadFile(c,l,t);r(o)}catch(o){s(o)}})})}async doReadFile(c,l,t){const r=await this.doReadFileStream(c,l,Object.assign(Object.assign({},t),{preferUnbuffered:!0}));return Object.assign(Object.assign({},r),{value:await(0,I.streamToBuffer)(r.value)})}async readFileStream(c,l){const t=await this.withReadProvider(c);return this.doReadFileStream(t,c,l)}async doReadFileStream(c,l,t){const r=new g.CancellationTokenSource,s=this.validateReadFile(l,t).then(d=>d,d=>{throw r.cancel(),d});let o;try{t&&typeof t.etag=="string"&&t.etag!==b.ETAG_DISABLED&&await s,!((0,b.hasOpenReadWriteCloseCapability)(c)||(0,b.hasFileReadStreamCapability)(c))||(0,b.hasReadWriteCapability)(c)&&(t==null?void 0:t.preferUnbuffered)?o=this.readFileUnbuffered(c,l,t):(0,b.hasFileReadStreamCapability)(c)?o=this.readFileStreamed(c,l,r.token,t):o=this.readFileBuffered(c,l,r.token,t);const d=await s;return Object.assign(Object.assign({},d),{value:o})}catch(d){throw o&&await(0,M.consumeStream)(o),new b.FileOperationError((0,m.localize)(8,null,this.resourceForError(l),(0,b.ensureFileSystemProviderError)(d).toString()),(0,b.toFileOperationResult)(d),t)}}readFileStreamed(c,l,t,r=Object.create(null)){const s=c.readFileStream(l,r,t);return(0,M.transform)(s,{data:o=>o instanceof I.VSBuffer?o:I.VSBuffer.wrap(o),error:o=>new b.FileOperationError((0,m.localize)(9,null,this.resourceForError(l),(0,b.ensureFileSystemProviderError)(o).toString()),(0,b.toFileOperationResult)(o),r)},o=>I.VSBuffer.concat(o))}readFileBuffered(c,l,t,r=Object.create(null)){const s=(0,I.newWriteableBufferStream)();return(0,D.readFileIntoStream)(c,l,s,o=>o,Object.assign(Object.assign({},r),{bufferSize:this.BUFFER_SIZE,errorTransformer:o=>new b.FileOperationError((0,m.localize)(10,null,this.resourceForError(l),(0,b.ensureFileSystemProviderError)(o).toString()),(0,b.toFileOperationResult)(o),r)}),t),s}readFileUnbuffered(c,l,t){const r=(0,M.newWriteableStream)(s=>I.VSBuffer.concat(s));return(async()=>{try{let s=await c.readFile(l);t&&typeof t.position=="number"&&(s=s.slice(t.position)),t&&typeof t.length=="number"&&(s=s.slice(0,t.length)),this.validateReadFileLimits(l,s.byteLength,t),r.end(I.VSBuffer.wrap(s))}catch(s){r.error(s),r.end()}})(),r}async validateReadFile(c,l){const t=await this.resolve(c,{resolveMetadata:!0});if(t.isDirectory)throw new b.FileOperationError((0,m.localize)(11,null,this.resourceForError(c)),0,l);if(l&&typeof l.etag=="string"&&l.etag!==b.ETAG_DISABLED&&l.etag===t.etag)throw new b.FileOperationError((0,m.localize)(12,null),2,l);return this.validateReadFileLimits(c,t.size,l),t}validateReadFileLimits(c,l,t){if(t==null?void 0:t.limits){let r;if(typeof t.limits.memory=="number"&&l>t.limits.memory&&(r=9),typeof t.limits.size=="number"&&l>t.limits.size&&(r=7),typeof r=="number")throw new b.FileOperationError((0,m.localize)(13,null,this.resourceForError(c)),r)}}async canMove(c,l,t){return this.doCanMoveCopy(c,l,"move",t)}async canCopy(c,l,t){return this.doCanMoveCopy(c,l,"copy",t)}async doCanMoveCopy(c,l,t,r){if(c.toString()!==l.toString())try{const s=t==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c):await this.withReadProvider(c),o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l);await this.doValidateMoveCopy(s,c,o,l,t,r)}catch(s){return s}return!0}async move(c,l,t){const r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),o=await this.doMoveCopy(r,c,s,l,"move",!!t),d=await this.resolve(l,{resolveMetadata:!0});return this._onDidRunOperation.fire(new b.FileOperationEvent(c,o==="move"?2:3,d)),d}async copy(c,l,t){const r=await this.withReadProvider(c),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),o=await this.doMoveCopy(r,c,s,l,"copy",!!t),d=await this.resolve(l,{resolveMetadata:!0});return this._onDidRunOperation.fire(new b.FileOperationEvent(c,o==="copy"?3:2,d)),d}async doMoveCopy(c,l,t,r,s,o){if(l.toString()===r.toString())return s;const{exists:d,isSameResourceWithDifferentPathCase:f}=await this.doValidateMoveCopy(c,l,t,r,s,o);if(d&&!f&&o&&await this.del(r,{recursive:!0}),await this.mkdirp(t,this.getExtUri(t).providerExtUri.dirname(r)),s==="copy"){if(c===t&&(0,b.hasFileFolderCopyCapability)(c))await c.copy(l,r,{overwrite:o});else{const h=await this.resolve(l);h.isDirectory?await this.doCopyFolder(c,h,t,r):await this.doCopyFile(c,l,t,r)}return s}else return c===t?(await c.rename(l,r,{overwrite:o}),s):(await this.doMoveCopy(c,l,t,r,"copy",o),await this.del(l,{recursive:!0}),"copy")}async doCopyFile(c,l,t,r){if((0,b.hasOpenReadWriteCloseCapability)(c)&&(0,b.hasOpenReadWriteCloseCapability)(t))return this.doPipeBuffered(c,l,t,r);if((0,b.hasOpenReadWriteCloseCapability)(c)&&(0,b.hasReadWriteCapability)(t))return this.doPipeBufferedToUnbuffered(c,l,t,r);if((0,b.hasReadWriteCapability)(c)&&(0,b.hasOpenReadWriteCloseCapability)(t))return this.doPipeUnbufferedToBuffered(c,l,t,r);if((0,b.hasReadWriteCapability)(c)&&(0,b.hasReadWriteCapability)(t))return this.doPipeUnbuffered(c,l,t,r)}async doCopyFolder(c,l,t,r){await t.mkdir(r),Array.isArray(l.children)&&await p.Promises.settled(l.children.map(async s=>{const o=this.getExtUri(t).providerExtUri.joinPath(r,s.name);return s.isDirectory?this.doCopyFolder(c,await this.resolve(s.resource),t,o):this.doCopyFile(c,s.resource,t,o)}))}async doValidateMoveCopy(c,l,t,r,s,o){let d=!1;if(c===t){const{providerExtUri:h,isPathCaseSensitive:P}=this.getExtUri(c);if(P||(d=h.isEqual(l,r)),d&&s==="copy")throw new Error((0,m.localize)(14,null,this.resourceForError(l),this.resourceForError(r)));if(!d&&h.isEqualOrParent(r,l))throw new Error((0,m.localize)(15,null,this.resourceForError(l),this.resourceForError(r)))}const f=await this.exists(r);if(f&&!d){if(!o)throw new b.FileOperationError((0,m.localize)(16,null,this.resourceForError(l),this.resourceForError(r)),4);if(c===t){const{providerExtUri:h}=this.getExtUri(c);if(h.isEqualOrParent(l,r))throw new Error((0,m.localize)(17,null,this.resourceForError(l),this.resourceForError(r)))}}return{exists:f,isSameResourceWithDifferentPathCase:d}}getExtUri(c){const l=this.isPathCaseSensitive(c);return{providerExtUri:l?n.extUri:n.extUriIgnorePathCase,isPathCaseSensitive:l}}isPathCaseSensitive(c){return!!(c.capabilities&1024)}async createFolder(c){const l=this.throwIfFileSystemIsReadonly(await this.withProvider(c),c);await this.mkdirp(l,c);const t=await this.resolve(c,{resolveMetadata:!0});return this._onDidRunOperation.fire(new b.FileOperationEvent(c,0,t)),t}async mkdirp(c,l){const t=[],{providerExtUri:r}=this.getExtUri(c);for(;!r.isEqual(l,r.dirname(l));)try{if(((await c.stat(l)).type&b.FileType.Directory)==0)throw new Error((0,m.localize)(18,null,this.resourceForError(l)));break}catch(s){if((0,b.toFileSystemProviderErrorCode)(s)!==b.FileSystemProviderErrorCode.FileNotFound)throw s;t.push(r.basename(l)),l=r.dirname(l)}for(let s=t.length-1;s>=0;s--){l=r.joinPath(l,t[s]);try{await c.mkdir(l)}catch(o){if((0,b.toFileSystemProviderErrorCode)(o)!==b.FileSystemProviderErrorCode.FileExists)throw o}}}async canDelete(c,l){try{await this.doValidateDelete(c,l)}catch(t){return t}return!0}async doValidateDelete(c,l){const t=this.throwIfFileSystemIsReadonly(await this.withProvider(c),c);if(!!(l==null?void 0:l.useTrash)&&!(t.capabilities&4096))throw new Error((0,m.localize)(19,null,this.resourceForError(c)));let s;try{s=await t.stat(c)}catch(d){}if(s)this.throwIfFileIsReadonly(c,s);else throw new b.FileOperationError((0,m.localize)(20,null,this.resourceForError(c)),1);if(!!!(l==null?void 0:l.recursive)){const d=await this.resolve(c);if(d.isDirectory&&Array.isArray(d.children)&&d.children.length>0)throw new Error((0,m.localize)(21,null,this.resourceForError(c)))}return t}async del(c,l){const t=await this.doValidateDelete(c,l),r=!!(l==null?void 0:l.useTrash),s=!!(l==null?void 0:l.recursive);await t.delete(c,{recursive:s,useTrash:r}),this._onDidRunOperation.fire(new b.FileOperationEvent(c,1))}watch(c,l={recursive:!1,excludes:[]}){let t=!1,r=()=>{t=!0};return this.doWatch(c,l).then(s=>{t?(0,A.dispose)(s):r=()=>(0,A.dispose)(s)},s=>this.logService.error(s)),(0,A.toDisposable)(()=>r())}async doWatch(c,l){const t=await this.withProvider(c),r=this.toWatchKey(t,c,l),s=this.activeWatchers.get(r)||{count:0,disposable:t.watch(c,l)};return this.activeWatchers.has(r)||this.activeWatchers.set(r,s),s.count+=1,(0,A.toDisposable)(()=>{s.count--,s.count===0&&((0,A.dispose)(s.disposable),this.activeWatchers.delete(r))})}toWatchKey(c,l,t){const{providerExtUri:r}=this.getExtUri(c);return[r.getComparisonKey(l),String(t.recursive),t.excludes.join()].join()}dispose(){super.dispose(),this.activeWatchers.forEach(c=>(0,A.dispose)(c.disposable)),this.activeWatchers.clear()}async doWriteBuffered(c,l,t,r){return this.writeQueue.queueFor(l,this.getExtUri(c).providerExtUri).queue(async()=>{var s;const o=await c.open(l,{create:!0,unlock:(s=t==null?void 0:t.unlock)!==null&&s!==void 0?s:!1});try{(0,M.isReadableStream)(r)||(0,M.isReadableBufferedStream)(r)?await this.doWriteStreamBufferedQueued(c,o,r):await this.doWriteReadableBufferedQueued(c,o,r)}catch(d){throw(0,b.ensureFileSystemProviderError)(d)}finally{await c.close(o)}})}async doWriteStreamBufferedQueued(c,l,t){let r=0,s;if((0,M.isReadableBufferedStream)(t)){if(t.buffer.length>0){const o=I.VSBuffer.concat(t.buffer);await this.doWriteBuffer(c,l,o,o.byteLength,r,0),r+=o.byteLength}if(t.ended)return;s=t.stream}else s=t;return new Promise(async(o,d)=>{(0,M.listenStream)(s,{onData:async f=>{s.pause();try{await this.doWriteBuffer(c,l,f,f.byteLength,r,0)}catch(h){return d(h)}r+=f.byteLength,setTimeout(()=>s.resume())},onError:f=>d(f),onEnd:()=>o()})})}async doWriteReadableBufferedQueued(c,l,t){let r=0,s;for(;(s=t.read())!==null;)await this.doWriteBuffer(c,l,s,s.byteLength,r,0),r+=s.byteLength}async doWriteBuffer(c,l,t,r,s,o){let d=0;for(;d<r;)d+=await c.write(l,s+d,t.buffer,o+d,r-d)}async doWriteUnbuffered(c,l,t,r){return this.writeQueue.queueFor(l,this.getExtUri(c).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(c,l,t,r))}async doWriteUnbufferedQueued(c,l,t,r){var s;let o;r instanceof I.VSBuffer?o=r:(0,M.isReadableStream)(r)?o=await(0,I.streamToBuffer)(r):(0,M.isReadableBufferedStream)(r)?o=await(0,I.bufferedStreamToBuffer)(r):o=(0,I.readableToBuffer)(r),await c.writeFile(l,o.buffer,{create:!0,overwrite:!0,unlock:(s=t==null?void 0:t.unlock)!==null&&s!==void 0?s:!1})}async doPipeBuffered(c,l,t,r){return this.writeQueue.queueFor(r,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeBufferedQueued(c,l,t,r))}async doPipeBufferedQueued(c,l,t,r){let s,o;try{s=await c.open(l,{create:!1}),o=await t.open(r,{create:!0,unlock:!1});const d=I.VSBuffer.alloc(this.BUFFER_SIZE);let f=0,h=0,P=0;do P=await c.read(s,f,d.buffer,h,d.byteLength-h),await this.doWriteBuffer(t,o,d,P,f,h),f+=P,h+=P,h===d.byteLength&&(h=0);while(P>0)}catch(d){throw(0,b.ensureFileSystemProviderError)(d)}finally{await p.Promises.settled([typeof s=="number"?c.close(s):Promise.resolve(),typeof o=="number"?t.close(o):Promise.resolve()])}}async doPipeUnbuffered(c,l,t,r){return this.writeQueue.queueFor(r,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(c,l,t,r))}async doPipeUnbufferedQueued(c,l,t,r){return t.writeFile(r,await c.readFile(l),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(c,l,t,r){return this.writeQueue.queueFor(r,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(c,l,t,r))}async doPipeUnbufferedToBufferedQueued(c,l,t,r){const s=await t.open(r,{create:!0,unlock:!1});try{const o=await c.readFile(l);await this.doWriteBuffer(t,s,I.VSBuffer.wrap(o),o.byteLength,0,0)}catch(o){throw(0,b.ensureFileSystemProviderError)(o)}finally{await t.close(s)}}async doPipeBufferedToUnbuffered(c,l,t,r){const s=await(0,I.streamToBuffer)(this.readFileBuffered(c,l,g.CancellationToken.None));await this.doWriteUnbuffered(t,r,void 0,s)}throwIfFileSystemIsReadonly(c,l){if(c.capabilities&2048)throw new b.FileOperationError((0,m.localize)(22,null,this.resourceForError(l)),6);return c}throwIfFileIsReadonly(c,l){var t;if(((t=l.permissions)!==null&&t!==void 0?t:0)&b.FilePermission.Readonly)throw new b.FileOperationError((0,m.localize)(23,null,this.resourceForError(c)),6)}resourceForError(c){return c.scheme===v.Schemas.file?c.fsPath:c.toString(!0)}};a=he([te(0,i.ILogService)],a),e.FileService=a}),define(J[182],Z([0,1,2,21,5,3,16,8,15,30,9,6,142,92,164,166,163,172,64,95,35,20]),function($,e,m,L,A,b,E,n,w,y,i,I,M,p,g,v,D,S,a,u,c,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0;class t extends m.Disposable{constructor(s,o){var d;super();this.logService=s,this.options=o,this.BUFFER_SIZE=((d=this.options)===null||d===void 0?void 0:d.bufferSize)||64*1024,this.onDidChangeCapabilities=A.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0,this._onDidWatchErrorOccur=this._register(new A.Emitter),this.onDidErrorOccur=this._onDidWatchErrorOccur.event,this._onDidChangeFile=this._register(new A.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new i.ThrottledDelayer(0))}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,b.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(s){try{const{stat:o,symbolicLink:d}=await E.SymlinkSupport.stat(this.toFilePath(s));return{type:this.toType(o,d),ctime:o.birthtime.getTime(),mtime:o.mtime.getTime(),size:o.size}}catch(o){throw this.toFileSystemProviderError(o)}}async readdir(s){try{const o=await(0,E.readdir)(this.toFilePath(s),{withFileTypes:!0}),d=[];return await Promise.all(o.map(async f=>{try{let h;f.isSymbolicLink()?h=(await this.stat((0,w.joinPath)(s,f.name))).type:h=this.toType(f),d.push([f.name,h])}catch(h){this.logService.trace(h)}})),d}catch(o){throw this.toFileSystemProviderError(o)}}toType(s,o){let d;return(o==null?void 0:o.dangling)?d=L.FileType.Unknown:s.isFile()?d=L.FileType.File:s.isDirectory()?d=L.FileType.Directory:d=L.FileType.Unknown,o&&(d|=L.FileType.SymbolicLink),d}async readFile(s){try{const o=this.toFilePath(s);return await E.Promises.readFile(o)}catch(o){throw this.toFileSystemProviderError(o)}}readFileStream(s,o,d){const f=(0,a.newWriteableStream)(h=>l.VSBuffer.concat(h.map(P=>l.VSBuffer.wrap(P))).buffer);return(0,u.readFileIntoStream)(this,s,f,h=>h.buffer,Object.assign(Object.assign({},o),{bufferSize:this.BUFFER_SIZE}),d),f}async writeFile(s,o,d){let f;try{const h=this.toFilePath(s);if(!d.create||!d.overwrite){if(await(0,E.exists)(h)){if(!d.overwrite)throw(0,L.createFileSystemProviderError)((0,M.localize)(0,null),L.FileSystemProviderErrorCode.FileExists)}else if(!d.create)throw(0,L.createFileSystemProviderError)((0,M.localize)(1,null),L.FileSystemProviderErrorCode.FileNotFound)}f=await this.open(s,{create:!0,unlock:d.unlock}),await this.write(f,0,o,0,o.byteLength)}catch(h){throw await this.toFileSystemProviderWriteError(s,h)}finally{typeof f=="number"&&await this.close(f)}}async open(s,o){try{const d=this.toFilePath(s);if((0,L.isFileOpenForWriteOptions)(o)&&o.unlock)try{const{stat:P}=await E.SymlinkSupport.stat(d);P.mode&128||await E.Promises.chmod(d,P.mode|128)}catch(P){this.logService.trace(P)}let f;if((0,L.isFileOpenForWriteOptions)(o)){if(b.isWindows)try{await E.Promises.truncate(d,0),f="r+"}catch(P){P.code!=="ENOENT"&&this.logService.trace(P)}f||(f="w")}else f="r";const h=await E.Promises.open(d,f);return this.mapHandleToPos.set(h,0),(0,L.isFileOpenForWriteOptions)(o)&&this.writeHandles.set(h,s),h}catch(d){throw(0,L.isFileOpenForWriteOptions)(o)?await this.toFileSystemProviderWriteError(s,d):this.toFileSystemProviderError(d)}}async close(s){try{if(this.mapHandleToPos.delete(s),this.writeHandles.delete(s)&&this.canFlush)try{await E.Promises.fdatasync(s)}catch(o){this.canFlush=!1,this.logService.error(o)}return await E.Promises.close(s)}catch(o){throw this.toFileSystemProviderError(o)}}async read(s,o,d,f,h){const P=this.normalizePos(s,o);let T=null;try{const U=await E.Promises.read(s,d,f,h,P);return typeof U=="number"?T=U:T=U.bytesRead,T}catch(U){throw this.toFileSystemProviderError(U)}finally{this.updatePos(s,P,T)}}normalizePos(s,o){return o===this.mapHandleToPos.get(s)?null:o}updatePos(s,o,d){const f=this.mapHandleToPos.get(s);typeof f=="number"&&(typeof o=="number"||(typeof d=="number"?this.mapHandleToPos.set(s,f+d):this.mapHandleToPos.delete(s)))}async write(s,o,d,f,h){return(0,i.retry)(()=>this.doWrite(s,o,d,f,h),100,3)}async doWrite(s,o,d,f,h){const P=this.normalizePos(s,o);let T=null;try{const U=await E.Promises.write(s,d,f,h,P);return typeof U=="number"?T=U:T=U.bytesWritten,T}catch(U){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(s),U)}finally{this.updatePos(s,P,T)}}async mkdir(s){try{await E.Promises.mkdir(this.toFilePath(s))}catch(o){throw this.toFileSystemProviderError(o)}}async delete(s,o){try{const d=this.toFilePath(s);await this.doDelete(d,o)}catch(d){throw this.toFileSystemProviderError(d)}}async doDelete(s,o){o.recursive?await(0,E.rimraf)(s,E.RimRafMode.MOVE):await E.Promises.unlink(s)}async rename(s,o,d){const f=this.toFilePath(s),h=this.toFilePath(o);if(f!==h)try{await this.validateTargetDeleted(s,o,"move",d.overwrite),await(0,E.move)(f,h)}catch(P){throw(P.code==="EINVAL"||P.code==="EBUSY"||P.code==="ENAMETOOLONG")&&(P=new Error((0,M.localize)(2,null,(0,n.basename)(f),(0,n.basename)((0,n.dirname)(h)),P.toString()))),this.toFileSystemProviderError(P)}}async copy(s,o,d){const f=this.toFilePath(s),h=this.toFilePath(o);if(f!==h)try{await this.validateTargetDeleted(s,o,"copy",d.overwrite),await(0,E.copy)(f,h,{preserveSymlinks:!0})}catch(P){throw(P.code==="EINVAL"||P.code==="EBUSY"||P.code==="ENAMETOOLONG")&&(P=new Error((0,M.localize)(3,null,(0,n.basename)(f),(0,n.basename)((0,n.dirname)(h)),P.toString()))),this.toFileSystemProviderError(P)}}async validateTargetDeleted(s,o,d,f){const h=this.toFilePath(s),P=this.toFilePath(o);let T=!1;if(!!(this.capabilities&1024)||(T=(0,y.isEqual)(h,P,!0)),T&&d==="copy")throw(0,L.createFileSystemProviderError)((0,M.localize)(4,null),L.FileSystemProviderErrorCode.FileExists);if(!T&&await(0,E.exists)(P)){if(!f)throw(0,L.createFileSystemProviderError)((0,M.localize)(5,null),L.FileSystemProviderErrorCode.FileExists);await this.delete(o,{recursive:!0,useTrash:!1})}}watch(s,o){return o.recursive?this.watchRecursive(s,o.excludes):this.watchNonRecursive(s)}watchRecursive(s,o){const d={path:this.toFilePath(s),excludes:o},f=(0,c.insert)(this.recursiveFoldersToWatch,d);return this.refreshRecursiveWatchers(),(0,m.toDisposable)(()=>{f(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(async()=>{this.doRefreshRecursiveWatchers()})}doRefreshRecursiveWatchers(){var s,o,d;if(this.recursiveWatcher instanceof D.FileWatcher)this.recursiveWatcher.setFolders(this.recursiveFoldersToWatch);else if((0,m.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,this.recursiveFoldersToWatch.length>0){let f,h;((o=(s=this.options)===null||s===void 0?void 0:s.watcher)===null||o===void 0?void 0:o.usePolling)?(f=g.FileWatcher,h=(d=this.options)===null||d===void 0?void 0:d.watcher):this.recursiveFoldersToWatch.length===1?b.isWindows?f=v.FileWatcher:f=g.FileWatcher:f=D.FileWatcher,this.recursiveWatcher=new f(this.recursiveFoldersToWatch,P=>this._onDidChangeFile.fire((0,p.toFileChanges)(P)),P=>{P.type==="error"&&this._onDidWatchErrorOccur.fire(P.message),this.logService[P.type](P.message)},this.logService.getLevel()===I.LogLevel.Trace,h),this.recursiveWatcherLogLevelListener||(this.recursiveWatcherLogLevelListener=this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher&&this.recursiveWatcher.setVerboseLogging(this.logService.getLevel()===I.LogLevel.Trace)}))}}watchNonRecursive(s){const o=new S.FileWatcher(this.toFilePath(s),f=>this._onDidChangeFile.fire((0,p.toFileChanges)(f)),f=>{f.type==="error"&&this._onDidWatchErrorOccur.fire(f.message),this.logService[f.type](f.message)},this.logService.getLevel()===I.LogLevel.Trace),d=this.logService.onDidChangeLogLevel(()=>{o.setVerboseLogging(this.logService.getLevel()===I.LogLevel.Trace)});return(0,m.combinedDisposable)(o,d)}toFilePath(s){return(0,n.normalize)(s.fsPath)}toFileSystemProviderError(s){if(s instanceof L.FileSystemProviderError)return s;let o;switch(s.code){case"ENOENT":o=L.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":o=L.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":o=L.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":o=L.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":o=L.FileSystemProviderErrorCode.NoPermissions;break;default:o=L.FileSystemProviderErrorCode.Unknown}return(0,L.createFileSystemProviderError)(s,o)}async toFileSystemProviderWriteError(s,o){let d=this.toFileSystemProviderError(o);if(s&&d.code===L.FileSystemProviderErrorCode.NoPermissions)try{const{stat:f}=await E.SymlinkSupport.stat(this.toFilePath(s));f.mode&128||(d=(0,L.createFileSystemProviderError)(o,L.FileSystemProviderErrorCode.FileWriteLocked))}catch(f){this.logService.trace(f)}return d}dispose(){super.dispose(),(0,m.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,(0,m.dispose)(this.recursiveWatcherLogLevelListener),this.recursiveWatcherLogLevelListener=void 0}}e.DiskFileSystemProvider=t}),define(J[22],Z([0,1,4]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProductService=void 0,e.IProductService=(0,m.createDecorator)("productService")}),define(J[183],Z([0,1,58,6,22]),function($,e,m,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionUrlTrustService=void 0;let b=class{constructor(n,w){this.productService=n,this.logService=w,this.trustedExtensionUrlPublicKeys=new Map}async isExtensionUrlTrusted(n,w){if(!this.productService.trustedExtensionUrlPublicKeys)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","There are no configured trusted keys"),!1;const y=/^(.*)#([^#]+)$/.exec(w);if(!y)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri has no fragment",w),!1;const[,i,I]=y;let M=this.trustedExtensionUrlPublicKeys.get(n);if(!M){if(M=this.productService.trustedExtensionUrlPublicKeys[n],!M||M.length===0)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Extension doesn't have any trusted keys",n),!1;this.trustedExtensionUrlPublicKeys.set(n,[...M])}const p=Buffer.from(decodeURIComponent(I),"base64");if(p.length<=6)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri fragment is not a signature",w),!1;const g=p.slice(0,6),v=p.readUIntBE(0,6),D=Date.now()-v;if(D<0||D>36e5)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri has expired",w),!1;const S=p.slice(6),a=m.createVerify("SHA256");a.write(g),a.write(Buffer.from(i)),a.end();for(let u=0;u<M.length;u++){let c=M[u];if(c!==null){if(typeof c=="string")try{c=m.createPublicKey({key:Buffer.from(c,"base64"),format:"der",type:"spki"}),M[u]=c}catch(l){this.logService.warn("ExtensionUrlTrustService#isExtensionUrlTrusted",`Failed to parse trusted extension uri public key #${u+1} for ${n}:`,l),M[u]=null;continue}if(a.verify(c,S))return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri is valid",w),!0}}return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri could not be verified",w),!1}};b=he([te(0,A.IProductService),te(1,L.ILogService)],b),e.ExtensionUrlTrustService=b}),define(J[55],Z([0,1,4]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProtocolMainService=void 0,e.IProtocolMainService=(0,m.createDecorator)("protocolMainService")}),define(J[184],Z([0,1,2,10,7,53,14,6,36,3,15,27]),function($,e,m,L,A,b,E,n,w,y,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProtocolMainService=void 0;let M=class extends m.Disposable{constructor(g,v){super();this.logService=v,this.validRoots=w.TernarySearchTree.forUris(()=>!y.isLinux),this.validExtensions=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp"]),this.addValidFileRoot(A.URI.file(g.appRoot)),this.addValidFileRoot(A.URI.file(g.extensionsPath)),this.addValidFileRoot(g.globalStorageHome),this.addValidFileRoot(g.workspaceStorageHome),this.handleProtocols()}handleProtocols(){const{defaultSession:g}=E.session;g.protocol.registerFileProtocol(L.Schemas.vscodeFileResource,(v,D)=>this.handleResourceRequest(v,D)),g.protocol.interceptFileProtocol(L.Schemas.file,(v,D)=>this.handleFileRequest(v,D)),this._register((0,m.toDisposable)(()=>{g.protocol.unregisterProtocol(L.Schemas.vscodeFileResource),g.protocol.uninterceptProtocol(L.Schemas.file)}))}addValidFileRoot(g){return this.validRoots.get(g)?m.Disposable.None:(this.validRoots.set(g,!0),(0,m.toDisposable)(()=>this.validRoots.delete(g)))}handleFileRequest(g,v){const D=A.URI.parse(g.url);return y.isPreferringBrowserCodeLoad?(this.logService.error(`Refused to load resource ${D.fsPath} from ${L.Schemas.file}: protocol (original URL: ${g.url})`),v({error:-3})):this.validRoots.findSubstr(D)?v({path:D.fsPath}):this.validExtensions.has((0,i.extname)(D))?v({path:D.fsPath}):(this.logService.error(`${L.Schemas.file}: Refused to load resource ${D.fsPath} from ${L.Schemas.file}: protocol (original URL: ${g.url})`),v({error:-3}))}handleResourceRequest(g,v){const D=A.URI.parse(g.url),S=L.FileAccess.asFileUri(D);return this.validRoots.findSubstr(S)?v({path:S.fsPath}):this.validExtensions.has((0,i.extname)(S))?v({path:S.fsPath}):(this.logService.error(`${L.Schemas.vscodeFileResource}: Refused to load resource ${S.fsPath} from ${L.Schemas.vscodeFileResource}: protocol (original URL: ${g.url})`),v({error:-3}))}createIPCObjectUrl(){let g;const v=A.URI.from({scheme:"vscode",path:(0,I.generateUuid)()}),D=v.toString(),S=async()=>g;return E.ipcMain.handle(D,S),this.logService.trace(`IPC Object URL: Registered new channel ${D}.`),{resource:v,update:a=>g=a,dispose:()=>{this.logService.trace(`IPC Object URL: Removed channel ${D}.`),E.ipcMain.removeHandler(D)}}}};M=he([te(0,b.INativeEnvironmentService),te(1,n.ILogService)],M),e.ProtocolMainService=M}),define(J[37],Z([0,1,13,102]),function($,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class A{constructor(){this.data=new Map}add(E,n){L.ok(m.isString(E)),L.ok(m.isObject(n)),L.ok(!this.data.has(E),"There is already an extension with this id"),this.data.set(E,n)}knows(E){return this.data.has(E)}as(E){return this.data.get(E)||null}}e.Registry=new A}),define(J[185],Z([0,1,37,5]),function($,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function A(n){return n.length>0&&n.charAt(n.length-1)==="#"?n.substring(0,n.length-1):n}class b{constructor(){this._onDidChangeSchema=new L.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(w,y){this.schemasById[A(w)]=y,this._onDidChangeSchema.fire(w)}notifySchemaChanged(w){this._onDidChangeSchema.fire(w)}getSchemaContributions(){return{schemas:this.schemasById}}}const E=new b;m.Registry.add(e.Extensions.JSONContribution,E)}),define(J[48],Z([0,1,132,5,37,13,185]),function($,e,m,L,A,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=void 0,e.Extensions={Configuration:"base.contributions.configuration"};var n;(function(D){D[D.APPLICATION=1]="APPLICATION",D[D.MACHINE=2]="MACHINE",D[D.WINDOW=3]="WINDOW",D[D.RESOURCE=4]="RESOURCE",D[D.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",D[D.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(n=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const w=A.Registry.as(E.Extensions.JSONContribution);class y{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new L.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new L.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:m.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},w.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(S,a=!0){this.registerConfigurations([S],a)}registerConfigurations(S,a=!0){const u=[];S.forEach(c=>{u.push(...this.validateAndRegisterProperties(c,a,c.extensionInfo)),this.configurationContributors.push(c),this.registerJSONConfiguration(c)}),w.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(u)}deregisterConfigurations(S){const a=[],u=c=>{if(c.properties)for(const l in c.properties)a.push(l),delete this.configurationProperties[l],this.removeFromSchema(l,c.properties[l]);c.allOf&&c.allOf.forEach(l=>u(l))};for(const c of S){u(c);const l=this.configurationContributors.indexOf(c);l!==-1&&this.configurationContributors.splice(l,1)}w.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(a)}registerDefaultConfigurations(S){const a=[],u=[];for(const c of S)for(const l in c)if(a.push(l),e.OVERRIDE_PROPERTY_PATTERN.test(l)){this.defaultValues[l]=Object.assign(Object.assign({},this.defaultValues[l]||{}),c[l]);const t={type:"object",default:this.defaultValues[l],description:m.localize(1,null,l),$ref:e.resourceLanguageSettingsSchemaId};u.push(I(l)),this.configurationProperties[l]=t,this.defaultLanguageConfigurationOverridesNode.properties[l]=t}else{this.defaultValues[l]=c[l];const t=this.configurationProperties[l];t&&(this.updatePropertyDefaultValue(l,t),this.updateSchema(l,t))}this.registerOverrideIdentifiers(u),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(a)}deregisterDefaultConfigurations(S){const a=[];for(const u of S)for(const c in u)if(a.push(c),delete this.defaultValues[c],e.OVERRIDE_PROPERTY_PATTERN.test(c))delete this.configurationProperties[c],delete this.defaultLanguageConfigurationOverridesNode.properties[c];else{const l=this.configurationProperties[c];l&&(this.updatePropertyDefaultValue(c,l),this.updateSchema(c,l))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(a)}notifyConfigurationSchemaUpdated(...S){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(S){for(const a of S)this.overrideIdentifiers.add(a);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(S,a=!0,u,c=3){var l;c=b.isUndefinedOrNull(S.scope)?c:S.scope;let t=[],r=S.properties;if(r)for(let o in r){if(a&&g(o)){delete r[o];continue}const d=r[o];if(this.updatePropertyDefaultValue(o,d),e.OVERRIDE_PROPERTY_PATTERN.test(o)?d.scope=void 0:(d.scope=b.isUndefinedOrNull(d.scope)?c:d.scope,d.restricted=b.isUndefinedOrNull(d.restricted)?!!((l=u==null?void 0:u.restrictedConfigurations)===null||l===void 0?void 0:l.includes(o)):d.restricted),r[o].hasOwnProperty("included")&&!r[o].included){this.excludedConfigurationProperties[o]=r[o],delete r[o];continue}else this.configurationProperties[o]=r[o];!r[o].deprecationMessage&&r[o].markdownDeprecationMessage&&(r[o].deprecationMessage=r[o].markdownDeprecationMessage),t.push(o)}let s=S.allOf;if(s)for(let o of s)t.push(...this.validateAndRegisterProperties(o,a,u,c));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(S){const a=u=>{let c=u.properties;if(c)for(const t in c)this.updateSchema(t,c[t]);let l=u.allOf;l&&l.forEach(a)};a(S)}updateSchema(S,a){switch(e.allSettings.properties[S]=a,a.scope){case 1:e.applicationSettings.properties[S]=a;break;case 2:e.machineSettings.properties[S]=a;break;case 6:e.machineOverridableSettings.properties[S]=a;break;case 3:e.windowSettings.properties[S]=a;break;case 4:e.resourceSettings.properties[S]=a;break;case 5:e.resourceSettings.properties[S]=a,this.resourceLanguageSettingsSchema.properties[S]=a;break}}removeFromSchema(S,a){switch(delete e.allSettings.properties[S],a.scope){case 1:delete e.applicationSettings.properties[S];break;case 2:delete e.machineSettings.properties[S];break;case 6:delete e.machineOverridableSettings.properties[S];break;case 3:delete e.windowSettings.properties[S];break;case 4:case 5:delete e.resourceSettings.properties[S];break}}updateOverridePropertyPatternKey(){for(const S of this.overrideIdentifiers.values()){const a=`[${S}]`,u={type:"object",description:m.localize(2,null),errorMessage:m.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(a,u),e.allSettings.properties[a]=u,e.applicationSettings.properties[a]=u,e.machineSettings.properties[a]=u,e.machineOverridableSettings.properties[a]=u,e.windowSettings.properties[a]=u,e.resourceSettings.properties[a]=u}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(S,a){let u=this.defaultValues[S];b.isUndefined(u)&&(u=a.default),b.isUndefined(u)&&(u=M(a.type)),a.default=u}}const i="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(i);function I(D){return D.substring(1,D.length-1)}e.overrideIdentifierFromKey=I;function M(D){switch(Array.isArray(D)?D[0]:D){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=M;const p=new y;A.Registry.add(e.Extensions.Configuration,p);function g(D){return D.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(D)?m.localize(5,null,D):p.getConfigurationProperties()[D]!==void 0?m.localize(6,null,D):null:m.localize(4,null)}e.validateProperty=g;function v(){const D=[],S=p.getConfigurationProperties();for(const a of Object.keys(S))D.push([a,S[a].scope]);return D.push(["launch",4]),D.push(["task",4]),D}e.getScopes=v}),define(J[17],Z([0,1,44,13,7,37,4,48]),function($,e,m,L,A,b,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,E.createDecorator)("configurationService");function w(r){return r&&typeof r=="object"&&(!r.overrideIdentifier||typeof r.overrideIdentifier=="string")&&(!r.resource||r.resource instanceof A.URI)}e.isConfigurationOverrides=w;var y;(function(r){r[r.USER=1]="USER",r[r.USER_LOCAL=2]="USER_LOCAL",r[r.USER_REMOTE=3]="USER_REMOTE",r[r.WORKSPACE=4]="WORKSPACE",r[r.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",r[r.DEFAULT=6]="DEFAULT",r[r.MEMORY=7]="MEMORY"})(y=e.ConfigurationTarget||(e.ConfigurationTarget={}));function i(r){switch(r){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=i;function I(r,s){const o=s?r?s.keys.filter(q=>r.keys.indexOf(q)===-1):[...s.keys]:[],d=r?s?r.keys.filter(q=>s.keys.indexOf(q)===-1):[...r.keys]:[],f=[];if(s&&r){for(const q of r.keys)if(s.keys.indexOf(q)!==-1){const Q=S(r.contents,q),x=S(s.contents,q);m.equals(Q,x)||f.push(q)}}const h=[],P=q=>{const Q={};for(const x of q)for(const j of x.identifiers)Q[l(j)]=x;return Q},T=s?P(s.overrides):{},U=r?P(r.overrides):{};if(Object.keys(T).length)for(const q of o){const Q=T[q];Q&&h.push([(0,n.overrideIdentifierFromKey)(q),Q.keys])}if(Object.keys(U).length)for(const q of d){const Q=U[q];Q&&h.push([(0,n.overrideIdentifierFromKey)(q),Q.keys])}if(Object.keys(T).length&&Object.keys(U).length)for(const q of f){const Q=U[q],x=T[q];if(Q&&x){const j=I({contents:Q.contents,keys:Q.keys,overrides:[]},{contents:x.contents,keys:x.keys,overrides:[]});h.push([(0,n.overrideIdentifierFromKey)(q),[...j.added,...j.removed,...j.updated]])}}return{added:o,removed:d,updated:f,overrides:h}}e.compare=I;function M(r,s){const o=[];for(const d of Object.keys(r))if(n.OVERRIDE_PROPERTY_PATTERN.test(d)){const f={};for(const h in r[d])f[h]=r[d][h];o.push({identifiers:[(0,n.overrideIdentifierFromKey)(d).trim()],keys:Object.keys(f),contents:p(f,s)})}return o}e.toOverrides=M;function p(r,s){const o=Object.create(null);for(let d in r)g(o,d,r[d],s);return o}e.toValuesTree=p;function g(r,s,o,d){const f=s.split("."),h=f.pop();let P=r;for(let T=0;T<f.length;T++){let U=f[T],q=P[U];switch(typeof q){case"undefined":q=P[U]=Object.create(null);break;case"object":break;default:d(`Ignoring ${s} as ${f.slice(0,T+1).join(".")} is ${JSON.stringify(q)}`);return}P=q}if(typeof P=="object"&&P!==null)try{P[h]=o}catch(T){d(`Ignoring ${s} as ${f.join(".")} is ${JSON.stringify(P)}`)}else d(`Ignoring ${s} as ${f.join(".")} is ${JSON.stringify(P)}`)}e.addToValueTree=g;function v(r,s){const o=s.split(".");D(r,o)}e.removeFromValueTree=v;function D(r,s){const o=s.shift();if(s.length===0){delete r[o];return}if(Object.keys(r).indexOf(o)!==-1){const d=r[o];typeof d=="object"&&!Array.isArray(d)&&(D(d,s),Object.keys(d).length===0&&delete r[o])}}function S(r,s,o){function d(P,T){let U=P;for(const q of T){if(typeof U!="object"||U===null)return;U=U[q]}return U}const f=s.split("."),h=d(r,f);return typeof h=="undefined"?o:h}e.getConfigurationValue=S;function a(r,s,o){Object.keys(s).forEach(d=>{d!=="__proto__"&&(d in r?L.isObject(r[d])&&L.isObject(s[d])?a(r[d],s[d],o):o&&(r[d]=s[d]):r[d]=s[d])})}e.merge=a;function u(){const r=b.Registry.as(n.Extensions.Configuration).getConfigurationProperties();return Object.keys(r)}e.getConfigurationKeys=u;function c(){const r=Object.create(null),s=b.Registry.as(n.Extensions.Configuration).getConfigurationProperties();for(let o in s){let d=s[o].default;g(r,o,d,f=>console.error(`Conflict in default settings: ${f}`))}return r}e.getDefaultValues=c;function l(r){return`[${r}]`}e.keyFromOverrideIdentifier=l;function t(r,s,o){const d=r.inspect(s),f=r.inspect(o);return typeof d.userValue!="undefined"||typeof d.workspaceValue!="undefined"||typeof d.workspaceFolderValue!="undefined"?d.value:typeof f.userValue!="undefined"||typeof f.workspaceValue!="undefined"||typeof f.workspaceFolderValue!="undefined"?f.value:d.defaultValue}e.getMigratedSettingValue=t}),define(J[186],Z([0,1,43,36,35,13,44,7,48,17,37,2,5]),function($,e,m,L,A,b,E,n,w,y,i,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class p{constructor(t={},r=[],s=[]){this._contents=t,this._keys=r,this._overrides=s,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,y.getConfigurationValue)(this.contents,t):this.contents}getOverrideValue(t,r){const s=this.getContentsForOverrideIdentifer(r);return s?t?(0,y.getConfigurationValue)(s,t):s:void 0}getKeysForOverrideIdentifier(t){for(const r of this.overrides)if(r.identifiers.indexOf(t)!==-1)return r.keys;return[]}override(t){const r=this.getContentsForOverrideIdentifer(t);if(!r||typeof r!="object"||!Object.keys(r).length)return this;let s={};for(const o of A.distinct([...Object.keys(this.contents),...Object.keys(r)])){let d=this.contents[o],f=r[o];f&&(typeof d=="object"&&typeof f=="object"?(d=E.deepClone(d),this.mergeContents(d,f)):d=f),s[o]=d}return new p(s,this.keys,this.overrides)}merge(...t){const r=E.deepClone(this.contents),s=E.deepClone(this.overrides),o=[...this.keys];for(const d of t){this.mergeContents(r,d.contents);for(const f of d.overrides){const[h]=s.filter(P=>A.equals(P.identifiers,f.identifiers));h?this.mergeContents(h.contents,f.contents):s.push(E.deepClone(f))}for(const f of d.keys)o.indexOf(f)===-1&&o.push(f)}return new p(r,o,s)}freeze(){return this.isFrozen=!0,this}mergeContents(t,r){for(const s of Object.keys(r)){if(s in t&&b.isObject(t[s])&&b.isObject(r[s])){this.mergeContents(t[s],r[s]);continue}t[s]=E.deepClone(r[s])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?E.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const r of this.overrides)if(r.identifiers.indexOf(t)!==-1)return r.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,r){this.addKey(t),(0,y.addToValueTree)(this.contents,t,r,s=>{throw new Error(s)})}removeValue(t){this.removeKey(t)&&(0,y.removeFromValueTree)(this.contents,t)}addKey(t){let r=this.keys.length;for(let s=0;s<r;s++)t.indexOf(this.keys[s])===0&&(r=s);this.keys.splice(r,1,t)}removeKey(t){let r=this.keys.indexOf(t);return r!==-1?(this.keys.splice(r,1),!0):!1}}e.ConfigurationModel=p;class g extends p{constructor(){const t=(0,y.getDefaultValues)(),r=(0,y.getConfigurationKeys)(),s=[];for(const o of Object.keys(t))w.OVERRIDE_PROPERTY_PATTERN.test(o)&&s.push({identifiers:[(0,w.overrideIdentifierFromKey)(o).trim()],keys:Object.keys(t[o]),contents:(0,y.toValuesTree)(t[o],d=>console.error(`Conflict in default settings file: ${d}`))});super(t,r,s)}}e.DefaultConfigurationModel=g;class v{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new p}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,r){if(!b.isUndefinedOrNull(t)){const s=this.doParseContent(t);this.parseRaw(s,r)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,r){this._raw=t;const{contents:s,keys:o,overrides:d,restricted:f}=this.doParseRaw(t,r);this._configurationModel=new p(s,o,d),this._restrictedConfigurations=f||[]}doParseContent(t){let r={},s=null,o=[],d=[],f=[];function h(T){Array.isArray(o)?o.push(T):s&&(o[s]=T)}let P={onObjectBegin:()=>{let T={};h(T),d.push(o),o=T,s=null},onObjectProperty:T=>{s=T},onObjectEnd:()=>{o=d.pop()},onArrayBegin:()=>{let T=[];h(T),d.push(o),o=T,s=null},onArrayEnd:()=>{o=d.pop()},onLiteralValue:h,onError:(T,U,q)=>{f.push({error:T,offset:U,length:q})}};if(t)try{m.visit(t,P),r=o[0]||{}}catch(T){console.error(`Error while parsing settings file ${this._name}: ${T}`),this._parseErrors=[T]}return r}doParseRaw(t,r){const s=i.Registry.as(w.Extensions.Configuration).getConfigurationProperties(),o=this.filter(t,s,!0,r);t=o.raw;const d=(0,y.toValuesTree)(t,P=>console.error(`Conflict in settings file ${this._name}: ${P}`)),f=Object.keys(t),h=(0,y.toOverrides)(t,P=>console.error(`Conflict in settings file ${this._name}: ${P}`));return{contents:d,keys:f,overrides:h,restricted:o.restricted}}filter(t,r,s,o){if(!(o==null?void 0:o.scopes)&&!(o==null?void 0:o.skipRestricted))return{raw:t,restricted:[]};const d={},f=[];for(let h in t)if(w.OVERRIDE_PROPERTY_PATTERN.test(h)&&s){const P=this.filter(t[h],r,!1,o);d[h]=P.raw,f.push(...P.restricted)}else{const P=r[h],T=P?typeof P.scope!="undefined"?P.scope:3:void 0;(P==null?void 0:P.restricted)&&f.push(h),(T===void 0||o.scopes===void 0||o.scopes.includes(T))&&(o.skipRestricted&&(P==null?void 0:P.restricted)||(d[h]=t[h]))}return{raw:d,restricted:f}}}e.ConfigurationModelParser=v;class D extends I.Disposable{constructor(t,r,s,o){super();this.userSettingsResource=t,this.scopes=r,this.fileService=o,this._onDidChange=this._register(new M.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new v(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(s.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(M.Event.filter(this.fileService.onDidFilesChange,d=>d.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new p}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=D;class S{constructor(t,r,s=new p,o=new p,d=new L.ResourceMap,f=new p,h=new L.ResourceMap,P=!0){this._defaultConfiguration=t,this._localUserConfiguration=r,this._remoteUserConfiguration=s,this._workspaceConfiguration=o,this._folderConfigurations=d,this._memoryConfiguration=f,this._memoryConfigurationByResource=h,this._freeze=P,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new L.ResourceMap,this._userConfiguration=null}getValue(t,r,s){return this.getConsolidateConfigurationModel(r,s).getValue(t)}updateValue(t,r,s={}){let o;s.resource?(o=this._memoryConfigurationByResource.get(s.resource),o||(o=new p,this._memoryConfigurationByResource.set(s.resource,o))):o=this._memoryConfiguration,r===void 0?o.removeValue(t):o.setValue(t,r),s.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,r,s){const o=this.getConsolidateConfigurationModel(r,s),d=this.getFolderConfigurationModelForResource(r.resource,s),f=r.resource?this._memoryConfigurationByResource.get(r.resource)||this._memoryConfiguration:this._memoryConfiguration,h=r.overrideIdentifier?this._defaultConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),P=r.overrideIdentifier?this.userConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),T=r.overrideIdentifier?this.localUserConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),U=r.overrideIdentifier?this.remoteUserConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),q=s?r.overrideIdentifier?this._workspaceConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,Q=d?r.overrideIdentifier?d.freeze().override(r.overrideIdentifier).getValue(t):d.freeze().getValue(t):void 0,x=r.overrideIdentifier?f.override(r.overrideIdentifier).getValue(t):f.getValue(t),j=o.getValue(t),X=A.distinct(A.flatten(o.overrides.map(B=>B.identifiers))).filter(B=>o.getOverrideValue(t,B)!==void 0);return{defaultValue:h,userValue:P,userLocalValue:T,userRemoteValue:U,workspaceValue:q,workspaceFolderValue:Q,memoryValue:x,value:j,default:h!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,user:P!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,userLocal:T!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,userRemote:U!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,workspace:q!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,workspaceFolder:Q!==void 0?{value:d==null?void 0:d.freeze().getValue(t),override:r.overrideIdentifier?d==null?void 0:d.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,memory:x!==void 0?{value:f.getValue(t),override:r.overrideIdentifier?f.getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,overrideIdentifiers:X.length?X:void 0}}keys(t){const r=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:r?r.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,r){this._folderConfigurations.set(t,r),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,r){const s=r.filter(o=>w.OVERRIDE_PROPERTY_PATTERN.test(o)).map(o=>{const d=(0,w.overrideIdentifierFromKey)(o),f=this._defaultConfiguration.getKeysForOverrideIdentifier(d),h=t.getKeysForOverrideIdentifier(d),P=[...h.filter(T=>f.indexOf(T)===-1),...f.filter(T=>h.indexOf(T)===-1),...f.filter(T=>!E.equals(this._defaultConfiguration.override(d).getValue(T),t.override(d).getValue(T)))];return[d,P]});return this.updateDefaultConfiguration(t),{keys:r,overrides:s}}compareAndUpdateLocalUserConfiguration(t){const{added:r,updated:s,removed:o,overrides:d}=(0,y.compare)(this.localUserConfiguration,t),f=[...r,...s,...o];return f.length&&this.updateLocalUserConfiguration(t),{keys:f,overrides:d}}compareAndUpdateRemoteUserConfiguration(t){const{added:r,updated:s,removed:o,overrides:d}=(0,y.compare)(this.remoteUserConfiguration,t);let f=[...r,...s,...o];return f.length&&this.updateRemoteUserConfiguration(t),{keys:f,overrides:d}}compareAndUpdateWorkspaceConfiguration(t){const{added:r,updated:s,removed:o,overrides:d}=(0,y.compare)(this.workspaceConfiguration,t);let f=[...r,...s,...o];return f.length&&this.updateWorkspaceConfiguration(t),{keys:f,overrides:d}}compareAndUpdateFolderConfiguration(t,r){const s=this.folderConfigurations.get(t),{added:o,updated:d,removed:f,overrides:h}=(0,y.compare)(s,r);let P=[...o,...d,...f];return(P.length||!s)&&this.updateFolderConfiguration(t,r),{keys:P,overrides:h}}compareAndDeleteFolderConfiguration(t){const r=this.folderConfigurations.get(t);if(!r)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:s,updated:o,removed:d,overrides:f}=(0,y.compare)(r,void 0);return{keys:[...s,...o,...d],overrides:f}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,r){let s=this.getConsolidatedConfigurationModelForResource(t,r);return t.overrideIdentifier?s.override(t.overrideIdentifier):s}getConsolidatedConfigurationModelForResource({resource:t},r){let s=this.getWorkspaceConsolidatedConfiguration();if(r&&t){const o=r.getFolder(t);o&&(s=this.getFolderConsolidatedConfiguration(o.uri)||s);const d=this._memoryConfigurationByResource.get(t);d&&(s=s.merge(d))}return s}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let r=this._foldersConsolidatedConfigurations.get(t);if(!r){const s=this.getWorkspaceConsolidatedConfiguration(),o=this._folderConfigurations.get(t);o?(r=s.merge(o),this._freeze&&(r=r.freeze()),this._foldersConsolidatedConfigurations.set(t,r)):r=s}return r}getFolderConfigurationModelForResource(t,r){if(r&&t){const s=r.getFolder(t);if(s)return this._folderConfigurations.get(s.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,r)=>{const{contents:s,overrides:o,keys:d}=this._folderConfigurations.get(r);return t.push([r,{contents:s,overrides:o,keys:d}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(r=>t.add(r)),this.userConfiguration.freeze().keys.forEach(r=>t.add(r)),this._workspaceConfiguration.freeze().keys.forEach(r=>t.add(r)),this._folderConfigurations.forEach(r=>r.freeze().keys.forEach(s=>t.add(s))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const r=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>r.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>r.add(s)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>r.add(s)),this._folderConfigurations.forEach(s=>s.getKeysForOverrideIdentifier(t).forEach(o=>r.add(o))),[...r.values()]}static parse(t){const r=this.parseConfigurationModel(t.defaults),s=this.parseConfigurationModel(t.user),o=this.parseConfigurationModel(t.workspace),d=t.folders.reduce((f,h)=>(f.set(n.URI.revive(h[0]),this.parseConfigurationModel(h[1])),f),new L.ResourceMap);return new S(r,s,new p,o,d,new p,new L.ResourceMap,!1)}static parseConfigurationModel(t){return new p(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=S;function a(...l){if(l.length===0)return{keys:[],overrides:[]};if(l.length===1)return l[0];const t=new Set,r=new Map;for(const o of l)o.keys.forEach(d=>t.add(d)),o.overrides.forEach(([d,f])=>{const h=(0,L.getOrSet)(r,d,new Set);f.forEach(P=>h.add(P))});const s=[];return r.forEach((o,d)=>s.push([d,[...o.values()]])),{keys:[...t.values()],overrides:s}}e.mergeChanges=a;class u{constructor(t,r,s,o){this.change=t,this.previous=r,this.currentConfiguraiton=s,this.currentWorkspace=o,this._previousConfiguration=void 0;const d=new Set;t.keys.forEach(h=>d.add(h)),t.overrides.forEach(([,h])=>h.forEach(P=>d.add(P))),this.affectedKeys=[...d.values()];const f=new p;this.affectedKeys.forEach(h=>f.setValue(h,{})),this.affectedKeysTree=f.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=S.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,r){var s;if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(r){const o=this.previousConfiguration?this.previousConfiguration.getValue(t,r,(s=this.previous)===null||s===void 0?void 0:s.workspace):void 0,d=this.currentConfiguraiton.getValue(t,r,this.currentWorkspace);return!E.equals(o,d)}return!0}return!1}doesAffectedKeysTreeContains(t,r){let s=(0,y.toValuesTree)({[r]:!0},()=>{}),o;for(;typeof s=="object"&&(o=Object.keys(s)[0]);){if(t=t[o],!t)return!1;s=s[o]}return!0}}e.ConfigurationChangeEvent=u;class c extends u{constructor(t,r,s,o){super({keys:t.allKeys(),overrides:[]},void 0,t,r);this.source=s,this.sourceConfig=o}}e.AllKeysConfigurationChangeEvent=c}),define(J[187],Z([0,1,37,48,2,17,186,5,9,15]),function($,e,m,L,A,b,E,n,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class i extends A.Disposable{constructor(M,p){super();this.settingsResource=M,this._onDidChangeConfiguration=this._register(new n.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new E.UserSettings(this.settingsResource,void 0,y.extUriBiasedIgnorePathCase,p)),this.configuration=new E.Configuration(new E.DefaultConfigurationModel,new E.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new w.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(m.Registry.as(L.Extensions.Configuration).onDidUpdateConfiguration(g=>this.onDidDefaultConfigurationChange(g))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const M=await this.userConfiguration.loadConfiguration();this.configuration=new E.Configuration(new E.DefaultConfigurationModel,M)}getConfigurationData(){return this.configuration.toData()}getValue(M,p){const g=typeof M=="string"?M:void 0,v=(0,b.isConfigurationOverrides)(M)?M:(0,b.isConfigurationOverrides)(p)?p:{};return this.configuration.getValue(g,v,void 0)}updateValue(M,p,g,v){return Promise.reject(new Error("not supported"))}inspect(M){return this.configuration.inspect(M,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const M=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(M)}onDidChangeUserConfiguration(M){const p=this.configuration.toData(),g=this.configuration.compareAndUpdateLocalUserConfiguration(M);this.trigger(g,p,1)}onDidDefaultConfigurationChange(M){const p=this.configuration.toData(),g=this.configuration.compareAndUpdateDefaultConfiguration(new E.DefaultConfigurationModel,M);this.trigger(g,p,6)}trigger(M,p,g){const v=new E.ConfigurationChangeEvent(M,{data:p},this.configuration);v.source=g,v.sourceConfig=this.getTargetConfiguration(g),this._onDidChangeConfiguration.fire(v)}getTargetConfiguration(M){switch(M){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=i}),define(J[188],Z([0,1,40,8,68,138,16,3,90,17,4,10,105]),function($,e,m,L,A,b,E,n,w,y,i,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const p=b.localize(0,null);class g{async getDefaultTerminalForPlatforms(){const t=await S.getDefaultTerminalLinuxReady();return{windows:v.getDefaultTerminalWindows(),linux:t,osx:"xterm"}}}let v=class Je extends g{constructor(t){super();this._configurationService=t}openTerminal(t){const r=this._configurationService.getValue();return this.spawnTerminal(m,r,A.getWindowsShell(),t)}spawnTerminal(t,r,s,o){const d=r.terminal.external,f=(d==null?void 0:d.windowsExec)||Je.getDefaultTerminalWindows();o&&o[1]===":"&&(o=o[0].toUpperCase()+o.substr(1));const h=L.basename(f).toLowerCase();if(h==="cmder"||h==="cmder.exe")return t.spawn(f,o?[o]:void 0),Promise.resolve(void 0);const P=["/c","start","/wait"];return f.indexOf(" ")>=0&&P.push('""'),P.push(f),(h==="wt"||h==="wt.exe")&&P.push("-d ."),new Promise((T,U)=>{const q=a(process),Q=t.spawn(s,P,{cwd:o,env:q});Q.on("error",U),Q.on("exit",()=>T())})}runInTerminal(t,r,s,o,d){const f="windowsExec"in d&&d.windowsExec?d.windowsExec:Je.getDefaultTerminalWindows();return new Promise((h,P)=>{const T=`"${r} - ${p}"`,U=`""${s.join('" "')}" & pause"`,q=["/c","start",T,"/wait",f,"/c",U],Q=Object.assign({},a(process),o);Object.keys(Q).filter(X=>Q[X]===null).forEach(X=>delete Q[X]);const x={cwd:r,env:Q,windowsVerbatimArguments:!0};m.spawn(Je.CMD,q,x).on("error",X=>{P(u(X))}),h(void 0)})}static getDefaultTerminalWindows(){if(!Je._DEFAULT_TERMINAL_WINDOWS){const t=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");Je._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${t?"Sysnative":"System32"}\\cmd.exe`}return Je._DEFAULT_TERMINAL_WINDOWS}};v.CMD="cmd.exe",v=he([te(0,(0,i.optional)(y.IConfigurationService))],v),e.WindowsExternalTerminalService=v;let D=class It extends g{constructor(t){super();this._configurationService=t}openTerminal(t){const r=this._configurationService.getValue();return this.spawnTerminal(m,r,t)}runInTerminal(t,r,s,o,d){const f=d.osxExec||w.DEFAULT_TERMINAL_OSX;return new Promise((h,P)=>{if(f===w.DEFAULT_TERMINAL_OSX||f==="iTerm.app"){const T=f===w.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",q=[I.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${T}.scpt`,$).fsPath,"-t",t||p,"-w",r];for(let j of s)q.push("-a"),q.push(j);if(o)for(let j in o){const X=o[j];X===null?(q.push("-u"),q.push(j)):(q.push("-e"),q.push(`${j}=${X}`))}let Q="";const x=m.spawn(It.OSASCRIPT,q);x.on("error",j=>{P(u(j))}),x.stderr.on("data",j=>{Q+=j.toString()}),x.on("exit",j=>{if(j===0)h(void 0);else if(Q){const X=Q.split(`
`,1);P(new Error(X[0]))}else P(new Error(b.localize(1,null,T,j)))})}else P(new Error(b.localize(2,null,f)))})}spawnTerminal(t,r,s){const o=r.terminal.external,d=(o==null?void 0:o.osxExec)||w.DEFAULT_TERMINAL_OSX;return new Promise((f,h)=>{const P=["-a",d];s&&P.push(s);const T=t.spawn("/usr/bin/open",P);T.on("error",h),T.on("exit",()=>f())})}};D.OSASCRIPT="/usr/bin/osascript",D=he([te(0,(0,i.optional)(y.IConfigurationService))],D),e.MacExternalTerminalService=D;let S=class Ze extends g{constructor(t){super();this._configurationService=t}openTerminal(t){const r=this._configurationService.getValue();return this.spawnTerminal(m,r,t)}runInTerminal(t,r,s,o,d){const f=d.linuxExec?Promise.resolve(d.linuxExec):Ze.getDefaultTerminalLinuxReady();return new Promise((h,P)=>{let T=[];f.then(U=>{U.indexOf("gnome-terminal")>=0?T.push("-x"):T.push("-e"),T.push("bash"),T.push("-c");const q=`${c(s)}; echo; read -p "${Ze.WAIT_MESSAGE}" -n1;`;T.push(`''${q}''`);const Q=Object.assign({},process.env,o);Object.keys(Q).filter(B=>Q[B]===null).forEach(B=>delete Q[B]);const x={cwd:r,env:Q};let j="";const X=m.spawn(U,T,x);X.on("error",B=>{P(u(B))}),X.stderr.on("data",B=>{j+=B.toString()}),X.on("exit",B=>{if(B===0)h(void 0);else if(j){const V=j.split(`
`,1);P(new Error(V[0]))}else P(new Error(b.localize(4,null,U,B)))})})})}static async getDefaultTerminalLinuxReady(){return Ze._DEFAULT_TERMINAL_LINUX_READY||(Ze._DEFAULT_TERMINAL_LINUX_READY=new Promise(async t=>{n.isLinux?await E.exists("/etc/debian_version")?t("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?t("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?t("konsole"):process.env.COLORTERM?t(process.env.COLORTERM):process.env.TERM?t(process.env.TERM):t("xterm"):t("xterm")})),Ze._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(t,r,s){const o=r.terminal.external,d=(o==null?void 0:o.linuxExec)?Promise.resolve(o.linuxExec):Ze.getDefaultTerminalLinuxReady();return new Promise((f,h)=>{d.then(P=>{const T=a(process),U=t.spawn(P,[],{cwd:s,env:T});U.on("error",h),U.on("exit",()=>f())})})}};S.WAIT_MESSAGE=b.localize(3,null),S=he([te(0,(0,i.optional)(y.IConfigurationService))],S),e.LinuxExternalTerminalService=S;function a(l){const t=l.env;return(0,M.sanitizeProcessEnvironment)(t),t}function u(l){return"errno"in l&&l.errno==="ENOENT"&&"path"in l&&typeof l.path=="string"?new Error(b.localize(5,null,l.path)):l}function c(l){let t="";for(let r of l)r.indexOf(" ")>=0?t+='"'+r+'"':t+=r,t+=" ";return t}}),define(J[189],Z([0,1,4]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,m.createDecorator)("remoteAuthorityResolverService");var L;(function(b){b.Unknown="Unknown",b.NotAvailable="NotAvailable",b.TemporarilyNotAvailable="TemporarilyNotAvailable",b.NoResolverFound="NoResolverFound"})(L=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class A extends Error{constructor(E,n=L.Unknown,w){super(E);this._message=E,this._code=n,this._detail=w,this.isHandled=n===L.NotAvailable&&w===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,A.prototype)}static isTemporarilyNotAvailable(E){return E instanceof A&&E._code===L.TemporarilyNotAvailable}static isNoResolverFound(E){return E instanceof A&&E._code===L.NoResolverFound}static isHandled(E){return E instanceof A&&E.isHandled}}e.RemoteAuthorityResolverError=A}),define(J[190],Z([0,1,84,27,2,20,5,189,19,9,25]),function($,e,m,L,A,b,E,n,w,y,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const I=30*1e3;var M;(function(k){k[k.Management=1]="Management",k[k.ExtensionHost=2]="ExtensionHost",k[k.Tunnel=3]="Tunnel"})(M=e.ConnectionType||(e.ConnectionType={}));function p(k){switch(k){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function g(k){const O=new i.CancellationTokenSource;return setTimeout(()=>O.cancel(),k),O.token}function v(k,O){if(k.isCancellationRequested||O.isCancellationRequested)return i.CancellationToken.Cancelled;const _=new i.CancellationTokenSource;return k.onCancellationRequested(()=>_.cancel()),O.onCancellationRequested(()=>_.cancel()),_.token}class D{constructor(O){this._state="pending",this._disposables=new A.DisposableStore,this.promise=new Promise((_,K)=>{this._resolvePromise=_,this._rejectPromise=K}),O.isCancellationRequested?this._timeout():this._disposables.add(O.onCancellationRequested(()=>this._timeout()))}get didTimeout(){return this._state==="timedout"}registerDisposable(O){this._state==="pending"?this._disposables.add(O):O.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const O=new Error("Time limit reached");return O.code="ETIMEDOUT",O.syscall="connect",O}resolve(O){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(O))}reject(O){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(O))}}function S(k,O){const _=new D(O);return _.registerDisposable(k.onControlMessage(K=>{const G=JSON.parse(K.toString()),Y=C(G);Y?_.reject(Y):_.resolve(G)})),_.promise}function a(k,O,_,K,G,Y){const ee=new D(Y);return O.connect(_,K,G,(ne,re)=>{ee.didTimeout?(ne&&k.error(ne),re==null||re.dispose()):ne||!re?ee.reject(ne):ee.resolve(re)}),ee.promise}function u(k,O){const _=new D(O);return k.then(K=>{_.didTimeout||_.resolve(K)},K=>{_.didTimeout||_.reject(K)}),_.promise}async function c(k,O,_,K){const G=R(k,O);k.logService.trace(`${G} 1/6. invoking socketFactory.connect().`);let Y;try{Y=await a(k.logService,k.socketFactory,k.host,k.port,`reconnectionToken=${k.reconnectionToken}&reconnection=${k.reconnectionProtocol?"true":"false"}`,K)}catch(se){throw k.logService.error(`${G} socketFactory.connect() failed or timed out. Error:`),k.logService.error(se),se}k.logService.trace(`${G} 2/6. socketFactory.connect() was successful.`);let ee,ne;k.reconnectionProtocol?(k.reconnectionProtocol.beginAcceptReconnection(Y,null),ee=k.reconnectionProtocol,ne=!1):(ee=new m.PersistentProtocol(Y,null),ne=!0),k.logService.trace(`${G} 3/6. sending AuthRequest control message.`);const re={type:"auth",auth:k.connectionToken||"00000000000000000000"};ee.sendControl(b.VSBuffer.fromString(JSON.stringify(re)));try{const se=await S(ee,v(K,g(1e4)));if(se.type!=="sign"||typeof se.data!="string"){const ue=new Error("Unexpected handshake message");throw ue.code="VSCODE_CONNECTION_ERROR",ue}k.logService.trace(`${G} 4/6. received SignRequest control message.`);const le=await u(k.signService.sign(se.data),K),oe={type:"connectionType",commit:k.commit,signedData:le,desiredConnectionType:O};return _&&(oe.args=_),k.logService.trace(`${G} 5/6. sending ConnectionTypeRequest control message.`),ee.sendControl(b.VSBuffer.fromString(JSON.stringify(oe))),{protocol:ee,ownsProtocol:ne}}catch(se){throw se&&se.code==="ETIMEDOUT"&&(k.logService.error(`${G} the handshake timed out. Error:`),k.logService.error(se)),se&&se.code==="VSCODE_CONNECTION_ERROR"&&(k.logService.error(`${G} received error control message when negotiating connection. Error:`),k.logService.error(se)),ne&&N(ee),se}}async function l(k,O,_,K){const G=Date.now(),Y=R(k,O),{protocol:ee,ownsProtocol:ne}=await c(k,O,_,K),re=new D(K);return re.registerDisposable(ee.onControlMessage(se=>{const le=JSON.parse(se.toString()),oe=C(le);oe?(k.logService.error(`${Y} received error control message when negotiating connection. Error:`),k.logService.error(oe),ne&&N(ee),re.reject(oe)):(k.reconnectionProtocol&&k.reconnectionProtocol.endAcceptReconnection(),k.logService.trace(`${Y} 6/6. handshake finished, connection is up and running after ${W(G)}!`),re.resolve({protocol:ee,firstMessage:le}))})),re.promise}async function t(k,O){const{protocol:_}=await l(k,1,void 0,O);return{protocol:_}}async function r(k,O,_){const{protocol:K,firstMessage:G}=await l(k,2,O,_),Y=G&&G.debugPort;return{protocol:K,debugPort:Y}}async function s(k,O,_){const K=Date.now(),G=R(k,3),{protocol:Y}=await c(k,3,O,_);return k.logService.trace(`${G} 6/6. handshake finished, connection is up and running after ${W(K)}!`),Y}async function o(k,O,_){const{host:K,port:G,connectionToken:Y}=await k.addressProvider.getAddress();return{commit:k.commit,host:K,port:G,connectionToken:Y,reconnectionToken:O,reconnectionProtocol:_,socketFactory:k.socketFactory,signService:k.signService,logService:k.logService}}async function d(k,O,_){try{const K=(0,L.generateUuid)(),G=await o(k,K,null),{protocol:Y}=await t(G,i.CancellationToken.None);return new B(k,O,_,K,Y)}catch(K){throw k.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),k.logService.error(K),X.triggerPermanentFailure(0,0,n.RemoteAuthorityResolverError.isHandled(K)),K}}e.connectRemoteAgentManagement=d;async function f(k,O){try{const _=(0,L.generateUuid)(),K=await o(k,_,null),{protocol:G,debugPort:Y}=await r(K,O,i.CancellationToken.None);return new V(k,O,_,G,Y)}catch(_){throw k.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),k.logService.error(_),X.triggerPermanentFailure(0,0,n.RemoteAuthorityResolverError.isHandled(_)),_}}e.connectRemoteAgentExtensionHost=f;async function h(k,O){const _=await o(k,(0,L.generateUuid)(),null);return await s(_,{port:O},i.CancellationToken.None)}e.connectRemoteAgentTunnel=h;function P(k){return(0,y.createCancelablePromise)(O=>new Promise((_,K)=>{const G=setTimeout(_,k*1e3);O.onCancellationRequested(()=>{clearTimeout(G),_()})}))}var T;(function(k){k[k.ConnectionLost=0]="ConnectionLost",k[k.ReconnectionWait=1]="ReconnectionWait",k[k.ReconnectionRunning=2]="ReconnectionRunning",k[k.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",k[k.ConnectionGain=4]="ConnectionGain"})(T=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class U{constructor(O,_){this.reconnectionToken=O,this.millisSinceLastIncomingData=_,this.type=0}}e.ConnectionLostEvent=U;class q{constructor(O,_,K,G){this.reconnectionToken=O,this.millisSinceLastIncomingData=_,this.durationSeconds=K,this.cancellableTimer=G,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=q;class Q{constructor(O,_,K){this.reconnectionToken=O,this.millisSinceLastIncomingData=_,this.attempt=K,this.type=2}}e.ReconnectionRunningEvent=Q;class x{constructor(O,_,K){this.reconnectionToken=O,this.millisSinceLastIncomingData=_,this.attempt=K,this.type=4}}e.ConnectionGainEvent=x;class j{constructor(O,_,K,G){this.reconnectionToken=O,this.millisSinceLastIncomingData=_,this.attempt=K,this.handled=G,this.type=3}}e.ReconnectionPermanentFailureEvent=j;class X extends A.Disposable{constructor(O,_,K,G){super();this._connectionType=O,this._onDidStateChange=this._register(new E.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._options=_,this.reconnectionToken=K,this.protocol=G,this._isReconnecting=!1,this._onDidStateChange.fire(new x(this.reconnectionToken,0,0)),this._register(G.onSocketClose(()=>this._beginReconnecting())),this._register(G.onSocketTimeout(()=>this._beginReconnecting())),X._instances.push(this),X._permanentFailure&&this._gotoPermanentFailure(X._permanentFailureMillisSinceLastIncomingData,X._permanentFailureAttempt,X._permanentFailureHandled)}static triggerPermanentFailure(O,_,K){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=O,this._permanentFailureAttempt=_,this._permanentFailureHandled=K,this._instances.forEach(G=>G._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(X._permanentFailure)return;const O=F(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${O} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new U(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const _=[0,5,5,10,10,10,10,10,30],K=Date.now();let G=-1;do{G++;const Y=G<_.length?_[G]:_[_.length-1];try{if(Y>0){const ne=P(Y);this._onDidStateChange.fire(new q(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),Y,ne)),this._options.logService.info(`${O} waiting for ${Y} seconds before reconnecting...`);try{await ne}catch(re){}}if(X._permanentFailure){this._options.logService.error(`${O} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new Q(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),G+1)),this._options.logService.info(`${O} resolving connection...`);const ee=await o(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${O} connecting to ${ee.host}:${ee.port}...`),await this._reconnect(ee,g(I)),this._options.logService.info(`${O} reconnected!`),this._onDidStateChange.fire(new x(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),G+1));break}catch(ee){if(ee.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${O} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(ee),X.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),G+1,!1);break}if(Date.now()-K>108e5){this._options.logService.error(`${O} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(ee),X.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),G+1,!1);break}if(n.RemoteAuthorityResolverError.isTemporarilyNotAvailable(ee)){this._options.logService.info(`${O} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(ee);continue}if((ee.code==="ETIMEDOUT"||ee.code==="ENETUNREACH"||ee.code==="ECONNREFUSED"||ee.code==="ECONNRESET")&&ee.syscall==="connect"){this._options.logService.info(`${O} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(ee);continue}if((0,w.isPromiseCanceledError)(ee)){this._options.logService.info(`${O} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(ee);continue}if(ee instanceof n.RemoteAuthorityResolverError){this._options.logService.error(`${O} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(ee),X.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),G+1,n.RemoteAuthorityResolverError.isHandled(ee));break}this._options.logService.error(`${O} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(ee),X.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),G+1,!1);break}}while(!X._permanentFailure)}_gotoPermanentFailure(O,_,K){this._onDidStateChange.fire(new j(this.reconnectionToken,O,_,K)),N(this.protocol)}}X._permanentFailure=!1,X._permanentFailureMillisSinceLastIncomingData=0,X._permanentFailureAttempt=0,X._permanentFailureHandled=!1,X._instances=[];class B extends X{constructor(O,_,K,G,Y){super(1,O,G,Y);this.client=this._register(new m.Client(Y,{remoteAuthority:_,clientId:K},O.ipcLogger))}async _reconnect(O,_){await t(O,_)}}e.ManagementPersistentConnection=B;class V extends X{constructor(O,_,K,G,Y){super(2,O,K,G);this._startArguments=_,this.debugPort=Y}async _reconnect(O,_){await r(O,this._startArguments,_)}}e.ExtensionHostPersistentConnection=V;function N(k){try{k.acceptDisconnect();const O=k.getSocket();k.dispose(),O.dispose()}catch(O){(0,w.onUnexpectedError)(O)}}function C(k){if(k&&k.type==="error"){const O=new Error(`Connection error: ${k.reason}`);return O.code="VSCODE_CONNECTION_ERROR",O}return null}function z(k,O){for(;k.length<O;)k+=" ";return k}function F(k,O,_){return`[remote-connection][${z(p(k),13)}][${O.substr(0,5)}\u2026][${_?"reconnect":"initial"}]`}function R(k,O){return`${F(O,k.reconnectionToken,!!k.reconnectionProtocol)}[${k.host}:${k.port}]`}function W(k){return`${Date.now()-k} ms`}}),define(J[73],Z([0,1,10]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.getRemoteName=e.getRemoteAuthority=void 0;function L(y){return y.scheme===m.Schemas.vscodeRemote?y.authority:void 0}e.getRemoteAuthority=L;function A(y){if(!y)return;const i=y.indexOf("+");return i<0?y:y.substr(0,i)}e.getRemoteName=A;function b(y){return y.scheme!==m.Schemas.file&&y.scheme!==m.Schemas.vscodeRemote}function E(y){if(y.folders.length)return y.folders.every(i=>b(i.uri))?y.folders[0].uri:void 0;if(y.configuration&&b(y.configuration))return y.configuration}e.getVirtualWorkspaceLocation=E;function n(y){var i;return(i=E(y))===null||i===void 0?void 0:i.scheme}e.getVirtualWorkspaceScheme=n;function w(y){return E(y)!==void 0}e.isVirtualWorkspace=w}),define(J[74],Z([0,1,5,3,4,6]),function($,e,m,L,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.ITunnelService=void 0,e.ITunnelService=(0,A.createDecorator)("tunnelService");var E;(function(M){M[M.Notify=1]="Notify",M[M.OpenBrowser=2]="OpenBrowser",M[M.OpenPreview=3]="OpenPreview",M[M.Silent=4]="Silent",M[M.Ignore=5]="Ignore"})(E=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function n(M){if(M.scheme!=="http"&&M.scheme!=="https")return;const p=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(M.authority);if(!!p)return{address:p[1],port:+p[2]}}e.extractLocalHostUriMetaDataForPortMapping=n,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function w(M){return e.LOCALHOST_ADDRESSES.indexOf(M)>=0}e.isLocalhost=w,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function y(M){return e.ALL_INTERFACES_ADDRESSES.indexOf(M)>=0}e.isAllInterfaces=y;function i(M,p){return p?p!==1&&M<1024:!L.isWindows&&M<1024}e.isPortPrivileged=i;let I=class{constructor(p){this.logService=p,this._onTunnelOpened=new m.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new m.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._tunnels=new Map,this._canElevate=!1,this._canMakePublic=!1}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(p,g){return this._tunnelProvider=p,p?(this._canElevate=g.elevation,this._canMakePublic=g.public,{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._canMakePublic=!1}}):(this._canElevate=!1,this._canMakePublic=!1,{dispose:()=>{}})}get canElevate(){return this._canElevate}get canMakePublic(){return this._canMakePublic}get tunnels(){return new Promise(async p=>{const g=[],v=Array.from(this._tunnels.values());for(let D of v){const S=Array.from(D.values());for(let a of S){const u=await a.value;u&&g.push(u)}}p(g)})}async dispose(){for(const p of this._tunnels.values()){for(const{value:g}of p.values())await g.then(v=>v==null?void 0:v.dispose());p.clear()}this._tunnels.clear()}openTunnel(p,g,v,D,S=!1,a=!1){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${g}:${v} on local port ${D}.`),!p)return;g||(g="localhost");const u=this.retainOrCreateTunnel(p,g,v,D,S,a);return u?u.then(c=>{if(!c){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(g,v);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const l=this.makeTunnel(c);return(c.tunnelRemoteHost!==g||c.tunnelRemotePort!==v)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(l),l}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),u)}makeTunnel(p){return{tunnelRemotePort:p.tunnelRemotePort,tunnelRemoteHost:p.tunnelRemoteHost,tunnelLocalPort:p.tunnelLocalPort,localAddress:p.localAddress,public:p.public,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${p.tunnelRemoteHost}:${p.tunnelRemotePort} `);const g=this._tunnels.get(p.tunnelRemoteHost);if(g){const v=g.get(p.tunnelRemotePort);v&&(v.refcount--,await this.tryDisposeTunnel(p.tunnelRemoteHost,p.tunnelRemotePort,v))}}}}async tryDisposeTunnel(p,g,v){if(v.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${p}:${g}.`);const D=v.value.then(async S=>{S&&(await S.dispose(!0),this._onTunnelClosed.fire({host:S.tunnelRemoteHost,port:S.tunnelRemotePort}))});return this._tunnels.has(p)&&this._tunnels.get(p).delete(g),D}}async closeTunnel(p,g){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${p}:${g} `);const v=this._tunnels.get(p);if(v&&v.has(g)){const D=v.get(g);D.refcount=0,await this.tryDisposeTunnel(p,g,D)}}addTunnelToMap(p,g,v){this._tunnels.has(p)||this._tunnels.set(p,new Map),this._tunnels.get(p).set(g,{refcount:1,value:v})}async removeEmptyTunnelFromMap(p,g){const v=this._tunnels.get(p);v&&(await v.get(g)||v.delete(g),v.size===0&&this._tunnels.delete(p))}getTunnelFromMap(p,g){let v=[p];w(p)?(v.push(...e.LOCALHOST_ADDRESSES),v.push(...e.ALL_INTERFACES_ADDRESSES)):y(p)&&v.push(...e.ALL_INTERFACES_ADDRESSES);const D=v.map(S=>this._tunnels.get(S));for(const S of D){const a=S==null?void 0:S.get(g);if(a)return a}}canTunnel(p){return!!n(p)}createWithProvider(p,g,v,D,S,a){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${g}:${v} on local port ${D}.`);const c={elevationRequired:S?i(D===void 0?v:D):!1},l={remoteAddress:{host:g,port:v},localAddressPort:D,public:a},t=p.forwardPort(l,c);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),t&&this.addTunnelToMap(g,v,t),t}};I=he([te(0,b.ILogService)],I),e.AbstractTunnelService=I}),define(J[49],Z([0,1,146,4,48,37,20]),function($,e,m,L,A,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,L.createDecorator)("requestService");function n(g){return g.res.statusCode&&g.res.statusCode>=200&&g.res.statusCode<300||g.res.statusCode===1223}e.isSuccess=n;function w(g){return g.res.statusCode===204}async function y(g){if(!n(g))throw new Error("Server returned "+g.res.statusCode);return w(g)?null:(await(0,E.streamToBuffer)(g.stream)).toString()}e.asText=y;async function i(g){if(!n(g))throw new Error("Server returned "+g.res.statusCode);if(w(g))return null;const D=(await(0,E.streamToBuffer)(g.stream)).toString();try{return JSON.parse(D)}catch(S){throw S.message+=`:
`+D,S}}e.asJson=i;function I(g){p(g)}e.updateProxyConfigurationsScope=I;let M;function p(g){const v=b.Registry.as(A.Extensions.Configuration);M&&v.deregisterConfigurations([M]),M={id:"http",order:15,title:(0,m.localize)(0,null),type:"object",scope:g,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,m.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,m.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,m.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,m.localize)(4,null),(0,m.localize)(5,null),(0,m.localize)(6,null),(0,m.localize)(7,null)],default:"override",description:(0,m.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,m.localize)(9,null),restricted:!0}}},v.registerConfiguration(M)}p(2)}),define(J[191],Z([0,1,192,13]),function($,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function A(E,n){return E.protocol==="http:"?n.HTTP_PROXY||n.http_proxy||null:E.protocol==="https:"&&(n.HTTPS_PROXY||n.https_proxy||n.HTTP_PROXY||n.http_proxy)||null}async function b(E,n,w={}){const y=(0,m.parse)(E),i=w.proxyUrl||A(y,n);if(!i)return null;const I=(0,m.parse)(i);if(!/^https?:$/.test(I.protocol||""))return null;const M={host:I.hostname||"",port:I.port||(I.protocol==="https"?"443":"80"),auth:I.auth,rejectUnauthorized:(0,L.isBoolean)(w.strictSSL)?w.strictSSL:!0};return y.protocol==="http:"?new(await new Promise((p,g)=>{$(["http-proxy-agent"],p,g)}))(M):new(await new Promise((p,g)=>{$(["https-proxy-agent"],p,g)}))(M)}e.getProxyAgent=b}),define(J[193],Z([0,1,27,20]),function($,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function A(b,E,n){let w=n&&n.get("storage.serviceMachineId",0)||null;if(w)return w;try{const i=(await E.readFile(b.serviceMachineIdResource)).value.toString();w=(0,m.isUUID)(i)?i:null}catch(y){w=null}if(!w){w=(0,m.generateUuid)();try{await E.writeFile(b.serviceMachineIdResource,L.VSBuffer.fromString(w))}catch(y){}}return n&&n.store("storage.serviceMachineId",w,0,1),w}e.getServiceMachineId=A}),define(J[75],Z([0,1,4]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,m.createDecorator)(e.SIGN_SERVICE_ID)}),define(J[194],Z([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class m{vsda(){return new Promise((A,b)=>$(["vsda"],A,b))}async sign(A){try{const b=await this.vsda(),E=new b.signer;if(E)return E.sign(A)}catch(b){}return A}}e.SignService=m}),define(J[38],Z([0,1,4]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateMainService=void 0,e.IStateMainService=(0,m.createDecorator)("stateMainService")}),define(J[18],Z([0,1,14,6,38,5,4,176,3,2,9,13,32]),function($,e,m,L,A,b,E,n,w,y,i,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LifecycleMainService=e.LifecycleMainPhase=e.UnloadReason=e.ILifecycleMainService=void 0,e.ILifecycleMainService=(0,E.createDecorator)("lifecycleMainService");var p;(function(D){D[D.CLOSE=1]="CLOSE",D[D.QUIT=2]="QUIT",D[D.RELOAD=3]="RELOAD",D[D.LOAD=4]="LOAD"})(p=e.UnloadReason||(e.UnloadReason={}));var g;(function(D){D[D.Starting=1]="Starting",D[D.Ready=2]="Ready",D[D.AfterWindowOpen=3]="AfterWindowOpen"})(g=e.LifecycleMainPhase||(e.LifecycleMainPhase={}));let v=class ct extends y.Disposable{constructor(S,a){super();this.logService=S,this.stateMainService=a,this._onBeforeShutdown=this._register(new b.Emitter),this.onBeforeShutdown=this._onBeforeShutdown.event,this._onWillShutdown=this._register(new b.Emitter),this.onWillShutdown=this._onWillShutdown.event,this._onWillLoadWindow=this._register(new b.Emitter),this.onWillLoadWindow=this._onWillLoadWindow.event,this._onBeforeCloseWindow=this._register(new b.Emitter),this.onBeforeCloseWindow=this._onBeforeCloseWindow.event,this._onBeforeUnloadWindow=this._register(new b.Emitter),this.onBeforeUnloadWindow=this._onBeforeUnloadWindow.event,this._quitRequested=!1,this._wasRestarted=!1,this._phase=1,this.windowToCloseRequest=new Set,this.oneTimeListenerTokenGenerator=0,this.windowCounter=0,this.pendingQuitPromise=void 0,this.pendingQuitPromiseResolve=void 0,this.pendingWillShutdownPromise=void 0,this.phaseWhen=new Map,this.resolveRestarted(),this.when(2).then(()=>this.registerListeners())}get quitRequested(){return this._quitRequested}get wasRestarted(){return this._wasRestarted}get phase(){return this._phase}resolveRestarted(){this._wasRestarted=!!this.stateMainService.getItem(ct.QUIT_AND_RESTART_KEY),this._wasRestarted&&this.stateMainService.removeItem(ct.QUIT_AND_RESTART_KEY)}registerListeners(){const S=()=>{this._quitRequested||(this.logService.trace("Lifecycle#app.on(before-quit)"),this._quitRequested=!0,this.logService.trace("Lifecycle#onBeforeShutdown.fire()"),this._onBeforeShutdown.fire(),w.isMacintosh&&this.windowCounter===0&&this.beginOnWillShutdown())};m.app.addListener("before-quit",S);const a=()=>{this.logService.trace("Lifecycle#app.on(window-all-closed)"),(this._quitRequested||!w.isMacintosh)&&m.app.quit()};m.app.addListener("window-all-closed",a),m.app.once("will-quit",u=>{this.logService.trace("Lifecycle#app.on(will-quit)"),u.preventDefault(),this.beginOnWillShutdown().finally(()=>{this.resolvePendingQuitPromise(!1),m.app.removeListener("before-quit",S),m.app.removeListener("window-all-closed",a),m.app.quit()})})}beginOnWillShutdown(){if(this.pendingWillShutdownPromise)return this.pendingWillShutdownPromise;this.logService.trace("Lifecycle#onWillShutdown.fire()");const S=[];return this._onWillShutdown.fire({join(a){S.push(a)}}),this.pendingWillShutdownPromise=(async()=>{try{await i.Promises.settled(S)}catch(a){this.logService.error(a)}try{await this.stateMainService.close()}catch(a){this.logService.error(a)}})(),this.pendingWillShutdownPromise}set phase(S){if(S<this.phase)throw new Error("Lifecycle cannot go backwards");if(this._phase===S)return;this.logService.trace(`lifecycle (main): phase changed (value: ${S})`),this._phase=S;const a=this.phaseWhen.get(this._phase);a&&(a.open(),this.phaseWhen.delete(this._phase))}async when(S){if(S<=this._phase)return;let a=this.phaseWhen.get(S);a||(a=new i.Barrier,this.phaseWhen.set(S,a)),await a.wait()}registerWindow(S){const a=new y.DisposableStore;this.windowCounter++,a.add(S.onWillLoad(c=>this._onWillLoadWindow.fire({window:S,workspace:c.workspace})));const u=(0,I.assertIsDefined)(S.win);u.on("close",c=>{const l=S.id;if(this.windowToCloseRequest.has(l)){this.windowToCloseRequest.delete(l);return}this.logService.trace(`Lifecycle#window.on('close') - window ID ${S.id}`),c.preventDefault(),this.unload(S,1).then(t=>{if(t){this.windowToCloseRequest.delete(l);return}this.windowToCloseRequest.add(l),this.logService.trace(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${l}`),this._onBeforeCloseWindow.fire(S),S.close()})}),u.on("closed",()=>{this.logService.trace(`Lifecycle#window.on('closed') - window ID ${S.id}`),this.windowCounter--,a.dispose(),this.windowCounter===0&&(!w.isMacintosh||this._quitRequested)&&this.beginOnWillShutdown()})}async reload(S,a){await this.unload(S,3)||S.reload(a)}async unload(S,a){if(!S.isReady)return!1;this.logService.trace(`Lifecycle#unload() - window ID ${S.id}`);const u=this._quitRequested?2:a;let c=await this.onBeforeUnloadWindowInRenderer(S,u);return c?(this.logService.trace(`Lifecycle#unload() - veto in renderer (window ID ${S.id})`),this.handleWindowUnloadVeto(c)):(c=await this.onBeforeUnloadWindowInMain(S,u),c?(this.logService.trace(`Lifecycle#unload() - veto in main (window ID ${S.id})`),this.handleWindowUnloadVeto(c)):(this.logService.trace(`Lifecycle#unload() - no veto (window ID ${S.id})`),await this.onWillUnloadWindowInRenderer(S,u),!1))}handleWindowUnloadVeto(S){return S?(this.resolvePendingQuitPromise(!0),this._quitRequested=!1,!0):!1}resolvePendingQuitPromise(S){this.pendingQuitPromiseResolve&&(this.pendingQuitPromiseResolve(S),this.pendingQuitPromiseResolve=void 0,this.pendingQuitPromise=void 0)}onBeforeUnloadWindowInRenderer(S,a){return new Promise(u=>{const c=this.oneTimeListenerTokenGenerator++,l=`vscode:ok${c}`,t=`vscode:cancel${c}`;m.ipcMain.once(l,()=>{u(!1)}),m.ipcMain.once(t,()=>{u(!0)}),S.send("vscode:onBeforeUnload",{okChannel:l,cancelChannel:t,reason:a})})}onBeforeUnloadWindowInMain(S,a){const u=[];return this._onBeforeUnloadWindow.fire({reason:a,window:S,veto(c){u.push(c)}}),(0,n.handleVetos)(u,c=>this.logService.error(c))}onWillUnloadWindowInRenderer(S,a){return new Promise(u=>{const l=`vscode:reply${this.oneTimeListenerTokenGenerator++}`;m.ipcMain.once(l,()=>u()),S.send("vscode:onWillUnload",{replyChannel:l,reason:a})})}quit(S){return this.pendingQuitPromise?this.pendingQuitPromise:(this.logService.trace(`Lifecycle#quit() - will restart: ${S}`),S&&this.stateMainService.setItem(ct.QUIT_AND_RESTART_KEY,!0),this.pendingQuitPromise=new Promise(a=>{this.pendingQuitPromiseResolve=a,this.logService.trace("Lifecycle#quit() - calling app.quit()"),m.app.quit()}),this.pendingQuitPromise)}async relaunch(S){this.logService.trace("Lifecycle#relaunch()");const a=process.argv.slice(1);if((S==null?void 0:S.addArgs)&&a.push(...S.addArgs),S==null?void 0:S.removeArgs)for(const l of S.removeArgs){const t=a.indexOf(l);t>=0&&a.splice(t,1)}const u=()=>{try{if(w.isWindows){const l=(0,M.cwd)();l!==process.cwd()&&process.chdir(l)}}catch(l){this.logService.error(l)}this.logService.trace("Lifecycle#relaunch() - calling app.relaunch()"),m.app.relaunch({args:a})};m.app.once("quit",u),await this.quit(!0)&&m.app.removeListener("quit",u)}async kill(S){this.logService.trace("Lifecycle#kill()"),await Promise.race([(0,i.timeout)(1e3),(async()=>{for(const a of m.BrowserWindow.getAllWindows())if(a&&!a.isDestroyed()){let u;a.webContents&&!a.webContents.isDestroyed()?u=new Promise(c=>a.once("closed",c)):u=Promise.resolve(),a.destroy(),await u}})()]),m.app.exit(S)}};v.QUIT_AND_RESTART_KEY="lifecycle.quitAndRestart",v=he([te(0,L.ILogService),te(1,A.IStateMainService)],v),e.LifecycleMainService=v}),define(J[195],Z([0,1,4,5,2,18]),function($,e,m,L,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyboardLayoutMainService=e.IKeyboardLayoutMainService=void 0,e.IKeyboardLayoutMainService=(0,m.createDecorator)("keyboardLayoutMainService");let E=class extends A.Disposable{constructor(y){super();this._onDidChangeKeyboardLayout=this._register(new L.Emitter),this.onDidChangeKeyboardLayout=this._onDidChangeKeyboardLayout.event,this._initPromise=null,this._keyboardLayoutData=null,y.when(3).then(()=>this._initialize())}_initialize(){return this._initPromise||(this._initPromise=this._doInitialize()),this._initPromise}async _doInitialize(){const y=await new Promise((i,I)=>{$(["native-keymap"],i,I)});this._keyboardLayoutData=n(y),y.onDidChangeKeyboardLayout(()=>{this._keyboardLayoutData=n(y),this._onDidChangeKeyboardLayout.fire(this._keyboardLayoutData)})}async getKeyboardLayoutData(){return await this._initialize(),this._keyboardLayoutData}};E=he([te(0,b.ILifecycleMainService)],E),e.KeyboardLayoutMainService=E;function n(w){const y=w.getKeyMap(),i=w.getCurrentKeyboardLayout();return{keyboardMapping:y,keyboardLayoutInfo:i}}}),define(J[96],Z([0,1,4,5,2,13,86,9]),function($,e,m,L,A,b,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const w="__$__targetStorageMarker";e.IStorageService=(0,m.createDecorator)("storageService");var y;(function(v){v[v.NONE=0]="NONE",v[v.SHUTDOWN=1]="SHUTDOWN"})(y=e.WillSaveStateReason||(e.WillSaveStateReason={}));var i;(function(v){v[v.GLOBAL=0]="GLOBAL",v[v.WORKSPACE=1]="WORKSPACE"})(i=e.StorageScope||(e.StorageScope={}));var I;(function(v){v[v.USER=0]="USER",v[v.MACHINE=1]="MACHINE"})(I=e.StorageTarget||(e.StorageTarget={}));class M extends A.Disposable{constructor(D={flushInterval:M.DEFAULT_FLUSH_INTERVAL}){super();this.options=D,this._onDidChangeValue=this._register(new L.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new L.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new L.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new n.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new A.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,n.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,A.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{await this.doInitialize(),this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(D,S){S===w?(D===0?this._globalKeyTargets=void 0:D===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:D})):this._onDidChangeValue.fire({scope:D,key:S,target:this.getKeyTargets(D)[S]})}emitWillSaveState(D){this._onWillSaveState.fire({reason:D})}get(D,S,a){var u;return(u=this.getStorage(S))===null||u===void 0?void 0:u.get(D,a)}getBoolean(D,S,a){var u;return(u=this.getStorage(S))===null||u===void 0?void 0:u.getBoolean(D,a)}getNumber(D,S,a){var u;return(u=this.getStorage(S))===null||u===void 0?void 0:u.getNumber(D,a)}store(D,S,a,u){if((0,b.isUndefinedOrNull)(S)){this.remove(D,a);return}this.withPausedEmitters(()=>{var c;this.updateKeyTarget(D,a,u),(c=this.getStorage(a))===null||c===void 0||c.set(D,S)})}remove(D,S){this.withPausedEmitters(()=>{var a;this.updateKeyTarget(D,S,void 0),(a=this.getStorage(S))===null||a===void 0||a.delete(D)})}withPausedEmitters(D){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{D()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(D,S){const a=[],u=this.getKeyTargets(D);for(const c of Object.keys(u))u[c]===S&&a.push(c);return a}updateKeyTarget(D,S,a){var u,c;const l=this.getKeyTargets(S);typeof a=="number"?l[D]!==a&&(l[D]=a,(u=this.getStorage(S))===null||u===void 0||u.set(w,JSON.stringify(l))):typeof l[D]=="number"&&(delete l[D],(c=this.getStorage(S))===null||c===void 0||c.set(w,JSON.stringify(l)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(D){return D===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(D){const S=this.get(w,D);if(S)try{return JSON.parse(S)}catch(a){}return Object.create(null)}isNew(D){return this.getBoolean(e.IS_NEW_KEY,D)===!0}async flush(){var D,S,a,u;this._onWillSaveState.fire({reason:y.NONE}),await n.Promises.settled([(S=(D=this.getStorage(0))===null||D===void 0?void 0:D.whenFlushed())!==null&&S!==void 0?S:Promise.resolve(),(u=(a=this.getStorage(1))===null||a===void 0?void 0:a.whenFlushed())!==null&&u!==void 0?u:Promise.resolve()])}async logStorage(){var D,S,a,u,c,l;const t=(S=(D=this.getStorage(0))===null||D===void 0?void 0:D.items)!==null&&S!==void 0?S:new Map,r=(u=(a=this.getStorage(1))===null||a===void 0?void 0:a.items)!==null&&u!==void 0?u:new Map;return g(t,r,(c=this.getLogDetails(0))!==null&&c!==void 0?c:"",(l=this.getLogDetails(1))!==null&&l!==void 0?l:"")}}e.AbstractStorageService=M,M.DEFAULT_FLUSH_INTERVAL=60*1e3;class p extends M{constructor(){super();this.globalStorage=new E.Storage(new E.InMemoryStorageDatabase),this.workspaceStorage=new E.Storage(new E.InMemoryStorageDatabase),this._register(this.workspaceStorage.onDidChangeStorage(D=>this.emitDidChangeValue(1,D))),this._register(this.globalStorage.onDidChangeStorage(D=>this.emitDidChangeValue(0,D)))}getStorage(D){return D===0?this.globalStorage:this.workspaceStorage}getLogDetails(D){return D===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(D){}}e.InMemoryStorageService=p;async function g(v,D,S,a){const u=d=>{try{return JSON.parse(d)}catch(f){return d}},c=new Map,l=new Map;v.forEach((d,f)=>{c.set(f,d),l.set(f,u(d))});const t=new Map,r=new Map;D.forEach((d,f)=>{t.set(f,d),r.set(f,u(d))}),console.group(`Storage: Global (path: ${S})`);let s=[];c.forEach((d,f)=>{s.push({key:f,value:d})}),console.table(s),console.groupEnd(),console.log(l),console.group(`Storage: Workspace (path: ${a})`);let o=[];t.forEach((d,f)=>{o.push({key:f,value:d})}),console.table(o),console.groupEnd(),console.log(r)}e.logStorage=g}),define(J[196],Z([0,1,3,32,27,7]),function($,e,m,L,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function E(y){if(m.platform===2&&/^penguin(\.|$)/i.test(y))return"chromebook"}async function n(y,i,I,M,p,g,v,D,S,a){const u=Object.create(null);u["common.machineId"]=v,u.sessionID=(0,A.generateUuid)()+Date.now(),u.commitHash=p,u.version=g,u["common.platformVersion"]=(i||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),u["common.platform"]=(0,m.PlatformToString)(m.platform),u["common.nodePlatform"]=L.platform,u["common.nodeArch"]=M,u["common.product"]=a||"desktop";const c=w(D||[]);c&&(u["common.msftInternal"]=c);let l=0;const t=Date.now();Object.defineProperties(u,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-t,enumerable:!0},"common.sequence":{get:()=>l++,enumerable:!0}}),m.isLinuxSnap&&(u["common.snap"]="true");const r=E(I);r&&(u["common.platformDetail"]=r);try{const s=await y.readFile(b.URI.file(S));u["common.source"]=s.value.toString().slice(0,30)}catch(s){}return u}e.resolveCommonProperties=n;function w(y){const i=L.env.USERDNSDOMAIN;if(!i)return!1;const I=i.toLowerCase();return y.some(M=>I===M)}e.verifyMicrosoftInternalDomain=w}),define(J[31],Z([0,1,4]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.instanceStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,m.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,m.createDecorator)("customEndpointTelemetryService"),e.instanceStorageKey="telemetry.instanceId",e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId"}),define(J[197],Z([0,1,26,66,70,29,8,43,83,22,3,7,31,63,10,21,16]),function($,e,m,L,A,b,E,n,w,y,i,I,M,p,g,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;async function S(t,r){const s=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.yml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i}],o=new Map,d=new Map,f=2e4;function h(U,q,Q,x){const j=q.substring(U.length+1);return new Promise(async X=>{var B,V,N;let C;try{C=await(0,D.readdir)(q,{withFileTypes:!0})}catch(R){X();return}if(x.count>=f){x.count+=C.length,x.maxReached=!0,X();return}let z=C.length;if(z===0){X();return}let F=C;x.count+C.length>f&&(x.maxReached=!0,z=f-x.count,F=C.slice(0,z)),x.count+=C.length;for(const R of F)if(R.isDirectory()){if(Q.includes(R.name)||await h(U,(0,E.join)(q,R.name),Q,x),--z==0){X();return}}else{const W=R.name.lastIndexOf(".");if(W>=0){const k=R.name.substring(W+1);k&&o.set(k,((B=o.get(k))!==null&&B!==void 0?B:0)+1)}for(const k of s)((V=k.relativePathPattern)===null||V===void 0?void 0:V.test(j))!==!1&&k.filePattern.test(R.name)&&d.set(k.tag,((N=d.get(k.tag))!==null&&N!==void 0?N:0)+1);if(--z==0){X();return}}})}const P={count:0,maxReached:!1};await h(t,t,r,P);const T=await c(t);return{configFiles:a(d),fileTypes:a(o),fileCount:P.count,maxFilesReached:P.maxReached,launchConfigFiles:T}}e.collectWorkspaceStats=S;function a(t){return[...p.Iterable.map(t.entries(),([r,s])=>({name:r,count:s}))].sort((r,s)=>s.count-r.count)}function u(){const t={os:`${m.type()} ${m.arch()} ${m.release()}`,memory:`${(m.totalmem()/v.ByteSize.GB).toFixed(2)}GB (${(m.freemem()/v.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(L.virtualMachineHint.value()*100)}%`},r=m.cpus();return r&&r.length>0&&(t.cpus=`${r[0].model} (${r.length} x ${r[0].speed})`),t}e.getMachineInfo=u;function c(t){let r=new Map,s=(0,E.join)(t,".vscode","launch.json");return new Promise((o,d)=>{(0,b.exists)(s,f=>{if(f)(0,b.readFile)(s,(h,P)=>{if(h)return o([]);const T=[],U=(0,n.parse)(P.toString(),T);if(T.length)return console.log(`Unable to parse ${s}`),o([]);if((0,n.getNodeType)(U)==="object"&&U.configurations)for(const q of U.configurations){const Q=q.type;Q&&(r.has(Q)?r.set(Q,r.get(Q)+1):r.set(Q,1))}return o(a(r))});else return o([])})})}e.collectLaunchConfigs=c;let l=class{constructor(r,s){this.telemetryService=r,this.productService=s}formatMachineInfo(r){const s=[];return s.push(`OS Version:       ${r.os}`),s.push(`CPUs:             ${r.cpus}`),s.push(`Memory (System):  ${r.memory}`),s.push(`VM:               ${r.vmHint}`),s.join(`
`)}formatEnvironment(r){const s=[];s.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),s.push(`OS Version:       ${m.type()} ${m.arch()} ${m.release()}`);const o=m.cpus();return o&&o.length>0&&s.push(`CPUs:             ${o[0].model} (${o.length} x ${o[0].speed})`),s.push(`Memory (System):  ${(m.totalmem()/v.ByteSize.GB).toFixed(2)}GB (${(m.freemem()/v.ByteSize.GB).toFixed(2)}GB free)`),i.isWindows||s.push(`Load (avg):       ${m.loadavg().map(d=>Math.round(d)).join(", ")}`),s.push(`VM:               ${Math.round(L.virtualMachineHint.value()*100)}%`),s.push(`Screen Reader:    ${r.screenReader?"yes":"no"}`),s.push(`Process Argv:     ${r.mainArguments.join(" ")}`),s.push(`GPU Status:       ${this.expandGPUFeatures(r.gpuFeatureStatus)}`),s.join(`
`)}async getPerformanceInfo(r,s){return Promise.all([(0,w.listProcesses)(r.mainPID),this.formatWorkspaceMetadata(r)]).then(async o=>{let[d,f]=o,h=this.formatProcessList(r,d);return s.forEach(P=>{if((0,A.isRemoteDiagnosticError)(P))h+=`
${P.errorMessage}`,f+=`
${P.errorMessage}`;else if(h+=`

Remote: ${P.hostName}`,P.processes&&(h+=`
${this.formatProcessList(r,P.processes)}`),P.workspaceMetadata){f+=`
|  Remote: ${P.hostName}`;for(const T of Object.keys(P.workspaceMetadata)){const U=P.workspaceMetadata[T];let q=`${U.fileCount} files`;U.maxFilesReached&&(q=`more than ${q}`),f+=`|    Folder (${T}): ${q}`,f+=this.formatWorkspaceStats(U)}}}),{processInfo:h,workspaceInfo:f}})}async getSystemInfo(r,s){const{memory:o,vmHint:d,os:f,cpus:h}=u(),P={os:f,memory:o,cpus:h,vmHint:d,processArgs:`${r.mainArguments.join(" ")}`,gpuStatus:r.gpuFeatureStatus,screenReader:`${r.screenReader?"yes":"no"}`,remoteData:s};return i.isWindows||(P.load=`${m.loadavg().map(T=>Math.round(T)).join(", ")}`),i.isLinux&&(P.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(P)}async getDiagnostics(r,s){const o=[];return(0,w.listProcesses)(r.mainPID).then(async d=>(o.push(""),o.push(this.formatEnvironment(r)),o.push(""),o.push(this.formatProcessList(r,d)),r.windows.some(f=>f.folderURIs&&f.folderURIs.length>0&&!f.remoteAuthority)&&(o.push(""),o.push("Workspace Stats: "),o.push(await this.formatWorkspaceMetadata(r))),s.forEach(f=>{if((0,A.isRemoteDiagnosticError)(f))o.push(`
${f.errorMessage}`);else if(o.push(`

`),o.push(`Remote:           ${f.hostName}`),o.push(this.formatMachineInfo(f.machineInfo)),f.processes&&o.push(this.formatProcessList(r,f.processes)),f.workspaceMetadata)for(const h of Object.keys(f.workspaceMetadata)){const P=f.workspaceMetadata[h];let T=`${P.fileCount} files`;P.maxFilesReached&&(T=`more than ${T}`),o.push(`Folder (${h}): ${T}`),o.push(this.formatWorkspaceStats(P))}}),o.push(""),o.push(""),o.join(`
`)))}formatWorkspaceStats(r){const s=[],o=60;let d=0;const f=(U,q)=>{const Q=` ${U}(${q})`;d+Q.length>o?(s.push(h),h="|                 ",d=h.length):d+=Q.length,h+=Q};let h="|      File types:";const P=10;let T=r.fileTypes.length>P?P:r.fileTypes.length;for(let U=0;U<T;U++){const q=r.fileTypes[U];f(q.name,q.count)}if(s.push(h),r.configFiles.length>=0&&(h="|      Conf files:",d=0,r.configFiles.forEach(U=>{f(U.name,U.count)}),s.push(h)),r.launchConfigFiles.length>0){let U="|      Launch Configs:";r.launchConfigFiles.forEach(q=>{U+=q.count>1?` ${q.name}(${q.count})`:` ${q.name}`}),s.push(U)}return s.join(`
`)}expandGPUFeatures(r){const s=Math.max(...Object.keys(r).map(o=>o.length));return Object.keys(r).map(o=>`${o}:  ${" ".repeat(s-o.length)}  ${r[o]}`).join(`
                  `)}formatWorkspaceMetadata(r){const s=[],o=[];return r.windows.forEach(d=>{d.folderURIs.length===0||!!d.remoteAuthority||(s.push(`|  Window (${d.title})`),d.folderURIs.forEach(f=>{const h=I.URI.revive(f);if(h.scheme===g.Schemas.file){const P=h.fsPath;o.push(S(P,["node_modules",".git"]).then(T=>{let U=`${T.fileCount} files`;T.maxFilesReached&&(U=`more than ${U}`),s.push(`|    Folder (${(0,E.basename)(P)}): ${U}`),s.push(this.formatWorkspaceStats(T))}).catch(T=>{s.push(`|      Error: Unable to collect workspace stats for folder ${P} (${T.toString()})`)}))}else s.push(`|    Folder (${h.toString()}): Workspace stats not available.`)}))}),Promise.all(o).then(d=>s.join(`
`)).catch(d=>`Unable to collect workspace stats: ${d}`)}formatProcessList(r,s){const o=new Map;r.windows.forEach(f=>o.set(f.pid,f.title));const d=[];return d.push("CPU %	Mem MB	   PID	Process"),s&&this.formatProcessItem(r.mainPID,o,d,s,0),d.join(`
`)}formatProcessItem(r,s,o,d,f){const h=f===0;let P;h?P=d.pid===r?`${this.productService.applicationName} main`:"remote agent":(P=`${"  ".repeat(f)} ${d.name}`,d.name==="window"&&(P=`${P} (${s.get(d.pid)})`));const T=process.platform==="win32"?d.mem:m.totalmem()*(d.mem/100);o.push(`${d.load.toFixed(0).padStart(5," ")}	${(T/v.ByteSize.MB).toFixed(0).padStart(6," ")}	${d.pid.toFixed(0).padStart(6," ")}	${P}`),Array.isArray(d.children)&&d.children.forEach(U=>this.formatProcessItem(r,s,o,U,f+1))}async reportWorkspaceStats(r){for(const{uri:s}of r.folders){const o=I.URI.revive(s);if(o.scheme!==g.Schemas.file)continue;const d=o.fsPath;try{const f=await S(d,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":r.telemetryId,rendererSessionId:r.rendererSessionId}),f.fileTypes.forEach(h=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:r.rendererSessionId,type:h.name,count:h.count})}),f.launchConfigFiles.forEach(h=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:r.rendererSessionId,type:h.name,count:h.count})}),f.configFiles.forEach(h=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:r.rendererSessionId,type:h.name,count:h.count})})}catch(f){}}}};l=he([te(0,M.ITelemetryService),te(1,y.IProductService)],l),e.DiagnosticsService=l}),define(J[198],Z([0,1,19,168,171,44,31,49,162,53,25,6,21,7,22,96,193,4,15]),function($,e,m,L,A,b,E,n,w,y,i,I,M,p,g,v,D,S,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=e.ExtensionGalleryService=void 0;var u;(function(F){F[F.None=0]="None",F[F.IncludeVersions=1]="IncludeVersions",F[F.IncludeFiles=2]="IncludeFiles",F[F.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",F[F.IncludeSharedAccounts=8]="IncludeSharedAccounts",F[F.IncludeVersionProperties=16]="IncludeVersionProperties",F[F.ExcludeNonValidated=32]="ExcludeNonValidated",F[F.IncludeInstallationTargets=64]="IncludeInstallationTargets",F[F.IncludeAssetUri=128]="IncludeAssetUri",F[F.IncludeStatistics=256]="IncludeStatistics",F[F.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",F[F.Unpublished=4096]="Unpublished"})(u||(u={}));function c(...F){return String(F.reduce((R,W)=>R|W,0))}var l;(function(F){F[F.Tag=1]="Tag",F[F.ExtensionId=4]="ExtensionId",F[F.Category=5]="Category",F[F.ExtensionName=7]="ExtensionName",F[F.Target=8]="Target",F[F.Featured=9]="Featured",F[F.SearchText=10]="SearchText",F[F.ExcludeWithFlags=12]="ExcludeWithFlags"})(l||(l={}));const t={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},r={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},o={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:u.None,criteria:[],assetTypes:[]};class d{constructor(R=o){this.state=R}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(R,W=this.state.pageSize){return new d(Object.assign(Object.assign({},this.state),{pageNumber:R,pageSize:W}))}withFilter(R,...W){const k=[...this.state.criteria,...W.length?W.map(O=>({filterType:R,value:O})):[{filterType:R}]];return new d(Object.assign(Object.assign({},this.state),{criteria:k}))}withSortBy(R){return new d(Object.assign(Object.assign({},this.state),{sortBy:R}))}withSortOrder(R){return new d(Object.assign(Object.assign({},this.state),{sortOrder:R}))}withFlags(...R){return new d(Object.assign(Object.assign({},this.state),{flags:R.reduce((W,k)=>W|k,0)}))}withAssetTypes(...R){return new d(Object.assign(Object.assign({},this.state),{assetTypes:R}))}get raw(){const{criteria:R,pageNumber:W,pageSize:k,sortBy:O,sortOrder:_,flags:K,assetTypes:G}=this.state;return{filters:[{criteria:R,pageNumber:W,pageSize:k,sortBy:O,sortOrder:_}],assetTypes:G,flags:K}}get searchText(){const R=this.state.criteria.filter(W=>W.filterType===l.SearchText)[0];return R&&R.value?R.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(R=>String(R.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function f(F,R){const W=(F||[]).filter(k=>k.statisticName===R)[0];return W?W.value:0}function h(F){const R="Microsoft.VisualStudio.Code.Translation.";return F.files.filter(k=>k.assetType.indexOf(R)===0).reduce((k,O)=>{const _=q(F,O.assetType);return _&&k.push([O.assetType.substring(R.length),_]),k},[])}function P(F){if(F.properties){const R=F.properties.filter(O=>O.key===t.Repository),W=new RegExp("((git|ssh|http(s)?)|(git@[w.]+))(:(//)?)([w.@:/-~]+)(.git)(/)?"),k=R.filter(O=>W.test(O.value))[0];return k?{uri:k.value,fallbackUri:k.value}:null}return q(F,t.Repository)}function T(F){return{uri:`${F.fallbackAssetUri}/${t.VSIX}?redirect=true`,fallbackUri:`${F.fallbackAssetUri}/${t.VSIX}`}}function U(F){const R=q(F,t.Icon);if(R)return R;const W=L.DefaultIconPath;return{uri:W,fallbackUri:W}}function q(F,R){return F.files.filter(k=>k.assetType===R)[0]?{uri:`${F.assetUri}/${R}`,fallbackUri:`${F.fallbackAssetUri}/${R}`}:null}function Q(F,R){const W=F.properties?F.properties.filter(O=>O.key===R):[],k=W.length>0&&W[0].value;return k?k.split(",").map(O=>(0,A.adoptToGalleryExtensionId)(O)):[]}function x(F){const R=F.properties?F.properties.filter(W=>W.key===r.Engine):[];return R.length>0&&R[0].value||""}function j(F){const R=F.properties?F.properties.filter(k=>k.key===r.LocalizedLanguages):[],W=R.length>0&&R[0].value||"";return W?W.split(","):[]}function X(F){return F.indexOf("preview")!==-1}function B(F){const R=F.properties?F.properties.find(W=>W.key===r.WebExtension):void 0;return!!R&&R.value==="true"}function V(F){return F.files.some(R=>R.assetType.startsWith("Microsoft.VisualStudio.Code.WebResources"))?(0,a.joinPath)(p.URI.parse(F.assetUri),"Microsoft.VisualStudio.Code.WebResources","extension"):void 0}function N(F,R,W,k,O){const _={manifest:q(R,t.Manifest),readme:q(R,t.Details),changelog:q(R,t.Changelog),license:q(R,t.License),repository:P(R),download:T(R),icon:U(R),coreTranslations:h(R)};return{identifier:{id:(0,A.getGalleryExtensionId)(F.publisher.publisherName,F.extensionName),uuid:F.extensionId},name:F.extensionName,version:R.version,date:R.lastUpdated,displayName:F.displayName,publisherId:F.publisher.publisherId,publisher:F.publisher.publisherName,publisherDisplayName:F.publisher.displayName,description:F.shortDescription||"",installCount:f(F.statistics,"install"),rating:f(F.statistics,"averagerating"),ratingCount:f(F.statistics,"ratingcount"),assetUri:p.URI.parse(R.assetUri),webResource:V(R),assetTypes:R.files.map(({assetType:K})=>K),assets:_,properties:{dependencies:Q(R,r.Dependency),extensionPack:Q(R,r.ExtensionPack),engine:x(R),localizedLanguages:j(R),webExtension:B(R)},telemetryData:{index:(k.pageNumber-1)*k.pageSize+W,querySource:O},preview:X(F.flags)}}let C=class{constructor(R,W,k,O,_,K,G){this.requestService=R,this.logService=W,this.environmentService=k,this.telemetryService=O,this.fileService=_,this.productService=K;const Y=K.extensionsGallery;this.extensionsGalleryUrl=Y&&Y.serviceUrl,this.extensionsControlUrl=Y&&Y.controlUrl,this.commonHeadersPromise=z(K.version,this.environmentService,this.fileService,G)}api(R=""){return`${this.extensionsGalleryUrl}${R}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(R,W){const k=[];let{total:O,firstPage:_,getPage:K}=await this.query({names:R,pageSize:R.length},W);k.push(..._);for(let G=1;k.length<O&&(_=await K(G,W),_.length);G++)k.push(..._);return k}async getCompatibleExtension(R,W){const k=await this.getCompatibleExtensionByEngine(R,W);return(k==null?void 0:k.properties.webExtension)?k.webResource?k:null:k}async getCompatibleExtensionByEngine(R,W){const k=(0,L.isIExtensionIdentifier)(R)?null:R;if(k&&k.properties.engine&&(0,w.isEngineValid)(k.properties.engine,this.productService.version,this.productService.date))return k;const{id:O,uuid:_}=k?k.identifier:R;let K=new d().withFlags(u.IncludeAssetUri,u.IncludeStatistics,u.IncludeFiles,u.IncludeVersionProperties).withPage(1,1).withFilter(l.Target,"Microsoft.VisualStudio.Code");_?K=K.withFilter(l.ExtensionId,_):K=K.withFilter(l.ExtensionName,O);const{galleryExtensions:G}=await this.queryGallery(K,i.CancellationToken.None),[Y]=G;if(!Y||!Y.versions.length)return null;if(W){const ne=Y.versions.filter(re=>re.version===W)[0];if(ne){const re=N(Y,ne,0,K);if(re.properties.engine&&(0,w.isEngineValid)(re.properties.engine,this.productService.version,this.productService.date))return re}return null}const ee=await this.getLastValidExtensionVersion(Y,Y.versions);return ee?N(Y,ee,0,K):null}async query(R,W){const k=i.CancellationToken.isCancellationToken(R)?{}:R,O=i.CancellationToken.isCancellationToken(R)?R:W;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let _=k.text||"";const K=(0,b.getOrDefault)(k,se=>se.pageSize,50);let G=new d().withFlags(u.IncludeLatestVersionOnly,u.IncludeAssetUri,u.IncludeStatistics,u.IncludeFiles,u.IncludeVersionProperties).withPage(1,K).withFilter(l.Target,"Microsoft.VisualStudio.Code");_?(_=_.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(se,le,oe)=>(G=G.withFilter(l.Category,oe||le),"")),_=_.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(se,le,oe)=>(G=G.withFilter(l.Tag,oe||le),"")),_=_.replace(/\bfeatured(\s+|\b|$)/g,()=>(G=G.withFilter(l.Featured),"")),_=_.trim(),_&&(_=_.length<200?_:_.substring(0,200),G=G.withFilter(l.SearchText,_)),G=G.withSortBy(0)):k.ids?G=G.withFilter(l.ExtensionId,...k.ids):k.names?G=G.withFilter(l.ExtensionName,...k.names):G=G.withSortBy(4),typeof k.sortBy=="number"&&(G=G.withSortBy(k.sortBy)),typeof k.sortOrder=="number"&&(G=G.withSortOrder(k.sortOrder));const{galleryExtensions:Y,total:ee}=await this.queryGallery(G,O),ne=Y.map((se,le)=>N(se,se.versions[0],le,G,k.source)),re=async(se,le)=>{if(le.isCancellationRequested)throw(0,m.canceled)();const oe=G.withPage(se+1),{galleryExtensions:ue}=await this.queryGallery(oe,le);return ue.map((me,Se)=>N(me,me.versions[0],Se,oe,k.source))};return{firstPage:ne,total:ee,pageSize:G.pageSize,getPage:re}}async queryGallery(R,W){if(!this.isEnabled())throw new Error("No extension gallery service configured.");R=R.withFlags(R.flags,u.ExcludeNonValidated).withFilter(l.ExcludeWithFlags,c(u.Unpublished));const k=await this.commonHeadersPromise,O=JSON.stringify(R.raw),_=Object.assign(Object.assign({},k),{"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(O.length)}),K=new Date().getTime();let G,Y,ee=0;try{if(G=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:O,headers:_},W),G.res.statusCode&&G.res.statusCode>=400&&G.res.statusCode<500)return{galleryExtensions:[],total:ee};const ne=await(0,n.asJson)(G);if(ne){const re=ne.results[0],se=re.extensions,le=re.resultMetadata&&re.resultMetadata.filter(oe=>oe.metadataType==="ResultCount")[0];return ee=le&&le.metadataItems.filter(oe=>oe.name==="TotalCount")[0].count||0,{galleryExtensions:se,total:ee}}return{galleryExtensions:[],total:ee}}catch(ne){throw Y=ne,ne}finally{this.telemetryService.publicLog2("galleryService:query",Object.assign(Object.assign({},R.telemetryData),{requestBodySize:String(O.length),duration:new Date().getTime()-K,success:!!G&&(0,n.isSuccess)(G),responseBodySize:G==null?void 0:G.res.headers["Content-Length"],statusCode:G?String(G.res.statusCode):void 0,errorCode:Y?(0,m.isPromiseCanceledError)(Y)?"canceled":(0,m.getErrorMessage)(Y).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(ee)}))}}async reportStatistic(R,W,k,O){if(!this.isEnabled())return;const _=await this.commonHeadersPromise,K=Object.assign(Object.assign({},_),{Accept:"*/*;api-version=4.0-preview.1"});try{await this.requestService.request({type:"POST",url:this.api(`/publishers/${R}/extensions/${W}/${k}/stats?statType=${O}`),headers:K},i.CancellationToken.None)}catch(G){}}async download(R,W,k){this.logService.trace("ExtensionGalleryService#download",R.identifier.id);const O=(0,A.getGalleryExtensionTelemetryData)(R),_=new Date().getTime(),K=ne=>this.telemetryService.publicLog("galleryService:downloadVSIX",Object.assign(Object.assign({},O),{duration:ne})),G=k===1?"install":k===2?"update":"",Y=G?{uri:`${R.assets.download.uri}&${G}=true`,fallbackUri:`${R.assets.download.fallbackUri}?${G}=true`}:R.assets.download,ee=await this.getAsset(Y);await this.fileService.writeFile(W,ee.stream),K(new Date().getTime()-_)}async getReadme(R,W){if(R.assets.readme){const k=await this.getAsset(R.assets.readme,{},W);return await(0,n.asText)(k)||""}return""}async getManifest(R,W){if(R.assets.manifest){const k=await this.getAsset(R.assets.manifest,{},W),O=await(0,n.asText)(k);return O?JSON.parse(O):null}return null}async getCoreTranslation(R,W){const k=R.assets.coreTranslations.filter(O=>O[0]===W.toUpperCase())[0];if(k){const O=await this.getAsset(k[1]),_=await(0,n.asText)(O);return _?JSON.parse(_):null}return null}async getChangelog(R,W){if(R.assets.changelog){const k=await this.getAsset(R.assets.changelog,{},W);return await(0,n.asText)(k)||""}return""}async getAllVersions(R,W){let k=new d().withFlags(u.IncludeVersions,u.IncludeFiles,u.IncludeVersionProperties).withPage(1,1).withFilter(l.Target,"Microsoft.VisualStudio.Code");R.identifier.uuid?k=k.withFilter(l.ExtensionId,R.identifier.uuid):k=k.withFilter(l.ExtensionName,R.identifier.id);const O=[],{galleryExtensions:_}=await this.queryGallery(k,i.CancellationToken.None);return _.length&&(W?await Promise.all(_[0].versions.map(async K=>{let G;try{G=await this.getEngine(K)}catch(Y){}G&&(0,w.isEngineValid)(G,this.productService.version,this.productService.date)&&O.push({version:K.version,date:K.lastUpdated})})):O.push(..._[0].versions.map(K=>({version:K.version,date:K.lastUpdated})))),O}async getAsset(R,W={},k=i.CancellationToken.None){const O=await this.commonHeadersPromise,_={type:"GET"},K=Object.assign(Object.assign({},O),W.headers||{});W=Object.assign(Object.assign(Object.assign({},W),_),{headers:K});const G=R.uri,Y=R.fallbackUri,ee=Object.assign(Object.assign({},W),{url:G});try{const ne=await this.requestService.request(ee,k);if(ne.res.statusCode===200)return ne;const re=await(0,n.asText)(ne);throw new Error(`Expected 200, got back ${ne.res.statusCode} instead.

${re}`)}catch(ne){if((0,m.isPromiseCanceledError)(ne))throw ne;const re=(0,m.getErrorMessage)(ne);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:G,message:re});const se=Object.assign(Object.assign({},W),{url:Y});return this.requestService.request(se,k)}}async getLastValidExtensionVersion(R,W){const k=this.getLastValidExtensionVersionFromProperties(R,W);return k||this.getLastValidExtensionVersionRecursively(R,W)}getLastValidExtensionVersionFromProperties(R,W){for(const k of W){const O=x(k);if(!O)return null;if((0,w.isEngineValid)(O,this.productService.version,this.productService.date))return k}return null}async getEngine(R){const W=x(R);if(W)return W;const k=q(R,t.Manifest);if(!k)throw new Error("Manifest was not found");const O={"Accept-Encoding":"gzip"},_=await this.getAsset(k,{headers:O}),K=await(0,n.asJson)(_);if(K)return K.engines.vscode;throw new Error("Error while reading manifest")}async getLastValidExtensionVersionRecursively(R,W){if(!W.length)return null;const k=W[0],O=await this.getEngine(k);return(0,w.isEngineValid)(O,this.productService.version,this.productService.date)?(k.properties=k.properties||[],k.properties.push({key:r.Engine,value:O}),k):this.getLastValidExtensionVersionRecursively(R,W.slice(1))}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const R=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},i.CancellationToken.None);if(R.res.statusCode!==200)throw new Error("Could not get extensions report.");const W=await(0,n.asJson)(R),k=new Map;if(W)for(const O of W.malicious){const _=k.get(O)||{id:{id:O},malicious:!0,slow:!1};_.malicious=!0,k.set(O,_)}return[...k.values()]}};C=he([te(0,n.IRequestService),te(1,I.ILogService),te(2,y.IEnvironmentService),te(3,E.ITelemetryService),te(4,M.IFileService),te(5,g.IProductService),te(6,(0,S.optional)(v.IStorageService))],C),e.ExtensionGalleryService=C;async function z(F,R,W,k){const O={"X-Market-Client-Id":`VSCode ${F}`,"User-Agent":`VSCode ${F}`},_=await(0,D.getServiceMachineId)(R,W,k);return O["X-Market-User-Id"]=_,O}e.resolveMarketplaceHeaders=z}),define(J[199],Z([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class m{constructor(b){this.appender=b}listen(b,E){throw new Error(`Event not found: ${E}`)}call(b,E,{eventName:n,data:w}){return this.appender.log(n,w),Promise.resolve(null)}}e.TelemetryAppenderChannel=m;class L{constructor(b){this.channel=b}log(b,E){return this.channel.call("log",{eventName:b,data:E}).then(void 0,n=>`Failed to log telemetry: ${console.warn(n)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=L}),define(J[200],Z([0,1,47,147,23,4,17,48,2,44,37]),function($,e,m,L,A,b,E,n,w,y,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let I=class{constructor(g,v){this._configurationService=v,this._experimentProperties={},this._disposables=new w.DisposableStore,this._cleanupPatterns=[],this._appender=g.appender,this._commonProperties=g.commonProperties||Promise.resolve({}),this._piiPaths=g.piiPaths||[],this._userOptIn=!0,this._enabled=!0,this.sendErrorTelemetry=!!g.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let D of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,A.escapeRegExpCharacters)(D),"gi"));this._configurationService&&(this._updateUserOptIn(),this._configurationService.onDidChangeConfiguration(this._updateUserOptIn,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._userOptIn}),this._commonProperties.then(D=>{const S=/^[a-f0-9]+$/i.test(D["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!S})}))}setExperimentProperty(g,v){this._experimentProperties[g]=v}setEnabled(g){this._enabled=g}_updateUserOptIn(){var g;const v=(g=this._configurationService)===null||g===void 0?void 0:g.getValue(M);this._userOptIn=v?v.enableTelemetry:this._userOptIn}get isOptedIn(){return this._userOptIn&&this._enabled}async getTelemetryInfo(){const g=await this._commonProperties;let v=g.sessionID,D=g["common.instanceId"],S=g["common.machineId"],a=g["common.firstSessionDate"],u=g["common.msftInternal"];return{sessionId:v,instanceId:D,machineId:S,firstSessionDate:a,msftInternal:u}}dispose(){this._disposables.dispose()}publicLog(g,v,D){return this.isOptedIn?this._commonProperties.then(S=>{v=(0,y.mixin)(v,S),v=(0,y.mixin)(v,this._experimentProperties),v=(0,y.cloneAndChange)(v,a=>{if(typeof a=="string")return this._cleanupInfo(a,D)}),this._appender.log(g,v)},S=>{console.error(S)}):Promise.resolve(void 0)}publicLog2(g,v,D){return this.publicLog(g,v,D)}publicLogError(g,v){return this.sendErrorTelemetry?this.publicLog(g,v,!0):Promise.resolve(void 0)}publicLogError2(g,v){return this.publicLogError(g,v)}_cleanupInfo(g,v){let D=g;if(v){const S=[];for(let l of this._cleanupPatterns)for(;;){const t=l.exec(g);if(!t)break;S.push([t.index,l.lastIndex])}const a=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,u=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let c=0;for(D="";;){const l=u.exec(g);if(!l)break;!a.test(l[0])&&S.every(([t,r])=>l.index<t||l.index>=r)&&(D+=g.substring(c,l.index)+"<REDACTED: user-file-path>",c=u.lastIndex)}c<g.length&&(D+=g.substr(c))}for(let S of this._cleanupPatterns)D=D.replace(S,"");return D}};I.IDLE_START_EVENT_NAME="UserIdleStart",I.IDLE_STOP_EVENT_NAME="UserIdleStop",I=he([te(1,(0,b.optional)(E.IConfigurationService))],I),e.TelemetryService=I;const M="telemetry";i.Registry.as(n.Extensions.Configuration).registerConfiguration({id:M,order:110,type:"object",title:(0,L.localize)(0,null),properties:{"telemetry.enableTelemetry":{type:"boolean",markdownDescription:m.default.privacyStatementUrl?(0,L.localize)(2,null,m.default.privacyStatementUrl):(0,L.localize)(1,null),default:!0,restricted:!0,scope:1,tags:["usesOnlineServices"]}}})}),define(J[97],Z([0,1,17,44,13,9]),function($,e,m,L,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanRemoteAuthority=e.validateTelemetryData=e.configurationTelemetry=e.NullAppender=e.combinedAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=void 0,e.NullTelemetryService=new class{constructor(){this.sendErrorTelemetry=!1,this.isOptedIn=!0}publicLog(g,v){return Promise.resolve(void 0)}publicLog2(g,v){return this.publicLog(g,v)}publicLogError(g,v){return Promise.resolve(void 0)}publicLogError2(g,v){return this.publicLogError(g,v)}setExperimentProperty(){}setEnabled(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}};class E{async publicLog(v,D,S){}async publicLogError(v,D,S){}}e.NullEndpointTelemetryService=E;function n(...g){return{log:(v,D)=>g.forEach(S=>S.log(v,D)),flush:()=>b.Promises.settled(g.map(v=>v.flush()))}}e.combinedAppender=n,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function w(g,v){return v.onDidChangeConfiguration(D=>{D.source!==6&&g.publicLog2("updateConfiguration",{configurationSource:(0,m.ConfigurationTargetToString)(D.source),configurationKeys:M(D.sourceConfig)})})}e.configurationTelemetry=w;function y(g){const v=Object.create(null),D=Object.create(null),S=Object.create(null);I(g,S);for(let a in S){a=a.length>150?a.substr(a.length-149):a;const u=S[a];typeof u=="number"?D[a]=u:typeof u=="boolean"?D[a]=u?1:0:typeof u=="string"?v[a]=u.substring(0,1023):typeof u!="undefined"&&u!==null&&(v[a]=u)}return{properties:v,measurements:D}}e.validateTelemetryData=y;function i(g){if(!g)return"none";let v="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(S=>{g.indexOf(`${S}+`)===0&&(v=S)}),v}e.cleanRemoteAuthority=i;function I(g,v,D=0,S){if(!!g)for(let a of Object.getOwnPropertyNames(g)){const u=g[a],c=S?S+a:a;Array.isArray(u)?v[c]=(0,L.safeStringify)(u):u instanceof Date?v[c]=u.toISOString():(0,A.isObject)(u)?D<2?I(u,v,D+1,c+"."):v[c]=(0,L.safeStringify)(u):v[c]=u}}function M(g){if(!g)return[];const v=[];return p(v,"",g),v}function p(g,v,D){D&&typeof D=="object"&&!Array.isArray(D)?Object.keys(D).forEach(S=>p(g,v?`${v}.${S}`:S,D[S])):g.push(v)}}),define(J[201],Z([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var m;(function(L){L.DARK="dark",L.LIGHT="light",L.HIGH_CONTRAST="hc"})(m=e.ColorScheme||(e.ColorScheme={}))}),define(J[202],Z([0,1,4,2,37,5,201,108]),function($,e,m,L,A,b,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,m.createDecorator)("themeService");var w;(function(D){function S(a){return a&&typeof a=="object"&&typeof a.id=="string"}D.isThemeColor=S})(w=e.ThemeColor||(e.ThemeColor={}));function y(D){return{id:D}}e.themeColorFromId=y;var i;(function(D){function S(r){return r&&typeof r=="object"&&typeof r.id=="string"&&(typeof r.color=="undefined"||w.isThemeColor(r.color))}D.isThemeIcon=S;const a=new RegExp(`^\\$\\((${n.CSSIcon.iconNameExpression}(?:${n.CSSIcon.iconModifierExpression})?)\\)$`);function u(r){const s=a.exec(r);if(!s)return;let[,o]=s;return{id:o}}D.fromString=u;function c(r,s){let o=r.id;const d=o.lastIndexOf("~");return d!==-1&&(o=o.substring(0,d)),s&&(o=`${o}~${s}`),{id:o}}D.modify=c;function l(r,s){var o,d;return r.id===s.id&&((o=r.color)===null||o===void 0?void 0:o.id)===((d=s.color)===null||d===void 0?void 0:d.id)}D.isEqual=l;function t(r){return{id:r.id}}D.asThemeIcon=t,D.asClassNameArray=n.CSSIcon.asClassNameArray,D.asClassName=n.CSSIcon.asClassName,D.asCSSSelector=n.CSSIcon.asCSSSelector})(i=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=n.Codicon.file,e.FolderThemeIcon=n.Codicon.folder;function I(D){switch(D){case E.ColorScheme.DARK:return"vs-dark";case E.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=I,e.Extensions={ThemingContribution:"base.contributions.theming"};class M{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new b.Emitter}onColorThemeChange(S){return this.themingParticipants.push(S),this.onThemingParticipantAddedEmitter.fire(S),(0,L.toDisposable)(()=>{const a=this.themingParticipants.indexOf(S);this.themingParticipants.splice(a,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let p=new M;A.Registry.add(e.Extensions.ThemingContribution,p);function g(D){return p.onColorThemeChange(D)}e.registerThemingParticipant=g;class v extends L.Disposable{constructor(S){super();this.themeService=S,this.theme=S.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(a=>this.onThemeChange(a)))}onThemeChange(S){this.theme=S,this.updateStyles()}updateStyles(){}getColor(S,a){let u=this.theme.getColor(S);return u&&a&&(u=a(u,this.theme)),u?u.toString():null}}e.Themable=v}),define(J[60],Z([0,1,14,3,38,4]),function($,e,m,L,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeMainService=e.IThemeMainService=void 0;const E="#FFFFFF",n="#1E1E1E",w="#000000",y="theme",i="themeBackground",I="windowSplash";e.IThemeMainService=(0,b.createDecorator)("themeMainService");let M=class{constructor(g){this.stateMainService=g}getBackgroundColor(){if((L.isWindows||L.isMacintosh)&&m.nativeTheme.shouldUseInvertedColorScheme)return w;let g=this.stateMainService.getItem(i,null);if(!g){let v;(L.isWindows||L.isMacintosh)&&m.nativeTheme.shouldUseInvertedColorScheme?v="hc-black":v=this.stateMainService.getItem(y,"vs-dark").split(" ")[0],g=v==="hc-black"?w:v==="vs"?E:n}return L.isMacintosh&&g.toUpperCase()===n&&(g="#171717"),g}saveWindowSplash(g,v){this.stateMainService.setItems([{key:y,data:v.baseTheme},{key:i,data:v.colorInfo.background},{key:I,data:v}]),typeof g=="number"&&this.updateBackgroundColor(g,v)}updateBackgroundColor(g,v){for(const D of m.BrowserWindow.getAllWindows())if(D.id===g){D.setBackgroundColor(v.colorInfo.background);break}}getWindowSplash(){return this.stateMainService.getItem(I)}};M=he([te(0,A.IStateMainService)],M),e.ThemeMainService=M}),define(J[41],Z([0,1,4]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUpdateService=e.State=e.UpdateType=e.StateType=void 0;var L;(function(b){b.Uninitialized="uninitialized",b.Idle="idle",b.CheckingForUpdates="checking for updates",b.AvailableForDownload="available for download",b.Downloading="downloading",b.Downloaded="downloaded",b.Updating="updating",b.Ready="ready"})(L=e.StateType||(e.StateType={}));var A;(function(b){b[b.Setup=0]="Setup",b[b.Archive=1]="Archive",b[b.Snap=2]="Snap"})(A=e.UpdateType||(e.UpdateType={})),e.State={Uninitialized:{type:"uninitialized"},Idle:(b,E)=>({type:"idle",updateType:b,error:E}),CheckingForUpdates:b=>({type:"checking for updates",explicit:b}),AvailableForDownload:b=>({type:"available for download",update:b}),Downloading:b=>({type:"downloading",update:b}),Downloaded:b=>({type:"downloaded",update:b}),Updating:b=>({type:"updating",update:b}),Ready:b=>({type:"ready",update:b})},e.IUpdateService=(0,m.createDecorator)("updateService")}),define(J[203],Z([0,1,37,48,148,3]),function($,e,m,L,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),m.Registry.as(L.Extensions.Configuration).registerConfiguration({id:"update",order:15,title:(0,A.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,A.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,A.localize)(2,null),(0,A.localize)(3,null),(0,A.localize)(4,null),(0,A.localize)(5,null)]},"update.channel":{type:"string",default:"default",scope:1,description:(0,A.localize)(6,null),deprecationMessage:(0,A.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,A.localize)(8,null),description:(0,A.localize)(9,null),included:b.isWindows&&!b.isWeb},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,A.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(J[204],Z([0,1,5,41]),function($,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UpdateChannelClient=e.UpdateChannel=void 0;class A{constructor(n){this.service=n}listen(n,w){switch(w){case"onStateChange":return this.service.onStateChange}throw new Error(`Event not found: ${w}`)}call(n,w,y){switch(w){case"checkForUpdates":return this.service.checkForUpdates(y);case"downloadUpdate":return this.service.downloadUpdate();case"applyUpdate":return this.service.applyUpdate();case"quitAndInstall":return this.service.quitAndInstall();case"_getInitialState":return Promise.resolve(this.service.state);case"isLatestVersion":return this.service.isLatestVersion()}throw new Error(`Call not found: ${w}`)}}e.UpdateChannel=A;class b{constructor(n){this.channel=n,this._onStateChange=new m.Emitter,this.onStateChange=this._onStateChange.event,this._state=L.State.Uninitialized,this.channel.listen("onStateChange")(w=>this.state=w),this.channel.call("_getInitialState").then(w=>this.state=w)}get state(){return this._state}set state(n){this._state=n,this._onStateChange.fire(n)}checkForUpdates(n){return this.channel.call("checkForUpdates",n)}downloadUpdate(){return this.channel.call("downloadUpdate")}applyUpdate(){return this.channel.call("applyUpdate")}quitAndInstall(){return this.channel.call("quitAndInstall")}isLatestVersion(){return this.channel.call("isLatestVersion")}}e.UpdateChannelClient=b}),define(J[98],Z([0,1,4]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IURLService=void 0,e.IURLService=(0,m.createDecorator)("urlService")}),define(J[205],Z([0,1,7]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URLHandlerRouter=e.URLHandlerChannelClient=e.URLHandlerChannel=void 0;class L{constructor(n){this.handler=n}listen(n,w){throw new Error(`Event not found: ${w}`)}call(n,w,y){switch(w){case"handleURL":return this.handler.handleURL(m.URI.revive(y[0]),y[1])}throw new Error(`Call not found: ${w}`)}}e.URLHandlerChannel=L;class A{constructor(n){this.channel=n}handleURL(n,w){return this.channel.call("handleURL",[n.toJSON(),w])}}e.URLHandlerChannelClient=A;class b{constructor(n){this.next=n}async routeCall(n,w,y,i){if(w!=="handleURL")throw new Error(`Call not found: ${w}`);if(y){const I=m.URI.revive(y);if(I&&I.query){const M=/\bwindowId=(\d+)/.exec(I.query);if(M){const p=M[1],g=new RegExp(`window:${p}`),v=n.connections.find(D=>g.test(D.ctx));if(v)return v}}}return this.next.routeCall(n,w,y,i)}routeEvent(n,w){throw new Error(`Event not found: ${w}`)}}e.URLHandlerRouter=b}),define(J[206],Z([0,1,7,9,2,22]),function($,e,m,L,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeURLService=e.AbstractURLService=void 0;class E extends A.Disposable{constructor(){super(...arguments);this.handlers=new Set}open(y,i){const I=[...this.handlers.values()];return(0,L.first)(I.map(M=>()=>M.handleURL(y,i)),void 0,!1).then(M=>M||!1)}registerHandler(y){return this.handlers.add(y),(0,A.toDisposable)(()=>this.handlers.delete(y))}}e.AbstractURLService=E;let n=class extends E{constructor(y){super();this.productService=y}create(y){let{authority:i,path:I,query:M,fragment:p}=y||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return i&&I&&I.indexOf("/")!==0&&(I=`/${I}`),m.URI.from({scheme:this.productService.urlProtocol,authority:i,path:I,query:M,fragment:p})}};n=he([te(0,b.IProductService)],n),e.NativeURLService=n}),define(J[207],Z([0,1,5,14,7,2,3,9]),function($,e,m,L,A,b,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronURLListener=void 0;function w(i){try{return A.URI.parse(i)}catch(I){return null}}class y{constructor(I,M,p,g,v){if(this.urlService=M,this.uris=[],this.retryCount=0,this.flushDisposable=b.Disposable.None,this.disposables=new b.DisposableStore,this.uris=I,E.isWindows){const a=g.isBuilt?[]:[`"${g.appRoot}"`];a.push("--open-url","--"),L.app.setAsDefaultProtocolClient(v.urlProtocol,process.execPath,a)}const D=m.Event.map(m.Event.fromNodeEventEmitter(L.app,"open-url",(a,u)=>({event:a,url:u})),({event:a,url:u})=>(a.preventDefault(),u));this.disposables.add(D(a=>{const u=w(a);!u||this.urlService.open(u,{originalUrl:a})})),p.getWindows().filter(a=>a.isReady).length>0?this.flush():m.Event.once(p.onDidSignalReadyWindow)(this.flush,this,this.disposables)}async flush(){if(this.retryCount++>10)return;const I=[];for(const M of this.uris)await this.urlService.open(M.uri,{originalUrl:M.url})||I.push(M);I.length!==0&&(this.uris=I,this.flushDisposable=(0,n.disposableTimeout)(()=>this.flush(),500))}dispose(){this.disposables.dispose(),this.flushDisposable.dispose()}}e.ElectronURLListener=y}),define(J[76],Z([0,1,4]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.webviewPartitionId=e.IWebviewManagerService=void 0,e.IWebviewManagerService=(0,m.createDecorator)("webviewManagerService"),e.webviewPartitionId="webview"}),define(J[208],Z([0,1,14,2,10,7,76]),function($,e,m,L,A,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewProtocolProvider=void 0;class n extends L.Disposable{constructor(){super();const y=m.session.fromPartition(E.webviewPartitionId),i=this.handleWebviewRequest.bind(this);m.protocol.registerFileProtocol(A.Schemas.vscodeWebview,i),y.protocol.registerFileProtocol(A.Schemas.vscodeWebview,i)}async handleWebviewRequest(y,i){try{const I=b.URI.parse(y.url),M=n.validWebviewFilePaths.get(I.path);if(typeof M=="string"){const p=I.path.startsWith("/electron-browser")?`vs/workbench/contrib/webview/electron-browser/pre/${M}`:`vs/workbench/contrib/webview/browser/pre/${M}`,g=A.FileAccess.asFileUri(p,$);return i(decodeURIComponent(g.fsPath))}}catch(I){}i({error:-10})}}e.WebviewProtocolProvider=n,n.validWebviewFilePaths=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/electron-browser-index.html","index.html"],["/main.js","main.js"],["/host.js","host.js"],["/service-worker.js","service-worker.js"]])}),define(J[61],Z([0,1,3]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.zoomLevelToZoomFactor=e.getTitleBarStyle=e.getMenuBarVisibility=e.isFileToOpen=e.isFolderToOpen=e.isWorkspaceToOpen=e.WindowMinimumSize=void 0,e.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function L(y){return!!y.workspaceUri}e.isWorkspaceToOpen=L;function A(y){return!!y.folderUri}e.isFolderToOpen=A;function b(y){return!!y.fileUri}e.isFileToOpen=b;function E(y){const i=n(y),I=y.getValue("window.menuBarVisibility");return I==="default"||i==="native"&&I==="compact"||m.isMacintosh&&m.isNative?"classic":I}e.getMenuBarVisibility=E;function n(y){if(m.isWeb)return"custom";const i=y.getValue("window");if(i){if(m.isMacintosh&&i.nativeTabs===!0||m.isMacintosh&&i.nativeFullScreen===!1)return"native";const p=i.titleBarStyle;if(p==="native"||p==="custom")return p}return m.isLinux?"native":"custom"}e.getTitleBarStyle=n;function w(y=0){return Math.pow(1.2,y)}e.zoomLevelToZoomFactor=w}),define(J[34],Z([0,1,4]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWindowsMainService=e.WindowError=e.WindowMode=e.defaultWindowState=e.OpenContext=void 0;var L;(function(n){n[n.CLI=0]="CLI",n[n.DOCK=1]="DOCK",n[n.MENU=2]="MENU",n[n.DIALOG=3]="DIALOG",n[n.DESKTOP=4]="DESKTOP",n[n.API=5]="API"})(L=e.OpenContext||(e.OpenContext={}));const A=function(n=1){return{width:1024,height:768,mode:n}};e.defaultWindowState=A;var b;(function(n){n[n.Maximized=0]="Maximized",n[n.Normal=1]="Normal",n[n.Minimized=2]="Minimized",n[n.Fullscreen=3]="Fullscreen"})(b=e.WindowMode||(e.WindowMode={}));var E;(function(n){n[n.UNRESPONSIVE=1]="UNRESPONSIVE",n[n.CRASHED=2]="CRASHED",n[n.LOAD=3]="LOAD"})(E=e.WindowError||(e.WindowError={})),e.IWindowsMainService=(0,m.createDecorator)("windowsMainService")}),define(J[209],Z([0,1,14,2,74,76,208,34]),function($,e,m,L,A,b,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewMainService=void 0;let w=class extends L.Disposable{constructor(i,I){super();this.windowsMainService=I,this._register(new E.WebviewProtocolProvider);const M=m.session.fromPartition(b.webviewPartitionId);M.setPermissionRequestHandler((p,g,v)=>v(g==="clipboard-read")),M.setPermissionCheckHandler((p,g)=>g==="clipboard-read")}async setIgnoreMenuShortcuts(i,I){let M;if(typeof i.windowId=="number"){const{windowId:p}=i,g=this.windowsMainService.getWindowById(p);if(!(g==null?void 0:g.win))throw new Error(`Invalid windowId: ${p}`);M=g.win.webContents}else{const{webContentsId:p}=i;if(M=m.webContents.fromId(p),!M)throw new Error(`Invalid webContentsId: ${p}`)}M.isDestroyed()||M.setIgnoreMenuShortcuts(I)}};w=he([te(0,A.ITunnelService),te(1,n.IWindowsMainService)],w),e.WebviewMainService=w}),define(J[210],Z([0,1,5,2,9]),function($,e,m,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class b extends L.Disposable{constructor({onDidOpenWindow:n,onDidFocusWindow:w,getActiveWindowId:y}){super();this.disposables=this._register(new L.DisposableStore),m.Event.latch(m.Event.any(n,w))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,A.createCancelablePromise)(()=>y()),(async()=>{try{const I=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:I}catch(I){}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(n){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=n}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=b}),define(J[211],Z([0,1,7,15,4,36]),function($,e,m,L,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,A.createDecorator)("contextService");var E;(function(M){M[M.EMPTY=1]="EMPTY",M[M.FOLDER=2]="FOLDER",M[M.WORKSPACE=3]="WORKSPACE"})(E=e.WorkbenchState||(e.WorkbenchState={}));function n(M){const p=M;return!!(p&&typeof p=="object"&&typeof p.id=="string"&&Array.isArray(p.folders))}e.isWorkspace=n;function w(M){const p=M;return!!(p&&typeof p=="object"&&m.URI.isUri(p.uri)&&typeof p.name=="string"&&typeof p.toResource=="function")}e.isWorkspaceFolder=w;class y{constructor(p,g,v,D){this._id=p,this._configuration=v,this._ignorePathCasing=D,this._foldersMap=b.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=g}update(p){this._id=p.id,this._configuration=p.configuration,this._ignorePathCasing=p._ignorePathCasing,this.folders=p.folders}get folders(){return this._folders}set folders(p){this._folders=p,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(p){this._configuration=p}getFolder(p){return p&&this._foldersMap.findSubstr(p.with({scheme:p.scheme,authority:p.authority,path:p.path}))||null}updateFoldersMap(){this._foldersMap=b.TernarySearchTree.forUris(this._ignorePathCasing);for(const p of this.folders)this._foldersMap.set(p.uri,p)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=y;class i{constructor(p,g){this.raw=g,this.uri=p.uri,this.index=p.index,this.name=p.name}toResource(p){return(0,L.joinPath)(this.uri,p)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=i;function I(M){return new i({uri:M,index:0,name:(0,L.basenameOrAuthority)(M)},{uri:M.toString()})}e.toWorkspaceFolder=I}),define(J[28],Z([0,1,4,151,211,7,3,8,15,104,43,10,39,30,73]),function($,e,m,L,A,b,E,n,w,y,i,I,M,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const v=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,L.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function D(V){return(typeof V=="string"?(0,n.extname)(V):(0,w.extname)(V))===v}e.hasWorkspaceFileExtension=D,e.IWorkspacesService=(0,m.createDecorator)("workspacesService");function S(V){return V.hasOwnProperty("workspace")}e.isRecentWorkspace=S;function a(V){return V.hasOwnProperty("folderUri")}e.isRecentFolder=a;function u(V){return V.hasOwnProperty("fileUri")}e.isRecentFile=u;function c(V){const N=V;return typeof(N==null?void 0:N.id)=="string"&&b.URI.isUri(N.uri)}e.isSingleFolderWorkspaceIdentifier=c;function l(V){if(V.configuration)return{id:V.id,configPath:V.configuration};if(V.folders.length===1)return{id:V.id,uri:V.folders[0].uri}}e.toWorkspaceIdentifier=l;function t(V){const N=V;return typeof(N==null?void 0:N.id)=="string"&&b.URI.isUri(N.configPath)}e.isWorkspaceIdentifier=t;function r(V){const N=V;if(N==null?void 0:N.uri)return{id:N.id,uri:b.URI.revive(N.uri)};const C=V;if(C==null?void 0:C.configPath)return{id:C.id,configPath:b.URI.revive(C.configPath)};if(V==null?void 0:V.id)return{id:V.id}}e.reviveIdentifier=r;function s(V,N){return w.extUriBiasedIgnorePathCase.isEqualOrParent(V,N.untitledWorkspacesHome)}e.isUntitledWorkspace=s;function o(V){return d(V)||f(V)}e.isStoredWorkspaceFolder=o;function d(V){const N=V;return typeof(N==null?void 0:N.path)=="string"&&(!N.name||typeof N.name=="string")}e.isRawFileWorkspaceFolder=d;function f(V){const N=V;return typeof(N==null?void 0:N.uri)=="string"&&(!N.name||typeof N.name=="string")}e.isRawUriWorkspaceFolder=f;function h(V,N,C,z,F=!E.isWindows,R){if(V.scheme!==z.scheme)return{name:C,uri:V.toString(!0)};let W=N?void 0:R.relativePath(z,V);if(W!==void 0)W.length===0?W=".":E.isWindows&&V.scheme===I.Schemas.file&&!F&&(W=W.replace(/\//g,"\\"));else if(V.scheme===I.Schemas.file)W=V.fsPath,E.isWindows&&(W=(0,M.normalizeDriveLetter)(W),F&&(W=(0,p.toSlashes)(W)));else{if(!R.isEqualAuthority(V.authority,z.authority))return{name:C,uri:V.toString(!0)};W=V.path}return{name:C,path:W}}e.getStoredWorkspaceFolder=h;function P(V,N,C){let z=[],F=new Set;const R=C.dirname(N);for(let W of V){let k;if(d(W))W.path&&(k=C.resolvePath(R,W.path));else if(f(W))try{k=b.URI.parse(W.uri),k.path[0]!=="/"&&(k=k.with({path:"/"+k.path}))}catch(O){console.warn(O)}if(k){let O=C.getComparisonKey(k);if(!F.has(O)){F.add(O);const _=W.name||C.basenameOrAuthority(k);z.push(new A.WorkspaceFolder({uri:k,name:_,index:z.length},W))}}}return z}e.toWorkspaceFolders=P;function T(V,N,C,z,F){let R=U(N,V);const W=F.dirname(N),k=F.dirname(z),O=[],_=q(R.folders);for(const ee of R.folders){const ne=d(ee)?F.resolvePath(W,ee.path):b.URI.parse(ee.uri);let re;C?re=!1:re=!d(ee)||(0,n.isAbsolute)(ee.path),O.push(h(ne,re,ee.name,k,_,F))}const K={insertSpaces:!1,tabSize:4,eol:E.isLinux||E.isMacintosh?`
`:`\r
`},G=y.setProperty(V,["folders"],O,K);let Y=y.applyEdits(V,G);return R.remoteAuthority===(0,g.getRemoteAuthority)(z)&&(Y=y.applyEdits(Y,y.removeProperty(Y,["remoteAuthority"],K))),Y}e.rewriteWorkspaceFileForNewLocation=T;function U(V,N){let C=i.parse(N);if(C&&Array.isArray(C.folders))C.folders=C.folders.filter(z=>o(z));else throw new Error(`${V} looks like an invalid workspace file.`);return C}function q(V){return E.isWindows?V.some(N=>d(N)&&N.path.indexOf("/")>=0):!0}e.useSlashForPath=q;function Q(V){return V.workspace&&typeof V.workspace=="object"&&typeof V.workspace.id=="string"&&typeof V.workspace.configPath=="string"}function x(V){return typeof V.folderUri=="string"}function j(V){return typeof V.fileUri=="string"}function X(V,N){const C={workspaces:[],files:[]};if(V){const z=function(R,W){for(let k=0;k<R.length;k++)try{W(R[k],k)}catch(O){N.warn(`Error restoring recent entry ${JSON.stringify(R[k])}: ${O.toString()}. Skip entry.`)}},F=V;if(Array.isArray(F.entries))z(F.entries,R=>{const W=R.label,k=R.remoteAuthority;Q(R)?C.workspaces.push({label:W,remoteAuthority:k,workspace:{id:R.workspace.id,configPath:b.URI.parse(R.workspace.configPath)}}):x(R)?C.workspaces.push({label:W,remoteAuthority:k,folderUri:b.URI.parse(R.folderUri)}):j(R)&&C.files.push({label:W,remoteAuthority:k,fileUri:b.URI.parse(R.fileUri)})});else{const R=V;Array.isArray(R.workspaces3)&&z(R.workspaces3,(W,k)=>{const O=Array.isArray(R.workspaceLabels)&&R.workspaceLabels[k]||void 0;typeof W=="object"&&typeof W.id=="string"&&typeof W.configURIPath=="string"?C.workspaces.push({label:O,workspace:{id:W.id,configPath:b.URI.parse(W.configURIPath)}}):typeof W=="string"&&C.workspaces.push({label:O,folderUri:b.URI.parse(W)})}),Array.isArray(R.files2)&&z(R.files2,(W,k)=>{const O=Array.isArray(R.fileLabels)&&R.fileLabels[k]||void 0;typeof W=="string"&&C.files.push({label:O,fileUri:b.URI.parse(W)})})}}return C}e.restoreRecentlyOpened=X;function B(V){const N={entries:[]};for(const C of V.workspaces)a(C)?N.entries.push({folderUri:C.folderUri.toString(),label:C.label,remoteAuthority:C.remoteAuthority}):N.entries.push({workspace:{id:C.workspace.id,configPath:C.workspace.configPath.toString()},label:C.label,remoteAuthority:C.remoteAuthority});for(const C of V.files)N.entries.push({fileUri:C.fileUri.toString(),label:C.label,remoteAuthority:C.remoteAuthority});return N}e.toStoreData=B}),define(J[50],Z([0,1,4,28]),function($,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isWorkspaceBackupInfo=e.IBackupMainService=void 0,e.IBackupMainService=(0,m.createDecorator)("backupMainService");function A(b){const E=b;return E&&(0,L.isWorkspaceIdentifier)(E.workspace)}e.isWorkspaceBackupInfo=A}),define(J[51],Z([0,1,4,14,9,38,3,8,65,16,13,133,28,39,2,80]),function($,e,m,L,A,b,E,n,w,y,i,I,M,p,g,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DialogMainService=e.IDialogMainService=void 0,e.IDialogMainService=(0,m.createDecorator)("dialogMainService");let D=class vt{constructor(a){this.stateMainService=a,this.windowFileDialogLocks=new Map,this.windowDialogQueues=new Map,this.noWindowDialogueQueue=new A.Queue}pickFileFolder(a,u){return this.doPick(Object.assign(Object.assign({},a),{pickFolders:!0,pickFiles:!0,title:(0,I.localize)(0,null)}),u)}pickFolder(a,u){return this.doPick(Object.assign(Object.assign({},a),{pickFolders:!0,title:(0,I.localize)(1,null)}),u)}pickFile(a,u){return this.doPick(Object.assign(Object.assign({},a),{pickFiles:!0,title:(0,I.localize)(2,null)}),u)}pickWorkspace(a,u){const c=(0,I.localize)(3,null),l=(0,p.mnemonicButtonLabel)((0,I.localize)(4,null)),t=M.WORKSPACE_FILTER;return this.doPick(Object.assign(Object.assign({},a),{pickFiles:!0,title:c,filters:t,buttonLabel:l}),u)}async doPick(a,u){const c={title:a.title,buttonLabel:a.buttonLabel,filters:a.filters};c.defaultPath=a.defaultPath||this.stateMainService.getItem(vt.workingDirPickerStorageKey),(typeof a.pickFiles=="boolean"||typeof a.pickFolders=="boolean")&&(c.properties=void 0,a.pickFiles&&a.pickFolders&&(c.properties=["multiSelections","openDirectory","openFile","createDirectory"])),c.properties||(c.properties=["multiSelections",a.pickFolders?"openDirectory":"openFile","createDirectory"]),E.isMacintosh&&c.properties.push("treatPackageAsDirectory");const l=u||L.BrowserWindow.getFocusedWindow(),t=await this.showOpenDialog(c,(0,i.withNullAsUndefined)(l));if(t&&t.filePaths&&t.filePaths.length>0)return this.stateMainService.setItem(vt.workingDirPickerStorageKey,(0,n.dirname)(t.filePaths[0])),t.filePaths}getWindowDialogQueue(a){if(a){let u=this.windowDialogQueues.get(a.id);return u||(u=new A.Queue,this.windowDialogQueues.set(a.id,u)),u}else return this.noWindowDialogueQueue}showMessageBox(a,u){return this.getWindowDialogQueue(u).queue(async()=>u?L.dialog.showMessageBox(u,a):L.dialog.showMessageBox(a))}async showSaveDialog(a,u){const c=this.acquireFileDialogLock(a,u);if(!c)throw new Error("A file save dialog is already or will be showing for the window with the same configuration");try{return await this.getWindowDialogQueue(u).queue(async()=>{let l;return u?l=await L.dialog.showSaveDialog(u,a):l=await L.dialog.showSaveDialog(a),l.filePath=this.normalizePath(l.filePath),l})}finally{(0,g.dispose)(c)}}normalizePath(a){return a&&E.isMacintosh&&(a=(0,w.normalizeNFC)(a)),a}normalizePaths(a){return a.map(u=>this.normalizePath(u))}async showOpenDialog(a,u){a.defaultPath&&(await(0,y.exists)(a.defaultPath)||(a.defaultPath=void 0));const c=this.acquireFileDialogLock(a,u);if(!c)throw new Error("A file open dialog is already or will be showing for the window with the same configuration");try{return await this.getWindowDialogQueue(u).queue(async()=>{let l;return u?l=await L.dialog.showOpenDialog(u,a):l=await L.dialog.showOpenDialog(a),l.filePaths=this.normalizePaths(l.filePaths),l})}finally{(0,g.dispose)(c)}}acquireFileDialogLock(a,u){if(!u)return g.Disposable.None;let c=this.windowFileDialogLocks.get(u.id);c||(c=new Set,this.windowFileDialogLocks.set(u.id,c));const l=(0,v.hash)(a);if(!c.has(l))return c.add(l),(0,g.toDisposable)(()=>{c==null||c.delete(l),(c==null?void 0:c.size)===0&&this.windowFileDialogLocks.delete(u.id)})}};D.workingDirPickerStorageKey="pickerWorkingDir",D=he([te(0,b.IStateMainService)],D),e.DialogMainService=D}),define(J[212],Z([0,1,5,2,28]),function($,e,m,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannel=void 0;class b extends L.Disposable{constructor(n,w){super();this.logService=n,this.storageMainService=w,this._onDidChangeGlobalStorage=this._register(new m.Emitter),this.onDidChangeGlobalStorage=this._onDidChangeGlobalStorage.event,this.registerGlobalStorageListeners()}registerGlobalStorageListeners(){this._register(m.Event.debounce(this.storageMainService.globalStorage.onDidChangeStorage,(n,w)=>(n?n.push(w):n=[w],n),b.STORAGE_CHANGE_DEBOUNCE_TIME)(n=>{n.length&&this._onDidChangeGlobalStorage.fire(this.serializeGlobalStorageEvents(n))}))}serializeGlobalStorageEvents(n){const w=new Map,y=new Set;return n.forEach(i=>{const I=this.storageMainService.globalStorage.get(i.key);typeof I=="string"?w.set(i.key,I):y.add(i.key)}),{changed:Array.from(w.entries()),deleted:Array.from(y.values())}}listen(n,w){switch(w){case"onDidChangeGlobalStorage":return this.onDidChangeGlobalStorage}throw new Error(`Event not found: ${w}`)}async call(n,w,y){const i=(0,A.reviveIdentifier)(y.workspace),I=await this.withStorageInitialized(i);switch(w){case"getItems":return Array.from(I.items.entries());case"updateItems":{const M=y;if(M.insert)for(const[p,g]of M.insert)I.set(p,g);M.delete&&M.delete.forEach(p=>I.delete(p));break}case"close":{if(i)return I.close();break}default:throw new Error(`Call not found: ${w}`)}}async withStorageInitialized(n){const w=n?this.storageMainService.workspaceStorage(n):this.storageMainService.globalStorage;try{await w.init()}catch(y){this.logService.error(`StorageIPC#init: Unable to init ${n?"workspace":"global"} storage due to ${y}`)}return w}}e.StorageDatabaseChannel=b,b.STORAGE_CHANGE_DEBOUNCE_TIME=100}),define(J[213],Z([0,1,16,5,2,6,123,86,8,96,31,27,28]),function($,e,m,L,A,b,E,n,w,y,i,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspaceStorageMain=e.GlobalStorageMain=void 0;class p extends A.Disposable{constructor(S){super();this.logService=S,this._onDidChangeStorage=this._register(new L.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this._onDidCloseStorage=this._register(new L.Emitter),this.onDidCloseStorage=this._onDidCloseStorage.event,this.storage=new n.Storage(new n.InMemoryStorageDatabase),this.initializePromise=void 0}init(){return this.initializePromise||(this.initializePromise=(async()=>{try{const S=await this.doCreate();this.storage.dispose(),this.storage=S,this._register(S.onDidChangeStorage(u=>this._onDidChangeStorage.fire({key:u}))),await this.doInit(S);const a=S.getBoolean(y.IS_NEW_KEY);a===void 0?S.set(y.IS_NEW_KEY,!0):a&&S.set(y.IS_NEW_KEY,!1)}catch(S){this.logService.error(`StorageMain#initialize(): Unable to init storage due to ${S}`)}})()),this.initializePromise}createLogginOptions(){return{logTrace:this.logService.getLevel()===b.LogLevel.Trace?S=>this.logService.trace(S):void 0,logError:S=>this.logService.error(S)}}doInit(S){return S.init()}get items(){return this.storage.items}get(S,a){return this.storage.get(S,a)}set(S,a){return this.storage.set(S,a)}delete(S){return this.storage.delete(S)}async close(){this.initializePromise&&await this.initializePromise,await this.storage.close(),this._onDidCloseStorage.fire()}}class g extends p{constructor(S,a,u){super(a);this.options=S,this.environmentService=u}async doCreate(){let S;return this.options.useInMemoryStorage?S=E.SQLiteStorageDatabase.IN_MEMORY_PATH:S=(0,w.join)(this.environmentService.globalStorageHome.fsPath,g.STORAGE_NAME),new n.Storage(new E.SQLiteStorageDatabase(S,{logging:this.createLogginOptions()}))}async doInit(S){await super.doInit(S),this.updateTelemetryState(S)}updateTelemetryState(S){S.get(i.instanceStorageKey,void 0)===void 0&&S.set(i.instanceStorageKey,(0,I.generateUuid)()),S.get(i.firstSessionDateStorageKey,void 0)===void 0&&S.set(i.firstSessionDateStorageKey,new Date().toUTCString());const c=S.get(i.currentSessionDateStorageKey,void 0),l=new Date().toUTCString();S.set(i.lastSessionDateStorageKey,typeof c=="undefined"?null:c),S.set(i.currentSessionDateStorageKey,l)}}e.GlobalStorageMain=g,g.STORAGE_NAME="state.vscdb";class v extends p{constructor(S,a,u,c){super(u);this.workspace=S,this.options=a,this.environmentService=c}async doCreate(){const{storageFilePath:S,wasCreated:a}=await this.prepareWorkspaceStorageFolder();return new n.Storage(new E.SQLiteStorageDatabase(S,{logging:this.createLogginOptions()}),{hint:a?n.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async prepareWorkspaceStorageFolder(){if(this.options.useInMemoryStorage)return{storageFilePath:E.SQLiteStorageDatabase.IN_MEMORY_PATH,wasCreated:!0};const S=(0,w.join)(this.environmentService.workspaceStorageHome.fsPath,this.workspace.id),a=(0,w.join)(S,v.WORKSPACE_STORAGE_NAME);return await(0,m.exists)(S)?{storageFilePath:a,wasCreated:!1}:(await m.Promises.mkdir(S,{recursive:!0}),this.ensureWorkspaceStorageFolderMeta(S),{storageFilePath:a,wasCreated:!0})}async ensureWorkspaceStorageFolderMeta(S){let a;if((0,M.isSingleFolderWorkspaceIdentifier)(this.workspace)?a={folder:this.workspace.uri.toString()}:(0,M.isWorkspaceIdentifier)(this.workspace)&&(a={workspace:this.workspace.configPath.toString()}),a)try{const u=(0,w.join)(S,v.WORKSPACE_META_NAME);await(0,m.exists)(u)||await(0,m.writeFile)(u,JSON.stringify(a,void 0,2))}catch(u){this.logService.error(`StorageMain#ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${u}`)}}}e.WorkspaceStorageMain=v,v.WORKSPACE_STORAGE_NAME="state.vscdb",v.WORKSPACE_META_NAME="workspace.json"}),define(J[99],Z([0,1,42,2,53,4,18,6,213]),function($,e,m,L,A,b,E,n,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageMainService=e.IStorageMainService=void 0,e.IStorageMainService=(0,b.createDecorator)("storageMainService");let y=class extends L.Disposable{constructor(I,M,p){super();this.logService=I,this.environmentService=M,this.lifecycleMainService=p,this.globalStorage=this.createGlobalStorage(),this.mapWorkspaceToStorage=new Map,this.registerListeners()}getStorageOptions(){return{useInMemoryStorage:!!this.environmentService.extensionTestsLocationURI}}registerListeners(){(async()=>{await this.lifecycleMainService.when(3),this.globalStorage.init()})(),this._register(this.lifecycleMainService.onWillLoadWindow(async I=>{I.workspace&&this.workspaceStorage(I.workspace).init()})),this._register(this.lifecycleMainService.onWillShutdown(I=>{I.join(this.globalStorage.close());for(const[,M]of this.mapWorkspaceToStorage)I.join(M.close())}))}createGlobalStorage(){if(this.globalStorage)return this.globalStorage;this.logService.trace("StorageMainService: creating global storage");const I=new w.GlobalStorageMain(this.getStorageOptions(),this.logService,this.environmentService);return(0,m.once)(I.onDidCloseStorage)(()=>{this.logService.trace("StorageMainService: closed global storage")}),I}createWorkspaceStorage(I){return new w.WorkspaceStorageMain(I,this.getStorageOptions(),this.logService,this.environmentService)}workspaceStorage(I){let M=this.mapWorkspaceToStorage.get(I.id);return M||(this.logService.trace(`StorageMainService: creating workspace storage (${I.id})`),M=this.createWorkspaceStorage(I),this.mapWorkspaceToStorage.set(I.id,M),(0,m.once)(M.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed workspace storage (${I.id})`),this.mapWorkspaceToStorage.delete(I.id)})),M}};y=he([te(0,n.ILogService),te(1,A.IEnvironmentService),te(2,E.ILifecycleMainService)],y),e.StorageMainService=y}),define(J[100],Z([0,1,7,28,15]),function($,e,m,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findWindowOnExtensionDevelopmentPath=e.findWindowOnWorkspaceOrFolder=e.findWindowOnFile=void 0;function b(w,y,i){for(const M of w){const p=M.openedWorkspace;if((0,L.isWorkspaceIdentifier)(p)){const g=i(p);if(g){if(g.folders.some(v=>A.extUriBiasedIgnorePathCase.isEqualOrParent(y,v.uri)))return M}else if(A.extUriBiasedIgnorePathCase.isEqualOrParent(y,p.configPath))return M}}const I=w.filter(M=>(0,L.isSingleFolderWorkspaceIdentifier)(M.openedWorkspace)&&A.extUriBiasedIgnorePathCase.isEqualOrParent(y,M.openedWorkspace.uri));if(I.length)return I.sort((M,p)=>-(M.openedWorkspace.uri.path.length-p.openedWorkspace.uri.path.length))[0]}e.findWindowOnFile=b;function E(w,y){for(const i of w)if((0,L.isWorkspaceIdentifier)(i.openedWorkspace)&&A.extUriBiasedIgnorePathCase.isEqual(i.openedWorkspace.configPath,y)||(0,L.isSingleFolderWorkspaceIdentifier)(i.openedWorkspace)&&A.extUriBiasedIgnorePathCase.isEqual(i.openedWorkspace.uri,y))return i}e.findWindowOnWorkspaceOrFolder=E;function n(w,y){var i,I;const M=p=>y.some(g=>A.extUriBiasedIgnorePathCase.isEqual(m.URI.file(g),m.URI.file(p)));for(const p of w)if((I=(i=p.config)===null||i===void 0?void 0:i.extensionDevelopmentPath)===null||I===void 0?void 0:I.some(g=>M(g)))return p}e.findWindowOnExtensionDevelopmentPath=n}),define(J[214],Z([0,1,14,2,3,15,7,17,18,6,38,34,28]),function($,e,m,L,A,b,E,n,w,y,i,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWindowsStateStoreData=e.restoreWindowsState=e.WindowsStateHandler=void 0;let p=class wt extends L.Disposable{constructor(u,c,l,t,r){super();this.windowsMainService=u,this.stateMainService=c,this.lifecycleMainService=l,this.logService=t,this.configurationService=r,this._state=g(this.stateMainService.getItem(wt.windowsStateStorageKey)),this.lastClosedState=void 0,this.shuttingDown=!1,this.registerListeners()}get state(){return this._state}registerListeners(){m.app.on("browser-window-blur",()=>{this.shuttingDown||this.saveWindowsState()}),this.lifecycleMainService.onBeforeCloseWindow(u=>this.onBeforeCloseWindow(u)),this.lifecycleMainService.onBeforeShutdown(()=>this.onBeforeShutdown()),this.windowsMainService.onDidChangeWindowsCount(u=>{u.newCount-u.oldCount>0&&(this.lastClosedState=void 0)}),this.windowsMainService.onDidDestroyWindow(u=>this.onBeforeCloseWindow(u))}onBeforeShutdown(){this.shuttingDown=!0,this.saveWindowsState()}saveWindowsState(){const u={openedWindows:[],lastPluginDevelopmentHostWindow:this._state.lastPluginDevelopmentHostWindow,lastActiveWindow:this.lastClosedState};if(!u.lastActiveWindow){let t=this.windowsMainService.getLastActiveWindow();(!t||t.isExtensionDevelopmentHost)&&(t=this.windowsMainService.getWindows().find(r=>!r.isExtensionDevelopmentHost)),t&&(u.lastActiveWindow=this.toWindowState(t))}const c=this.windowsMainService.getWindows().find(t=>t.isExtensionDevelopmentHost&&!t.isExtensionTestHost);c&&(u.lastPluginDevelopmentHostWindow=this.toWindowState(c)),this.windowsMainService.getWindowCount()>1&&(u.openedWindows=this.windowsMainService.getWindows().filter(t=>!t.isExtensionDevelopmentHost).map(t=>this.toWindowState(t)));const l=D(u);this.stateMainService.setItem(wt.windowsStateStorageKey,l),this.shuttingDown&&this.logService.trace("[WindowsStateHandler] onBeforeShutdown",l)}onBeforeCloseWindow(u){if(this.lifecycleMainService.quitRequested)return;const c=this.toWindowState(u);u.isExtensionDevelopmentHost&&!u.isExtensionTestHost?this._state.lastPluginDevelopmentHostWindow=c:!u.isExtensionDevelopmentHost&&u.openedWorkspace&&this._state.openedWindows.forEach(l=>{var t;const r=(0,M.isWorkspaceIdentifier)(u.openedWorkspace)&&((t=l.workspace)===null||t===void 0?void 0:t.id)===u.openedWorkspace.id,s=(0,M.isSingleFolderWorkspaceIdentifier)(u.openedWorkspace)&&l.folderUri&&b.extUriBiasedIgnorePathCase.isEqual(l.folderUri,u.openedWorkspace.uri);(r||s)&&(l.uiState=c.uiState)}),this.windowsMainService.getWindowCount()===1&&(this.lastClosedState=c)}toWindowState(u){return{workspace:(0,M.isWorkspaceIdentifier)(u.openedWorkspace)?u.openedWorkspace:void 0,folderUri:(0,M.isSingleFolderWorkspaceIdentifier)(u.openedWorkspace)?u.openedWorkspace.uri:void 0,backupPath:u.backupPath,remoteAuthority:u.remoteAuthority,uiState:u.serializeWindowState()}}getNewWindowState(u){const c=this.doGetNewWindowState(u),l=this.configurationService.getValue("window");let t;return c.hasDefaultState?t=!!((l==null?void 0:l.newWindowDimensions)&&["fullscreen","inherit","offset"].indexOf(l.newWindowDimensions)>=0):(t=!!(this.lifecycleMainService.wasRestarted||(l==null?void 0:l.restoreFullscreen)),t&&A.isMacintosh&&this.windowsMainService.getWindows().some(r=>r.isFullScreen)&&(t=!1)),c.mode===3&&!t&&(c.mode=1),c}doGetNewWindowState(u){const c=this.windowsMainService.getLastActiveWindow();if(!u.extensionTestsPath){if(!!u.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const d=u.workspace;if((0,M.isWorkspaceIdentifier)(d)){const h=this.state.openedWindows.filter(P=>P.workspace&&P.workspace.id===d.id).map(P=>P.uiState);if(h.length)return h[0]}if((0,M.isSingleFolderWorkspaceIdentifier)(d)){const h=this.state.openedWindows.filter(P=>P.folderUri&&b.extUriBiasedIgnorePathCase.isEqual(P.folderUri,d.uri)).map(P=>P.uiState);if(h.length)return h[0]}else if(u.backupPath){const h=this.state.openedWindows.filter(P=>P.backupPath===u.backupPath).map(P=>P.uiState);if(h.length)return h[0]}const f=this.lastClosedState||this.state.lastActiveWindow;if(!c&&f)return f.uiState}let l;const t=m.screen.getAllDisplays();if(t.length===1)l=t[0];else{if(A.isMacintosh){const d=m.screen.getCursorScreenPoint();l=m.screen.getDisplayNearestPoint(d)}!l&&c&&(l=m.screen.getDisplayMatching(c.getBounds())),l||(l=m.screen.getPrimaryDisplay()||t[0])}let r=(0,I.defaultWindowState)();r.x=Math.round(l.bounds.x+l.bounds.width/2-r.width/2),r.y=Math.round(l.bounds.y+l.bounds.height/2-r.height/2);const s=this.configurationService.getValue("window");let o=!0;if(s==null?void 0:s.newWindowDimensions){if(s.newWindowDimensions==="maximized")r.mode=0,o=!1;else if(s.newWindowDimensions==="fullscreen")r.mode=3,o=!1;else if((s.newWindowDimensions==="inherit"||s.newWindowDimensions==="offset")&&c){const d=c.serializeWindowState();d.mode===3?r.mode=3:r=d,o=r.mode!==3&&s.newWindowDimensions==="offset"}}return o&&(r=this.ensureNoOverlap(r)),r.hasDefaultState=!0,r}ensureNoOverlap(u){if(this.windowsMainService.getWindows().length===0)return u;u.x=typeof u.x=="number"?u.x:0,u.y=typeof u.y=="number"?u.y:0;const c=this.windowsMainService.getWindows().map(l=>l.getBounds());for(;c.some(l=>l.x===u.x||l.y===u.y);)u.x+=30,u.y+=30;return u}};p.windowsStateStorageKey="windowsState",p=he([te(0,I.IWindowsMainService),te(1,i.IStateMainService),te(2,w.ILifecycleMainService),te(3,y.ILogService),te(4,n.IConfigurationService)],p),e.WindowsStateHandler=p;function g(a){const u={openedWindows:[]},c=a||{openedWindows:[]};return c.lastActiveWindow&&(u.lastActiveWindow=v(c.lastActiveWindow)),c.lastPluginDevelopmentHostWindow&&(u.lastPluginDevelopmentHostWindow=v(c.lastPluginDevelopmentHostWindow)),Array.isArray(c.openedWindows)&&(u.openedWindows=c.openedWindows.map(l=>v(l))),u}e.restoreWindowsState=g;function v(a){const u={uiState:a.uiState};return a.backupPath&&(u.backupPath=a.backupPath),a.remoteAuthority&&(u.remoteAuthority=a.remoteAuthority),a.folder&&(u.folderUri=E.URI.parse(a.folder)),a.workspaceIdentifier&&(u.workspace={id:a.workspaceIdentifier.id,configPath:E.URI.parse(a.workspaceIdentifier.configURIPath)}),u}function D(a){return{lastActiveWindow:a.lastActiveWindow&&S(a.lastActiveWindow),lastPluginDevelopmentHostWindow:a.lastPluginDevelopmentHostWindow&&S(a.lastPluginDevelopmentHostWindow),openedWindows:a.openedWindows.map(u=>S(u))}}e.getWindowsStateStoreData=D;function S(a){return{workspaceIdentifier:a.workspace&&{id:a.workspace.id,configURIPath:a.workspace.configPath.toString()},folder:a.folderUri&&a.folderUri.toString(),backupPath:a.backupPath,remoteAuthority:a.remoteAuthority,uiState:a.uiState}}}),define(J[56],Z([0,1,58,59,215,5,33,8,26,27,2,20,84,19,3]),function($,e,m,L,A,b,E,n,w,y,i,I,M,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class v{constructor(h){this.socket=h,this._errorListener=P=>{if(P){if(P.code==="EPIPE")return;(0,p.onUnexpectedError)(P)}},this.socket.on("error",this._errorListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(h){const P=T=>h(I.VSBuffer.wrap(T));return this.socket.on("data",P),{dispose:()=>this.socket.off("data",P)}}onClose(h){return this.socket.on("close",h),{dispose:()=>this.socket.off("close",h)}}onEnd(h){return this.socket.on("end",h),{dispose:()=>this.socket.off("end",h)}}write(h){if(!this.socket.destroyed)try{this.socket.write(h.buffer,P=>{if(P){if(P.code==="EPIPE")return;(0,p.onUnexpectedError)(P)}})}catch(P){if(P.code==="EPIPE")return;(0,p.onUnexpectedError)(P)}}end(){this.socket.end()}drain(){return new Promise((h,P)=>{if(this.socket.bufferSize===0){h();return}const T=()=>{this.socket.off("close",T),this.socket.off("end",T),this.socket.off("error",T),this.socket.off("timeout",T),this.socket.off("drain",T),h()};this.socket.on("close",T),this.socket.on("end",T),this.socket.on("error",T),this.socket.on("timeout",T),this.socket.on("drain",T)})}}e.NodeSocket=v;var D;(function(f){f[f.MinHeaderByteSize=2]="MinHeaderByteSize"})(D||(D={}));var S;(function(f){f[f.PeekHeader=1]="PeekHeader",f[f.ReadHeader=2]="ReadHeader",f[f.ReadBody=3]="ReadBody",f[f.Fin=4]="Fin"})(S||(S={}));class a extends i.Disposable{constructor(h,P,T,U){super();this._onDidZlibFlush=this._register(new b.Emitter),this._recordedInflateBytes=[],this._pendingInflateData=[],this._pendingDeflateData=[],this._onData=this._register(new b.Emitter),this._onClose=this._register(new b.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,mask:0},this.socket=h,this._totalIncomingWireBytes=0,this._totalIncomingDataBytes=0,this._totalOutgoingWireBytes=0,this._totalOutgoingDataBytes=0,this.permessageDeflate=P,this._recordInflateBytes=U,P?(this._zlibInflate=A.createInflateRaw({windowBits:15}),this._zlibInflate.on("error",q=>{console.error(q),(0,p.onUnexpectedError)(q),this._onClose.fire()}),this._zlibInflate.on("data",q=>{this._pendingInflateData.push(q)}),T&&(this._zlibInflate.write(T.buffer),this._zlibInflate.flush(()=>{this._pendingInflateData.length=0})),this._zlibDeflate=A.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",q=>{console.error(q),(0,p.onUnexpectedError)(q),this._onClose.fire()}),this._zlibDeflate.on("data",q=>{this._pendingDeflateData.push(q)})):(this._zlibInflate=null,this._zlibDeflate=null),this._zlibDeflateFlushWaitingCount=0,this._incomingData=new M.ChunkStream,this._register(this.socket.onData(q=>this._acceptChunk(q))),this._register(this.socket.onClose(()=>this._onClose.fire()))}get totalIncomingWireBytes(){return this._totalIncomingWireBytes}get totalIncomingDataBytes(){return this._totalIncomingDataBytes}get totalOutgoingWireBytes(){return this._totalOutgoingWireBytes}get totalOutgoingDataBytes(){return this._totalOutgoingDataBytes}get recordedInflateBytes(){return this._recordInflateBytes?I.VSBuffer.wrap(Buffer.concat(this._recordedInflateBytes)):I.VSBuffer.alloc(0)}dispose(){this._zlibDeflateFlushWaitingCount>0?this._register(this._onDidZlibFlush.event(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(h){return this._onData.event(h)}onClose(h){return this._onClose.event(h)}onEnd(h){return this.socket.onEnd(h)}write(h){this._totalOutgoingDataBytes+=h.byteLength,this._zlibDeflate?(this._zlibDeflate.write(h.buffer),this._zlibDeflateFlushWaitingCount++,this._zlibDeflate.flush(2,()=>{this._zlibDeflateFlushWaitingCount--;let P=Buffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,P=P.slice(0,P.length-4),this._isEnded||this._write(I.VSBuffer.wrap(P),!0),this._zlibDeflateFlushWaitingCount===0&&this._onDidZlibFlush.fire()})):this._write(h,!1)}_write(h,P){let T=2;h.byteLength<126?T+=0:h.byteLength<2**16?T+=2:T+=8;const U=I.VSBuffer.alloc(T);if(P?U.writeUInt8(194,0):U.writeUInt8(130,0),h.byteLength<126)U.writeUInt8(h.byteLength,1);else if(h.byteLength<2**16){U.writeUInt8(126,1);let q=1;U.writeUInt8(h.byteLength>>>8&255,++q),U.writeUInt8(h.byteLength>>>0&255,++q)}else{U.writeUInt8(127,1);let q=1;U.writeUInt8(0,++q),U.writeUInt8(0,++q),U.writeUInt8(0,++q),U.writeUInt8(0,++q),U.writeUInt8(h.byteLength>>>24&255,++q),U.writeUInt8(h.byteLength>>>16&255,++q),U.writeUInt8(h.byteLength>>>8&255,++q),U.writeUInt8(h.byteLength>>>0&255,++q)}this._totalOutgoingWireBytes+=U.byteLength+h.byteLength,this.socket.write(I.VSBuffer.concat([U,h]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(h){if(h.byteLength!==0){for(this._totalIncomingWireBytes+=h.byteLength,this._incomingData.acceptChunk(h);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const P=this._incomingData.peek(this._state.readLen),U=(P.readUInt8(0)&128)>>>7,q=P.readUInt8(1),Q=(q&128)>>>7,x=q&127;this._state.state=2,this._state.readLen=2+(Q?4:0)+(x===126?2:0)+(x===127?8:0),this._state.fin=U,this._state.mask=0}else if(this._state.state===2){const P=this._incomingData.read(this._state.readLen),T=P.readUInt8(1),U=(T&128)>>>7;let q=T&127,Q=1;q===126?q=P.readUInt8(++Q)*2**8+P.readUInt8(++Q):q===127&&(q=P.readUInt8(++Q)*0+P.readUInt8(++Q)*0+P.readUInt8(++Q)*0+P.readUInt8(++Q)*0+P.readUInt8(++Q)*2**24+P.readUInt8(++Q)*2**16+P.readUInt8(++Q)*2**8+P.readUInt8(++Q));let x=0;U&&(x=P.readUInt8(++Q)*2**24+P.readUInt8(++Q)*2**16+P.readUInt8(++Q)*2**8+P.readUInt8(++Q)),this._state.state=3,this._state.readLen=q,this._state.mask=x}else if(this._state.state===3){const P=this._incomingData.read(this._state.readLen);u(P,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._zlibInflate?(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from(P.buffer)),this._zlibInflate.write(P.buffer),this._state.fin&&(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from([0,0,255,255])),this._zlibInflate.write(Buffer.from([0,0,255,255]))),this._zlibInflate.flush(()=>{const T=Buffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,this._totalIncomingDataBytes+=T.length,this._onData.fire(I.VSBuffer.wrap(T))})):(this._totalIncomingDataBytes+=P.byteLength,this._onData.fire(P))}}}async drain(){this._zlibDeflateFlushWaitingCount>0&&await b.Event.toPromise(this._onDidZlibFlush.event),await this.socket.drain()}}e.WebSocketNodeSocket=a;function u(f,h){if(h===0)return;let P=f.byteLength>>>2;for(let j=0;j<P;j++){const X=f.readUInt32BE(j*4);f.writeUInt32BE(X^h,j*4)}let T=P*4,U=f.byteLength-T;const q=h>>>24&255,Q=h>>>16&255,x=h>>>8&255;U>=1&&f.writeUInt8(f.readUInt8(T)^q,T),U>=2&&f.writeUInt8(f.readUInt8(T+1)^Q,T+1),U>=3&&f.writeUInt8(f.readUInt8(T+2)^x,T+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const c={[2]:107,[1]:103};function l(){const f=(0,y.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${f}-sock`;let h;return e.XDG_RUNTIME_DIR?h=(0,n.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${f}.sock`):h=(0,n.join)((0,w.tmpdir)(),`vscode-ipc-${f}.sock`),r(h),h}e.createRandomIPCHandle=l;function t(f,h,P){const T=(0,m.createHash)("md5").update(f).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${T}-${P}-${h}-sock`;let U;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?U=(0,n.join)(e.XDG_RUNTIME_DIR,`vscode-${T.substr(0,8)}-${P}-${h}.sock`):U=(0,n.join)(f,`${P}-${h}.sock`),r(U),U}e.createStaticIPCHandle=t;function r(f){const h=c[g.platform];typeof h=="number"&&f.length>=h&&console.warn(`WARNING: IPC handle "${f}" is longer than ${h} chars, try a shorter --user-data-dir`)}class s extends E.IPCServer{constructor(h){super(s.toClientConnectionEvent(h));this.server=h}static toClientConnectionEvent(h){const P=b.Event.fromNodeEventEmitter(h,"connection");return b.Event.map(P,T=>({protocol:new M.Protocol(new v(T)),onDidClientDisconnect:b.Event.once(b.Event.fromNodeEventEmitter(T,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=s;function o(f){return new Promise((h,P)=>{const T=(0,L.createServer)();T.on("error",P),T.listen(f,()=>{T.removeListener("error",P),h(new s(T))})})}e.serve=o;function d(f,h){return new Promise((P,T)=>{const U=(0,L.createConnection)(f,()=>{U.removeListener("error",T),P(M.Client.fromSocket(new v(U),h))});U.once("error",T)})}e.connect=d}),define(J[216],Z([0,1,56]),function($,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.WindowDriverRegistryChannel=e.DriverChannelClient=e.DriverChannel=void 0;class L{constructor(w){this.driver=w}listen(w,y){throw new Error("No event found")}call(w,y,i){switch(y){case"getWindowIds":return this.driver.getWindowIds();case"capturePage":return this.driver.capturePage(i);case"reloadWindow":return this.driver.reloadWindow(i);case"exitApplication":return this.driver.exitApplication();case"dispatchKeybinding":return this.driver.dispatchKeybinding(i[0],i[1]);case"click":return this.driver.click(i[0],i[1],i[2],i[3]);case"doubleClick":return this.driver.doubleClick(i[0],i[1]);case"setValue":return this.driver.setValue(i[0],i[1],i[2]);case"getTitle":return this.driver.getTitle(i[0]);case"isActiveElement":return this.driver.isActiveElement(i[0],i[1]);case"getElements":return this.driver.getElements(i[0],i[1],i[2]);case"getElementXY":return this.driver.getElementXY(i[0],i[1],i[2]);case"typeInEditor":return this.driver.typeInEditor(i[0],i[1],i[2]);case"getTerminalBuffer":return this.driver.getTerminalBuffer(i[0],i[1]);case"writeInTerminal":return this.driver.writeInTerminal(i[0],i[1],i[2])}throw new Error(`Call not found: ${y}`)}}e.DriverChannel=L;class A{constructor(w){this.channel=w}getWindowIds(){return this.channel.call("getWindowIds")}capturePage(w){return this.channel.call("capturePage",w)}reloadWindow(w){return this.channel.call("reloadWindow",w)}exitApplication(){return this.channel.call("exitApplication")}dispatchKeybinding(w,y){return this.channel.call("dispatchKeybinding",[w,y])}click(w,y,i,I){return this.channel.call("click",[w,y,i,I])}doubleClick(w,y){return this.channel.call("doubleClick",[w,y])}setValue(w,y,i){return this.channel.call("setValue",[w,y,i])}getTitle(w){return this.channel.call("getTitle",[w])}isActiveElement(w,y){return this.channel.call("isActiveElement",[w,y])}getElements(w,y,i){return this.channel.call("getElements",[w,y,i])}getElementXY(w,y,i,I){return this.channel.call("getElementXY",[w,y,i,I])}typeInEditor(w,y,i){return this.channel.call("typeInEditor",[w,y,i])}getTerminalBuffer(w,y){return this.channel.call("getTerminalBuffer",[w,y])}writeInTerminal(w,y,i){return this.channel.call("writeInTerminal",[w,y,i])}}e.DriverChannelClient=A;class b{constructor(w){this.registry=w}listen(w,y){throw new Error(`Event not found: ${y}`)}call(w,y,i){switch(y){case"registerWindowDriver":return this.registry.registerWindowDriver(i);case"reloadWindowDriver":return this.registry.reloadWindowDriver(i)}throw new Error(`Call not found: ${y}`)}}e.WindowDriverRegistryChannel=b;async function E(n){const w=await(0,m.connect)(n,"driverClient"),y=w.getChannel("driver"),i=new A(y);return{client:w,driver:i}}e.connect=E}),define(J[24],Z([0,1,8,46,4,53,160,56]),function($,e,m,L,A,b,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentMainService=e.IEnvironmentMainService=void 0,e.IEnvironmentMainService=(0,A.refineServiceDecorator)(b.IEnvironmentService);class w extends E.NativeEnvironmentService{get cachedLanguagesPath(){return(0,m.join)(this.userDataPath,"clp")}get backupHome(){return(0,m.join)(this.userDataPath,"Backups")}get backupWorkspacesPath(){return(0,m.join)(this.backupHome,"workspaces.json")}get mainIPCHandle(){return(0,n.createStaticIPCHandle)(this.userDataPath,"main",this.productService.version)}get sandbox(){return!!this.args.__sandbox}get driverVerbose(){return!!this.args["driver-verbose"]}get disableUpdates(){return!!this.args["disable-updates"]}get disableKeytar(){return!!this.args["disable-keytar"]}get nodeCachedDataDir(){return process.env.VSCODE_NODE_CACHED_DATA_DIR||void 0}get chromeCachedDataDir(){return(0,m.join)(this.userDataPath,"Code Cache")}}he([L.memoize],w.prototype,"cachedLanguagesPath",null),he([L.memoize],w.prototype,"backupHome",null),he([L.memoize],w.prototype,"backupWorkspacesPath",null),he([L.memoize],w.prototype,"mainIPCHandle",null),he([L.memoize],w.prototype,"sandbox",null),he([L.memoize],w.prototype,"driverVerbose",null),he([L.memoize],w.prototype,"disableUpdates",null),he([L.memoize],w.prototype,"disableKeytar",null),he([L.memoize],w.prototype,"nodeCachedDataDir",null),he([L.memoize],w.prototype,"chromeCachedDataDir",null),e.EnvironmentMainService=w}),define(J[217],Z([0,1,29,58,8,3,16,50,24,17,21,6,28,7,30,10,15]),function($,e,m,L,A,b,E,n,w,y,i,I,M,p,g,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BackupMainService=void 0;let S=class{constructor(u,c,l){this.configurationService=c,this.logService=l,this.workspaces=[],this.folders=[],this.emptyWindows=[],this.backupUriComparer=D.extUriBiasedIgnorePathCase,this.backupPathComparer={isEqual:(t,r)=>(0,g.isEqual)(t,r,!b.isLinux)},this.backupHome=u.backupHome,this.workspacesJsonPath=u.backupWorkspacesPath}async initialize(){let u;try{u=JSON.parse(await E.Promises.readFile(this.workspacesJsonPath,"utf8"))}catch(t){u=Object.create(null)}u.emptyWorkspaceInfos&&(this.emptyWindows=await this.validateEmptyWorkspaces(u.emptyWorkspaceInfos));let c=[];try{Array.isArray(u.rootURIWorkspaces)&&(c=u.rootURIWorkspaces.map(t=>({workspace:{id:t.id,configPath:p.URI.parse(t.configURIPath)},remoteAuthority:t.remoteAuthority})))}catch(t){}this.workspaces=await this.validateWorkspaces(c);let l=[];try{Array.isArray(u.folderURIWorkspaces)&&(l=u.folderURIWorkspaces.map(t=>p.URI.parse(t)))}catch(t){}this.folders=await this.validateFolders(l),await this.save()}getWorkspaceBackups(){return this.isHotExitOnExitAndWindowClose()?[]:this.workspaces.slice(0)}getFolderBackupPaths(){return this.isHotExitOnExitAndWindowClose()?[]:this.folders.slice(0)}isHotExitEnabled(){return this.getHotExitConfig()!==i.HotExitConfiguration.OFF}isHotExitOnExitAndWindowClose(){return this.getHotExitConfig()===i.HotExitConfiguration.ON_EXIT_AND_WINDOW_CLOSE}getHotExitConfig(){var u;const c=this.configurationService.getValue();return((u=c==null?void 0:c.files)===null||u===void 0?void 0:u.hotExit)||i.HotExitConfiguration.ON_EXIT}getEmptyWindowBackupPaths(){return this.emptyWindows.slice(0)}registerWorkspaceBackupSync(u,c){this.workspaces.some(t=>u.workspace.id===t.workspace.id)||(this.workspaces.push(u),this.saveSync());const l=this.getBackupPath(u.workspace.id);return c&&this.moveBackupFolderSync(l,c),l}moveBackupFolderSync(u,c){if(m.existsSync(u)&&this.convertToEmptyWindowBackupSync(u),m.existsSync(c))try{m.renameSync(c,u)}catch(l){this.logService.error(`Backup: Could not move backup folder to new location: ${l.toString()}`)}}unregisterWorkspaceBackupSync(u){const c=u.id,l=this.workspaces.findIndex(t=>t.workspace.id===c);l!==-1&&(this.workspaces.splice(l,1),this.saveSync())}registerFolderBackupSync(u){return this.folders.some(c=>this.backupUriComparer.isEqual(u,c))||(this.folders.push(u),this.saveSync()),this.getBackupPath(this.getFolderHash(u))}unregisterFolderBackupSync(u){const c=this.folders.findIndex(l=>this.backupUriComparer.isEqual(u,l));c!==-1&&(this.folders.splice(c,1),this.saveSync())}registerEmptyWindowBackupSync(u,c){const l=u||this.getRandomEmptyWindowId();return this.emptyWindows.some(t=>!!t.backupFolder&&this.backupPathComparer.isEqual(t.backupFolder,l))||(this.emptyWindows.push({backupFolder:l,remoteAuthority:c}),this.saveSync()),this.getBackupPath(l)}unregisterEmptyWindowBackupSync(u){const c=this.emptyWindows.findIndex(l=>!!l.backupFolder&&this.backupPathComparer.isEqual(l.backupFolder,u));c!==-1&&(this.emptyWindows.splice(c,1),this.saveSync())}getBackupPath(u){return(0,A.join)(this.backupHome,u)}async validateWorkspaces(u){if(!Array.isArray(u))return[];const c=new Set,l=[];for(let t of u){const r=t.workspace;if(!(0,M.isWorkspaceIdentifier)(r))return[];if(!c.has(r.id)){c.add(r.id);const s=this.getBackupPath(r.id);await this.doHasBackups(s)?r.configPath.scheme!==v.Schemas.file||await(0,E.exists)(r.configPath.fsPath)?l.push(t):await this.convertToEmptyWindowBackup(s):await this.deleteStaleBackup(s)}}return l}async validateFolders(u){if(!Array.isArray(u))return[];const c=[],l=new Set;for(let t of u){const r=this.backupUriComparer.getComparisonKey(t);if(!l.has(r)){l.add(r);const s=this.getBackupPath(this.getFolderHash(t));await this.doHasBackups(s)?t.scheme!==v.Schemas.file||await(0,E.exists)(t.fsPath)?c.push(t):await this.convertToEmptyWindowBackup(s):await this.deleteStaleBackup(s)}}return c}async validateEmptyWorkspaces(u){if(!Array.isArray(u))return[];const c=[],l=new Set;for(let t of u){const r=t.backupFolder;if(typeof r!="string")return[];if(!l.has(r)){l.add(r);const s=this.getBackupPath(r);await this.doHasBackups(s)?c.push(t):await this.deleteStaleBackup(s)}}return c}async deleteStaleBackup(u){try{await(0,E.exists)(u)&&await(0,E.rimraf)(u,E.RimRafMode.MOVE)}catch(c){this.logService.error(`Backup: Could not delete stale backup: ${c.toString()}`)}}async convertToEmptyWindowBackup(u){let c=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(t=>!!t.backupFolder&&this.backupPathComparer.isEqual(t.backupFolder,c));)c=this.getRandomEmptyWindowId();const l=this.getBackupPath(c);try{await E.Promises.rename(u,l)}catch(t){return this.logService.error(`Backup: Could not rename backup folder: ${t.toString()}`),!1}return this.emptyWindows.push({backupFolder:c}),!0}convertToEmptyWindowBackupSync(u){let c=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(t=>!!t.backupFolder&&this.backupPathComparer.isEqual(t.backupFolder,c));)c=this.getRandomEmptyWindowId();const l=this.getBackupPath(c);try{m.renameSync(u,l)}catch(t){return this.logService.error(`Backup: Could not rename backup folder: ${t.toString()}`),!1}return this.emptyWindows.push({backupFolder:c}),!0}async getDirtyWorkspaces(){const u=[];for(const c of this.workspaces)await this.hasBackups(c)&&u.push(c.workspace);for(const c of this.folders)await this.hasBackups(c)&&u.push(c);return u}hasBackups(u){let c;return p.URI.isUri(u)?c=this.getBackupPath(this.getFolderHash(u)):(0,n.isWorkspaceBackupInfo)(u)?c=this.getBackupPath(u.workspace.id):c=u.backupFolder,this.doHasBackups(c)}async doHasBackups(u){try{const c=await(0,E.readdir)(u);for(const l of c)try{if((await(0,E.readdir)((0,A.join)(u,l))).length>0)return!0}catch(t){}}catch(c){}return!1}saveSync(){try{(0,E.writeFileSync)(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(u){this.logService.error(`Backup: Could not save workspaces.json: ${u.toString()}`)}}async save(){try{await(0,E.writeFile)(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(u){this.logService.error(`Backup: Could not save workspaces.json: ${u.toString()}`)}}serializeBackups(){return{rootURIWorkspaces:this.workspaces.map(u=>({id:u.workspace.id,configURIPath:u.workspace.configPath.toString(),remoteAuthority:u.remoteAuthority})),folderURIWorkspaces:this.folders.map(u=>u.toString()),emptyWorkspaceInfos:this.emptyWindows}}getRandomEmptyWindowId(){return(Date.now()+Math.round(Math.random()*1e3)).toString()}getFolderHash(u){let c;return u.scheme===v.Schemas.file?c=b.isLinux?u.fsPath:u.fsPath.toLowerCase():c=u.toString().toLowerCase(),(0,L.createHash)("md5").update(c).digest("hex")}};S=he([te(0,w.IEnvironmentMainService),te(1,y.IConfigurationService),te(2,I.ILogService)],S),e.BackupMainService=S}),define(J[45],Z([0,1,40,114,145,82,5,34,14,18,3,24,51,16,7,31,4,26,66,6,8,22,46,2,60]),function($,e,m,L,A,b,E,n,w,y,i,I,M,p,g,v,D,S,a,u,c,l,t,r,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeHostMainService=e.INativeHostMainService=void 0,e.INativeHostMainService=(0,D.createDecorator)("nativeHostMainService");let o=class ut extends r.Disposable{constructor(f,h,P,T,U,q,Q,x,j){super();this.sharedProcess=f,this.windowsMainService=h,this.dialogMainService=P,this.lifecycleMainService=T,this.environmentMainService=U,this.telemetryService=q,this.logService=Q,this.productService=x,this.themeMainService=j,this.onDidOpenWindow=E.Event.map(this.windowsMainService.onDidOpenWindow,X=>X.id),this.onDidMaximizeWindow=E.Event.filter(E.Event.fromNodeEventEmitter(w.app,"browser-window-maximize",(X,B)=>B.id),X=>!!this.windowsMainService.getWindowById(X)),this.onDidUnmaximizeWindow=E.Event.filter(E.Event.fromNodeEventEmitter(w.app,"browser-window-unmaximize",(X,B)=>B.id),X=>!!this.windowsMainService.getWindowById(X)),this.onDidBlurWindow=E.Event.filter(E.Event.fromNodeEventEmitter(w.app,"browser-window-blur",(X,B)=>B.id),X=>!!this.windowsMainService.getWindowById(X)),this.onDidFocusWindow=E.Event.any(E.Event.map(E.Event.filter(E.Event.map(this.windowsMainService.onDidChangeWindowsCount,()=>this.windowsMainService.getLastActiveWindow()),X=>!!X),X=>X.id),E.Event.filter(E.Event.fromNodeEventEmitter(w.app,"browser-window-focus",(X,B)=>B.id),X=>!!this.windowsMainService.getWindowById(X))),this.onDidResumeOS=E.Event.fromNodeEventEmitter(w.powerMonitor,"resume"),this._onDidChangeColorScheme=this._register(new E.Emitter),this.onDidChangeColorScheme=this._onDidChangeColorScheme.event,this._onDidChangePassword=this._register(new E.Emitter),this.onDidChangePassword=this._onDidChangePassword.event,this.onDidChangeDisplay=E.Event.debounce(E.Event.any(E.Event.filter(E.Event.fromNodeEventEmitter(w.screen,"display-metrics-changed",(X,B,V)=>V),X=>!(Array.isArray(X)&&X.length===1&&X[0]==="workArea")),E.Event.fromNodeEventEmitter(w.screen,"display-added"),E.Event.fromNodeEventEmitter(w.screen,"display-removed")),()=>{},100),this.registerListeners()}registerListeners(){w.nativeTheme.on("updated",()=>{this._onDidChangeColorScheme.fire({highContrast:w.nativeTheme.shouldUseInvertedColorScheme||w.nativeTheme.shouldUseHighContrastColors,dark:w.nativeTheme.shouldUseDarkColors})})}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(){return this.windowsMainService.getWindows().map(h=>{var P,T;return{id:h.id,workspace:h.openedWorkspace,title:(T=(P=h.win)===null||P===void 0?void 0:P.getTitle())!==null&&T!==void 0?T:"",filename:h.getRepresentedFilename(),dirty:h.isDocumentEdited()}})}async getWindowCount(f){return this.windowsMainService.getWindowCount()}async getActiveWindowId(f){const h=w.BrowserWindow.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(h)return h.id}openWindow(f,h,P){return Array.isArray(h)?this.doOpenWindow(f,h,P):this.doOpenEmptyWindow(f,h)}async doOpenWindow(f,h,P=Object.create(null)){h.length>0&&this.windowsMainService.open({context:5,contextWindowId:f,urisToOpen:h,cli:this.environmentMainService.args,forceNewWindow:P.forceNewWindow,forceReuseWindow:P.forceReuseWindow,preferNewWindow:P.preferNewWindow,diffMode:P.diffMode,addMode:P.addMode,gotoLineMode:P.gotoLineMode,noRecentEntry:P.noRecentEntry,waitMarkerFileURI:P.waitMarkerFileURI,remoteAuthority:P.remoteAuthority||void 0})}async doOpenEmptyWindow(f,h){this.windowsMainService.openEmptyWindow({context:5,contextWindowId:f},h)}async toggleFullScreen(f){const h=this.windowById(f);h&&h.toggleFullScreen()}async handleTitleDoubleClick(f){const h=this.windowById(f);h&&h.handleTitleDoubleClick()}async isMaximized(f){const h=this.windowById(f);return(h==null?void 0:h.win)?h.win.isMaximized():!1}async maximizeWindow(f){const h=this.windowById(f);(h==null?void 0:h.win)&&h.win.maximize()}async unmaximizeWindow(f){const h=this.windowById(f);(h==null?void 0:h.win)&&h.win.unmaximize()}async minimizeWindow(f){const h=this.windowById(f);(h==null?void 0:h.win)&&h.win.minimize()}async focusWindow(f,h){var P;h&&typeof h.windowId=="number"&&(f=h.windowId);const T=this.windowById(f);T&&T.focus({force:(P=h==null?void 0:h.force)!==null&&P!==void 0?P:!1})}async setMinimumSize(f,h,P){const T=this.windowById(f);if(T==null?void 0:T.win){const[U,q]=T.win.getSize(),[Q,x]=T.win.getMinimumSize(),[j,X]=[h!=null?h:Q,P!=null?P:x],[B,V]=[Math.max(U,j),Math.max(q,X)];(Q!==j||x!==X)&&T.win.setMinimumSize(j,X),(U!==B||q!==V)&&T.win.setSize(B,V)}}async saveWindowSplash(f,h){this.themeMainService.saveWindowSplash(f,h)}async installShellCommand(f){const{source:h,target:P}=await this.getShellCommandLink();try{const{symbolicLink:T}=await p.SymlinkSupport.stat(h);if(T&&!T.dangling){const U=await(0,b.realpath)(h);if(P===U)return}await p.Promises.unlink(h)}catch(T){if(T.code!=="ENOENT")throw T}try{await p.Promises.symlink(P,h)}catch(T){if(T.code!=="EACCES"&&T.code!=="ENOENT")throw T;const{response:U}=await this.showMessageBox(f,{type:"info",message:(0,A.localize)(0,null,this.productService.nameShort),buttons:[(0,A.localize)(1,null),(0,A.localize)(2,null)],cancelId:1});if(U===0)try{const q=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${P}' '${h}'\\" with administrator privileges"`;await(0,L.promisify)(m.exec)(q)}catch(q){throw new Error((0,A.localize)(3,null,h))}}}async uninstallShellCommand(f){const{source:h}=await this.getShellCommandLink();try{await p.Promises.unlink(h)}catch(P){switch(P.code){case"EACCES":const{response:T}=await this.showMessageBox(f,{type:"info",message:(0,A.localize)(4,null,this.productService.nameShort),buttons:[(0,A.localize)(5,null),(0,A.localize)(6,null)],cancelId:1});if(T===0)try{const U=`osascript -e "do shell script \\"rm '${h}'\\" with administrator privileges"`;await(0,L.promisify)(m.exec)(U)}catch(U){throw new Error((0,A.localize)(7,null,h))}break;case"ENOENT":break;default:throw P}}}async getShellCommandLink(){const f=(0,c.resolve)(this.environmentMainService.appRoot,"bin","code"),h=`/usr/local/bin/${this.productService.applicationName}`;if(!await(0,p.exists)(f))throw new Error((0,A.localize)(8,null,f));return{source:h,target:f}}async showMessageBox(f,h){return this.dialogMainService.showMessageBox(h,this.toBrowserWindow(f))}async showSaveDialog(f,h){return this.dialogMainService.showSaveDialog(h,this.toBrowserWindow(f))}async showOpenDialog(f,h){return this.dialogMainService.showOpenDialog(h,this.toBrowserWindow(f))}toBrowserWindow(f){const h=this.windowById(f);if(h==null?void 0:h.win)return h.win}async pickFileFolderAndOpen(f,h){const P=await this.dialogMainService.pickFileFolder(h);P&&(this.sendPickerTelemetry(P,h.telemetryEventName||"openFileFolder",h.telemetryExtraData),this.doOpenPicked(await Promise.all(P.map(async T=>await p.SymlinkSupport.existsDirectory(T)?{folderUri:g.URI.file(T)}:{fileUri:g.URI.file(T)})),h,f))}async pickFolderAndOpen(f,h){const P=await this.dialogMainService.pickFolder(h);P&&(this.sendPickerTelemetry(P,h.telemetryEventName||"openFolder",h.telemetryExtraData),this.doOpenPicked(P.map(T=>({folderUri:g.URI.file(T)})),h,f))}async pickFileAndOpen(f,h){const P=await this.dialogMainService.pickFile(h);P&&(this.sendPickerTelemetry(P,h.telemetryEventName||"openFile",h.telemetryExtraData),this.doOpenPicked(P.map(T=>({fileUri:g.URI.file(T)})),h,f))}async pickWorkspaceAndOpen(f,h){const P=await this.dialogMainService.pickWorkspace(h);P&&(this.sendPickerTelemetry(P,h.telemetryEventName||"openWorkspace",h.telemetryExtraData),this.doOpenPicked(P.map(T=>({workspaceUri:g.URI.file(T)})),h,f))}doOpenPicked(f,h,P){this.windowsMainService.open({context:3,contextWindowId:P,cli:this.environmentMainService.args,urisToOpen:f,forceNewWindow:h.forceNewWindow})}sendPickerTelemetry(f,h,P){const T=f?f.length:0;this.telemetryService.publicLog(h,Object.assign(Object.assign({},P),{outcome:T?"success":"canceled",numberOfPaths:T}))}async showItemInFolder(f,h){w.shell.showItemInFolder(h)}async setRepresentedFilename(f,h){const P=this.windowById(f);P&&P.setRepresentedFilename(h)}async setDocumentEdited(f,h){const P=this.windowById(f);P&&P.setDocumentEdited(h)}async openExternal(f,h){return i.isLinuxSnap?this.safeSnapOpenExternal(h):w.shell.openExternal(h),!0}safeSnapOpenExternal(f){const h=process.env.GDK_PIXBUF_MODULE_FILE,P=process.env.GDK_PIXBUF_MODULEDIR;delete process.env.GDK_PIXBUF_MODULE_FILE,delete process.env.GDK_PIXBUF_MODULEDIR,w.shell.openExternal(f),process.env.GDK_PIXBUF_MODULE_FILE=h,process.env.GDK_PIXBUF_MODULEDIR=P}moveItemToTrash(f,h){return w.shell.trashItem(h)}async isAdmin(){let f;return i.isWindows?f=(await new Promise((h,P)=>{$(["native-is-elevated"],h,P)}))():f=process.getuid()===0,f}async writeElevated(f,h,P,T){const U=await new Promise((q,Q)=>{$(["sudo-prompt"],q,Q)});return new Promise((q,Q)=>{const x=[`"${this.cliPath}"`];(T==null?void 0:T.unlock)&&x.push("--file-chmod"),x.push("--file-write",`"${h.fsPath}"`,`"${P.fsPath}"`);const j={name:this.productService.nameLong.replace("-",""),icns:i.isMacintosh&&this.environmentMainService.isBuilt?(0,c.join)((0,c.dirname)(this.environmentMainService.appRoot),`${this.productService.nameShort}.icns`):void 0};U.exec(x.join(" "),j,(X,B,V)=>{B&&this.logService.trace(`[sudo-prompt] received stdout: ${B}`),V&&this.logService.trace(`[sudo-prompt] received stderr: ${V}`),X?Q(X):q(void 0)})})}get cliPath(){return i.isWindows?this.environmentMainService.isBuilt?(0,c.join)((0,c.dirname)(process.execPath),"bin",`${this.productService.applicationName}.cmd`):(0,c.join)(this.environmentMainService.appRoot,"scripts","code-cli.bat"):i.isLinux?this.environmentMainService.isBuilt?(0,c.join)((0,c.dirname)(process.execPath),"bin",`${this.productService.applicationName}`):(0,c.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh"):this.environmentMainService.isBuilt?(0,c.join)(this.environmentMainService.appRoot,"bin","code"):(0,c.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,S.totalmem)(),freemem:(0,S.freemem)(),loadavg:(0,S.loadavg)()}}async getOSProperties(){return{arch:(0,S.arch)(),platform:(0,S.platform)(),release:(0,S.release)(),type:(0,S.type)(),cpus:(0,S.cpus)()}}async getOSVirtualMachineHint(){return a.virtualMachineHint.value()}async killProcess(f,h,P){process.kill(h,P)}async readClipboardText(f,h){return w.clipboard.readText(h)}async writeClipboardText(f,h,P){return w.clipboard.writeText(h,P)}async readClipboardFindText(f){return w.clipboard.readFindText()}async writeClipboardFindText(f,h){return w.clipboard.writeFindText(h)}async writeClipboardBuffer(f,h,P,T){return w.clipboard.writeBuffer(h,Buffer.from(P),T)}async readClipboardBuffer(f,h){return w.clipboard.readBuffer(h)}async hasClipboard(f,h,P){return w.clipboard.has(h,P)}async newWindowTab(){this.windowsMainService.open({context:5,cli:this.environmentMainService.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.environmentMainService.args.remote||void 0})}async showPreviousWindowTab(){w.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){w.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){w.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){w.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){w.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(f,h){const P=this.windowById(f);P&&P.updateTouchBar(h)}async notifyReady(f){const h=this.windowById(f);h&&h.setReady()}async relaunch(f,h){return this.lifecycleMainService.relaunch(h)}async reload(f,h){const P=this.windowById(f);if(P)return this.lifecycleMainService.reload(P,(h==null?void 0:h.disableExtensions)!==void 0?{_:[],"disable-extensions":h==null?void 0:h.disableExtensions}:void 0)}async closeWindow(f){this.closeWindowById(f,f)}async closeWindowById(f,h){const P=this.windowById(h);if(P==null?void 0:P.win)return P.win.close()}async quit(f){const h=this.windowsMainService.getLastActiveWindow();(h==null?void 0:h.isExtensionDevelopmentHost)&&this.windowsMainService.getWindowCount()>1&&h.win?h.win.close():this.lifecycleMainService.quit()}async exit(f,h){await this.lifecycleMainService.kill(h)}async resolveProxy(f,h){var P,T;const U=this.windowById(f),q=(T=(P=U==null?void 0:U.win)===null||P===void 0?void 0:P.webContents)===null||T===void 0?void 0:T.session;if(q)return q.resolveProxy(h)}async openDevTools(f,h){const P=this.windowById(f);(P==null?void 0:P.win)&&P.win.webContents.openDevTools(h)}async toggleDevTools(f){const h=this.windowById(f);(h==null?void 0:h.win)&&h.win.webContents.toggleDevTools()}async sendInputEvent(f,h){const P=this.windowById(f);(P==null?void 0:P.win)&&(h.type==="mouseDown"||h.type==="mouseUp")&&P.win.webContents.sendInputEvent(h)}async toggleSharedProcessWindow(){return this.sharedProcess.toggle()}async windowsGetStringRegKey(f,h,P,T){if(!i.isWindows)return;const U=await new Promise((q,Q)=>{$(["vscode-windows-registry"],q,Q)});try{return U.GetStringRegKey(h,P,T)}catch(q){return}}async getPassword(f,h,P){const T=await this.withKeytar(),U=await T.getPassword(h,P);if(U)try{let{content:q,hasNextChunk:Q}=JSON.parse(U);if(!q||!Q)return U;let x=1;for(;Q;){const j=await T.getPassword(h,`${P}-${x}`),X=JSON.parse(j);q+=X.content,Q=X.hasNextChunk}return q}catch(q){return U}return U}async setPassword(f,h,P,T){const U=await this.withKeytar(),q=3,Q=async(x,j,X)=>{let B=0,V;for(;B<q;)try{await U.setPassword(x,j,X);return}catch(N){V=N,this.logService.warn("Error attempting to set a password: ",N),B++,await new Promise(C=>setTimeout(C,200))}throw V};if(i.isWindows&&T.length>ut.MAX_PASSWORD_LENGTH){let x=0,j=0,X=!0;for(;X;){const B=T.substring(x,x+ut.PASSWORD_CHUNK_SIZE);x+=ut.PASSWORD_CHUNK_SIZE,X=T.length-x>0;const V={content:B,hasNextChunk:X};await Q(h,j?`${P}-${j}`:P,JSON.stringify(V)),j++}}else await Q(h,P,T);this._onDidChangePassword.fire({service:h,account:P})}async deletePassword(f,h,P){const U=await(await this.withKeytar()).deletePassword(h,P);return U&&this._onDidChangePassword.fire({service:h,account:P}),U}async findPassword(f,h){return(await this.withKeytar()).findPassword(h)}async findCredentials(f,h){return(await this.withKeytar()).findCredentials(h)}async withKeytar(){if(this.environmentMainService.disableKeytar)throw new Error("keytar has been disabled via --disable-keytar option");return await new Promise((f,h)=>{$(["keytar"],f,h)})}windowById(f){if(typeof f=="number")return this.windowsMainService.getWindowById(f)}};o.MAX_PASSWORD_LENGTH=2500,o.PASSWORD_CHUNK_SIZE=o.MAX_PASSWORD_LENGTH-100,he([t.memoize],o.prototype,"cliPath",null),o=he([te(1,n.IWindowsMainService),te(2,M.IDialogMainService),te(3,y.ILifecycleMainService),te(4,I.IEnvironmentMainService),te(5,v.ITelemetryService),te(6,u.ILogService),te(7,l.IProductService),te(8,s.IThemeMainService)],o),e.NativeHostMainService=o}),define(J[218],Z([0,1,2,5,80,14,6,34,45,89,27,22,25]),function($,e,m,L,A,b,E,n,w,y,i,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProxyAuthHandler=void 0;var p;(function(v){v[v.Initial=1]="Initial",v[v.StoredCredentialsUsed=2]="StoredCredentialsUsed",v[v.LoginDialogShown=3]="LoginDialogShown"})(p||(p={}));let g=class extends m.Disposable{constructor(D,S,a,u,c){super();this.logService=D,this.windowsMainService=S,this.nativeHostMainService=a,this.encryptionMainService=u,this.productService=c,this.PROXY_CREDENTIALS_SERVICE_KEY=`${this.productService.urlProtocol}.proxy-credentials`,this.pendingProxyResolve=void 0,this.state=p.Initial,this.sessionCredentials=void 0,this.registerListeners()}registerListeners(){const D=L.Event.fromNodeEventEmitter(b.app,"login",(S,a,u,c,l)=>({event:S,webContents:a,req:u,authInfo:c,callback:l}));this._register(D(this.onLogin,this))}async onLogin({event:D,authInfo:S,req:a,callback:u}){if(!S.isProxy)return;if(!this.pendingProxyResolve&&this.state===p.LoginDialogShown&&a.firstAuthAttempt){this.logService.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}D.preventDefault();let c;if(this.pendingProxyResolve)this.logService.trace("auth#onLogin (proxy) - pending proxy handling found"),c=await this.pendingProxyResolve;else{this.logService.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.pendingProxyResolve=this.resolveProxyCredentials(S);try{c=await this.pendingProxyResolve}finally{this.pendingProxyResolve=void 0}}u(c==null?void 0:c.username,c==null?void 0:c.password)}async resolveProxyCredentials(D){this.logService.trace("auth#resolveProxyCredentials (proxy) - enter");try{const S=await this.doResolveProxyCredentials(D);if(S)return this.logService.trace("auth#resolveProxyCredentials (proxy) - got credentials"),S;this.logService.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.logService.trace("auth#resolveProxyCredentials (proxy) - exit")}}async doResolveProxyCredentials(D){var S,a,u,c;this.logService.trace("auth#doResolveProxyCredentials - enter",D);const l=String((0,A.hash)({scheme:D.scheme,host:D.host,port:D.port}));let t,r;try{const f=await this.nativeHostMainService.getPassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,l);if(f){const h=JSON.parse(await this.encryptionMainService.decrypt(f));t=h.username,r=h.password}}catch(f){this.logService.error(f)}if(this.state!==p.StoredCredentialsUsed&&typeof t=="string"&&typeof r=="string")return this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.state=p.StoredCredentialsUsed,{username:t,password:r};const s=this.windowsMainService.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(!s){this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.logService.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${s.id} to handle proxy login`);const o={authInfo:D,username:(a=(S=this.sessionCredentials)===null||S===void 0?void 0:S.username)!==null&&a!==void 0?a:t,password:(c=(u=this.sessionCredentials)===null||u===void 0?void 0:u.password)!==null&&c!==void 0?c:r,replyChannel:`vscode:proxyAuthResponse:${(0,i.generateUuid)()}`};s.sendWhenReady("vscode:openProxyAuthenticationDialog",M.CancellationToken.None,o),this.state=p.LoginDialogShown;const d=await new Promise(f=>{var h;const P=async(T,U,q)=>{var Q;if(U===o.replyChannel)if(this.logService.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${s.id}`),(Q=s.win)===null||Q===void 0||Q.webContents.off("ipc-message",P),q){const x={username:q.username,password:q.password};try{if(q.remember){const j=await this.encryptionMainService.encrypt(JSON.stringify(x));await this.nativeHostMainService.setPassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,l,j)}else await this.nativeHostMainService.deletePassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,l)}catch(j){this.logService.error(j)}f({username:x.username,password:x.password})}else f(void 0)};(h=s.win)===null||h===void 0||h.webContents.on("ipc-message",P)});return this.sessionCredentials=d,d}};g=he([te(0,E.ILogService),te(1,n.IWindowsMainService),te(2,w.INativeHostMainService),te(3,y.IEncryptionMainService),te(4,I.IProductService)],g),e.ProxyAuthHandler=g}),define(J[219],Z([0,1,216,155,34,56,2,33,57,175,3,5,79,106,9,18,45]),function($,e,m,L,A,b,E,n,w,y,i,I,M,p,g,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.serve=e.Driver=void 0;function S(c){return c<21}let a=class{constructor(l,t,r,s,o){this.windowServer=l,this.options=t,this.windowsMainService=r,this.lifecycleMainService=s,this.nativeHostMainService=o,this.registeredWindowIds=new Set,this.reloadingWindowIds=new Set,this.onDidReloadingChange=new I.Emitter}async registerWindowDriver(l){return this.registeredWindowIds.add(l),this.reloadingWindowIds.delete(l),this.onDidReloadingChange.fire(),this.options}async reloadWindowDriver(l){this.reloadingWindowIds.add(l)}async getWindowIds(){return this.windowsMainService.getWindows().map(l=>l.id).filter(l=>this.registeredWindowIds.has(l)&&!this.reloadingWindowIds.has(l))}async capturePage(l){await this.whenUnfrozen(l);const t=this.windowsMainService.getWindowById(l);if(!(t==null?void 0:t.win))throw new Error("Invalid window");return(await t.win.webContents.capturePage()).toPNG().toString("base64")}async reloadWindow(l){await this.whenUnfrozen(l);const t=this.windowsMainService.getWindowById(l);if(!t)throw new Error("Invalid window");this.reloadingWindowIds.add(l),this.lifecycleMainService.reload(t)}async exitApplication(){return this.nativeHostMainService.quit(void 0)}async dispatchKeybinding(l,t){await this.whenUnfrozen(l);const r=p.KeybindingParser.parseUserBinding(t);for(let s of r)await this._dispatchKeybinding(l,s)}async _dispatchKeybinding(l,t){if(t instanceof M.ScanCodeBinding)throw new Error("ScanCodeBindings not supported");const r=this.windowsMainService.getWindowById(l);if(!(r==null?void 0:r.win))throw new Error("Invalid window");const s=r.win.webContents,o=new w.SimpleKeybinding(!1,!1,!1,!1,t.keyCode),f=new y.USLayoutResolvedKeybinding(o.toChord(),i.OS).getElectronAccelerator(),h=[];t.ctrlKey&&h.push("ctrl"),t.metaKey&&h.push("meta"),t.shiftKey&&h.push("shift"),t.altKey&&h.push("alt"),s.sendInputEvent({type:"keyDown",keyCode:f,modifiers:h}),S(t.keyCode)||s.sendInputEvent({type:"char",keyCode:f,modifiers:h}),s.sendInputEvent({type:"keyUp",keyCode:f,modifiers:h}),await(0,g.timeout)(100)}async click(l,t,r,s){await(await this.getWindowDriver(l)).click(t,r,s)}async doubleClick(l,t){await(await this.getWindowDriver(l)).doubleClick(t)}async setValue(l,t,r){await(await this.getWindowDriver(l)).setValue(t,r)}async getTitle(l){return await(await this.getWindowDriver(l)).getTitle()}async isActiveElement(l,t){return await(await this.getWindowDriver(l)).isActiveElement(t)}async getElements(l,t,r){return await(await this.getWindowDriver(l)).getElements(t,r)}async getElementXY(l,t,r,s){return await(await this.getWindowDriver(l)).getElementXY(t,r,s)}async typeInEditor(l,t,r){await(await this.getWindowDriver(l)).typeInEditor(t,r)}async getTerminalBuffer(l,t){return await(await this.getWindowDriver(l)).getTerminalBuffer(t)}async writeInTerminal(l,t,r){await(await this.getWindowDriver(l)).writeInTerminal(t,r)}async getWindowDriver(l){await this.whenUnfrozen(l);const t=`window:${l}`,r=new n.StaticRouter(o=>o===t),s=this.windowServer.getChannel("windowDriver",r);return new L.WindowDriverChannelClient(s)}async whenUnfrozen(l){for(;this.reloadingWindowIds.has(l);)await I.Event.toPromise(this.onDidReloadingChange.event)}};a=he([te(2,A.IWindowsMainService),te(3,v.ILifecycleMainService),te(4,D.INativeHostMainService)],a),e.Driver=a;async function u(c,l,t,r){const s=t.driverVerbose,o=r.createInstance(a,c,{verbose:s}),d=new m.WindowDriverRegistryChannel(o);c.registerChannel("windowDriverRegistry",d);const f=await(0,b.serve)(l),h=new m.DriverChannel(o);return f.registerChannel("driver",h),(0,E.combinedDisposable)(f,c)}e.serve=u}),define(J[220],Z([0,1,59,56]),function($,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(A,b,E,n){const w=i=>n(i,void 0),y=m.createConnection({host:A,port:b},()=>{y.removeListener("error",w);const i=Buffer.alloc(16);for(let g=0;g<16;g++)i[g]=Math.round(Math.random()*256);const I=i.toString("base64");let M=[`GET ws://${/:/.test(A)?`[${A}]`:A}:${b}/?${E}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${I}`];y.write(M.join(`\r
`)+`\r
\r
`);const p=g=>{g.toString().indexOf(`\r
\r
`)>=0&&(y.off("data",p),n(void 0,new L.NodeSocket(y)))};y.on("data",p)});y.once("error",w)}}}),define(J[221],Z([0,1,59,9,2,115,6,22,190,74,220,75]),function($,e,m,L,A,b,E,n,w,y,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TunnelService=e.BaseTunnelService=void 0;async function M(D,S,a,u){return new p(D,S,a,u).waitForReady()}class p extends A.Disposable{constructor(S,a,u,c){super();this.suggestedLocalPort=c,this.public=!1,this._socketsDispose=new Map,this._options=S,this._server=m.createServer(),this._barrier=new L.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=l=>this._onConnection(l),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=u,this.tunnelRemoteHost=a}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(a=>{a()})}async waitForReady(){var S;let a=await(0,b.findFreePortFaster)((S=this.suggestedLocalPort)!==null&&S!==void 0?S:this.tunnelRemotePort,2,1e3),u=null;return u=this._server.listen(a).address(),u||(a=0,u=this._server.listen(a).address()),this.tunnelLocalPort=u.port,await this._barrier.wait(),this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${u.port}`,this}async _onConnection(S){S.pause();const a=await(0,w.connectRemoteAgentTunnel)(this._options,this.tunnelRemotePort),u=a.getSocket().socket,c=a.readEntireBuffer();a.dispose(),c.byteLength>0&&S.write(c.buffer),S.on("end",()=>{this._socketsDispose.delete(S.localAddress),u.end()}),S.on("close",()=>u.end()),S.on("error",()=>{this._socketsDispose.delete(S.localAddress),u.destroy()}),u.on("end",()=>S.end()),u.on("close",()=>S.end()),u.on("error",()=>{S.destroy()}),S.pipe(u),u.pipe(S),this._socketsDispose.set(S.localAddress,()=>{S.end(),u.end()})}}let g=class extends y.AbstractTunnelService{constructor(S,a,u,c){super(a);this.socketFactory=S,this.signService=u,this.productService=c}retainOrCreateTunnel(S,a,u,c,l,t){const r=this.getTunnelFromMap(a,u);if(r)return++r.refcount,r.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,a,u,c,l,t);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${a}:${u} on local port ${c}.`);const s={commit:this.productService.commit,socketFactory:this.socketFactory,addressProvider:S,signService:this.signService,logService:this.logService,ipcLogger:null},o=M(s,a,u,c);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(a,u,o),o}}};g=he([te(1,E.ILogService),te(2,I.ISignService),te(3,n.IProductService)],g),e.BaseTunnelService=g;let v=class extends g{constructor(S,a,u){super(i.nodeSocketFactory,S,a,u)}};v=he([te(0,E.ILogService),te(1,I.ISignService),te(2,n.IProductService)],v),e.TunnelService=v}),define(J[222],Z([0,1,215,192,2,13,19,191,17,6,20,53,91]),function($,e,m,L,A,b,E,n,w,y,i,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let p=class extends A.Disposable{constructor(v,D,S){super();this.environmentService=D,this.logService=S,this.configure(v.getValue()),this._register(v.onDidChangeConfiguration(()=>this.configure(v.getValue()),this))}configure(v){this.proxyUrl=v.http&&v.http.proxy,this.strictSSL=!!(v.http&&v.http.proxyStrictSSL),this.authorization=v.http&&v.http.proxyAuthorization}async request(v,D){this.logService.trace("RequestService#request",v.url);const{proxyUrl:S,strictSSL:a}=this,u=Object.assign(Object.assign({},process.env),await(0,M.resolveShellEnv)(this.logService,this.environmentService.args,process.env)),c=v.agent?v.agent:await(0,n.getProxyAgent)(v.url||"",u,{proxyUrl:S,strictSSL:a});return v.agent=c,v.strictSSL=a,this.authorization&&(v.headers=Object.assign(Object.assign({},v.headers||{}),{"Proxy-Authorization":this.authorization})),this._request(v,D)}async getNodeRequest(v){return((0,L.parse)(v.url).protocol==="https:"?await new Promise((a,u)=>{$(["https"],a,u)}):await new Promise((a,u)=>{$(["http"],a,u)})).request}_request(v,D){return new Promise(async(S,a)=>{let u;const c=(0,L.parse)(v.url),l=v.getRawRequest?v.getRawRequest(v):await this.getNodeRequest(v),t={hostname:c.hostname,port:c.port?parseInt(c.port):c.protocol==="https:"?443:80,protocol:c.protocol,path:c.path,method:v.type||"GET",headers:v.headers,agent:v.agent,rejectUnauthorized:(0,b.isBoolean)(v.strictSSL)?v.strictSSL:!0};v.user&&v.password&&(t.auth=v.user+":"+v.password),u=l(t,r=>{const s=(0,b.isNumber)(v.followRedirects)?v.followRedirects:3;if(r.statusCode&&r.statusCode>=300&&r.statusCode<400&&s>0&&r.headers.location)this._request(Object.assign(Object.assign({},v),{url:r.headers.location,followRedirects:s-1}),D).then(S,a);else{let o=r;r.headers["content-encoding"]==="gzip"&&(o=r.pipe((0,m.createGunzip)())),S({res:r,stream:(0,i.streamToBufferReadableStream)(o)})}}),u.on("error",a),v.timeout&&u.setTimeout(v.timeout),v.data&&typeof v.data=="string"&&u.write(v.data),u.end(),D.onCancellationRequested(()=>{u.abort(),a((0,E.canceled)())})})}async resolveProxy(v){}};p=he([te(0,w.IConfigurationService),te(1,I.INativeEnvironmentService),te(2,y.ILogService)],p),e.RequestService=p}),define(J[223],Z([0,1,222,14]),function($,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestMainService=void 0;function A(E){return L.net.request}class b extends m.RequestService{request(n,w){return super.request(Object.assign(Object.assign({},n||{}),{getRawRequest:A}),w)}}e.RequestMainService=b}),define(J[224],Z([0,1,47,14,24,9,6,18,60,10,3,2,85,13,5,55]),function($,e,m,L,A,b,E,n,w,y,i,I,M,p,g,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcess=void 0;let D=class extends I.Disposable{constructor(a,u,c,l,t,r,s){super();this.machineId=a,this.userEnv=u,this.environmentMainService=c,this.lifecycleMainService=l,this.logService=t,this.themeMainService=r,this.protocolMainService=s,this.firstWindowConnectionBarrier=new b.Barrier,this.window=void 0,this.windowCloseListener=void 0,this._onDidError=this._register(new g.Emitter),this.onDidError=g.Event.buffer(this._onDidError.event),this._whenReady=void 0,this._whenIpcReady=void 0,this.registerListeners()}registerListeners(){this._register(this.lifecycleMainService.onWillShutdown(()=>this.onWillShutdown())),L.ipcMain.on("vscode:createSharedProcessMessageChannel",async(a,u)=>this.onWindowConnection(a,u))}async onWindowConnection(a,u){this.logService.trace("SharedProcess: on vscode:createSharedProcessMessageChannel"),this.firstWindowConnectionBarrier.isOpen()||this.firstWindowConnectionBarrier.open(),await this.whenReady();const c=await this.connect();if(a.sender.isDestroyed())return c.close();a.sender.postMessage("vscode:createSharedProcessMessageChannelResult",u,[c])}onWillShutdown(){const a=this.window;!a||(!a.isDestroyed()&&!a.webContents.isDestroyed()&&a.webContents.send("vscode:electron-main->shared-process=exit"),this.windowCloseListener&&(a.removeListener("close",this.windowCloseListener),this.windowCloseListener=void 0),setTimeout(()=>{try{a.close()}catch(u){}this.window=void 0},0))}whenReady(){return this._whenReady||(this._whenReady=new Promise(a=>L.ipcMain.once("vscode:shared-process->electron-main=init-done",()=>{this.logService.trace("SharedProcess: Overall ready"),a()}))),this._whenReady}get whenIpcReady(){return this._whenIpcReady||(this._whenIpcReady=(async()=>{await this.firstWindowConnectionBarrier.wait(),this.createWindow(),this.registerWindowListeners(),await new Promise(a=>L.ipcMain.once("vscode:shared-process->electron-main=ipc-ready",()=>{this.logService.trace("SharedProcess: IPC ready"),a()}))})()),this._whenIpcReady}createWindow(){const a=this._register(this.protocolMainService.createIPCObjectUrl());this.window=new L.BrowserWindow({show:!1,backgroundColor:this.themeMainService.getBackgroundColor(),webPreferences:{preload:y.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",$).fsPath,additionalArguments:[`--vscode-window-config=${a.resource.toString()}`],v8CacheOptions:i.browserCodeLoadingCacheStrategy,nodeIntegration:!0,contextIsolation:!1,enableWebSQL:!1,enableRemoteModule:!1,spellcheck:!1,nativeWindowOpen:!0,images:!1,webgl:!1,disableBlinkFeatures:"Auxclick"}}),a.update({machineId:this.machineId,windowId:this.window.id,appRoot:this.environmentMainService.appRoot,nodeCachedDataDir:this.environmentMainService.nodeCachedDataDir,backupWorkspacesPath:this.environmentMainService.backupWorkspacesPath,userEnv:this.userEnv,args:this.environmentMainService.args,logLevel:this.logService.getLevel(),product:m.default}),this.window.loadURL(y.FileAccess.asBrowserUri("vs/code/electron-browser/sharedProcess/sharedProcess.html",$).toString(!0))}registerWindowListeners(){!this.window||(this.windowCloseListener=a=>{var u;this.logService.trace("SharedProcess#close prevented"),a.preventDefault(),((u=this.window)===null||u===void 0?void 0:u.isVisible())&&this.window.hide()},this.window.on("close",this.windowCloseListener),this.window.webContents.on("render-process-gone",(a,u)=>this._onDidError.fire({type:2,details:u})),this.window.on("unresponsive",()=>this._onDidError.fire({type:1,details:"SharedProcess: detected unresponsive window"})),this.window.webContents.on("did-fail-load",(a,u,c)=>this._onDidError.fire({type:3,details:`SharedProcess: failed to load: ${c}`})))}async connect(){await this.whenIpcReady;const a=(0,p.assertIsDefined)(this.window);return(0,M.connect)(a)}async toggle(){await this.whenIpcReady,!!this.window&&(this.window.isVisible()?(this.window.webContents.closeDevTools(),this.window.hide()):(this.window.show(),this.window.webContents.openDevTools()))}isVisible(){var a,u;return(u=(a=this.window)===null||a===void 0?void 0:a.isVisible())!==null&&u!==void 0?u:!1}};D=he([te(2,A.IEnvironmentMainService),te(3,n.ILifecycleMainService),te(4,E.ILogService),te(5,w.IThemeMainService),te(6,v.IProtocolMainService)],D),e.SharedProcess=D}),define(J[225],Z([0,1,7,8,13,6,24,9,21,20]),function($,e,m,L,A,b,E,n,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateMainService=e.FileStorage=void 0;class i{constructor(p,g,v){this.storagePath=p,this.logService=g,this.fileService=v,this.storage=Object.create(null),this.lastSavedStorageContents="",this.flushDelayer=new n.ThrottledDelayer(100),this.initializing=void 0,this.closing=void 0}init(){return this.initializing||(this.initializing=this.doInit()),this.initializing}async doInit(){try{this.lastSavedStorageContents=(await this.fileService.readFile(this.storagePath)).value.toString(),this.storage=JSON.parse(this.lastSavedStorageContents)}catch(p){p.fileOperationResult!==1&&this.logService.error(p)}}getItem(p,g){const v=this.storage[p];return(0,A.isUndefinedOrNull)(v)?g:v}setItem(p,g){this.setItems([{key:p,data:g}])}setItems(p){let g=!1;for(const{key:v,data:D}of p)this.storage[v]!==D&&((0,A.isUndefinedOrNull)(D)?(0,A.isUndefined)(this.storage[v])||(this.storage[v]=void 0,g=!0):(this.storage[v]=D,g=!0));g&&this.save()}removeItem(p){(0,A.isUndefined)(this.storage[p])||(this.storage[p]=void 0,this.save())}async save(p){if(!this.closing)return this.flushDelayer.trigger(()=>this.doSave(),p)}async doSave(){if(!this.initializing)return;await this.initializing;const p=JSON.stringify(this.storage,null,4);if(p!==this.lastSavedStorageContents)try{await this.fileService.writeFile(this.storagePath,y.VSBuffer.fromString(p)),this.lastSavedStorageContents=p}catch(g){this.logService.error(g)}}async close(){return this.closing||(this.closing=this.flushDelayer.trigger(()=>this.doSave(),0)),this.closing}}e.FileStorage=i;let I=class Pt{constructor(p,g,v){this.fileStorage=new i(m.URI.file((0,L.join)(p.userDataPath,Pt.STATE_FILE)),g,v)}async init(){return this.fileStorage.init()}getItem(p,g){return this.fileStorage.getItem(p,g)}setItem(p,g){this.fileStorage.setItem(p,g)}setItems(p){this.fileStorage.setItems(p)}removeItem(p){this.fileStorage.removeItem(p)}close(){return this.fileStorage.close()}};I.STATE_FILE="storage.json",I=he([te(0,E.IEnvironmentMainService),te(1,b.ILogService),te(2,w.IFileService)],I),e.StateMainService=I}),define(J[77],Z([0,1,5,9,17,18,22,41,24,6,49,25]),function($,e,m,L,A,b,E,n,w,y,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUpdateService=e.createUpdateURL=void 0;function M(g,v,D){return`${D.updateUrl}/api/update/${g}/${v}/${D.commit}`}e.createUpdateURL=M;let p=class{constructor(v,D,S,a,u,c){this.lifecycleMainService=v,this.configurationService=D,this.environmentMainService=S,this.requestService=a,this.logService=u,this.productService=c,this._state=n.State.Uninitialized,this._onStateChange=new m.Emitter,this.onStateChange=this._onStateChange.event}get state(){return this._state}setState(v){this.logService.info("update#setState",v.type),this._state=v,this._onStateChange.fire(v)}initialize(){if(!this.environmentMainService.isBuilt)return;if(this.environmentMainService.disableUpdates){this.logService.info("update#ctor - updates are disabled by the environment");return}if(!this.productService.updateUrl||!this.productService.commit){this.logService.info("update#ctor - updates are disabled as there is no update URL");return}const v=(0,A.getMigratedSettingValue)(this.configurationService,"update.mode","update.channel"),D=this.getProductQuality(v);if(!D){this.logService.info("update#ctor - updates are disabled by user preference");return}if(this.url=this.buildUpdateFeedUrl(D),!this.url){this.logService.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.setState(n.State.Idle(this.getUpdateType())),v==="manual"){this.logService.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}v==="start"?(this.logService.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.scheduleCheckForUpdates(30*1e3).then(void 0,S=>this.logService.error(S))}getProductQuality(v){return v==="none"?void 0:this.productService.quality}scheduleCheckForUpdates(v=60*60*1e3){return(0,L.timeout)(v).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(v){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(v)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}async doDownloadUpdate(v){}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}async doApplyUpdate(){}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(v=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${v}`),!v&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}isLatestVersion(){return this.url?this.requestService.request({url:this.url},I.CancellationToken.None).then(v=>v.res.statusCode===204):Promise.resolve(void 0)}getUpdateType(){return 1}doQuitAndInstall(){}};p=he([te(0,b.ILifecycleMainService),te(1,A.IConfigurationService),te(2,w.IEnvironmentMainService),te(3,i.IRequestService),te(4,y.ILogService),te(5,E.IProductService)],p),e.AbstractUpdateService=p}),define(J[226],Z([0,1,14,2,5,46,17,18,41,31,24,6,77,49,22]),function($,e,m,L,A,b,E,n,w,y,i,I,M,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DarwinUpdateService=void 0;let v=class extends M.AbstractUpdateService{constructor(S,a,u,c,l,t,r){super(S,a,c,l,t,r);this.telemetryService=u,this.disposables=new L.DisposableStore}get onRawError(){return A.Event.fromNodeEventEmitter(m.autoUpdater,"error",(S,a)=>a)}get onRawUpdateNotAvailable(){return A.Event.fromNodeEventEmitter(m.autoUpdater,"update-not-available")}get onRawUpdateAvailable(){return A.Event.fromNodeEventEmitter(m.autoUpdater,"update-available",(S,a,u)=>({url:a,version:u,productVersion:u}))}get onRawUpdateDownloaded(){return A.Event.fromNodeEventEmitter(m.autoUpdater,"update-downloaded",(S,a,u,c)=>({releaseNotes:a,version:u,productVersion:u,date:c}))}initialize(){super.initialize(),this.onRawError(this.onError,this,this.disposables),this.onRawUpdateAvailable(this.onUpdateAvailable,this,this.disposables),this.onRawUpdateDownloaded(this.onUpdateDownloaded,this,this.disposables),this.onRawUpdateNotAvailable(this.onUpdateNotAvailable,this,this.disposables)}onError(S){this.logService.error("UpdateService error:",S);const u=(this.state.type==="checking for updates"?this.state.explicit:!0)?S:void 0;this.setState(w.State.Idle(1,u))}buildUpdateFeedUrl(S){let a;this.productService.darwinUniversalAssetId?a=this.productService.darwinUniversalAssetId:a=process.arch==="x64"?"darwin":"darwin-arm64";const u=(0,M.createUpdateURL)(a,S,this.productService);try{m.autoUpdater.setFeedURL({url:u})}catch(c){this.logService.error("Failed to set update feed URL",c);return}return u}doCheckForUpdates(S){this.setState(w.State.CheckingForUpdates(S)),m.autoUpdater.checkForUpdates()}onUpdateAvailable(S){this.state.type==="checking for updates"&&this.setState(w.State.Downloading(S))}onUpdateDownloaded(S){this.state.type==="downloading"&&(this.telemetryService.publicLog2("update:downloaded",{version:S.version}),this.setState(w.State.Ready(S)))}onUpdateNotAvailable(){this.state.type==="checking for updates"&&(this.telemetryService.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.setState(w.State.Idle(1)))}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),m.autoUpdater.quitAndInstall()}dispose(){this.disposables.dispose()}};he([b.memoize],v.prototype,"onRawError",null),he([b.memoize],v.prototype,"onRawUpdateNotAvailable",null),he([b.memoize],v.prototype,"onRawUpdateAvailable",null),he([b.memoize],v.prototype,"onRawUpdateDownloaded",null),v=he([te(0,n.ILifecycleMainService),te(1,E.IConfigurationService),te(2,y.ITelemetryService),te(3,i.IEnvironmentMainService),te(4,p.IRequestService),te(5,I.ILogService),te(6,g.IProductService)],v),e.DarwinUpdateService=v}),define(J[227],Z([0,1,22,17,18,41,31,24,6,77,49,25,45]),function($,e,m,L,A,b,E,n,w,y,i,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxUpdateService=void 0;let p=class extends y.AbstractUpdateService{constructor(v,D,S,a,u,c,l,t){super(v,D,a,u,c,t);this.telemetryService=S,this.nativeHostMainService=l}buildUpdateFeedUrl(v){return(0,y.createUpdateURL)(`linux-${process.arch}`,v,this.productService)}doCheckForUpdates(v){!this.url||(this.setState(b.State.CheckingForUpdates(v)),this.requestService.request({url:this.url},I.CancellationToken.None).then(i.asJson).then(D=>{!D||!D.url||!D.version||!D.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!v}),this.setState(b.State.Idle(1))):this.setState(b.State.AvailableForDownload(D))}).then(void 0,D=>{this.logService.error(D),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!v});const S=v?D.message||D:void 0;this.setState(b.State.Idle(1,S))}))}async doDownloadUpdate(v){this.productService.downloadUrl&&this.productService.downloadUrl.length>0?this.nativeHostMainService.openExternal(void 0,this.productService.downloadUrl):v.update.url&&this.nativeHostMainService.openExternal(void 0,v.update.url),this.setState(b.State.Idle(1))}};p=he([te(0,A.ILifecycleMainService),te(1,L.IConfigurationService),te(2,E.ITelemetryService),te(3,n.IEnvironmentMainService),te(4,i.IRequestService),te(5,w.ILogService),te(6,M.INativeHostMainService),te(7,m.IProductService)],p),e.LinuxUpdateService=p}),define(J[228],Z([0,1,5,9,18,41,24,6,8,29,40,31]),function($,e,m,L,A,b,E,n,w,y,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnapUpdateService=void 0;let M=class{constructor(v,D,S){if(this.lifecycleMainService=v,this.logService=S,this._state=b.State.Uninitialized,this._onStateChange=new m.Emitter,this.onStateChange=this._onStateChange.event,D.disableUpdates){this.logService.info("update#ctor - updates are disabled");return}this.setState(b.State.Idle(this.getUpdateType())),this.scheduleCheckForUpdates(30*1e3).then(void 0,a=>this.logService.error(a))}get state(){return this._state}setState(v){this.logService.info("update#setState",v.type),this._state=v,this._onStateChange.fire(v)}scheduleCheckForUpdates(v=60*60*1e3){return(0,L.timeout)(v).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(v){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(v)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}doDownloadUpdate(v){return Promise.resolve(void 0)}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}doApplyUpdate(){return Promise.resolve(void 0)}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(v=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${v}`),!v&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}getUpdateType(){return 2}doQuitAndInstall(){}};M=he([te(0,A.ILifecycleMainService),te(1,E.IEnvironmentMainService),te(2,n.ILogService)],M);let p=class extends M{constructor(v,D,S,a,u,c){super(S,a,u);this.snap=v,this.snapRevision=D,this.telemetryService=c;const l=(0,y.watch)(w.dirname(this.snap)),t=m.Event.fromNodeEventEmitter(l,"change",(d,f)=>f),r=m.Event.filter(t,d=>d==="current"),o=m.Event.debounce(r,(d,f)=>f,2e3)(()=>this.checkForUpdates(!1));S.onWillShutdown(()=>{o.dispose(),l.close()})}doCheckForUpdates(){this.setState(b.State.CheckingForUpdates(!1)),this.isUpdateAvailable().then(v=>{v?this.setState(b.State.Ready({version:"something",productVersion:"something"})):(this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(b.State.Idle(2)))},v=>{this.logService.error(v),this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(b.State.Idle(2,v.message||v))})}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,i.spawn)("sleep 3 && "+w.basename(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async isUpdateAvailable(){const v=await new Promise((S,a)=>(0,y.realpath)(`${w.dirname(this.snap)}/current`,(u,c)=>u?a(u):S(c))),D=w.basename(v);return this.snapRevision!==D}isLatestVersion(){return this.isUpdateAvailable().then(void 0,v=>{this.logService.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};p=he([te(2,A.ILifecycleMainService),te(3,E.IEnvironmentMainService),te(4,n.ILogService),te(5,I.ITelemetryService)],p),e.SnapUpdateService=p}),define(J[229],Z([0,1,29,8,16,46,17,18,22,41,31,24,6,77,49,112,26,40,25,9,21,7,45]),function($,e,m,L,A,b,E,n,w,y,i,I,M,p,g,v,D,S,a,u,c,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Win32UpdateService=void 0;async function r(f,h=1e3){for(;!f();)await(0,u.timeout)(h)}let s;function o(){return typeof s=="undefined"&&(s=m.existsSync(L.join(L.dirname(process.execPath),"unins000.exe"))?0:1),s}let d=class extends p.AbstractUpdateService{constructor(h,P,T,U,q,Q,x,j,X){super(h,P,U,q,Q,X);this.telemetryService=T,this.fileService=x,this.nativeHostMainService=j}get cachePath(){const h=L.join((0,D.tmpdir)(),`vscode-update-${this.productService.target}-${process.arch}`);return A.Promises.mkdir(h,{recursive:!0}).then(()=>h)}initialize(){super.initialize(),o()===0&&this.telemetryService.publicLog("update:win32SetupTarget",{target:this.productService.target})}buildUpdateFeedUrl(h){let P="win32";return process.arch!=="ia32"&&(P+=`-${process.arch}`),o()===1?P+="-archive":this.productService.target==="user"&&(P+="-user"),(0,p.createUpdateURL)(P,h,this.productService)}doCheckForUpdates(h){!this.url||(this.setState(y.State.CheckingForUpdates(h)),this.requestService.request({url:this.url},a.CancellationToken.None).then(g.asJson).then(P=>{const T=o();return!P||!P.url||!P.version||!P.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!h}),this.setState(y.State.Idle(T)),Promise.resolve(null)):T===1?(this.setState(y.State.AvailableForDownload(P)),Promise.resolve(null)):(this.setState(y.State.Downloading(P)),this.cleanup(P.version).then(()=>this.getUpdatePackagePath(P.version).then(U=>A.exists(U).then(q=>{if(q)return Promise.resolve(U);const Q=P.url,x=P.hash,j=`${U}.tmp`;return this.requestService.request({url:Q},a.CancellationToken.None).then(X=>this.fileService.writeFile(l.URI.file(j),X.stream)).then(x?()=>(0,v.checksum)(j,P.hash):()=>{}).then(()=>A.Promises.rename(j,U)).then(()=>U)})).then(U=>{const q=this.configurationService.getValue("update.enableWindowsBackgroundUpdates");this.availableUpdate={packagePath:U},q&&P.supportsFastUpdate?this.productService.target==="user"?this.doApplyUpdate():this.setState(y.State.Downloaded(P)):this.setState(y.State.Ready(P))})))}).then(void 0,P=>{this.logService.error(P),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!h});const T=h?P.message||P:void 0;this.setState(y.State.Idle(o(),T))}))}async doDownloadUpdate(h){h.update.url&&this.nativeHostMainService.openExternal(void 0,h.update.url),this.setState(y.State.Idle(o()))}async getUpdatePackagePath(h){const P=await this.cachePath;return L.join(P,`CodeSetup-${this.productService.quality}-${h}.exe`)}async cleanup(h=null){const P=h?Q=>!new RegExp(`${this.productService.quality}-${h}\\.exe$`).test(Q):()=>!0,T=await this.cachePath,q=(await A.readdir(T)).filter(P).map(async Q=>{try{await A.Promises.unlink(L.join(T,Q))}catch(x){}});await Promise.all(q)}async doApplyUpdate(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.availableUpdate)return Promise.resolve(void 0);const h=this.state.update;this.setState(y.State.Updating(h));const P=await this.cachePath;this.availableUpdate.updateFilePath=L.join(P,`CodeSetup-${this.productService.quality}-${h.version}.flag`),await A.writeFile(this.availableUpdate.updateFilePath,"flag"),(0,S.spawn)(this.availableUpdate.packagePath,["/verysilent",`/update="${this.availableUpdate.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.availableUpdate=void 0,this.setState(y.State.Idle(o()))});const U=`${this.productService.win32MutexName}-ready`,q=await new Promise((Q,x)=>{$(["windows-mutex"],Q,x)});r(()=>q.isActive(U)).then(()=>this.setState(y.State.Ready(h)))}doQuitAndInstall(){this.state.type!=="ready"||!this.availableUpdate||(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.state.update.supportsFastUpdate&&this.availableUpdate.updateFilePath?m.unlinkSync(this.availableUpdate.updateFilePath):(0,S.spawn)(this.availableUpdate.packagePath,["/silent","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}getUpdateType(){return o()}};he([b.memoize],d.prototype,"cachePath",null),d=he([te(0,n.ILifecycleMainService),te(1,E.IConfigurationService),te(2,i.ITelemetryService),te(3,I.IEnvironmentMainService),te(4,g.IRequestService),te(5,M.ILogService),te(6,c.IFileService),te(7,t.INativeHostMainService),te(8,w.IProductService)],d),e.Win32UpdateService=d}),define(J[52],Z([0,1,28,24,8,16,29,3,5,6,58,43,10,2,15,4,153,22,14,13,50,51,100]),function($,e,m,L,A,b,E,n,w,y,i,I,M,p,g,v,D,S,a,u,c,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=e.WorkspacesManagementMainService=e.IWorkspacesManagementMainService=void 0,e.IWorkspacesManagementMainService=(0,v.createDecorator)("workspacesManagementMainService");let r=class extends p.Disposable{constructor(f,h,P,T,U){super();this.environmentMainService=f,this.logService=h,this.backupMainService=P,this.dialogMainService=T,this.productService=U,this.untitledWorkspacesHome=this.environmentMainService.untitledWorkspacesHome,this._onDidDeleteUntitledWorkspace=this._register(new w.Emitter),this.onDidDeleteUntitledWorkspace=this._onDidDeleteUntitledWorkspace.event,this._onDidEnterWorkspace=this._register(new w.Emitter),this.onDidEnterWorkspace=this._onDidEnterWorkspace.event}resolveLocalWorkspaceSync(f){if(!this.isWorkspacePath(f)||f.scheme!==M.Schemas.file)return;let h;try{h=(0,E.readFileSync)(f.fsPath,"utf8")}catch(P){return}return this.doResolveWorkspace(f,h)}isWorkspacePath(f){return(0,m.isUntitledWorkspace)(f,this.environmentMainService)||(0,m.hasWorkspaceFileExtension)(f)}doResolveWorkspace(f,h){try{const P=this.doParseStoredWorkspace(f,h),T=s(f);return{id:T.id,configPath:T.configPath,folders:(0,m.toWorkspaceFolders)(P.folders,T.configPath,g.extUriBiasedIgnorePathCase),remoteAuthority:P.remoteAuthority}}catch(P){this.logService.warn(P.toString())}}doParseStoredWorkspace(f,h){const P=(0,I.parse)(h);if(P&&Array.isArray(P.folders))P.folders=P.folders.filter(T=>(0,m.isStoredWorkspaceFolder)(T));else throw new Error(`${f.toString(!0)} looks like an invalid workspace file.`);return P}async createUntitledWorkspace(f,h){const{workspace:P,storedWorkspace:T}=this.newUntitledWorkspace(f,h),U=P.configPath.fsPath;return await b.Promises.mkdir((0,A.dirname)(U),{recursive:!0}),await(0,b.writeFile)(U,JSON.stringify(T,null,"	")),P}createUntitledWorkspaceSync(f,h){const{workspace:P,storedWorkspace:T}=this.newUntitledWorkspace(f,h),U=P.configPath.fsPath;return(0,E.mkdirSync)((0,A.dirname)(U),{recursive:!0}),(0,b.writeFileSync)(U,JSON.stringify(T,null,"	")),P}newUntitledWorkspace(f=[],h){const P=(Date.now()+Math.round(Math.random()*1e3)).toString(),T=(0,g.joinPath)(this.untitledWorkspacesHome,P),U=(0,g.joinPath)(T,m.UNTITLED_WORKSPACE_NAME),q=[];for(const Q of f)q.push((0,m.getStoredWorkspaceFolder)(Q.uri,!0,Q.name,T,!n.isWindows,g.extUriBiasedIgnorePathCase));return{workspace:s(U),storedWorkspace:{folders:q,remoteAuthority:h}}}async getWorkspaceIdentifier(f){return s(f)}isUntitledWorkspace(f){return(0,m.isUntitledWorkspace)(f.configPath,this.environmentMainService)}deleteUntitledWorkspaceSync(f){!this.isUntitledWorkspace(f)||(this.doDeleteUntitledWorkspaceSync(f),this._onDidDeleteUntitledWorkspace.fire(f))}async deleteUntitledWorkspace(f){this.deleteUntitledWorkspaceSync(f)}doDeleteUntitledWorkspaceSync(f){const h=(0,g.originalFSPath)(f.configPath);try{(0,b.rimrafSync)((0,A.dirname)(h));const P=(0,A.join)(this.environmentMainService.workspaceStorageHome.fsPath,f.id);(0,E.existsSync)(P)&&(0,b.writeFileSync)((0,A.join)(P,"obsolete"),"")}catch(P){this.logService.warn(`Unable to delete untitled workspace ${h} (${P}).`)}}getUntitledWorkspacesSync(){const f=[];try{const h=(0,b.readdirSync)(this.untitledWorkspacesHome.fsPath).map(P=>(0,g.joinPath)(this.untitledWorkspacesHome,P,m.UNTITLED_WORKSPACE_NAME));for(const P of h){const T=s(P),U=this.resolveLocalWorkspaceSync(P);U?f.push({workspace:T,remoteAuthority:U.remoteAuthority}):this.doDeleteUntitledWorkspaceSync(T)}}catch(h){h.code!=="ENOENT"&&this.logService.warn(`Unable to read folders in ${this.untitledWorkspacesHome} (${h}).`)}return f}async enterWorkspace(f,h,P){if(!f||!f.win||!f.isReady||!await this.isValidTargetWorkspacePath(f,h,P))return;const U=this.doEnterWorkspace(f,s(P));if(!!U)return this._onDidEnterWorkspace.fire({window:f,workspace:U.workspace}),U}async isValidTargetWorkspacePath(f,h,P){if(!P)return!0;if((0,m.isWorkspaceIdentifier)(f.openedWorkspace)&&g.extUriBiasedIgnorePathCase.isEqual(f.openedWorkspace.configPath,P))return!1;if((0,t.findWindowOnWorkspaceOrFolder)(h,P)){const T={title:this.productService.nameLong,type:"info",buttons:[(0,D.localize)(0,null)],message:(0,D.localize)(1,null,(0,g.basename)(P)),detail:(0,D.localize)(2,null),noLink:!0};return await this.dialogMainService.showMessageBox(T,(0,u.withNullAsUndefined)(a.BrowserWindow.getFocusedWindow())),!1}return!0}doEnterWorkspace(f,h){if(!f.config)return;f.focus();let P;return f.config.extensionDevelopmentPath||(P=this.backupMainService.registerWorkspaceBackupSync({workspace:h,remoteAuthority:f.remoteAuthority},f.config.backupPath)),(0,m.isWorkspaceIdentifier)(f.openedWorkspace)&&this.isUntitledWorkspace(f.openedWorkspace)&&this.deleteUntitledWorkspaceSync(f.openedWorkspace),f.config.workspace=h,f.config.backupPath=P,{workspace:h,backupPath:P}}};r=he([te(0,L.IEnvironmentMainService),te(1,y.ILogService),te(2,c.IBackupMainService),te(3,l.IDialogMainService),te(4,S.IProductService)],r),e.WorkspacesManagementMainService=r;function s(d){function f(){let h=d.scheme===M.Schemas.file?(0,g.originalFSPath)(d):d.toString();return n.isLinux||(h=h.toLowerCase()),(0,i.createHash)("md5").update(h).digest("hex")}return{id:f(),configPath:d}}e.getWorkspaceIdentifier=s;function o(d,f){function h(){if(d.scheme!==M.Schemas.file)return(0,i.createHash)("md5").update(d.toString()).digest("hex");if(!f)try{f=(0,E.statSync)(d.fsPath)}catch(U){return}let T;return n.isLinux?T=f.ino:n.isMacintosh?T=f.birthtime.getTime():n.isWindows&&(typeof f.birthtimeMs=="number"?T=Math.floor(f.birthtimeMs):T=f.birthtime.getTime()),(0,i.createHash)("md5").update(d.fsPath).update(T?String(T):"").digest("hex")}const P=h();if(typeof P=="string")return{id:P,uri:d}}e.getSingleFolderWorkspaceIdentifier=o}),define(J[101],Z([0,1,6,98,3,4,34,16,52,17,7,14,35,54,25,28,13]),function($,e,m,L,A,b,E,n,w,y,i,I,M,p,g,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LaunchMainService=e.ILaunchMainService=e.ID=void 0,e.ID="launchMainService",e.ILaunchMainService=(0,b.createDecorator)(e.ID);let S=class{constructor(u,c,l,t,r){this.logService=u,this.windowsMainService=c,this.urlService=l,this.workspacesManagementMainService=t,this.configurationService=r}async start(u,c){this.logService.trace("Received data from other instance: ",u,c),A.isMacintosh&&I.app.focus({steal:!0});const l=this.parseOpenUrl(u);if(l.length){let t=Promise.resolve();this.windowsMainService.getWindowCount()===0&&(t=this.windowsMainService.openEmptyWindow({context:4})[0].ready()),t.then(()=>{for(const{uri:r,url:s}of l)this.urlService.open(r,{originalUrl:s})})}else return this.startOpenWindow(u,c)}parseOpenUrl(u){return u["open-url"]&&u._urls&&u._urls.length>0?(0,M.coalesce)(u._urls.map(c=>{try{return{uri:i.URI.parse(c),url:c}}catch(l){return null}})):[]}async startOpenWindow(u,c){const l=(0,p.isLaunchedFromCli)(c)?0:4;let t=[];const r=u.wait&&u.waitMarkerFilePath?i.URI.file(u.waitMarkerFilePath):void 0,s=u.remote||void 0;if(u.extensionDevelopmentPath)this.windowsMainService.openExtensionDevelopmentHostWindow(u.extensionDevelopmentPath,{context:l,cli:u,userEnv:c,waitMarkerFileURI:r,remoteAuthority:s});else if(!u._.length&&!u["folder-uri"]&&!u["file-uri"]){let o=!1;if(u["new-window"]||u["unity-launch"])o=!0;else if(u["reuse-window"])o=!1;else{const d=this.configurationService.getValue("window");switch((d==null?void 0:d.openWithoutArgumentsInNewWindow)||"default"){case"on":o=!0;break;case"off":o=!1;break;default:o=!A.isMacintosh}}if(o)t=this.windowsMainService.open({context:l,cli:u,userEnv:c,forceNewWindow:!0,forceEmpty:!0,waitMarkerFileURI:r,remoteAuthority:s});else{const d=this.windowsMainService.getLastActiveWindow();d?(d.focus(),t=[d]):t=this.windowsMainService.open({context:l,cli:u,forceEmpty:!0,remoteAuthority:s})}}else t=this.windowsMainService.open({context:l,cli:u,userEnv:c,forceNewWindow:u["new-window"],preferNewWindow:!u["reuse-window"]&&!u.wait,forceReuseWindow:u["reuse-window"],diffMode:u.diff,addMode:u.add,noRecentEntry:!!u["skip-add-to-recently-opened"],waitMarkerFileURI:r,gotoLineMode:u.goto,remoteAuthority:s});if(r&&t.length===1&&t[0])return Promise.race([t[0].whenClosedOrLoaded,(0,n.whenDeleted)(r.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.logService.trace("Received request for process ID from other instance."),process.pid}async getMainProcessInfo(){this.logService.trace("Received request for main process info from other instance.");const u=[];return I.BrowserWindow.getAllWindows().forEach(c=>{const l=this.windowsMainService.getWindowById(c.id);l?u.push(this.codeWindowToInfo(l)):u.push(this.browserWindowToInfo(c))}),{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:u,screenReader:!!I.app.accessibilitySupportEnabled,gpuFeatureStatus:I.app.getGPUFeatureStatus()}}async getRemoteDiagnostics(u){const c=this.windowsMainService.getWindows();return(await Promise.all(c.map(t=>new Promise(r=>{const s=t.remoteAuthority;if(s){const o=`vscode:getDiagnosticInfoResponse${t.id}`,d={includeProcesses:u.includeProcesses,folders:u.includeWorkspaceMetadata?this.getFolderURIs(t):void 0};t.sendWhenReady("vscode:getDiagnosticInfo",g.CancellationToken.None,{replyChannel:o,args:d}),I.ipcMain.once(o,(f,h)=>{h||r({hostName:s,errorMessage:`Unable to resolve connection to '${s}'.`}),r(h)}),setTimeout(()=>{r({hostName:s,errorMessage:`Fetching remote diagnostics for '${s}' timed out.`})},5e3)}else r(void 0)})))).filter(t=>!!t)}getFolderURIs(u){const c=[],l=u.openedWorkspace;if((0,v.isSingleFolderWorkspaceIdentifier)(l))c.push(l.uri);else if((0,v.isWorkspaceIdentifier)(l)){const t=this.workspacesManagementMainService.resolveLocalWorkspaceSync(l.configPath);t&&t.folders.forEach(s=>{c.push(s.uri)})}return c}codeWindowToInfo(u){const c=this.getFolderURIs(u),l=(0,D.assertIsDefined)(u.win);return this.browserWindowToInfo(l,c,u.remoteAuthority)}browserWindowToInfo(u,c=[],l){return{pid:u.webContents.getOSProcessId(),title:u.getTitle(),folderURIs:c,remoteAuthority:l}}};S=he([te(0,m.ILogService),te(1,E.IWindowsMainService),te(2,L.IURLService),te(3,w.IWorkspacesManagementMainService),te(4,y.IConfigurationService)],S),e.LaunchMainService=S}),define(J[230],Z([0,1,143,26,47,14,101,70,24,3,6,83,51,4,61,10,45,55,2]),function($,e,m,L,A,b,E,n,w,y,i,I,M,p,g,v,D,S,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IssueMainService=e.IIssueMainService=void 0,e.IIssueMainService=(0,p.createDecorator)("issueMainService");let u=class Mt{constructor(l,t,r,s,o,d,f,h){this.userEnv=l,this.environmentMainService=t,this.launchMainService=r,this.logService=s,this.diagnosticsService=o,this.dialogMainService=d,this.nativeHostMainService=f,this.protocolMainService=h,this.issueReporterWindow=null,this.issueReporterParentWindow=null,this.processExplorerWindow=null,this.processExplorerParentWindow=null,this.registerListeners()}registerListeners(){b.ipcMain.on("vscode:issueSystemInfoRequest",async l=>{const[t,r]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]),s=await this.diagnosticsService.getSystemInfo(t,r);this.safeSend(l,"vscode:issueSystemInfoResponse",s)}),b.ipcMain.on("vscode:listProcesses",async l=>{const t=[];try{const r=await this.launchMainService.getMainProcessId();t.push({name:(0,m.localize)(0,null),rootProcess:await(0,I.listProcesses)(r)}),(await this.launchMainService.getRemoteDiagnostics({includeProcesses:!0})).forEach(o=>{(0,n.isRemoteDiagnosticError)(o)?t.push({name:o.hostName,rootProcess:o}):o.processes&&t.push({name:o.hostName,rootProcess:o.processes})})}catch(r){this.logService.error(`Listing processes failed: ${r}`)}this.safeSend(l,"vscode:listProcessesResponse",t)}),b.ipcMain.on("vscode:issueReporterClipboard",async l=>{const t={message:(0,m.localize)(1,null),type:"warning",buttons:[(0,m.localize)(2,null),(0,m.localize)(3,null)]};if(this.issueReporterWindow){const r=await this.dialogMainService.showMessageBox(t,this.issueReporterWindow);this.safeSend(l,"vscode:issueReporterClipboardResponse",r.response===0)}}),b.ipcMain.on("vscode:issuePerformanceInfoRequest",async l=>{const t=await this.getPerformanceInfo();this.safeSend(l,"vscode:issuePerformanceInfoResponse",t)}),b.ipcMain.on("vscode:issueReporterConfirmClose",async()=>{const l={message:(0,m.localize)(4,null),type:"warning",buttons:[(0,m.localize)(5,null),(0,m.localize)(6,null)]};this.issueReporterWindow&&(await this.dialogMainService.showMessageBox(l,this.issueReporterWindow)).response===0&&this.issueReporterWindow&&(this.issueReporterWindow.destroy(),this.issueReporterWindow=null)}),b.ipcMain.on("vscode:workbenchCommand",(l,t)=>{const{id:r,from:s,args:o}=t;let d;switch(s){case"issueReporter":d=this.issueReporterParentWindow;break;case"processExplorer":d=this.processExplorerParentWindow;break;default:throw new Error(`Unexpected command source: ${s}`)}d&&d.webContents.send("vscode:runAction",{id:r,from:s,args:o})}),b.ipcMain.on("vscode:openExternal",(l,t)=>{this.nativeHostMainService.openExternal(void 0,t)}),b.ipcMain.on("vscode:closeIssueReporter",l=>{this.issueReporterWindow&&this.issueReporterWindow.close()}),b.ipcMain.on("vscode:closeProcessExplorer",l=>{this.processExplorerWindow&&this.processExplorerWindow.close()}),b.ipcMain.on("vscode:windowsInfoRequest",async l=>{const t=await this.launchMainService.getMainProcessInfo();this.safeSend(l,"vscode:windowsInfoResponse",t.windows)})}safeSend(l,t,...r){l.sender.isDestroyed()||l.sender.send(t,...r)}async openReporter(l){var t;if(!this.issueReporterWindow&&(this.issueReporterParentWindow=b.BrowserWindow.getFocusedWindow(),this.issueReporterParentWindow)){const r=new a.DisposableStore,s=r.add(this.protocolMainService.createIPCObjectUrl()),o=this.getWindowPosition(this.issueReporterParentWindow,700,800);this.issueReporterWindow=this.createBrowserWindow(o,s,{backgroundColor:l.styles.backgroundColor,title:(0,m.localize)(7,null),zoomLevel:l.zoomLevel,alwaysOnTop:!1}),s.update({appRoot:this.environmentMainService.appRoot,windowId:this.issueReporterWindow.id,userEnv:this.userEnv,data:l,disableExtensions:!!this.environmentMainService.disableExtensions,os:{type:(0,L.type)(),arch:(0,L.arch)(),release:(0,L.release)()},product:A.default}),this.issueReporterWindow.loadURL(v.FileAccess.asBrowserUri("vs/code/electron-sandbox/issue/issueReporter.html",$,!0).toString(!0)),this.issueReporterWindow.on("close",()=>{this.issueReporterWindow=null,r.dispose()}),this.issueReporterParentWindow.on("closed",()=>{this.issueReporterWindow&&(this.issueReporterWindow.close(),this.issueReporterWindow=null,r.dispose())})}(t=this.issueReporterWindow)===null||t===void 0||t.focus()}async openProcessExplorer(l){var t;if(!this.processExplorerWindow&&(this.processExplorerParentWindow=b.BrowserWindow.getFocusedWindow(),this.processExplorerParentWindow)){const r=new a.DisposableStore,s=r.add(this.protocolMainService.createIPCObjectUrl()),o=this.getWindowPosition(this.processExplorerParentWindow,800,500);this.processExplorerWindow=this.createBrowserWindow(o,s,{backgroundColor:l.styles.backgroundColor,title:(0,m.localize)(8,null),zoomLevel:l.zoomLevel,alwaysOnTop:!0}),s.update({appRoot:this.environmentMainService.appRoot,windowId:this.processExplorerWindow.id,userEnv:this.userEnv,data:l,product:A.default}),this.processExplorerWindow.loadURL(v.FileAccess.asBrowserUri("vs/code/electron-sandbox/processExplorer/processExplorer.html",$,!0).toString(!0)),this.processExplorerWindow.on("close",()=>{this.processExplorerWindow=null,r.dispose()}),this.processExplorerParentWindow.on("close",()=>{this.processExplorerWindow&&(this.processExplorerWindow.close(),this.processExplorerWindow=null,r.dispose())})}(t=this.processExplorerWindow)===null||t===void 0||t.focus()}createBrowserWindow(l,t,r){const s=new b.BrowserWindow({fullscreen:!1,skipTaskbar:!0,resizable:!0,width:l.width,height:l.height,minWidth:300,minHeight:200,x:l.x,y:l.y,title:r.title,backgroundColor:r.backgroundColor||Mt.DEFAULT_BACKGROUND_COLOR,webPreferences:{preload:v.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",$).fsPath,additionalArguments:[`--vscode-window-config=${t.resource.toString()}`,"--context-isolation"],v8CacheOptions:y.browserCodeLoadingCacheStrategy,enableWebSQL:!1,enableRemoteModule:!1,spellcheck:!1,nativeWindowOpen:!0,zoomFactor:(0,g.zoomLevelToZoomFactor)(r.zoomLevel),sandbox:!0,contextIsolation:!0},alwaysOnTop:r.alwaysOnTop});return s.setMenuBarVisibility(!1),s}async getSystemStatus(){const[l,t]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.diagnosticsService.getDiagnostics(l,t)}getWindowPosition(l,t,r){let s;const o=b.screen.getAllDisplays();if(o.length===1)s=o[0];else{if(y.isMacintosh){const h=b.screen.getCursorScreenPoint();s=b.screen.getDisplayNearestPoint(h)}!s&&l&&(s=b.screen.getDisplayMatching(l.getBounds())),s||(s=b.screen.getPrimaryDisplay()||o[0])}const d={width:t,height:r},f=s.bounds;return d.x=f.x+f.width/2-d.width/2,d.y=f.y+f.height/2-d.height/2,f.width>0&&f.height>0&&(d.x<f.x&&(d.x=f.x),d.y<f.y&&(d.y=f.y),d.x>f.x+f.width&&(d.x=f.x),d.y>f.y+f.height&&(d.y=f.y),d.width>f.width&&(d.width=f.width),d.height>f.height&&(d.height=f.height)),d}async getPerformanceInfo(){try{const[l,t]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.diagnosticsService.getPerformanceInfo(l,t)}catch(l){throw this.logService.warn("issueService#getPerformanceInfo ",l.message),l}}};u.DEFAULT_BACKGROUND_COLOR="#1E1E1E",u=he([te(1,w.IEnvironmentMainService),te(2,E.ILaunchMainService),te(3,i.ILogService),te(4,n.IDiagnosticsService),te(5,M.IDialogMainService),te(6,D.INativeHostMainService),te(7,S.IProtocolMainService)],u),e.IssueMainService=u}),define(J[231],Z([0,1,8,149,72,5,7,14,24,6,17,22,61,2,3,34,28,52,50,198,60,31,51,39,202,18,99,21,10,54,25,55]),function($,e,m,L,A,b,E,n,w,y,i,I,M,p,g,v,D,S,a,u,c,l,t,r,s,o,d,f,h,P,T,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeWindow=void 0;var q;(function(x){x[x.NONE=0]="NONE",x[x.LOADING=1]="LOADING",x[x.NAVIGATING=2]="NAVIGATING",x[x.READY=3]="READY"})(q||(q={}));let Q=class extends p.Disposable{constructor(j,X,B,V,N,C,z,F,R,W,k,O,_,K){super();this.logService=X,this.environmentMainService=B,this.fileService=V,this.configurationService=C,this.themeMainService=z,this.workspacesManagementMainService=F,this.backupMainService=R,this.telemetryService=W,this.dialogMainService=k,this.lifecycleMainService=O,this.productService=_,this.protocolMainService=K,this._onWillLoad=this._register(new b.Emitter),this.onWillLoad=this._onWillLoad.event,this._onDidSignalReady=this._register(new b.Emitter),this.onDidSignalReady=this._onDidSignalReady.event,this._onDidClose=this._register(new b.Emitter),this.onDidClose=this._onDidClose.event,this._onDidDestroy=this._register(new b.Emitter),this.onDidDestroy=this._onDidDestroy.event,this.whenReadyCallbacks=[],this.touchBarGroups=[],this.currentHttpProxy=void 0,this.currentNoProxy=void 0,this._lastFocusTime=-1,this.configObjectUrl=this._register(this.protocolMainService.createIPCObjectUrl()),this.readyState=0;{const[G,Y]=this.restoreWindowState(j.state);this.windowState=G,this.logService.trace("window#ctor: using window state",G);const ee=this.windowState.mode===0||this.windowState.mode===3,ne=this.configurationService.getValue("window"),re={width:this.windowState.width,height:this.windowState.height,x:this.windowState.x,y:this.windowState.y,backgroundColor:this.themeMainService.getBackgroundColor(),minWidth:M.WindowMinimumSize.WIDTH,minHeight:M.WindowMinimumSize.HEIGHT,show:!ee,title:this.productService.nameLong,webPreferences:Object.assign({preload:h.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",$).fsPath,additionalArguments:this.environmentMainService.sandbox?[`--vscode-window-config=${this.configObjectUrl.resource.toString()}`,"--context-isolation"]:[`--vscode-window-config=${this.configObjectUrl.resource.toString()}`],v8CacheOptions:g.browserCodeLoadingCacheStrategy,enableWebSQL:!1,enableRemoteModule:!1,spellcheck:!1,nativeWindowOpen:!0,webviewTag:!0,zoomFactor:(0,M.zoomLevelToZoomFactor)(ne==null?void 0:ne.zoomLevel)},this.environmentMainService.sandbox?{sandbox:!0}:{nodeIntegration:!0,contextIsolation:!1})};g.browserCodeLoadingCacheStrategy?this.logService.info(`window#ctor: using vscode-file:// protocol and V8 cache options: ${g.browserCodeLoadingCacheStrategy}`):this.logService.trace("window#ctor: vscode-file:// protocol is explicitly disabled"),g.isLinux?re.icon=(0,m.join)(this.environmentMainService.appRoot,"resources/linux/code.png"):g.isWindows&&!this.environmentMainService.isBuilt&&(re.icon=(0,m.join)(this.environmentMainService.appRoot,"resources/win32/code_150x150.png")),g.isMacintosh&&!this.useNativeFullScreen()&&(re.fullscreenable=!1),g.isMacintosh&&(re.acceptFirstMouse=!0,(ne==null?void 0:ne.clickThroughInactive)===!1&&(re.acceptFirstMouse=!1));const se=g.isMacintosh&&(ne==null?void 0:ne.nativeTabs)===!0;se&&(re.tabbingIdentifier=this.productService.nameShort);const le=(0,M.getTitleBarStyle)(this.configurationService)==="custom";if(le&&(re.titleBarStyle="hidden",this.hiddenTitleBarStyle=!0,g.isMacintosh||(re.frame=!1)),(0,A.mark)("code/willCreateCodeBrowserWindow"),this._win=new n.BrowserWindow(re),(0,A.mark)("code/didCreateCodeBrowserWindow"),this._id=this._win.id,this.environmentMainService.args["open-devtools"]===!0&&this._win.webContents.openDevTools(),g.isMacintosh&&le&&this._win.setSheetOffset(22),g.isMacintosh&&Y&&(!se||n.BrowserWindow.getAllWindows().length===1)&&[this.windowState.width,this.windowState.height,this.windowState.x,this.windowState.y].every(oe=>typeof oe=="number")){const oe=this.windowState;this._win.setBounds({width:oe.width,height:oe.height,x:oe.x,y:oe.y})}ee&&((0,A.mark)("code/willMaximizeCodeWindow"),this._win.maximize(),this.windowState.mode===3&&this.setFullScreen(!0),this._win.isVisible()||this._win.show(),(0,A.mark)("code/didMaximizeCodeWindow")),this._lastFocusTime=Date.now()}this.onConfigurationUpdated(),this.createTouchBar(),this.marketplaceHeadersPromise=(0,u.resolveMarketplaceHeaders)(this.productService.version,this.environmentMainService,this.fileService,{get:G=>N.globalStorage.get(G),store:(G,Y)=>N.globalStorage.set(G,Y)}),this.registerListeners()}get id(){return this._id}get win(){return this._win}get lastFocusTime(){return this._lastFocusTime}get backupPath(){var j;return(j=this.currentConfig)===null||j===void 0?void 0:j.backupPath}get openedWorkspace(){var j;return(j=this.currentConfig)===null||j===void 0?void 0:j.workspace}get remoteAuthority(){var j;return(j=this.currentConfig)===null||j===void 0?void 0:j.remoteAuthority}get config(){return this.currentConfig}get hasHiddenTitleBarStyle(){return!!this.hiddenTitleBarStyle}get isExtensionDevelopmentHost(){var j;return!!((j=this.currentConfig)===null||j===void 0?void 0:j.extensionDevelopmentPath)}get isExtensionTestHost(){var j;return!!((j=this.currentConfig)===null||j===void 0?void 0:j.extensionTestsPath)}get isExtensionDevelopmentTestFromCli(){var j;return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!((j=this.currentConfig)===null||j===void 0?void 0:j.debugId)}setRepresentedFilename(j){g.isMacintosh?this._win.setRepresentedFilename(j):this.representedFilename=j}getRepresentedFilename(){return g.isMacintosh?this._win.getRepresentedFilename():this.representedFilename}setDocumentEdited(j){g.isMacintosh&&this._win.setDocumentEdited(j),this.documentEdited=j}isDocumentEdited(){return g.isMacintosh?this._win.isDocumentEdited():!!this.documentEdited}focus(j){g.isMacintosh&&(j==null?void 0:j.force)&&n.app.focus({steal:!0}),!!this._win&&(this._win.isMinimized()&&this._win.restore(),this._win.focus())}setReady(){for(this.readyState=3;this.whenReadyCallbacks.length;)this.whenReadyCallbacks.pop()(this);this._onDidSignalReady.fire()}ready(){return new Promise(j=>{if(this.isReady)return j(this);this.whenReadyCallbacks.push(j)})}get isReady(){return this.readyState===3}get whenClosedOrLoaded(){return new Promise(j=>{function X(){B.dispose(),V.dispose(),j()}const B=this.onDidClose(()=>X()),V=this.onWillLoad(()=>X())})}registerListeners(){this._win.on("unresponsive",()=>this.onWindowError(1)),this._win.webContents.on("render-process-gone",(N,C)=>this.onWindowError(2,C)),this._win.webContents.on("did-fail-load",(N,C,z)=>this.onWindowError(3,z)),this._win.webContents.on("will-prevent-unload",N=>{N.preventDefault()}),this._win.on("closed",()=>{this._onDidClose.fire(),this.dispose()});const j=new Set([h.Schemas.file,h.Schemas.vscodeFileResource,h.Schemas.vscodeRemoteResource,"devtools"]),X=N=>{for(let C=N;C;C=C.parent)if(C.url.startsWith(`${h.Schemas.vscodeWebview}://`))return!0;return!1},B=N=>N.resourceType==="xhr"||X(N.frame);this._win.webContents.session.webRequest.onBeforeRequest((N,C)=>{const z=E.URI.parse(N.url);return z.path.endsWith(".svg")&&!(j.has(z.scheme)||z.path.includes(h.Schemas.vscodeRemoteResource))?C({cancel:!B(N)}):C({cancel:!1})}),this._win.webContents.session.webRequest.onHeadersReceived((N,C)=>{const z=N.responseHeaders,F=z["content-type"]||z["Content-Type"];if(F&&Array.isArray(F)){const R=E.URI.parse(N.url);if(R.path.endsWith(".svg")&&j.has(R.scheme))return z["Content-Type"]=["image/svg+xml"],C({cancel:!1,responseHeaders:z});if(!R.path.includes(h.Schemas.vscodeRemoteResource)&&F.some(W=>W.toLowerCase().includes("image/svg")))return C({cancel:!B(N)})}return C({cancel:!1})}),this._win.webContents.on("did-finish-load",()=>{this.readyState=1,this.pendingLoadConfig&&(this.currentConfig=this.pendingLoadConfig,this.pendingLoadConfig=void 0)}),this._win.on("focus",()=>{this._lastFocusTime=Date.now()}),this._win.on("maximize",N=>{this.currentConfig&&(this.currentConfig.maximized=!0),n.app.emit("browser-window-maximize",N,this._win)}),this._win.on("unmaximize",N=>{this.currentConfig&&(this.currentConfig.maximized=!1),n.app.emit("browser-window-unmaximize",N,this._win)}),this._win.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",T.CancellationToken.None)}),this._win.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",T.CancellationToken.None)}),this._register(this.configurationService.onDidChangeConfiguration(()=>this.onConfigurationUpdated())),this._register(this.workspacesManagementMainService.onDidDeleteUntitledWorkspace(N=>this.onDidDeleteUntitledWorkspace(N)));const V=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this._win.webContents.session.webRequest.onBeforeSendHeaders({urls:V},async(N,C)=>{const z=await this.marketplaceHeadersPromise;C({cancel:!1,requestHeaders:Object.assign(N.requestHeaders,z)})})}async onWindowError(j,X){var B;switch(j){case 2:this.logService.error(`CodeWindow: renderer process crashed (detail: ${typeof X=="string"?X:X==null?void 0:X.reason}, code: ${typeof X=="string"?"<unknown>":(B=X==null?void 0:X.exitCode)!==null&&B!==void 0?B:"<unknown>"})`);break;case 1:this.logService.error("CodeWindow: detected unresponsive");break;case 3:this.logService.error(`CodeWindow: failed to load workbench window: ${typeof X=="string"?X:X==null?void 0:X.reason}`);break}if(this.isExtensionDevelopmentTestFromCli){this.lifecycleMainService.kill(1);return}if(this.telemetryService.publicLog2("windowerror",{type:j,reason:typeof X!="string"?X==null?void 0:X.reason:void 0}),j===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this._win&&this._win.webContents&&this._win.webContents.isDevToolsOpened())return;const V=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,r.mnemonicButtonLabel)((0,L.localize)(0,null)),(0,r.mnemonicButtonLabel)((0,L.localize)(1,null)),(0,r.mnemonicButtonLabel)((0,L.localize)(2,null))],message:(0,L.localize)(3,null),detail:(0,L.localize)(4,null),noLink:!0},this._win);if(!this._win)return;V.response===0?(this._win.webContents.forcefullyCrashRenderer(),this.reload()):V.response===2&&this.destroyWindow()}else if(j===2){let V;typeof X=="string"||!X?V=(0,L.localize)(5,null):V=(0,L.localize)(6,null,X.reason);const N=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,r.mnemonicButtonLabel)((0,L.localize)(7,null)),(0,r.mnemonicButtonLabel)((0,L.localize)(8,null))],message:V,detail:(0,L.localize)(9,null),noLink:!0},this._win);if(!this._win)return;N.response===0?this.reload():N.response===1&&this.destroyWindow()}}destroyWindow(){this._onDidDestroy.fire(),this._win.destroy()}onDidDeleteUntitledWorkspace(j){var X;((X=this.openedWorkspace)===null||X===void 0?void 0:X.id)===j.id&&this.currentConfig&&(this.currentConfig.workspace=void 0)}onConfigurationUpdated(){const j=this.getMenuBarVisibility();j!==this.currentMenuBarVisibility&&(this.currentMenuBarVisibility=j,this.setMenuBarVisibility(j));let X=(this.configurationService.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;(X==null?void 0:X.endsWith("/"))&&(X=X.substr(0,X.length-1));const B=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((X||"").indexOf("@")===-1&&(X!==this.currentHttpProxy||B!==this.currentNoProxy)){this.currentHttpProxy=X,this.currentNoProxy=B;const V=X||"",N=B?`${B},<local>`:"<local>";this.logService.trace(`Setting proxy to '${V}', bypassing '${N}'`),this._win.webContents.session.setProxy({proxyRules:V,proxyBypassRules:N,pacScript:""})}}addTabbedWindow(j){g.isMacintosh&&j.win&&this._win.addTabbedWindow(j.win)}load(j,X=Object.create(null)){this.isDocumentEdited()&&(!X.isReload||!this.backupMainService.isHotExitEnabled())&&this.setDocumentEdited(!1),X.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this._win.setTitle(this.productService.nameLong)),this.updateConfiguration(j,X),this.readyState===0?this.currentConfig=j:(this.pendingLoadConfig=j,this.readyState=2),this._win.loadURL(h.FileAccess.asBrowserUri(this.environmentMainService.sandbox?"vs/code/electron-sandbox/workbench/workbench.html":"vs/code/electron-browser/workbench/workbench.html",$).toString(!0)),!this.environmentMainService.isBuilt&&!this.environmentMainService.extensionTestsLocationURI&&(this.showTimeoutHandle=setTimeout(()=>{this._win&&!this._win.isVisible()&&!this._win.isMinimized()&&(this._win.show(),this.focus({force:!0}),this._win.webContents.openDevTools())},1e4)),this._onWillLoad.fire({workspace:j.workspace})}updateConfiguration(j,X){var B,V;const N=(V=(B=this.currentConfig)!==null&&B!==void 0?B:this.pendingLoadConfig)===null||V===void 0?void 0:V.userEnv;N&&(0,P.isLaunchedFromCli)(N)&&!(0,P.isLaunchedFromCli)(j.userEnv)&&(j.userEnv=Object.assign(Object.assign({},N),j.userEnv)),process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(j.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),X.disableExtensions!==void 0&&(j["disable-extensions"]=X.disableExtensions),j.fullscreen=this.isFullScreen,j.maximized=this._win.isMaximized(),j.partsSplash=this.themeMainService.getWindowSplash(),(0,A.mark)("code/willOpenNewWindow"),j.perfMarks=(0,A.getMarks)(),this.configObjectUrl.update(j)}async reload(j){const X=Object.assign({},this.currentConfig);X.workspace=await this.validateWorkspace(X),delete X.filesToOpenOrCreate,delete X.filesToDiff,delete X.filesToWait,this.isExtensionDevelopmentHost&&j&&(X.verbose=j.verbose,X.debugId=j.debugId,X["inspect-extensions"]=j["inspect-extensions"],X["inspect-brk-extensions"]=j["inspect-brk-extensions"],X["extensions-dir"]=j["extensions-dir"]),X.isInitialStartup=!1,this.load(X,{isReload:!0,disableExtensions:j==null?void 0:j["disable-extensions"]})}async validateWorkspace(j){if((0,D.isWorkspaceIdentifier)(j.workspace)){const X=j.workspace.configPath;if(X.scheme===h.Schemas.file&&!await this.fileService.exists(X))return}else if((0,D.isSingleFolderWorkspaceIdentifier)(j.workspace)){const X=j.workspace.uri;if(X.scheme===h.Schemas.file&&!await this.fileService.exists(X))return}return j.workspace}serializeWindowState(){if(!this._win)return(0,v.defaultWindowState)();if(this.isFullScreen){let B;try{B=n.screen.getDisplayMatching(this.getBounds())}catch(C){}const V=(0,v.defaultWindowState)();return{mode:3,display:B?B.id:void 0,width:this.windowState.width||V.width,height:this.windowState.height||V.height,x:this.windowState.x||0,y:this.windowState.y||0}}const j=Object.create(null);let X;if(!g.isMacintosh&&this._win.isMaximized()?X=0:X=1,X===0?j.mode=0:j.mode=1,X===1||X===0){let B;X===1?B=this.getBounds():B=this._win.getNormalBounds(),j.x=B.x,j.y=B.y,j.width=B.width,j.height=B.height}return j}restoreWindowState(j){(0,A.mark)("code/willRestoreCodeWindowState");let X=!1;if(j)try{const B=n.screen.getAllDisplays();X=B.length>1,j=this.validateWindowState(j,B)}catch(B){this.logService.warn(`Unexpected error validating window state: ${B}
${B.stack}`)}return(0,A.mark)("code/didRestoreCodeWindowState"),[j||(0,v.defaultWindowState)(),X]}validateWindowState(j,X){var B,V;if(this.logService.trace(`window#validateWindowState: validating window state on ${X.length} display(s)`,j),typeof j.x!="number"||typeof j.y!="number"||typeof j.width!="number"||typeof j.height!="number"){this.logService.trace("window#validateWindowState: unexpected type of state values");return}if(j.width<=0||j.height<=0){this.logService.trace("window#validateWindowState: unexpected negative values");return}if(X.length===1){const z=this.getWorkingArea(X[0]);if(z){let F=function(){!j||typeof j.x!="number"||typeof j.y!="number"||!z||(j.x<z.x&&(j.x=z.x),j.y<z.y&&(j.y=z.y))};this.logService.trace("window#validateWindowState: 1 monitor working area",z),F(),j.width>z.width&&(j.width=z.width),j.height>z.height&&(j.height=z.height),j.x>z.x+z.width-128&&(j.x=z.x+z.width-j.width),j.y>z.y+z.height-128&&(j.y=z.y+z.height-j.height),F()}return j}if(j.display&&j.mode===3){const z=X.find(F=>F.id===j.display);if(z&&typeof((B=z.bounds)===null||B===void 0?void 0:B.x)=="number"&&typeof((V=z.bounds)===null||V===void 0?void 0:V.y)=="number"){this.logService.trace("window#validateWindowState: restoring fullscreen to previous display");const F=(0,v.defaultWindowState)(3);return F.x=z.bounds.x,F.y=z.bounds.y,F}}let N,C;try{N=n.screen.getDisplayMatching({x:j.x,y:j.y,width:j.width,height:j.height}),C=this.getWorkingArea(N)}catch(z){}if(N&&C&&j.x+j.width>C.x&&j.y+j.height>C.y&&j.x<C.x+C.width&&j.y<C.y+C.height)return this.logService.trace("window#validateWindowState: multi-monitor working area",C),j}getWorkingArea(j){if(j.workArea.width>0&&j.workArea.height>0)return j.workArea;if(j.bounds.width>0&&j.bounds.height>0)return j.bounds}getBounds(){const[j,X]=this._win.getPosition(),[B,V]=this._win.getSize();return{x:j,y:X,width:B,height:V}}toggleFullScreen(){this.setFullScreen(!this.isFullScreen)}setFullScreen(j){this.useNativeFullScreen()?this.setNativeFullScreen(j):this.setSimpleFullScreen(j),this.sendWhenReady(j?"vscode:enterFullScreen":"vscode:leaveFullScreen",T.CancellationToken.None),this.currentMenuBarVisibility&&this.setMenuBarVisibility(this.currentMenuBarVisibility,!1)}get isFullScreen(){return this._win.isFullScreen()||this._win.isSimpleFullScreen()}setNativeFullScreen(j){this._win.isSimpleFullScreen()&&this._win.setSimpleFullScreen(!1),this._win.setFullScreen(j)}setSimpleFullScreen(j){this._win.isFullScreen()&&this._win.setFullScreen(!1),this._win.setSimpleFullScreen(j),this._win.webContents.focus()}useNativeFullScreen(){const j=this.configurationService.getValue("window");return!j||typeof j.nativeFullScreen!="boolean"||j.nativeTabs?!0:j.nativeFullScreen!==!1}isMinimized(){return this._win.isMinimized()}getMenuBarVisibility(){let j=(0,M.getMenuBarVisibility)(this.configurationService);return["visible","toggle","hidden"].indexOf(j)<0&&(j="classic"),j}setMenuBarVisibility(j,X=!0){g.isMacintosh||(j==="toggle"&&X&&this.send("vscode:showInfoMessage",(0,L.localize)(10,null)),j==="hidden"?setTimeout(()=>{this.doSetMenuBarVisibility(j)}):this.doSetMenuBarVisibility(j))}doSetMenuBarVisibility(j){const X=this.isFullScreen;switch(j){case"classic":this._win.setMenuBarVisibility(!X),this._win.autoHideMenuBar=X;break;case"visible":this._win.setMenuBarVisibility(!0),this._win.autoHideMenuBar=!1;break;case"toggle":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!0;break;case"hidden":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!1;break}}handleTitleDoubleClick(){if(g.isMacintosh)switch(n.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this._win.minimize();break;case"None":break;case"Maximize":default:this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}else this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}close(){this._win&&this._win.close()}sendWhenReady(j,X,...B){this.isReady?this.send(j,...B):this.ready().then(()=>{X.isCancellationRequested||this.send(j,...B)})}send(j,...X){if(this._win){if(this._win.isDestroyed()||this._win.webContents.isDestroyed()){this.logService.warn(`Sending IPC message to channel ${j} for window that is destroyed`);return}this._win.webContents.send(j,...X)}}updateTouchBar(j){!g.isMacintosh||this.touchBarGroups.forEach((X,B)=>{const V=j[B];X.segments=this.createTouchBarGroupSegments(V)})}createTouchBar(){if(!!g.isMacintosh){for(let j=0;j<10;j++){const X=this.createTouchBarGroup();this.touchBarGroups.push(X)}this._win.setTouchBar(new n.TouchBar({items:this.touchBarGroups}))}}createTouchBarGroup(j=[]){const X=this.createTouchBarGroupSegments(j),B=new n.TouchBar.TouchBarSegmentedControl({segments:X,mode:"buttons",segmentStyle:"automatic",change:V=>{this.sendWhenReady("vscode:runAction",T.CancellationToken.None,{id:B.segments[V].id,from:"touchbar"})}});return B}createTouchBarGroupSegments(j=[]){return j.map(B=>{var V,N;let C;B.icon&&!s.ThemeIcon.isThemeIcon(B.icon)&&((N=(V=B.icon)===null||V===void 0?void 0:V.dark)===null||N===void 0?void 0:N.scheme)===h.Schemas.file&&(C=n.nativeImage.createFromPath(E.URI.revive(B.icon.dark).fsPath),C.isEmpty()&&(C=void 0));let z;return typeof B.title=="string"?z=B.title:z=B.title.value,{id:B.id,label:C?void 0:z,icon:C}})}dispose(){super.dispose(),this.showTimeoutHandle&&clearTimeout(this.showTimeoutHandle),this._win=null}};Q=he([te(1,y.ILogService),te(2,w.IEnvironmentMainService),te(3,f.IFileService),te(4,d.IStorageMainService),te(5,i.IConfigurationService),te(6,c.IThemeMainService),te(7,S.IWorkspacesManagementMainService),te(8,a.IBackupMainService),te(9,l.ITelemetryService),te(10,t.IDialogMainService),te(11,o.ILifecycleMainService),te(12,I.IProductService),te(13,U.IProtocolMainService)],Q),e.CodeWindow=Q}),define(J[62],Z([0,1,152,35,38,14,6,39,5,3,28,52,9,15,7,10,16,18,4,2]),function($,e,m,L,A,b,E,n,w,y,i,I,M,p,g,v,D,S,a,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesHistoryMainService=e.IWorkspacesHistoryMainService=void 0,e.IWorkspacesHistoryMainService=(0,a.createDecorator)("workspacesHistoryMainService");let c=class Ve extends u.Disposable{constructor(f,h,P,T){super();this.stateMainService=f,this.logService=h,this.workspacesManagementMainService=P,this.lifecycleMainService=T,this._onDidChangeRecentlyOpened=this._register(new w.Emitter),this.onDidChangeRecentlyOpened=this._onDidChangeRecentlyOpened.event,this.macOSRecentDocumentsUpdater=this._register(new M.ThrottledDelayer(800)),this.registerListeners()}registerListeners(){this.lifecycleMainService.when(3).then(()=>this.handleWindowsJumpList()),this._register(this.workspacesManagementMainService.onDidEnterWorkspace(f=>this.addRecentlyOpened([{workspace:f.workspace}])))}handleWindowsJumpList(){!y.isWindows||(this.updateWindowsJumpList(),this._register(this.onDidChangeRecentlyOpened(()=>this.updateWindowsJumpList())))}addRecentlyOpened(f){const h=[],P=[];for(let T of f)if((0,i.isRecentWorkspace)(T))!this.workspacesManagementMainService.isUntitledWorkspace(T.workspace)&&r(h,T.workspace)===-1&&h.push(T);else if((0,i.isRecentFolder)(T))s(h,T.folderUri)===-1&&h.push(T);else{const U=o(P,T.fileUri)>=0,q=T.fileUri.scheme===v.Schemas.file&&Ve.COMMON_FILES_FILTER.indexOf((0,p.basename)(T.fileUri))>=0;!U&&!q&&(P.push(T),y.isWindows&&T.fileUri.scheme===v.Schemas.file&&b.app.addRecentDocument(T.fileUri.fsPath))}this.addEntriesFromStorage(h,P),h.length>Ve.MAX_TOTAL_RECENT_ENTRIES&&(h.length=Ve.MAX_TOTAL_RECENT_ENTRIES),P.length>Ve.MAX_TOTAL_RECENT_ENTRIES&&(P.length=Ve.MAX_TOTAL_RECENT_ENTRIES),this.saveRecentlyOpened({workspaces:h,files:P}),this._onDidChangeRecentlyOpened.fire(),y.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments())}removeRecentlyOpened(f){const h=q=>{const Q=t(q);for(const x of f)if(p.extUriBiasedIgnorePathCase.isEqual(x,Q))return!1;return!0},P=this.getRecentlyOpened(),T=P.workspaces.filter(h),U=P.files.filter(h);(T.length!==P.workspaces.length||U.length!==P.files.length)&&(this.saveRecentlyOpened({files:U,workspaces:T}),this._onDidChangeRecentlyOpened.fire(),y.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments()))}async updateMacOSRecentDocuments(){if(!y.isMacintosh)return;b.app.clearRecentDocuments();const f=this.getRecentlyOpened(),h=[];let P=0;for(let U=0;U<f.workspaces.length&&P<Ve.MAX_MACOS_DOCK_RECENT_WORKSPACES;U++){const q=t(f.workspaces[U]);if(q.scheme===v.Schemas.file){const Q=(0,p.originalFSPath)(q);await(0,D.exists)(Q)&&(h.push(Q),P++)}}const T=[];for(let U=0;U<f.files.length&&P<Ve.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL;U++){const q=t(f.files[U]);if(q.scheme===v.Schemas.file){const Q=(0,p.originalFSPath)(q);if(Ve.COMMON_FILES_FILTER.includes((0,p.basename)(q))||h.includes(Q))continue;await(0,D.exists)(Q)&&(T.push(Q),P++)}}T.reverse().forEach(U=>b.app.addRecentDocument(U)),h.reverse().forEach(U=>b.app.addRecentDocument(U))}clearRecentlyOpened(){this.saveRecentlyOpened({workspaces:[],files:[]}),b.app.clearRecentDocuments(),this._onDidChangeRecentlyOpened.fire()}getRecentlyOpened(f){var h,P;const T=[],U=[],q=(h=f==null?void 0:f.config)===null||h===void 0?void 0:h.workspace;(0,i.isWorkspaceIdentifier)(q)&&!this.workspacesManagementMainService.isUntitledWorkspace(q)?T.push({workspace:q}):(0,i.isSingleFolderWorkspaceIdentifier)(q)&&T.push({folderUri:q.uri});const Q=(P=f==null?void 0:f.config)===null||P===void 0?void 0:P.filesToOpenOrCreate;if(Q)for(let x of Q){const j=x.fileUri;j&&o(U,j)===-1&&U.push({fileUri:j})}return this.addEntriesFromStorage(T,U),{workspaces:T,files:U}}addEntriesFromStorage(f,h){let P=this.getRecentlyOpenedFromStorage();for(let T of P.workspaces){let U=(0,i.isRecentFolder)(T)?s(f,T.folderUri):r(f,T.workspace);U>=0?f[U].label=f[U].label||T.label:f.push(T)}for(let T of P.files){let U=o(h,T.fileUri);U>=0?h[U].label=h[U].label||T.label:h.push(T)}}getRecentlyOpenedFromStorage(){const f=this.stateMainService.getItem(Ve.recentlyOpenedStorageKey);return(0,i.restoreRecentlyOpened)(f,this.logService)}saveRecentlyOpened(f){const h=(0,i.toStoreData)(f);this.stateMainService.setItem(Ve.recentlyOpenedStorageKey,h)}updateWindowsJumpList(){if(!y.isWindows)return;const f=[];if(f.push({type:"tasks",items:[{type:"task",title:(0,m.localize)(0,null),description:(0,m.localize)(1,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),this.getRecentlyOpened().workspaces.length>0){let h=[];for(let U of b.app.getJumpListSettings().removedItems){const q=U.args;if(q){const Q=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(q);Q&&h.push(g.URI.parse(Q[2]))}}this.removeRecentlyOpened(h);let P=!1;const T=(0,L.coalesce)(this.getRecentlyOpened().workspaces.slice(0,7).map(U=>{const q=(0,i.isRecentWorkspace)(U)?U.workspace:U.folderUri,{title:Q,description:x}=this.getWindowsJumpListLabel(q,U.label);let j;return g.URI.isUri(q)?j=`--folder-uri "${q.toString()}"`:(P=!0,j=`--file-uri "${q.configPath.toString()}"`),{type:"task",title:Q.substr(0,255),description:x.substr(0,255),program:process.execPath,args:j,iconPath:"explorer.exe",iconIndex:0}}));T.length>0&&f.push({type:"custom",name:P?(0,m.localize)(2,null):(0,m.localize)(3,null),items:T})}f.push({type:"recent"});try{b.app.setJumpList(f)}catch(h){this.logService.warn("updateWindowsJumpList#setJumpList",h)}}getWindowsJumpListLabel(f,h){if(h)return{title:(0,n.splitName)(h).name,description:h};if(g.URI.isUri(f))return{title:(0,p.basename)(f),description:l(f)};if(this.workspacesManagementMainService.isUntitledWorkspace(f))return{title:(0,m.localize)(4,null),description:""};let P=(0,p.basename)(f.configPath);return P.endsWith(i.WORKSPACE_EXTENSION)&&(P=P.substr(0,P.length-i.WORKSPACE_EXTENSION.length-1)),{title:(0,m.localize)(5,null,P),description:l(f.configPath)}}};c.MAX_TOTAL_RECENT_ENTRIES=100,c.MAX_MACOS_DOCK_RECENT_WORKSPACES=7,c.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL=10,c.COMMON_FILES_FILTER=["COMMIT_EDITMSG","MERGE_MSG"],c.recentlyOpenedStorageKey="openedPathsList",c=he([te(0,A.IStateMainService),te(1,E.ILogService),te(2,I.IWorkspacesManagementMainService),te(3,S.ILifecycleMainService)],c),e.WorkspacesHistoryMainService=c;function l(d){return d.scheme==="file"?(0,n.normalizeDriveLetter)(d.fsPath):d.toString()}function t(d){return(0,i.isRecentFolder)(d)?d.folderUri:(0,i.isRecentFile)(d)?d.fileUri:d.workspace.configPath}function r(d,f){return d.findIndex(h=>(0,i.isRecentWorkspace)(h)&&h.workspace.id===f.id)}function s(d,f){return d.findIndex(h=>(0,i.isRecentFolder)(h)&&p.extUriBiasedIgnorePathCase.isEqual(h.folderUri,f))}function o(d,f){return d.findIndex(h=>p.extUriBiasedIgnorePathCase.isEqual(h.fileUri,f))}}),define(J[232],Z([0,1,144,3,24,14,61,17,31,41,22,9,6,39,34,62,180,7,38,18,45,25]),function($,e,m,L,A,b,E,n,w,y,i,I,M,p,g,v,D,S,a,u,c,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Menubar=void 0;const t="menu";let r=class pt{constructor(d,f,h,P,T,U,q,Q,x,j,X){this.updateService=d,this.configurationService=f,this.windowsMainService=h,this.environmentMainService=P,this.telemetryService=T,this.workspacesHistoryMainService=U,this.stateMainService=q,this.lifecycleMainService=Q,this.logService=x,this.nativeHostMainService=j,this.productService=X,this.fallbackMenuHandlers=Object.create(null),this.menuUpdater=new I.RunOnceScheduler(()=>this.doUpdateMenu(),0),this.menuGC=new I.RunOnceScheduler(()=>{this.oldMenus=[]},1e4),this.menubarMenus=Object.create(null),this.keybindings=Object.create(null),(L.isMacintosh||(0,E.getTitleBarStyle)(this.configurationService)==="native")&&this.restoreCachedMenubarData(),this.addFallbackHandlers(),this.closedLastWindow=!1,this.noActiveWindow=!1,this.oldMenus=[],this.install(),this.registerListeners()}restoreCachedMenubarData(){const d=this.stateMainService.getItem(pt.lastKnownMenubarStorageKey);d&&(d.menus&&(this.menubarMenus=d.menus),d.keybindings&&(this.keybindings=d.keybindings))}addFallbackHandlers(){this.fallbackMenuHandlers["workbench.action.files.newUntitledFile"]=(U,q,Q)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:q==null?void 0:q.id}),this.fallbackMenuHandlers["workbench.action.newWindow"]=(U,q,Q)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:q==null?void 0:q.id}),this.fallbackMenuHandlers["workbench.action.files.openFileFolder"]=(U,q,Q)=>this.nativeHostMainService.pickFileFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(Q),telemetryExtraData:{from:t}}),this.fallbackMenuHandlers["workbench.action.openWorkspace"]=(U,q,Q)=>this.nativeHostMainService.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.isOptionClick(Q),telemetryExtraData:{from:t}}),this.fallbackMenuHandlers["workbench.action.clearRecentFiles"]=()=>this.workspacesHistoryMainService.clearRecentlyOpened();const d=this.productService.twitterUrl;d&&(this.fallbackMenuHandlers["workbench.action.openTwitterUrl"]=()=>this.openUrl(d,"openTwitterUrl"));const f=this.productService.requestFeatureUrl;f&&(this.fallbackMenuHandlers["workbench.action.openRequestFeatureUrl"]=()=>this.openUrl(f,"openUserVoiceUrl"));const h=this.productService.reportIssueUrl;h&&(this.fallbackMenuHandlers["workbench.action.openIssueReporter"]=()=>this.openUrl(h,"openReportIssues"));const P=this.productService.licenseUrl;P&&(this.fallbackMenuHandlers["workbench.action.openLicenseUrl"]=()=>{if(L.language){const U=P.indexOf("?")>0?"&":"?";this.openUrl(`${P}${U}lang=${L.language}`,"openLicenseUrl")}else this.openUrl(P,"openLicenseUrl")});const T=this.productService.privacyStatementUrl;T&&P&&(this.fallbackMenuHandlers["workbench.action.openPrivacyStatementUrl"]=()=>{if(L.language){const U=P.indexOf("?")>0?"&":"?";this.openUrl(`${T}${U}lang=${L.language}`,"openPrivacyStatement")}else this.openUrl(T,"openPrivacyStatement")})}registerListeners(){this.lifecycleMainService.onWillShutdown(()=>this.willShutdown=!0),this.windowsMainService.onDidChangeWindowsCount(d=>this.onDidChangeWindowsCount(d)),this.nativeHostMainService.onDidBlurWindow(()=>this.onDidChangeWindowFocus()),this.nativeHostMainService.onDidFocusWindow(()=>this.onDidChangeWindowFocus())}get currentEnableMenuBarMnemonics(){let d=this.configurationService.getValue("window.enableMenuBarMnemonics");return typeof d!="boolean"&&(d=!0),d}get currentEnableNativeTabs(){if(!L.isMacintosh)return!1;let d=this.configurationService.getValue("window.nativeTabs");return typeof d!="boolean"&&(d=!1),d}updateMenu(d,f){this.menubarMenus=d.menus,this.keybindings=d.keybindings,this.stateMainService.setItem(pt.lastKnownMenubarStorageKey,d),this.scheduleUpdateMenu()}scheduleUpdateMenu(){this.menuUpdater.schedule()}doUpdateMenu(){this.willShutdown||setTimeout(()=>{this.willShutdown||this.install()},10)}onDidChangeWindowsCount(d){!L.isMacintosh||(d.oldCount===0&&d.newCount>0||d.oldCount>0&&d.newCount===0)&&(this.closedLastWindow=d.newCount===0,this.scheduleUpdateMenu())}onDidChangeWindowFocus(){!L.isMacintosh||(this.noActiveWindow=!b.BrowserWindow.getFocusedWindow(),this.scheduleUpdateMenu())}install(){const d=b.Menu.getApplicationMenu();if(d&&this.oldMenus.push(d),Object.keys(this.menubarMenus).length===0){b.Menu.setApplicationMenu(L.isMacintosh?new b.Menu:null);return}const f=new b.Menu;let h;if(L.isMacintosh){const O=new b.Menu;h=new b.MenuItem({label:this.productService.nameShort,submenu:O}),this.setMacApplicationMenu(O),f.append(h)}if(L.isMacintosh&&!this.appMenuInstalled){this.appMenuInstalled=!0;const O=new b.Menu;O.append(new b.MenuItem({label:this.mnemonicLabel(m.localize(0,null)),click:()=>this.windowsMainService.openEmptyWindow({context:1})})),b.app.dock.setMenu(O)}const P=new b.Menu,T=new b.MenuItem({label:this.mnemonicLabel(m.localize(1,null)),submenu:P});this.setMenuById(P,"File"),f.append(T);const U=new b.Menu,q=new b.MenuItem({label:this.mnemonicLabel(m.localize(2,null)),submenu:U});this.setMenuById(U,"Edit"),f.append(q);const Q=new b.Menu,x=new b.MenuItem({label:this.mnemonicLabel(m.localize(3,null)),submenu:Q});this.setMenuById(Q,"Selection"),f.append(x);const j=new b.Menu,X=new b.MenuItem({label:this.mnemonicLabel(m.localize(4,null)),submenu:j});this.setMenuById(j,"View"),f.append(X);const B=new b.Menu,V=new b.MenuItem({label:this.mnemonicLabel(m.localize(5,null)),submenu:B});this.setMenuById(B,"Go"),f.append(V);const N=new b.Menu,C=new b.MenuItem({label:this.mnemonicLabel(m.localize(6,null)),submenu:N});this.setMenuById(N,"Run"),f.append(C);const z=new b.Menu,F=new b.MenuItem({label:this.mnemonicLabel(m.localize(7,null)),submenu:z});this.setMenuById(z,"Terminal"),f.append(F);let R;if(this.shouldDrawMenu("Window")){const O=new b.Menu;R=new b.MenuItem({label:this.mnemonicLabel(m.localize(8,null)),submenu:O,role:"window"}),this.setMacWindowMenu(O)}R&&f.append(R);const W=new b.Menu,k=new b.MenuItem({label:this.mnemonicLabel(m.localize(9,null)),submenu:W,role:"help"});this.setMenuById(W,"Help"),f.append(k),f.items&&f.items.length>0?b.Menu.setApplicationMenu(f):b.Menu.setApplicationMenu(null),this.menuGC.schedule()}setMacApplicationMenu(d){const f=this.createMenuItem(m.localize(10,null,this.productService.nameLong),"workbench.action.showAboutDialog"),h=this.getUpdateMenuItems();let P;if(this.shouldDrawMenu("Preferences")){const B=new b.Menu;this.setMenuById(B,"Preferences"),P=new b.MenuItem({label:this.mnemonicLabel(m.localize(11,null)),submenu:B})}const T=new b.Menu,U=new b.MenuItem({label:m.localize(12,null),role:"services",submenu:T}),q=new b.MenuItem({label:m.localize(13,null,this.productService.nameLong),role:"hide",accelerator:"Command+H"}),Q=new b.MenuItem({label:m.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),x=new b.MenuItem({label:m.localize(15,null),role:"unhide"}),j=new b.MenuItem(this.likeAction("workbench.action.quit",{label:m.localize(16,null,this.productService.nameLong),click:()=>{const B=this.windowsMainService.getLastActiveWindow();(this.windowsMainService.getWindowCount()===0||!!b.BrowserWindow.getFocusedWindow()||(B==null?void 0:B.isMinimized()))&&this.nativeHostMainService.quit(void 0)}})),X=[f];X.push(...h),P&&X.push(s(),P),X.push(s(),U,s(),q,Q,x,s(),j),X.forEach(B=>d.append(B))}shouldDrawMenu(d){if(!L.isMacintosh&&(0,E.getTitleBarStyle)(this.configurationService)==="custom")return!1;switch(d){case"File":case"Help":if(L.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus&&!!this.menubarMenus[d];case"Window":if(L.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus;default:return this.windowsMainService.getWindowCount()>0&&!!this.menubarMenus&&!!this.menubarMenus[d]}}setMenu(d,f){f.forEach(h=>{if((0,D.isMenubarMenuItemSeparator)(h))d.append(s());else if((0,D.isMenubarMenuItemSubmenu)(h)){const P=new b.Menu,T=new b.MenuItem({label:this.mnemonicLabel(h.label),submenu:P});this.setMenu(P,h.submenu.items),d.append(T)}else(0,D.isMenubarMenuItemRecentAction)(h)?d.append(this.createOpenRecentMenuItem(h)):(0,D.isMenubarMenuItemAction)(h)&&(h.id==="workbench.action.showAboutDialog"&&this.insertCheckForUpdatesItems(d),L.isMacintosh?this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow?this.fallbackMenuHandlers[h.id]?d.append(new b.MenuItem(this.likeAction(h.id,{label:this.mnemonicLabel(h.label),click:this.fallbackMenuHandlers[h.id]}))):d.append(this.createMenuItem(h.label,h.id,!1,h.checked)):d.append(this.createMenuItem(h.label,h.id,h.enabled!==!1,!!h.checked)):d.append(this.createMenuItem(h.label,h.id,h.enabled!==!1,!!h.checked)))})}setMenuById(d,f){this.menubarMenus&&this.menubarMenus[f]&&this.setMenu(d,this.menubarMenus[f].items)}insertCheckForUpdatesItems(d){const f=this.getUpdateMenuItems();f.length&&(f.forEach(h=>d.append(h)),d.append(s()))}createOpenRecentMenuItem(d){const f=S.URI.revive(d.uri),h=d.id,P=h==="openRecentFile"?{fileUri:f}:h==="openRecentWorkspace"?{workspaceUri:f}:{folderUri:f};return new b.MenuItem(this.likeAction(h,{label:d.label,click:(T,U,q)=>{const Q=this.isOptionClick(q);this.windowsMainService.open({context:2,cli:this.environmentMainService.args,urisToOpen:[P],forceNewWindow:Q,gotoLineMode:!1,remoteAuthority:d.remoteAuthority}).length>0||this.workspacesHistoryMainService.removeRecentlyOpened([f])}},!1))}isOptionClick(d){return!!(d&&(!L.isMacintosh&&(d.ctrlKey||d.shiftKey)||L.isMacintosh&&(d.metaKey||d.altKey)))}createRoleMenuItem(d,f,h){const P={label:this.mnemonicLabel(d),role:h,enabled:!0};return new b.MenuItem(this.withKeybinding(f,P))}setMacWindowMenu(d){const f=new b.MenuItem({label:m.localize(17,null),role:"minimize",accelerator:"Command+M",enabled:this.windowsMainService.getWindowCount()>0}),h=new b.MenuItem({label:m.localize(18,null),role:"zoom",enabled:this.windowsMainService.getWindowCount()>0}),P=new b.MenuItem({label:m.localize(19,null),role:"front",enabled:this.windowsMainService.getWindowCount()>0}),T=this.createMenuItem(m.localize(20,null),"workbench.action.switchWindow"),U=[];this.currentEnableNativeTabs&&(U.push(s()),U.push(this.createMenuItem(m.localize(21,null),"workbench.action.newWindowTab")),U.push(this.createRoleMenuItem(m.localize(22,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),U.push(this.createRoleMenuItem(m.localize(23,null),"workbench.action.showNextWindowTab","selectNextTab")),U.push(this.createRoleMenuItem(m.localize(24,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),U.push(this.createRoleMenuItem(m.localize(25,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[f,h,s(),T,...U,s(),P].forEach(q=>d.append(q))}getUpdateMenuItems(){switch(this.updateService.state.type){case"uninitialized":return[];case"idle":return[new b.MenuItem({label:this.mnemonicLabel(m.localize(26,null)),click:()=>setTimeout(()=>{this.reportMenuActionTelemetry("CheckForUpdate"),this.updateService.checkForUpdates(!0)},0)})];case"checking for updates":return[new b.MenuItem({label:m.localize(27,null),enabled:!1})];case"available for download":return[new b.MenuItem({label:this.mnemonicLabel(m.localize(28,null)),click:()=>{this.updateService.downloadUpdate()}})];case"downloading":return[new b.MenuItem({label:m.localize(29,null),enabled:!1})];case"downloaded":return[new b.MenuItem({label:this.mnemonicLabel(m.localize(30,null)),click:()=>{this.reportMenuActionTelemetry("InstallUpdate"),this.updateService.applyUpdate()}})];case"updating":return[new b.MenuItem({label:m.localize(31,null),enabled:!1})];case"ready":return[new b.MenuItem({label:this.mnemonicLabel(m.localize(32,null)),click:()=>{this.reportMenuActionTelemetry("RestartToUpdate"),this.updateService.quitAndInstall()}})]}}createMenuItem(d,f,h,P){const T=this.mnemonicLabel(d),U=typeof f=="function"?f:(X,B,V)=>{const N=X?X.userSettingsLabel:null;let C=f;Array.isArray(f)&&(C=this.isOptionClick(V)?f[1]:f[0]),N&&V.triggeredByAccelerator?this.runActionInRenderer({type:"keybinding",userSettingsLabel:N}):this.runActionInRenderer({type:"commandId",commandId:C})},q=typeof h=="boolean"?h:this.windowsMainService.getWindowCount()>0,Q=typeof P=="boolean"?P:!1,x={label:T,click:U,enabled:q};Q&&(x.type="checkbox",x.checked=Q);let j;return typeof f=="string"?j=f:Array.isArray(f)&&(j=f[0]),L.isMacintosh&&(j==="editor.action.clipboardCutAction"?x.role="cut":j==="editor.action.clipboardCopyAction"?x.role="copy":j==="editor.action.clipboardPasteAction"&&(x.role="paste"),j==="undo"?x.click=this.makeContextAwareClickHandler(U,{inDevTools:X=>X.undo(),inNoWindow:()=>b.Menu.sendActionToFirstResponder("undo:")}):j==="redo"?x.click=this.makeContextAwareClickHandler(U,{inDevTools:X=>X.redo(),inNoWindow:()=>b.Menu.sendActionToFirstResponder("redo:")}):j==="editor.action.selectAll"&&(x.click=this.makeContextAwareClickHandler(U,{inDevTools:X=>X.selectAll(),inNoWindow:()=>b.Menu.sendActionToFirstResponder("selectAll:")}))),new b.MenuItem(this.withKeybinding(j,x))}makeContextAwareClickHandler(d,f){return(h,P,T)=>{const U=b.BrowserWindow.getFocusedWindow();if(!U)return f.inNoWindow();if(U.webContents.isDevToolsFocused()&&U.webContents.devToolsWebContents)return f.inDevTools(U.webContents.devToolsWebContents);d(h,P||U,T)}}runActionInRenderer(d){let f=b.BrowserWindow.getFocusedWindow();if(!f){const P=this.windowsMainService.getLastActiveWindow();(P==null?void 0:P.isMinimized())&&(f=P.win)}const h=f?this.windowsMainService.getWindowById(f.id):void 0;if(h){if(this.logService.trace("menubar#runActionInRenderer",d),L.isMacintosh&&!this.environmentMainService.isBuilt&&!h.isReady&&(d.type==="commandId"&&d.commandId==="workbench.action.toggleDevTools"||d.type!=="commandId"&&d.userSettingsLabel==="alt+cmd+i"))return;if(d.type==="commandId"){const P={id:d.commandId,from:"menu"};h.sendWhenReady("vscode:runAction",l.CancellationToken.None,P)}else{const P={userSettingsLabel:d.userSettingsLabel};h.sendWhenReady("vscode:runKeybinding",l.CancellationToken.None,P)}}else this.logService.trace("menubar#runActionInRenderer: no active window found",d)}withKeybinding(d,f){const h=typeof d=="string"?this.keybindings[d]:void 0;if(h==null?void 0:h.label){if(h.isNative!==!1)f.accelerator=h.label,f.userSettingsLabel=h.userSettingsLabel;else if(typeof f.label=="string"){const P=f.label.indexOf("[");P>=0?f.label=`${f.label.substr(0,P)} [${h.label}]`:f.label=`${f.label} [${h.label}]`}}else f.accelerator=void 0;return f}likeAction(d,f,h=!f.accelerator){h&&(f=this.withKeybinding(d,f));const P=f.click;return f.click=(T,U,q)=>{this.reportMenuActionTelemetry(d),P&&P(T,U,q)},f}openUrl(d,f){this.nativeHostMainService.openExternal(void 0,d),this.reportMenuActionTelemetry(f)}reportMenuActionTelemetry(d){this.telemetryService.publicLog2("workbenchActionExecuted",{id:d,from:t})}mnemonicLabel(d){return(0,p.mnemonicMenuLabel)(d,!this.currentEnableMenuBarMnemonics)}};r.lastKnownMenubarStorageKey="lastKnownMenubarData",r=he([te(0,y.IUpdateService),te(1,n.IConfigurationService),te(2,g.IWindowsMainService),te(3,A.IEnvironmentMainService),te(4,w.ITelemetryService),te(5,v.IWorkspacesHistoryMainService),te(6,a.IStateMainService),te(7,u.ILifecycleMainService),te(8,M.ILogService),te(9,c.INativeHostMainService),te(10,i.IProductService)],r),e.Menubar=r;function s(){return new b.MenuItem({type:"separator"})}}),define(J[233],Z([0,1,232,6,4,18]),function($,e,m,L,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MenubarMainService=e.IMenubarMainService=void 0,e.IMenubarMainService=(0,A.createDecorator)("menubarMainService");let E=class{constructor(w,y,i){this.instantiationService=w,this.lifecycleMainService=y,this.logService=i,this.menubar=this.installMenuBarAfterWindowOpen()}async installMenuBarAfterWindowOpen(){return await this.lifecycleMainService.when(3),this.instantiationService.createInstance(m.Menubar)}async updateMenubar(w,y){this.logService.trace("menubarService#updateMenubar",w),(await this.menubar).updateMenu(y,w)}};E=he([te(0,A.IInstantiationService),te(1,b.ILifecycleMainService),te(2,L.ILogService)],E),e.MenubarMainService=E}),define(J[234],Z([0,1,29,26,47,72,8,150,35,50,24,38,231,14,18,17,6,61,100,5,22,62,3,28,4,10,7,15,73,214,52,42,2,51,13,30,39,25,21,32,55]),function($,e,m,L,A,b,E,n,w,y,i,I,M,p,g,v,D,S,a,u,c,l,t,r,s,o,d,f,h,P,T,U,q,Q,x,j,X,B,V,N,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsMainService=void 0;function z(W){return(0,r.isWorkspaceIdentifier)(W==null?void 0:W.workspace)}function F(W){return(0,r.isSingleFolderWorkspaceIdentifier)(W==null?void 0:W.workspace)}let R=class et extends q.Disposable{constructor(k,O,_,K,G,Y,ee,ne,re,se,le,oe,ue,me,Se){super();this.machineId=k,this.initialUserEnv=O,this.logService=_,this.stateMainService=K,this.environmentMainService=G,this.lifecycleMainService=Y,this.backupMainService=ee,this.configurationService=ne,this.workspacesHistoryMainService=re,this.workspacesManagementMainService=se,this.instantiationService=le,this.dialogMainService=oe,this.fileService=ue,this.productService=me,this.protocolMainService=Se,this._onDidOpenWindow=this._register(new u.Emitter),this.onDidOpenWindow=this._onDidOpenWindow.event,this._onDidSignalReadyWindow=this._register(new u.Emitter),this.onDidSignalReadyWindow=this._onDidSignalReadyWindow.event,this._onDidDestroyWindow=this._register(new u.Emitter),this.onDidDestroyWindow=this._onDidDestroyWindow.event,this._onDidChangeWindowsCount=this._register(new u.Emitter),this.onDidChangeWindowsCount=this._onDidChangeWindowsCount.event,this.windowsStateHandler=this._register(new P.WindowsStateHandler(this,this.stateMainService,this.lifecycleMainService,this.logService,this.configurationService)),this.registerListeners()}registerListeners(){this._register(this.workspacesManagementMainService.onDidEnterWorkspace(k=>this._onDidSignalReadyWindow.fire(k.window))),this._register(this.onDidSignalReadyWindow(k=>{var O,_;if(((O=k.config)===null||O===void 0?void 0:O.extensionDevelopmentPath)||((_=k.config)===null||_===void 0?void 0:_.extensionTestsPath)){const K=new q.DisposableStore;if(K.add(u.Event.any(k.onDidClose,k.onDidDestroy)(()=>K.dispose())),k.config.extensionDevelopmentPath)for(const G of k.config.extensionDevelopmentPath)K.add(this.protocolMainService.addValidFileRoot(d.URI.file(G)));k.config.extensionTestsPath&&K.add(this.protocolMainService.addValidFileRoot(d.URI.file(k.config.extensionTestsPath)))}}))}openEmptyWindow(k,O){let _=this.environmentMainService.args;const K=(O==null?void 0:O.remoteAuthority)||void 0,G=!0,Y=O==null?void 0:O.forceReuseWindow,ee=!Y;return this.open(Object.assign(Object.assign({},k),{cli:_,forceEmpty:G,forceNewWindow:ee,forceReuseWindow:Y,remoteAuthority:K}))}open(k){this.logService.trace("windowsManager#open"),k.addMode&&(k.initialStartup||!this.getLastActiveWindow())&&(k.addMode=!1);const O=[],_=[],K=[],G=[],Y=[];let ee,ne=0;const re=this.getPathsToOpen(k);this.logService.trace("windowsManager#open pathsToOpen",re);for(const me of re)F(me)?k.addMode?O.push(me):_.push(me):z(me)?K.push(me):me.fileUri?(ee||(ee={filesToOpenOrCreate:[],filesToDiff:[],remoteAuthority:me.remoteAuthority}),ee.filesToOpenOrCreate.push(me)):me.backupPath?Y.push({backupFolder:(0,E.basename)(me.backupPath),remoteAuthority:me.remoteAuthority}):ne++;k.diffMode&&(ee==null?void 0:ee.filesToOpenOrCreate.length)===2&&(ee.filesToDiff=ee.filesToOpenOrCreate,ee.filesToOpenOrCreate=[]),ee&&k.waitMarkerFileURI&&(ee.filesToWait={paths:[...ee.filesToDiff,...ee.filesToOpenOrCreate],waitMarkerFileUri:k.waitMarkerFileURI}),k.initialStartup?(G.push(...this.workspacesManagementMainService.getUntitledWorkspacesSync()),K.push(...G),Y.push(...this.backupMainService.getEmptyWindowBackupPaths())):Y.length=0;const{windows:se,filesOpenedInWindow:le}=this.doOpen(k,K,_,Y,ne,ee,O);if(this.logService.trace(`windowsManager#open used window count ${se.length} (workspacesToOpen: ${K.length}, foldersToOpen: ${_.length}, emptyToRestore: ${Y.length}, emptyToOpen: ${ne})`),se.length>1)if(le)le.focus();else{const me=this.windowsStateHandler.state.lastActiveWindow&&!k.forceEmpty&&!k.cli._.length&&!k.cli["file-uri"]&&!k.cli["folder-uri"]&&!(k.urisToOpen&&k.urisToOpen.length);let Se=!0,Le=!0;if(me){const Ie=se.filter(we=>this.windowsStateHandler.state.lastActiveWindow&&we.backupPath===this.windowsStateHandler.state.lastActiveWindow.backupPath);Ie.length&&(Ie[0].focus(),Se=!1,Le=!1)}if(Se)for(let Ie=se.length-1;Ie>=0;Ie--){const we=se[Ie];if(!(we.openedWorkspace&&G.some(ye=>we.openedWorkspace&&ye.workspace.id===we.openedWorkspace.id)||we.backupPath&&Y.some(ye=>we.backupPath&&ye.backupFolder===(0,E.basename)(we.backupPath)))){we.focus(),Le=!1;break}}Le&&se[se.length-1].focus()}const oe=ee&&ee.filesToDiff.length>0;if(!se.some(me=>me.isExtensionDevelopmentHost)&&!oe&&!k.noRecentEntry){const me=[];for(const Se of re)z(Se)?me.push({label:Se.label,workspace:Se.workspace,remoteAuthority:Se.remoteAuthority}):F(Se)?me.push({label:Se.label,folderUri:Se.workspace.uri,remoteAuthority:Se.remoteAuthority}):Se.fileUri&&me.push({label:Se.label,fileUri:Se.fileUri,remoteAuthority:Se.remoteAuthority});this.workspacesHistoryMainService.addRecentlyOpened(me)}const ue=k.waitMarkerFileURI;return k.context===0&&ue&&se.length===1&&se[0]&&(async()=>{await se[0].whenClosedOrLoaded;try{await this.fileService.del(ue)}catch(me){}})(),se}doOpen(k,O,_,K,G,Y,ee){const ne=[];let re;function se(Ie,we){ne.push(Ie),we&&(re=Ie,Y=void 0)}let{openFolderInNewWindow:le,openFilesInNewWindow:oe}=this.shouldOpenNewWindow(k);if(!k.initialStartup&&ee.length>0){const Ie=ee[0].remoteAuthority,we=this.getLastActiveWindowForAuthority(Ie);we&&se(this.doAddFoldersToExistingWindow(we,ee.map(ye=>ye.workspace.uri)))}const ue=_.length+O.length+K.length;if(Y&&ue===0){const Ie=Y.filesToOpenOrCreate[0]||Y.filesToDiff[0],we=this.getWindows().filter(Re=>Y&&Re.remoteAuthority===Y.remoteAuthority);let ye;(Ie==null?void 0:Ie.fileUri)&&!oe&&((k.context===4||k.context===0||k.context===1)&&(ye=(0,a.findWindowOnFile)(we,Ie.fileUri,Re=>Re.configPath.scheme===o.Schemas.file?this.workspacesManagementMainService.resolveLocalWorkspaceSync(Re.configPath):void 0)),ye||(ye=this.doGetLastActiveWindow(we))),ye?(0,r.isWorkspaceIdentifier)(ye.openedWorkspace)?O.push({workspace:ye.openedWorkspace,remoteAuthority:ye.remoteAuthority}):(0,r.isSingleFolderWorkspaceIdentifier)(ye.openedWorkspace)?_.push({workspace:ye.openedWorkspace,remoteAuthority:ye.remoteAuthority}):se(this.doOpenFilesInExistingWindow(k,ye,Y),!0):se(this.openInBrowserWindow({userEnv:k.userEnv,cli:k.cli,initialStartup:k.initialStartup,filesToOpen:Y,forceNewWindow:!0,remoteAuthority:Y.remoteAuthority,forceNewTabbedWindow:k.forceNewTabbedWindow}),!0)}const me=(0,w.distinct)(O,Ie=>Ie.workspace.id);if(me.length>0){const Ie=(0,w.coalesce)(me.map(we=>(0,a.findWindowOnWorkspaceOrFolder)(this.getWindows(),we.workspace.configPath)));if(Ie.length>0){const we=Ie[0],ye=(Y==null?void 0:Y.remoteAuthority)===we.remoteAuthority?Y:void 0;se(this.doOpenFilesInExistingWindow(k,we,ye),!!ye),le=!0}me.forEach(we=>{if(Ie.some(Te=>Te.openedWorkspace&&Te.openedWorkspace.id===we.workspace.id))return;const ye=we.remoteAuthority,Re=(Y==null?void 0:Y.remoteAuthority)===ye?Y:void 0;se(this.doOpenFolderOrWorkspace(k,we,le,Re),!!Re),le=!0})}const Se=(0,w.distinct)(_,Ie=>f.extUriBiasedIgnorePathCase.getComparisonKey(Ie.workspace.uri));if(Se.length>0){const Ie=(0,w.coalesce)(Se.map(we=>(0,a.findWindowOnWorkspaceOrFolder)(this.getWindows(),we.workspace.uri)));if(Ie.length>0){const we=Ie[0],ye=(Y==null?void 0:Y.remoteAuthority)===we.remoteAuthority?Y:void 0;se(this.doOpenFilesInExistingWindow(k,we,ye),!!ye),le=!0}Se.forEach(we=>{if(Ie.some(Te=>(0,r.isSingleFolderWorkspaceIdentifier)(Te.openedWorkspace)&&f.extUriBiasedIgnorePathCase.isEqual(Te.openedWorkspace.uri,we.workspace.uri)))return;const ye=we.remoteAuthority,Re=(Y==null?void 0:Y.remoteAuthority)===ye?Y:void 0;se(this.doOpenFolderOrWorkspace(k,we,le,Re),!!Re),le=!0})}const Le=(0,w.distinct)(K,Ie=>Ie.backupFolder);if(Le.length>0&&Le.forEach(Ie=>{const we=Ie.remoteAuthority,ye=(Y==null?void 0:Y.remoteAuthority)===we?Y:void 0;se(this.openInBrowserWindow({userEnv:k.userEnv,cli:k.cli,initialStartup:k.initialStartup,filesToOpen:ye,remoteAuthority:we,forceNewWindow:!0,forceNewTabbedWindow:k.forceNewTabbedWindow,emptyWindowBackupInfo:Ie}),!!ye),le=!0}),ne.length===0||Y){Y&&!G&&G++;const Ie=Y?Y.remoteAuthority:k.remoteAuthority;for(let we=0;we<G;we++)se(this.doOpenEmpty(k,le,Ie,Y),!!Y),le=!0}return{windows:(0,w.distinct)(ne),filesOpenedInWindow:re}}doOpenFilesInExistingWindow(k,O,_){var K;this.logService.trace("windowsManager#doOpenFilesInExistingWindow"),O.focus();const G={filesToOpenOrCreate:_==null?void 0:_.filesToOpenOrCreate,filesToDiff:_==null?void 0:_.filesToDiff,filesToWait:_==null?void 0:_.filesToWait,termProgram:(K=k==null?void 0:k.userEnv)===null||K===void 0?void 0:K.TERM_PROGRAM};return O.sendWhenReady("vscode:openFiles",B.CancellationToken.None,G),O}doAddFoldersToExistingWindow(k,O){this.logService.trace("windowsManager#doAddFoldersToExistingWindow"),k.focus();const _={foldersToAdd:O};return k.sendWhenReady("vscode:addFolders",B.CancellationToken.None,_),k}doOpenEmpty(k,O,_,K,G){return!O&&!G&&typeof k.contextWindowId=="number"&&(G=this.getWindowById(k.contextWindowId)),this.openInBrowserWindow({userEnv:k.userEnv,cli:k.cli,initialStartup:k.initialStartup,remoteAuthority:_,forceNewWindow:O,forceNewTabbedWindow:k.forceNewTabbedWindow,filesToOpen:K,windowToUse:G})}doOpenFolderOrWorkspace(k,O,_,K,G){return!_&&!G&&typeof k.contextWindowId=="number"&&(G=this.getWindowById(k.contextWindowId)),this.openInBrowserWindow({workspace:O.workspace,userEnv:k.userEnv,cli:k.cli,initialStartup:k.initialStartup,remoteAuthority:O.remoteAuthority,forceNewWindow:_,forceNewTabbedWindow:k.forceNewTabbedWindow,filesToOpen:K,windowToUse:G})}getPathsToOpen(k){var O;let _,K=!1,G=!1;if(k.urisToOpen&&k.urisToOpen.length>0?(_=this.doExtractPathsFromAPI(k),K=!0):k.forceEmpty?_=[Object.create(null)]:k.cli._.length||k.cli["folder-uri"]||k.cli["file-uri"]?(_=this.doExtractPathsFromCLI(k.cli),_.length===0&&_.push(Object.create(null)),K=!0):(_=this.doGetPathsFromLastSession(),_.length===0&&_.push(Object.create(null)),G=!0),!k.addMode&&K){const Y=_.filter(ee=>F(ee));if(Y.length>1){const ee=Y[0].remoteAuthority;if(Y.every(ne=>ne.remoteAuthority===ee)){const ne=this.workspacesManagementMainService.createUntitledWorkspaceSync(Y.map(re=>({uri:re.workspace.uri})));_.push({workspace:ne,remoteAuthority:ee}),_=_.filter(re=>!F(re))}}}return k.initialStartup&&!G&&((O=this.configurationService.getValue("window"))===null||O===void 0?void 0:O.restoreWindows)==="preserve"&&_.unshift(...this.doGetPathsFromLastSession().filter(Y=>z(Y)||F(Y)||Y.backupPath)),_}doExtractPathsFromAPI(k){const O=[],_={gotoLineMode:k.gotoLineMode,remoteAuthority:k.remoteAuthority};for(const K of(0,w.coalesce)(k.urisToOpen||[])){const G=this.resolveOpenable(K,_);if(G)G.label=K.label,O.push(G);else{const Y=this.resourceFromOpenable(K),ee={title:this.productService.nameLong,type:"info",buttons:[(0,n.localize)(0,null)],message:Y.scheme===o.Schemas.file?(0,n.localize)(1,null):(0,n.localize)(2,null),detail:Y.scheme===o.Schemas.file?(0,n.localize)(3,null,(0,X.getPathLabel)(Y.fsPath,this.environmentMainService)):(0,n.localize)(4,null,Y.toString()),noLink:!0};this.dialogMainService.showMessageBox(ee,(0,x.withNullAsUndefined)(p.BrowserWindow.getFocusedWindow()))}}return O}doExtractPathsFromCLI(k){const O=[],_={ignoreFileNotFound:!0,gotoLineMode:k.goto,remoteAuthority:k.remote||void 0,forceOpenWorkspaceAsFile:!1},K=k["folder-uri"];if(K)for(const ee of K){const ne=this.cliArgToUri(ee);if(ne){const re=this.resolveOpenable({folderUri:ne},_);re&&O.push(re)}}const G=k["file-uri"];if(G)for(const ee of G){const ne=this.cliArgToUri(ee);if(ne){const re=this.resolveOpenable((0,r.hasWorkspaceFileExtension)(ee)?{workspaceUri:ne}:{fileUri:ne},_);re&&O.push(re)}}const Y=k._;for(const ee of Y){const ne=_.remoteAuthority?this.doResolvePathRemote(ee,_):this.doResolveFilePath(ee,_);ne&&O.push(ne)}return O}cliArgToUri(k){try{const O=d.URI.parse(k);if(!O.scheme){this.logService.error(`Invalid URI input string, scheme missing: ${k}`);return}return O}catch(O){this.logService.error(`Invalid URI input string: ${k}, ${O.message}`)}}doGetPathsFromLastSession(){const k=this.getRestoreWindowsSetting();switch(k){case"none":return[];case"one":case"all":case"preserve":case"folders":const O=[];k!=="one"&&O.push(...this.windowsStateHandler.state.openedWindows),this.windowsStateHandler.state.lastActiveWindow&&O.push(this.windowsStateHandler.state.lastActiveWindow);const _=[];for(const K of O)if(K.workspace){const G=this.resolveOpenable({workspaceUri:K.workspace.configPath},{remoteAuthority:K.remoteAuthority});z(G)&&_.push(G)}else if(K.folderUri){const G=this.resolveOpenable({folderUri:K.folderUri},{remoteAuthority:K.remoteAuthority});F(G)&&_.push(G)}else k!=="folders"&&K.backupPath&&_.push({backupPath:K.backupPath,remoteAuthority:K.remoteAuthority});return _}}getRestoreWindowsSetting(){let k;if(this.lifecycleMainService.wasRestarted)k="all";else{const O=this.configurationService.getValue("window");k=(O==null?void 0:O.restoreWindows)||"all",["preserve","all","folders","one","none"].includes(k)||(k="all")}return k}resolveOpenable(k,O={}){let _=this.resourceFromOpenable(k);return _.scheme===o.Schemas.file?((0,S.isFileToOpen)(k)&&(O=Object.assign(Object.assign({},O),{forceOpenWorkspaceAsFile:!0})),this.doResolveFilePath(_.fsPath,O)):this.doResolveRemoteOpenable(k,O)}doResolveRemoteOpenable(k,O){let _=this.resourceFromOpenable(k);const K=(0,h.getRemoteAuthority)(_)||O.remoteAuthority;if(_=(0,f.removeTrailingPathSeparator)((0,f.normalizePath)(_)),(0,S.isFileToOpen)(k)){if(O.gotoLineMode){const{path:G,line:Y,column:ee}=(0,j.parseLineAndColumnAware)(_.path);return{fileUri:_.with({path:G}),lineNumber:Y,columnNumber:ee,remoteAuthority:K}}return{fileUri:_,remoteAuthority:K}}else if((0,S.isWorkspaceToOpen)(k))return{workspace:(0,T.getWorkspaceIdentifier)(_),remoteAuthority:K};return{workspace:(0,T.getSingleFolderWorkspaceIdentifier)(_),remoteAuthority:K}}resourceFromOpenable(k){return(0,S.isWorkspaceToOpen)(k)?k.workspaceUri:(0,S.isFolderToOpen)(k)?k.folderUri:k.fileUri}doResolveFilePath(k,O){let _,K;O.gotoLineMode&&({path:k,line:_,column:K}=(0,j.parseLineAndColumnAware)(k)),k=(0,j.sanitizeFilePath)((0,E.normalize)(k),(0,N.cwd)());try{const G=(0,m.statSync)(k);if(G.isFile()){if(!O.forceOpenWorkspaceAsFile){const Y=this.workspacesManagementMainService.resolveLocalWorkspaceSync(d.URI.file(k));if(Y)return{workspace:{id:Y.id,configPath:Y.configPath},remoteAuthority:Y.remoteAuthority,exists:!0}}return{fileUri:d.URI.file(k),lineNumber:_,columnNumber:K,exists:!0}}else if(G.isDirectory())return{workspace:(0,T.getSingleFolderWorkspaceIdentifier)(d.URI.file(k),G),exists:!0}}catch(G){const Y=d.URI.file(k);if(this.workspacesHistoryMainService.removeRecentlyOpened([Y]),O.ignoreFileNotFound)return{fileUri:Y,exists:!1}}}doResolvePathRemote(k,O){const _=k.charCodeAt(0),K=O.remoteAuthority;let G,Y;O.gotoLineMode&&({path:k,line:G,column:Y}=(0,j.parseLineAndColumnAware)(k)),_!==47&&((0,j.isWindowsDriveLetter)(_)&&k.charCodeAt(k.charCodeAt(1))===58&&(k=(0,j.toSlashes)(k)),k=`/${k}`);const ee=d.URI.from({scheme:o.Schemas.vscodeRemote,authority:K,path:k});if(k.charCodeAt(k.length-1)!==47){if((0,r.hasWorkspaceFileExtension)(k))return O.forceOpenWorkspaceAsFile?{fileUri:ee,lineNumber:G,columnNumber:Y,remoteAuthority:O.remoteAuthority}:{workspace:(0,T.getWorkspaceIdentifier)(ee),remoteAuthority:K};if(O.gotoLineMode||E.posix.basename(k).indexOf(".")!==-1)return{fileUri:ee,lineNumber:G,columnNumber:Y,remoteAuthority:K}}return{workspace:(0,T.getSingleFolderWorkspaceIdentifier)(ee),remoteAuthority:K}}shouldOpenNewWindow(k){const O=this.configurationService.getValue("window"),_=(O==null?void 0:O.openFoldersInNewWindow)||"default",K=(O==null?void 0:O.openFilesInNewWindow)||"off";let G=(k.preferNewWindow||k.forceNewWindow)&&!k.forceReuseWindow;!k.forceNewWindow&&!k.forceReuseWindow&&(_==="on"||_==="off")&&(G=_==="on");let Y=!1;return k.forceNewWindow||k.forceReuseWindow?Y=!!k.forceNewWindow&&!k.forceReuseWindow:(t.isMacintosh?k.context===1&&(Y=!0):k.context!==3&&k.context!==2&&!(k.userEnv&&k.userEnv.TERM_PROGRAM==="vscode")&&(Y=!0),!k.cli.extensionDevelopmentPath&&(K==="on"||K==="off")&&(Y=K==="on")),{openFolderInNewWindow:!!G,openFilesInNewWindow:Y}}openExtensionDevelopmentHostWindow(k,O){const _=(0,a.findWindowOnExtensionDevelopmentPath)(this.getWindows(),k);if(_)return this.lifecycleMainService.reload(_,O.cli),_.focus(),[_];let K=O.cli["folder-uri"]||[],G=O.cli["file-uri"]||[],Y=O.cli._;if(!Y.length&&!K.length&&!G.length&&!O.cli.extensionTestsPath){const se=this.windowsStateHandler.state.lastPluginDevelopmentHostWindow,le=se&&(se.workspace||se.folderUri);le&&(d.URI.isUri(le)?le.scheme===o.Schemas.file?Y=[le.fsPath]:K=[le.toString()]:le.configPath.scheme===o.Schemas.file?Y=[(0,f.originalFSPath)(le.configPath)]:G=[le.configPath.toString()])}let ee=O.remoteAuthority;for(const se of k)if(se.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const le=d.URI.parse(se),oe=(0,h.getRemoteAuthority)(le);oe&&(ee?oe!==ee&&this.logService.error("more than one extension development path authority"):ee=oe)}Y=Y.filter(se=>{const le=d.URI.file(se);return(0,a.findWindowOnWorkspaceOrFolder)(this.getWindows(),le)?!1:(0,h.getRemoteAuthority)(le)===ee}),K=K.filter(se=>{const le=this.cliArgToUri(se);return le&&!!(0,a.findWindowOnWorkspaceOrFolder)(this.getWindows(),le)?!1:le?(0,h.getRemoteAuthority)(le)===ee:!1}),G=G.filter(se=>{const le=this.cliArgToUri(se);return le&&!!(0,a.findWindowOnWorkspaceOrFolder)(this.getWindows(),le)?!1:le?(0,h.getRemoteAuthority)(le)===ee:!1}),O.cli._=Y,O.cli["folder-uri"]=K,O.cli["file-uri"]=G;const ne=!Y.length&&!K.length&&!G.length,re={context:O.context,cli:O.cli,forceNewWindow:!0,forceEmpty:ne,userEnv:O.userEnv,noRecentEntry:!0,waitMarkerFileURI:O.waitMarkerFileURI,remoteAuthority:ee};return this.open(re)}openInBrowserWindow(k){var O,_,K,G,Y;const ee=this.configurationService.getValue("window"),ne=Object.assign(Object.assign(Object.assign({},this.environmentMainService.args),k.cli),{machineId:this.machineId,windowId:-1,mainPid:process.pid,appRoot:this.environmentMainService.appRoot,execPath:process.execPath,nodeCachedDataDir:this.environmentMainService.nodeCachedDataDir,backupPath:k.emptyWindowBackupInfo?(0,E.join)(this.environmentMainService.backupHome,k.emptyWindowBackupInfo.backupFolder):void 0,homeDir:this.environmentMainService.userHome.fsPath,tmpDir:this.environmentMainService.tmpDir.fsPath,userDataDir:this.environmentMainService.userDataPath,remoteAuthority:k.remoteAuthority,workspace:k.workspace,userEnv:Object.assign(Object.assign({},this.initialUserEnv),k.userEnv),filesToOpenOrCreate:(O=k.filesToOpen)===null||O===void 0?void 0:O.filesToOpenOrCreate,filesToDiff:(_=k.filesToOpen)===null||_===void 0?void 0:_.filesToDiff,filesToWait:(K=k.filesToOpen)===null||K===void 0?void 0:K.filesToWait,logLevel:this.logService.getLevel(),logsPath:this.environmentMainService.logsPath,product:A.default,isInitialStartup:k.initialStartup,perfMarks:(0,b.getMarks)(),os:{release:(0,L.release)(),hostname:(0,L.hostname)()},zoomLevel:typeof(ee==null?void 0:ee.zoomLevel)=="number"?ee.zoomLevel:void 0,autoDetectHighContrast:(G=ee==null?void 0:ee.autoDetectHighContrast)!==null&&G!==void 0?G:!0,accessibilitySupport:p.app.accessibilitySupportEnabled,colorScheme:{dark:p.nativeTheme.shouldUseDarkColors,highContrast:p.nativeTheme.shouldUseInvertedColorScheme||p.nativeTheme.shouldUseHighContrastColors}});let re;if(!k.forceNewWindow&&!k.forceNewTabbedWindow&&(re=k.windowToUse||this.getLastActiveWindow(),re&&re.focus()),re){const se=re.config;!ne.extensionDevelopmentPath&&se&&!!se.extensionDevelopmentPath&&(ne.extensionDevelopmentPath=se.extensionDevelopmentPath,ne.verbose=se.verbose,ne["inspect-brk-extensions"]=se["inspect-brk-extensions"],ne.debugId=se.debugId,ne["inspect-extensions"]=se["inspect-extensions"],ne["extensions-dir"]=se["extensions-dir"])}else{const se=this.windowsStateHandler.getNewWindowState(ne);(0,b.mark)("code/willCreateCodeWindow");const le=re=this.instantiationService.createInstance(M.CodeWindow,{state:se,extensionDevelopmentPath:ne.extensionDevelopmentPath,isExtensionTestHost:!!ne.extensionTestsPath});if((0,b.mark)("code/didCreateCodeWindow"),k.forceNewTabbedWindow){const ue=this.getLastActiveWindow();ue&&ue.addTabbedWindow(le)}et.WINDOWS.push(le),this._onDidOpenWindow.fire(le),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()}),(0,U.once)(le.onDidSignalReady)(()=>this._onDidSignalReadyWindow.fire(le)),(0,U.once)(le.onDidClose)(()=>this.onWindowClosed(le)),(0,U.once)(le.onDidDestroy)(()=>this._onDidDestroyWindow.fire(le));const oe=(0,x.assertIsDefined)((Y=le.win)===null||Y===void 0?void 0:Y.webContents);oe.removeAllListeners("devtools-reload-page"),oe.on("devtools-reload-page",()=>this.lifecycleMainService.reload(le)),this.lifecycleMainService.registerWindow(le)}return ne.windowId=re.id,re.isReady?this.lifecycleMainService.unload(re,4).then(se=>{se||this.doOpenInBrowserWindow(re,ne,k)}):this.doOpenInBrowserWindow(re,ne,k),re}doOpenInBrowserWindow(k,O,_){if(!O.extensionDevelopmentPath)if((0,r.isWorkspaceIdentifier)(O.workspace))O.backupPath=this.backupMainService.registerWorkspaceBackupSync({workspace:O.workspace,remoteAuthority:O.remoteAuthority});else if((0,r.isSingleFolderWorkspaceIdentifier)(O.workspace))O.backupPath=this.backupMainService.registerFolderBackupSync(O.workspace.uri);else{const K=_.emptyWindowBackupInfo&&_.emptyWindowBackupInfo.backupFolder;O.backupPath=this.backupMainService.registerEmptyWindowBackupSync(K,O.remoteAuthority)}k.load(O)}onWindowClosed(k){const O=et.WINDOWS.indexOf(k);et.WINDOWS.splice(O,1),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()})}getFocusedWindow(){const k=p.BrowserWindow.getFocusedWindow();if(k)return this.getWindowById(k.id)}getLastActiveWindow(){return this.doGetLastActiveWindow(this.getWindows())}getLastActiveWindowForAuthority(k){return this.doGetLastActiveWindow(this.getWindows().filter(O=>O.remoteAuthority===k))}doGetLastActiveWindow(k){const O=Math.max.apply(Math,k.map(_=>_.lastFocusTime));return k.find(_=>_.lastFocusTime===O)}sendToFocused(k,...O){const _=this.getFocusedWindow()||this.getLastActiveWindow();_&&_.sendWhenReady(k,B.CancellationToken.None,...O)}sendToAll(k,O,_){for(const K of this.getWindows())_&&_.indexOf(K.id)>=0||K.sendWhenReady(k,B.CancellationToken.None,O)}getWindows(){return et.WINDOWS}getWindowCount(){return et.WINDOWS.length}getWindowById(k){const O=this.getWindows().filter(_=>_.id===k);return(0,w.firstOrDefault)(O)}getWindowByWebContents(k){const O=p.BrowserWindow.fromWebContents(k);if(!!O)return this.getWindowById(O.id)}};R.WINDOWS=[],R=he([te(2,D.ILogService),te(3,I.IStateMainService),te(4,i.IEnvironmentMainService),te(5,g.ILifecycleMainService),te(6,y.IBackupMainService),te(7,v.IConfigurationService),te(8,l.IWorkspacesHistoryMainService),te(9,T.IWorkspacesManagementMainService),te(10,s.IInstantiationService),te(11,Q.IDialogMainService),te(12,V.IFileService),te(13,c.IProductService),te(14,C.IProtocolMainService)],R),e.WindowsMainService=R}),define(J[235],Z([0,1,52,34,62,50]),function($,e,m,L,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesMainService=void 0;let E=class{constructor(w,y,i,I){this.workspacesManagementMainService=w,this.windowsMainService=y,this.workspacesHistoryMainService=i,this.backupMainService=I,this.onDidChangeRecentlyOpened=this.workspacesHistoryMainService.onDidChangeRecentlyOpened}async enterWorkspace(w,y){const i=this.windowsMainService.getWindowById(w);if(i)return this.workspacesManagementMainService.enterWorkspace(i,this.windowsMainService.getWindows(),y)}createUntitledWorkspace(w,y,i){return this.workspacesManagementMainService.createUntitledWorkspace(y,i)}deleteUntitledWorkspace(w,y){return this.workspacesManagementMainService.deleteUntitledWorkspace(y)}getWorkspaceIdentifier(w,y){return this.workspacesManagementMainService.getWorkspaceIdentifier(y)}async getRecentlyOpened(w){return this.workspacesHistoryMainService.getRecentlyOpened(this.windowsMainService.getWindowById(w))}async addRecentlyOpened(w,y){return this.workspacesHistoryMainService.addRecentlyOpened(y)}async removeRecentlyOpened(w,y){return this.workspacesHistoryMainService.removeRecentlyOpened(y)}async clearRecentlyOpened(w){return this.workspacesHistoryMainService.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.backupMainService.getDirtyWorkspaces()}};E=he([te(0,m.IWorkspacesManagementMainService),te(1,L.IWindowsMainService),te(2,A.IWorkspacesHistoryMainService),te(3,b.IBackupMainService)],E),e.WorkspacesMainService=E}),define(J[236],Z([0,1,26,29,14,3,234,18,91,41,204,33,122,85,224,101,4,71,69,6,38,24,17,98,205,31,97,199,200,196,22,218,2,34,7,28,235,66,229,227,226,230,178,19,207,219,233,119,8,15,131,10,228,99,212,217,50,62,206,52,70,157,45,51,13,39,209,76,21,43,27,20,89,210,195,54,30,9,169,183,42,73,75,90,188]),function($,e,m,L,A,b,E,n,w,y,i,I,M,p,g,v,D,S,a,u,c,l,t,r,s,o,d,f,h,P,T,U,q,Q,x,j,X,B,V,N,C,z,F,R,W,k,O,_,K,G,Y,ee,ne,re,se,le,oe,ue,me,Se,Le,Ie,we,ye,Re,Te,$e,Ne,je,tt,Be,ot,it,ht,Ge,dt,at,H,ie,ae,ce,fe,be,Me,Fe){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeApplication=void 0;let Ue=class extends q.Disposable{constructor(de,pe,ge,ve,Ee,Ae,ke,De,Pe,Ce){super();this.mainProcessNodeIpcServer=de,this.userEnv=pe,this.mainInstantiationService=ge,this.logService=ve,this.environmentMainService=Ee,this.lifecycleMainService=Ae,this.configurationService=ke,this.stateMainService=De,this.fileService=Pe,this.productService=Ce,this.registerListeners()}registerListeners(){(0,R.setUnexpectedErrorHandler)(ge=>this.onUnexpectedError(ge)),process.on("uncaughtException",ge=>this.onUnexpectedError(ge)),process.on("unhandledRejection",ge=>(0,R.onUnexpectedError)(ge)),this.lifecycleMainService.onWillShutdown(()=>this.dispose()),(0,_.registerContextMenuListener)(),A.app.on("accessibility-support-changed",(ge,ve)=>{var Ee;(Ee=this.windowsMainService)===null||Ee===void 0||Ee.sendToAll("vscode:accessibilitySupportChanged",ve)}),A.app.on("activate",(ge,ve)=>{var Ee;this.logService.trace("app#activate"),ve||(Ee=this.windowsMainService)===null||Ee===void 0||Ee.openEmptyWindow({context:1})}),A.app.on("remote-require",(ge,ve,Ee)=>{this.logService.trace("app#on(remote-require): prevented"),ge.preventDefault()}),A.app.on("remote-get-global",(ge,ve,Ee)=>{this.logService.trace(`app#on(remote-get-global): prevented on ${Ee}`),ge.preventDefault()}),A.app.on("remote-get-builtin",(ge,ve,Ee)=>{this.logService.trace(`app#on(remote-get-builtin): prevented on ${Ee}`),Ee!=="clipboard"&&ge.preventDefault()}),A.app.on("remote-get-current-window",ge=>{this.logService.trace("app#on(remote-get-current-window): prevented"),ge.preventDefault()}),A.app.on("remote-get-current-web-contents",ge=>{this.environmentMainService.args.driver||(this.logService.trace("app#on(remote-get-current-web-contents): prevented"),ge.preventDefault())}),A.app.on("web-contents-created",(ge,ve)=>{ve.on("will-attach-webview",(Ae,ke,De)=>{const Pe=Ce=>{if(!Ce)return!1;const He=x.URI.parse(Ce);if(He.scheme===ee.Schemas.vscodeWebview)return He.path==="/index.html"||He.path==="/electron-browser-index.html";const Ye=He.fsPath.toLowerCase(),Xe=x.URI.file(this.environmentMainService.appRoot).fsPath.toLowerCase();return Ye.startsWith(Xe+K.sep)};delete ke.preload,ke.nodeIntegration=!1,!(Pe(De.src)&&Pe(ke.preloadURL))&&(delete ke.preloadURL,this.logService.error("webContents#web-contents-created: Prevented webview attach"),Ae.preventDefault())}),ve.on("will-navigate",Ae=>{this.logService.error("webContents#will-navigate: Prevented webcontent navigation"),Ae.preventDefault()}),ve.on("new-window",(Ae,ke)=>{var De;Ae.preventDefault(),(De=this.nativeHostMainService)===null||De===void 0||De.openExternal(void 0,ke)});const Ee=Ae=>Ae.startsWith(`${ee.Schemas.vscodeWebview}://`);A.session.defaultSession.setPermissionRequestHandler((Ae,ke,De,Pe)=>Ee(Pe.requestingUrl)?De(ke==="clipboard-read"):De(!1)),A.session.defaultSession.setPermissionCheckHandler((Ae,ke,De,Pe)=>Ee(Pe.requestingUrl)?ke==="clipboard-read":!1)});let de=[],pe;A.app.on("open-file",(ge,ve)=>{this.logService.trace("app#open-file: ",ve),ge.preventDefault(),de.push(this.getWindowOpenableFromPathSync(ve)),pe!==void 0&&(clearTimeout(pe),pe=void 0),pe=setTimeout(()=>{var Ee;(Ee=this.windowsMainService)===null||Ee===void 0||Ee.open({context:1,cli:this.environmentMainService.args,urisToOpen:de,gotoLineMode:!1,preferNewWindow:!0}),de=[],pe=void 0},100)}),A.app.on("new-window-for-tab",()=>{var ge;(ge=this.windowsMainService)===null||ge===void 0||ge.openEmptyWindow({context:4})}),A.ipcMain.handle("vscode:fetchShellEnv",ge=>{var ve;const Ee=(ve=this.windowsMainService)===null||ve===void 0?void 0:ve.getWindowByWebContents(ge.sender);let Ae,ke;return(Ee==null?void 0:Ee.config)?(Ae=Ee.config,ke=Object.assign(Object.assign({},process.env),Ee.config.userEnv)):(Ae=this.environmentMainService.args,ke=process.env),(0,w.resolveShellEnv)(this.logService,Ae,ke)}),A.ipcMain.handle("vscode:writeNlsFile",(ge,ve,Ee)=>{const Ae=this.validateNlsPath([ve]);if(!Ae||typeof Ee!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.fileService.writeFile(Ae,ot.VSBuffer.fromString(Ee))}),A.ipcMain.handle("vscode:readNlsFile",async(ge,...ve)=>{const Ee=this.validateNlsPath(ve);if(!Ee)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.fileService.readFile(Ee)).value.toString()}),A.ipcMain.on("vscode:toggleDevTools",ge=>ge.sender.toggleDevTools()),A.ipcMain.on("vscode:openDevTools",ge=>ge.sender.openDevTools()),A.ipcMain.on("vscode:reloadWindow",ge=>ge.sender.reload())}validateNlsPath(de){let pe;for(const ge of de)typeof ge=="string"&&(typeof pe!="string"?pe=ge:pe=(0,K.join)(pe,ge));if(!(typeof pe!="string"||!(0,K.isAbsolute)(pe)||!(0,at.isEqualOrParent)(pe,this.environmentMainService.cachedLanguagesPath,!b.isLinux)))return x.URI.file(pe)}onUnexpectedError(de){var pe;if(de){const ge={message:`[uncaught exception in main]: ${de.message}`,stack:de.stack};(pe=this.windowsMainService)===null||pe===void 0||pe.sendToFocused("vscode:reportError",JSON.stringify(ge))}this.logService.error(`[uncaught exception in main]: ${de}`),de.stack&&this.logService.error(de.stack)}async startup(){this.logService.debug("Starting VS Code"),this.logService.debug(`from: ${this.environmentMainService.appRoot}`),this.logService.debug("args:",this.environmentMainService.args);try{const Pe=x.URI.file(this.environmentMainService.chromeCachedDataDir);this.logService.trace(`Deleting Chrome cached data path: ${Pe.fsPath}`),await this.fileService.del(Pe,{recursive:!0})}catch(Pe){Pe.fileOperationResult!==1&&this.logService.error(Pe)}const de=this.productService.win32AppUserModelId;b.isWindows&&de&&A.app.setAppUserModelId(de);try{b.isMacintosh&&this.configurationService.getValue("window.nativeTabs")===!0&&!A.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&A.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(Pe){this.logService.error(Pe)}const pe=new M.Server;this.logService.trace("Resolving machine identifier...");const ge=await this.resolveMachineId();this.logService.trace(`Resolved machine identifier: ${ge}`);const{sharedProcess:ve,sharedProcessReady:Ee,sharedProcessClient:Ae}=this.setupSharedProcess(ge),ke=await this.initServices(ge,ve,Ee);if(this.environmentMainService.driverHandle){const Pe=await(0,k.serve)(pe,this.environmentMainService.driverHandle,this.environmentMainService,ke);this.logService.info("Driver started at:",this.environmentMainService.driverHandle),this._register(Pe)}this._register(ke.createInstance(U.ProxyAuthHandler)),ke.invokeFunction(Pe=>this.initChannels(Pe,pe,Ae));const De=ke.invokeFunction(Pe=>this.openFirstWindow(Pe,pe));ke.invokeFunction(Pe=>this.afterWindowOpen(Pe,ve)),this.environmentMainService.args.trace&&ke.invokeFunction(Pe=>this.stopTracingEventually(Pe,De))}async resolveMachineId(){let de=this.stateMainService.getItem(o.machineIdKey);return(!de||b.isMacintosh&&de==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(de=await(0,B.getMachineId)(),this.stateMainService.setItem(o.machineIdKey,de)),de}setupSharedProcess(de){const pe=this._register(this.mainInstantiationService.createInstance(g.SharedProcess,de,this.userEnv)),ge=(async()=>{this.logService.trace("Main->SharedProcess#connect");const Ee=await pe.connect();return this.logService.trace("Main->SharedProcess#connect: connection established"),new p.Client(Ee,"main")})(),ve=(async()=>(await pe.whenReady(),ge))();return{sharedProcess:pe,sharedProcessReady:ve,sharedProcessClient:ge}}async initServices(de,pe,ge){const ve=new S.ServiceCollection;switch(process.platform){case"win32":ve.set(y.IUpdateService,new a.SyncDescriptor(V.Win32UpdateService));break;case"linux":b.isLinuxSnap?ve.set(y.IUpdateService,new a.SyncDescriptor(ne.SnapUpdateService,[process.env.SNAP,process.env.SNAP_REVISION])):ve.set(y.IUpdateService,new a.SyncDescriptor(N.LinuxUpdateService));break;case"darwin":ve.set(y.IUpdateService,new a.SyncDescriptor(C.DarwinUpdateService));break}ve.set(Q.IWindowsMainService,new a.SyncDescriptor(E.WindowsMainService,[de,this.userEnv])),ve.set(ye.IDialogMainService,new a.SyncDescriptor(ye.DialogMainService)),ve.set(v.ILaunchMainService,new a.SyncDescriptor(v.LaunchMainService)),ve.set(Le.IDiagnosticsService,I.ProxyChannel.toService((0,I.getDelayedChannel)(ge.then(Ae=>Ae.getChannel("diagnostics"))))),ve.set(z.IIssueMainService,new a.SyncDescriptor(z.IssueMainService,[this.userEnv])),ve.set(it.IEncryptionMainService,new a.SyncDescriptor(it.EncryptionMainService,[de])),ve.set(Ge.IKeyboardLayoutMainService,new a.SyncDescriptor(Ge.KeyboardLayoutMainService)),ve.set(we.INativeHostMainService,new a.SyncDescriptor(we.NativeHostMainService,[pe])),ve.set(Ne.IWebviewManagerService,new a.SyncDescriptor($e.WebviewMainService)),ve.set(j.IWorkspacesService,new a.SyncDescriptor(X.WorkspacesMainService)),ve.set(Se.IWorkspacesManagementMainService,new a.SyncDescriptor(Se.WorkspacesManagementMainService)),ve.set(ue.IWorkspacesHistoryMainService,new a.SyncDescriptor(ue.WorkspacesHistoryMainService)),ve.set(O.IMenubarMainService,new a.SyncDescriptor(O.MenubarMainService)),ve.set(ie.IExtensionUrlTrustService,new a.SyncDescriptor(ae.ExtensionUrlTrustService)),ve.set(re.IStorageMainService,new a.SyncDescriptor(re.StorageMainService)),b.isWindows?ve.set(Me.IExternalTerminalMainService,new a.SyncDescriptor(Fe.WindowsExternalTerminalService)):b.isMacintosh?ve.set(Me.IExternalTerminalMainService,new a.SyncDescriptor(Fe.MacExternalTerminalService)):b.isLinux&&ve.set(Me.IExternalTerminalMainService,new a.SyncDescriptor(Fe.LinuxExternalTerminalService));const Ee=new le.BackupMainService(this.environmentMainService,this.configurationService,this.logService);if(ve.set(oe.IBackupMainService,Ee),ve.set(r.IURLService,new a.SyncDescriptor(me.NativeURLService)),!this.environmentMainService.isExtensionDevelopment&&!this.environmentMainService.args["disable-telemetry"]&&!!this.productService.enableTelemetry){const Ae=(0,I.getDelayedChannel)(ge.then(He=>He.getChannel("telemetryAppender"))),ke=new f.TelemetryAppenderClient(Ae),De=(0,P.resolveCommonProperties)(this.fileService,(0,m.release)(),(0,m.hostname)(),process.arch,this.productService.commit,this.productService.version,de,this.productService.msftInternalDomains,this.environmentMainService.installSourcePath),Pe=[this.environmentMainService.appRoot,this.environmentMainService.extensionsPath],Ce={appender:ke,commonProperties:De,piiPaths:Pe,sendErrorTelemetry:!0};ve.set(o.ITelemetryService,new a.SyncDescriptor(h.TelemetryService,[Ce]))}else ve.set(o.ITelemetryService,d.NullTelemetryService);return await Ee.initialize(),this.mainInstantiationService.createChild(ve)}initChannels(de,pe,ge){const ve=I.ProxyChannel.fromService(de.get(v.ILaunchMainService),{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("launch",ve);const Ee=new i.UpdateChannel(de.get(y.IUpdateService));pe.registerChannel("update",Ee);const Ae=I.ProxyChannel.fromService(de.get(z.IIssueMainService));pe.registerChannel("issue",Ae);const ke=I.ProxyChannel.fromService(de.get(it.IEncryptionMainService));pe.registerChannel("encryption",ke);const De=I.ProxyChannel.fromService(de.get(be.ISignService));pe.registerChannel("sign",De);const Pe=I.ProxyChannel.fromService(de.get(Ge.IKeyboardLayoutMainService));pe.registerChannel("keyboardLayout",Pe),this.nativeHostMainService=de.get(we.INativeHostMainService);const Ce=I.ProxyChannel.fromService(this.nativeHostMainService);pe.registerChannel("nativeHost",Ce),ge.then(qe=>qe.registerChannel("nativeHost",Ce));const He=I.ProxyChannel.fromService(de.get(j.IWorkspacesService));pe.registerChannel("workspaces",He);const Ye=I.ProxyChannel.fromService(de.get(O.IMenubarMainService));pe.registerChannel("menubar",Ye);const Xe=I.ProxyChannel.fromService(de.get(r.IURLService));pe.registerChannel("url",Xe);const ft=I.ProxyChannel.fromService(de.get(ie.IExtensionUrlTrustService));pe.registerChannel("extensionUrlTrust",ft);const _e=I.ProxyChannel.fromService(de.get(Ne.IWebviewManagerService));pe.registerChannel("webview",_e);const nt=this._register(new se.StorageDatabaseChannel(this.logService,de.get(re.IStorageMainService)));pe.registerChannel("storage",nt),ge.then(qe=>qe.registerChannel("storage",nt));const rt=I.ProxyChannel.fromService(de.get(Me.IExternalTerminalMainService));pe.registerChannel("externalTerminal",rt);const xe=new F.LogLevelChannel(de.get(u.ILogService));pe.registerChannel("logLevel",xe),ge.then(qe=>qe.registerChannel("logLevel",xe));const st=new F.LoggerChannel(de.get(u.ILoggerService));pe.registerChannel("logger",st),ge.then(qe=>qe.registerChannel("logger",st));const lt=new Ie.ElectronExtensionHostDebugBroadcastChannel(de.get(Q.IWindowsMainService));pe.registerChannel("extensionhostdebugservice",lt)}openFirstWindow(de,pe){const ge=this.windowsMainService=de.get(Q.IWindowsMainService),ve=de.get(r.IURLService),Ee=de.get(we.INativeHostMainService);this.lifecycleMainService.phase=2;const Ae=[],ke=[...this.environmentMainService.args["open-url"]?this.environmentMainService.args._urls||[]:[],...global.getOpenUrls()||[]].map(We=>{try{return{uri:x.URI.parse(We),url:We}}catch(Qe){return null}}).filter(We=>{if(!We||this.shouldBlockURI(We.uri))return!1;const Qe=this.getWindowOpenableFromProtocolLink(We.uri);return Qe?(Ae.push(Qe),!1):!0}),De=this,Pe=this.environmentMainService,Ce=this.productService;ve.registerHandler({async handleURL(We,Qe){if(We.scheme===Ce.urlProtocol&&We.path==="workspace"&&(We=We.with({authority:"file",path:x.URI.parse(We.query).path,query:""})),De.shouldBlockURI(We))return!0;const Et=De.getWindowOpenableFromProtocolLink(We);if(Et){const[mt]=ge.open({context:5,cli:Object.assign({},Pe.args),urisToOpen:[Et],gotoLineMode:!0});return mt.focus(),!0}if(b.isMacintosh&&ge.getWindowCount()===0){const[mt]=ge.open({context:5,cli:Object.assign({},Pe.args),forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,fe.getRemoteAuthority)(We)});return await mt.ready(),ve.open(We,Qe)}return!1}});const He=this._register(new ht.ActiveWindowManager({onDidOpenWindow:Ee.onDidOpenWindow,onDidFocusWindow:Ee.onDidFocusWindow,getActiveWindowId:()=>Ee.getActiveWindowId(-1)})),Ye=new I.StaticRouter(We=>He.getActiveClientId().then(Qe=>We===Qe)),Xe=new s.URLHandlerRouter(Ye),ft=pe.getChannel("urlHandler",Xe);ve.registerHandler(new s.URLHandlerChannelClient(ft)),this._register(new W.ElectronURLListener(ke,ve,ge,this.environmentMainService,this.productService));const _e=this.environmentMainService.args,nt=global.macOpenFiles,rt=(0,dt.isLaunchedFromCli)(process.env)?0:4,xe=_e._.length,st=!!_e["folder-uri"],lt=!!_e["file-uri"],qe=_e["skip-add-to-recently-opened"]===!0,gt=_e.wait&&_e.waitMarkerFilePath?x.URI.file(_e.waitMarkerFilePath):void 0,bt=_e.remote||void 0;return Ae.length>0?ge.open({context:rt,cli:_e,urisToOpen:Ae,gotoLineMode:!0,initialStartup:!0}):_e["new-window"]&&!xe&&!st&&!lt?ge.open({context:rt,cli:_e,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:qe,waitMarkerFileURI:gt,initialStartup:!0,remoteAuthority:bt}):nt.length&&!xe&&!st&&!lt?ge.open({context:1,cli:_e,urisToOpen:nt.map(We=>this.getWindowOpenableFromPathSync(We)),noRecentEntry:qe,waitMarkerFileURI:gt,initialStartup:!0}):ge.open({context:rt,cli:_e,forceNewWindow:_e["new-window"]||!xe&&_e["unity-launch"],diffMode:_e.diff,noRecentEntry:qe,waitMarkerFileURI:gt,gotoLineMode:_e.goto,initialStartup:!0,remoteAuthority:bt})}shouldBlockURI(de){return!!(de.authority===ee.Schemas.file&&b.isWindows&&A.dialog.showMessageBoxSync({title:this.productService.nameLong,type:"question",buttons:[(0,Te.mnemonicButtonLabel)((0,Y.localize)(0,null)),(0,Te.mnemonicButtonLabel)((0,Y.localize)(1,null))],cancelId:1,message:(0,Y.localize)(2,null,(0,Te.getPathLabel)(de.fsPath,this.environmentMainService),this.productService.nameShort),detail:(0,Y.localize)(3,null),noLink:!0})===1)}getWindowOpenableFromProtocolLink(de){if(!!de.path){if(de.authority===ee.Schemas.file)return{fileUri:x.URI.file(de.fsPath)};if(de.authority===ee.Schemas.vscodeRemote){const pe=de.path.indexOf(K.posix.sep,1);if(pe!==-1){const ge=de.path.substring(1,pe),ve=de.path.substring(pe),Ee=x.URI.from({scheme:ee.Schemas.vscodeRemote,authority:ge,path:ve,query:de.query,fragment:de.fragment});return(0,j.hasWorkspaceFileExtension)(ve)?{workspaceUri:Ee}:/:[\d]+$/.test(ve)?{fileUri:Ee}:{folderUri:Ee}}}}}getWindowOpenableFromPathSync(de){try{if((0,L.statSync)(de).isDirectory())return{folderUri:x.URI.file(de)};if((0,j.hasWorkspaceFileExtension)(de))return{workspaceUri:x.URI.file(de)}}catch(pe){}return{fileUri:x.URI.file(de)}}async afterWindowOpen(de,pe){var ge;this.lifecycleMainService.phase=3;let ve=!1;(0,ce.once)(this.lifecycleMainService.onWillShutdown)(()=>ve=!0);const Ee=de.get(o.ITelemetryService);this._register(pe.onDidError(({type:De,details:Pe})=>{let Ce;typeof Pe=="string"?Ce=Pe:Ce=`SharedProcess: crashed (detail: ${Pe.reason}, code: ${Pe.exitCode})`,(0,R.onUnexpectedError)(new Error(Ce)),Ee.publicLog2("sharedprocesserror",{type:De,reason:typeof Pe!="string"?Pe==null?void 0:Pe.reason:void 0,visible:pe.isVisible(),shuttingdown:ve})}));const Ae=this.productService.win32MutexName;if(b.isWindows&&Ae)try{const De=$.__$__nodeRequire("windows-mutex").Mutex,Pe=new De(Ae);(0,ce.once)(this.lifecycleMainService.onWillShutdown)(()=>Pe.release())}catch(De){this.logService.error(De)}A.protocol.registerHttpProtocol(ee.Schemas.vscodeRemoteResource,(De,Pe)=>{Pe({url:De.url.replace(/^vscode-remote-resource:/,"http:"),method:De.method})});const ke=de.get(y.IUpdateService);(ke instanceof V.Win32UpdateService||ke instanceof N.LinuxUpdateService||ke instanceof C.DarwinUpdateService)&&ke.initialize(),(async()=>{const De=this._register(new H.RunOnceScheduler(()=>this.logService.warn("Resolving your shell environment is taking more than 10s. Please review your shell configuration. Learn more at https://go.microsoft.com/fwlink/?linkid=2149667."),1e4));De.schedule(),await(0,w.resolveShellEnv)(this.logService,this.environmentMainService.args,process.env),De.dispose()})();try{const Pe=(await this.fileService.readFile(this.environmentMainService.argvResource)).value.toString();if(JSON.parse((0,tt.stripComments)(Pe))["enable-crash-reporter"]===void 0){const He=(ge=this.configurationService.getValue("telemetry.enableCrashReporter"))!==null&&ge!==void 0?ge:!0,Ye=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${He},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,Be.generateUuid)()}"`,"}"],Xe=Pe.substring(0,Pe.length-2).concat(`,
`,Ye.join(`
`));await this.fileService.writeFile(this.environmentMainService.argvResource,ot.VSBuffer.fromString(Xe))}}catch(De){this.logService.error(De)}}stopTracingEventually(de,pe){this.logService.info("Tracing: waiting for windows to get ready...");const ge=de.get(ye.IDialogMainService);let ve=!1;const Ee=async ke=>{if(ve)return;ve=!0;const De=await A.contentTracing.stopRecording((0,G.joinPath)(this.environmentMainService.userHome,`${this.productService.applicationName}-${Math.random().toString(16).slice(-4)}.trace.txt`).fsPath);ke?this.logService.info(`Tracing: data recorded (after 30s timeout) to ${De}`):ge.showMessageBox({type:"info",message:(0,Y.localize)(4,null),detail:(0,Y.localize)(5,null,De),buttons:[(0,Y.localize)(6,null)]},(0,Re.withNullAsUndefined)(A.BrowserWindow.getFocusedWindow()))},Ae=setTimeout(()=>Ee(!0),3e4);Promise.all(pe.map(ke=>ke.ready())).then(()=>{clearTimeout(Ae),Ee(!1)})}};Ue=he([te(2,D.IInstantiationService),te(3,u.ILogService),te(4,l.IEnvironmentMainService),te(5,n.ILifecycleMainService),te(6,t.IConfigurationService),te(7,c.IStateMainService),te(8,je.IFileService),te(9,T.IProductService)],Ue),e.CodeApplication=Ue}),define(J[240],Z([0,1,14,29,16,11,3,72,47,54,161,18,33,56,173,71,69,6,225,38,17,187,49,223,236,39,94,93,19,60,42,75,194,197,181,182,10,21,74,221,22,30,23,8,35,24,67,97,179,32,55,184,9,203]),function($,e,m,L,A,b,E,n,w,y,i,I,M,p,g,v,D,S,a,u,c,l,t,r,s,o,d,f,h,P,T,U,q,Q,x,j,X,B,V,N,C,z,F,R,W,k,O,_,K,G,Y,ee,ne){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class re{main(){try{this.startup()}catch(oe){console.error(oe.message),m.app.exit(1)}}async startup(){(0,h.setUnexpectedErrorHandler)(ye=>console.error(ye));const[oe,ue,me,Se,Le,Ie,we]=this.createServices();try{try{await this.initServices(me,Se,Le)}catch(ye){throw this.handleStartupDataDirError(me,we.nameLong,ye),ye}await oe.invokeFunction(async ye=>{const Re=ye.get(S.ILogService),Te=ye.get(I.ILifecycleMainService),$e=ye.get(B.IFileService),Ne=await this.claimInstance(Re,me,Te,oe,we,!0);return Ie.logger=new d.SpdLogLogger("main",(0,R.join)(me.logsPath,"main.log"),!0,Ie.getLevel()),(0,T.once)(Te.onWillShutdown)(()=>{$e.dispose(),Se.dispose()}),oe.createInstance(s.CodeApplication,Ne,ue).startup()})}catch(ye){oe.invokeFunction(this.quit,ye)}}createServices(){const oe=new v.ServiceCollection,ue=Object.assign({_serviceBrand:void 0},w.default);oe.set(C.IProductService,ue);const me=new k.EnvironmentMainService(this.resolveArgs(),ue),Se=this.patchEnvironment(me);oe.set(k.IEnvironmentMainService,me);const Le=new f.BufferLogService,Ie=new S.MultiplexLogService([new S.ConsoleMainLogger((0,S.getLogLevel)(me)),Le]);process.once("exit",()=>Ie.dispose()),oe.set(S.ILogService,Ie);const we=new x.FileService(Ie);oe.set(B.IFileService,we);const ye=new j.DiskFileSystemProvider(Ie);we.registerProvider(X.Schemas.file,ye),oe.set(S.ILoggerService,new K.LoggerService(Ie,we));const Re=new l.ConfigurationService(me.settingsResource,we);oe.set(c.IConfigurationService,Re),oe.set(I.ILifecycleMainService,new D.SyncDescriptor(I.LifecycleMainService));const Te=new a.StateMainService(me,Ie,we);return oe.set(u.IStateMainService,Te),oe.set(t.IRequestService,new D.SyncDescriptor(r.RequestMainService)),oe.set(P.IThemeMainService,new D.SyncDescriptor(P.ThemeMainService)),oe.set(U.ISignService,new D.SyncDescriptor(q.SignService)),oe.set(V.ITunnelService,new D.SyncDescriptor(N.TunnelService)),oe.set(Y.IProtocolMainService,new D.SyncDescriptor(ee.ProtocolMainService)),[new g.InstantiationService(oe,!0),Se,me,Re,Te,Le,ue]}patchEnvironment(oe){const ue={VSCODE_IPC_HOOK:oe.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(me=>{const Se=process.env[me];typeof Se=="string"&&(ue[me]=Se)}),Object.assign(process.env,ue),ue}initServices(oe,ue,me){return ne.Promises.settled([Promise.all([oe.extensionsPath,oe.nodeCachedDataDir,oe.logsPath,oe.globalStorageHome.fsPath,oe.workspaceStorageHome.fsPath,oe.backupHome].map(Se=>Se?A.Promises.mkdir(Se,{recursive:!0}):void 0)),ue.initialize(),me.init()])}async claimInstance(oe,ue,me,Se,Le,Ie){let we;try{(0,n.mark)("code/willStartMainServer"),we=await(0,p.serve)(ue.mainIPCHandle),(0,n.mark)("code/didStartMainServer"),(0,T.once)(me.onWillShutdown)(()=>we.dispose())}catch(ye){if(ye.code!=="EADDRINUSE")throw this.handleStartupDataDirError(ue,Le.nameLong,ye),ye;let Re;try{Re=await(0,p.connect)(ue.mainIPCHandle,"main")}catch(Ne){if(!Ie||E.isWindows||Ne.code!=="ECONNREFUSED")throw Ne.code==="EPERM"&&this.showStartupWarningDialog((0,b.localize)(0,null,Le.nameShort),(0,b.localize)(1,null),Le.nameLong),Ne;try{(0,L.unlinkSync)(ue.mainIPCHandle)}catch(je){throw oe.warn("Could not delete obsolete instance handle",je),je}return this.claimInstance(oe,ue,me,Se,Le,!1)}if(ue.extensionTestsLocationURI&&!ue.debugExtensionHost.break){const Ne="Running extension tests from the command line is currently only supported if no other instance of Code is running.";throw oe.error(Ne),Re.dispose(),new Error(Ne)}let Te;!ue.args.wait&&!ue.args.status&&(Te=setTimeout(()=>{this.showStartupWarningDialog((0,b.localize)(2,null,Le.nameShort),(0,b.localize)(3,null),Le.nameLong)},1e4));const $e=M.ProxyChannel.toService(Re.getChannel("launch"),{disableMarshalling:!0});if(ue.args.status)return Se.invokeFunction(async()=>{const Ne=new Q.DiagnosticsService(_.NullTelemetryService,Le),je=await $e.getMainProcessInfo(),tt=await $e.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),Be=await Ne.getDiagnostics(je,tt);throw console.log(Be),new h.ExpectedError});throw E.isWindows&&await this.windowsAllowSetForegroundWindow($e,oe),oe.trace("Sending env to running instance..."),await $e.start(ue.args,process.env),Re.dispose(),Te&&clearTimeout(Te),new h.ExpectedError("Sent env to running instance. Terminating...")}if(ue.args.status)throw oe.warn("Warning: The --status argument can only be used if Code is already running. Please run it again after Code has started."),new h.ExpectedError("Terminating...");return process.env.VSCODE_PID=String(process.pid),we}handleStartupDataDirError(oe,ue,me){if(me.code==="EACCES"||me.code==="EPERM"){const Se=(0,W.coalesce)([oe.userDataPath,oe.extensionsPath,p.XDG_RUNTIME_DIR]).map(Le=>(0,o.getPathLabel)(Le,oe));this.showStartupWarningDialog((0,b.localize)(4,null),(0,b.localize)(5,null,(0,O.toErrorMessage)(me),Se.join(`
`)),ue)}}showStartupWarningDialog(oe,ue,me){m.dialog.showMessageBoxSync({title:me,type:"warning",buttons:[(0,o.mnemonicButtonLabel)((0,b.localize)(6,null))],message:oe,detail:ue,noLink:!0})}async windowsAllowSetForegroundWindow(oe,ue){if(E.isWindows){const me=await oe.getMainProcessId();ue.trace("Sending some foreground love to the running instance:",me);try{(await new Promise((Se,Le)=>{$(["windows-foreground-love"],Se,Le)})).allowSetForegroundWindow(me)}catch(Se){ue.error(Se)}}}quit(oe,ue){const me=oe.get(S.ILogService),Se=oe.get(I.ILifecycleMainService);let Le=0;ue&&(ue.isExpected?ue.message&&me.trace(ue.message):(Le=1,ue.stack?me.error(ue.stack):me.error(`Startup error: ${ue.toString()}`))),Se.kill(Le)}resolveArgs(){const oe=this.validatePaths((0,y.parseMainProcessArgv)(process.argv));if(oe.wait&&!oe.waitMarkerFilePath){const ue=(0,i.createWaitMarkerFile)(oe.verbose);ue&&((0,y.addArg)(process.argv,"--waitMarkerFilePath",ue),oe.waitMarkerFilePath=ue)}return oe}validatePaths(oe){if(oe["open-url"]&&(oe._urls=oe._,oe._=[]),!oe.remote){const ue=this.doValidatePaths(oe._,oe.goto);oe._=ue}return oe}doValidatePaths(oe,ue){const me=(0,G.cwd)(),Se=oe.map(we=>{let ye=String(we),Re;ue&&(Re=(0,z.parseLineAndColumnAware)(ye),ye=Re.path),ye&&(ye=this.preparePath(me,ye));const Te=(0,z.sanitizeFilePath)(ye,me),$e=(0,R.basename)(Te);return $e&&!(0,z.isValidBasename)($e)?null:ue&&Re?(Re.path=Te,this.toPath(Re)):Te}),Le=E.isWindows||E.isMacintosh,Ie=(0,W.distinct)(Se,we=>we&&Le?we.toLowerCase():we||"");return(0,W.coalesce)(Ie)}preparePath(oe,ue){return E.isWindows&&(ue=(0,F.rtrim)(ue,'"')),ue=(0,F.trim)((0,F.trim)(ue," "),"	"),E.isWindows&&(ue=(0,R.resolve)(oe,ue),ue=(0,F.rtrim)(ue,".")),ue}toPath(oe){const ue=[oe.path];return typeof oe.line=="number"&&ue.push(String(oe.line)),typeof oe.column=="number"&&ue.push(String(oe.column)),ue.join(":")}}new re().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/5319757634f77a050b49c10162939bfe60970c29/core/vs/code/electron-main/main.js.map
